////////////////////////////////////////////////////////////////////////////////
///
/// PrlPythonSDK.cpp
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY sdk2python UTILITY***
///
/// Copyright (c) 1999-2014 Parallels IP Holdings GmbH.
/// All rights reserved.
/// http://www.parallels.com
///
////////////////////////////////////////////////////////////////////////////////

#include <string>
#include <vector>
#ifdef _LIN_
#ifdef _POSIX_C_SOURCE
#undef _POSIX_C_SOURCE
#endif
#ifdef _XOPEN_SOURCE
#undef _XOPEN_SOURCE
#endif
#endif
#include "SDK/Python/PrlPython.h"
#include "SDK/Wrappers/SdkWrap/SdkWrap.h"
#include "Interfaces/Debug.h"

#define PRL_SDK_CHECK \
	if ( ! s_bIsSDKInitialized ) \
	{ \
		PyErr_SetString(PyExc_RuntimeError, "SDK was not initialized"); \
		return NULL; \
	} 

static std::string s_strSdkLibraryPath;
static bool s_bIsSDKInitialized = false;

static std::vector<PyObject *> args_vector;

static PyObject* sdk_SetSDKLibraryPath(PyObject* /*self*/, PyObject* args)
{
	do {
		PRL_CONST_STR sSdkLibraryPath;

		if ( ! PyArg_ParseTuple( args, "s", &sSdkLibraryPath ) )
			break;

		s_strSdkLibraryPath = sSdkLibraryPath;

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", PRL_ERR_SUCCESS )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_GetSDKLibraryPath(PyObject* /*self*/, PyObject* )
{
	do {
		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", PRL_ERR_SUCCESS )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", s_strSdkLibraryPath.c_str() )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_IsSDKInitialized(PyObject* /*self*/, PyObject* )
{
	do {
		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", PRL_ERR_SUCCESS )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", s_bIsSDKInitialized )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_InitializeSDK(PyObject* /*self*/, PyObject* args)
{
	do {
		PRL_APPLICATION_MODE nMode;

		if ( ! PyArg_ParseTuple( args, "I", &nMode ) )
			break;

		PRL_RESULT prlResult = PRL_ERR_SUCCESS;
		if (s_strSdkLibraryPath.empty())
			prlResult = SdkWrap_LoadLibFromStdPaths() ? PRL_ERR_SUCCESS : PRL_ERR_FAILURE;
		else
			prlResult = SdkWrap_Load(s_strSdkLibraryPath.c_str());

		prlResult = PRL_SUCCEEDED(prlResult) ? PrlApi_InitEx(PARALLELS_API_VER, nMode, 0, 0) : prlResult;
		s_bIsSDKInitialized = PRL_SUCCEEDED(prlResult);

		if (PRL_FAILED(prlResult))
		{
			SdkWrap_Unload();
		}
		else
		{
			PrlApi_SwitchConsoleLogging(PRL_FALSE);
			PrlApi_InitCrashHandler(0);
		}

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_InitializeSDKEx(PyObject* /*self*/, PyObject* args)
{
	do {
		PRL_UINT32 nVersion;
		PRL_APPLICATION_MODE nMode = PAM_SERVER;
		PRL_UINT32 nFlags = 0;
		PRL_UINT32 nReserved = 0;

		if ( ! PyArg_ParseTuple( args, "I|III", &nVersion, &nMode, &nFlags, &nReserved ) )
			break;

		PRL_RESULT prlResult = PRL_ERR_SUCCESS;
		if (s_strSdkLibraryPath.empty())
			prlResult = SdkWrap_LoadLibFromStdPaths() ? PRL_ERR_SUCCESS : PRL_ERR_FAILURE;
		else
			prlResult = SdkWrap_Load(s_strSdkLibraryPath.c_str());

		prlResult = PRL_SUCCEEDED(prlResult) ? PrlApi_InitEx(nVersion, nMode, nFlags, nReserved) : prlResult;
		s_bIsSDKInitialized = PRL_SUCCEEDED(prlResult);

		if (PRL_FAILED(prlResult))
		{
			SdkWrap_Unload();
		}
		else
		{
			PrlApi_SwitchConsoleLogging(PRL_FALSE);
			PrlApi_InitCrashHandler(0);
		}

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_DeinitializeSDK(PyObject* /*self*/, PyObject* )
{
	PRL_SDK_CHECK;
	do {
		PRL_RESULT prlResult = PrlApi_Deinit();
		s_bIsSDKInitialized = ( ! PRL_SUCCEEDED(prlResult) );

		// FIXME: Uncomment unload SDK library after bug #441458 will be fixed
		// SdkWrap_Unload();

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlApi_GetVersion(PyObject* /*self*/, PyObject* )
{
	PRL_SDK_CHECK;
	do {
		PRL_UINT32	current_version = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlApi_GetVersion( &current_version );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", current_version )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlApi_GetAppMode(PyObject* /*self*/, PyObject* )
{
	PRL_SDK_CHECK;
	do {
		PRL_APPLICATION_MODE	app_mode = (PRL_APPLICATION_MODE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlApi_GetAppMode( &app_mode );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "i", app_mode )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlApi_GetResultDescription(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_RESULT	nErrCode = (PRL_RESULT )0;
		PRL_BOOL	bIsBriefMessage = (PRL_BOOL )0;
		PRL_BOOL	bFormated = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "III:PrlApi_GetResultDescription" , &nErrCode, &bIsBriefMessage, &bFormated ) )
			break;

		PRL_STR	sErrString = (PRL_STR )0;
		PRL_UINT32	rnErrStringBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlApi_GetResultDescription( nErrCode, bIsBriefMessage, bFormated, sErrString, &rnErrStringBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sErrString(rnErrStringBufLength, '\0');
		sErrString = (PRL_STR )std_sErrString.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlApi_GetResultDescription( nErrCode, bIsBriefMessage, bFormated, sErrString, &rnErrStringBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sErrString )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlApi_GetMessageType(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_RESULT	nErrCode = (PRL_RESULT )0;

		if ( ! PyArg_ParseTuple( args, "I:PrlApi_GetMessageType" , &nErrCode ) )
			break;

		PRL_MESSAGE_TYPE_ENUM	rnMsgType = (PRL_MESSAGE_TYPE_ENUM )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlApi_GetMessageType( nErrCode, &rnMsgType );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "i", rnMsgType )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlApi_MsgCanBeIgnored(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_RESULT	nErrCode = (PRL_RESULT )0;

		if ( ! PyArg_ParseTuple( args, "I:PrlApi_MsgCanBeIgnored" , &nErrCode ) )
			break;

		PRL_BOOL	rbCanBeIgnored = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlApi_MsgCanBeIgnored( nErrCode, &rbCanBeIgnored );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbCanBeIgnored )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlApi_GetCrashDumpsPath(PyObject* /*self*/, PyObject* )
{
	PRL_SDK_CHECK;
	do {
		PRL_STR	sPath = (PRL_STR )0;
		PRL_UINT32	rnPathBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlApi_GetCrashDumpsPath( sPath, &rnPathBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sPath(rnPathBufLength, '\0');
		sPath = (PRL_STR )std_sPath.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlApi_GetCrashDumpsPath( sPath, &rnPathBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sPath )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlApi_InitCrashHandler(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_CONST_STR	sCrashDumpFileSuffix = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "s:PrlApi_InitCrashHandler" , &sCrashDumpFileSuffix ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlApi_InitCrashHandler( sCrashDumpFileSuffix );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlApi_CreateStringsList(PyObject* /*self*/, PyObject* )
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	rhStringsList = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlApi_CreateStringsList( &rhStringsList );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhStringsList )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlApi_CreateHandlesList(PyObject* /*self*/, PyObject* )
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	rhHandlesList = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlApi_CreateHandlesList( &rhHandlesList );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhHandlesList )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlApi_CreateOpTypeList(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_SIZE	nTypeSize = (PRL_SIZE )0;

		if ( ! PyArg_ParseTuple( args, "I:PrlApi_CreateOpTypeList" , &nTypeSize ) )
			break;

		PRL_HANDLE	rhOpTypeList = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlApi_CreateOpTypeList( &rhOpTypeList, nTypeSize );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhOpTypeList )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlApi_GetSupportedOsesTypes(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_INT32	nHostOsType = (PRL_INT32 )0;

		if ( ! PyArg_ParseTuple( args, "i:PrlApi_GetSupportedOsesTypes" , &nHostOsType ) )
			break;

		PRL_HANDLE	rhOsesTypesList = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlApi_GetSupportedOsesTypes( (PRL_HOST_OS_TYPE )nHostOsType, &rhOsesTypesList );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhOsesTypesList )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlApi_GetSupportedOsesVersions(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_INT32	nHostOsType = (PRL_INT32 )0;
		PRL_UINT8	nGuestOsType = (PRL_UINT8 )0;

		if ( ! PyArg_ParseTuple( args, "iB:PrlApi_GetSupportedOsesVersions" , &nHostOsType, &nGuestOsType ) )
			break;

		PRL_HANDLE	rhGuestsList = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlApi_GetSupportedOsesVersions( (PRL_HOST_OS_TYPE )nHostOsType, nGuestOsType, &rhGuestsList );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhGuestsList )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlApi_GetDefaultOsVersion(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_UINT8	nGuestOsType = (PRL_UINT8 )0;

		if ( ! PyArg_ParseTuple( args, "B:PrlApi_GetDefaultOsVersion" , &nGuestOsType ) )
			break;

		PRL_UINT16	rnOsVersion = (PRL_UINT16 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlApi_GetDefaultOsVersion( nGuestOsType, &rnOsVersion );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "H", rnOsVersion )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlStrList_GetItemsCount(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hStringsList = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlStrList_GetItemsCount" , &hStringsList ) )
			break;

		PRL_UINT32	rnItemsCount = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlStrList_GetItemsCount( hStringsList, &rnItemsCount );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnItemsCount )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlStrList_AddItem(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hStringsList = (PRL_HANDLE )0;
		PRL_CONST_STR	sItem = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ks:PrlStrList_AddItem" , &hStringsList, &sItem ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlStrList_AddItem( hStringsList, sItem );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlStrList_GetItem(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hStringsList = (PRL_HANDLE )0;
		PRL_UINT32	nItemIndex = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlStrList_GetItem" , &hStringsList, &nItemIndex ) )
			break;

		PRL_STR	sItemBuf = (PRL_STR )0;
		PRL_UINT32	rnItemBufSize = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlStrList_GetItem( hStringsList, nItemIndex, sItemBuf, &rnItemBufSize );
		Py_END_ALLOW_THREADS

		std::string std_sItemBuf(rnItemBufSize, '\0');
		sItemBuf = (PRL_STR )std_sItemBuf.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlStrList_GetItem( hStringsList, nItemIndex, sItemBuf, &rnItemBufSize );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sItemBuf )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlStrList_RemoveItem(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hStringsList = (PRL_HANDLE )0;
		PRL_UINT32	nItemIndex = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlStrList_RemoveItem" , &hStringsList, &nItemIndex ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlStrList_RemoveItem( hStringsList, nItemIndex );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlHndlList_GetItemsCount(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hHandlesList = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlHndlList_GetItemsCount" , &hHandlesList ) )
			break;

		PRL_UINT32	rnItemsCount = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlHndlList_GetItemsCount( hHandlesList, &rnItemsCount );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnItemsCount )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlHndlList_AddItem(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hHandlesList = (PRL_HANDLE )0;
		PRL_HANDLE	hItem = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "kk:PrlHndlList_AddItem" , &hHandlesList, &hItem ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlHndlList_AddItem( hHandlesList, hItem );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlHndlList_GetItem(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hHandlesList = (PRL_HANDLE )0;
		PRL_UINT32	nItemIndex = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlHndlList_GetItem" , &hHandlesList, &nItemIndex ) )
			break;

		PRL_HANDLE	rhItem = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlHndlList_GetItem( hHandlesList, nItemIndex, &rhItem );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhItem )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlHndlList_RemoveItem(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hHandlesList = (PRL_HANDLE )0;
		PRL_UINT32	nItemIndex = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlHndlList_RemoveItem" , &hHandlesList, &nItemIndex ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlHndlList_RemoveItem( hHandlesList, nItemIndex );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlOpTypeList_GetItemsCount(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hOpTypeList = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlOpTypeList_GetItemsCount" , &hOpTypeList ) )
			break;

		PRL_UINT32	rnItemsCount = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlOpTypeList_GetItemsCount( hOpTypeList, &rnItemsCount );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnItemsCount )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlOpTypeList_RemoveItem(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hOpTypeList = (PRL_HANDLE )0;
		PRL_UINT32	nItemIndex = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlOpTypeList_RemoveItem" , &hOpTypeList, &nItemIndex ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlOpTypeList_RemoveItem( hOpTypeList, nItemIndex );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlOpTypeList_GetTypeSize(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hOpTypeList = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlOpTypeList_GetTypeSize" , &hOpTypeList ) )
			break;

		PRL_SIZE	rnTypeSize = (PRL_SIZE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlOpTypeList_GetTypeSize( hOpTypeList, &rnTypeSize );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnTypeSize )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlApi_GetRecommendMinVmMem(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_UINT32	nOsVersion = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "I:PrlApi_GetRecommendMinVmMem" , &nOsVersion ) )
			break;

		PRL_UINT32	rnMinMemSize = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlApi_GetRecommendMinVmMem( nOsVersion, &rnMinMemSize );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnMinMemSize )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlHandle_AddRef(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	handle = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlHandle_AddRef" , &handle ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlHandle_AddRef( handle );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlHandle_Free(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	handle = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlHandle_Free" , &handle ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlHandle_Free( handle );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlHandle_GetType(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	handle = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlHandle_GetType" , &handle ) )
			break;

		PRL_HANDLE_TYPE	type = (PRL_HANDLE_TYPE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlHandle_GetType( handle, &type );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "i", type )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlDbg_GetHandlesNum(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_INT32	type = (PRL_INT32 )0;

		if ( ! PyArg_ParseTuple( args, "i:PrlDbg_GetHandlesNum" , &type ) )
			break;

		PRL_UINT32	handles_num = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlDbg_GetHandlesNum( &handles_num, (PRL_HANDLE_TYPE )type );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", handles_num )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlDbg_PrlResultToString(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_RESULT	value = (PRL_RESULT )0;

		if ( ! PyArg_ParseTuple( args, "I:PrlDbg_PrlResultToString" , &value ) )
			break;

		PRL_CONST_STR	result = (PRL_CONST_STR )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlDbg_PrlResultToString( value, &result );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", result )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlDbg_HandleTypeToString(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_INT32	handle_type = (PRL_INT32 )0;

		if ( ! PyArg_ParseTuple( args, "i:PrlDbg_HandleTypeToString" , &handle_type ) )
			break;

		PRL_CONST_STR	result = (PRL_CONST_STR )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlDbg_HandleTypeToString( (PRL_HANDLE_TYPE )handle_type, &result );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", result )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlDbg_EventTypeToString(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_INT32	event_type = (PRL_INT32 )0;

		if ( ! PyArg_ParseTuple( args, "i:PrlDbg_EventTypeToString" , &event_type ) )
			break;

		PRL_CONST_STR	result = (PRL_CONST_STR )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlDbg_EventTypeToString( (PRL_EVENT_TYPE )event_type, &result );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", result )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlJob_Wait(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hJob = (PRL_HANDLE )0;
		PRL_UINT32	msecs = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlJob_Wait" , &hJob, &msecs ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlJob_Wait( hJob, msecs );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlJob_Cancel(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hJob = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlJob_Cancel" , &hJob ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlJob_Cancel( hJob );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlJob_GetStatus(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hJob = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlJob_GetStatus" , &hJob ) )
			break;

		PRL_JOB_STATUS	status = (PRL_JOB_STATUS )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlJob_GetStatus( hJob, &status );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "i", status )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlJob_GetProgress(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hJob = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlJob_GetProgress" , &hJob ) )
			break;

		PRL_UINT32	rercentage = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlJob_GetProgress( hJob, &rercentage );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rercentage )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlJob_GetRetCode(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hJob = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlJob_GetRetCode" , &hJob ) )
			break;

		PRL_RESULT	retcode = (PRL_RESULT )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlJob_GetRetCode( hJob, &retcode );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", retcode )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlJob_GetResult(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hJob = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlJob_GetResult" , &hJob ) )
			break;

		PRL_HANDLE	handle = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlJob_GetResult( hJob, &handle );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", handle )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlJob_GetError(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hJob = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlJob_GetError" , &hJob ) )
			break;

		PRL_HANDLE	rhError = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlJob_GetError( hJob, &rhError );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhError )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlJob_GetOpCode(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hJob = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlJob_GetOpCode" , &hJob ) )
			break;

		PRL_JOB_OPERATION_CODE	rnOpCode = (PRL_JOB_OPERATION_CODE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlJob_GetOpCode( hJob, &rnOpCode );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "i", rnOpCode )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlJob_IsRequestWasSent(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hJob = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlJob_IsRequestWasSent" , &hJob ) )
			break;

		PRL_BOOL	rbIsRequestWasSent = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlJob_IsRequestWasSent( hJob, &rbIsRequestWasSent );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbIsRequestWasSent )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlResult_GetParamsCount(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hResult = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlResult_GetParamsCount" , &hResult ) )
			break;

		PRL_UINT32	rCount = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlResult_GetParamsCount( hResult, &rCount );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rCount )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlResult_GetParamByIndex(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hResult = (PRL_HANDLE )0;
		PRL_UINT32	nIndex = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlResult_GetParamByIndex" , &hResult, &nIndex ) )
			break;

		PRL_HANDLE	rhParam = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlResult_GetParamByIndex( hResult, nIndex, &rhParam );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhParam )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlResult_GetParam(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hResult = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlResult_GetParam" , &hResult ) )
			break;

		PRL_HANDLE	rHandle = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlResult_GetParam( hResult, &rHandle );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rHandle )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlResult_GetParamByIndexAsString(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hResult = (PRL_HANDLE )0;
		PRL_UINT32	nIndex = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlResult_GetParamByIndexAsString" , &hResult, &nIndex ) )
			break;

		PRL_STR	sParamBuf = (PRL_STR )0;
		PRL_UINT32	rnParamBufSize = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlResult_GetParamByIndexAsString( hResult, nIndex, sParamBuf, &rnParamBufSize );
		Py_END_ALLOW_THREADS

		std::string std_sParamBuf(rnParamBufSize, '\0');
		sParamBuf = (PRL_STR )std_sParamBuf.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlResult_GetParamByIndexAsString( hResult, nIndex, sParamBuf, &rnParamBufSize );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sParamBuf )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlResult_GetParamAsString(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hResult = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlResult_GetParamAsString" , &hResult ) )
			break;

		PRL_STR	sParamBuf = (PRL_STR )0;
		PRL_UINT32	rnParamBufSize = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlResult_GetParamAsString( hResult, sParamBuf, &rnParamBufSize );
		Py_END_ALLOW_THREADS

		std::string std_sParamBuf(rnParamBufSize, '\0');
		sParamBuf = (PRL_STR )std_sParamBuf.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlResult_GetParamAsString( hResult, sParamBuf, &rnParamBufSize );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sParamBuf )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlEvent_GetType(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hEvent = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlEvent_GetType" , &hEvent ) )
			break;

		PRL_EVENT_TYPE	type = (PRL_EVENT_TYPE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlEvent_GetType( hEvent, &type );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "i", type )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlEvent_GetServer(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hEvent = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlEvent_GetServer" , &hEvent ) )
			break;

		PRL_HANDLE	server = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlEvent_GetServer( hEvent, &server );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", server )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlEvent_GetVm(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hEvent = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlEvent_GetVm" , &hEvent ) )
			break;

		PRL_HANDLE	rVm = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlEvent_GetVm( hEvent, &rVm );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rVm )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlEvent_GetJob(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hEvent = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlEvent_GetJob" , &hEvent ) )
			break;

		PRL_HANDLE	rJob = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlEvent_GetJob( hEvent, &rJob );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlEvent_GetParamsCount(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hEvent = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlEvent_GetParamsCount" , &hEvent ) )
			break;

		PRL_UINT32	rnParamsCount = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlEvent_GetParamsCount( hEvent, &rnParamsCount );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnParamsCount )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlEvent_GetParam(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hEvent = (PRL_HANDLE )0;
		PRL_UINT32	nIndex = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlEvent_GetParam" , &hEvent, &nIndex ) )
			break;

		PRL_HANDLE	rhEventParam = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlEvent_GetParam( hEvent, nIndex, &rhEventParam );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhEventParam )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlEvent_GetParamByName(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hEvent = (PRL_HANDLE )0;
		PRL_CONST_STR	sParamName = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ks:PrlEvent_GetParamByName" , &hEvent, &sParamName ) )
			break;

		PRL_HANDLE	rhEventParam = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlEvent_GetParamByName( hEvent, sParamName, &rhEventParam );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhEventParam )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlEvent_GetErrCode(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hEvent = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlEvent_GetErrCode" , &hEvent ) )
			break;

		PRL_RESULT	rnErrCode = (PRL_RESULT )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlEvent_GetErrCode( hEvent, &rnErrCode );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnErrCode )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlEvent_GetErrString(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hEvent = (PRL_HANDLE )0;
		PRL_BOOL	bIsBriefMessage = (PRL_BOOL )0;
		PRL_BOOL	bFormated = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kII:PrlEvent_GetErrString" , &hEvent, &bIsBriefMessage, &bFormated ) )
			break;

		PRL_STR	sErrString = (PRL_STR )0;
		PRL_UINT32	rnErrStringBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlEvent_GetErrString( hEvent, bIsBriefMessage, bFormated, sErrString, &rnErrStringBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sErrString(rnErrStringBufLength, '\0');
		sErrString = (PRL_STR )std_sErrString.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlEvent_GetErrString( hEvent, bIsBriefMessage, bFormated, sErrString, &rnErrStringBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sErrString )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlEvent_CanBeIgnored(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hEvent = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlEvent_CanBeIgnored" , &hEvent ) )
			break;

		PRL_BOOL	rbCanBeIgnored = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlEvent_CanBeIgnored( hEvent, &rbCanBeIgnored );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbCanBeIgnored )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlEvent_IsAnswerRequired(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hEvent = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlEvent_IsAnswerRequired" , &hEvent ) )
			break;

		PRL_BOOL	rbIsAnswerRequired = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlEvent_IsAnswerRequired( hEvent, &rbIsAnswerRequired );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbIsAnswerRequired )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlEvent_GetIssuerType(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hEvent = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlEvent_GetIssuerType" , &hEvent ) )
			break;

		PRL_EVENT_ISSUER_TYPE	rnIssuerType = (PRL_EVENT_ISSUER_TYPE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlEvent_GetIssuerType( hEvent, &rnIssuerType );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "i", rnIssuerType )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlEvent_GetIssuerId(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hEvent = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlEvent_GetIssuerId" , &hEvent ) )
			break;

		PRL_STR	sIssuerId = (PRL_STR )0;
		PRL_UINT32	rnIssuerIdBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlEvent_GetIssuerId( hEvent, sIssuerId, &rnIssuerIdBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sIssuerId(rnIssuerIdBufLength, '\0');
		sIssuerId = (PRL_STR )std_sIssuerId.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlEvent_GetIssuerId( hEvent, sIssuerId, &rnIssuerIdBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sIssuerId )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlEvent_CreateAnswerEvent(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hEvent = (PRL_HANDLE )0;
		PRL_RESULT	nAnswer = (PRL_RESULT )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlEvent_CreateAnswerEvent" , &hEvent, &nAnswer ) )
			break;

		PRL_HANDLE	rhEvent = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlEvent_CreateAnswerEvent( hEvent, &rhEvent, nAnswer );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhEvent )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlEvtPrm_GetName(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hEventParam = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlEvtPrm_GetName" , &hEventParam ) )
			break;

		PRL_STR	sParamName = (PRL_STR )0;
		PRL_UINT32	rnParamNameBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlEvtPrm_GetName( hEventParam, sParamName, &rnParamNameBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sParamName(rnParamNameBufLength, '\0');
		sParamName = (PRL_STR )std_sParamName.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlEvtPrm_GetName( hEventParam, sParamName, &rnParamNameBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sParamName )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlEvtPrm_GetType(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hEventParam = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlEvtPrm_GetType" , &hEventParam ) )
			break;

		PRL_PARAM_FIELD_DATA_TYPE	rnParamType = (PRL_PARAM_FIELD_DATA_TYPE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlEvtPrm_GetType( hEventParam, &rnParamType );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "i", rnParamType )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlEvtPrm_ToString(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hEventParam = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlEvtPrm_ToString" , &hEventParam ) )
			break;

		PRL_STR	sParamValue = (PRL_STR )0;
		PRL_UINT32	rnParamValueBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlEvtPrm_ToString( hEventParam, sParamValue, &rnParamValueBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sParamValue(rnParamValueBufLength, '\0');
		sParamValue = (PRL_STR )std_sParamValue.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlEvtPrm_ToString( hEventParam, sParamValue, &rnParamValueBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sParamValue )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlEvtPrm_ToCData(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hEventParam = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlEvtPrm_ToCData" , &hEventParam ) )
			break;

		PRL_STR	sParamValue = (PRL_STR )0;
		PRL_UINT32	rnParamValueBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlEvtPrm_ToCData( hEventParam, sParamValue, &rnParamValueBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sParamValue(rnParamValueBufLength, '\0');
		sParamValue = (PRL_STR )std_sParamValue.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlEvtPrm_ToCData( hEventParam, sParamValue, &rnParamValueBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sParamValue )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlEvtPrm_ToUint32(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hEventParam = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlEvtPrm_ToUint32" , &hEventParam ) )
			break;

		PRL_UINT32	rnParamValue = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlEvtPrm_ToUint32( hEventParam, &rnParamValue );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnParamValue )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlEvtPrm_ToInt32(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hEventParam = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlEvtPrm_ToInt32" , &hEventParam ) )
			break;

		PRL_INT32	rnParamValue = (PRL_INT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlEvtPrm_ToInt32( hEventParam, &rnParamValue );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "i", rnParamValue )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlEvtPrm_ToUint64(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hEventParam = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlEvtPrm_ToUint64" , &hEventParam ) )
			break;

		PRL_UINT64	rnParamValue = (PRL_UINT64 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlEvtPrm_ToUint64( hEventParam, &rnParamValue );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "K", rnParamValue )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlEvtPrm_ToInt64(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hEventParam = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlEvtPrm_ToInt64" , &hEventParam ) )
			break;

		PRL_INT64	rnParamValue = (PRL_INT64 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlEvtPrm_ToInt64( hEventParam, &rnParamValue );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "L", rnParamValue )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlEvtPrm_ToBoolean(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hEventParam = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlEvtPrm_ToBoolean" , &hEventParam ) )
			break;

		PRL_BOOL	rbParamValue = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlEvtPrm_ToBoolean( hEventParam, &rbParamValue );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbParamValue )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlEvtPrm_ToHandle(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hEventParam = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlEvtPrm_ToHandle" , &hEventParam ) )
			break;

		PRL_HANDLE	rhParamValue = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlEvtPrm_ToHandle( hEventParam, &rhParamValue );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhParamValue )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_Create(PyObject* /*self*/, PyObject* )
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	handle = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrv_Create( &handle );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", handle )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_Login(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;
		PRL_CONST_STR	host = (PRL_CONST_STR )0;
		PRL_CONST_STR	user = (PRL_CONST_STR )0;
		PRL_CONST_STR	passwd = (PRL_CONST_STR )0;
		PRL_CONST_STR	sPrevSessionUuid = (PRL_CONST_STR )0;
		PRL_UINT32	port_cmd = (PRL_UINT32 )0;
		PRL_UINT32	timeout = (PRL_UINT32 )0;
		PRL_INT32	security_level = (PRL_INT32 )0;

		if ( ! PyArg_ParseTuple( args, "kssssIIi:PrlSrv_Login" , &hServer, &host, &user, &passwd, &sPrevSessionUuid, &port_cmd, &timeout, &security_level ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_Login( hServer, host, user, passwd, sPrevSessionUuid, port_cmd, timeout, (PRL_SECURITY_LEVEL )security_level );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_LoginLocal(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;
		PRL_CONST_STR	sPrevSessionUuid = (PRL_CONST_STR )0;
		PRL_UINT32	port = (PRL_UINT32 )0;
		PRL_INT32	security_level = (PRL_INT32 )0;

		if ( ! PyArg_ParseTuple( args, "ksIi:PrlSrv_LoginLocal" , &hServer, &sPrevSessionUuid, &port, &security_level ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_LoginLocal( hServer, sPrevSessionUuid, port, (PRL_SECURITY_LEVEL )security_level );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_Logoff(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrv_Logoff" , &hServer ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_Logoff( hServer );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_GetQuestions(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrv_GetQuestions" , &hServer ) )
			break;

		PRL_HANDLE	rQuestionsList = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrv_GetQuestions( hServer, &rQuestionsList );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rQuestionsList )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_SetNonInteractiveSession(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;
		PRL_BOOL	bNonInteractive = (PRL_BOOL )0;
		PRL_UINT32	nFlags = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kII:PrlSrv_SetNonInteractiveSession" , &hServer, &bNonInteractive, &nFlags ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_SetNonInteractiveSession( hServer, bNonInteractive, nFlags );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_IsNonInteractiveSession(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrv_IsNonInteractiveSession" , &hServer ) )
			break;

		PRL_BOOL	rbNonInteractive = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrv_IsNonInteractiveSession( hServer, &rbNonInteractive );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbNonInteractive )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_DisableConfirmationMode(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;
		PRL_CONST_STR	sUser = (PRL_CONST_STR )0;
		PRL_CONST_STR	sPasswd = (PRL_CONST_STR )0;
		PRL_UINT32	nFlags = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kssI:PrlSrv_DisableConfirmationMode" , &hServer, &sUser, &sPasswd, &nFlags ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_DisableConfirmationMode( hServer, sUser, sPasswd, nFlags );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_EnableConfirmationMode(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;
		PRL_UINT32	nFlags = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlSrv_EnableConfirmationMode" , &hServer, &nFlags ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_EnableConfirmationMode( hServer, nFlags );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_IsConfirmationModeEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrv_IsConfirmationModeEnabled" , &hServer ) )
			break;

		PRL_BOOL	rbConfirmationModeEnabled = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrv_IsConfirmationModeEnabled( hServer, &rbConfirmationModeEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbConfirmationModeEnabled )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_GetSrvConfig(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrv_GetSrvConfig" , &hServer ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_GetSrvConfig( hServer );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_GetCommonPrefs(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrv_GetCommonPrefs" , &hServer ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_GetCommonPrefs( hServer );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_CommonPrefsBeginEdit(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrv_CommonPrefsBeginEdit" , &hServer ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_CommonPrefsBeginEdit( hServer );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_CommonPrefsCommit(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;
		PRL_HANDLE	hDispCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "kk:PrlSrv_CommonPrefsCommit" , &hServer, &hDispCfg ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_CommonPrefsCommit( hServer, hDispCfg );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_CommonPrefsCommitEx(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;
		PRL_HANDLE	hDispCfg = (PRL_HANDLE )0;
		PRL_UINT32	nFlags = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kkI:PrlSrv_CommonPrefsCommitEx" , &hServer, &hDispCfg, &nFlags ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_CommonPrefsCommitEx( hServer, hDispCfg, nFlags );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_GetUserProfile(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrv_GetUserProfile" , &hServer ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_GetUserProfile( hServer );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_GetUserInfoList(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrv_GetUserInfoList" , &hServer ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_GetUserInfoList( hServer );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_GetUserInfo(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;
		PRL_CONST_STR	sUserId = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ks:PrlSrv_GetUserInfo" , &hServer, &sUserId ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_GetUserInfo( hServer, sUserId );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_GetVirtualNetworkList(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;
		PRL_UINT32	nFlags = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlSrv_GetVirtualNetworkList" , &hServer, &nFlags ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_GetVirtualNetworkList( hServer, nFlags );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_AddVirtualNetwork(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;
		PRL_HANDLE	hVirtNet = (PRL_HANDLE )0;
		PRL_UINT32	nFlags = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kkI:PrlSrv_AddVirtualNetwork" , &hServer, &hVirtNet, &nFlags ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_AddVirtualNetwork( hServer, hVirtNet, nFlags );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_UpdateVirtualNetwork(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;
		PRL_HANDLE	hVirtNet = (PRL_HANDLE )0;
		PRL_UINT32	nFlags = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kkI:PrlSrv_UpdateVirtualNetwork" , &hServer, &hVirtNet, &nFlags ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_UpdateVirtualNetwork( hServer, hVirtNet, nFlags );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_DeleteVirtualNetwork(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;
		PRL_HANDLE	hVirtNet = (PRL_HANDLE )0;
		PRL_UINT32	nFlags = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kkI:PrlSrv_DeleteVirtualNetwork" , &hServer, &hVirtNet, &nFlags ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_DeleteVirtualNetwork( hServer, hVirtNet, nFlags );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlOffmgmtService_Create(PyObject* /*self*/, PyObject* )
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	rhOffmgmtService = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlOffmgmtService_Create( &rhOffmgmtService );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhOffmgmtService )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlOffmgmtService_GetName(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hOffmgmtService = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlOffmgmtService_GetName" , &hOffmgmtService ) )
			break;

		PRL_STR	sName = (PRL_STR )0;
		PRL_UINT32	rnNameBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlOffmgmtService_GetName( hOffmgmtService, sName, &rnNameBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sName(rnNameBufLength, '\0');
		sName = (PRL_STR )std_sName.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlOffmgmtService_GetName( hOffmgmtService, sName, &rnNameBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sName )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlOffmgmtService_SetName(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hOffmgmtService = (PRL_HANDLE )0;
		PRL_CONST_STR	sName = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ks:PrlOffmgmtService_SetName" , &hOffmgmtService, &sName ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlOffmgmtService_SetName( hOffmgmtService, sName );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlOffmgmtService_GetPort(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hOffmgmtService = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlOffmgmtService_GetPort" , &hOffmgmtService ) )
			break;

		PRL_UINT32	rnPort = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlOffmgmtService_GetPort( hOffmgmtService, &rnPort );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnPort )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlOffmgmtService_SetPort(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hOffmgmtService = (PRL_HANDLE )0;
		PRL_UINT32	nPort = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlOffmgmtService_SetPort" , &hOffmgmtService, &nPort ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlOffmgmtService_SetPort( hOffmgmtService, nPort );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlOffmgmtService_IsUsedByDefault(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hOffmgmtService = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlOffmgmtService_IsUsedByDefault" , &hOffmgmtService ) )
			break;

		PRL_BOOL	rbDefault = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlOffmgmtService_IsUsedByDefault( hOffmgmtService, &rbDefault );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbDefault )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlOffmgmtService_SetUsedByDefault(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hOffmgmtService = (PRL_HANDLE )0;
		PRL_BOOL	bDefault = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlOffmgmtService_SetUsedByDefault" , &hOffmgmtService, &bDefault ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlOffmgmtService_SetUsedByDefault( hOffmgmtService, bDefault );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_UpdateOfflineService(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;
		PRL_HANDLE	hOffmgmtService = (PRL_HANDLE )0;
		PRL_UINT32	nFlags = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kkI:PrlSrv_UpdateOfflineService" , &hServer, &hOffmgmtService, &nFlags ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_UpdateOfflineService( hServer, hOffmgmtService, nFlags );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_DeleteOfflineService(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;
		PRL_HANDLE	hOffmgmtService = (PRL_HANDLE )0;
		PRL_UINT32	nFlags = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kkI:PrlSrv_DeleteOfflineService" , &hServer, &hOffmgmtService, &nFlags ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_DeleteOfflineService( hServer, hOffmgmtService, nFlags );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_GetOfflineServicesList(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;
		PRL_UINT32	nFlags = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlSrv_GetOfflineServicesList" , &hServer, &nFlags ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_GetOfflineServicesList( hServer, nFlags );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlNetworkClass_Create(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_UINT32	nClassId = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "I:PrlNetworkClass_Create" , &nClassId ) )
			break;

		PRL_HANDLE	rhNetworkClass = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlNetworkClass_Create( nClassId, &rhNetworkClass );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhNetworkClass )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlNetworkClass_GetClassId(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hNetworkClass = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlNetworkClass_GetClassId" , &hNetworkClass ) )
			break;

		PRL_UINT32	rnClassId = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlNetworkClass_GetClassId( hNetworkClass, &rnClassId );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnClassId )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlNetworkClass_SetClassId(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hNetworkClass = (PRL_HANDLE )0;
		PRL_UINT32	nClassId = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlNetworkClass_SetClassId" , &hNetworkClass, &nClassId ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlNetworkClass_SetClassId( hNetworkClass, nClassId );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlNetworkClass_GetNetworkList(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hNetworkClass = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlNetworkClass_GetNetworkList" , &hNetworkClass ) )
			break;

		PRL_HANDLE	rhNetworkList = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlNetworkClass_GetNetworkList( hNetworkClass, &rhNetworkList );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhNetworkList )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlNetworkClass_SetNetworkList(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hNetworkClass = (PRL_HANDLE )0;
		PRL_HANDLE	hNetworkList = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "kk:PrlNetworkClass_SetNetworkList" , &hNetworkClass, &hNetworkList ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlNetworkClass_SetNetworkList( hNetworkClass, hNetworkList );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_UpdateNetworkClassesList(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;
		PRL_HANDLE	hNetworkClassesList = (PRL_HANDLE )0;
		PRL_UINT32	nFlags = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kkI:PrlSrv_UpdateNetworkClassesList" , &hServer, &hNetworkClassesList, &nFlags ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_UpdateNetworkClassesList( hServer, hNetworkClassesList, nFlags );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_GetNetworkClassesList(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;
		PRL_UINT32	nFlags = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlSrv_GetNetworkClassesList" , &hServer, &nFlags ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_GetNetworkClassesList( hServer, nFlags );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlNetworkShapingEntry_Create(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_UINT32	nClassId = (PRL_UINT32 )0;
		PRL_UINT32	nTotalRate = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "II:PrlNetworkShapingEntry_Create" , &nClassId, &nTotalRate ) )
			break;

		PRL_HANDLE	rhNetworkShapingEntry = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlNetworkShapingEntry_Create( nClassId, nTotalRate, &rhNetworkShapingEntry );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhNetworkShapingEntry )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlNetworkShapingEntry_GetClassId(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	pNetworkShapingEntry = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlNetworkShapingEntry_GetClassId" , &pNetworkShapingEntry ) )
			break;

		PRL_UINT32	rnClassId = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlNetworkShapingEntry_GetClassId( pNetworkShapingEntry, &rnClassId );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnClassId )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlNetworkShapingEntry_SetClassId(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	pNetworkShapingEntry = (PRL_HANDLE )0;
		PRL_UINT32	nClassId = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlNetworkShapingEntry_SetClassId" , &pNetworkShapingEntry, &nClassId ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlNetworkShapingEntry_SetClassId( pNetworkShapingEntry, nClassId );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlNetworkShapingEntry_GetTotalRate(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	pNetworkShapingEntry = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlNetworkShapingEntry_GetTotalRate" , &pNetworkShapingEntry ) )
			break;

		PRL_UINT32	rnTotalRate = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlNetworkShapingEntry_GetTotalRate( pNetworkShapingEntry, &rnTotalRate );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnTotalRate )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlNetworkShapingEntry_SetTotalRate(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	pNetworkShapingEntry = (PRL_HANDLE )0;
		PRL_UINT32	nTotalRate = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlNetworkShapingEntry_SetTotalRate" , &pNetworkShapingEntry, &nTotalRate ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlNetworkShapingEntry_SetTotalRate( pNetworkShapingEntry, nTotalRate );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlNetworkShapingEntry_SetDevice(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hNetworkShapingEntry = (PRL_HANDLE )0;
		PRL_CONST_STR	sDev = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ks:PrlNetworkShapingEntry_SetDevice" , &hNetworkShapingEntry, &sDev ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlNetworkShapingEntry_SetDevice( hNetworkShapingEntry, sDev );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlNetworkShapingEntry_GetDevice(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hNetworkShapingEntry = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlNetworkShapingEntry_GetDevice" , &hNetworkShapingEntry ) )
			break;

		PRL_STR	sDev = (PRL_STR )0;
		PRL_UINT32	rnBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlNetworkShapingEntry_GetDevice( hNetworkShapingEntry, sDev, &rnBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sDev(rnBufLength, '\0');
		sDev = (PRL_STR )std_sDev.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlNetworkShapingEntry_GetDevice( hNetworkShapingEntry, sDev, &rnBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sDev )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlNetworkShapingEntry_SetRate(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	pNetworkShapingEntry = (PRL_HANDLE )0;
		PRL_UINT32	nRate = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlNetworkShapingEntry_SetRate" , &pNetworkShapingEntry, &nRate ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlNetworkShapingEntry_SetRate( pNetworkShapingEntry, nRate );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlNetworkShapingEntry_GetRate(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	pNetworkShapingEntry = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlNetworkShapingEntry_GetRate" , &pNetworkShapingEntry ) )
			break;

		PRL_UINT32	rnRate = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlNetworkShapingEntry_GetRate( pNetworkShapingEntry, &rnRate );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnRate )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlNetworkShapingEntry_SetRateMPU(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	pNetworkShapingEntry = (PRL_HANDLE )0;
		PRL_INT32	nRateMPU = (PRL_INT32 )0;

		if ( ! PyArg_ParseTuple( args, "ki:PrlNetworkShapingEntry_SetRateMPU" , &pNetworkShapingEntry, &nRateMPU ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlNetworkShapingEntry_SetRateMPU( pNetworkShapingEntry, nRateMPU );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlNetworkShapingEntry_GetRateMPU(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	pNetworkShapingEntry = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlNetworkShapingEntry_GetRateMPU" , &pNetworkShapingEntry ) )
			break;

		PRL_INT32	rnRateMPU = (PRL_INT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlNetworkShapingEntry_GetRateMPU( pNetworkShapingEntry, &rnRateMPU );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "i", rnRateMPU )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_UpdateNetworkShapingConfig(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;
		PRL_HANDLE	hNetworkShapingConfig = (PRL_HANDLE )0;
		PRL_UINT32	nFlags = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kkI:PrlSrv_UpdateNetworkShapingConfig" , &hServer, &hNetworkShapingConfig, &nFlags ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_UpdateNetworkShapingConfig( hServer, hNetworkShapingConfig, nFlags );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_GetNetworkShapingConfig(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;
		PRL_UINT32	nFlags = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlSrv_GetNetworkShapingConfig" , &hServer, &nFlags ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_GetNetworkShapingConfig( hServer, nFlags );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlNetworkShapingConfig_IsEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hConfig = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlNetworkShapingConfig_IsEnabled" , &hConfig ) )
			break;

		PRL_BOOL	rbEnabled = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlNetworkShapingConfig_IsEnabled( hConfig, &rbEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbEnabled )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlNetworkShapingConfig_SetEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hConfig = (PRL_HANDLE )0;
		PRL_BOOL	bEnabled = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlNetworkShapingConfig_SetEnabled" , &hConfig, &bEnabled ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlNetworkShapingConfig_SetEnabled( hConfig, bEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlNetworkShapingConfig_GetNetworkShapingList(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hConfig = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlNetworkShapingConfig_GetNetworkShapingList" , &hConfig ) )
			break;

		PRL_HANDLE	rhList = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlNetworkShapingConfig_GetNetworkShapingList( hConfig, &rhList );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhList )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlNetworkShapingConfig_SetNetworkShapingList(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hConfig = (PRL_HANDLE )0;
		PRL_HANDLE	hList = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "kk:PrlNetworkShapingConfig_SetNetworkShapingList" , &hConfig, &hList ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlNetworkShapingConfig_SetNetworkShapingList( hConfig, hList );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlNetworkShapingBandwidthEntry_Create(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_CONST_STR	sDev = (PRL_CONST_STR )0;
		PRL_UINT32	nBandwidth = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "sI:PrlNetworkShapingBandwidthEntry_Create" , &sDev, &nBandwidth ) )
			break;

		PRL_HANDLE	rhDeviceEntry = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlNetworkShapingBandwidthEntry_Create( sDev, nBandwidth, &rhDeviceEntry );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhDeviceEntry )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlNetworkShapingBandwidthEntry_SetDevice(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hDeviceEntry = (PRL_HANDLE )0;
		PRL_CONST_STR	sDev = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ks:PrlNetworkShapingBandwidthEntry_SetDevice" , &hDeviceEntry, &sDev ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlNetworkShapingBandwidthEntry_SetDevice( hDeviceEntry, sDev );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlNetworkShapingBandwidthEntry_GetDevice(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hDeviceEntry = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlNetworkShapingBandwidthEntry_GetDevice" , &hDeviceEntry ) )
			break;

		PRL_STR	sDev = (PRL_STR )0;
		PRL_UINT32	rnBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlNetworkShapingBandwidthEntry_GetDevice( hDeviceEntry, sDev, &rnBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sDev(rnBufLength, '\0');
		sDev = (PRL_STR )std_sDev.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlNetworkShapingBandwidthEntry_GetDevice( hDeviceEntry, sDev, &rnBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sDev )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlNetworkShapingBandwidthEntry_SetBandwidth(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hDeviceEntry = (PRL_HANDLE )0;
		PRL_UINT32	nBandwidth = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlNetworkShapingBandwidthEntry_SetBandwidth" , &hDeviceEntry, &nBandwidth ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlNetworkShapingBandwidthEntry_SetBandwidth( hDeviceEntry, nBandwidth );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlNetworkShapingBandwidthEntry_GetBandwidth(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hDeviceEntry = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlNetworkShapingBandwidthEntry_GetBandwidth" , &hDeviceEntry ) )
			break;

		PRL_UINT32	rnBandwidth = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlNetworkShapingBandwidthEntry_GetBandwidth( hDeviceEntry, &rnBandwidth );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnBandwidth )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlNetworkShapingConfig_GetNetworkDeviceBandwidthList(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hConfig = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlNetworkShapingConfig_GetNetworkDeviceBandwidthList" , &hConfig ) )
			break;

		PRL_HANDLE	rhList = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlNetworkShapingConfig_GetNetworkDeviceBandwidthList( hConfig, &rhList );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhList )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlNetworkShapingConfig_SetNetworkDeviceBandwidthList(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hConfig = (PRL_HANDLE )0;
		PRL_HANDLE	hList = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "kk:PrlNetworkShapingConfig_SetNetworkDeviceBandwidthList" , &hConfig, &hList ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlNetworkShapingConfig_SetNetworkDeviceBandwidthList( hConfig, hList );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlNetworkRate_Create(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_UINT32	nClassId = (PRL_UINT32 )0;
		PRL_UINT32	nRate = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "II:PrlNetworkRate_Create" , &nClassId, &nRate ) )
			break;

		PRL_HANDLE	rhNetworkRate = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlNetworkRate_Create( nClassId, nRate, &rhNetworkRate );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhNetworkRate )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlNetworkRate_GetClassId(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hNetworkRate = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlNetworkRate_GetClassId" , &hNetworkRate ) )
			break;

		PRL_UINT32	rnClassId = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlNetworkRate_GetClassId( hNetworkRate, &rnClassId );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnClassId )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlNetworkRate_GetRate(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hNetworkRate = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlNetworkRate_GetRate" , &hNetworkRate ) )
			break;

		PRL_UINT32	rnRate = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlNetworkRate_GetRate( hNetworkRate, &rnRate );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnRate )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetNetworkRateList(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_HANDLE	hNetworkRateList = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "kk:PrlVmCfg_SetNetworkRateList" , &hVmCfg, &hNetworkRateList ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetNetworkRateList( hVmCfg, hNetworkRateList );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetNetworkRateList(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_GetNetworkRateList" , &hVmCfg ) )
			break;

		PRL_HANDLE	rhNetworkRateList = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetNetworkRateList( hVmCfg, &rhNetworkRateList );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhNetworkRateList )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_IsRateBound(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_IsRateBound" , &hVmCfg ) )
			break;

		PRL_BOOL	rbEnabled = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_IsRateBound( hVmCfg, &rbEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbEnabled )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetRateBound(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_BOOL	bEnabled = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmCfg_SetRateBound" , &hVmCfg, &bEnabled ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetRateBound( hVmCfg, bEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetOsTemplate(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_CONST_STR	sOsTemplate = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ks:PrlVmCfg_SetOsTemplate" , &hVmCfg, &sOsTemplate ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetOsTemplate( hVmCfg, sOsTemplate );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetOsTemplate(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_GetOsTemplate" , &hVmCfg ) )
			break;

		PRL_STR	sOsTemplate = (PRL_STR )0;
		PRL_UINT32	rnBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetOsTemplate( hVmCfg, sOsTemplate, &rnBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sOsTemplate(rnBufLength, '\0');
		sOsTemplate = (PRL_STR )std_sOsTemplate.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetOsTemplate( hVmCfg, sOsTemplate, &rnBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sOsTemplate )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_ApplyConfigSample(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_CONST_STR	sConfigSample = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ks:PrlVmCfg_ApplyConfigSample" , &hVmCfg, &sConfigSample ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_ApplyConfigSample( hVmCfg, sConfigSample );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetAppTemplateList(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_GetAppTemplateList" , &hVmCfg ) )
			break;

		PRL_HANDLE	rhAppList = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetAppTemplateList( hVmCfg, &rhAppList );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhAppList )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetAppTemplateList(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_HANDLE	hAppList = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "kk:PrlVmCfg_SetAppTemplateList" , &hVmCfg, &hAppList ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetAppTemplateList( hVmCfg, hAppList );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_ConfigureGenericPci(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;
		PRL_HANDLE	hDevList = (PRL_HANDLE )0;
		PRL_UINT32	nFlags = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kkI:PrlSrv_ConfigureGenericPci" , &hServer, &hDevList, &nFlags ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_ConfigureGenericPci( hServer, hDevList, nFlags );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_GetStatistics(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrv_GetStatistics" , &hServer ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_GetStatistics( hServer );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_UserProfileBeginEdit(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrv_UserProfileBeginEdit" , &hServer ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_UserProfileBeginEdit( hServer );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_UserProfileCommit(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;
		PRL_HANDLE	hUserProfile = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "kk:PrlSrv_UserProfileCommit" , &hServer, &hUserProfile ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_UserProfileCommit( hServer, hUserProfile );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_IsConnected(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrv_IsConnected" , &hServer ) )
			break;

		PRL_BOOL	rbConnected = (PRL_BOOL )0;
		PRL_BOOL	rbIsConnectionLocal = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrv_IsConnected( hServer, &rbConnected, &rbIsConnectionLocal );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbConnected )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbIsConnectionLocal )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_GetServerInfo(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrv_GetServerInfo" , &hServer ) )
			break;

		PRL_HANDLE	rhServerInfo = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrv_GetServerInfo( hServer, &rhServerInfo );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhServerInfo )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_RegisterVm(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;
		PRL_CONST_STR	strVmDirPath = (PRL_CONST_STR )0;
		PRL_BOOL	bNonInteractiveMode = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "ksI:PrlSrv_RegisterVm" , &hServer, &strVmDirPath, &bNonInteractiveMode ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_RegisterVm( hServer, strVmDirPath, bNonInteractiveMode );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_RegisterVmEx(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;
		PRL_CONST_STR	strVmDirPath = (PRL_CONST_STR )0;
		PRL_UINT32	nFlags = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "ksI:PrlSrv_RegisterVmEx" , &hServer, &strVmDirPath, &nFlags ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_RegisterVmEx( hServer, strVmDirPath, nFlags );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_RegisterVmWithUuid(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;
		PRL_CONST_STR	strVmDirPath = (PRL_CONST_STR )0;
		PRL_CONST_STR	strVmUuid = (PRL_CONST_STR )0;
		PRL_UINT32	nFlags = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kssI:PrlSrv_RegisterVmWithUuid" , &hServer, &strVmDirPath, &strVmUuid, &nFlags ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_RegisterVmWithUuid( hServer, strVmDirPath, strVmUuid, nFlags );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_Register3rdPartyVm(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;
		PRL_CONST_STR	strVmConfigPath = (PRL_CONST_STR )0;
		PRL_CONST_STR	strVmRootDirPath = (PRL_CONST_STR )0;
		PRL_UINT32	nFlags = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kssI:PrlSrv_Register3rdPartyVm" , &hServer, &strVmConfigPath, &strVmRootDirPath, &nFlags ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_Register3rdPartyVm( hServer, strVmConfigPath, strVmRootDirPath, nFlags );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_CreateVm(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrv_CreateVm" , &hServer ) )
			break;

		PRL_HANDLE	rhVm = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrv_CreateVm( hServer, &rhVm );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhVm )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_GetVmList(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrv_GetVmList" , &hServer ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_GetVmList( hServer );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_GetVmListEx(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;
		PRL_UINT32	nFlags = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlSrv_GetVmListEx" , &hServer, &nFlags ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_GetVmListEx( hServer, nFlags );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_CreateVmBackup(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hSourceServer = (PRL_HANDLE )0;
		PRL_CONST_STR	sVmUuid = (PRL_CONST_STR )0;
		PRL_CONST_STR	sTargetHost = (PRL_CONST_STR )0;
		PRL_UINT32	nTargetPort = (PRL_UINT32 )0;
		PRL_CONST_STR	sTargetSessionId = (PRL_CONST_STR )0;
		PRL_CONST_STR	strDescription = (PRL_CONST_STR )0;
		PRL_UINT32	backup_flags = (PRL_UINT32 )0;
		PRL_UINT32	reserved_flags = (PRL_UINT32 )0;
		PRL_BOOL	force_operation = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kssIssIII:PrlSrv_CreateVmBackup" , &hSourceServer, &sVmUuid, &sTargetHost, &nTargetPort, &sTargetSessionId, &strDescription, &backup_flags, &reserved_flags, &force_operation ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_CreateVmBackup( hSourceServer, sVmUuid, sTargetHost, nTargetPort, sTargetSessionId, strDescription, backup_flags, reserved_flags, force_operation );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_RestoreVmBackup(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hSourceServer = (PRL_HANDLE )0;
		PRL_CONST_STR	sVmUuid = (PRL_CONST_STR )0;
		PRL_CONST_STR	sBackupUuid = (PRL_CONST_STR )0;
		PRL_CONST_STR	sTargetHost = (PRL_CONST_STR )0;
		PRL_UINT32	nTargetPort = (PRL_UINT32 )0;
		PRL_CONST_STR	sTargetSessionId = (PRL_CONST_STR )0;
		PRL_CONST_STR	sTargetVmHomePath = (PRL_CONST_STR )0;
		PRL_CONST_STR	sTargetVmName = (PRL_CONST_STR )0;
		PRL_UINT32	restore_flags = (PRL_UINT32 )0;
		PRL_UINT32	reserved_flags = (PRL_UINT32 )0;
		PRL_BOOL	force_operation = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "ksssIsssIII:PrlSrv_RestoreVmBackup" , &hSourceServer, &sVmUuid, &sBackupUuid, &sTargetHost, &nTargetPort, &sTargetSessionId, &sTargetVmHomePath, &sTargetVmName, &restore_flags, &reserved_flags, &force_operation ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_RestoreVmBackup( hSourceServer, sVmUuid, sBackupUuid, sTargetHost, nTargetPort, sTargetSessionId, sTargetVmHomePath, sTargetVmName, restore_flags, reserved_flags, force_operation );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_GetBackupTree(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hSourceServer = (PRL_HANDLE )0;
		PRL_CONST_STR	sUuid = (PRL_CONST_STR )0;
		PRL_CONST_STR	sTargetHost = (PRL_CONST_STR )0;
		PRL_UINT32	nTargetPort = (PRL_UINT32 )0;
		PRL_CONST_STR	sTargetSessionId = (PRL_CONST_STR )0;
		PRL_UINT32	backup_flags = (PRL_UINT32 )0;
		PRL_UINT32	reserved_flags = (PRL_UINT32 )0;
		PRL_BOOL	force_operation = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kssIsIII:PrlSrv_GetBackupTree" , &hSourceServer, &sUuid, &sTargetHost, &nTargetPort, &sTargetSessionId, &backup_flags, &reserved_flags, &force_operation ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_GetBackupTree( hSourceServer, sUuid, sTargetHost, nTargetPort, sTargetSessionId, backup_flags, reserved_flags, force_operation );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_RemoveVmBackup(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hSourceServer = (PRL_HANDLE )0;
		PRL_CONST_STR	sVmUuid = (PRL_CONST_STR )0;
		PRL_CONST_STR	sBackupUuid = (PRL_CONST_STR )0;
		PRL_CONST_STR	sTargetHost = (PRL_CONST_STR )0;
		PRL_UINT32	nTargetPort = (PRL_UINT32 )0;
		PRL_CONST_STR	sTargetSessionId = (PRL_CONST_STR )0;
		PRL_UINT32	remove_flags = (PRL_UINT32 )0;
		PRL_UINT32	reserved_flags = (PRL_UINT32 )0;
		PRL_BOOL	force_operation = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "ksssIsIII:PrlSrv_RemoveVmBackup" , &hSourceServer, &sVmUuid, &sBackupUuid, &sTargetHost, &nTargetPort, &sTargetSessionId, &remove_flags, &reserved_flags, &force_operation ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_RemoveVmBackup( hSourceServer, sVmUuid, sBackupUuid, sTargetHost, nTargetPort, sTargetSessionId, remove_flags, reserved_flags, force_operation );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_SubscribeToHostStatistics(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrv_SubscribeToHostStatistics" , &hServer ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_SubscribeToHostStatistics( hServer );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_UnsubscribeFromHostStatistics(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrv_UnsubscribeFromHostStatistics" , &hServer ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_UnsubscribeFromHostStatistics( hServer );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_Shutdown(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;
		PRL_BOOL	bForceShutdown = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlSrv_Shutdown" , &hServer, &bForceShutdown ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_Shutdown( hServer, bForceShutdown );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_ShutdownEx(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;
		PRL_UINT32	nFlags = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlSrv_ShutdownEx" , &hServer, &nFlags ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_ShutdownEx( hServer, nFlags );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_FsGetDiskList(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrv_FsGetDiskList" , &hServer ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_FsGetDiskList( hServer );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_FsGetDirEntries(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;
		PRL_CONST_STR	path = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ks:PrlSrv_FsGetDirEntries" , &hServer, &path ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_FsGetDirEntries( hServer, path );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_FsCreateDir(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;
		PRL_CONST_STR	path = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ks:PrlSrv_FsCreateDir" , &hServer, &path ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_FsCreateDir( hServer, path );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_FsRemoveEntry(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;
		PRL_CONST_STR	path = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ks:PrlSrv_FsRemoveEntry" , &hServer, &path ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_FsRemoveEntry( hServer, path );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_FsCanCreateFile(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;
		PRL_CONST_STR	path = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ks:PrlSrv_FsCanCreateFile" , &hServer, &path ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_FsCanCreateFile( hServer, path );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_FsRenameEntry(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;
		PRL_CONST_STR	oldPath = (PRL_CONST_STR )0;
		PRL_CONST_STR	newPath = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "kss:PrlSrv_FsRenameEntry" , &hServer, &oldPath, &newPath ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_FsRenameEntry( hServer, oldPath, newPath );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_UpdateLicense(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;
		PRL_CONST_STR	sKey = (PRL_CONST_STR )0;
		PRL_CONST_STR	sUser = (PRL_CONST_STR )0;
		PRL_CONST_STR	sCompany = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ksss:PrlSrv_UpdateLicense" , &hServer, &sKey, &sUser, &sCompany ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_UpdateLicense( hServer, sKey, sUser, sCompany );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_UpdateLicenseEx(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;
		PRL_CONST_STR	sKey = (PRL_CONST_STR )0;
		PRL_CONST_STR	sUser = (PRL_CONST_STR )0;
		PRL_CONST_STR	sCompany = (PRL_CONST_STR )0;
		PRL_UINT32	nFlags = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "ksssI:PrlSrv_UpdateLicenseEx" , &hServer, &sKey, &sUser, &sCompany, &nFlags ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_UpdateLicenseEx( hServer, sKey, sUser, sCompany, nFlags );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_GetLicenseInfo(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrv_GetLicenseInfo" , &hServer ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_GetLicenseInfo( hServer );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_SendAnswer(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;
		PRL_HANDLE	hAnswer = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "kk:PrlSrv_SendAnswer" , &hServer, &hAnswer ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_SendAnswer( hServer, hAnswer );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_StartSearchVms(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;
		PRL_HANDLE	hStringsList = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "kk:PrlSrv_StartSearchVms" , &hServer, &hStringsList ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_StartSearchVms( hServer, hStringsList );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlFsInfo_GetType(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hFsInfo = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlFsInfo_GetType" , &hFsInfo ) )
			break;

		PRL_FILE_SYSTEM_TYPE	rnFsType = (PRL_FILE_SYSTEM_TYPE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlFsInfo_GetType( hFsInfo, &rnFsType );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "i", rnFsType )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlFsInfo_GetFsType(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hFsInfo = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlFsInfo_GetFsType" , &hFsInfo ) )
			break;

		PRL_FILE_SYSTEM_FS_TYPE	rnFsType = (PRL_FILE_SYSTEM_FS_TYPE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlFsInfo_GetFsType( hFsInfo, &rnFsType );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "i", rnFsType )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlFsInfo_GetChildEntriesCount(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hFsInfo = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlFsInfo_GetChildEntriesCount" , &hFsInfo ) )
			break;

		PRL_UINT32	rnChildEntriesCount = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlFsInfo_GetChildEntriesCount( hFsInfo, &rnChildEntriesCount );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnChildEntriesCount )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlFsInfo_GetChildEntry(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hFsInfo = (PRL_HANDLE )0;
		PRL_UINT32	nIndex = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlFsInfo_GetChildEntry" , &hFsInfo, &nIndex ) )
			break;

		PRL_HANDLE	rhChildEntry = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlFsInfo_GetChildEntry( hFsInfo, nIndex, &rhChildEntry );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhChildEntry )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlFsInfo_GetParentEntry(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hFsInfo = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlFsInfo_GetParentEntry" , &hFsInfo ) )
			break;

		PRL_HANDLE	rhParentEntry = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlFsInfo_GetParentEntry( hFsInfo, &rhParentEntry );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhParentEntry )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlFsEntry_GetAbsolutePath(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hFsEntry = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlFsEntry_GetAbsolutePath" , &hFsEntry ) )
			break;

		PRL_STR	sAbsolutePath = (PRL_STR )0;
		PRL_UINT32	rnAbsolutePathBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlFsEntry_GetAbsolutePath( hFsEntry, sAbsolutePath, &rnAbsolutePathBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sAbsolutePath(rnAbsolutePathBufLength, '\0');
		sAbsolutePath = (PRL_STR )std_sAbsolutePath.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlFsEntry_GetAbsolutePath( hFsEntry, sAbsolutePath, &rnAbsolutePathBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sAbsolutePath )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlFsEntry_GetRelativeName(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hFsEntry = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlFsEntry_GetRelativeName" , &hFsEntry ) )
			break;

		PRL_STR	sRelativeName = (PRL_STR )0;
		PRL_UINT32	rnRelativeNameBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlFsEntry_GetRelativeName( hFsEntry, sRelativeName, &rnRelativeNameBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sRelativeName(rnRelativeNameBufLength, '\0');
		sRelativeName = (PRL_STR )std_sRelativeName.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlFsEntry_GetRelativeName( hFsEntry, sRelativeName, &rnRelativeNameBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sRelativeName )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlFsEntry_GetLastModifiedDate(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hFsEntry = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlFsEntry_GetLastModifiedDate" , &hFsEntry ) )
			break;

		PRL_STR	sFsEntryLastModifiedDate = (PRL_STR )0;
		PRL_UINT32	rnFsEntryLastModifiedDateBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlFsEntry_GetLastModifiedDate( hFsEntry, sFsEntryLastModifiedDate, &rnFsEntryLastModifiedDateBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sFsEntryLastModifiedDate(rnFsEntryLastModifiedDateBufLength, '\0');
		sFsEntryLastModifiedDate = (PRL_STR )std_sFsEntryLastModifiedDate.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlFsEntry_GetLastModifiedDate( hFsEntry, sFsEntryLastModifiedDate, &rnFsEntryLastModifiedDateBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sFsEntryLastModifiedDate )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlFsEntry_GetSize(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hFsEntry = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlFsEntry_GetSize" , &hFsEntry ) )
			break;

		PRL_UINT64	rnSize = (PRL_UINT64 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlFsEntry_GetSize( hFsEntry, &rnSize );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "K", rnSize )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlFsEntry_GetPermissions(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hFsEntry = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlFsEntry_GetPermissions" , &hFsEntry ) )
			break;

		PRL_UINT32	rnPermissions = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlFsEntry_GetPermissions( hFsEntry, &rnPermissions );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnPermissions )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlFsEntry_GetType(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hFsEntry = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlFsEntry_GetType" , &hFsEntry ) )
			break;

		PRL_FILE_SYSTEM_ELEMENT_TYPE	rnFsEntryType = (PRL_FILE_SYSTEM_ELEMENT_TYPE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlFsEntry_GetType( hFsEntry, &rnFsEntryType );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "i", rnFsEntryType )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_NetServiceStart(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrv_NetServiceStart" , &hServer ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_NetServiceStart( hServer );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_NetServiceStop(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrv_NetServiceStop" , &hServer ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_NetServiceStop( hServer );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_NetServiceRestart(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrv_NetServiceRestart" , &hServer ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_NetServiceRestart( hServer );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_NetServiceRestoreDefaults(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrv_NetServiceRestoreDefaults" , &hServer ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_NetServiceRestoreDefaults( hServer );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_GetNetServiceStatus(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrv_GetNetServiceStatus" , &hServer ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_GetNetServiceStatus( hServer );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_GetProblemReport(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrv_GetProblemReport" , &hServer ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_GetProblemReport( hServer );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_GetPackedProblemReport(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;
		PRL_UINT32	nFlags = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlSrv_GetPackedProblemReport" , &hServer, &nFlags ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_GetPackedProblemReport( hServer, nFlags );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_AttachToLostTask(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;
		PRL_CONST_STR	sTaskId = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ks:PrlSrv_AttachToLostTask" , &hServer, &sTaskId ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_AttachToLostTask( hServer, sTaskId );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_GetSupportedOses(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrv_GetSupportedOses" , &hServer ) )
			break;

		PRL_HANDLE	rhOsesMatrix = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrv_GetSupportedOses( hServer, &rhOsesMatrix );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhOsesMatrix )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvCfg_GetHostRamSize(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hSrvConfig = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrvCfg_GetHostRamSize" , &hSrvConfig ) )
			break;

		PRL_UINT32	rnHostRamSize = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfg_GetHostRamSize( hSrvConfig, &rnHostRamSize );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnHostRamSize )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvCfg_GetCpuModel(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hSrvConfig = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrvCfg_GetCpuModel" , &hSrvConfig ) )
			break;

		PRL_STR	sCpuModel = (PRL_STR )0;
		PRL_UINT32	rnCpuModelBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfg_GetCpuModel( hSrvConfig, sCpuModel, &rnCpuModelBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sCpuModel(rnCpuModelBufLength, '\0');
		sCpuModel = (PRL_STR )std_sCpuModel.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfg_GetCpuModel( hSrvConfig, sCpuModel, &rnCpuModelBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sCpuModel )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvCfg_GetCpuCount(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hSrvConfig = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrvCfg_GetCpuCount" , &hSrvConfig ) )
			break;

		PRL_UINT32	rnCpuCount = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfg_GetCpuCount( hSrvConfig, &rnCpuCount );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnCpuCount )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvCfg_GetCpuSpeed(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hSrvConfig = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrvCfg_GetCpuSpeed" , &hSrvConfig ) )
			break;

		PRL_UINT32	rnCpuSpeed = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfg_GetCpuSpeed( hSrvConfig, &rnCpuSpeed );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnCpuSpeed )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvCfg_GetCpuMode(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hSrvConfig = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrvCfg_GetCpuMode" , &hSrvConfig ) )
			break;

		PRL_CPU_MODE	rnCpuMode = (PRL_CPU_MODE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfg_GetCpuMode( hSrvConfig, &rnCpuMode );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "i", rnCpuMode )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvCfg_GetCpuHvt(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hSrvConfig = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrvCfg_GetCpuHvt" , &hSrvConfig ) )
			break;

		PRL_CPU_HVT	rnCpuHvt = (PRL_CPU_HVT )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfg_GetCpuHvt( hSrvConfig, &rnCpuHvt );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "i", rnCpuHvt )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvCfg_GetCpuFeaturesEx(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hSrvConfig = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrvCfg_GetCpuFeaturesEx" , &hSrvConfig ) )
			break;

		PRL_HANDLE	rhCpuFeatures = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfg_GetCpuFeaturesEx( hSrvConfig, &rhCpuFeatures );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhCpuFeatures )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvCfg_GetCpuFeaturesMaskingCapabilities(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hSrvConfig = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrvCfg_GetCpuFeaturesMaskingCapabilities" , &hSrvConfig ) )
			break;

		PRL_HANDLE	rhCpuFeatures = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfg_GetCpuFeaturesMaskingCapabilities( hSrvConfig, &rhCpuFeatures );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhCpuFeatures )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvCfg_GetHostOsType(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hSrvConfig = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrvCfg_GetHostOsType" , &hSrvConfig ) )
			break;

		PRL_HOST_OS_TYPE	rnHostOsType = (PRL_HOST_OS_TYPE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfg_GetHostOsType( hSrvConfig, &rnHostOsType );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "i", rnHostOsType )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvCfg_GetHostOsMajor(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hSrvConfig = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrvCfg_GetHostOsMajor" , &hSrvConfig ) )
			break;

		PRL_UINT32	rnHostOsMajor = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfg_GetHostOsMajor( hSrvConfig, &rnHostOsMajor );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnHostOsMajor )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvCfg_GetHostOsMinor(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hSrvConfig = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrvCfg_GetHostOsMinor" , &hSrvConfig ) )
			break;

		PRL_UINT32	rnHostOsMinor = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfg_GetHostOsMinor( hSrvConfig, &rnHostOsMinor );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnHostOsMinor )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvCfg_GetHostOsSubMinor(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hSrvConfig = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrvCfg_GetHostOsSubMinor" , &hSrvConfig ) )
			break;

		PRL_UINT32	rnHostOsSubMinor = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfg_GetHostOsSubMinor( hSrvConfig, &rnHostOsSubMinor );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnHostOsSubMinor )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvCfg_GetHostOsStrPresentation(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hSrvConfig = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrvCfg_GetHostOsStrPresentation" , &hSrvConfig ) )
			break;

		PRL_STR	sHostOsStrPresentation = (PRL_STR )0;
		PRL_UINT32	rnHostOsStrPresentationBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfg_GetHostOsStrPresentation( hSrvConfig, sHostOsStrPresentation, &rnHostOsStrPresentationBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sHostOsStrPresentation(rnHostOsStrPresentationBufLength, '\0');
		sHostOsStrPresentation = (PRL_STR )std_sHostOsStrPresentation.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfg_GetHostOsStrPresentation( hSrvConfig, sHostOsStrPresentation, &rnHostOsStrPresentationBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sHostOsStrPresentation )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvCfg_IsSoundDefaultEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hSrvConfig = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrvCfg_IsSoundDefaultEnabled" , &hSrvConfig ) )
			break;

		PRL_BOOL	rbSoundDefaultEnabled = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfg_IsSoundDefaultEnabled( hSrvConfig, &rbSoundDefaultEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbSoundDefaultEnabled )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvCfg_IsUsbSupported(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hSrvConfig = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrvCfg_IsUsbSupported" , &hSrvConfig ) )
			break;

		PRL_BOOL	rbUsbSupported = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfg_IsUsbSupported( hSrvConfig, &rbUsbSupported );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbUsbSupported )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvCfg_IsVtdSupported(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hSrvConfig = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrvCfg_IsVtdSupported" , &hSrvConfig ) )
			break;

		PRL_BOOL	rbVtdSupported = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfg_IsVtdSupported( hSrvConfig, &rbVtdSupported );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbVtdSupported )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvCfg_GetMaxHostNetAdapters(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hSrvConfig = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrvCfg_GetMaxHostNetAdapters" , &hSrvConfig ) )
			break;

		PRL_UINT32	rnMaxNetAdaptersCount = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfg_GetMaxHostNetAdapters( hSrvConfig, &rnMaxNetAdaptersCount );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnMaxNetAdaptersCount )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvCfg_GetMaxVmNetAdapters(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hSrvConfig = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrvCfg_GetMaxVmNetAdapters" , &hSrvConfig ) )
			break;

		PRL_UINT32	rnMaxNetAdaptersCount = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfg_GetMaxVmNetAdapters( hSrvConfig, &rnMaxNetAdaptersCount );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnMaxNetAdaptersCount )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvCfg_GetHostname(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hSrvConfig = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrvCfg_GetHostname" , &hSrvConfig ) )
			break;

		PRL_STR	sHostname = (PRL_STR )0;
		PRL_UINT32	rnHostnameBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfg_GetHostname( hSrvConfig, sHostname, &rnHostnameBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sHostname(rnHostnameBufLength, '\0');
		sHostname = (PRL_STR )std_sHostname.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfg_GetHostname( hSrvConfig, sHostname, &rnHostnameBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sHostname )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvCfg_GetDefaultGateway(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hSrvConfig = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrvCfg_GetDefaultGateway" , &hSrvConfig ) )
			break;

		PRL_STR	sDefaultGateway = (PRL_STR )0;
		PRL_UINT32	rnDefaultGatewayBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfg_GetDefaultGateway( hSrvConfig, sDefaultGateway, &rnDefaultGatewayBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sDefaultGateway(rnDefaultGatewayBufLength, '\0');
		sDefaultGateway = (PRL_STR )std_sDefaultGateway.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfg_GetDefaultGateway( hSrvConfig, sDefaultGateway, &rnDefaultGatewayBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sDefaultGateway )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvCfg_GetDefaultGatewayIPv6(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hSrvConfig = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrvCfg_GetDefaultGatewayIPv6" , &hSrvConfig ) )
			break;

		PRL_STR	sDefaultGateway = (PRL_STR )0;
		PRL_UINT32	rnDefaultGatewayBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfg_GetDefaultGatewayIPv6( hSrvConfig, sDefaultGateway, &rnDefaultGatewayBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sDefaultGateway(rnDefaultGatewayBufLength, '\0');
		sDefaultGateway = (PRL_STR )std_sDefaultGateway.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfg_GetDefaultGatewayIPv6( hSrvConfig, sDefaultGateway, &rnDefaultGatewayBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sDefaultGateway )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvCfg_GetDnsServers(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hSrvConfig = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrvCfg_GetDnsServers" , &hSrvConfig ) )
			break;

		PRL_HANDLE	rhDnsServersList = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfg_GetDnsServers( hSrvConfig, &rhDnsServersList );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhDnsServersList )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvCfg_GetSearchDomains(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hSrvConfig = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrvCfg_GetSearchDomains" , &hSrvConfig ) )
			break;

		PRL_HANDLE	rhSearchDomainsList = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfg_GetSearchDomains( hSrvConfig, &rhSearchDomainsList );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhSearchDomainsList )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvCfg_GetFloppyDisksCount(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hSrvConfig = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrvCfg_GetFloppyDisksCount" , &hSrvConfig ) )
			break;

		PRL_UINT32	rnFloppyDisksCount = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfg_GetFloppyDisksCount( hSrvConfig, &rnFloppyDisksCount );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnFloppyDisksCount )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvCfg_GetFloppyDisk(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hSrvConfig = (PRL_HANDLE )0;
		PRL_UINT32	nIndex = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlSrvCfg_GetFloppyDisk" , &hSrvConfig, &nIndex ) )
			break;

		PRL_HANDLE	rhDevice = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfg_GetFloppyDisk( hSrvConfig, nIndex, &rhDevice );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhDevice )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvCfg_GetOpticalDisksCount(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hSrvConfig = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrvCfg_GetOpticalDisksCount" , &hSrvConfig ) )
			break;

		PRL_UINT32	rnOpticalDisksCount = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfg_GetOpticalDisksCount( hSrvConfig, &rnOpticalDisksCount );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnOpticalDisksCount )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvCfg_GetOpticalDisk(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hSrvConfig = (PRL_HANDLE )0;
		PRL_UINT32	nIndex = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlSrvCfg_GetOpticalDisk" , &hSrvConfig, &nIndex ) )
			break;

		PRL_HANDLE	rhDevice = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfg_GetOpticalDisk( hSrvConfig, nIndex, &rhDevice );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhDevice )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvCfg_GetSerialPortsCount(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hSrvConfig = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrvCfg_GetSerialPortsCount" , &hSrvConfig ) )
			break;

		PRL_UINT32	rnSerialPortsCount = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfg_GetSerialPortsCount( hSrvConfig, &rnSerialPortsCount );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnSerialPortsCount )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvCfg_GetSerialPort(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hSrvConfig = (PRL_HANDLE )0;
		PRL_UINT32	nIndex = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlSrvCfg_GetSerialPort" , &hSrvConfig, &nIndex ) )
			break;

		PRL_HANDLE	rhDevice = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfg_GetSerialPort( hSrvConfig, nIndex, &rhDevice );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhDevice )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvCfg_GetParallelPortsCount(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hSrvConfig = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrvCfg_GetParallelPortsCount" , &hSrvConfig ) )
			break;

		PRL_UINT32	rnParallelPortsCount = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfg_GetParallelPortsCount( hSrvConfig, &rnParallelPortsCount );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnParallelPortsCount )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvCfg_GetParallelPort(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hSrvConfig = (PRL_HANDLE )0;
		PRL_UINT32	nIndex = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlSrvCfg_GetParallelPort" , &hSrvConfig, &nIndex ) )
			break;

		PRL_HANDLE	rhDevice = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfg_GetParallelPort( hSrvConfig, nIndex, &rhDevice );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhDevice )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvCfg_GetSoundOutputDevsCount(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hSrvConfig = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrvCfg_GetSoundOutputDevsCount" , &hSrvConfig ) )
			break;

		PRL_UINT32	rnSoundOutputDevsCount = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfg_GetSoundOutputDevsCount( hSrvConfig, &rnSoundOutputDevsCount );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnSoundOutputDevsCount )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvCfg_GetSoundOutputDev(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hSrvConfig = (PRL_HANDLE )0;
		PRL_UINT32	nIndex = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlSrvCfg_GetSoundOutputDev" , &hSrvConfig, &nIndex ) )
			break;

		PRL_HANDLE	rhDevice = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfg_GetSoundOutputDev( hSrvConfig, nIndex, &rhDevice );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhDevice )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvCfg_GetSoundMixerDevsCount(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hSrvConfig = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrvCfg_GetSoundMixerDevsCount" , &hSrvConfig ) )
			break;

		PRL_UINT32	rnSoundMixerDevsCount = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfg_GetSoundMixerDevsCount( hSrvConfig, &rnSoundMixerDevsCount );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnSoundMixerDevsCount )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvCfg_GetSoundMixerDev(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hSrvConfig = (PRL_HANDLE )0;
		PRL_UINT32	nIndex = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlSrvCfg_GetSoundMixerDev" , &hSrvConfig, &nIndex ) )
			break;

		PRL_HANDLE	rhDevice = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfg_GetSoundMixerDev( hSrvConfig, nIndex, &rhDevice );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhDevice )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvCfg_GetPrintersCount(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hSrvConfig = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrvCfg_GetPrintersCount" , &hSrvConfig ) )
			break;

		PRL_UINT32	rnPrintersCount = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfg_GetPrintersCount( hSrvConfig, &rnPrintersCount );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnPrintersCount )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvCfg_GetPrinter(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hSrvConfig = (PRL_HANDLE )0;
		PRL_UINT32	nIndex = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlSrvCfg_GetPrinter" , &hSrvConfig, &nIndex ) )
			break;

		PRL_HANDLE	rhDevice = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfg_GetPrinter( hSrvConfig, nIndex, &rhDevice );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhDevice )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvCfg_GetGenericPciDevicesCount(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hSrvConfig = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrvCfg_GetGenericPciDevicesCount" , &hSrvConfig ) )
			break;

		PRL_UINT32	rnGenericPciDevicesCount = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfg_GetGenericPciDevicesCount( hSrvConfig, &rnGenericPciDevicesCount );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnGenericPciDevicesCount )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvCfg_GetGenericPciDevice(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hSrvConfig = (PRL_HANDLE )0;
		PRL_UINT32	nIndex = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlSrvCfg_GetGenericPciDevice" , &hSrvConfig, &nIndex ) )
			break;

		PRL_HANDLE	rhDevice = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfg_GetGenericPciDevice( hSrvConfig, nIndex, &rhDevice );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhDevice )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvCfg_GetGenericScsiDevicesCount(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hSrvConfig = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrvCfg_GetGenericScsiDevicesCount" , &hSrvConfig ) )
			break;

		PRL_UINT32	rnGenericScsiDevicesCount = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfg_GetGenericScsiDevicesCount( hSrvConfig, &rnGenericScsiDevicesCount );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnGenericScsiDevicesCount )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvCfg_GetGenericScsiDevice(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hSrvConfig = (PRL_HANDLE )0;
		PRL_UINT32	nIndex = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlSrvCfg_GetGenericScsiDevice" , &hSrvConfig, &nIndex ) )
			break;

		PRL_HANDLE	rhDevice = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfg_GetGenericScsiDevice( hSrvConfig, nIndex, &rhDevice );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhDevice )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvCfg_GetUsbDevsCount(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hSrvConfig = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrvCfg_GetUsbDevsCount" , &hSrvConfig ) )
			break;

		PRL_UINT32	rnUsbDevsCount = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfg_GetUsbDevsCount( hSrvConfig, &rnUsbDevsCount );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnUsbDevsCount )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvCfg_GetUsbDev(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hSrvConfig = (PRL_HANDLE )0;
		PRL_UINT32	nIndex = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlSrvCfg_GetUsbDev" , &hSrvConfig, &nIndex ) )
			break;

		PRL_HANDLE	rhDevice = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfg_GetUsbDev( hSrvConfig, nIndex, &rhDevice );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhDevice )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvCfg_GetHardDisksCount(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hSrvConfig = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrvCfg_GetHardDisksCount" , &hSrvConfig ) )
			break;

		PRL_UINT32	rnHardDisksCount = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfg_GetHardDisksCount( hSrvConfig, &rnHardDisksCount );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnHardDisksCount )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvCfg_GetHardDisk(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hSrvConfig = (PRL_HANDLE )0;
		PRL_UINT32	nIndex = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlSrvCfg_GetHardDisk" , &hSrvConfig, &nIndex ) )
			break;

		PRL_HANDLE	rhDevice = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfg_GetHardDisk( hSrvConfig, nIndex, &rhDevice );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhDevice )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvCfg_GetNetAdaptersCount(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hSrvConfig = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrvCfg_GetNetAdaptersCount" , &hSrvConfig ) )
			break;

		PRL_UINT32	rnNetAdaptersCount = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfg_GetNetAdaptersCount( hSrvConfig, &rnNetAdaptersCount );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnNetAdaptersCount )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvCfg_GetNetAdapter(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hSrvConfig = (PRL_HANDLE )0;
		PRL_UINT32	nIndex = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlSrvCfg_GetNetAdapter" , &hSrvConfig, &nIndex ) )
			break;

		PRL_HANDLE	rhDevice = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfg_GetNetAdapter( hSrvConfig, nIndex, &rhDevice );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhDevice )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvCfgDev_GetName(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hGenericDevice = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrvCfgDev_GetName" , &hGenericDevice ) )
			break;

		PRL_STR	sDevName = (PRL_STR )0;
		PRL_UINT32	rnDevNameBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfgDev_GetName( hGenericDevice, sDevName, &rnDevNameBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sDevName(rnDevNameBufLength, '\0');
		sDevName = (PRL_STR )std_sDevName.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfgDev_GetName( hGenericDevice, sDevName, &rnDevNameBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sDevName )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvCfgDev_GetId(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hGenericDevice = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrvCfgDev_GetId" , &hGenericDevice ) )
			break;

		PRL_STR	sDevId = (PRL_STR )0;
		PRL_UINT32	rnDevIdBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfgDev_GetId( hGenericDevice, sDevId, &rnDevIdBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sDevId(rnDevIdBufLength, '\0');
		sDevId = (PRL_STR )std_sDevId.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfgDev_GetId( hGenericDevice, sDevId, &rnDevIdBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sDevId )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvCfgDev_GetType(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hGenericDevice = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrvCfgDev_GetType" , &hGenericDevice ) )
			break;

		PRL_DEVICE_TYPE	rnDevType = (PRL_DEVICE_TYPE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfgDev_GetType( hGenericDevice, &rnDevType );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "i", rnDevType )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvCfgDev_IsConnectedToVm(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hGenericDevice = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrvCfgDev_IsConnectedToVm" , &hGenericDevice ) )
			break;

		PRL_BOOL	rbConnected = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfgDev_IsConnectedToVm( hGenericDevice, &rbConnected );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbConnected )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvCfgDev_GetDeviceState(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hGenericDevice = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrvCfgDev_GetDeviceState" , &hGenericDevice ) )
			break;

		PRL_GENERIC_DEVICE_STATE	rnDeviceState = (PRL_GENERIC_DEVICE_STATE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfgDev_GetDeviceState( hGenericDevice, &rnDeviceState );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "i", rnDeviceState )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvCfgDev_SetDeviceState(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hGenericDevice = (PRL_HANDLE )0;
		PRL_INT32	nDeviceState = (PRL_INT32 )0;

		if ( ! PyArg_ParseTuple( args, "ki:PrlSrvCfgDev_SetDeviceState" , &hGenericDevice, &nDeviceState ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfgDev_SetDeviceState( hGenericDevice, (PRL_GENERIC_DEVICE_STATE )nDeviceState );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvCfgHdd_GetDevName(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hHardDisk = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrvCfgHdd_GetDevName" , &hHardDisk ) )
			break;

		PRL_STR	sDevName = (PRL_STR )0;
		PRL_UINT32	rnDevNameBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfgHdd_GetDevName( hHardDisk, sDevName, &rnDevNameBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sDevName(rnDevNameBufLength, '\0');
		sDevName = (PRL_STR )std_sDevName.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfgHdd_GetDevName( hHardDisk, sDevName, &rnDevNameBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sDevName )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvCfgHdd_GetDevId(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hHardDisk = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrvCfgHdd_GetDevId" , &hHardDisk ) )
			break;

		PRL_STR	sDevId = (PRL_STR )0;
		PRL_UINT32	rnDevIdBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfgHdd_GetDevId( hHardDisk, sDevId, &rnDevIdBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sDevId(rnDevIdBufLength, '\0');
		sDevId = (PRL_STR )std_sDevId.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfgHdd_GetDevId( hHardDisk, sDevId, &rnDevIdBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sDevId )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvCfgHdd_GetDevSize(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hHardDisk = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrvCfgHdd_GetDevSize" , &hHardDisk ) )
			break;

		PRL_UINT64	rnSize = (PRL_UINT64 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfgHdd_GetDevSize( hHardDisk, &rnSize );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "K", rnSize )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvCfgHdd_GetDiskIndex(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hHardDisk = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrvCfgHdd_GetDiskIndex" , &hHardDisk ) )
			break;

		PRL_UINT32	rnIndex = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfgHdd_GetDiskIndex( hHardDisk, &rnIndex );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnIndex )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvCfgHdd_GetPartsCount(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hHardDisk = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrvCfgHdd_GetPartsCount" , &hHardDisk ) )
			break;

		PRL_UINT32	rnPartsCount = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfgHdd_GetPartsCount( hHardDisk, &rnPartsCount );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnPartsCount )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvCfgHdd_GetPart(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hHardDisk = (PRL_HANDLE )0;
		PRL_UINT32	nIndex = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlSrvCfgHdd_GetPart" , &hHardDisk, &nIndex ) )
			break;

		PRL_HANDLE	rhPart = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfgHdd_GetPart( hHardDisk, nIndex, &rhPart );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhPart )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvCfgHddPart_GetName(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hPart = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrvCfgHddPart_GetName" , &hPart ) )
			break;

		PRL_STR	sName = (PRL_STR )0;
		PRL_UINT32	rnNameBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfgHddPart_GetName( hPart, sName, &rnNameBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sName(rnNameBufLength, '\0');
		sName = (PRL_STR )std_sName.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfgHddPart_GetName( hPart, sName, &rnNameBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sName )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvCfgHddPart_GetSysName(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hPart = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrvCfgHddPart_GetSysName" , &hPart ) )
			break;

		PRL_STR	sSysName = (PRL_STR )0;
		PRL_UINT32	rnSysNameBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfgHddPart_GetSysName( hPart, sSysName, &rnSysNameBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sSysName(rnSysNameBufLength, '\0');
		sSysName = (PRL_STR )std_sSysName.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfgHddPart_GetSysName( hPart, sSysName, &rnSysNameBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sSysName )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvCfgHddPart_GetSize(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hPart = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrvCfgHddPart_GetSize" , &hPart ) )
			break;

		PRL_UINT64	rnSize = (PRL_UINT64 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfgHddPart_GetSize( hPart, &rnSize );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "K", rnSize )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvCfgHddPart_GetIndex(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hPart = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrvCfgHddPart_GetIndex" , &hPart ) )
			break;

		PRL_UINT32	rnIndex = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfgHddPart_GetIndex( hPart, &rnIndex );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnIndex )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvCfgHddPart_GetType(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hPart = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrvCfgHddPart_GetType" , &hPart ) )
			break;

		PRL_UINT32	rnType = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfgHddPart_GetType( hPart, &rnType );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnType )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvCfgHddPart_IsInUse(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hPart = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrvCfgHddPart_IsInUse" , &hPart ) )
			break;

		PRL_BOOL	rbInUse = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfgHddPart_IsInUse( hPart, &rbInUse );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbInUse )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvCfgHddPart_IsLogical(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hPart = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrvCfgHddPart_IsLogical" , &hPart ) )
			break;

		PRL_BOOL	rbLogical = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfgHddPart_IsLogical( hPart, &rbLogical );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbLogical )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvCfgHddPart_IsActive(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hPart = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrvCfgHddPart_IsActive" , &hPart ) )
			break;

		PRL_BOOL	rbActive = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfgHddPart_IsActive( hPart, &rbActive );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbActive )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvCfgNet_GetNetAdapterType(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hNetAdapter = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrvCfgNet_GetNetAdapterType" , &hNetAdapter ) )
			break;

		PRL_HW_INFO_NET_ADAPTER_TYPE	rnNetAdapterType = (PRL_HW_INFO_NET_ADAPTER_TYPE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfgNet_GetNetAdapterType( hNetAdapter, &rnNetAdapterType );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "i", rnNetAdapterType )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvCfgNet_GetSysIndex(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hNetAdapter = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrvCfgNet_GetSysIndex" , &hNetAdapter ) )
			break;

		PRL_UINT32	rnSysIndex = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfgNet_GetSysIndex( hNetAdapter, &rnSysIndex );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnSysIndex )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvCfgNet_IsEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hNetAdapter = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrvCfgNet_IsEnabled" , &hNetAdapter ) )
			break;

		PRL_BOOL	rbEnabled = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfgNet_IsEnabled( hNetAdapter, &rbEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbEnabled )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvCfgNet_IsConfigureWithDhcp(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hNetAdapter = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrvCfgNet_IsConfigureWithDhcp" , &hNetAdapter ) )
			break;

		PRL_BOOL	rbConfigureWithDhcp = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfgNet_IsConfigureWithDhcp( hNetAdapter, &rbConfigureWithDhcp );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbConfigureWithDhcp )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvCfgNet_IsConfigureWithDhcpIPv6(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hNetAdapter = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrvCfgNet_IsConfigureWithDhcpIPv6" , &hNetAdapter ) )
			break;

		PRL_BOOL	rbConfigureWithDhcp = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfgNet_IsConfigureWithDhcpIPv6( hNetAdapter, &rbConfigureWithDhcp );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbConfigureWithDhcp )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvCfgNet_GetDefaultGateway(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hNetAdapter = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrvCfgNet_GetDefaultGateway" , &hNetAdapter ) )
			break;

		PRL_STR	sDefaultGateway = (PRL_STR )0;
		PRL_UINT32	rnDefaultGatewayBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfgNet_GetDefaultGateway( hNetAdapter, sDefaultGateway, &rnDefaultGatewayBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sDefaultGateway(rnDefaultGatewayBufLength, '\0');
		sDefaultGateway = (PRL_STR )std_sDefaultGateway.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfgNet_GetDefaultGateway( hNetAdapter, sDefaultGateway, &rnDefaultGatewayBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sDefaultGateway )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvCfgNet_GetDefaultGatewayIPv6(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hNetAdapter = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrvCfgNet_GetDefaultGatewayIPv6" , &hNetAdapter ) )
			break;

		PRL_STR	sDefaultGateway = (PRL_STR )0;
		PRL_UINT32	rnDefaultGatewayBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfgNet_GetDefaultGatewayIPv6( hNetAdapter, sDefaultGateway, &rnDefaultGatewayBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sDefaultGateway(rnDefaultGatewayBufLength, '\0');
		sDefaultGateway = (PRL_STR )std_sDefaultGateway.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfgNet_GetDefaultGatewayIPv6( hNetAdapter, sDefaultGateway, &rnDefaultGatewayBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sDefaultGateway )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvCfgNet_GetMacAddress(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hNetAdapter = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrvCfgNet_GetMacAddress" , &hNetAdapter ) )
			break;

		PRL_STR	sMacAddress = (PRL_STR )0;
		PRL_UINT32	rnMacAddressBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfgNet_GetMacAddress( hNetAdapter, sMacAddress, &rnMacAddressBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sMacAddress(rnMacAddressBufLength, '\0');
		sMacAddress = (PRL_STR )std_sMacAddress.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfgNet_GetMacAddress( hNetAdapter, sMacAddress, &rnMacAddressBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sMacAddress )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvCfgNet_GetVlanTag(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hNetAdapter = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrvCfgNet_GetVlanTag" , &hNetAdapter ) )
			break;

		PRL_UINT16	rnVlanTag = (PRL_UINT16 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfgNet_GetVlanTag( hNetAdapter, &rnVlanTag );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "H", rnVlanTag )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvCfgNet_GetNetAddresses(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hNetAdapter = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrvCfgNet_GetNetAddresses" , &hNetAdapter ) )
			break;

		PRL_HANDLE	rhNetAddressesList = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfgNet_GetNetAddresses( hNetAdapter, &rhNetAddressesList );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhNetAddressesList )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvCfgNet_GetDnsServers(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hNetAdapter = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrvCfgNet_GetDnsServers" , &hNetAdapter ) )
			break;

		PRL_HANDLE	rhDnsServersList = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfgNet_GetDnsServers( hNetAdapter, &rhDnsServersList );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhDnsServersList )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvCfgNet_GetSearchDomains(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hNetAdapter = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrvCfgNet_GetSearchDomains" , &hNetAdapter ) )
			break;

		PRL_HANDLE	rhSearchDomainsList = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfgNet_GetSearchDomains( hNetAdapter, &rhSearchDomainsList );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhSearchDomainsList )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvCfgPci_GetDeviceClass(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hGenericPci = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrvCfgPci_GetDeviceClass" , &hGenericPci ) )
			break;

		PRL_GENERIC_PCI_DEVICE_CLASS	rnGenericPciClass = (PRL_GENERIC_PCI_DEVICE_CLASS )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfgPci_GetDeviceClass( hGenericPci, &rnGenericPciClass );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "i", rnGenericPciClass )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvCfgPci_IsPrimaryDevice(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hGenericPci = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrvCfgPci_IsPrimaryDevice" , &hGenericPci ) )
			break;

		PRL_BOOL	rbIsPrimaryDevice = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvCfgPci_IsPrimaryDevice( hGenericPci, &rbIsPrimaryDevice );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbIsPrimaryDevice )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlUsrCfg_GetVmDirUuid(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hUserProfile = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlUsrCfg_GetVmDirUuid" , &hUserProfile ) )
			break;

		PRL_STR	sVmDirUuid = (PRL_STR )0;
		PRL_UINT32	rnVmDirUuidBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlUsrCfg_GetVmDirUuid( hUserProfile, sVmDirUuid, &rnVmDirUuidBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sVmDirUuid(rnVmDirUuidBufLength, '\0');
		sVmDirUuid = (PRL_STR )std_sVmDirUuid.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlUsrCfg_GetVmDirUuid( hUserProfile, sVmDirUuid, &rnVmDirUuidBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sVmDirUuid )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlUsrCfg_SetVmDirUuid(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hUserProfile = (PRL_HANDLE )0;
		PRL_CONST_STR	sNewVmDirUuid = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ks:PrlUsrCfg_SetVmDirUuid" , &hUserProfile, &sNewVmDirUuid ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlUsrCfg_SetVmDirUuid( hUserProfile, sNewVmDirUuid );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlUsrCfg_GetDefaultVmFolder(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hUserProfile = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlUsrCfg_GetDefaultVmFolder" , &hUserProfile ) )
			break;

		PRL_STR	sDefaultVmFolder = (PRL_STR )0;
		PRL_UINT32	rnDefaultVmFolderBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlUsrCfg_GetDefaultVmFolder( hUserProfile, sDefaultVmFolder, &rnDefaultVmFolderBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sDefaultVmFolder(rnDefaultVmFolderBufLength, '\0');
		sDefaultVmFolder = (PRL_STR )std_sDefaultVmFolder.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlUsrCfg_GetDefaultVmFolder( hUserProfile, sDefaultVmFolder, &rnDefaultVmFolderBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sDefaultVmFolder )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlUsrCfg_SetDefaultVmFolder(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hUserProfile = (PRL_HANDLE )0;
		PRL_CONST_STR	sNewDefaultVmFolder = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ks:PrlUsrCfg_SetDefaultVmFolder" , &hUserProfile, &sNewDefaultVmFolder ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlUsrCfg_SetDefaultVmFolder( hUserProfile, sNewDefaultVmFolder );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlUsrCfg_CanUseMngConsole(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hUserProfile = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlUsrCfg_CanUseMngConsole" , &hUserProfile ) )
			break;

		PRL_BOOL	rbCanUseMngConsole = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlUsrCfg_CanUseMngConsole( hUserProfile, &rbCanUseMngConsole );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbCanUseMngConsole )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlUsrCfg_CanChangeSrvSets(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hUserProfile = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlUsrCfg_CanChangeSrvSets" , &hUserProfile ) )
			break;

		PRL_BOOL	rbCanChangeSrvSets = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlUsrCfg_CanChangeSrvSets( hUserProfile, &rbCanChangeSrvSets );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbCanChangeSrvSets )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlUsrCfg_IsLocalAdministrator(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hUserProfile = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlUsrCfg_IsLocalAdministrator" , &hUserProfile ) )
			break;

		PRL_BOOL	rbIsLocalAdmin = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlUsrCfg_IsLocalAdministrator( hUserProfile, &rbIsLocalAdmin );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbIsLocalAdmin )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlUsrInfo_GetName(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hUserInfo = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlUsrInfo_GetName" , &hUserInfo ) )
			break;

		PRL_STR	sName = (PRL_STR )0;
		PRL_UINT32	rnNameBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlUsrInfo_GetName( hUserInfo, sName, &rnNameBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sName(rnNameBufLength, '\0');
		sName = (PRL_STR )std_sName.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlUsrInfo_GetName( hUserInfo, sName, &rnNameBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sName )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlUsrInfo_GetUuid(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hUserInfo = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlUsrInfo_GetUuid" , &hUserInfo ) )
			break;

		PRL_STR	sUuid = (PRL_STR )0;
		PRL_UINT32	rnUuidBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlUsrInfo_GetUuid( hUserInfo, sUuid, &rnUuidBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sUuid(rnUuidBufLength, '\0');
		sUuid = (PRL_STR )std_sUuid.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlUsrInfo_GetUuid( hUserInfo, sUuid, &rnUuidBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sUuid )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlUsrInfo_GetSessionCount(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hUserInfo = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlUsrInfo_GetSessionCount" , &hUserInfo ) )
			break;

		PRL_UINT32	rnSessionCount = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlUsrInfo_GetSessionCount( hUserInfo, &rnSessionCount );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnSessionCount )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlUsrInfo_GetDefaultVmFolder(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hUserInfo = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlUsrInfo_GetDefaultVmFolder" , &hUserInfo ) )
			break;

		PRL_STR	sDefaultVmFolder = (PRL_STR )0;
		PRL_UINT32	rnDefaultVmFolderBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlUsrInfo_GetDefaultVmFolder( hUserInfo, sDefaultVmFolder, &rnDefaultVmFolderBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sDefaultVmFolder(rnDefaultVmFolderBufLength, '\0');
		sDefaultVmFolder = (PRL_STR )std_sDefaultVmFolder.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlUsrInfo_GetDefaultVmFolder( hUserInfo, sDefaultVmFolder, &rnDefaultVmFolderBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sDefaultVmFolder )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlUsrInfo_CanChangeSrvSets(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hUserInfo = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlUsrInfo_CanChangeSrvSets" , &hUserInfo ) )
			break;

		PRL_BOOL	rbCanChangeSrvSets = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlUsrInfo_CanChangeSrvSets( hUserInfo, &rbCanChangeSrvSets );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbCanChangeSrvSets )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlDispCfg_GetDefaultVmDir(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hDispConfig = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlDispCfg_GetDefaultVmDir" , &hDispConfig ) )
			break;

		PRL_STR	sDefaultVmDir = (PRL_STR )0;
		PRL_UINT32	rnDefaultVmDirBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlDispCfg_GetDefaultVmDir( hDispConfig, sDefaultVmDir, &rnDefaultVmDirBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sDefaultVmDir(rnDefaultVmDirBufLength, '\0');
		sDefaultVmDir = (PRL_STR )std_sDefaultVmDir.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlDispCfg_GetDefaultVmDir( hDispConfig, sDefaultVmDir, &rnDefaultVmDirBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sDefaultVmDir )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlDispCfg_GetDefaultCtDir(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hDispConfig = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlDispCfg_GetDefaultCtDir" , &hDispConfig ) )
			break;

		PRL_STR	sDefaultDir = (PRL_STR )0;
		PRL_UINT32	rnDefaultDirBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlDispCfg_GetDefaultCtDir( hDispConfig, sDefaultDir, &rnDefaultDirBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sDefaultDir(rnDefaultDirBufLength, '\0');
		sDefaultDir = (PRL_STR )std_sDefaultDir.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlDispCfg_GetDefaultCtDir( hDispConfig, sDefaultDir, &rnDefaultDirBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sDefaultDir )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlDispCfg_GetReservedMemLimit(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hDispConfig = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlDispCfg_GetReservedMemLimit" , &hDispConfig ) )
			break;

		PRL_UINT32	rnMemSize = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlDispCfg_GetReservedMemLimit( hDispConfig, &rnMemSize );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnMemSize )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlDispCfg_SetReservedMemLimit(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hDispConfig = (PRL_HANDLE )0;
		PRL_UINT32	nMemSize = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlDispCfg_SetReservedMemLimit" , &hDispConfig, &nMemSize ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlDispCfg_SetReservedMemLimit( hDispConfig, nMemSize );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlDispCfg_GetMinVmMem(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hDispConfig = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlDispCfg_GetMinVmMem" , &hDispConfig ) )
			break;

		PRL_UINT32	rnMemSize = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlDispCfg_GetMinVmMem( hDispConfig, &rnMemSize );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnMemSize )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlDispCfg_SetMinVmMem(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hDispConfig = (PRL_HANDLE )0;
		PRL_UINT32	nMemSize = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlDispCfg_SetMinVmMem" , &hDispConfig, &nMemSize ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlDispCfg_SetMinVmMem( hDispConfig, nMemSize );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlDispCfg_GetMaxVmMem(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hDispConfig = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlDispCfg_GetMaxVmMem" , &hDispConfig ) )
			break;

		PRL_UINT32	rnMemSize = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlDispCfg_GetMaxVmMem( hDispConfig, &rnMemSize );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnMemSize )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlDispCfg_SetMaxVmMem(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hDispConfig = (PRL_HANDLE )0;
		PRL_UINT32	nMemSize = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlDispCfg_SetMaxVmMem" , &hDispConfig, &nMemSize ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlDispCfg_SetMaxVmMem( hDispConfig, nMemSize );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlDispCfg_GetRecommendMaxVmMem(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hDispConfig = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlDispCfg_GetRecommendMaxVmMem" , &hDispConfig ) )
			break;

		PRL_UINT32	rnMemSize = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlDispCfg_GetRecommendMaxVmMem( hDispConfig, &rnMemSize );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnMemSize )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlDispCfg_SetRecommendMaxVmMem(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hDispConfig = (PRL_HANDLE )0;
		PRL_UINT32	nMemSize = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlDispCfg_SetRecommendMaxVmMem" , &hDispConfig, &nMemSize ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlDispCfg_SetRecommendMaxVmMem( hDispConfig, nMemSize );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlDispCfg_GetMaxReservMemLimit(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hDispConfig = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlDispCfg_GetMaxReservMemLimit" , &hDispConfig ) )
			break;

		PRL_UINT32	rnMemSize = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlDispCfg_GetMaxReservMemLimit( hDispConfig, &rnMemSize );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnMemSize )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlDispCfg_SetMaxReservMemLimit(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hDispConfig = (PRL_HANDLE )0;
		PRL_UINT32	nMemSize = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlDispCfg_SetMaxReservMemLimit" , &hDispConfig, &nMemSize ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlDispCfg_SetMaxReservMemLimit( hDispConfig, nMemSize );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlDispCfg_GetMinReservMemLimit(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hDispConfig = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlDispCfg_GetMinReservMemLimit" , &hDispConfig ) )
			break;

		PRL_UINT32	rnMemSize = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlDispCfg_GetMinReservMemLimit( hDispConfig, &rnMemSize );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnMemSize )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlDispCfg_SetMinReservMemLimit(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hDispConfig = (PRL_HANDLE )0;
		PRL_UINT32	nMemSize = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlDispCfg_SetMinReservMemLimit" , &hDispConfig, &nMemSize ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlDispCfg_SetMinReservMemLimit( hDispConfig, nMemSize );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlDispCfg_IsAdjustMemAuto(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hDispConfig = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlDispCfg_IsAdjustMemAuto" , &hDispConfig ) )
			break;

		PRL_BOOL	rbAdjustMemAuto = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlDispCfg_IsAdjustMemAuto( hDispConfig, &rbAdjustMemAuto );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbAdjustMemAuto )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlDispCfg_SetAdjustMemAuto(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hDispConfig = (PRL_HANDLE )0;
		PRL_BOOL	bAdjustMemAuto = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlDispCfg_SetAdjustMemAuto" , &hDispConfig, &bAdjustMemAuto ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlDispCfg_SetAdjustMemAuto( hDispConfig, bAdjustMemAuto );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlDispCfg_IsSendStatisticReport(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hDispConfig = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlDispCfg_IsSendStatisticReport" , &hDispConfig ) )
			break;

		PRL_BOOL	rbSendStatisticReport = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlDispCfg_IsSendStatisticReport( hDispConfig, &rbSendStatisticReport );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbSendStatisticReport )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlDispCfg_SetSendStatisticReport(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hDispConfig = (PRL_HANDLE )0;
		PRL_BOOL	bSendStatisticReport = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlDispCfg_SetSendStatisticReport" , &hDispConfig, &bSendStatisticReport ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlDispCfg_SetSendStatisticReport( hDispConfig, bSendStatisticReport );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlDispCfg_GetDefaultVNCHostName(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hDispConfig = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlDispCfg_GetDefaultVNCHostName" , &hDispConfig ) )
			break;

		PRL_STR	sHostName = (PRL_STR )0;
		PRL_UINT32	rnHostNameBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlDispCfg_GetDefaultVNCHostName( hDispConfig, sHostName, &rnHostNameBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sHostName(rnHostNameBufLength, '\0');
		sHostName = (PRL_STR )std_sHostName.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlDispCfg_GetDefaultVNCHostName( hDispConfig, sHostName, &rnHostNameBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sHostName )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlDispCfg_SetDefaultVNCHostName(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hDispConfig = (PRL_HANDLE )0;
		PRL_CONST_STR	sNewHostName = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ks:PrlDispCfg_SetDefaultVNCHostName" , &hDispConfig, &sNewHostName ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlDispCfg_SetDefaultVNCHostName( hDispConfig, sNewHostName );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlDispCfg_GetVNCBasePort(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hDispConfig = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlDispCfg_GetVNCBasePort" , &hDispConfig ) )
			break;

		PRL_UINT32	rnPort = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlDispCfg_GetVNCBasePort( hDispConfig, &rnPort );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnPort )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlDispCfg_SetVNCBasePort(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hDispConfig = (PRL_HANDLE )0;
		PRL_UINT32	nPort = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlDispCfg_SetVNCBasePort" , &hDispConfig, &nPort ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlDispCfg_SetVNCBasePort( hDispConfig, nPort );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlDispCfg_CanChangeDefaultSettings(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hDispConfig = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlDispCfg_CanChangeDefaultSettings" , &hDispConfig ) )
			break;

		PRL_BOOL	rbDefaultChangeSettings = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlDispCfg_CanChangeDefaultSettings( hDispConfig, &rbDefaultChangeSettings );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbDefaultChangeSettings )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlDispCfg_SetCanChangeDefaultSettings(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hDispConfig = (PRL_HANDLE )0;
		PRL_BOOL	bDefaultChangeSettings = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlDispCfg_SetCanChangeDefaultSettings" , &hDispConfig, &bDefaultChangeSettings ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlDispCfg_SetCanChangeDefaultSettings( hDispConfig, bDefaultChangeSettings );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlDispCfg_GetMinSecurityLevel(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hDispConfig = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlDispCfg_GetMinSecurityLevel" , &hDispConfig ) )
			break;

		PRL_SECURITY_LEVEL	rnMinSecurityLevel = (PRL_SECURITY_LEVEL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlDispCfg_GetMinSecurityLevel( hDispConfig, &rnMinSecurityLevel );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "i", rnMinSecurityLevel )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlDispCfg_SetMinSecurityLevel(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hDispConfig = (PRL_HANDLE )0;
		PRL_INT32	nMinSecurityLevel = (PRL_INT32 )0;

		if ( ! PyArg_ParseTuple( args, "ki:PrlDispCfg_SetMinSecurityLevel" , &hDispConfig, &nMinSecurityLevel ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlDispCfg_SetMinSecurityLevel( hDispConfig, (PRL_SECURITY_LEVEL )nMinSecurityLevel );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlDispCfg_GetConfirmationsList(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hDispConfig = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlDispCfg_GetConfirmationsList" , &hDispConfig ) )
			break;

		PRL_HANDLE	rhConfirmList = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlDispCfg_GetConfirmationsList( hDispConfig, &rhConfirmList );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhConfirmList )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlDispCfg_SetConfirmationsList(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hDispConfig = (PRL_HANDLE )0;
		PRL_HANDLE	hConfirmList = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "kk:PrlDispCfg_SetConfirmationsList" , &hDispConfig, &hConfirmList ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlDispCfg_SetConfirmationsList( hDispConfig, hConfirmList );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlDispCfg_GetDefaultBackupServer(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hDispConfig = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlDispCfg_GetDefaultBackupServer" , &hDispConfig ) )
			break;

		PRL_STR	sBackupServer = (PRL_STR )0;
		PRL_UINT32	rnBackupServerBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlDispCfg_GetDefaultBackupServer( hDispConfig, sBackupServer, &rnBackupServerBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sBackupServer(rnBackupServerBufLength, '\0');
		sBackupServer = (PRL_STR )std_sBackupServer.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlDispCfg_GetDefaultBackupServer( hDispConfig, sBackupServer, &rnBackupServerBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sBackupServer )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlDispCfg_SetDefaultBackupServer(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hDispConfig = (PRL_HANDLE )0;
		PRL_CONST_STR	sBackupServer = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ks:PrlDispCfg_SetDefaultBackupServer" , &hDispConfig, &sBackupServer ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlDispCfg_SetDefaultBackupServer( hDispConfig, sBackupServer );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlDispCfg_GetBackupUserLogin(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hDispConfig = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlDispCfg_GetBackupUserLogin" , &hDispConfig ) )
			break;

		PRL_STR	sUserLogin = (PRL_STR )0;
		PRL_UINT32	rnUserLoginBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlDispCfg_GetBackupUserLogin( hDispConfig, sUserLogin, &rnUserLoginBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sUserLogin(rnUserLoginBufLength, '\0');
		sUserLogin = (PRL_STR )std_sUserLogin.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlDispCfg_GetBackupUserLogin( hDispConfig, sUserLogin, &rnUserLoginBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sUserLogin )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlDispCfg_SetBackupUserLogin(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hDispConfig = (PRL_HANDLE )0;
		PRL_CONST_STR	sUserLogin = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ks:PrlDispCfg_SetBackupUserLogin" , &hDispConfig, &sUserLogin ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlDispCfg_SetBackupUserLogin( hDispConfig, sUserLogin );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlDispCfg_SetBackupUserPassword(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hDispConfig = (PRL_HANDLE )0;
		PRL_CONST_STR	sUserPassword = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ks:PrlDispCfg_SetBackupUserPassword" , &hDispConfig, &sUserPassword ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlDispCfg_SetBackupUserPassword( hDispConfig, sUserPassword );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlDispCfg_IsBackupUserPasswordEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hDispConfig = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlDispCfg_IsBackupUserPasswordEnabled" , &hDispConfig ) )
			break;

		PRL_BOOL	rbUserPasswordEnabled = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlDispCfg_IsBackupUserPasswordEnabled( hDispConfig, &rbUserPasswordEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbUserPasswordEnabled )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlDispCfg_SetBackupUserPasswordEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hDispConfig = (PRL_HANDLE )0;
		PRL_BOOL	bUserPasswordEnabled = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlDispCfg_SetBackupUserPasswordEnabled" , &hDispConfig, &bUserPasswordEnabled ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlDispCfg_SetBackupUserPasswordEnabled( hDispConfig, bUserPasswordEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlDispCfg_GetDefaultBackupDirectory(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hDispConfig = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlDispCfg_GetDefaultBackupDirectory" , &hDispConfig ) )
			break;

		PRL_STR	sBackupDirectory = (PRL_STR )0;
		PRL_UINT32	rnBackupDirectoryBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlDispCfg_GetDefaultBackupDirectory( hDispConfig, sBackupDirectory, &rnBackupDirectoryBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sBackupDirectory(rnBackupDirectoryBufLength, '\0');
		sBackupDirectory = (PRL_STR )std_sBackupDirectory.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlDispCfg_GetDefaultBackupDirectory( hDispConfig, sBackupDirectory, &rnBackupDirectoryBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sBackupDirectory )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlDispCfg_SetDefaultBackupDirectory(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hDispConfig = (PRL_HANDLE )0;
		PRL_CONST_STR	sBackupDirectory = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ks:PrlDispCfg_SetDefaultBackupDirectory" , &hDispConfig, &sBackupDirectory ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlDispCfg_SetDefaultBackupDirectory( hDispConfig, sBackupDirectory );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlDispCfg_GetBackupTimeout(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hDispConfig = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlDispCfg_GetBackupTimeout" , &hDispConfig ) )
			break;

		PRL_UINT32	rnBackupTimeout = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlDispCfg_GetBackupTimeout( hDispConfig, &rnBackupTimeout );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnBackupTimeout )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlDispCfg_SetBackupTimeout(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hDispConfig = (PRL_HANDLE )0;
		PRL_UINT32	nTimeout = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlDispCfg_SetBackupTimeout" , &hDispConfig, &nTimeout ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlDispCfg_SetBackupTimeout( hDispConfig, nTimeout );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlDispCfg_ArePluginsEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hDispConfig = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlDispCfg_ArePluginsEnabled" , &hDispConfig ) )
			break;

		PRL_BOOL	rbIsPluginsAllowed = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlDispCfg_ArePluginsEnabled( hDispConfig, &rbIsPluginsAllowed );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbIsPluginsAllowed )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlDispCfg_EnablePlugins(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hDispConfig = (PRL_HANDLE )0;
		PRL_BOOL	bEnablePluginsSupport = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlDispCfg_EnablePlugins" , &hDispConfig, &bEnablePluginsSupport ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlDispCfg_EnablePlugins( hDispConfig, bEnablePluginsSupport );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlDispCfg_GetVmCpuLimitType(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hDispConfig = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlDispCfg_GetVmCpuLimitType" , &hDispConfig ) )
			break;

		PRL_UINT32	rnVmCpuLimitType = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlDispCfg_GetVmCpuLimitType( hDispConfig, &rnVmCpuLimitType );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnVmCpuLimitType )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlDispCfg_SetVmCpuLimitType(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hDispConfig = (PRL_HANDLE )0;
		PRL_UINT32	nVmCpuLimitType = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlDispCfg_SetVmCpuLimitType" , &hDispConfig, &nVmCpuLimitType ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlDispCfg_SetVmCpuLimitType( hDispConfig, nVmCpuLimitType );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlDispCfg_IsVerboseLogEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hDispConfig = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlDispCfg_IsVerboseLogEnabled" , &hDispConfig ) )
			break;

		PRL_BOOL	rbEnabled = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlDispCfg_IsVerboseLogEnabled( hDispConfig, &rbEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbEnabled )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlDispCfg_SetVerboseLogEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hDispConfig = (PRL_HANDLE )0;
		PRL_BOOL	bEnabled = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlDispCfg_SetVerboseLogEnabled" , &hDispConfig, &bEnabled ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlDispCfg_SetVerboseLogEnabled( hDispConfig, bEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlDispCfg_IsAllowMultiplePMC(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hDispConfig = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlDispCfg_IsAllowMultiplePMC" , &hDispConfig ) )
			break;

		PRL_BOOL	rbEnabled = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlDispCfg_IsAllowMultiplePMC( hDispConfig, &rbEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbEnabled )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlDispCfg_SetAllowMultiplePMC(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hDispConfig = (PRL_HANDLE )0;
		PRL_BOOL	bEnabled = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlDispCfg_SetAllowMultiplePMC" , &hDispConfig, &bEnabled ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlDispCfg_SetAllowMultiplePMC( hDispConfig, bEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlDispCfg_IsLogRotationEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hDispConfig = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlDispCfg_IsLogRotationEnabled" , &hDispConfig ) )
			break;

		PRL_BOOL	rbEnabled = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlDispCfg_IsLogRotationEnabled( hDispConfig, &rbEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbEnabled )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlDispCfg_SetLogRotationEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hDispConfig = (PRL_HANDLE )0;
		PRL_BOOL	bEnabled = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlDispCfg_SetLogRotationEnabled" , &hDispConfig, &bEnabled ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlDispCfg_SetLogRotationEnabled( hDispConfig, bEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlDispCfg_GetCpuFeaturesMaskEx(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hDispConfig = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlDispCfg_GetCpuFeaturesMaskEx" , &hDispConfig ) )
			break;

		PRL_HANDLE	rhCpuFeatures = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlDispCfg_GetCpuFeaturesMaskEx( hDispConfig, &rhCpuFeatures );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhCpuFeatures )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlDispCfg_SetCpuFeaturesMaskEx(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hDispConfig = (PRL_HANDLE )0;
		PRL_HANDLE	hCpuFeatures = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "kk:PrlDispCfg_SetCpuFeaturesMaskEx" , &hDispConfig, &hCpuFeatures ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlDispCfg_SetCpuFeaturesMaskEx( hDispConfig, hCpuFeatures );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlCpuFeatures_Create(PyObject* /*self*/, PyObject* )
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	rhCpuFeatures = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlCpuFeatures_Create( &rhCpuFeatures );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhCpuFeatures )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlCpuFeatures_GetValue(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hCpuFeatures = (PRL_HANDLE )0;
		PRL_INT32	nId = (PRL_INT32 )0;

		if ( ! PyArg_ParseTuple( args, "ki:PrlCpuFeatures_GetValue" , &hCpuFeatures, &nId ) )
			break;

		PRL_UINT32	rnValue = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlCpuFeatures_GetValue( hCpuFeatures, (PRL_CPU_FEATURES_EX )nId, &rnValue );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnValue )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlCpuFeatures_SetValue(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hCpuFeatures = (PRL_HANDLE )0;
		PRL_INT32	nId = (PRL_INT32 )0;
		PRL_UINT32	nValue = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kiI:PrlCpuFeatures_SetValue" , &hCpuFeatures, &nId, &nValue ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlCpuFeatures_SetValue( hCpuFeatures, (PRL_CPU_FEATURES_EX )nId, nValue );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVirtNet_Create(PyObject* /*self*/, PyObject* )
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	rhVirtNet = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVirtNet_Create( &rhVirtNet );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhVirtNet )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVirtNet_GetNetworkId(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVirtNet = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVirtNet_GetNetworkId" , &hVirtNet ) )
			break;

		PRL_STR	sNetworkId = (PRL_STR )0;
		PRL_UINT32	rnNetworkIdBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVirtNet_GetNetworkId( hVirtNet, sNetworkId, &rnNetworkIdBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sNetworkId(rnNetworkIdBufLength, '\0');
		sNetworkId = (PRL_STR )std_sNetworkId.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVirtNet_GetNetworkId( hVirtNet, sNetworkId, &rnNetworkIdBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sNetworkId )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVirtNet_SetNetworkId(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVirtNet = (PRL_HANDLE )0;
		PRL_CONST_STR	sNetworkId = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ks:PrlVirtNet_SetNetworkId" , &hVirtNet, &sNetworkId ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVirtNet_SetNetworkId( hVirtNet, sNetworkId );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVirtNet_GetDescription(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVirtNet = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVirtNet_GetDescription" , &hVirtNet ) )
			break;

		PRL_STR	sDescription = (PRL_STR )0;
		PRL_UINT32	rnDescriptionBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVirtNet_GetDescription( hVirtNet, sDescription, &rnDescriptionBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sDescription(rnDescriptionBufLength, '\0');
		sDescription = (PRL_STR )std_sDescription.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVirtNet_GetDescription( hVirtNet, sDescription, &rnDescriptionBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sDescription )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVirtNet_SetDescription(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVirtNet = (PRL_HANDLE )0;
		PRL_CONST_STR	sDescription = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ks:PrlVirtNet_SetDescription" , &hVirtNet, &sDescription ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVirtNet_SetDescription( hVirtNet, sDescription );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVirtNet_GetNetworkType(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVirtNet = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVirtNet_GetNetworkType" , &hVirtNet ) )
			break;

		PRL_NET_VIRTUAL_NETWORK_TYPE	rnNetworkType = (PRL_NET_VIRTUAL_NETWORK_TYPE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVirtNet_GetNetworkType( hVirtNet, &rnNetworkType );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "i", rnNetworkType )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVirtNet_SetNetworkType(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVirtNet = (PRL_HANDLE )0;
		PRL_INT32	nNetworkType = (PRL_INT32 )0;

		if ( ! PyArg_ParseTuple( args, "ki:PrlVirtNet_SetNetworkType" , &hVirtNet, &nNetworkType ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVirtNet_SetNetworkType( hVirtNet, (PRL_NET_VIRTUAL_NETWORK_TYPE )nNetworkType );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVirtNet_GetBoundCardMac(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVirtNet = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVirtNet_GetBoundCardMac" , &hVirtNet ) )
			break;

		PRL_STR	sBoundCardMac = (PRL_STR )0;
		PRL_UINT32	rnBoundCardMacBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVirtNet_GetBoundCardMac( hVirtNet, sBoundCardMac, &rnBoundCardMacBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sBoundCardMac(rnBoundCardMacBufLength, '\0');
		sBoundCardMac = (PRL_STR )std_sBoundCardMac.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVirtNet_GetBoundCardMac( hVirtNet, sBoundCardMac, &rnBoundCardMacBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sBoundCardMac )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVirtNet_SetBoundCardMac(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVirtNet = (PRL_HANDLE )0;
		PRL_CONST_STR	sBoundCardMac = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ks:PrlVirtNet_SetBoundCardMac" , &hVirtNet, &sBoundCardMac ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVirtNet_SetBoundCardMac( hVirtNet, sBoundCardMac );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVirtNet_GetAdapterName(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVirtNet = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVirtNet_GetAdapterName" , &hVirtNet ) )
			break;

		PRL_STR	sAdapterName = (PRL_STR )0;
		PRL_UINT32	rnAdapterNameBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVirtNet_GetAdapterName( hVirtNet, sAdapterName, &rnAdapterNameBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sAdapterName(rnAdapterNameBufLength, '\0');
		sAdapterName = (PRL_STR )std_sAdapterName.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVirtNet_GetAdapterName( hVirtNet, sAdapterName, &rnAdapterNameBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sAdapterName )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVirtNet_SetAdapterName(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVirtNet = (PRL_HANDLE )0;
		PRL_CONST_STR	sAdapterName = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ks:PrlVirtNet_SetAdapterName" , &hVirtNet, &sAdapterName ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVirtNet_SetAdapterName( hVirtNet, sAdapterName );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVirtNet_GetAdapterIndex(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVirtNet = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVirtNet_GetAdapterIndex" , &hVirtNet ) )
			break;

		PRL_UINT32	rnAdapterIndex = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVirtNet_GetAdapterIndex( hVirtNet, &rnAdapterIndex );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnAdapterIndex )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVirtNet_SetAdapterIndex(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVirtNet = (PRL_HANDLE )0;
		PRL_UINT32	nAdapterIndex = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVirtNet_SetAdapterIndex" , &hVirtNet, &nAdapterIndex ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVirtNet_SetAdapterIndex( hVirtNet, nAdapterIndex );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVirtNet_GetHostIPAddress(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVirtNet = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVirtNet_GetHostIPAddress" , &hVirtNet ) )
			break;

		PRL_STR	sHostIPAddress = (PRL_STR )0;
		PRL_UINT32	rnHostIPAddressBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVirtNet_GetHostIPAddress( hVirtNet, sHostIPAddress, &rnHostIPAddressBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sHostIPAddress(rnHostIPAddressBufLength, '\0');
		sHostIPAddress = (PRL_STR )std_sHostIPAddress.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVirtNet_GetHostIPAddress( hVirtNet, sHostIPAddress, &rnHostIPAddressBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sHostIPAddress )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVirtNet_SetHostIPAddress(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVirtNet = (PRL_HANDLE )0;
		PRL_CONST_STR	sHostIPAddress = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ks:PrlVirtNet_SetHostIPAddress" , &hVirtNet, &sHostIPAddress ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVirtNet_SetHostIPAddress( hVirtNet, sHostIPAddress );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVirtNet_GetHostIP6Address(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVirtNet = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVirtNet_GetHostIP6Address" , &hVirtNet ) )
			break;

		PRL_STR	sHostIPAddress = (PRL_STR )0;
		PRL_UINT32	rnHostIPAddressBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVirtNet_GetHostIP6Address( hVirtNet, sHostIPAddress, &rnHostIPAddressBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sHostIPAddress(rnHostIPAddressBufLength, '\0');
		sHostIPAddress = (PRL_STR )std_sHostIPAddress.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVirtNet_GetHostIP6Address( hVirtNet, sHostIPAddress, &rnHostIPAddressBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sHostIPAddress )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVirtNet_SetHostIP6Address(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVirtNet = (PRL_HANDLE )0;
		PRL_CONST_STR	sHostIPAddress = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ks:PrlVirtNet_SetHostIP6Address" , &hVirtNet, &sHostIPAddress ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVirtNet_SetHostIP6Address( hVirtNet, sHostIPAddress );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVirtNet_GetDhcpIPAddress(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVirtNet = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVirtNet_GetDhcpIPAddress" , &hVirtNet ) )
			break;

		PRL_STR	sDhcpIPAddress = (PRL_STR )0;
		PRL_UINT32	rnDhcpIPAddressBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVirtNet_GetDhcpIPAddress( hVirtNet, sDhcpIPAddress, &rnDhcpIPAddressBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sDhcpIPAddress(rnDhcpIPAddressBufLength, '\0');
		sDhcpIPAddress = (PRL_STR )std_sDhcpIPAddress.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVirtNet_GetDhcpIPAddress( hVirtNet, sDhcpIPAddress, &rnDhcpIPAddressBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sDhcpIPAddress )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVirtNet_SetDhcpIPAddress(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVirtNet = (PRL_HANDLE )0;
		PRL_CONST_STR	sDhcpIPAddress = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ks:PrlVirtNet_SetDhcpIPAddress" , &hVirtNet, &sDhcpIPAddress ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVirtNet_SetDhcpIPAddress( hVirtNet, sDhcpIPAddress );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVirtNet_GetDhcpIP6Address(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVirtNet = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVirtNet_GetDhcpIP6Address" , &hVirtNet ) )
			break;

		PRL_STR	sDhcpIPAddress = (PRL_STR )0;
		PRL_UINT32	rnDhcpIPAddressBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVirtNet_GetDhcpIP6Address( hVirtNet, sDhcpIPAddress, &rnDhcpIPAddressBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sDhcpIPAddress(rnDhcpIPAddressBufLength, '\0');
		sDhcpIPAddress = (PRL_STR )std_sDhcpIPAddress.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVirtNet_GetDhcpIP6Address( hVirtNet, sDhcpIPAddress, &rnDhcpIPAddressBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sDhcpIPAddress )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVirtNet_SetDhcpIP6Address(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVirtNet = (PRL_HANDLE )0;
		PRL_CONST_STR	sDhcpIPAddress = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ks:PrlVirtNet_SetDhcpIP6Address" , &hVirtNet, &sDhcpIPAddress ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVirtNet_SetDhcpIP6Address( hVirtNet, sDhcpIPAddress );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVirtNet_GetIPNetMask(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVirtNet = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVirtNet_GetIPNetMask" , &hVirtNet ) )
			break;

		PRL_STR	sIPNetMask = (PRL_STR )0;
		PRL_UINT32	rnIPNetMaskBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVirtNet_GetIPNetMask( hVirtNet, sIPNetMask, &rnIPNetMaskBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sIPNetMask(rnIPNetMaskBufLength, '\0');
		sIPNetMask = (PRL_STR )std_sIPNetMask.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVirtNet_GetIPNetMask( hVirtNet, sIPNetMask, &rnIPNetMaskBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sIPNetMask )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVirtNet_SetIPNetMask(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVirtNet = (PRL_HANDLE )0;
		PRL_CONST_STR	sIPNetMask = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ks:PrlVirtNet_SetIPNetMask" , &hVirtNet, &sIPNetMask ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVirtNet_SetIPNetMask( hVirtNet, sIPNetMask );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVirtNet_GetIP6NetMask(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVirtNet = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVirtNet_GetIP6NetMask" , &hVirtNet ) )
			break;

		PRL_STR	sIPNetMask = (PRL_STR )0;
		PRL_UINT32	rnIPNetMaskBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVirtNet_GetIP6NetMask( hVirtNet, sIPNetMask, &rnIPNetMaskBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sIPNetMask(rnIPNetMaskBufLength, '\0');
		sIPNetMask = (PRL_STR )std_sIPNetMask.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVirtNet_GetIP6NetMask( hVirtNet, sIPNetMask, &rnIPNetMaskBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sIPNetMask )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVirtNet_SetIP6NetMask(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVirtNet = (PRL_HANDLE )0;
		PRL_CONST_STR	sIPNetMask = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ks:PrlVirtNet_SetIP6NetMask" , &hVirtNet, &sIPNetMask ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVirtNet_SetIP6NetMask( hVirtNet, sIPNetMask );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVirtNet_GetVlanTag(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVirtNet = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVirtNet_GetVlanTag" , &hVirtNet ) )
			break;

		PRL_UINT16	rnVlanTag = (PRL_UINT16 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVirtNet_GetVlanTag( hVirtNet, &rnVlanTag );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "H", rnVlanTag )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVirtNet_SetVlanTag(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVirtNet = (PRL_HANDLE )0;
		PRL_UINT16	nVlanTag = (PRL_UINT16 )0;

		if ( ! PyArg_ParseTuple( args, "kH:PrlVirtNet_SetVlanTag" , &hVirtNet, &nVlanTag ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVirtNet_SetVlanTag( hVirtNet, nVlanTag );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVirtNet_GetIPScopeStart(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVirtNet = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVirtNet_GetIPScopeStart" , &hVirtNet ) )
			break;

		PRL_STR	sIPScopeStart = (PRL_STR )0;
		PRL_UINT32	rnIPScopeStartBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVirtNet_GetIPScopeStart( hVirtNet, sIPScopeStart, &rnIPScopeStartBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sIPScopeStart(rnIPScopeStartBufLength, '\0');
		sIPScopeStart = (PRL_STR )std_sIPScopeStart.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVirtNet_GetIPScopeStart( hVirtNet, sIPScopeStart, &rnIPScopeStartBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sIPScopeStart )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVirtNet_SetIPScopeStart(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVirtNet = (PRL_HANDLE )0;
		PRL_CONST_STR	sIPScopeStart = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ks:PrlVirtNet_SetIPScopeStart" , &hVirtNet, &sIPScopeStart ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVirtNet_SetIPScopeStart( hVirtNet, sIPScopeStart );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVirtNet_GetIPScopeEnd(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVirtNet = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVirtNet_GetIPScopeEnd" , &hVirtNet ) )
			break;

		PRL_STR	sIPScopeEnd = (PRL_STR )0;
		PRL_UINT32	rnIPScopeEndBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVirtNet_GetIPScopeEnd( hVirtNet, sIPScopeEnd, &rnIPScopeEndBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sIPScopeEnd(rnIPScopeEndBufLength, '\0');
		sIPScopeEnd = (PRL_STR )std_sIPScopeEnd.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVirtNet_GetIPScopeEnd( hVirtNet, sIPScopeEnd, &rnIPScopeEndBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sIPScopeEnd )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVirtNet_SetIPScopeEnd(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVirtNet = (PRL_HANDLE )0;
		PRL_CONST_STR	sIPScopeEnd = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ks:PrlVirtNet_SetIPScopeEnd" , &hVirtNet, &sIPScopeEnd ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVirtNet_SetIPScopeEnd( hVirtNet, sIPScopeEnd );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVirtNet_GetIP6ScopeStart(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVirtNet = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVirtNet_GetIP6ScopeStart" , &hVirtNet ) )
			break;

		PRL_STR	sIPScopeStart = (PRL_STR )0;
		PRL_UINT32	rnIPScopeStartBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVirtNet_GetIP6ScopeStart( hVirtNet, sIPScopeStart, &rnIPScopeStartBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sIPScopeStart(rnIPScopeStartBufLength, '\0');
		sIPScopeStart = (PRL_STR )std_sIPScopeStart.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVirtNet_GetIP6ScopeStart( hVirtNet, sIPScopeStart, &rnIPScopeStartBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sIPScopeStart )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVirtNet_SetIP6ScopeStart(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVirtNet = (PRL_HANDLE )0;
		PRL_CONST_STR	sIPScopeStart = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ks:PrlVirtNet_SetIP6ScopeStart" , &hVirtNet, &sIPScopeStart ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVirtNet_SetIP6ScopeStart( hVirtNet, sIPScopeStart );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVirtNet_GetIP6ScopeEnd(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVirtNet = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVirtNet_GetIP6ScopeEnd" , &hVirtNet ) )
			break;

		PRL_STR	sIPScopeEnd = (PRL_STR )0;
		PRL_UINT32	rnIPScopeEndBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVirtNet_GetIP6ScopeEnd( hVirtNet, sIPScopeEnd, &rnIPScopeEndBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sIPScopeEnd(rnIPScopeEndBufLength, '\0');
		sIPScopeEnd = (PRL_STR )std_sIPScopeEnd.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVirtNet_GetIP6ScopeEnd( hVirtNet, sIPScopeEnd, &rnIPScopeEndBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sIPScopeEnd )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVirtNet_SetIP6ScopeEnd(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVirtNet = (PRL_HANDLE )0;
		PRL_CONST_STR	sIPScopeEnd = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ks:PrlVirtNet_SetIP6ScopeEnd" , &hVirtNet, &sIPScopeEnd ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVirtNet_SetIP6ScopeEnd( hVirtNet, sIPScopeEnd );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVirtNet_IsEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVirtNet = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVirtNet_IsEnabled" , &hVirtNet ) )
			break;

		PRL_BOOL	rbEnabled = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVirtNet_IsEnabled( hVirtNet, &rbEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbEnabled )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVirtNet_SetEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVirtNet = (PRL_HANDLE )0;
		PRL_BOOL	bEnabled = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVirtNet_SetEnabled" , &hVirtNet, &bEnabled ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVirtNet_SetEnabled( hVirtNet, bEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVirtNet_IsAdapterEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVirtNet = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVirtNet_IsAdapterEnabled" , &hVirtNet ) )
			break;

		PRL_BOOL	rbEnabled = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVirtNet_IsAdapterEnabled( hVirtNet, &rbEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbEnabled )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVirtNet_SetAdapterEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVirtNet = (PRL_HANDLE )0;
		PRL_BOOL	bEnabled = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVirtNet_SetAdapterEnabled" , &hVirtNet, &bEnabled ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVirtNet_SetAdapterEnabled( hVirtNet, bEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVirtNet_IsDHCPServerEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVirtNet = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVirtNet_IsDHCPServerEnabled" , &hVirtNet ) )
			break;

		PRL_BOOL	rbEnabled = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVirtNet_IsDHCPServerEnabled( hVirtNet, &rbEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbEnabled )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVirtNet_SetDHCPServerEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVirtNet = (PRL_HANDLE )0;
		PRL_BOOL	bEnabled = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVirtNet_SetDHCPServerEnabled" , &hVirtNet, &bEnabled ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVirtNet_SetDHCPServerEnabled( hVirtNet, bEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVirtNet_IsDHCP6ServerEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVirtNet = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVirtNet_IsDHCP6ServerEnabled" , &hVirtNet ) )
			break;

		PRL_BOOL	rbEnabled = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVirtNet_IsDHCP6ServerEnabled( hVirtNet, &rbEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbEnabled )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVirtNet_SetDHCP6ServerEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVirtNet = (PRL_HANDLE )0;
		PRL_BOOL	bEnabled = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVirtNet_SetDHCP6ServerEnabled" , &hVirtNet, &bEnabled ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVirtNet_SetDHCP6ServerEnabled( hVirtNet, bEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVirtNet_IsNATServerEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVirtNet = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVirtNet_IsNATServerEnabled" , &hVirtNet ) )
			break;

		PRL_BOOL	rbEnabled = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVirtNet_IsNATServerEnabled( hVirtNet, &rbEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbEnabled )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVirtNet_SetNATServerEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVirtNet = (PRL_HANDLE )0;
		PRL_BOOL	bEnabled = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVirtNet_SetNATServerEnabled" , &hVirtNet, &bEnabled ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVirtNet_SetNATServerEnabled( hVirtNet, bEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVirtNet_GetPortForwardList(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVirtNet = (PRL_HANDLE )0;
		PRL_INT32	nPortFwdType = (PRL_INT32 )0;

		if ( ! PyArg_ParseTuple( args, "ki:PrlVirtNet_GetPortForwardList" , &hVirtNet, &nPortFwdType ) )
			break;

		PRL_HANDLE	rhPortFwdList = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVirtNet_GetPortForwardList( hVirtNet, (PRL_PORT_FORWARDING_TYPE )nPortFwdType, &rhPortFwdList );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhPortFwdList )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVirtNet_SetPortForwardList(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVirtNet = (PRL_HANDLE )0;
		PRL_INT32	nPortFwdType = (PRL_INT32 )0;
		PRL_HANDLE	hPortFwdList = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "kik:PrlVirtNet_SetPortForwardList" , &hVirtNet, &nPortFwdType, &hPortFwdList ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVirtNet_SetPortForwardList( hVirtNet, (PRL_PORT_FORWARDING_TYPE )nPortFwdType, hPortFwdList );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVirtNet_GetBoundAdapterInfo(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVirtNet = (PRL_HANDLE )0;
		PRL_HANDLE	hSrvConfig = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "kk:PrlVirtNet_GetBoundAdapterInfo" , &hVirtNet, &hSrvConfig ) )
			break;

		PRL_HANDLE	rhNetAdapter = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVirtNet_GetBoundAdapterInfo( hVirtNet, hSrvConfig, &rhNetAdapter );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhNetAdapter )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlPortFwd_Create(PyObject* /*self*/, PyObject* )
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	rhPortFwd = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlPortFwd_Create( &rhPortFwd );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhPortFwd )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlPortFwd_GetRuleName(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hPortFwd = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlPortFwd_GetRuleName" , &hPortFwd ) )
			break;

		PRL_STR	sRuleName = (PRL_STR )0;
		PRL_UINT32	rnRuleNameBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlPortFwd_GetRuleName( hPortFwd, sRuleName, &rnRuleNameBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sRuleName(rnRuleNameBufLength, '\0');
		sRuleName = (PRL_STR )std_sRuleName.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlPortFwd_GetRuleName( hPortFwd, sRuleName, &rnRuleNameBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sRuleName )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlPortFwd_SetRuleName(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hPortFwd = (PRL_HANDLE )0;
		PRL_CONST_STR	sRuleName = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ks:PrlPortFwd_SetRuleName" , &hPortFwd, &sRuleName ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlPortFwd_SetRuleName( hPortFwd, sRuleName );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlPortFwd_GetIncomingPort(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hPortFwd = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlPortFwd_GetIncomingPort" , &hPortFwd ) )
			break;

		PRL_UINT16	rnIncomingPort = (PRL_UINT16 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlPortFwd_GetIncomingPort( hPortFwd, &rnIncomingPort );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "H", rnIncomingPort )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlPortFwd_SetIncomingPort(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hPortFwd = (PRL_HANDLE )0;
		PRL_UINT16	nIncomingPort = (PRL_UINT16 )0;

		if ( ! PyArg_ParseTuple( args, "kH:PrlPortFwd_SetIncomingPort" , &hPortFwd, &nIncomingPort ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlPortFwd_SetIncomingPort( hPortFwd, nIncomingPort );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlPortFwd_GetRedirectIPAddress(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hPortFwd = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlPortFwd_GetRedirectIPAddress" , &hPortFwd ) )
			break;

		PRL_STR	sRedirectIPAddress = (PRL_STR )0;
		PRL_UINT32	rnRedirectIPAddressBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlPortFwd_GetRedirectIPAddress( hPortFwd, sRedirectIPAddress, &rnRedirectIPAddressBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sRedirectIPAddress(rnRedirectIPAddressBufLength, '\0');
		sRedirectIPAddress = (PRL_STR )std_sRedirectIPAddress.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlPortFwd_GetRedirectIPAddress( hPortFwd, sRedirectIPAddress, &rnRedirectIPAddressBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sRedirectIPAddress )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlPortFwd_SetRedirectIPAddress(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hPortFwd = (PRL_HANDLE )0;
		PRL_CONST_STR	sRedirectIPAddress = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ks:PrlPortFwd_SetRedirectIPAddress" , &hPortFwd, &sRedirectIPAddress ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlPortFwd_SetRedirectIPAddress( hPortFwd, sRedirectIPAddress );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlPortFwd_GetRedirectPort(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hPortFwd = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlPortFwd_GetRedirectPort" , &hPortFwd ) )
			break;

		PRL_UINT16	rnRedirectPort = (PRL_UINT16 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlPortFwd_GetRedirectPort( hPortFwd, &rnRedirectPort );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "H", rnRedirectPort )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlPortFwd_SetRedirectPort(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hPortFwd = (PRL_HANDLE )0;
		PRL_UINT16	nRedirectPort = (PRL_UINT16 )0;

		if ( ! PyArg_ParseTuple( args, "kH:PrlPortFwd_SetRedirectPort" , &hPortFwd, &nRedirectPort ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlPortFwd_SetRedirectPort( hPortFwd, nRedirectPort );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlPortFwd_GetRedirectVm(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hPortFwd = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlPortFwd_GetRedirectVm" , &hPortFwd ) )
			break;

		PRL_STR	sRedirectVm = (PRL_STR )0;
		PRL_UINT32	rnRedirectVmBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlPortFwd_GetRedirectVm( hPortFwd, sRedirectVm, &rnRedirectVmBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sRedirectVm(rnRedirectVmBufLength, '\0');
		sRedirectVm = (PRL_STR )std_sRedirectVm.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlPortFwd_GetRedirectVm( hPortFwd, sRedirectVm, &rnRedirectVmBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sRedirectVm )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlPortFwd_SetRedirectVm(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hPortFwd = (PRL_HANDLE )0;
		PRL_CONST_STR	sRedirectVm = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ks:PrlPortFwd_SetRedirectVm" , &hPortFwd, &sRedirectVm ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlPortFwd_SetRedirectVm( hPortFwd, sRedirectVm );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVm_Start(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVm_Start" , &hVm ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlVm_Start( hVm );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVm_StartEx(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;
		PRL_UINT32	nStartMode = (PRL_UINT32 )0;
		PRL_UINT32	nReserved = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kII:PrlVm_StartEx" , &hVm, &nStartMode, &nReserved ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlVm_StartEx( hVm, nStartMode, nReserved );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVm_Restart(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVm_Restart" , &hVm ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlVm_Restart( hVm );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVm_Stop(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;
		PRL_BOOL	bGraceful = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVm_Stop" , &hVm, &bGraceful ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlVm_Stop( hVm, bGraceful );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVm_StopEx(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;
		PRL_UINT32	nStopMode = (PRL_UINT32 )0;
		PRL_UINT32	nFlags = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kII:PrlVm_StopEx" , &hVm, &nStopMode, &nFlags ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlVm_StopEx( hVm, nStopMode, nFlags );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVm_Pause(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;
		PRL_BOOL	bAcpi = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVm_Pause" , &hVm, &bAcpi ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlVm_Pause( hVm, bAcpi );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVm_Reset(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVm_Reset" , &hVm ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlVm_Reset( hVm );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVm_Suspend(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVm_Suspend" , &hVm ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlVm_Suspend( hVm );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVm_ChangeSid(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;
		PRL_UINT32	nFlags = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVm_ChangeSid" , &hVm, &nFlags ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlVm_ChangeSid( hVm, nFlags );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVm_ResetUptime(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;
		PRL_UINT32	nFlags = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVm_ResetUptime" , &hVm, &nFlags ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlVm_ResetUptime( hVm, nFlags );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVm_GetSuspendedScreen(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVm_GetSuspendedScreen" , &hVm ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlVm_GetSuspendedScreen( hVm );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVm_Resume(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVm_Resume" , &hVm ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlVm_Resume( hVm );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVm_DropSuspendedState(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVm_DropSuspendedState" , &hVm ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlVm_DropSuspendedState( hVm );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVm_CreateSnapshot(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;
		PRL_CONST_STR	sName = (PRL_CONST_STR )0;
		PRL_CONST_STR	sDescription = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "kss:PrlVm_CreateSnapshot" , &hVm, &sName, &sDescription ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlVm_CreateSnapshot( hVm, sName, sDescription );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVm_SwitchToSnapshot(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;
		PRL_CONST_STR	sSnapshotUuid = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ks:PrlVm_SwitchToSnapshot" , &hVm, &sSnapshotUuid ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlVm_SwitchToSnapshot( hVm, sSnapshotUuid );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVm_SwitchToSnapshotEx(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;
		PRL_CONST_STR	sSnapshotUuid = (PRL_CONST_STR )0;
		PRL_UINT32	nFlags = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "ksI:PrlVm_SwitchToSnapshotEx" , &hVm, &sSnapshotUuid, &nFlags ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlVm_SwitchToSnapshotEx( hVm, sSnapshotUuid, nFlags );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVm_DeleteSnapshot(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;
		PRL_CONST_STR	sSnapshotUuid = (PRL_CONST_STR )0;
		PRL_BOOL	bChild = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "ksI:PrlVm_DeleteSnapshot" , &hVm, &sSnapshotUuid, &bChild ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlVm_DeleteSnapshot( hVm, sSnapshotUuid, bChild );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVm_GetSnapshotsTree(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVm_GetSnapshotsTree" , &hVm ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlVm_GetSnapshotsTree( hVm );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVm_GetSnapshotsTreeEx(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;
		PRL_UINT32	nFlags = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVm_GetSnapshotsTreeEx" , &hVm, &nFlags ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlVm_GetSnapshotsTreeEx( hVm, nFlags );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVm_Lock(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;
		PRL_UINT32	nReserved = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVm_Lock" , &hVm, &nReserved ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlVm_Lock( hVm, nReserved );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVm_Unlock(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;
		PRL_UINT32	nReserved = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVm_Unlock" , &hVm, &nReserved ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlVm_Unlock( hVm, nReserved );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVm_UpdateSnapshotData(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;
		PRL_CONST_STR	sSnapshotUuid = (PRL_CONST_STR )0;
		PRL_CONST_STR	sNewName = (PRL_CONST_STR )0;
		PRL_CONST_STR	sNewDescription = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ksss:PrlVm_UpdateSnapshotData" , &hVm, &sSnapshotUuid, &sNewName, &sNewDescription ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlVm_UpdateSnapshotData( hVm, sSnapshotUuid, sNewName, sNewDescription );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVm_Clone(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;
		PRL_CONST_STR	new_vm_name = (PRL_CONST_STR )0;
		PRL_CONST_STR	new_vm_root_path = (PRL_CONST_STR )0;
		PRL_BOOL	bCreateTemplate = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kssI:PrlVm_Clone" , &hVm, &new_vm_name, &new_vm_root_path, &bCreateTemplate ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlVm_Clone( hVm, new_vm_name, new_vm_root_path, bCreateTemplate );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVm_CloneEx(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;
		PRL_CONST_STR	new_vm_name = (PRL_CONST_STR )0;
		PRL_CONST_STR	new_vm_root_path = (PRL_CONST_STR )0;
		PRL_UINT32	nFlags = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kssI:PrlVm_CloneEx" , &hVm, &new_vm_name, &new_vm_root_path, &nFlags ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlVm_CloneEx( hVm, new_vm_name, new_vm_root_path, nFlags );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVm_CloneWithUuid(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;
		PRL_CONST_STR	new_vm_name = (PRL_CONST_STR )0;
		PRL_CONST_STR	new_vm_uuid = (PRL_CONST_STR )0;
		PRL_CONST_STR	new_vm_root_path = (PRL_CONST_STR )0;
		PRL_UINT32	nFlags = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "ksssI:PrlVm_CloneWithUuid" , &hVm, &new_vm_name, &new_vm_uuid, &new_vm_root_path, &nFlags ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlVm_CloneWithUuid( hVm, new_vm_name, new_vm_uuid, new_vm_root_path, nFlags );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVm_Migrate(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;
		PRL_HANDLE	hTargetServer = (PRL_HANDLE )0;
		PRL_CONST_STR	target_home_path = (PRL_CONST_STR )0;
		PRL_UINT32	migration_flags = (PRL_UINT32 )0;
		PRL_UINT32	reserved_flags = (PRL_UINT32 )0;
		PRL_BOOL	force_operation = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kksIII:PrlVm_Migrate" , &hVm, &hTargetServer, &target_home_path, &migration_flags, &reserved_flags, &force_operation ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlVm_Migrate( hVm, hTargetServer, target_home_path, migration_flags, reserved_flags, force_operation );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVm_MigrateEx(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;
		PRL_CONST_STR	target_host = (PRL_CONST_STR )0;
		PRL_UINT32	target_port = (PRL_UINT32 )0;
		PRL_CONST_STR	target_session_id = (PRL_CONST_STR )0;
		PRL_CONST_STR	target_home_path = (PRL_CONST_STR )0;
		PRL_UINT32	migration_flags = (PRL_UINT32 )0;
		PRL_UINT32	reserved_flags = (PRL_UINT32 )0;
		PRL_BOOL	force_operation = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "ksIssIII:PrlVm_MigrateEx" , &hVm, &target_host, &target_port, &target_session_id, &target_home_path, &migration_flags, &reserved_flags, &force_operation ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlVm_MigrateEx( hVm, target_host, target_port, target_session_id, target_home_path, migration_flags, reserved_flags, force_operation );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVm_MigrateWithRename(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;
		PRL_HANDLE	hTargetServer = (PRL_HANDLE )0;
		PRL_CONST_STR	target_name = (PRL_CONST_STR )0;
		PRL_CONST_STR	target_home_path = (PRL_CONST_STR )0;
		PRL_UINT32	migration_flags = (PRL_UINT32 )0;
		PRL_UINT32	reserved_flags = (PRL_UINT32 )0;
		PRL_BOOL	force_operation = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kkssIII:PrlVm_MigrateWithRename" , &hVm, &hTargetServer, &target_name, &target_home_path, &migration_flags, &reserved_flags, &force_operation ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlVm_MigrateWithRename( hVm, hTargetServer, target_name, target_home_path, migration_flags, reserved_flags, force_operation );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVm_MigrateWithRenameEx(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;
		PRL_CONST_STR	target_host = (PRL_CONST_STR )0;
		PRL_UINT32	target_port = (PRL_UINT32 )0;
		PRL_CONST_STR	target_session_id = (PRL_CONST_STR )0;
		PRL_CONST_STR	target_name = (PRL_CONST_STR )0;
		PRL_CONST_STR	target_home_path = (PRL_CONST_STR )0;
		PRL_UINT32	migration_flags = (PRL_UINT32 )0;
		PRL_UINT32	reserved_flags = (PRL_UINT32 )0;
		PRL_BOOL	force_operation = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "ksIsssIII:PrlVm_MigrateWithRenameEx" , &hVm, &target_host, &target_port, &target_session_id, &target_name, &target_home_path, &migration_flags, &reserved_flags, &force_operation ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlVm_MigrateWithRenameEx( hVm, target_host, target_port, target_session_id, target_name, target_home_path, migration_flags, reserved_flags, force_operation );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVm_MigrateCancel(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVm_MigrateCancel" , &hVm ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlVm_MigrateCancel( hVm );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVm_GenerateVmDevFilename(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;
		PRL_CONST_STR	sFilenamePrefix = (PRL_CONST_STR )0;
		PRL_CONST_STR	sFilenameSuffix = (PRL_CONST_STR )0;
		PRL_CONST_STR	sIndexDelimiter = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ksss:PrlVm_GenerateVmDevFilename" , &hVm, &sFilenamePrefix, &sFilenameSuffix, &sIndexDelimiter ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlVm_GenerateVmDevFilename( hVm, sFilenamePrefix, sFilenameSuffix, sIndexDelimiter );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVm_Delete(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;
		PRL_HANDLE	hDevicesList = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "kk:PrlVm_Delete" , &hVm, &hDevicesList ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlVm_Delete( hVm, hDevicesList );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVm_GetProblemReport(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVm_GetProblemReport" , &hVm ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlVm_GetProblemReport( hVm );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVm_GetPackedProblemReport(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;
		PRL_UINT32	nFlags = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVm_GetPackedProblemReport" , &hVm, &nFlags ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlVm_GetPackedProblemReport( hVm, nFlags );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVm_GetState(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVm_GetState" , &hVm ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlVm_GetState( hVm );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVm_RefreshConfig(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVm_RefreshConfig" , &hVm ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlVm_RefreshConfig( hVm );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVm_RefreshConfigEx(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;
		PRL_UINT32	nFlags = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVm_RefreshConfigEx" , &hVm, &nFlags ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlVm_RefreshConfigEx( hVm, nFlags );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVm_LoginInGuest(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;
		PRL_CONST_STR	sUserName = (PRL_CONST_STR )0;
		PRL_CONST_STR	sUserPassword = (PRL_CONST_STR )0;
		PRL_UINT32	nFlags = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kssI:PrlVm_LoginInGuest" , &hVm, &sUserName, &sUserPassword, &nFlags ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlVm_LoginInGuest( hVm, sUserName, sUserPassword, nFlags );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVm_StartVncServer(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;
		PRL_UINT32	nReserved = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVm_StartVncServer" , &hVm, &nReserved ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlVm_StartVncServer( hVm, nReserved );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVm_StopVncServer(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;
		PRL_UINT32	nReserved = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVm_StopVncServer" , &hVm, &nReserved ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlVm_StopVncServer( hVm, nReserved );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmGuest_Logout(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmGuest = (PRL_HANDLE )0;
		PRL_UINT32	nReserved = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmGuest_Logout" , &hVmGuest, &nReserved ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlVmGuest_Logout( hVmGuest, nReserved );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmGuest_RunProgram(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmGuest = (PRL_HANDLE )0;
		PRL_CONST_STR	sAppName = (PRL_CONST_STR )0;
		PRL_HANDLE	hArgsList = (PRL_HANDLE )0;
		PRL_HANDLE	hEnvsList = (PRL_HANDLE )0;
		PRL_UINT32	nFlags = (PRL_UINT32 )0;
		PRL_FILE_DESC	nStdin = (PRL_FILE_DESC )0;
		PRL_FILE_DESC	nStdout = (PRL_FILE_DESC )0;
		PRL_FILE_DESC	nStderr = (PRL_FILE_DESC )0;

		if ( ! PyArg_ParseTuple( args, "kskkIIII:PrlVmGuest_RunProgram" , &hVmGuest, &sAppName, &hArgsList, &hEnvsList, &nFlags, &nStdin, &nStdout, &nStderr ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlVmGuest_RunProgram( hVmGuest, sAppName, hArgsList, hEnvsList, nFlags, nStdin, nStdout, nStderr );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmGuest_GetNetworkSettings(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmGuest = (PRL_HANDLE )0;
		PRL_UINT32	nReserved = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmGuest_GetNetworkSettings" , &hVmGuest, &nReserved ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlVmGuest_GetNetworkSettings( hVmGuest, nReserved );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVm_SetUserPasswd(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;
		PRL_CONST_STR	sUserName = (PRL_CONST_STR )0;
		PRL_CONST_STR	sUserPasswd = (PRL_CONST_STR )0;
		PRL_UINT32	nFlags = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kssI:PrlVm_SetUserPasswd" , &hVm, &sUserName, &sUserPasswd, &nFlags ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlVm_SetUserPasswd( hVm, sUserName, sUserPasswd, nFlags );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVm_SetConfig(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "kk:PrlVm_SetConfig" , &hVm, &hVmCfg ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVm_SetConfig( hVm, hVmCfg );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVm_GetConfig(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVm_GetConfig" , &hVm ) )
			break;

		PRL_HANDLE	rhVmCfg = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVm_GetConfig( hVm, &rhVmCfg );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhVmCfg )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetDefaultConfig(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_HANDLE	hSrvConfig = (PRL_HANDLE )0;
		PRL_UINT32	guestOsVersion = (PRL_UINT32 )0;
		PRL_BOOL	needCreateDevices = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kkII:PrlVmCfg_SetDefaultConfig" , &hVmCfg, &hSrvConfig, &guestOsVersion, &needCreateDevices ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetDefaultConfig( hVmCfg, hSrvConfig, guestOsVersion, needCreateDevices );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_IsConfigInvalid(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_RESULT	nErrCode = (PRL_RESULT )0;

		if ( ! PyArg_ParseTuple( args, "I:PrlVmCfg_IsConfigInvalid" , &nErrCode ) )
			break;

		PRL_BOOL	rbInvalid = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_IsConfigInvalid( nErrCode, &rbInvalid );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbInvalid )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetConfigValidity(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_GetConfigValidity" , &hVmCfg ) )
			break;

		PRL_RESULT	rnErrCode = (PRL_RESULT )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetConfigValidity( hVmCfg, &rnErrCode );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnErrCode )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_AddDefaultDevice(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_HANDLE	hSrvConfig = (PRL_HANDLE )0;
		PRL_INT32	deviceType = (PRL_INT32 )0;

		if ( ! PyArg_ParseTuple( args, "kki:PrlVmCfg_AddDefaultDevice" , &hVmCfg, &hSrvConfig, &deviceType ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_AddDefaultDevice( hVmCfg, hSrvConfig, (PRL_DEVICE_TYPE )deviceType );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_AddDefaultDeviceEx(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_HANDLE	hSrvConfig = (PRL_HANDLE )0;
		PRL_INT32	deviceType = (PRL_INT32 )0;

		if ( ! PyArg_ParseTuple( args, "kki:PrlVmCfg_AddDefaultDeviceEx" , &hVmCfg, &hSrvConfig, &deviceType ) )
			break;

		PRL_HANDLE	rhVmDevice = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_AddDefaultDeviceEx( hVmCfg, hSrvConfig, (PRL_DEVICE_TYPE )deviceType, &rhVmDevice );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhVmDevice )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_IsDefaultDeviceNeeded(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_UINT32	guestOsVersion = (PRL_UINT32 )0;
		PRL_INT32	deviceType = (PRL_INT32 )0;

		if ( ! PyArg_ParseTuple( args, "Ii:PrlVmCfg_IsDefaultDeviceNeeded" , &guestOsVersion, &deviceType ) )
			break;

		PRL_BOOL	rbNeeded = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_IsDefaultDeviceNeeded( guestOsVersion, (PRL_DEVICE_TYPE )deviceType, &rbNeeded );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbNeeded )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetDefaultMemSize(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_UINT32	guestOsVersion = (PRL_UINT32 )0;
		PRL_UINT32	hostRam = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "II:PrlVmCfg_GetDefaultMemSize" , &guestOsVersion, &hostRam ) )
			break;

		PRL_UINT32	rnMemSize = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetDefaultMemSize( guestOsVersion, hostRam, &rnMemSize );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnMemSize )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetDefaultHddSize(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_UINT32	guestOsVersion = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "I:PrlVmCfg_GetDefaultHddSize" , &guestOsVersion ) )
			break;

		PRL_UINT32	rnHddSize = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetDefaultHddSize( guestOsVersion, &rnHddSize );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnHddSize )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetDefaultVideoRamSize(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_UINT32	guestOsVersion = (PRL_UINT32 )0;
		PRL_HANDLE	hSrvConfig = (PRL_HANDLE )0;
		PRL_BOOL	bIs3DSupportEnabled = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "IkI:PrlVmCfg_GetDefaultVideoRamSize" , &guestOsVersion, &hSrvConfig, &bIs3DSupportEnabled ) )
			break;

		PRL_UINT32	rnVideoRamSize = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetDefaultVideoRamSize( guestOsVersion, hSrvConfig, bIs3DSupportEnabled, &rnVideoRamSize );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnVideoRamSize )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVm_GetStatistics(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVm_GetStatistics" , &hVm ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlVm_GetStatistics( hVm );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVm_GetStatisticsEx(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;
		PRL_UINT32	nFlags = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVm_GetStatisticsEx" , &hVm, &nFlags ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlVm_GetStatisticsEx( hVm, nFlags );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVm_SubscribeToGuestStatistics(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVm_SubscribeToGuestStatistics" , &hVm ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlVm_SubscribeToGuestStatistics( hVm );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVm_UnsubscribeFromGuestStatistics(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVm_UnsubscribeFromGuestStatistics" , &hVm ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlVm_UnsubscribeFromGuestStatistics( hVm );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVm_Reg(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;
		PRL_CONST_STR	sVmParentPath = (PRL_CONST_STR )0;
		PRL_BOOL	bNonInteractiveMode = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "ksI:PrlVm_Reg" , &hVm, &sVmParentPath, &bNonInteractiveMode ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlVm_Reg( hVm, sVmParentPath, bNonInteractiveMode );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVm_RegEx(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;
		PRL_CONST_STR	sVmParentPath = (PRL_CONST_STR )0;
		PRL_UINT32	nFlags = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "ksI:PrlVm_RegEx" , &hVm, &sVmParentPath, &nFlags ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlVm_RegEx( hVm, sVmParentPath, nFlags );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVm_Unreg(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVm_Unreg" , &hVm ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlVm_Unreg( hVm );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVm_Restore(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVm_Restore" , &hVm ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlVm_Restore( hVm );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVm_BeginEdit(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVm_BeginEdit" , &hVm ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlVm_BeginEdit( hVm );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVm_Commit(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVm_Commit" , &hVm ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlVm_Commit( hVm );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVm_CommitEx(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;
		PRL_UINT32	nFlags = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVm_CommitEx" , &hVm, &nFlags ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlVm_CommitEx( hVm, nFlags );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_CreateVmDev(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_INT32	nDeviceType = (PRL_INT32 )0;

		if ( ! PyArg_ParseTuple( args, "ki:PrlVmCfg_CreateVmDev" , &hVmCfg, &nDeviceType ) )
			break;

		PRL_HANDLE	rhVmDevice = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_CreateVmDev( hVmCfg, (PRL_DEVICE_TYPE )nDeviceType, &rhVmDevice );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhVmDevice )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetAccessRights(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_GetAccessRights" , &hVmCfg ) )
			break;

		PRL_HANDLE	rhVmAcl = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetAccessRights( hVmCfg, &rhVmAcl );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhVmAcl )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetDevsCount(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_GetDevsCount" , &hVmCfg ) )
			break;

		PRL_UINT32	vmdev_handles_count = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetDevsCount( hVmCfg, &vmdev_handles_count );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", vmdev_handles_count )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetAllDevices(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_GetAllDevices" , &hVmCfg ) )
			break;

		PRL_HANDLE	rhDevsList = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetAllDevices( hVmCfg, &rhDevsList );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhDevsList )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetDevsCountByType(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_INT32	vmDeviceType = (PRL_INT32 )0;

		if ( ! PyArg_ParseTuple( args, "ki:PrlVmCfg_GetDevsCountByType" , &hVmCfg, &vmDeviceType ) )
			break;

		PRL_UINT32	rnDevicesCount = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetDevsCountByType( hVmCfg, (PRL_DEVICE_TYPE )vmDeviceType, &rnDevicesCount );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnDevicesCount )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetDevByType(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_INT32	vmDeviceType = (PRL_INT32 )0;
		PRL_UINT32	nIndex = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kiI:PrlVmCfg_GetDevByType" , &hVmCfg, &vmDeviceType, &nIndex ) )
			break;

		PRL_HANDLE	rhDevice = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetDevByType( hVmCfg, (PRL_DEVICE_TYPE )vmDeviceType, nIndex, &rhDevice );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhDevice )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetFloppyDisksCount(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_GetFloppyDisksCount" , &hVmCfg ) )
			break;

		PRL_UINT32	rnFloppyDisksCount = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetFloppyDisksCount( hVmCfg, &rnFloppyDisksCount );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnFloppyDisksCount )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetFloppyDisk(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_UINT32	nIndex = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmCfg_GetFloppyDisk" , &hVmCfg, &nIndex ) )
			break;

		PRL_HANDLE	rhDevice = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetFloppyDisk( hVmCfg, nIndex, &rhDevice );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhDevice )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetHardDisksCount(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_GetHardDisksCount" , &hVmCfg ) )
			break;

		PRL_UINT32	rnHardDisksCount = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetHardDisksCount( hVmCfg, &rnHardDisksCount );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnHardDisksCount )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetHardDisk(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_UINT32	nIndex = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmCfg_GetHardDisk" , &hVmCfg, &nIndex ) )
			break;

		PRL_HANDLE	rhDevice = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetHardDisk( hVmCfg, nIndex, &rhDevice );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhDevice )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetOpticalDisksCount(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_GetOpticalDisksCount" , &hVmCfg ) )
			break;

		PRL_UINT32	rnOpticalDisksCount = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetOpticalDisksCount( hVmCfg, &rnOpticalDisksCount );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnOpticalDisksCount )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetOpticalDisk(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_UINT32	nIndex = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmCfg_GetOpticalDisk" , &hVmCfg, &nIndex ) )
			break;

		PRL_HANDLE	rhDevice = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetOpticalDisk( hVmCfg, nIndex, &rhDevice );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhDevice )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetParallelPortsCount(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_GetParallelPortsCount" , &hVmCfg ) )
			break;

		PRL_UINT32	rnParallelPortsCount = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetParallelPortsCount( hVmCfg, &rnParallelPortsCount );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnParallelPortsCount )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetParallelPort(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_UINT32	nIndex = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmCfg_GetParallelPort" , &hVmCfg, &nIndex ) )
			break;

		PRL_HANDLE	rhDevice = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetParallelPort( hVmCfg, nIndex, &rhDevice );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhDevice )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetSerialPortsCount(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_GetSerialPortsCount" , &hVmCfg ) )
			break;

		PRL_UINT32	rnSerialPortsCount = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetSerialPortsCount( hVmCfg, &rnSerialPortsCount );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnSerialPortsCount )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetSerialPort(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_UINT32	nIndex = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmCfg_GetSerialPort" , &hVmCfg, &nIndex ) )
			break;

		PRL_HANDLE	rhDevice = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetSerialPort( hVmCfg, nIndex, &rhDevice );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhDevice )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetSoundDevsCount(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_GetSoundDevsCount" , &hVmCfg ) )
			break;

		PRL_UINT32	rnSoundDevsCount = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetSoundDevsCount( hVmCfg, &rnSoundDevsCount );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnSoundDevsCount )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetSoundDev(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_UINT32	nIndex = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmCfg_GetSoundDev" , &hVmCfg, &nIndex ) )
			break;

		PRL_HANDLE	rhDevice = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetSoundDev( hVmCfg, nIndex, &rhDevice );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhDevice )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetUsbDevicesCount(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_GetUsbDevicesCount" , &hVmCfg ) )
			break;

		PRL_UINT32	rnUsbDevicesCount = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetUsbDevicesCount( hVmCfg, &rnUsbDevicesCount );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnUsbDevicesCount )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetUsbDevice(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_UINT32	nIndex = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmCfg_GetUsbDevice" , &hVmCfg, &nIndex ) )
			break;

		PRL_HANDLE	rhDevice = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetUsbDevice( hVmCfg, nIndex, &rhDevice );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhDevice )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetNetAdaptersCount(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_GetNetAdaptersCount" , &hVmCfg ) )
			break;

		PRL_UINT32	rnNetAdaptersCount = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetNetAdaptersCount( hVmCfg, &rnNetAdaptersCount );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnNetAdaptersCount )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetNetAdapter(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_UINT32	nIndex = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmCfg_GetNetAdapter" , &hVmCfg, &nIndex ) )
			break;

		PRL_HANDLE	rhDevice = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetNetAdapter( hVmCfg, nIndex, &rhDevice );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhDevice )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetGenericPciDevsCount(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_GetGenericPciDevsCount" , &hVmCfg ) )
			break;

		PRL_UINT32	rnGenericPciDevsCount = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetGenericPciDevsCount( hVmCfg, &rnGenericPciDevsCount );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnGenericPciDevsCount )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetGenericPciDev(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_UINT32	nIndex = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmCfg_GetGenericPciDev" , &hVmCfg, &nIndex ) )
			break;

		PRL_HANDLE	rhDevice = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetGenericPciDev( hVmCfg, nIndex, &rhDevice );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhDevice )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetGenericScsiDevsCount(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_GetGenericScsiDevsCount" , &hVmCfg ) )
			break;

		PRL_UINT32	rnGenericScsiDevsCount = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetGenericScsiDevsCount( hVmCfg, &rnGenericScsiDevsCount );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnGenericScsiDevsCount )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetGenericScsiDev(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_UINT32	nIndex = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmCfg_GetGenericScsiDev" , &hVmCfg, &nIndex ) )
			break;

		PRL_HANDLE	rhDevice = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetGenericScsiDev( hVmCfg, nIndex, &rhDevice );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhDevice )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetDisplayDevsCount(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_GetDisplayDevsCount" , &hVmCfg ) )
			break;

		PRL_UINT32	rnDisplayDevsCount = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetDisplayDevsCount( hVmCfg, &rnDisplayDevsCount );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnDisplayDevsCount )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetDisplayDev(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_UINT32	nIndex = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmCfg_GetDisplayDev" , &hVmCfg, &nIndex ) )
			break;

		PRL_HANDLE	rhDevice = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetDisplayDev( hVmCfg, nIndex, &rhDevice );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhDevice )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_CreateShare(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_CreateShare" , &hVmCfg ) )
			break;

		PRL_HANDLE	rhVmShare = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_CreateShare( hVmCfg, &rhVmShare );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhVmShare )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetSharesCount(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_GetSharesCount" , &hVmCfg ) )
			break;

		PRL_UINT32	rnSharesCount = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetSharesCount( hVmCfg, &rnSharesCount );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnSharesCount )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetShare(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_UINT32	nShareIndex = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmCfg_GetShare" , &hVmCfg, &nShareIndex ) )
			break;

		PRL_HANDLE	rhVmShare = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetShare( hVmCfg, nShareIndex, &rhVmShare );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhVmShare )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_IsSmartGuardEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_IsSmartGuardEnabled" , &hVmCfg ) )
			break;

		PRL_BOOL	rbEnabled = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_IsSmartGuardEnabled( hVmCfg, &rbEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbEnabled )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetSmartGuardEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_BOOL	bEnabled = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmCfg_SetSmartGuardEnabled" , &hVmCfg, &bEnabled ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetSmartGuardEnabled( hVmCfg, bEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_IsSmartGuardNotifyBeforeCreation(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_IsSmartGuardNotifyBeforeCreation" , &hVmCfg ) )
			break;

		PRL_BOOL	rbNotifyBeforeCreation = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_IsSmartGuardNotifyBeforeCreation( hVmCfg, &rbNotifyBeforeCreation );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbNotifyBeforeCreation )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetSmartGuardNotifyBeforeCreation(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_BOOL	bNotifyBeforeCreation = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmCfg_SetSmartGuardNotifyBeforeCreation" , &hVmCfg, &bNotifyBeforeCreation ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetSmartGuardNotifyBeforeCreation( hVmCfg, bNotifyBeforeCreation );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetSmartGuardInterval(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_GetSmartGuardInterval" , &hVmCfg ) )
			break;

		PRL_UINT32	rnInterval = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetSmartGuardInterval( hVmCfg, &rnInterval );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnInterval )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetSmartGuardInterval(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_UINT32	nInterval = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmCfg_SetSmartGuardInterval" , &hVmCfg, &nInterval ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetSmartGuardInterval( hVmCfg, nInterval );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetSmartGuardMaxSnapshotsCount(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_GetSmartGuardMaxSnapshotsCount" , &hVmCfg ) )
			break;

		PRL_UINT32	rnMaxSnapshotsCount = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetSmartGuardMaxSnapshotsCount( hVmCfg, &rnMaxSnapshotsCount );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnMaxSnapshotsCount )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetSmartGuardMaxSnapshotsCount(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_UINT32	nMaxSnapshotsCount = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmCfg_SetSmartGuardMaxSnapshotsCount" , &hVmCfg, &nMaxSnapshotsCount ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetSmartGuardMaxSnapshotsCount( hVmCfg, nMaxSnapshotsCount );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_IsUserDefinedSharedFoldersEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_IsUserDefinedSharedFoldersEnabled" , &hVmCfg ) )
			break;

		PRL_BOOL	rbEnabled = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_IsUserDefinedSharedFoldersEnabled( hVmCfg, &rbEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbEnabled )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetUserDefinedSharedFoldersEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_BOOL	bEnabled = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmCfg_SetUserDefinedSharedFoldersEnabled" , &hVmCfg, &bEnabled ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetUserDefinedSharedFoldersEnabled( hVmCfg, bEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_IsSmartMountEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_IsSmartMountEnabled" , &hVmCfg ) )
			break;

		PRL_BOOL	rbEnabled = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_IsSmartMountEnabled( hVmCfg, &rbEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbEnabled )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetSmartMountEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_BOOL	bEnabled = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmCfg_SetSmartMountEnabled" , &hVmCfg, &bEnabled ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetSmartMountEnabled( hVmCfg, bEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_IsSmartMountRemovableDrivesEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_IsSmartMountRemovableDrivesEnabled" , &hVmCfg ) )
			break;

		PRL_BOOL	rbEnabled = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_IsSmartMountRemovableDrivesEnabled( hVmCfg, &rbEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbEnabled )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetSmartMountRemovableDrivesEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_BOOL	bEnabled = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmCfg_SetSmartMountRemovableDrivesEnabled" , &hVmCfg, &bEnabled ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetSmartMountRemovableDrivesEnabled( hVmCfg, bEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_IsSmartMountDVDsEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_IsSmartMountDVDsEnabled" , &hVmCfg ) )
			break;

		PRL_BOOL	rbEnabled = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_IsSmartMountDVDsEnabled( hVmCfg, &rbEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbEnabled )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetSmartMountDVDsEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_BOOL	bEnabled = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmCfg_SetSmartMountDVDsEnabled" , &hVmCfg, &bEnabled ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetSmartMountDVDsEnabled( hVmCfg, bEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_IsSmartMountNetworkSharesEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_IsSmartMountNetworkSharesEnabled" , &hVmCfg ) )
			break;

		PRL_BOOL	rbEnabled = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_IsSmartMountNetworkSharesEnabled( hVmCfg, &rbEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbEnabled )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetSmartMountNetworkSharesEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_BOOL	bEnabled = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmCfg_SetSmartMountNetworkSharesEnabled" , &hVmCfg, &bEnabled ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetSmartMountNetworkSharesEnabled( hVmCfg, bEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_IsSharedProfileEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_IsSharedProfileEnabled" , &hVmCfg ) )
			break;

		PRL_BOOL	rbEnabled = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_IsSharedProfileEnabled( hVmCfg, &rbEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbEnabled )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetSharedProfileEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_BOOL	bEnabled = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmCfg_SetSharedProfileEnabled" , &hVmCfg, &bEnabled ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetSharedProfileEnabled( hVmCfg, bEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_IsUseDesktop(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_IsUseDesktop" , &hVmCfg ) )
			break;

		PRL_BOOL	rbEnabled = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_IsUseDesktop( hVmCfg, &rbEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbEnabled )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetUseDesktop(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_BOOL	bEnabled = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmCfg_SetUseDesktop" , &hVmCfg, &bEnabled ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetUseDesktop( hVmCfg, bEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_IsUseDocuments(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_IsUseDocuments" , &hVmCfg ) )
			break;

		PRL_BOOL	rbEnabled = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_IsUseDocuments( hVmCfg, &rbEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbEnabled )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetUseDocuments(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_BOOL	bEnabled = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmCfg_SetUseDocuments" , &hVmCfg, &bEnabled ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetUseDocuments( hVmCfg, bEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_IsUsePictures(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_IsUsePictures" , &hVmCfg ) )
			break;

		PRL_BOOL	rbEnabled = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_IsUsePictures( hVmCfg, &rbEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbEnabled )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetUsePictures(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_BOOL	bEnabled = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmCfg_SetUsePictures" , &hVmCfg, &bEnabled ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetUsePictures( hVmCfg, bEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_IsUseMusic(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_IsUseMusic" , &hVmCfg ) )
			break;

		PRL_BOOL	rbEnabled = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_IsUseMusic( hVmCfg, &rbEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbEnabled )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetUseMusic(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_BOOL	bEnabled = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmCfg_SetUseMusic" , &hVmCfg, &bEnabled ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetUseMusic( hVmCfg, bEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_IsUseDownloads(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_IsUseDownloads" , &hVmCfg ) )
			break;

		PRL_BOOL	rbEnabled = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_IsUseDownloads( hVmCfg, &rbEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbEnabled )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetUseDownloads(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_BOOL	bEnabled = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmCfg_SetUseDownloads" , &hVmCfg, &bEnabled ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetUseDownloads( hVmCfg, bEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_IsUseMovies(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_IsUseMovies" , &hVmCfg ) )
			break;

		PRL_BOOL	rbEnabled = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_IsUseMovies( hVmCfg, &rbEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbEnabled )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetUseMovies(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_BOOL	bEnabled = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmCfg_SetUseMovies" , &hVmCfg, &bEnabled ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetUseMovies( hVmCfg, bEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetOptimizeModifiersMode(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_GetOptimizeModifiersMode" , &hVm ) )
			break;

		PRL_OPTIMIZE_MODIFIERS_MODE	rnMode = (PRL_OPTIMIZE_MODIFIERS_MODE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetOptimizeModifiersMode( hVm, &rnMode );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "i", rnMode )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetOptimizeModifiersMode(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;
		PRL_INT32	nMode = (PRL_INT32 )0;

		if ( ! PyArg_ParseTuple( args, "ki:PrlVmCfg_SetOptimizeModifiersMode" , &hVm, &nMode ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetOptimizeModifiersMode( hVm, (PRL_OPTIMIZE_MODIFIERS_MODE )nMode );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_IsShareClipboard(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_IsShareClipboard" , &hVmCfg ) )
			break;

		PRL_BOOL	rbEnabled = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_IsShareClipboard( hVmCfg, &rbEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbEnabled )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetShareClipboard(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_BOOL	bEnabled = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmCfg_SetShareClipboard" , &hVmCfg, &bEnabled ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetShareClipboard( hVmCfg, bEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_IsOfflineManagementEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_IsOfflineManagementEnabled" , &hVmCfg ) )
			break;

		PRL_BOOL	rbEnabled = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_IsOfflineManagementEnabled( hVmCfg, &rbEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbEnabled )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetOfflineManagementEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_BOOL	bEnabled = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmCfg_SetOfflineManagementEnabled" , &hVmCfg, &bEnabled ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetOfflineManagementEnabled( hVmCfg, bEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_IsToolsAutoUpdateEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_IsToolsAutoUpdateEnabled" , &hVmCfg ) )
			break;

		PRL_BOOL	rbEnabled = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_IsToolsAutoUpdateEnabled( hVmCfg, &rbEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbEnabled )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetToolsAutoUpdateEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_BOOL	bEnabled = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmCfg_SetToolsAutoUpdateEnabled" , &hVmCfg, &bEnabled ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetToolsAutoUpdateEnabled( hVmCfg, bEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_IsTimeSynchronizationEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_IsTimeSynchronizationEnabled" , &hVmCfg ) )
			break;

		PRL_BOOL	rbEnabled = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_IsTimeSynchronizationEnabled( hVmCfg, &rbEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbEnabled )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetTimeSynchronizationEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_BOOL	bEnabled = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmCfg_SetTimeSynchronizationEnabled" , &hVmCfg, &bEnabled ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetTimeSynchronizationEnabled( hVmCfg, bEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_IsTimeSyncSmartModeEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_IsTimeSyncSmartModeEnabled" , &hVmCfg ) )
			break;

		PRL_BOOL	rbEnabled = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_IsTimeSyncSmartModeEnabled( hVmCfg, &rbEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbEnabled )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetTimeSyncSmartModeEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_BOOL	bEnabled = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmCfg_SetTimeSyncSmartModeEnabled" , &hVmCfg, &bEnabled ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetTimeSyncSmartModeEnabled( hVmCfg, bEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetTimeSyncInterval(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_GetTimeSyncInterval" , &hVmCfg ) )
			break;

		PRL_UINT32	rnTimeSyncInterval = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetTimeSyncInterval( hVmCfg, &rnTimeSyncInterval );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnTimeSyncInterval )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetTimeSyncInterval(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_UINT32	nTimeSyncInterval = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmCfg_SetTimeSyncInterval" , &hVmCfg, &nTimeSyncInterval ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetTimeSyncInterval( hVmCfg, nTimeSyncInterval );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_IsAllowSelectBootDevice(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_IsAllowSelectBootDevice" , &hVmCfg ) )
			break;

		PRL_BOOL	rbAllowed = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_IsAllowSelectBootDevice( hVmCfg, &rbAllowed );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbAllowed )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetAllowSelectBootDevice(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_BOOL	bAllowed = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmCfg_SetAllowSelectBootDevice" , &hVmCfg, &bAllowed ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetAllowSelectBootDevice( hVmCfg, bAllowed );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVm_GetQuestions(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVm_GetQuestions" , &hVm ) )
			break;

		PRL_HANDLE	rQuestionsList = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVm_GetQuestions( hVm, &rQuestionsList );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rQuestionsList )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_CreateBootDev(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_CreateBootDev" , &hVmCfg ) )
			break;

		PRL_HANDLE	rhVmBootDev = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_CreateBootDev( hVmCfg, &rhVmBootDev );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhVmBootDev )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetBootDevCount(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_GetBootDevCount" , &hVmCfg ) )
			break;

		PRL_UINT32	rnBootDevCount = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetBootDevCount( hVmCfg, &rnBootDevCount );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnBootDevCount )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetBootDev(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_UINT32	nBootDevIndex = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmCfg_GetBootDev" , &hVmCfg, &nBootDevIndex ) )
			break;

		PRL_HANDLE	rhVmBootDev = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetBootDev( hVmCfg, nBootDevIndex, &rhVmBootDev );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhVmBootDev )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetName(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_GetName" , &hVmCfg ) )
			break;

		PRL_STR	sVmName = (PRL_STR )0;
		PRL_UINT32	rnVmNameBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetName( hVmCfg, sVmName, &rnVmNameBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sVmName(rnVmNameBufLength, '\0');
		sVmName = (PRL_STR )std_sVmName.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetName( hVmCfg, sVmName, &rnVmNameBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sVmName )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetName(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_CONST_STR	sNewVmName = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ks:PrlVmCfg_SetName" , &hVmCfg, &sNewVmName ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetName( hVmCfg, sNewVmName );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetHostname(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_GetHostname" , &hVmCfg ) )
			break;

		PRL_STR	sVmHostname = (PRL_STR )0;
		PRL_UINT32	rnVmHostnameBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetHostname( hVmCfg, sVmHostname, &rnVmHostnameBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sVmHostname(rnVmHostnameBufLength, '\0');
		sVmHostname = (PRL_STR )std_sVmHostname.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetHostname( hVmCfg, sVmHostname, &rnVmHostnameBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sVmHostname )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetHostname(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_CONST_STR	sNewVmHostname = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ks:PrlVmCfg_SetHostname" , &hVmCfg, &sNewVmHostname ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetHostname( hVmCfg, sNewVmHostname );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetDnsServers(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_GetDnsServers" , &hVmCfg ) )
			break;

		PRL_HANDLE	rhDnsServersList = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetDnsServers( hVmCfg, &rhDnsServersList );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhDnsServersList )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetDnsServers(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_HANDLE	hDnsServersList = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "kk:PrlVmCfg_SetDnsServers" , &hVmCfg, &hDnsServersList ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetDnsServers( hVmCfg, hDnsServersList );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetUuid(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_GetUuid" , &hVmCfg ) )
			break;

		PRL_STR	sVmUuid = (PRL_STR )0;
		PRL_UINT32	rnVmUuidBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetUuid( hVmCfg, sVmUuid, &rnVmUuidBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sVmUuid(rnVmUuidBufLength, '\0');
		sVmUuid = (PRL_STR )std_sVmUuid.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetUuid( hVmCfg, sVmUuid, &rnVmUuidBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sVmUuid )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetUuid(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_CONST_STR	sNewVmUuid = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ks:PrlVmCfg_SetUuid" , &hVmCfg, &sNewVmUuid ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetUuid( hVmCfg, sNewVmUuid );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetCtId(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_GetCtId" , &hVmCfg ) )
			break;

		PRL_STR	sCtId = (PRL_STR )0;
		PRL_UINT32	rnCtIdBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetCtId( hVmCfg, sCtId, &rnCtIdBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sCtId(rnCtIdBufLength, '\0');
		sCtId = (PRL_STR )std_sCtId.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetCtId( hVmCfg, sCtId, &rnCtIdBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sCtId )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetLinkedVmUuid(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_GetLinkedVmUuid" , &hVmCfg ) )
			break;

		PRL_STR	sVmUuid = (PRL_STR )0;
		PRL_UINT32	rnVmUuidBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetLinkedVmUuid( hVmCfg, sVmUuid, &rnVmUuidBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sVmUuid(rnVmUuidBufLength, '\0');
		sVmUuid = (PRL_STR )std_sVmUuid.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetLinkedVmUuid( hVmCfg, sVmUuid, &rnVmUuidBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sVmUuid )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetOsType(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_GetOsType" , &hVmCfg ) )
			break;

		PRL_UINT32	rnVmOsType = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetOsType( hVmCfg, &rnVmOsType );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnVmOsType )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetOsVersion(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_GetOsVersion" , &hVmCfg ) )
			break;

		PRL_UINT32	rnVmOsVersion = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetOsVersion( hVmCfg, &rnVmOsVersion );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnVmOsVersion )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetOsVersion(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_UINT32	nVmOsVersion = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmCfg_SetOsVersion" , &hVmCfg, &nVmOsVersion ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetOsVersion( hVmCfg, nVmOsVersion );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetRamSize(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_GetRamSize" , &hVmCfg ) )
			break;

		PRL_UINT32	rnVmRamSize = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetRamSize( hVmCfg, &rnVmRamSize );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnVmRamSize )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetRamSize(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_UINT32	nVmRamSize = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmCfg_SetRamSize" , &hVmCfg, &nVmRamSize ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetRamSize( hVmCfg, nVmRamSize );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetVideoRamSize(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_GetVideoRamSize" , &hVmCfg ) )
			break;

		PRL_UINT32	rnVmVideoRamSize = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetVideoRamSize( hVmCfg, &rnVmVideoRamSize );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnVmVideoRamSize )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetVideoRamSize(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_UINT32	nVmVideoRamSize = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmCfg_SetVideoRamSize" , &hVmCfg, &nVmVideoRamSize ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetVideoRamSize( hVmCfg, nVmVideoRamSize );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetCpuCount(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_GetCpuCount" , &hVmCfg ) )
			break;

		PRL_UINT32	rnVmCpuCount = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetCpuCount( hVmCfg, &rnVmCpuCount );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnVmCpuCount )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetCpuCount(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_UINT32	nVmCpuCount = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmCfg_SetCpuCount" , &hVmCfg, &nVmCpuCount ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetCpuCount( hVmCfg, nVmCpuCount );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetCpuMode(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_GetCpuMode" , &hVmCfg ) )
			break;

		PRL_CPU_MODE	rnVmCpuMode = (PRL_CPU_MODE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetCpuMode( hVmCfg, &rnVmCpuMode );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "i", rnVmCpuMode )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetCpuMode(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_INT32	nVmCpuMode = (PRL_INT32 )0;

		if ( ! PyArg_ParseTuple( args, "ki:PrlVmCfg_SetCpuMode" , &hVmCfg, &nVmCpuMode ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetCpuMode( hVmCfg, (PRL_CPU_MODE )nVmCpuMode );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetCpuAccelLevel(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_GetCpuAccelLevel" , &hVmCfg ) )
			break;

		PRL_VM_ACCELERATION_LEVEL	rnVmCpuAccelLevel = (PRL_VM_ACCELERATION_LEVEL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetCpuAccelLevel( hVmCfg, &rnVmCpuAccelLevel );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "i", rnVmCpuAccelLevel )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetCpuAccelLevel(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_INT32	nVmCpuAccelLevel = (PRL_INT32 )0;

		if ( ! PyArg_ParseTuple( args, "ki:PrlVmCfg_SetCpuAccelLevel" , &hVmCfg, &nVmCpuAccelLevel ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetCpuAccelLevel( hVmCfg, (PRL_VM_ACCELERATION_LEVEL )nVmCpuAccelLevel );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_IsCpuVtxEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_IsCpuVtxEnabled" , &hVmCfg ) )
			break;

		PRL_BOOL	rbVmCpuVtxEnabled = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_IsCpuVtxEnabled( hVmCfg, &rbVmCpuVtxEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbVmCpuVtxEnabled )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_IsCpuHotplugEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_IsCpuHotplugEnabled" , &hVmCfg ) )
			break;

		PRL_BOOL	rbVmCpuHotplugEnabled = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_IsCpuHotplugEnabled( hVmCfg, &rbVmCpuHotplugEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbVmCpuHotplugEnabled )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetCpuHotplugEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_BOOL	bVmCpuHotplugEnabled = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmCfg_SetCpuHotplugEnabled" , &hVmCfg, &bVmCpuHotplugEnabled ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetCpuHotplugEnabled( hVmCfg, bVmCpuHotplugEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_Get3DAccelerationMode(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_Get3DAccelerationMode" , &hVmCfg ) )
			break;

		PRL_VIDEO_3D_ACCELERATION	rn3DAccelerationMode = (PRL_VIDEO_3D_ACCELERATION )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_Get3DAccelerationMode( hVmCfg, &rn3DAccelerationMode );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "i", rn3DAccelerationMode )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_Set3DAccelerationMode(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_INT32	n3DAccelerationMode = (PRL_INT32 )0;

		if ( ! PyArg_ParseTuple( args, "ki:PrlVmCfg_Set3DAccelerationMode" , &hVmCfg, &n3DAccelerationMode ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_Set3DAccelerationMode( hVmCfg, (PRL_VIDEO_3D_ACCELERATION )n3DAccelerationMode );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_IsVerticalSynchronizationEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_IsVerticalSynchronizationEnabled" , &hVmCfg ) )
			break;

		PRL_BOOL	rbEnabled = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_IsVerticalSynchronizationEnabled( hVmCfg, &rbEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbEnabled )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetVerticalSynchronizationEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_BOOL	bEnabled = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmCfg_SetVerticalSynchronizationEnabled" , &hVmCfg, &bEnabled ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetVerticalSynchronizationEnabled( hVmCfg, bEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_IsHighResolutionEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_IsHighResolutionEnabled" , &hVmCfg ) )
			break;

		PRL_BOOL	rbEnabled = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_IsHighResolutionEnabled( hVmCfg, &rbEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbEnabled )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetHighResolutionEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_BOOL	bEnabled = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmCfg_SetHighResolutionEnabled" , &hVmCfg, &bEnabled ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetHighResolutionEnabled( hVmCfg, bEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_IsAdaptiveHypervisorEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_IsAdaptiveHypervisorEnabled" , &hVm ) )
			break;

		PRL_BOOL	rbEnable = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_IsAdaptiveHypervisorEnabled( hVm, &rbEnable );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbEnable )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetAdaptiveHypervisorEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;
		PRL_BOOL	bEnable = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmCfg_SetAdaptiveHypervisorEnabled" , &hVm, &bEnable ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetAdaptiveHypervisorEnabled( hVm, bEnable );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_IsSwitchOffWindowsLogoEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_IsSwitchOffWindowsLogoEnabled" , &hVm ) )
			break;

		PRL_BOOL	rbEnable = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_IsSwitchOffWindowsLogoEnabled( hVm, &rbEnable );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbEnable )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetSwitchOffWindowsLogoEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;
		PRL_BOOL	bEnable = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmCfg_SetSwitchOffWindowsLogoEnabled" , &hVm, &bEnable ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetSwitchOffWindowsLogoEnabled( hVm, bEnable );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_IsLongerBatteryLifeEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_IsLongerBatteryLifeEnabled" , &hVm ) )
			break;

		PRL_BOOL	rbEnable = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_IsLongerBatteryLifeEnabled( hVm, &rbEnable );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbEnable )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetLongerBatteryLifeEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;
		PRL_BOOL	bEnable = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmCfg_SetLongerBatteryLifeEnabled" , &hVm, &bEnable ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetLongerBatteryLifeEnabled( hVm, bEnable );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_IsBatteryStatusEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_IsBatteryStatusEnabled" , &hVm ) )
			break;

		PRL_BOOL	rbEnable = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_IsBatteryStatusEnabled( hVm, &rbEnable );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbEnable )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetBatteryStatusEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;
		PRL_BOOL	bEnable = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmCfg_SetBatteryStatusEnabled" , &hVm, &bEnable ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetBatteryStatusEnabled( hVm, bEnable );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_IsNestedVirtualizationEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_IsNestedVirtualizationEnabled" , &hVm ) )
			break;

		PRL_BOOL	rbEnable = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_IsNestedVirtualizationEnabled( hVm, &rbEnable );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbEnable )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetNestedVirtualizationEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;
		PRL_BOOL	bEnable = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmCfg_SetNestedVirtualizationEnabled" , &hVm, &bEnable ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetNestedVirtualizationEnabled( hVm, bEnable );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_IsPMUVirtualizationEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_IsPMUVirtualizationEnabled" , &hVm ) )
			break;

		PRL_BOOL	rbEnable = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_IsPMUVirtualizationEnabled( hVm, &rbEnable );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbEnable )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetPMUVirtualizationEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;
		PRL_BOOL	bEnable = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmCfg_SetPMUVirtualizationEnabled" , &hVm, &bEnable ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetPMUVirtualizationEnabled( hVm, bEnable );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_IsLockGuestOnSuspendEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_IsLockGuestOnSuspendEnabled" , &hVm ) )
			break;

		PRL_BOOL	rbEnable = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_IsLockGuestOnSuspendEnabled( hVm, &rbEnable );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbEnable )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetLockGuestOnSuspendEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;
		PRL_BOOL	bEnable = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmCfg_SetLockGuestOnSuspendEnabled" , &hVm, &bEnable ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetLockGuestOnSuspendEnabled( hVm, bEnable );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_IsIsolatedVmEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_IsIsolatedVmEnabled" , &hVm ) )
			break;

		PRL_BOOL	rbEnable = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_IsIsolatedVmEnabled( hVm, &rbEnable );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbEnable )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetIsolatedVmEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;
		PRL_BOOL	bEnable = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmCfg_SetIsolatedVmEnabled" , &hVm, &bEnable ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetIsolatedVmEnabled( hVm, bEnable );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetCpuUnits(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_UINT32	nVmCpuUnits = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmCfg_SetCpuUnits" , &hVmCfg, &nVmCpuUnits ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetCpuUnits( hVmCfg, nVmCpuUnits );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetCpuUnits(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_GetCpuUnits" , &hVmCfg ) )
			break;

		PRL_UINT32	nVmCpuUnits = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetCpuUnits( hVmCfg, &nVmCpuUnits );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", nVmCpuUnits )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetCpuLimit(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_UINT32	nVmCpuLimit = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmCfg_SetCpuLimit" , &hVmCfg, &nVmCpuLimit ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetCpuLimit( hVmCfg, nVmCpuLimit );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetCpuLimit(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_GetCpuLimit" , &hVmCfg ) )
			break;

		PRL_UINT32	nVmCpuLimit = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetCpuLimit( hVmCfg, &nVmCpuLimit );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", nVmCpuLimit )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetCpuMask(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_GetCpuMask" , &hVmCfg ) )
			break;

		PRL_STR	sMask = (PRL_STR )0;
		PRL_UINT32	rnMaskBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetCpuMask( hVmCfg, sMask, &rnMaskBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sMask(rnMaskBufLength, '\0');
		sMask = (PRL_STR )std_sMask.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetCpuMask( hVmCfg, sMask, &rnMaskBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sMask )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetCpuMask(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_CONST_STR	sMask = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ks:PrlVmCfg_SetCpuMask" , &hVmCfg, &sMask ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetCpuMask( hVmCfg, sMask );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetNodeMask(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_GetNodeMask" , &hVmCfg ) )
			break;

		PRL_STR	sMask = (PRL_STR )0;
		PRL_UINT32	rnMaskBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetNodeMask( hVmCfg, sMask, &rnMaskBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sMask(rnMaskBufLength, '\0');
		sMask = (PRL_STR )std_sMask.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetNodeMask( hVmCfg, sMask, &rnMaskBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sMask )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetNodeMask(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_CONST_STR	sMask = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ks:PrlVmCfg_SetNodeMask" , &hVmCfg, &sMask ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetNodeMask( hVmCfg, sMask );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetIoPriority(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_GetIoPriority" , &hVmCfg ) )
			break;

		PRL_UINT32	rnVmIoPriority = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetIoPriority( hVmCfg, &rnVmIoPriority );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnVmIoPriority )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetIoPriority(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_UINT32	nVmIoPriority = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmCfg_SetIoPriority" , &hVmCfg, &nVmIoPriority ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetIoPriority( hVmCfg, nVmIoPriority );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetIopsLimit(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_GetIopsLimit" , &hVmCfg ) )
			break;

		PRL_UINT32	rnVmIopsLimit = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetIopsLimit( hVmCfg, &rnVmIopsLimit );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnVmIopsLimit )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetIopsLimit(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_UINT32	nVmIopsLimit = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmCfg_SetIopsLimit" , &hVmCfg, &nVmIopsLimit ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetIopsLimit( hVmCfg, nVmIopsLimit );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetServerUuid(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_GetServerUuid" , &hVmCfg ) )
			break;

		PRL_STR	sServerUuid = (PRL_STR )0;
		PRL_UINT32	rnServerUuidBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetServerUuid( hVmCfg, sServerUuid, &rnServerUuidBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sServerUuid(rnServerUuidBufLength, '\0');
		sServerUuid = (PRL_STR )std_sServerUuid.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetServerUuid( hVmCfg, sServerUuid, &rnServerUuidBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sServerUuid )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetServerHost(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_GetServerHost" , &hVmCfg ) )
			break;

		PRL_STR	sServerHost = (PRL_STR )0;
		PRL_UINT32	rnServerHostBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetServerHost( hVmCfg, sServerHost, &rnServerHostBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sServerHost(rnServerHostBufLength, '\0');
		sServerHost = (PRL_STR )std_sServerHost.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetServerHost( hVmCfg, sServerHost, &rnServerHostBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sServerHost )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetHomePath(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_GetHomePath" , &hVmCfg ) )
			break;

		PRL_STR	sHomePath = (PRL_STR )0;
		PRL_UINT32	rnHomePathBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetHomePath( hVmCfg, sHomePath, &rnHomePathBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sHomePath(rnHomePathBufLength, '\0');
		sHomePath = (PRL_STR )std_sHomePath.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetHomePath( hVmCfg, sHomePath, &rnHomePathBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sHomePath )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetLocation(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_GetLocation" , &hVmCfg ) )
			break;

		PRL_VM_LOCATION	rnVmLocation = (PRL_VM_LOCATION )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetLocation( hVmCfg, &rnVmLocation );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "i", rnVmLocation )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetIcon(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_GetIcon" , &hVmCfg ) )
			break;

		PRL_STR	sVmIcon = (PRL_STR )0;
		PRL_UINT32	rnVmIconBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetIcon( hVmCfg, sVmIcon, &rnVmIconBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sVmIcon(rnVmIconBufLength, '\0');
		sVmIcon = (PRL_STR )std_sVmIcon.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetIcon( hVmCfg, sVmIcon, &rnVmIconBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sVmIcon )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetIcon(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_CONST_STR	sNewVmIcon = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ks:PrlVmCfg_SetIcon" , &hVmCfg, &sNewVmIcon ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetIcon( hVmCfg, sNewVmIcon );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetDescription(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_GetDescription" , &hVmCfg ) )
			break;

		PRL_STR	sVmDescription = (PRL_STR )0;
		PRL_UINT32	rnVmDescriptionBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetDescription( hVmCfg, sVmDescription, &rnVmDescriptionBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sVmDescription(rnVmDescriptionBufLength, '\0');
		sVmDescription = (PRL_STR )std_sVmDescription.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetDescription( hVmCfg, sVmDescription, &rnVmDescriptionBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sVmDescription )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetDescription(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_CONST_STR	sNewVmDescription = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ks:PrlVmCfg_SetDescription" , &hVmCfg, &sNewVmDescription ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetDescription( hVmCfg, sNewVmDescription );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_IsTemplate(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_IsTemplate" , &hVmCfg ) )
			break;

		PRL_BOOL	rbVmIsTemplate = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_IsTemplate( hVmCfg, &rbVmIsTemplate );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbVmIsTemplate )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetTemplateSign(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_BOOL	bVmIsTemplate = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmCfg_SetTemplateSign" , &hVmCfg, &bVmIsTemplate ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetTemplateSign( hVmCfg, bVmIsTemplate );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetCustomProperty(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_GetCustomProperty" , &hVmCfg ) )
			break;

		PRL_STR	sVmCustomProperty = (PRL_STR )0;
		PRL_UINT32	rnVmCustomPropertyBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetCustomProperty( hVmCfg, sVmCustomProperty, &rnVmCustomPropertyBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sVmCustomProperty(rnVmCustomPropertyBufLength, '\0');
		sVmCustomProperty = (PRL_STR )std_sVmCustomProperty.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetCustomProperty( hVmCfg, sVmCustomProperty, &rnVmCustomPropertyBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sVmCustomProperty )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetCustomProperty(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_CONST_STR	sNewVmCustomProperty = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ks:PrlVmCfg_SetCustomProperty" , &hVmCfg, &sNewVmCustomProperty ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetCustomProperty( hVmCfg, sNewVmCustomProperty );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetAutoStart(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_GetAutoStart" , &hVmCfg ) )
			break;

		PRL_VM_AUTOSTART_OPTION	rnVmAutoStart = (PRL_VM_AUTOSTART_OPTION )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetAutoStart( hVmCfg, &rnVmAutoStart );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "i", rnVmAutoStart )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetAutoStart(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_INT32	nVmAutoStart = (PRL_INT32 )0;

		if ( ! PyArg_ParseTuple( args, "ki:PrlVmCfg_SetAutoStart" , &hVmCfg, &nVmAutoStart ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetAutoStart( hVmCfg, (PRL_VM_AUTOSTART_OPTION )nVmAutoStart );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetAutoStartDelay(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_GetAutoStartDelay" , &hVmCfg ) )
			break;

		PRL_UINT32	rnVmAutoStartDelay = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetAutoStartDelay( hVmCfg, &rnVmAutoStartDelay );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnVmAutoStartDelay )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetAutoStartDelay(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_UINT32	nVmAutoStartDelay = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmCfg_SetAutoStartDelay" , &hVmCfg, &nVmAutoStartDelay ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetAutoStartDelay( hVmCfg, nVmAutoStartDelay );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetStartLoginMode(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_GetStartLoginMode" , &hVmCfg ) )
			break;

		PRL_VM_START_LOGIN_MODE	rnVmStartLoginMode = (PRL_VM_START_LOGIN_MODE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetStartLoginMode( hVmCfg, &rnVmStartLoginMode );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "i", rnVmStartLoginMode )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetStartLoginMode(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_INT32	nVmStartLoginMode = (PRL_INT32 )0;

		if ( ! PyArg_ParseTuple( args, "ki:PrlVmCfg_SetStartLoginMode" , &hVmCfg, &nVmStartLoginMode ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetStartLoginMode( hVmCfg, (PRL_VM_START_LOGIN_MODE )nVmStartLoginMode );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetStartUserLogin(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_GetStartUserLogin" , &hVmCfg ) )
			break;

		PRL_STR	sStartUserLogin = (PRL_STR )0;
		PRL_UINT32	rnStartUserLoginBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetStartUserLogin( hVmCfg, sStartUserLogin, &rnStartUserLoginBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sStartUserLogin(rnStartUserLoginBufLength, '\0');
		sStartUserLogin = (PRL_STR )std_sStartUserLogin.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetStartUserLogin( hVmCfg, sStartUserLogin, &rnStartUserLoginBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sStartUserLogin )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetStartUserCreds(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_CONST_STR	sStartUserLogin = (PRL_CONST_STR )0;
		PRL_CONST_STR	sPassword = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "kss:PrlVmCfg_SetStartUserCreds" , &hVmCfg, &sStartUserLogin, &sPassword ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetStartUserCreds( hVmCfg, sStartUserLogin, sPassword );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetAutoStop(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_GetAutoStop" , &hVmCfg ) )
			break;

		PRL_VM_AUTOSTOP_OPTION	rnVmAutoStop = (PRL_VM_AUTOSTOP_OPTION )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetAutoStop( hVmCfg, &rnVmAutoStop );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "i", rnVmAutoStop )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetAutoStop(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_INT32	nVmAutoStop = (PRL_INT32 )0;

		if ( ! PyArg_ParseTuple( args, "ki:PrlVmCfg_SetAutoStop" , &hVmCfg, &nVmAutoStop ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetAutoStop( hVmCfg, (PRL_VM_AUTOSTOP_OPTION )nVmAutoStop );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetActionOnWindowClose(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_GetActionOnWindowClose" , &hVmCfg ) )
			break;

		PRL_VM_ACTION_ON_WINDOW_CLOSE	rnActionOnWindowClose = (PRL_VM_ACTION_ON_WINDOW_CLOSE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetActionOnWindowClose( hVmCfg, &rnActionOnWindowClose );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "i", rnActionOnWindowClose )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetActionOnWindowClose(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_INT32	nActionOnWindowClose = (PRL_INT32 )0;

		if ( ! PyArg_ParseTuple( args, "ki:PrlVmCfg_SetActionOnWindowClose" , &hVmCfg, &nActionOnWindowClose ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetActionOnWindowClose( hVmCfg, (PRL_VM_ACTION_ON_WINDOW_CLOSE )nActionOnWindowClose );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetActionOnStopMode(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_GetActionOnStopMode" , &hVm ) )
			break;

		PRL_VM_ACTION_ON_STOP	rnMode = (PRL_VM_ACTION_ON_STOP )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetActionOnStopMode( hVm, &rnMode );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "i", rnMode )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetActionOnStopMode(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;
		PRL_INT32	nMode = (PRL_INT32 )0;

		if ( ! PyArg_ParseTuple( args, "ki:PrlVmCfg_SetActionOnStopMode" , &hVm, &nMode ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetActionOnStopMode( hVm, (PRL_VM_ACTION_ON_STOP )nMode );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetWindowMode(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_GetWindowMode" , &hVmCfg ) )
			break;

		PRL_VM_WINDOW_MODE	rnVmWindowMode = (PRL_VM_WINDOW_MODE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetWindowMode( hVmCfg, &rnVmWindowMode );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "i", rnVmWindowMode )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetWindowMode(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_INT32	nVmWindowMode = (PRL_INT32 )0;

		if ( ! PyArg_ParseTuple( args, "ki:PrlVmCfg_SetWindowMode" , &hVmCfg, &nVmWindowMode ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetWindowMode( hVmCfg, (PRL_VM_WINDOW_MODE )nVmWindowMode );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_IsStartInDetachedWindowEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_IsStartInDetachedWindowEnabled" , &hVm ) )
			break;

		PRL_BOOL	rbEnable = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_IsStartInDetachedWindowEnabled( hVm, &rbEnable );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbEnable )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetStartInDetachedWindowEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;
		PRL_BOOL	bEnable = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmCfg_SetStartInDetachedWindowEnabled" , &hVm, &bEnable ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetStartInDetachedWindowEnabled( hVm, bEnable );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_IsLockInFullScreenMode(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_IsLockInFullScreenMode" , &hVmCfg ) )
			break;

		PRL_BOOL	rbValue = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_IsLockInFullScreenMode( hVmCfg, &rbValue );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbValue )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetLockInFullScreenMode(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_BOOL	bValue = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmCfg_SetLockInFullScreenMode" , &hVmCfg, &bValue ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetLockInFullScreenMode( hVmCfg, bValue );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetLastModifiedDate(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_GetLastModifiedDate" , &hVmCfg ) )
			break;

		PRL_STR	sVmLastModifiedDate = (PRL_STR )0;
		PRL_UINT32	rnVmLastModifiedDateBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetLastModifiedDate( hVmCfg, sVmLastModifiedDate, &rnVmLastModifiedDateBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sVmLastModifiedDate(rnVmLastModifiedDateBufLength, '\0');
		sVmLastModifiedDate = (PRL_STR )std_sVmLastModifiedDate.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetLastModifiedDate( hVmCfg, sVmLastModifiedDate, &rnVmLastModifiedDateBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sVmLastModifiedDate )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetLastModifierName(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_GetLastModifierName" , &hVmCfg ) )
			break;

		PRL_STR	sVmLastModifierName = (PRL_STR )0;
		PRL_UINT32	rnVmLastModifierNameBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetLastModifierName( hVmCfg, sVmLastModifierName, &rnVmLastModifierNameBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sVmLastModifierName(rnVmLastModifierNameBufLength, '\0');
		sVmLastModifierName = (PRL_STR )std_sVmLastModifierName.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetLastModifierName( hVmCfg, sVmLastModifierName, &rnVmLastModifierNameBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sVmLastModifierName )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetUptimeStartDate(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_GetUptimeStartDate" , &hVmCfg ) )
			break;

		PRL_STR	sVmUptimeStartDate = (PRL_STR )0;
		PRL_UINT32	rnVmUptimeStartDateBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetUptimeStartDate( hVmCfg, sVmUptimeStartDate, &rnVmUptimeStartDateBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sVmUptimeStartDate(rnVmUptimeStartDateBufLength, '\0');
		sVmUptimeStartDate = (PRL_STR )std_sVmUptimeStartDate.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetUptimeStartDate( hVmCfg, sVmUptimeStartDate, &rnVmUptimeStartDateBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sVmUptimeStartDate )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetUptime(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_GetUptime" , &hVmCfg ) )
			break;

		PRL_UINT64	rnVmUptime = (PRL_UINT64 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetUptime( hVmCfg, &rnVmUptime );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "K", rnVmUptime )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_IsGuestSharingEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_IsGuestSharingEnabled" , &hVmCfg ) )
			break;

		PRL_BOOL	rbVmGuestSharingEnabled = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_IsGuestSharingEnabled( hVmCfg, &rbVmGuestSharingEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbVmGuestSharingEnabled )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetGuestSharingEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_BOOL	bVmGuestSharingEnabled = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmCfg_SetGuestSharingEnabled" , &hVmCfg, &bVmGuestSharingEnabled ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetGuestSharingEnabled( hVmCfg, bVmGuestSharingEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_IsGuestSharingAutoMount(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_IsGuestSharingAutoMount" , &hVmCfg ) )
			break;

		PRL_BOOL	rbVmGuestSharingAutoMount = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_IsGuestSharingAutoMount( hVmCfg, &rbVmGuestSharingAutoMount );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbVmGuestSharingAutoMount )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetGuestSharingAutoMount(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_BOOL	bVmGuestSharingAutoMount = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmCfg_SetGuestSharingAutoMount" , &hVmCfg, &bVmGuestSharingAutoMount ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetGuestSharingAutoMount( hVmCfg, bVmGuestSharingAutoMount );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_IsGuestSharingEnableSpotlight(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_IsGuestSharingEnableSpotlight" , &hVmCfg ) )
			break;

		PRL_BOOL	rbVmGuestSharingEnableSpotlight = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_IsGuestSharingEnableSpotlight( hVmCfg, &rbVmGuestSharingEnableSpotlight );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbVmGuestSharingEnableSpotlight )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetGuestSharingEnableSpotlight(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_BOOL	bVmGuestSharingEnableSpotlight = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmCfg_SetGuestSharingEnableSpotlight" , &hVmCfg, &bVmGuestSharingEnableSpotlight ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetGuestSharingEnableSpotlight( hVmCfg, bVmGuestSharingEnableSpotlight );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_IsHostSharingEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_IsHostSharingEnabled" , &hVmCfg ) )
			break;

		PRL_BOOL	rbVmHostSharingEnabled = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_IsHostSharingEnabled( hVmCfg, &rbVmHostSharingEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbVmHostSharingEnabled )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetHostSharingEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_BOOL	bVmHostSharingEnabled = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmCfg_SetHostSharingEnabled" , &hVmCfg, &bVmHostSharingEnabled ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetHostSharingEnabled( hVmCfg, bVmHostSharingEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_IsShareAllHostDisks(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_IsShareAllHostDisks" , &hVmCfg ) )
			break;

		PRL_BOOL	rbShareAllHostDisks = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_IsShareAllHostDisks( hVmCfg, &rbShareAllHostDisks );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbShareAllHostDisks )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetShareAllHostDisks(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_BOOL	bShareAllHostDisks = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmCfg_SetShareAllHostDisks" , &hVmCfg, &bShareAllHostDisks ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetShareAllHostDisks( hVmCfg, bShareAllHostDisks );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_IsShareUserHomeDir(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_IsShareUserHomeDir" , &hVmCfg ) )
			break;

		PRL_BOOL	rbShareUserHomeDir = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_IsShareUserHomeDir( hVmCfg, &rbShareUserHomeDir );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbShareUserHomeDir )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetShareUserHomeDir(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_BOOL	bShareUserHomeDir = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmCfg_SetShareUserHomeDir" , &hVmCfg, &bShareUserHomeDir ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetShareUserHomeDir( hVmCfg, bShareUserHomeDir );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_IsMapSharedFoldersOnLetters(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_IsMapSharedFoldersOnLetters" , &hVmCfg ) )
			break;

		PRL_BOOL	rbMapSharedFoldersOnLetters = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_IsMapSharedFoldersOnLetters( hVmCfg, &rbMapSharedFoldersOnLetters );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbMapSharedFoldersOnLetters )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetMapSharedFoldersOnLetters(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_BOOL	bMapSharedFoldersOnLetters = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmCfg_SetMapSharedFoldersOnLetters" , &hVmCfg, &bMapSharedFoldersOnLetters ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetMapSharedFoldersOnLetters( hVmCfg, bMapSharedFoldersOnLetters );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetVNCMode(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_GetVNCMode" , &hVmCfg ) )
			break;

		PRL_VM_REMOTE_DISPLAY_MODE	rnVmRemoteDisplayMode = (PRL_VM_REMOTE_DISPLAY_MODE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetVNCMode( hVmCfg, &rnVmRemoteDisplayMode );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "i", rnVmRemoteDisplayMode )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetVNCMode(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_INT32	nVmRemoteDisplayMode = (PRL_INT32 )0;

		if ( ! PyArg_ParseTuple( args, "ki:PrlVmCfg_SetVNCMode" , &hVmCfg, &nVmRemoteDisplayMode ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetVNCMode( hVmCfg, (PRL_VM_REMOTE_DISPLAY_MODE )nVmRemoteDisplayMode );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetVNCPassword(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_GetVNCPassword" , &hVmCfg ) )
			break;

		PRL_STR	sVmRemoteDisplayPassword = (PRL_STR )0;
		PRL_UINT32	rnVmRemoteDisplayPasswordBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetVNCPassword( hVmCfg, sVmRemoteDisplayPassword, &rnVmRemoteDisplayPasswordBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sVmRemoteDisplayPassword(rnVmRemoteDisplayPasswordBufLength, '\0');
		sVmRemoteDisplayPassword = (PRL_STR )std_sVmRemoteDisplayPassword.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetVNCPassword( hVmCfg, sVmRemoteDisplayPassword, &rnVmRemoteDisplayPasswordBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sVmRemoteDisplayPassword )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetVNCPassword(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_CONST_STR	sNewVmRemoteDisplayPassword = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ks:PrlVmCfg_SetVNCPassword" , &hVmCfg, &sNewVmRemoteDisplayPassword ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetVNCPassword( hVmCfg, sNewVmRemoteDisplayPassword );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetVNCHostName(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_GetVNCHostName" , &hVmCfg ) )
			break;

		PRL_STR	sVmRemoteDisplayHostName = (PRL_STR )0;
		PRL_UINT32	rnVmRemoteDisplayHostNameBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetVNCHostName( hVmCfg, sVmRemoteDisplayHostName, &rnVmRemoteDisplayHostNameBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sVmRemoteDisplayHostName(rnVmRemoteDisplayHostNameBufLength, '\0');
		sVmRemoteDisplayHostName = (PRL_STR )std_sVmRemoteDisplayHostName.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetVNCHostName( hVmCfg, sVmRemoteDisplayHostName, &rnVmRemoteDisplayHostNameBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sVmRemoteDisplayHostName )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetVNCHostName(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_CONST_STR	sNewVmRemoteDisplayHostName = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ks:PrlVmCfg_SetVNCHostName" , &hVmCfg, &sNewVmRemoteDisplayHostName ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetVNCHostName( hVmCfg, sNewVmRemoteDisplayHostName );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetVNCPort(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_GetVNCPort" , &hVmCfg ) )
			break;

		PRL_UINT32	rnVmRemoteDisplayPort = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetVNCPort( hVmCfg, &rnVmRemoteDisplayPort );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnVmRemoteDisplayPort )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetVNCPort(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_UINT32	nVmRemoteDisplayPort = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmCfg_SetVNCPort" , &hVmCfg, &nVmRemoteDisplayPort ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetVNCPort( hVmCfg, nVmRemoteDisplayPort );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_IsScrResEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_IsScrResEnabled" , &hVmCfg ) )
			break;

		PRL_BOOL	rbVmScrResEnabled = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_IsScrResEnabled( hVmCfg, &rbVmScrResEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbVmScrResEnabled )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetScrResEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_BOOL	bVmScrResEnabled = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmCfg_SetScrResEnabled" , &hVmCfg, &bVmScrResEnabled ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetScrResEnabled( hVmCfg, bVmScrResEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_IsDiskCacheWriteBack(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_IsDiskCacheWriteBack" , &hVmCfg ) )
			break;

		PRL_BOOL	rbVmDiskCacheWriteBack = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_IsDiskCacheWriteBack( hVmCfg, &rbVmDiskCacheWriteBack );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbVmDiskCacheWriteBack )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetDiskCacheWriteBack(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_BOOL	bVmDiskCacheWriteBack = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmCfg_SetDiskCacheWriteBack" , &hVmCfg, &bVmDiskCacheWriteBack ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetDiskCacheWriteBack( hVmCfg, bVmDiskCacheWriteBack );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_IsOsResInFullScrMode(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_IsOsResInFullScrMode" , &hVmCfg ) )
			break;

		PRL_BOOL	rbVmOsResInFullScrMode = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_IsOsResInFullScrMode( hVmCfg, &rbVmOsResInFullScrMode );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbVmOsResInFullScrMode )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetOsResInFullScrMode(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_BOOL	bVmOsResInFullScrMode = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmCfg_SetOsResInFullScrMode" , &hVmCfg, &bVmOsResInFullScrMode ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetOsResInFullScrMode( hVmCfg, bVmOsResInFullScrMode );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_IsCloseAppOnShutdown(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_IsCloseAppOnShutdown" , &hVmCfg ) )
			break;

		PRL_BOOL	rbVmCloseAppOnShutdown = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_IsCloseAppOnShutdown( hVmCfg, &rbVmCloseAppOnShutdown );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbVmCloseAppOnShutdown )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetCloseAppOnShutdown(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_BOOL	bVmCloseAppOnShutdown = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmCfg_SetCloseAppOnShutdown" , &hVmCfg, &bVmCloseAppOnShutdown ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetCloseAppOnShutdown( hVmCfg, bVmCloseAppOnShutdown );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetSystemFlags(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_GetSystemFlags" , &hVmCfg ) )
			break;

		PRL_STR	sVmSystemFlags = (PRL_STR )0;
		PRL_UINT32	rnVmSystemFlagsBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetSystemFlags( hVmCfg, sVmSystemFlags, &rnVmSystemFlagsBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sVmSystemFlags(rnVmSystemFlagsBufLength, '\0');
		sVmSystemFlags = (PRL_STR )std_sVmSystemFlags.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetSystemFlags( hVmCfg, sVmSystemFlags, &rnVmSystemFlagsBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sVmSystemFlags )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetSystemFlags(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_CONST_STR	sNewVmSystemFlags = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ks:PrlVmCfg_SetSystemFlags" , &hVmCfg, &sNewVmSystemFlags ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetSystemFlags( hVmCfg, sNewVmSystemFlags );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_IsDisableAPIC(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_IsDisableAPIC" , &hVmCfg ) )
			break;

		PRL_BOOL	rbDisableAPIC = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_IsDisableAPIC( hVmCfg, &rbDisableAPIC );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbDisableAPIC )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetDisableAPICSign(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_BOOL	bDisableAPIC = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmCfg_SetDisableAPICSign" , &hVmCfg, &bDisableAPIC ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetDisableAPICSign( hVmCfg, bDisableAPIC );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_IsDisableSpeaker(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_IsDisableSpeaker" , &hVmCfg ) )
			break;

		PRL_BOOL	rbDisableSpeaker = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_IsDisableSpeaker( hVmCfg, &rbDisableSpeaker );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbDisableSpeaker )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetDisableSpeakerSign(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_BOOL	bDisableSpeaker = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmCfg_SetDisableSpeakerSign" , &hVmCfg, &bDisableSpeaker ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetDisableSpeakerSign( hVmCfg, bDisableSpeaker );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetUndoDisksMode(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_GetUndoDisksMode" , &hVmCfg ) )
			break;

		PRL_UNDO_DISKS_MODE	rnUndoDisksMode = (PRL_UNDO_DISKS_MODE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetUndoDisksMode( hVmCfg, &rnUndoDisksMode );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "i", rnUndoDisksMode )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetUndoDisksMode(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_INT32	nUndoDisksMode = (PRL_INT32 )0;

		if ( ! PyArg_ParseTuple( args, "ki:PrlVmCfg_SetUndoDisksMode" , &hVmCfg, &nUndoDisksMode ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetUndoDisksMode( hVmCfg, (PRL_UNDO_DISKS_MODE )nUndoDisksMode );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetForegroundPriority(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_GetForegroundPriority" , &hVmCfg ) )
			break;

		PRL_VM_PRIORITY	rnVmForegroundPriority = (PRL_VM_PRIORITY )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetForegroundPriority( hVmCfg, &rnVmForegroundPriority );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "i", rnVmForegroundPriority )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetForegroundPriority(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_INT32	nVmForegroundPriority = (PRL_INT32 )0;

		if ( ! PyArg_ParseTuple( args, "ki:PrlVmCfg_SetForegroundPriority" , &hVmCfg, &nVmForegroundPriority ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetForegroundPriority( hVmCfg, (PRL_VM_PRIORITY )nVmForegroundPriority );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetBackgroundPriority(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_GetBackgroundPriority" , &hVmCfg ) )
			break;

		PRL_VM_PRIORITY	rnVmBackgroundPriority = (PRL_VM_PRIORITY )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetBackgroundPriority( hVmCfg, &rnVmBackgroundPriority );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "i", rnVmBackgroundPriority )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetBackgroundPriority(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_INT32	nVmBackgroundPriority = (PRL_INT32 )0;

		if ( ! PyArg_ParseTuple( args, "ki:PrlVmCfg_SetBackgroundPriority" , &hVmCfg, &nVmBackgroundPriority ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetBackgroundPriority( hVmCfg, (PRL_VM_PRIORITY )nVmBackgroundPriority );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_IsUseDefaultAnswers(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_IsUseDefaultAnswers" , &hVmCfg ) )
			break;

		PRL_BOOL	rbUseDefaultAnswers = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_IsUseDefaultAnswers( hVmCfg, &rbUseDefaultAnswers );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbUseDefaultAnswers )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetUseDefaultAnswers(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_BOOL	bUseDefaultAnswers = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmCfg_SetUseDefaultAnswers" , &hVmCfg, &bUseDefaultAnswers ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetUseDefaultAnswers( hVmCfg, bUseDefaultAnswers );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetSearchDomains(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_GetSearchDomains" , &hVmCfg ) )
			break;

		PRL_HANDLE	rhSearchDomainsList = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetSearchDomains( hVmCfg, &rhSearchDomainsList );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhSearchDomainsList )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetSearchDomains(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_HANDLE	hSearchDomainsList = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "kk:PrlVmCfg_SetSearchDomains" , &hVmCfg, &hSearchDomainsList ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetSearchDomains( hVmCfg, hSearchDomainsList );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetOfflineServices(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_GetOfflineServices" , &hVmCfg ) )
			break;

		PRL_HANDLE	rhOfflineServicesList = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetOfflineServices( hVmCfg, &rhOfflineServicesList );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhOfflineServicesList )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetOfflineServices(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_HANDLE	hOfflineServicesList = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "kk:PrlVmCfg_SetOfflineServices" , &hVmCfg, &hOfflineServicesList ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetOfflineServices( hVmCfg, hOfflineServicesList );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetConfirmationsList(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_GetConfirmationsList" , &hVmCfg ) )
			break;

		PRL_HANDLE	rhConfirmList = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetConfirmationsList( hVmCfg, &rhConfirmList );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhConfirmList )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetConfirmationsList(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_HANDLE	hConfirmList = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "kk:PrlVmCfg_SetConfirmationsList" , &hVmCfg, &hConfirmList ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetConfirmationsList( hVmCfg, hConfirmList );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_IsAutoCompressEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_IsAutoCompressEnabled" , &hVmCfg ) )
			break;

		PRL_BOOL	rbEnabled = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_IsAutoCompressEnabled( hVmCfg, &rbEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbEnabled )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetAutoCompressEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_BOOL	bEnabled = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmCfg_SetAutoCompressEnabled" , &hVmCfg, &bEnabled ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetAutoCompressEnabled( hVmCfg, bEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetAutoCompressInterval(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_GetAutoCompressInterval" , &hVmCfg ) )
			break;

		PRL_UINT32	rnInterval = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetAutoCompressInterval( hVmCfg, &rnInterval );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnInterval )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetAutoCompressInterval(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_UINT32	nInterval = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmCfg_SetAutoCompressInterval" , &hVmCfg, &nInterval ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetAutoCompressInterval( hVmCfg, nInterval );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetFreeDiskSpaceRatio(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_GetFreeDiskSpaceRatio" , &hVmCfg ) )
			break;

		PRL_DOUBLE	rdFreeDiskSpaceRatio = (PRL_DOUBLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetFreeDiskSpaceRatio( hVmCfg, &rdFreeDiskSpaceRatio );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "d", rdFreeDiskSpaceRatio )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetFreeDiskSpaceRatio(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_DOUBLE	dFreeDiskSpaceRatio = (PRL_DOUBLE )0;

		if ( ! PyArg_ParseTuple( args, "kd:PrlVmCfg_SetFreeDiskSpaceRatio" , &hVmCfg, &dFreeDiskSpaceRatio ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetFreeDiskSpaceRatio( hVmCfg, dFreeDiskSpaceRatio );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetVmInfo(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_GetVmInfo" , &hVmCfg ) )
			break;

		PRL_HANDLE	rhVmInfo = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetVmInfo( hVmCfg, &rhVmInfo );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhVmInfo )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetVmType(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_GetVmType" , &hVmCfg ) )
			break;

		PRL_VM_TYPE	rnType = (PRL_VM_TYPE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetVmType( hVmCfg, &rnType );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "i", rnType )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetVmType(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_INT32	nType = (PRL_INT32 )0;

		if ( ! PyArg_ParseTuple( args, "ki:PrlVmCfg_SetVmType" , &hVmCfg, &nType ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetVmType( hVmCfg, (PRL_VM_TYPE )nType );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_IsEfiEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_IsEfiEnabled" , &hVmCfg ) )
			break;

		PRL_BOOL	rbEfiEnabled = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_IsEfiEnabled( hVmCfg, &rbEfiEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbEfiEnabled )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetEfiEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_BOOL	bEfiEnabled = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmCfg_SetEfiEnabled" , &hVmCfg, &bEfiEnabled ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetEfiEnabled( hVmCfg, bEfiEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetExternalBootDevice(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_GetExternalBootDevice" , &hVmCfg ) )
			break;

		PRL_STR	sSysName = (PRL_STR )0;
		PRL_UINT32	rnSysNameBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetExternalBootDevice( hVmCfg, sSysName, &rnSysNameBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sSysName(rnSysNameBufLength, '\0');
		sSysName = (PRL_STR )std_sSysName.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetExternalBootDevice( hVmCfg, sSysName, &rnSysNameBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sSysName )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetExternalBootDevice(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_CONST_STR	sNewSysName = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ks:PrlVmCfg_SetExternalBootDevice" , &hVmCfg, &sNewSysName ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetExternalBootDevice( hVmCfg, sNewSysName );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVm_CreateEvent(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVm_CreateEvent" , &hVm ) )
			break;

		PRL_HANDLE	rhEvent = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVm_CreateEvent( hVm, &rhEvent );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhEvent )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVm_CreateUnattendedFloppy(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;
		PRL_INT32	nGuestDistroType = (PRL_INT32 )0;
		PRL_CONST_STR	sUsername = (PRL_CONST_STR )0;
		PRL_CONST_STR	sCompanyName = (PRL_CONST_STR )0;
		PRL_CONST_STR	sSerialKey = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "kisss:PrlVm_CreateUnattendedFloppy" , &hVm, &nGuestDistroType, &sUsername, &sCompanyName, &sSerialKey ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlVm_CreateUnattendedFloppy( hVm, (PRL_GUEST_DISTRO_VERSION_ENUM )nGuestDistroType, sUsername, sCompanyName, sSerialKey );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_CreateUnattendedCd(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;
		PRL_UINT32	nGuestType = (PRL_UINT32 )0;
		PRL_CONST_STR	sUserName = (PRL_CONST_STR )0;
		PRL_CONST_STR	sPasswd = (PRL_CONST_STR )0;
		PRL_CONST_STR	sFullUserName = (PRL_CONST_STR )0;
		PRL_CONST_STR	sOsDistroPath = (PRL_CONST_STR )0;
		PRL_CONST_STR	sOutImagePath = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "kIsssss:PrlSrv_CreateUnattendedCd" , &hServer, &nGuestType, &sUserName, &sPasswd, &sFullUserName, &sOsDistroPath, &sOutImagePath ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_CreateUnattendedCd( hServer, nGuestType, sUserName, sPasswd, sFullUserName, sOsDistroPath, sOutImagePath );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVm_InitiateDevStateNotifications(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVm_InitiateDevStateNotifications" , &hVm ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlVm_InitiateDevStateNotifications( hVm );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVm_ValidateConfig(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;
		PRL_INT32	nSection = (PRL_INT32 )0;

		if ( ! PyArg_ParseTuple( args, "ki:PrlVm_ValidateConfig" , &hVm, &nSection ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlVm_ValidateConfig( hVm, (PRL_VM_CONFIG_SECTIONS )nSection );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVm_UpdateSecurity(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;
		PRL_HANDLE	hAccessRights = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "kk:PrlVm_UpdateSecurity" , &hVm, &hAccessRights ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlVm_UpdateSecurity( hVm, hAccessRights );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVm_InstallTools(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVm_InstallTools" , &hVm ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlVm_InstallTools( hVm );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVm_GetToolsState(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVm_GetToolsState" , &hVm ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlVm_GetToolsState( hVm );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDev_Create(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_INT32	nDeviceType = (PRL_INT32 )0;

		if ( ! PyArg_ParseTuple( args, "i:PrlVmDev_Create" , &nDeviceType ) )
			break;

		PRL_HANDLE	rhVmDevice = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDev_Create( (PRL_DEVICE_TYPE )nDeviceType, &rhVmDevice );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhVmDevice )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDev_Connect(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmDev_Connect" , &hVmDev ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlVmDev_Connect( hVmDev );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDev_Disconnect(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmDev_Disconnect" , &hVmDev ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlVmDev_Disconnect( hVmDev );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDev_CreateImage(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;
		PRL_BOOL	bRecreateIsAllowed = (PRL_BOOL )0;
		PRL_BOOL	bNonInteractiveMode = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kII:PrlVmDev_CreateImage" , &hVmDev, &bRecreateIsAllowed, &bNonInteractiveMode ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlVmDev_CreateImage( hVmDev, bRecreateIsAllowed, bNonInteractiveMode );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDev_CopyImage(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;
		PRL_CONST_STR	sNewImageName = (PRL_CONST_STR )0;
		PRL_CONST_STR	sTargetPath = (PRL_CONST_STR )0;
		PRL_UINT32	nFlags = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kssI:PrlVmDev_CopyImage" , &hVmDev, &sNewImageName, &sTargetPath, &nFlags ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlVmDev_CopyImage( hVmDev, sNewImageName, sTargetPath, nFlags );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDev_ResizeImage(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;
		PRL_UINT32	nNewSize = (PRL_UINT32 )0;
		PRL_UINT32	nFlags = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kII:PrlVmDev_ResizeImage" , &hVmDev, &nNewSize, &nFlags ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlVmDev_ResizeImage( hVmDev, nNewSize, nFlags );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDev_GetIndex(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmDev_GetIndex" , &hVmDev ) )
			break;

		PRL_UINT32	rnIndex = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDev_GetIndex( hVmDev, &rnIndex );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnIndex )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDev_SetIndex(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;
		PRL_UINT32	nIndex = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmDev_SetIndex" , &hVmDev, &nIndex ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDev_SetIndex( hVmDev, nIndex );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDev_Remove(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmDev_Remove" , &hVmDev ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDev_Remove( hVmDev );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDev_GetType(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmDev_GetType" , &hVmDev ) )
			break;

		PRL_DEVICE_TYPE	rnDeviceType = (PRL_DEVICE_TYPE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDev_GetType( hVmDev, &rnDeviceType );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "i", rnDeviceType )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDev_IsConnected(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmDev_IsConnected" , &hVmDev ) )
			break;

		PRL_BOOL	rbConnected = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDev_IsConnected( hVmDev, &rbConnected );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbConnected )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDev_SetConnected(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;
		PRL_BOOL	bConnected = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmDev_SetConnected" , &hVmDev, &bConnected ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDev_SetConnected( hVmDev, bConnected );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDev_IsEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmDev_IsEnabled" , &hVmDev ) )
			break;

		PRL_BOOL	rbEnabled = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDev_IsEnabled( hVmDev, &rbEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbEnabled )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDev_SetEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;
		PRL_BOOL	bEnabled = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmDev_SetEnabled" , &hVmDev, &bEnabled ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDev_SetEnabled( hVmDev, bEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDev_IsRemote(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmDev_IsRemote" , &hVmDev ) )
			break;

		PRL_BOOL	rbRemote = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDev_IsRemote( hVmDev, &rbRemote );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbRemote )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDev_SetRemote(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;
		PRL_BOOL	bRemote = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmDev_SetRemote" , &hVmDev, &bRemote ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDev_SetRemote( hVmDev, bRemote );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDev_GetEmulatedType(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmDev_GetEmulatedType" , &hVmDev ) )
			break;

		PRL_VM_DEV_EMULATION_TYPE	rnEmulatedType = (PRL_VM_DEV_EMULATION_TYPE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDev_GetEmulatedType( hVmDev, &rnEmulatedType );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "i", rnEmulatedType )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDev_SetEmulatedType(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;
		PRL_INT32	nEmulatedType = (PRL_INT32 )0;

		if ( ! PyArg_ParseTuple( args, "ki:PrlVmDev_SetEmulatedType" , &hVmDev, &nEmulatedType ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDev_SetEmulatedType( hVmDev, (PRL_VM_DEV_EMULATION_TYPE )nEmulatedType );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDev_GetImagePath(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmDev_GetImagePath" , &hVmDev ) )
			break;

		PRL_STR	sImagePath = (PRL_STR )0;
		PRL_UINT32	rnImagePathBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDev_GetImagePath( hVmDev, sImagePath, &rnImagePathBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sImagePath(rnImagePathBufLength, '\0');
		sImagePath = (PRL_STR )std_sImagePath.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDev_GetImagePath( hVmDev, sImagePath, &rnImagePathBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sImagePath )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDev_SetImagePath(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;
		PRL_CONST_STR	sNewImagePath = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ks:PrlVmDev_SetImagePath" , &hVmDev, &sNewImagePath ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDev_SetImagePath( hVmDev, sNewImagePath );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDev_GetSysName(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmDev_GetSysName" , &hVmDev ) )
			break;

		PRL_STR	sSysName = (PRL_STR )0;
		PRL_UINT32	rnSysNameBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDev_GetSysName( hVmDev, sSysName, &rnSysNameBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sSysName(rnSysNameBufLength, '\0');
		sSysName = (PRL_STR )std_sSysName.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDev_GetSysName( hVmDev, sSysName, &rnSysNameBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sSysName )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDev_SetSysName(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;
		PRL_CONST_STR	sNewSysName = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ks:PrlVmDev_SetSysName" , &hVmDev, &sNewSysName ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDev_SetSysName( hVmDev, sNewSysName );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDev_GetFriendlyName(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmDev_GetFriendlyName" , &hVmDev ) )
			break;

		PRL_STR	sFriendlyName = (PRL_STR )0;
		PRL_UINT32	rnFriendlyNameBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDev_GetFriendlyName( hVmDev, sFriendlyName, &rnFriendlyNameBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sFriendlyName(rnFriendlyNameBufLength, '\0');
		sFriendlyName = (PRL_STR )std_sFriendlyName.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDev_GetFriendlyName( hVmDev, sFriendlyName, &rnFriendlyNameBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sFriendlyName )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDev_SetFriendlyName(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;
		PRL_CONST_STR	sNewFriendlyName = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ks:PrlVmDev_SetFriendlyName" , &hVmDev, &sNewFriendlyName ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDev_SetFriendlyName( hVmDev, sNewFriendlyName );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDev_GetDescription(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmDev_GetDescription" , &hVmDev ) )
			break;

		PRL_STR	sDescription = (PRL_STR )0;
		PRL_UINT32	rnDescriptionBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDev_GetDescription( hVmDev, sDescription, &rnDescriptionBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sDescription(rnDescriptionBufLength, '\0');
		sDescription = (PRL_STR )std_sDescription.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDev_GetDescription( hVmDev, sDescription, &rnDescriptionBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sDescription )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDev_SetDescription(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;
		PRL_CONST_STR	sNewDescription = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ks:PrlVmDev_SetDescription" , &hVmDev, &sNewDescription ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDev_SetDescription( hVmDev, sNewDescription );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDev_GetIfaceType(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmDev_GetIfaceType" , &hVmDev ) )
			break;

		PRL_MASS_STORAGE_INTERFACE_TYPE	rnIfaceType = (PRL_MASS_STORAGE_INTERFACE_TYPE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDev_GetIfaceType( hVmDev, &rnIfaceType );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "i", rnIfaceType )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDev_SetIfaceType(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;
		PRL_INT32	nIfaceType = (PRL_INT32 )0;

		if ( ! PyArg_ParseTuple( args, "ki:PrlVmDev_SetIfaceType" , &hVmDev, &nIfaceType ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDev_SetIfaceType( hVmDev, (PRL_MASS_STORAGE_INTERFACE_TYPE )nIfaceType );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDev_GetSubType(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmDev_GetSubType" , &hVmDev ) )
			break;

		PRL_CLUSTERED_DEVICE_SUBTYPE	rnSubType = (PRL_CLUSTERED_DEVICE_SUBTYPE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDev_GetSubType( hVmDev, &rnSubType );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "i", rnSubType )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDev_SetSubType(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;
		PRL_INT32	nSubType = (PRL_INT32 )0;

		if ( ! PyArg_ParseTuple( args, "ki:PrlVmDev_SetSubType" , &hVmDev, &nSubType ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDev_SetSubType( hVmDev, (PRL_CLUSTERED_DEVICE_SUBTYPE )nSubType );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDev_GetStackIndex(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmDev_GetStackIndex" , &hVmDev ) )
			break;

		PRL_UINT32	rnStackIndex = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDev_GetStackIndex( hVmDev, &rnStackIndex );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnStackIndex )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDev_SetStackIndex(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;
		PRL_UINT32	nStackIndex = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmDev_SetStackIndex" , &hVmDev, &nStackIndex ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDev_SetStackIndex( hVmDev, nStackIndex );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDev_SetDefaultStackIndex(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmDev_SetDefaultStackIndex" , &hVmDev ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDev_SetDefaultStackIndex( hVmDev );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDev_GetOutputFile(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmDev_GetOutputFile" , &hVmDev ) )
			break;

		PRL_STR	sOutputFile = (PRL_STR )0;
		PRL_UINT32	rnOutputFileBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDev_GetOutputFile( hVmDev, sOutputFile, &rnOutputFileBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sOutputFile(rnOutputFileBufLength, '\0');
		sOutputFile = (PRL_STR )std_sOutputFile.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDev_GetOutputFile( hVmDev, sOutputFile, &rnOutputFileBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sOutputFile )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDev_SetOutputFile(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;
		PRL_CONST_STR	sNewOutputFile = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ks:PrlVmDev_SetOutputFile" , &hVmDev, &sNewOutputFile ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDev_SetOutputFile( hVmDev, sNewOutputFile );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDev_IsPassthrough(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmDev_IsPassthrough" , &hVmDev ) )
			break;

		PRL_BOOL	rbPassthrough = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDev_IsPassthrough( hVmDev, &rbPassthrough );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbPassthrough )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDev_SetPassthrough(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;
		PRL_BOOL	bPassthrough = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmDev_SetPassthrough" , &hVmDev, &bPassthrough ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDev_SetPassthrough( hVmDev, bPassthrough );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDevHd_GetDiskType(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmDevHd_GetDiskType" , &hVmDev ) )
			break;

		PRL_HARD_DISK_INTERNAL_FORMAT	rnDiskType = (PRL_HARD_DISK_INTERNAL_FORMAT )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDevHd_GetDiskType( hVmDev, &rnDiskType );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "i", rnDiskType )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDevHd_SetDiskType(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;
		PRL_INT32	nDiskType = (PRL_INT32 )0;

		if ( ! PyArg_ParseTuple( args, "ki:PrlVmDevHd_SetDiskType" , &hVmDev, &nDiskType ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDevHd_SetDiskType( hVmDev, (PRL_HARD_DISK_INTERNAL_FORMAT )nDiskType );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDevHd_IsSplitted(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmDevHd_IsSplitted" , &hVmDev ) )
			break;

		PRL_BOOL	rbSplitted = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDevHd_IsSplitted( hVmDev, &rbSplitted );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbSplitted )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDevHd_SetSplitted(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;
		PRL_BOOL	bSplitted = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmDevHd_SetSplitted" , &hVmDev, &bSplitted ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDevHd_SetSplitted( hVmDev, bSplitted );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDevHd_GetDiskSize(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmDevHd_GetDiskSize" , &hVmDev ) )
			break;

		PRL_UINT32	rnDiskSize = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDevHd_GetDiskSize( hVmDev, &rnDiskSize );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnDiskSize )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDevHd_SetDiskSize(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;
		PRL_UINT32	nDiskSize = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmDevHd_SetDiskSize" , &hVmDev, &nDiskSize ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDevHd_SetDiskSize( hVmDev, nDiskSize );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDevHd_GetSizeOnDisk(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmDevHd_GetSizeOnDisk" , &hVmDev ) )
			break;

		PRL_UINT32	rnOnDiskSize = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDevHd_GetSizeOnDisk( hVmDev, &rnOnDiskSize );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnOnDiskSize )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDevHd_AddPartition(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmDevHd_AddPartition" , &hVmDev ) )
			break;

		PRL_HANDLE	rhPartition = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDevHd_AddPartition( hVmDev, &rhPartition );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhPartition )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDevHd_GetPartitionsCount(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmDevHd_GetPartitionsCount" , &hVmDev ) )
			break;

		PRL_UINT32	rnPartitionsCount = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDevHd_GetPartitionsCount( hVmDev, &rnPartitionsCount );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnPartitionsCount )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDevHd_GetPartition(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;
		PRL_UINT32	nIndex = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmDevHd_GetPartition" , &hVmDev, &nIndex ) )
			break;

		PRL_HANDLE	rhPartition = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDevHd_GetPartition( hVmDev, nIndex, &rhPartition );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhPartition )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDevHdPart_Remove(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hPartition = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmDevHdPart_Remove" , &hPartition ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDevHdPart_Remove( hPartition );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDevHd_SetMountPoint(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;
		PRL_CONST_STR	sMountPoint = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ks:PrlVmDevHd_SetMountPoint" , &hVmDev, &sMountPoint ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDevHd_SetMountPoint( hVmDev, sMountPoint );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDevHd_GetMountPoint(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmDevHd_GetMountPoint" , &hVmDev ) )
			break;

		PRL_STR	sMountPoint = (PRL_STR )0;
		PRL_UINT32	rnMountPointBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDevHd_GetMountPoint( hVmDev, sMountPoint, &rnMountPointBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sMountPoint(rnMountPointBufLength, '\0');
		sMountPoint = (PRL_STR )std_sMountPoint.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDevHd_GetMountPoint( hVmDev, sMountPoint, &rnMountPointBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sMountPoint )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDevHd_SetAutoCompressEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;
		PRL_BOOL	bEnabled = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmDevHd_SetAutoCompressEnabled" , &hVmDev, &bEnabled ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDevHd_SetAutoCompressEnabled( hVmDev, bEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDevHd_IsAutoCompressEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmDevHd_IsAutoCompressEnabled" , &hVmDev ) )
			break;

		PRL_BOOL	rbEnabled = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDevHd_IsAutoCompressEnabled( hVmDev, &rbEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbEnabled )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDevHd_SetStorageURL(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;
		PRL_CONST_STR	sURL = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ks:PrlVmDevHd_SetStorageURL" , &hVmDev, &sURL ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDevHd_SetStorageURL( hVmDev, sURL );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDevHd_GetStorageURL(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmDevHd_GetStorageURL" , &hVmDev ) )
			break;

		PRL_STR	sURL = (PRL_STR )0;
		PRL_UINT32	rnURLBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDevHd_GetStorageURL( hVmDev, sURL, &rnURLBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sURL(rnURLBufLength, '\0');
		sURL = (PRL_STR )std_sURL.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDevHd_GetStorageURL( hVmDev, sURL, &rnURLBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sURL )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDevHdPart_GetSysName(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hPartition = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmDevHdPart_GetSysName" , &hPartition ) )
			break;

		PRL_STR	sSysName = (PRL_STR )0;
		PRL_UINT32	rnSysNameBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDevHdPart_GetSysName( hPartition, sSysName, &rnSysNameBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sSysName(rnSysNameBufLength, '\0');
		sSysName = (PRL_STR )std_sSysName.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDevHdPart_GetSysName( hPartition, sSysName, &rnSysNameBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sSysName )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDevHdPart_SetSysName(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hPartition = (PRL_HANDLE )0;
		PRL_CONST_STR	sSysName = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ks:PrlVmDevHdPart_SetSysName" , &hPartition, &sSysName ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDevHdPart_SetSysName( hPartition, sSysName );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDevNet_GetBoundAdapterIndex(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmDevNet_GetBoundAdapterIndex" , &hVmDev ) )
			break;

		PRL_INT32	rnIndex = (PRL_INT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDevNet_GetBoundAdapterIndex( hVmDev, &rnIndex );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "i", rnIndex )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDevNet_SetBoundAdapterIndex(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;
		PRL_INT32	nIndex = (PRL_INT32 )0;

		if ( ! PyArg_ParseTuple( args, "ki:PrlVmDevNet_SetBoundAdapterIndex" , &hVmDev, &nIndex ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDevNet_SetBoundAdapterIndex( hVmDev, nIndex );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDevNet_GetBoundAdapterName(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmDevNet_GetBoundAdapterName" , &hVmDev ) )
			break;

		PRL_STR	sBoundAdapterName = (PRL_STR )0;
		PRL_UINT32	rnBoundAdapterNameBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDevNet_GetBoundAdapterName( hVmDev, sBoundAdapterName, &rnBoundAdapterNameBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sBoundAdapterName(rnBoundAdapterNameBufLength, '\0');
		sBoundAdapterName = (PRL_STR )std_sBoundAdapterName.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDevNet_GetBoundAdapterName( hVmDev, sBoundAdapterName, &rnBoundAdapterNameBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sBoundAdapterName )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDevNet_SetBoundAdapterName(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;
		PRL_CONST_STR	sNewBoundAdapterName = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ks:PrlVmDevNet_SetBoundAdapterName" , &hVmDev, &sNewBoundAdapterName ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDevNet_SetBoundAdapterName( hVmDev, sNewBoundAdapterName );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDevNet_GetMacAddress(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmDevNet_GetMacAddress" , &hVmDev ) )
			break;

		PRL_STR	sMacAddress = (PRL_STR )0;
		PRL_UINT32	rnMacAddressBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDevNet_GetMacAddress( hVmDev, sMacAddress, &rnMacAddressBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sMacAddress(rnMacAddressBufLength, '\0');
		sMacAddress = (PRL_STR )std_sMacAddress.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDevNet_GetMacAddress( hVmDev, sMacAddress, &rnMacAddressBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sMacAddress )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDevNet_GetMacAddressCanonical(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmDevNet_GetMacAddressCanonical" , &hVmDev ) )
			break;

		PRL_STR	sMacAddress = (PRL_STR )0;
		PRL_UINT32	rnMacAddressBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDevNet_GetMacAddressCanonical( hVmDev, sMacAddress, &rnMacAddressBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sMacAddress(rnMacAddressBufLength, '\0');
		sMacAddress = (PRL_STR )std_sMacAddress.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDevNet_GetMacAddressCanonical( hVmDev, sMacAddress, &rnMacAddressBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sMacAddress )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDevNet_SetMacAddress(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;
		PRL_CONST_STR	sNewMacAddress = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ks:PrlVmDevNet_SetMacAddress" , &hVmDev, &sNewMacAddress ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDevNet_SetMacAddress( hVmDev, sNewMacAddress );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDevNet_GenerateMacAddr(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmDevNet_GenerateMacAddr" , &hVmDev ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDevNet_GenerateMacAddr( hVmDev );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDevNet_IsAutoApply(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmDevNet_IsAutoApply" , &hVmDev ) )
			break;

		PRL_BOOL	rbAutoApply = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDevNet_IsAutoApply( hVmDev, &rbAutoApply );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbAutoApply )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDevNet_SetAutoApply(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;
		PRL_BOOL	bAutoApply = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmDevNet_SetAutoApply" , &hVmDev, &bAutoApply ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDevNet_SetAutoApply( hVmDev, bAutoApply );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDevNet_GetNetAddresses(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmDevNet_GetNetAddresses" , &hVmDev ) )
			break;

		PRL_HANDLE	rhNetAddressesList = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDevNet_GetNetAddresses( hVmDev, &rhNetAddressesList );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhNetAddressesList )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDevNet_SetNetAddresses(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;
		PRL_HANDLE	hNetAddressesList = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "kk:PrlVmDevNet_SetNetAddresses" , &hVmDev, &hNetAddressesList ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDevNet_SetNetAddresses( hVmDev, hNetAddressesList );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDevNet_GetDnsServers(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmDevNet_GetDnsServers" , &hVmDev ) )
			break;

		PRL_HANDLE	rhDnsServersList = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDevNet_GetDnsServers( hVmDev, &rhDnsServersList );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhDnsServersList )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDevNet_SetDnsServers(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;
		PRL_HANDLE	hDnsServersList = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "kk:PrlVmDevNet_SetDnsServers" , &hVmDev, &hDnsServersList ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDevNet_SetDnsServers( hVmDev, hDnsServersList );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDevNet_GetSearchDomains(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmDevNet_GetSearchDomains" , &hVmDev ) )
			break;

		PRL_HANDLE	rhSearchDomainsList = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDevNet_GetSearchDomains( hVmDev, &rhSearchDomainsList );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhSearchDomainsList )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDevNet_SetSearchDomains(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;
		PRL_HANDLE	hSearchDomainsList = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "kk:PrlVmDevNet_SetSearchDomains" , &hVmDev, &hSearchDomainsList ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDevNet_SetSearchDomains( hVmDev, hSearchDomainsList );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDevNet_IsConfigureWithDhcp(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmDevNet_IsConfigureWithDhcp" , &hVmDev ) )
			break;

		PRL_BOOL	rbConfigureWithDhcp = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDevNet_IsConfigureWithDhcp( hVmDev, &rbConfigureWithDhcp );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbConfigureWithDhcp )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDevNet_SetConfigureWithDhcp(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;
		PRL_BOOL	bConfigureWithDhcp = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmDevNet_SetConfigureWithDhcp" , &hVmDev, &bConfigureWithDhcp ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDevNet_SetConfigureWithDhcp( hVmDev, bConfigureWithDhcp );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDevNet_IsConfigureWithDhcpIPv6(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmDevNet_IsConfigureWithDhcpIPv6" , &hVmDev ) )
			break;

		PRL_BOOL	rbConfigureWithDhcp = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDevNet_IsConfigureWithDhcpIPv6( hVmDev, &rbConfigureWithDhcp );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbConfigureWithDhcp )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDevNet_SetConfigureWithDhcpIPv6(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;
		PRL_BOOL	bConfigureWithDhcp = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmDevNet_SetConfigureWithDhcpIPv6" , &hVmDev, &bConfigureWithDhcp ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDevNet_SetConfigureWithDhcpIPv6( hVmDev, bConfigureWithDhcp );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDevNet_GetDefaultGateway(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmDevNet_GetDefaultGateway" , &hVmDev ) )
			break;

		PRL_STR	sDefaultGateway = (PRL_STR )0;
		PRL_UINT32	rnDefaultGatewayBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDevNet_GetDefaultGateway( hVmDev, sDefaultGateway, &rnDefaultGatewayBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sDefaultGateway(rnDefaultGatewayBufLength, '\0');
		sDefaultGateway = (PRL_STR )std_sDefaultGateway.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDevNet_GetDefaultGateway( hVmDev, sDefaultGateway, &rnDefaultGatewayBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sDefaultGateway )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDevNet_SetDefaultGateway(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;
		PRL_CONST_STR	sNewDefaultGateway = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ks:PrlVmDevNet_SetDefaultGateway" , &hVmDev, &sNewDefaultGateway ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDevNet_SetDefaultGateway( hVmDev, sNewDefaultGateway );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDevNet_GetDefaultGatewayIPv6(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmDevNet_GetDefaultGatewayIPv6" , &hVmDev ) )
			break;

		PRL_STR	sDefaultGateway = (PRL_STR )0;
		PRL_UINT32	rnDefaultGatewayBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDevNet_GetDefaultGatewayIPv6( hVmDev, sDefaultGateway, &rnDefaultGatewayBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sDefaultGateway(rnDefaultGatewayBufLength, '\0');
		sDefaultGateway = (PRL_STR )std_sDefaultGateway.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDevNet_GetDefaultGatewayIPv6( hVmDev, sDefaultGateway, &rnDefaultGatewayBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sDefaultGateway )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDevNet_SetDefaultGatewayIPv6(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;
		PRL_CONST_STR	sNewDefaultGateway = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ks:PrlVmDevNet_SetDefaultGatewayIPv6" , &hVmDev, &sNewDefaultGateway ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDevNet_SetDefaultGatewayIPv6( hVmDev, sNewDefaultGateway );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDevNet_GetVirtualNetworkId(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmDevNet_GetVirtualNetworkId" , &hVmDev ) )
			break;

		PRL_STR	sVirtualNetworkId = (PRL_STR )0;
		PRL_UINT32	rnVirtualNetworkIdBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDevNet_GetVirtualNetworkId( hVmDev, sVirtualNetworkId, &rnVirtualNetworkIdBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sVirtualNetworkId(rnVirtualNetworkIdBufLength, '\0');
		sVirtualNetworkId = (PRL_STR )std_sVirtualNetworkId.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDevNet_GetVirtualNetworkId( hVmDev, sVirtualNetworkId, &rnVirtualNetworkIdBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sVirtualNetworkId )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDevNet_SetVirtualNetworkId(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;
		PRL_CONST_STR	sNewVirtualNetworkId = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ks:PrlVmDevNet_SetVirtualNetworkId" , &hVmDev, &sNewVirtualNetworkId ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDevNet_SetVirtualNetworkId( hVmDev, sNewVirtualNetworkId );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDevNet_GetAdapterType(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmDevNet_GetAdapterType" , &hVmDev ) )
			break;

		PRL_VM_NET_ADAPTER_TYPE	rnAdapterType = (PRL_VM_NET_ADAPTER_TYPE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDevNet_GetAdapterType( hVmDev, &rnAdapterType );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "i", rnAdapterType )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDevNet_SetAdapterType(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;
		PRL_INT32	nAdapterType = (PRL_INT32 )0;

		if ( ! PyArg_ParseTuple( args, "ki:PrlVmDevNet_SetAdapterType" , &hVmDev, &nAdapterType ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDevNet_SetAdapterType( hVmDev, (PRL_VM_NET_ADAPTER_TYPE )nAdapterType );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDevNet_IsPktFilterPreventMacSpoof(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmDevNet_IsPktFilterPreventMacSpoof" , &hVmDev ) )
			break;

		PRL_BOOL	rbPktFilterPreventMacSpoof = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDevNet_IsPktFilterPreventMacSpoof( hVmDev, &rbPktFilterPreventMacSpoof );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbPktFilterPreventMacSpoof )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDevNet_SetPktFilterPreventMacSpoof(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;
		PRL_BOOL	bPktFilterPreventMacSpoof = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmDevNet_SetPktFilterPreventMacSpoof" , &hVmDev, &bPktFilterPreventMacSpoof ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDevNet_SetPktFilterPreventMacSpoof( hVmDev, bPktFilterPreventMacSpoof );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDevNet_IsPktFilterPreventPromisc(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmDevNet_IsPktFilterPreventPromisc" , &hVmDev ) )
			break;

		PRL_BOOL	rbPktFilterPreventPromisc = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDevNet_IsPktFilterPreventPromisc( hVmDev, &rbPktFilterPreventPromisc );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbPktFilterPreventPromisc )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDevNet_SetPktFilterPreventPromisc(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;
		PRL_BOOL	bPktFilterPreventPromisc = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmDevNet_SetPktFilterPreventPromisc" , &hVmDev, &bPktFilterPreventPromisc ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDevNet_SetPktFilterPreventPromisc( hVmDev, bPktFilterPreventPromisc );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDevNet_IsPktFilterPreventIpSpoof(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmDevNet_IsPktFilterPreventIpSpoof" , &hVmDev ) )
			break;

		PRL_BOOL	rbPktFilterPreventIpSpoof = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDevNet_IsPktFilterPreventIpSpoof( hVmDev, &rbPktFilterPreventIpSpoof );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbPktFilterPreventIpSpoof )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDevNet_SetPktFilterPreventIpSpoof(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;
		PRL_BOOL	bPktFilterPreventIpSpoof = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmDevNet_SetPktFilterPreventIpSpoof" , &hVmDev, &bPktFilterPreventIpSpoof ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDevNet_SetPktFilterPreventIpSpoof( hVmDev, bPktFilterPreventIpSpoof );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDevNet_IsFirewallEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmDevNet_IsFirewallEnabled" , &hVmDev ) )
			break;

		PRL_BOOL	rbEnabled = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDevNet_IsFirewallEnabled( hVmDev, &rbEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbEnabled )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDevNet_SetFirewallEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;
		PRL_BOOL	bEnabled = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmDevNet_SetFirewallEnabled" , &hVmDev, &bEnabled ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDevNet_SetFirewallEnabled( hVmDev, bEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDevNet_GetFirewallDefaultPolicy(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;
		PRL_INT32	nDirection = (PRL_INT32 )0;

		if ( ! PyArg_ParseTuple( args, "ki:PrlVmDevNet_GetFirewallDefaultPolicy" , &hVmDev, &nDirection ) )
			break;

		PRL_FIREWALL_POLICY	rnPolicy = (PRL_FIREWALL_POLICY )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDevNet_GetFirewallDefaultPolicy( hVmDev, (PRL_FIREWALL_DIRECTION )nDirection, &rnPolicy );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "i", rnPolicy )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDevNet_SetFirewallDefaultPolicy(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;
		PRL_INT32	nDirection = (PRL_INT32 )0;
		PRL_INT32	nPolicy = (PRL_INT32 )0;

		if ( ! PyArg_ParseTuple( args, "kii:PrlVmDevNet_SetFirewallDefaultPolicy" , &hVmDev, &nDirection, &nPolicy ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDevNet_SetFirewallDefaultPolicy( hVmDev, (PRL_FIREWALL_DIRECTION )nDirection, (PRL_FIREWALL_POLICY )nPolicy );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDevNet_GetFirewallRuleList(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;
		PRL_INT32	nDirection = (PRL_INT32 )0;

		if ( ! PyArg_ParseTuple( args, "ki:PrlVmDevNet_GetFirewallRuleList" , &hVmDev, &nDirection ) )
			break;

		PRL_HANDLE	rhRuleList = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDevNet_GetFirewallRuleList( hVmDev, (PRL_FIREWALL_DIRECTION )nDirection, &rhRuleList );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhRuleList )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDevNet_SetFirewallRuleList(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;
		PRL_INT32	nDirection = (PRL_INT32 )0;
		PRL_HANDLE	hRuleList = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "kik:PrlVmDevNet_SetFirewallRuleList" , &hVmDev, &nDirection, &hRuleList ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDevNet_SetFirewallRuleList( hVmDev, (PRL_FIREWALL_DIRECTION )nDirection, hRuleList );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDevNet_GetHostInterfaceName(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmDevNet_GetHostInterfaceName" , &hVmDev ) )
			break;

		PRL_STR	sHostInterfaceName = (PRL_STR )0;
		PRL_UINT32	rnHostInterfaceNameBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDevNet_GetHostInterfaceName( hVmDev, sHostInterfaceName, &rnHostInterfaceNameBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sHostInterfaceName(rnHostInterfaceNameBufLength, '\0');
		sHostInterfaceName = (PRL_STR )std_sHostInterfaceName.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDevNet_GetHostInterfaceName( hVmDev, sHostInterfaceName, &rnHostInterfaceNameBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sHostInterfaceName )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDevNet_SetHostInterfaceName(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;
		PRL_CONST_STR	sNewHostInterfaceName = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ks:PrlVmDevNet_SetHostInterfaceName" , &hVmDev, &sNewHostInterfaceName ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDevNet_SetHostInterfaceName( hVmDev, sNewHostInterfaceName );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlFirewallRule_Create(PyObject* /*self*/, PyObject* )
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	rhRule = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlFirewallRule_Create( &rhRule );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhRule )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlFirewallRule_GetLocalPort(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hRule = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlFirewallRule_GetLocalPort" , &hRule ) )
			break;

		PRL_UINT32	rnPort = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlFirewallRule_GetLocalPort( hRule, &rnPort );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnPort )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlFirewallRule_SetLocalPort(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hRule = (PRL_HANDLE )0;
		PRL_UINT32	nPort = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlFirewallRule_SetLocalPort" , &hRule, &nPort ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlFirewallRule_SetLocalPort( hRule, nPort );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlFirewallRule_GetRemotePort(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hRule = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlFirewallRule_GetRemotePort" , &hRule ) )
			break;

		PRL_UINT32	rnPort = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlFirewallRule_GetRemotePort( hRule, &rnPort );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnPort )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlFirewallRule_SetRemotePort(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hRule = (PRL_HANDLE )0;
		PRL_UINT32	nPort = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlFirewallRule_SetRemotePort" , &hRule, &nPort ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlFirewallRule_SetRemotePort( hRule, nPort );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlFirewallRule_GetProtocol(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hRule = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlFirewallRule_GetProtocol" , &hRule ) )
			break;

		PRL_STR	sProtocol = (PRL_STR )0;
		PRL_UINT32	rnBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlFirewallRule_GetProtocol( hRule, sProtocol, &rnBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sProtocol(rnBufLength, '\0');
		sProtocol = (PRL_STR )std_sProtocol.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlFirewallRule_GetProtocol( hRule, sProtocol, &rnBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sProtocol )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlFirewallRule_SetProtocol(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hRule = (PRL_HANDLE )0;
		PRL_CONST_STR	sProtocol = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ks:PrlFirewallRule_SetProtocol" , &hRule, &sProtocol ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlFirewallRule_SetProtocol( hRule, sProtocol );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlFirewallRule_GetLocalNetAddress(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hRule = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlFirewallRule_GetLocalNetAddress" , &hRule ) )
			break;

		PRL_STR	sAddr = (PRL_STR )0;
		PRL_UINT32	rnBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlFirewallRule_GetLocalNetAddress( hRule, sAddr, &rnBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sAddr(rnBufLength, '\0');
		sAddr = (PRL_STR )std_sAddr.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlFirewallRule_GetLocalNetAddress( hRule, sAddr, &rnBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sAddr )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlFirewallRule_SetLocalNetAddress(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hRule = (PRL_HANDLE )0;
		PRL_CONST_STR	sAddr = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ks:PrlFirewallRule_SetLocalNetAddress" , &hRule, &sAddr ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlFirewallRule_SetLocalNetAddress( hRule, sAddr );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlFirewallRule_GetRemoteNetAddress(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hRule = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlFirewallRule_GetRemoteNetAddress" , &hRule ) )
			break;

		PRL_STR	sAddr = (PRL_STR )0;
		PRL_UINT32	rnBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlFirewallRule_GetRemoteNetAddress( hRule, sAddr, &rnBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sAddr(rnBufLength, '\0');
		sAddr = (PRL_STR )std_sAddr.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlFirewallRule_GetRemoteNetAddress( hRule, sAddr, &rnBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sAddr )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlFirewallRule_SetRemoteNetAddress(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hRule = (PRL_HANDLE )0;
		PRL_CONST_STR	sAddr = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ks:PrlFirewallRule_SetRemoteNetAddress" , &hRule, &sAddr ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlFirewallRule_SetRemoteNetAddress( hRule, sAddr );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDevUsb_GetAutoconnectOption(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmDevUsb_GetAutoconnectOption" , &hVmDev ) )
			break;

		PRL_USB_DEVICE_AUTO_CONNECT_OPTION	rnAutoconnectOption = (PRL_USB_DEVICE_AUTO_CONNECT_OPTION )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDevUsb_GetAutoconnectOption( hVmDev, &rnAutoconnectOption );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "i", rnAutoconnectOption )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDevUsb_SetAutoconnectOption(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;
		PRL_INT32	nAutoconnectOption = (PRL_INT32 )0;

		if ( ! PyArg_ParseTuple( args, "ki:PrlVmDevUsb_SetAutoconnectOption" , &hVmDev, &nAutoconnectOption ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDevUsb_SetAutoconnectOption( hVmDev, (PRL_USB_DEVICE_AUTO_CONNECT_OPTION )nAutoconnectOption );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDevSound_GetOutputDev(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmDevSound_GetOutputDev" , &hVmDev ) )
			break;

		PRL_STR	sOutputDev = (PRL_STR )0;
		PRL_UINT32	rnOutputDevBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDevSound_GetOutputDev( hVmDev, sOutputDev, &rnOutputDevBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sOutputDev(rnOutputDevBufLength, '\0');
		sOutputDev = (PRL_STR )std_sOutputDev.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDevSound_GetOutputDev( hVmDev, sOutputDev, &rnOutputDevBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sOutputDev )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDevSound_SetOutputDev(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;
		PRL_CONST_STR	sNewOutputDev = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ks:PrlVmDevSound_SetOutputDev" , &hVmDev, &sNewOutputDev ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDevSound_SetOutputDev( hVmDev, sNewOutputDev );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDevSound_GetMixerDev(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmDevSound_GetMixerDev" , &hVmDev ) )
			break;

		PRL_STR	sMixerDev = (PRL_STR )0;
		PRL_UINT32	rnMixerDevBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDevSound_GetMixerDev( hVmDev, sMixerDev, &rnMixerDevBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sMixerDev(rnMixerDevBufLength, '\0');
		sMixerDev = (PRL_STR )std_sMixerDev.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDevSound_GetMixerDev( hVmDev, sMixerDev, &rnMixerDevBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sMixerDev )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDevSound_SetMixerDev(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;
		PRL_CONST_STR	sNewMixerDev = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ks:PrlVmDevSound_SetMixerDev" , &hVmDev, &sNewMixerDev ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDevSound_SetMixerDev( hVmDev, sNewMixerDev );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDevSerial_GetSocketMode(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmDevSerial_GetSocketMode" , &hVmDev ) )
			break;

		PRL_SERIAL_PORT_SOCKET_OPERATION_MODE	rnSocketMode = (PRL_SERIAL_PORT_SOCKET_OPERATION_MODE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDevSerial_GetSocketMode( hVmDev, &rnSocketMode );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "i", rnSocketMode )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmDevSerial_SetSocketMode(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmDev = (PRL_HANDLE )0;
		PRL_INT32	nSocketMode = (PRL_INT32 )0;

		if ( ! PyArg_ParseTuple( args, "ki:PrlVmDevSerial_SetSocketMode" , &hVmDev, &nSocketMode ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmDevSerial_SetSocketMode( hVmDev, (PRL_SERIAL_PORT_SOCKET_OPERATION_MODE )nSocketMode );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlShare_Remove(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmShare = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlShare_Remove" , &hVmShare ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlShare_Remove( hVmShare );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlShare_GetName(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmShare = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlShare_GetName" , &hVmShare ) )
			break;

		PRL_STR	sShareName = (PRL_STR )0;
		PRL_UINT32	rnShareNameBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlShare_GetName( hVmShare, sShareName, &rnShareNameBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sShareName(rnShareNameBufLength, '\0');
		sShareName = (PRL_STR )std_sShareName.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlShare_GetName( hVmShare, sShareName, &rnShareNameBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sShareName )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlShare_SetName(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmShare = (PRL_HANDLE )0;
		PRL_CONST_STR	sNewShareName = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ks:PrlShare_SetName" , &hVmShare, &sNewShareName ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlShare_SetName( hVmShare, sNewShareName );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlShare_GetPath(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmShare = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlShare_GetPath" , &hVmShare ) )
			break;

		PRL_STR	sSharePath = (PRL_STR )0;
		PRL_UINT32	rnSharePathBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlShare_GetPath( hVmShare, sSharePath, &rnSharePathBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sSharePath(rnSharePathBufLength, '\0');
		sSharePath = (PRL_STR )std_sSharePath.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlShare_GetPath( hVmShare, sSharePath, &rnSharePathBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sSharePath )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlShare_SetPath(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmShare = (PRL_HANDLE )0;
		PRL_CONST_STR	sNewSharePath = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ks:PrlShare_SetPath" , &hVmShare, &sNewSharePath ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlShare_SetPath( hVmShare, sNewSharePath );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlShare_GetDescription(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmShare = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlShare_GetDescription" , &hVmShare ) )
			break;

		PRL_STR	sShareDescription = (PRL_STR )0;
		PRL_UINT32	rnShareDescriptionBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlShare_GetDescription( hVmShare, sShareDescription, &rnShareDescriptionBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sShareDescription(rnShareDescriptionBufLength, '\0');
		sShareDescription = (PRL_STR )std_sShareDescription.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlShare_GetDescription( hVmShare, sShareDescription, &rnShareDescriptionBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sShareDescription )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlShare_SetDescription(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmShare = (PRL_HANDLE )0;
		PRL_CONST_STR	sNewShareDescription = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ks:PrlShare_SetDescription" , &hVmShare, &sNewShareDescription ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlShare_SetDescription( hVmShare, sNewShareDescription );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlShare_IsEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmShare = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlShare_IsEnabled" , &hVmShare ) )
			break;

		PRL_BOOL	rbEnabled = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlShare_IsEnabled( hVmShare, &rbEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbEnabled )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlShare_SetEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmShare = (PRL_HANDLE )0;
		PRL_BOOL	bEnabled = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlShare_SetEnabled" , &hVmShare, &bEnabled ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlShare_SetEnabled( hVmShare, bEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlShare_IsReadOnly(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmShare = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlShare_IsReadOnly" , &hVmShare ) )
			break;

		PRL_BOOL	rbReadOnly = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlShare_IsReadOnly( hVmShare, &rbReadOnly );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbReadOnly )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlShare_SetReadOnly(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmShare = (PRL_HANDLE )0;
		PRL_BOOL	bReadOnly = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlShare_SetReadOnly" , &hVmShare, &bReadOnly ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlShare_SetReadOnly( hVmShare, bReadOnly );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlBootDev_Remove(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmBootDev = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlBootDev_Remove" , &hVmBootDev ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlBootDev_Remove( hVmBootDev );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlBootDev_GetType(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmBootDev = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlBootDev_GetType" , &hVmBootDev ) )
			break;

		PRL_DEVICE_TYPE	rnDevType = (PRL_DEVICE_TYPE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlBootDev_GetType( hVmBootDev, &rnDevType );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "i", rnDevType )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlBootDev_SetType(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmBootDev = (PRL_HANDLE )0;
		PRL_INT32	nDevType = (PRL_INT32 )0;

		if ( ! PyArg_ParseTuple( args, "ki:PrlBootDev_SetType" , &hVmBootDev, &nDevType ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlBootDev_SetType( hVmBootDev, (PRL_DEVICE_TYPE )nDevType );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlBootDev_GetIndex(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmBootDev = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlBootDev_GetIndex" , &hVmBootDev ) )
			break;

		PRL_UINT32	rnDevIndex = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlBootDev_GetIndex( hVmBootDev, &rnDevIndex );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnDevIndex )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlBootDev_SetIndex(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmBootDev = (PRL_HANDLE )0;
		PRL_UINT32	nDevIndex = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlBootDev_SetIndex" , &hVmBootDev, &nDevIndex ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlBootDev_SetIndex( hVmBootDev, nDevIndex );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlBootDev_GetSequenceIndex(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmBootDev = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlBootDev_GetSequenceIndex" , &hVmBootDev ) )
			break;

		PRL_UINT32	rnSequenceIndex = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlBootDev_GetSequenceIndex( hVmBootDev, &rnSequenceIndex );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnSequenceIndex )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlBootDev_SetSequenceIndex(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmBootDev = (PRL_HANDLE )0;
		PRL_UINT32	nSequenceIndex = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlBootDev_SetSequenceIndex" , &hVmBootDev, &nSequenceIndex ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlBootDev_SetSequenceIndex( hVmBootDev, nSequenceIndex );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlBootDev_IsInUse(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmBootDev = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlBootDev_IsInUse" , &hVmBootDev ) )
			break;

		PRL_BOOL	rbInUse = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlBootDev_IsInUse( hVmBootDev, &rbInUse );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbInUse )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlBootDev_SetInUse(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmBootDev = (PRL_HANDLE )0;
		PRL_BOOL	bInUse = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlBootDev_SetInUse" , &hVmBootDev, &bInUse ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlBootDev_SetInUse( hVmBootDev, bInUse );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmInfo_GetState(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	handle = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmInfo_GetState" , &handle ) )
			break;

		VIRTUAL_MACHINE_STATE	rVmState = (VIRTUAL_MACHINE_STATE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmInfo_GetState( handle, &rVmState );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "i", rVmState )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmInfo_GetAccessRights(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmInfo = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmInfo_GetAccessRights" , &hVmInfo ) )
			break;

		PRL_HANDLE	rhVmAcl = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmInfo_GetAccessRights( hVmInfo, &rhVmAcl );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhVmAcl )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmInfo_IsInvalid(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	handle = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmInfo_IsInvalid" , &handle ) )
			break;

		PRL_BOOL	rbIsInvalid = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmInfo_IsInvalid( handle, &rbIsInvalid );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbIsInvalid )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmInfo_IsVmWaitingForAnswer(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	handle = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmInfo_IsVmWaitingForAnswer" , &handle ) )
			break;

		PRL_BOOL	rbIsVmWaitingForAnswer = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmInfo_IsVmWaitingForAnswer( handle, &rbIsVmWaitingForAnswer );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbIsVmWaitingForAnswer )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmInfo_IsVncServerStarted(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	handle = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmInfo_IsVncServerStarted" , &handle ) )
			break;

		PRL_BOOL	rbIsVncServerStarted = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmInfo_IsVncServerStarted( handle, &rbIsVncServerStarted );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbIsVncServerStarted )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlFoundVmInfo_GetName(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	handle = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlFoundVmInfo_GetName" , &handle ) )
			break;

		PRL_STR	sName = (PRL_STR )0;
		PRL_UINT32	rnNameBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlFoundVmInfo_GetName( handle, sName, &rnNameBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sName(rnNameBufLength, '\0');
		sName = (PRL_STR )std_sName.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlFoundVmInfo_GetName( handle, sName, &rnNameBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sName )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlFoundVmInfo_IsOldConfig(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	handle = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlFoundVmInfo_IsOldConfig" , &handle ) )
			break;

		PRL_BOOL	rbOldVersion = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlFoundVmInfo_IsOldConfig( handle, &rbOldVersion );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbOldVersion )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlFoundVmInfo_GetOSVersion(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	handle = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlFoundVmInfo_GetOSVersion" , &handle ) )
			break;

		PRL_UINT32	rnOSVersion = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlFoundVmInfo_GetOSVersion( handle, &rnOSVersion );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnOSVersion )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlFoundVmInfo_GetConfigPath(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	handle = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlFoundVmInfo_GetConfigPath" , &handle ) )
			break;

		PRL_STR	sPath = (PRL_STR )0;
		PRL_UINT32	rnPathBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlFoundVmInfo_GetConfigPath( handle, sPath, &rnPathBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sPath(rnPathBufLength, '\0');
		sPath = (PRL_STR )std_sPath.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlFoundVmInfo_GetConfigPath( handle, sPath, &rnPathBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sPath )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlFoundVmInfo_IsTemplate(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	handle = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlFoundVmInfo_IsTemplate" , &handle ) )
			break;

		PRL_BOOL	rbIsTemplate = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlFoundVmInfo_IsTemplate( handle, &rbIsTemplate );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbIsTemplate )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlAcl_IsAllowed(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hAcl = (PRL_HANDLE )0;
		PRL_INT32	nPermission = (PRL_INT32 )0;

		if ( ! PyArg_ParseTuple( args, "ki:PrlAcl_IsAllowed" , &hAcl, &nPermission ) )
			break;

		PRL_BOOL	rbAllowed = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlAcl_IsAllowed( hAcl, (PRL_ALLOWED_VM_COMMAND )nPermission, &rbAllowed );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbAllowed )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlAcl_GetAccessForOthers(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hAcl = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlAcl_GetAccessForOthers" , &hAcl ) )
			break;

		PRL_VM_ACCESS_FOR_OTHERS	rnAccessForOthers = (PRL_VM_ACCESS_FOR_OTHERS )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlAcl_GetAccessForOthers( hAcl, &rnAccessForOthers );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "i", rnAccessForOthers )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlAcl_SetAccessForOthers(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hAcl = (PRL_HANDLE )0;
		PRL_INT32	nAccessForOthers = (PRL_INT32 )0;

		if ( ! PyArg_ParseTuple( args, "ki:PrlAcl_SetAccessForOthers" , &hAcl, &nAccessForOthers ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlAcl_SetAccessForOthers( hAcl, (PRL_VM_ACCESS_FOR_OTHERS )nAccessForOthers );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlAcl_GetOwnerName(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hAcl = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlAcl_GetOwnerName" , &hAcl ) )
			break;

		PRL_STR	sOwnerNameBuf = (PRL_STR )0;
		PRL_UINT32	rnOwnerNameBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlAcl_GetOwnerName( hAcl, sOwnerNameBuf, &rnOwnerNameBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sOwnerNameBuf(rnOwnerNameBufLength, '\0');
		sOwnerNameBuf = (PRL_STR )std_sOwnerNameBuf.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlAcl_GetOwnerName( hAcl, sOwnerNameBuf, &rnOwnerNameBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sOwnerNameBuf )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlAcl_IsCurrentSessionOwner(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hAcl = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlAcl_IsCurrentSessionOwner" , &hAcl ) )
			break;

		PRL_BOOL	rbIsOwner = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlAcl_IsCurrentSessionOwner( hAcl, &rbIsOwner );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbIsOwner )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmToolsInfo_GetState(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	handle = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmToolsInfo_GetState" , &handle ) )
			break;

		PRL_VM_TOOLS_STATE	rVmToolsState = (PRL_VM_TOOLS_STATE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmToolsInfo_GetState( handle, &rVmToolsState );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "i", rVmToolsState )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmToolsInfo_GetVersion(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	handle = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmToolsInfo_GetVersion" , &handle ) )
			break;

		PRL_STR	sName = (PRL_STR )0;
		PRL_UINT32	rnNameBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmToolsInfo_GetVersion( handle, sName, &rnNameBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sName(rnNameBufLength, '\0');
		sName = (PRL_STR )std_sName.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmToolsInfo_GetVersion( handle, sName, &rnNameBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sName )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlStat_GetTotalRamSize(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hStat = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlStat_GetTotalRamSize" , &hStat ) )
			break;

		PRL_UINT64	rnSize = (PRL_UINT64 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlStat_GetTotalRamSize( hStat, &rnSize );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "K", rnSize )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlStat_GetUsageRamSize(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hStat = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlStat_GetUsageRamSize" , &hStat ) )
			break;

		PRL_UINT64	rnSize = (PRL_UINT64 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlStat_GetUsageRamSize( hStat, &rnSize );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "K", rnSize )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlStat_GetFreeRamSize(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hStat = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlStat_GetFreeRamSize" , &hStat ) )
			break;

		PRL_UINT64	rnSize = (PRL_UINT64 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlStat_GetFreeRamSize( hStat, &rnSize );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "K", rnSize )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlStat_GetRealRamSize(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hStat = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlStat_GetRealRamSize" , &hStat ) )
			break;

		PRL_UINT64	rnSize = (PRL_UINT64 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlStat_GetRealRamSize( hStat, &rnSize );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "K", rnSize )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlStat_GetOsUptime(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hStat = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlStat_GetOsUptime" , &hStat ) )
			break;

		PRL_UINT64	rnUptime = (PRL_UINT64 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlStat_GetOsUptime( hStat, &rnUptime );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "K", rnUptime )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlStat_GetCpusStatsCount(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hStat = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlStat_GetCpusStatsCount" , &hStat ) )
			break;

		PRL_UINT32	rnCount = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlStat_GetCpusStatsCount( hStat, &rnCount );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnCount )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlStat_GetCpuStat(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hStat = (PRL_HANDLE )0;
		PRL_UINT32	nIndex = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlStat_GetCpuStat" , &hStat, &nIndex ) )
			break;

		PRL_HANDLE	rhCpuStat = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlStat_GetCpuStat( hStat, nIndex, &rhCpuStat );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhCpuStat )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlStatCpu_GetCpuUsage(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hCpuStat = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlStatCpu_GetCpuUsage" , &hCpuStat ) )
			break;

		PRL_UINT32	rnPercents = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlStatCpu_GetCpuUsage( hCpuStat, &rnPercents );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnPercents )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlStatCpu_GetTotalTime(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hCpuStat = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlStatCpu_GetTotalTime" , &hCpuStat ) )
			break;

		PRL_UINT64	rnTime = (PRL_UINT64 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlStatCpu_GetTotalTime( hCpuStat, &rnTime );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "K", rnTime )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlStatCpu_GetUserTime(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hCpuStat = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlStatCpu_GetUserTime" , &hCpuStat ) )
			break;

		PRL_UINT64	rnTime = (PRL_UINT64 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlStatCpu_GetUserTime( hCpuStat, &rnTime );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "K", rnTime )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlStatCpu_GetSystemTime(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hCpuStat = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlStatCpu_GetSystemTime" , &hCpuStat ) )
			break;

		PRL_UINT64	rnTime = (PRL_UINT64 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlStatCpu_GetSystemTime( hCpuStat, &rnTime );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "K", rnTime )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlLic_IsValid(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hLicense = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlLic_IsValid" , &hLicense ) )
			break;

		PRL_BOOL	rbValue = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlLic_IsValid( hLicense, &rbValue );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbValue )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlLic_GetStatus(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hLicense = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlLic_GetStatus" , &hLicense ) )
			break;

		PRL_RESULT	rnValue = (PRL_RESULT )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlLic_GetStatus( hLicense, &rnValue );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnValue )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlLic_GetLicenseKey(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hLicense = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlLic_GetLicenseKey" , &hLicense ) )
			break;

		PRL_STR	sLicenseKey = (PRL_STR )0;
		PRL_UINT32	rnLicenseKeyBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlLic_GetLicenseKey( hLicense, sLicenseKey, &rnLicenseKeyBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sLicenseKey(rnLicenseKeyBufLength, '\0');
		sLicenseKey = (PRL_STR )std_sLicenseKey.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlLic_GetLicenseKey( hLicense, sLicenseKey, &rnLicenseKeyBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sLicenseKey )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlLic_GetUserName(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hLicense = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlLic_GetUserName" , &hLicense ) )
			break;

		PRL_STR	sUserName = (PRL_STR )0;
		PRL_UINT32	rnUserNameBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlLic_GetUserName( hLicense, sUserName, &rnUserNameBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sUserName(rnUserNameBufLength, '\0');
		sUserName = (PRL_STR )std_sUserName.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlLic_GetUserName( hLicense, sUserName, &rnUserNameBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sUserName )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlLic_GetCompanyName(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hLicense = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlLic_GetCompanyName" , &hLicense ) )
			break;

		PRL_STR	sCompanyName = (PRL_STR )0;
		PRL_UINT32	rnCompanyNameBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlLic_GetCompanyName( hLicense, sCompanyName, &rnCompanyNameBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sCompanyName(rnCompanyNameBufLength, '\0');
		sCompanyName = (PRL_STR )std_sCompanyName.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlLic_GetCompanyName( hLicense, sCompanyName, &rnCompanyNameBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sCompanyName )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvInfo_GetHostName(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServerInfo = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrvInfo_GetHostName" , &hServerInfo ) )
			break;

		PRL_STR	sHostName = (PRL_STR )0;
		PRL_UINT32	rnHostNameBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvInfo_GetHostName( hServerInfo, sHostName, &rnHostNameBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sHostName(rnHostNameBufLength, '\0');
		sHostName = (PRL_STR )std_sHostName.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvInfo_GetHostName( hServerInfo, sHostName, &rnHostNameBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sHostName )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvInfo_GetOsVersion(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServerInfo = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrvInfo_GetOsVersion" , &hServerInfo ) )
			break;

		PRL_STR	sOsVersion = (PRL_STR )0;
		PRL_UINT32	rnOsVersionBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvInfo_GetOsVersion( hServerInfo, sOsVersion, &rnOsVersionBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sOsVersion(rnOsVersionBufLength, '\0');
		sOsVersion = (PRL_STR )std_sOsVersion.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvInfo_GetOsVersion( hServerInfo, sOsVersion, &rnOsVersionBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sOsVersion )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvInfo_GetProductVersion(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServerInfo = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrvInfo_GetProductVersion" , &hServerInfo ) )
			break;

		PRL_STR	sProductVersion = (PRL_STR )0;
		PRL_UINT32	rnProductVersionBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvInfo_GetProductVersion( hServerInfo, sProductVersion, &rnProductVersionBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sProductVersion(rnProductVersionBufLength, '\0');
		sProductVersion = (PRL_STR )std_sProductVersion.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvInfo_GetProductVersion( hServerInfo, sProductVersion, &rnProductVersionBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sProductVersion )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvInfo_GetCmdPort(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServerInfo = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrvInfo_GetCmdPort" , &hServerInfo ) )
			break;

		PRL_UINT32	rnPort = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvInfo_GetCmdPort( hServerInfo, &rnPort );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnPort )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvInfo_GetApplicationMode(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServerInfo = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrvInfo_GetApplicationMode" , &hServerInfo ) )
			break;

		PRL_APPLICATION_MODE	rnApplicationMode = (PRL_APPLICATION_MODE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvInfo_GetApplicationMode( hServerInfo, &rnApplicationMode );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "i", rnApplicationMode )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvInfo_GetServerUuid(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServerInfo = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrvInfo_GetServerUuid" , &hServerInfo ) )
			break;

		PRL_STR	sServerUuid = (PRL_STR )0;
		PRL_UINT32	rnServerUuidBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvInfo_GetServerUuid( hServerInfo, sServerUuid, &rnServerUuidBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sServerUuid(rnServerUuidBufLength, '\0');
		sServerUuid = (PRL_STR )std_sServerUuid.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvInfo_GetServerUuid( hServerInfo, sServerUuid, &rnServerUuidBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sServerUuid )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvInfo_GetStartTime(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServerInfo = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrvInfo_GetStartTime" , &hServerInfo ) )
			break;

		PRL_UINT64	rnStartTime = (PRL_UINT64 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvInfo_GetStartTime( hServerInfo, &rnStartTime );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "K", rnStartTime )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrvInfo_GetStartTimeMonotonic(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServerInfo = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrvInfo_GetStartTimeMonotonic" , &hServerInfo ) )
			break;

		PRL_UINT64	rnStartTimeMonotonic = (PRL_UINT64 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrvInfo_GetStartTimeMonotonic( hServerInfo, &rnStartTimeMonotonic );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "K", rnStartTimeMonotonic )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlNetSvc_GetStatus(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	handle = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlNetSvc_GetStatus" , &handle ) )
			break;

		PRL_SERVICE_STATUS_ENUM	rnNetStatus = (PRL_SERVICE_STATUS_ENUM )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlNetSvc_GetStatus( handle, &rnNetStatus );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "i", rnNetStatus )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_FsGenerateEntryName(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;
		PRL_CONST_STR	sDirPath = (PRL_CONST_STR )0;
		PRL_CONST_STR	sFilenamePrefix = (PRL_CONST_STR )0;
		PRL_CONST_STR	sFilenameSuffix = (PRL_CONST_STR )0;
		PRL_CONST_STR	sIndexDelimiter = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "kssss:PrlSrv_FsGenerateEntryName" , &hServer, &sDirPath, &sFilenamePrefix, &sFilenameSuffix, &sIndexDelimiter ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_FsGenerateEntryName( hServer, sDirPath, sFilenamePrefix, sFilenameSuffix, sIndexDelimiter );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlLoginResponse_GetSessionUuid(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hLoginResp = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlLoginResponse_GetSessionUuid" , &hLoginResp ) )
			break;

		PRL_STR	sSessionUuid = (PRL_STR )0;
		PRL_UINT32	rnSessionUuidBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlLoginResponse_GetSessionUuid( hLoginResp, sSessionUuid, &rnSessionUuidBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sSessionUuid(rnSessionUuidBufLength, '\0');
		sSessionUuid = (PRL_STR )std_sSessionUuid.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlLoginResponse_GetSessionUuid( hLoginResp, sSessionUuid, &rnSessionUuidBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sSessionUuid )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlLoginResponse_GetRunningTaskCount(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hLoginResp = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlLoginResponse_GetRunningTaskCount" , &hLoginResp ) )
			break;

		PRL_UINT32	rnCount = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlLoginResponse_GetRunningTaskCount( hLoginResp, &rnCount );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnCount )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlLoginResponse_GetRunningTaskByIndex(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hLoginResp = (PRL_HANDLE )0;
		PRL_UINT32	nIndex = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlLoginResponse_GetRunningTaskByIndex" , &hLoginResp, &nIndex ) )
			break;

		PRL_HANDLE	rhRunningTask = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlLoginResponse_GetRunningTaskByIndex( hLoginResp, nIndex, &rhRunningTask );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhRunningTask )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlLoginResponse_GetServerUuid(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hLoginResp = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlLoginResponse_GetServerUuid" , &hLoginResp ) )
			break;

		PRL_STR	sServerUuid = (PRL_STR )0;
		PRL_UINT32	rnServerUuidBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlLoginResponse_GetServerUuid( hLoginResp, sServerUuid, &rnServerUuidBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sServerUuid(rnServerUuidBufLength, '\0');
		sServerUuid = (PRL_STR )std_sServerUuid.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlLoginResponse_GetServerUuid( hLoginResp, sServerUuid, &rnServerUuidBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sServerUuid )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlLoginResponse_GetHostOsVersion(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hLoginResp = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlLoginResponse_GetHostOsVersion" , &hLoginResp ) )
			break;

		PRL_STR	sHostOsVersion = (PRL_STR )0;
		PRL_UINT32	rnHostOsVersionBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlLoginResponse_GetHostOsVersion( hLoginResp, sHostOsVersion, &rnHostOsVersionBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sHostOsVersion(rnHostOsVersionBufLength, '\0');
		sHostOsVersion = (PRL_STR )std_sHostOsVersion.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlLoginResponse_GetHostOsVersion( hLoginResp, sHostOsVersion, &rnHostOsVersionBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sHostOsVersion )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlLoginResponse_GetProductVersion(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hLoginResp = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlLoginResponse_GetProductVersion" , &hLoginResp ) )
			break;

		PRL_STR	sProductVersion = (PRL_STR )0;
		PRL_UINT32	rnProductVersionBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlLoginResponse_GetProductVersion( hLoginResp, sProductVersion, &rnProductVersionBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sProductVersion(rnProductVersionBufLength, '\0');
		sProductVersion = (PRL_STR )std_sProductVersion.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlLoginResponse_GetProductVersion( hLoginResp, sProductVersion, &rnProductVersionBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sProductVersion )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlRunningTask_GetTaskUuid(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hRunningTask = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlRunningTask_GetTaskUuid" , &hRunningTask ) )
			break;

		PRL_STR	sTaskUuid = (PRL_STR )0;
		PRL_UINT32	rnTaskUuidBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlRunningTask_GetTaskUuid( hRunningTask, sTaskUuid, &rnTaskUuidBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sTaskUuid(rnTaskUuidBufLength, '\0');
		sTaskUuid = (PRL_STR )std_sTaskUuid.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlRunningTask_GetTaskUuid( hRunningTask, sTaskUuid, &rnTaskUuidBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sTaskUuid )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlRunningTask_GetTaskType(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hRunningTask = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlRunningTask_GetTaskType" , &hRunningTask ) )
			break;

		PRL_RUNNING_TASK_TYPE_ENUM	rnType = (PRL_RUNNING_TASK_TYPE_ENUM )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlRunningTask_GetTaskType( hRunningTask, &rnType );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "i", rnType )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlRunningTask_GetTaskParametersAsString(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hRunningTask = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlRunningTask_GetTaskParametersAsString" , &hRunningTask ) )
			break;

		PRL_STR	sParamsStr = (PRL_STR )0;
		PRL_UINT32	rnsParamsStrBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlRunningTask_GetTaskParametersAsString( hRunningTask, sParamsStr, &rnsParamsStrBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sParamsStr(rnsParamsStrBufLength, '\0');
		sParamsStr = (PRL_STR )std_sParamsStr.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlRunningTask_GetTaskParametersAsString( hRunningTask, sParamsStr, &rnsParamsStrBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sParamsStr )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_SubscribeToPerfStats(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;
		PRL_CONST_STR	sFilter = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ks:PrlSrv_SubscribeToPerfStats" , &hServer, &sFilter ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_SubscribeToPerfStats( hServer, sFilter );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_UnsubscribeFromPerfStats(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrv_UnsubscribeFromPerfStats" , &hServer ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_UnsubscribeFromPerfStats( hServer );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_GetPerfStats(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;
		PRL_CONST_STR	sFilter = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ks:PrlSrv_GetPerfStats" , &hServer, &sFilter ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_GetPerfStats( hServer, sFilter );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVm_SubscribeToPerfStats(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;
		PRL_CONST_STR	sFilter = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ks:PrlVm_SubscribeToPerfStats" , &hVm, &sFilter ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlVm_SubscribeToPerfStats( hVm, sFilter );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVm_UnsubscribeFromPerfStats(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVm_UnsubscribeFromPerfStats" , &hVm ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlVm_UnsubscribeFromPerfStats( hVm );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVm_GetPerfStats(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;
		PRL_CONST_STR	sFilter = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ks:PrlVm_GetPerfStats" , &hVm, &sFilter ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlVm_GetPerfStats( hVm, sFilter );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVm_AuthWithGuestSecurityDb(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;
		PRL_CONST_STR	sUserName = (PRL_CONST_STR )0;
		PRL_CONST_STR	sUserPassword = (PRL_CONST_STR )0;
		PRL_UINT32	nFlags = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kssI:PrlVm_AuthWithGuestSecurityDb" , &hVm, &sUserName, &sUserPassword, &nFlags ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlVm_AuthWithGuestSecurityDb( hVm, sUserName, sUserPassword, nFlags );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmInfo_GetAdditionState(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	handle = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmInfo_GetAdditionState" , &handle ) )
			break;

		VIRTUAL_MACHINE_ADDITION_STATE	rVmState = (VIRTUAL_MACHINE_ADDITION_STATE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmInfo_GetAdditionState( handle, &rVmState );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "i", rVmState )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVm_Compact(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;
		PRL_UINT32	uMask = (PRL_UINT32 )0;
		PRL_UINT32	nFlags = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kII:PrlVm_Compact" , &hVm, &uMask, &nFlags ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlVm_Compact( hVm, uMask, nFlags );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVm_CancelCompact(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVm_CancelCompact" , &hVm ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlVm_CancelCompact( hVm );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVm_ConvertDisks(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;
		PRL_UINT32	uMask = (PRL_UINT32 )0;
		PRL_UINT32	nFlags = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kII:PrlVm_ConvertDisks" , &hVm, &uMask, &nFlags ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlVm_ConvertDisks( hVm, uMask, nFlags );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVm_CancelConvertDisks(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;
		PRL_UINT32	nFlags = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVm_CancelConvertDisks" , &hVm, &nFlags ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlVm_CancelConvertDisks( hVm, nFlags );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlOsesMatrix_GetSupportedOsesTypes(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hOsesMatrix = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlOsesMatrix_GetSupportedOsesTypes" , &hOsesMatrix ) )
			break;

		PRL_HANDLE	rhOsesTypesList = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlOsesMatrix_GetSupportedOsesTypes( hOsesMatrix, &rhOsesTypesList );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhOsesTypesList )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlOsesMatrix_GetSupportedOsesVersions(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hOsesMatrix = (PRL_HANDLE )0;
		PRL_UINT8	nGuestOsType = (PRL_UINT8 )0;

		if ( ! PyArg_ParseTuple( args, "kB:PrlOsesMatrix_GetSupportedOsesVersions" , &hOsesMatrix, &nGuestOsType ) )
			break;

		PRL_HANDLE	rhGuestsList = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlOsesMatrix_GetSupportedOsesVersions( hOsesMatrix, nGuestOsType, &rhGuestsList );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhGuestsList )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlOsesMatrix_GetDefaultOsVersion(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hOsesMatrix = (PRL_HANDLE )0;
		PRL_UINT8	nGuestOsType = (PRL_UINT8 )0;

		if ( ! PyArg_ParseTuple( args, "kB:PrlOsesMatrix_GetDefaultOsVersion" , &hOsesMatrix, &nGuestOsType ) )
			break;

		PRL_UINT16	rnOsVersion = (PRL_UINT16 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlOsesMatrix_GetDefaultOsVersion( hOsesMatrix, nGuestOsType, &rnOsVersion );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "H", rnOsVersion )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_HasRestriction(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;
		PRL_INT32	nRestrictionKey = (PRL_INT32 )0;

		if ( ! PyArg_ParseTuple( args, "ki:PrlSrv_HasRestriction" , &hServer, &nRestrictionKey ) )
			break;

		PRL_BOOL	rbHasRestriction = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrv_HasRestriction( hServer, (PRL_LICENSE_RESTRICTION_KEY )nRestrictionKey, &rbHasRestriction );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbHasRestriction )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_GetRestrictionInfo(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;
		PRL_INT32	nRestrictionKey = (PRL_INT32 )0;

		if ( ! PyArg_ParseTuple( args, "ki:PrlSrv_GetRestrictionInfo" , &hServer, &nRestrictionKey ) )
			break;

		PRL_HANDLE	rhEvtParam = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrv_GetRestrictionInfo( hServer, (PRL_LICENSE_RESTRICTION_KEY )nRestrictionKey, &rhEvtParam );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhEvtParam )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlApi_CreateProblemReport(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_INT32	nReportScheme = (PRL_INT32 )0;

		if ( ! PyArg_ParseTuple( args, "i:PrlApi_CreateProblemReport" , &nReportScheme ) )
			break;

		PRL_HANDLE	rhProblemReport = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlApi_CreateProblemReport( (PRL_PROBLEM_REPORT_SCHEME )nReportScheme, &rhProblemReport );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhProblemReport )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlReport_SetUserName(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hProblemReport = (PRL_HANDLE )0;
		PRL_CONST_STR	sNewUserName = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ks:PrlReport_SetUserName" , &hProblemReport, &sNewUserName ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlReport_SetUserName( hProblemReport, sNewUserName );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlReport_GetUserName(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hProblemReport = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlReport_GetUserName" , &hProblemReport ) )
			break;

		PRL_STR	sUserName = (PRL_STR )0;
		PRL_UINT32	rnUserNameBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlReport_GetUserName( hProblemReport, sUserName, &rnUserNameBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sUserName(rnUserNameBufLength, '\0');
		sUserName = (PRL_STR )std_sUserName.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlReport_GetUserName( hProblemReport, sUserName, &rnUserNameBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sUserName )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlReport_SetUserEmail(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hProblemReport = (PRL_HANDLE )0;
		PRL_CONST_STR	sNewUserEmail = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ks:PrlReport_SetUserEmail" , &hProblemReport, &sNewUserEmail ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlReport_SetUserEmail( hProblemReport, sNewUserEmail );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlReport_GetUserEmail(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hProblemReport = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlReport_GetUserEmail" , &hProblemReport ) )
			break;

		PRL_STR	sUserEmail = (PRL_STR )0;
		PRL_UINT32	rnUserEmailBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlReport_GetUserEmail( hProblemReport, sUserEmail, &rnUserEmailBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sUserEmail(rnUserEmailBufLength, '\0');
		sUserEmail = (PRL_STR )std_sUserEmail.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlReport_GetUserEmail( hProblemReport, sUserEmail, &rnUserEmailBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sUserEmail )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlReport_SetDescription(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hProblemReport = (PRL_HANDLE )0;
		PRL_CONST_STR	sNewDescription = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ks:PrlReport_SetDescription" , &hProblemReport, &sNewDescription ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlReport_SetDescription( hProblemReport, sNewDescription );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlReport_GetDescription(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hProblemReport = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlReport_GetDescription" , &hProblemReport ) )
			break;

		PRL_STR	sDescription = (PRL_STR )0;
		PRL_UINT32	rnDescriptionBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlReport_GetDescription( hProblemReport, sDescription, &rnDescriptionBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sDescription(rnDescriptionBufLength, '\0');
		sDescription = (PRL_STR )std_sDescription.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlReport_GetDescription( hProblemReport, sDescription, &rnDescriptionBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sDescription )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlReport_SetType(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hProblemReport = (PRL_HANDLE )0;
		PRL_INT32	nReportType = (PRL_INT32 )0;

		if ( ! PyArg_ParseTuple( args, "ki:PrlReport_SetType" , &hProblemReport, &nReportType ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlReport_SetType( hProblemReport, (PRL_PROBLEM_REPORT_TYPE )nReportType );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlReport_GetType(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hProblemReport = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlReport_GetType" , &hProblemReport ) )
			break;

		PRL_PROBLEM_REPORT_TYPE	rnReportType = (PRL_PROBLEM_REPORT_TYPE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlReport_GetType( hProblemReport, &rnReportType );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "i", rnReportType )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlReport_SetReason(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hProblemReport = (PRL_HANDLE )0;
		PRL_INT32	nReportReason = (PRL_INT32 )0;

		if ( ! PyArg_ParseTuple( args, "ki:PrlReport_SetReason" , &hProblemReport, &nReportReason ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlReport_SetReason( hProblemReport, (PRL_PROBLEM_REPORT_REASON )nReportReason );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlReport_GetReason(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hProblemReport = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlReport_GetReason" , &hProblemReport ) )
			break;

		PRL_PROBLEM_REPORT_REASON	rnReportReason = (PRL_PROBLEM_REPORT_REASON )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlReport_GetReason( hProblemReport, &rnReportReason );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "i", rnReportReason )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlReport_GetScheme(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hProblemReport = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlReport_GetScheme" , &hProblemReport ) )
			break;

		PRL_PROBLEM_REPORT_SCHEME	rnReportScheme = (PRL_PROBLEM_REPORT_SCHEME )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlReport_GetScheme( hProblemReport, &rnReportScheme );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "i", rnReportScheme )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlReport_GetArchiveFileName(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hProblemReport = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlReport_GetArchiveFileName" , &hProblemReport ) )
			break;

		PRL_STR	sArchiveFileName = (PRL_STR )0;
		PRL_UINT32	rnBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlReport_GetArchiveFileName( hProblemReport, sArchiveFileName, &rnBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sArchiveFileName(rnBufLength, '\0');
		sArchiveFileName = (PRL_STR )std_sArchiveFileName.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlReport_GetArchiveFileName( hProblemReport, sArchiveFileName, &rnBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sArchiveFileName )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlReport_AsString(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hProblemReport = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlReport_AsString" , &hProblemReport ) )
			break;

		PRL_STR	sBuffer = (PRL_STR )0;
		PRL_UINT32	rnBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlReport_AsString( hProblemReport, sBuffer, &rnBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sBuffer(rnBufLength, '\0');
		sBuffer = (PRL_STR )std_sBuffer.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlReport_AsString( hProblemReport, sBuffer, &rnBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sBuffer )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlReport_Assembly(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hProblemReport = (PRL_HANDLE )0;
		PRL_UINT32	nFlags = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlReport_Assembly" , &hProblemReport, &nFlags ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlReport_Assembly( hProblemReport, nFlags );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_InstallAppliance(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;
		PRL_HANDLE	hAppCfg = (PRL_HANDLE )0;
		PRL_CONST_STR	sVmParentPath = (PRL_CONST_STR )0;
		PRL_UINT32	nFlags = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kksI:PrlSrv_InstallAppliance" , &hServer, &hAppCfg, &sVmParentPath, &nFlags ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_InstallAppliance( hServer, hAppCfg, sVmParentPath, nFlags );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_CancelInstallAppliance(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;
		PRL_HANDLE	hAppCfg = (PRL_HANDLE )0;
		PRL_UINT32	nFlags = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kkI:PrlSrv_CancelInstallAppliance" , &hServer, &hAppCfg, &nFlags ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_CancelInstallAppliance( hServer, hAppCfg, nFlags );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_StopInstallAppliance(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;
		PRL_HANDLE	hAppCfg = (PRL_HANDLE )0;
		PRL_UINT32	nFlags = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kkI:PrlSrv_StopInstallAppliance" , &hServer, &hAppCfg, &nFlags ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_StopInstallAppliance( hServer, hAppCfg, nFlags );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlAppliance_Create(PyObject* /*self*/, PyObject* )
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	rhAppCfg = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlAppliance_Create( &rhAppCfg );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhAppCfg )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlCtTemplate_GetName(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hTemplate = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlCtTemplate_GetName" , &hTemplate ) )
			break;

		PRL_STR	sName = (PRL_STR )0;
		PRL_UINT32	rnNameLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlCtTemplate_GetName( hTemplate, sName, &rnNameLength );
		Py_END_ALLOW_THREADS

		std::string std_sName(rnNameLength, '\0');
		sName = (PRL_STR )std_sName.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlCtTemplate_GetName( hTemplate, sName, &rnNameLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sName )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlCtTemplate_GetType(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hTemplate = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlCtTemplate_GetType" , &hTemplate ) )
			break;

		PRL_CT_TEMPLATE_TYPE	rType = (PRL_CT_TEMPLATE_TYPE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlCtTemplate_GetType( hTemplate, &rType );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "i", rType )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlCtTemplate_GetDescription(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hTemplate = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlCtTemplate_GetDescription" , &hTemplate ) )
			break;

		PRL_STR	sDescription = (PRL_STR )0;
		PRL_UINT32	rnDescriptionLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlCtTemplate_GetDescription( hTemplate, sDescription, &rnDescriptionLength );
		Py_END_ALLOW_THREADS

		std::string std_sDescription(rnDescriptionLength, '\0');
		sDescription = (PRL_STR )std_sDescription.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlCtTemplate_GetDescription( hTemplate, sDescription, &rnDescriptionLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sDescription )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlCtTemplate_GetVersion(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hTemplate = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlCtTemplate_GetVersion" , &hTemplate ) )
			break;

		PRL_STR	sVersion = (PRL_STR )0;
		PRL_UINT32	rnVersionLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlCtTemplate_GetVersion( hTemplate, sVersion, &rnVersionLength );
		Py_END_ALLOW_THREADS

		std::string std_sVersion(rnVersionLength, '\0');
		sVersion = (PRL_STR )std_sVersion.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlCtTemplate_GetVersion( hTemplate, sVersion, &rnVersionLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sVersion )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlCtTemplate_GetOsType(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hTemplate = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlCtTemplate_GetOsType" , &hTemplate ) )
			break;

		PRL_UINT32	rnOsType = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlCtTemplate_GetOsType( hTemplate, &rnOsType );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnOsType )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlCtTemplate_GetOsVersion(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hTemplate = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlCtTemplate_GetOsVersion" , &hTemplate ) )
			break;

		PRL_UINT32	rnOsVersion = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlCtTemplate_GetOsVersion( hTemplate, &rnOsVersion );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnOsVersion )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlCtTemplate_GetOsTemplate(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hTemplate = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlCtTemplate_GetOsTemplate" , &hTemplate ) )
			break;

		PRL_STR	sOsTemplate = (PRL_STR )0;
		PRL_UINT32	rnOsTemplateLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlCtTemplate_GetOsTemplate( hTemplate, sOsTemplate, &rnOsTemplateLength );
		Py_END_ALLOW_THREADS

		std::string std_sOsTemplate(rnOsTemplateLength, '\0');
		sOsTemplate = (PRL_STR )std_sOsTemplate.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlCtTemplate_GetOsTemplate( hTemplate, sOsTemplate, &rnOsTemplateLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sOsTemplate )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlCtTemplate_GetCpuMode(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hTemplate = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlCtTemplate_GetCpuMode" , &hTemplate ) )
			break;

		PRL_CPU_MODE	rnCpuMode = (PRL_CPU_MODE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlCtTemplate_GetCpuMode( hTemplate, &rnCpuMode );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "i", rnCpuMode )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlCtTemplate_IsCached(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hTemplate = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlCtTemplate_IsCached" , &hTemplate ) )
			break;

		PRL_BOOL	rbCached = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlCtTemplate_IsCached( hTemplate, &rbCached );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbCached )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_GetCtTemplateList(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;
		PRL_UINT32	nFlags = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlSrv_GetCtTemplateList" , &hServer, &nFlags ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_GetCtTemplateList( hServer, nFlags );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_RemoveCtTemplate(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;
		PRL_CONST_STR	sName = (PRL_CONST_STR )0;
		PRL_CONST_STR	sOsTmplName = (PRL_CONST_STR )0;
		PRL_UINT32	nFlags = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kssI:PrlSrv_RemoveCtTemplate" , &hServer, &sName, &sOsTmplName, &nFlags ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_RemoveCtTemplate( hServer, sName, sOsTmplName, nFlags );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlDispCfg_GetUsbIdentityCount(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hDispCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlDispCfg_GetUsbIdentityCount" , &hDispCfg ) )
			break;

		PRL_UINT32	rnUsbIdentityCount = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlDispCfg_GetUsbIdentityCount( hDispCfg, &rnUsbIdentityCount );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnUsbIdentityCount )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlDispCfg_GetUsbIdentity(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hDispCfg = (PRL_HANDLE )0;
		PRL_UINT32	nUsbIdentIndex = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlDispCfg_GetUsbIdentity" , &hDispCfg, &nUsbIdentIndex ) )
			break;

		PRL_HANDLE	rhUsbIdent = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlDispCfg_GetUsbIdentity( hDispCfg, nUsbIdentIndex, &rhUsbIdent );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhUsbIdent )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlUsbIdent_GetSystemName(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hUsbIdent = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlUsbIdent_GetSystemName" , &hUsbIdent ) )
			break;

		PRL_STR	sSystemName = (PRL_STR )0;
		PRL_UINT32	rnSystemNameBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlUsbIdent_GetSystemName( hUsbIdent, sSystemName, &rnSystemNameBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sSystemName(rnSystemNameBufLength, '\0');
		sSystemName = (PRL_STR )std_sSystemName.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlUsbIdent_GetSystemName( hUsbIdent, sSystemName, &rnSystemNameBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sSystemName )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlUsbIdent_GetFriendlyName(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hUsbIdent = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlUsbIdent_GetFriendlyName" , &hUsbIdent ) )
			break;

		PRL_STR	sFriendlyName = (PRL_STR )0;
		PRL_UINT32	rnFriendlyNameBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlUsbIdent_GetFriendlyName( hUsbIdent, sFriendlyName, &rnFriendlyNameBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sFriendlyName(rnFriendlyNameBufLength, '\0');
		sFriendlyName = (PRL_STR )std_sFriendlyName.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlUsbIdent_GetFriendlyName( hUsbIdent, sFriendlyName, &rnFriendlyNameBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sFriendlyName )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlUsbIdent_GetVmUuidAssociation(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hUsbIdent = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlUsbIdent_GetVmUuidAssociation" , &hUsbIdent ) )
			break;

		PRL_STR	sVmUuid = (PRL_STR )0;
		PRL_UINT32	rnVmUuidBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlUsbIdent_GetVmUuidAssociation( hUsbIdent, sVmUuid, &rnVmUuidBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sVmUuid(rnVmUuidBufLength, '\0');
		sVmUuid = (PRL_STR )std_sVmUuid.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlUsbIdent_GetVmUuidAssociation( hUsbIdent, sVmUuid, &rnVmUuidBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sVmUuid )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlDispCfg_SetUsbIdentAssociation(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hDispCfg = (PRL_HANDLE )0;
		PRL_CONST_STR	sSystemName = (PRL_CONST_STR )0;
		PRL_CONST_STR	sVmUuid = (PRL_CONST_STR )0;
		PRL_UINT32	nFlags = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kssI:PrlDispCfg_SetUsbIdentAssociation" , &hDispCfg, &sSystemName, &sVmUuid, &nFlags ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlDispCfg_SetUsbIdentAssociation( hDispCfg, sSystemName, sVmUuid, nFlags );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_CopyCtTemplate(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hSrv = (PRL_HANDLE )0;
		PRL_CONST_STR	sName = (PRL_CONST_STR )0;
		PRL_CONST_STR	sOsTmplName = (PRL_CONST_STR )0;
		PRL_CONST_STR	sTargetServerHostname = (PRL_CONST_STR )0;
		PRL_UINT32	nTargetServerPort = (PRL_UINT32 )0;
		PRL_CONST_STR	sTargetServerSessionUuid = (PRL_CONST_STR )0;
		PRL_UINT32	nFlags = (PRL_UINT32 )0;
		PRL_UINT32	nReservedFlags = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "ksssIsII:PrlSrv_CopyCtTemplate" , &hSrv, &sName, &sOsTmplName, &sTargetServerHostname, &nTargetServerPort, &sTargetServerSessionUuid, &nFlags, &nReservedFlags ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_CopyCtTemplate( hSrv, sName, sOsTmplName, sTargetServerHostname, nTargetServerPort, sTargetServerSessionUuid, nFlags, nReservedFlags );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_IsFeatureSupported(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;
		PRL_INT32	nFeatureId = (PRL_INT32 )0;

		if ( ! PyArg_ParseTuple( args, "ki:PrlSrv_IsFeatureSupported" , &hServer, &nFeatureId ) )
			break;

		PRL_BOOL	rbIsSupported = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlSrv_IsFeatureSupported( hServer, (PRL_FEATURES_MATRIX )nFeatureId, &rbIsSupported );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbIsSupported )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_AddIPPrivateNetwork(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;
		PRL_HANDLE	hPrivNet = (PRL_HANDLE )0;
		PRL_UINT32	nFlags = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kkI:PrlSrv_AddIPPrivateNetwork" , &hServer, &hPrivNet, &nFlags ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_AddIPPrivateNetwork( hServer, hPrivNet, nFlags );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_RemoveIPPrivateNetwork(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;
		PRL_HANDLE	hPrivNet = (PRL_HANDLE )0;
		PRL_UINT32	nFlags = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kkI:PrlSrv_RemoveIPPrivateNetwork" , &hServer, &hPrivNet, &nFlags ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_RemoveIPPrivateNetwork( hServer, hPrivNet, nFlags );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_UpdateIPPrivateNetwork(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;
		PRL_HANDLE	hPrivNet = (PRL_HANDLE )0;
		PRL_UINT32	nFlags = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kkI:PrlSrv_UpdateIPPrivateNetwork" , &hServer, &hPrivNet, &nFlags ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_UpdateIPPrivateNetwork( hServer, hPrivNet, nFlags );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_GetIPPrivateNetworksList(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;
		PRL_UINT32	nFlags = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlSrv_GetIPPrivateNetworksList" , &hServer, &nFlags ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_GetIPPrivateNetworksList( hServer, nFlags );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlIPPrivNet_Create(PyObject* /*self*/, PyObject* )
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	rhPrivNet = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlIPPrivNet_Create( &rhPrivNet );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhPrivNet )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlIPPrivNet_GetName(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hPrivNet = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlIPPrivNet_GetName" , &hPrivNet ) )
			break;

		PRL_STR	sName = (PRL_STR )0;
		PRL_UINT32	rnNameBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlIPPrivNet_GetName( hPrivNet, sName, &rnNameBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sName(rnNameBufLength, '\0');
		sName = (PRL_STR )std_sName.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlIPPrivNet_GetName( hPrivNet, sName, &rnNameBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sName )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlIPPrivNet_SetNetAddresses(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hPrivNet = (PRL_HANDLE )0;
		PRL_HANDLE	NetAddresses = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "kk:PrlIPPrivNet_SetNetAddresses" , &hPrivNet, &NetAddresses ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlIPPrivNet_SetNetAddresses( hPrivNet, NetAddresses );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlIPPrivNet_GetNetAddresses(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hPrivNet = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlIPPrivNet_GetNetAddresses" , &hPrivNet ) )
			break;

		PRL_HANDLE	rNetAddresses = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlIPPrivNet_GetNetAddresses( hPrivNet, &rNetAddresses );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rNetAddresses )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlIPPrivNet_SetName(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hPrivNet = (PRL_HANDLE )0;
		PRL_CONST_STR	sName = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ks:PrlIPPrivNet_SetName" , &hPrivNet, &sName ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlIPPrivNet_SetName( hPrivNet, sName );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlIPPrivNet_IsGlobal(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hPrivNet = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlIPPrivNet_IsGlobal" , &hPrivNet ) )
			break;

		PRL_BOOL	rbGlobal = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlIPPrivNet_IsGlobal( hPrivNet, &rbGlobal );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbGlobal )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlIPPrivNet_SetGlobal(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hPrivNet = (PRL_HANDLE )0;
		PRL_BOOL	bGlobal = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlIPPrivNet_SetGlobal" , &hPrivNet, &bGlobal ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlIPPrivNet_SetGlobal( hPrivNet, bGlobal );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_IsRamHotplugEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_IsRamHotplugEnabled" , &hVmCfg ) )
			break;

		PRL_BOOL	rbVmRamHotplugEnabled = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_IsRamHotplugEnabled( hVmCfg, &rbVmRamHotplugEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbVmRamHotplugEnabled )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetRamHotplugEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_BOOL	bVmRamHotplugEnabled = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmCfg_SetRamHotplugEnabled" , &hVmCfg, &bVmRamHotplugEnabled ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetRamHotplugEnabled( hVmCfg, bVmRamHotplugEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_RefreshPlugins(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;
		PRL_UINT32	nFlags = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlSrv_RefreshPlugins" , &hServer, &nFlags ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_RefreshPlugins( hServer, nFlags );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_GetPluginsList(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;
		PRL_CONST_STR	sClassId = (PRL_CONST_STR )0;
		PRL_UINT32	nFlags = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "ksI:PrlSrv_GetPluginsList" , &hServer, &sClassId, &nFlags ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_GetPluginsList( hServer, sClassId, nFlags );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVm_Mount(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;
		PRL_CONST_STR	sMntPath = (PRL_CONST_STR )0;
		PRL_UINT32	nFlags = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "ksI:PrlVm_Mount" , &hVm, &sMntPath, &nFlags ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlVm_Mount( hVm, sMntPath, nFlags );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVm_Umount(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;
		PRL_UINT32	nFlags = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVm_Umount" , &hVm, &nFlags ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlVm_Umount( hVm, nFlags );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlPluginInfo_GetVendor(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hPluginInfo = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlPluginInfo_GetVendor" , &hPluginInfo ) )
			break;

		PRL_STR	sVendor = (PRL_STR )0;
		PRL_UINT32	rnBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlPluginInfo_GetVendor( hPluginInfo, sVendor, &rnBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sVendor(rnBufLength, '\0');
		sVendor = (PRL_STR )std_sVendor.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlPluginInfo_GetVendor( hPluginInfo, sVendor, &rnBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sVendor )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlPluginInfo_GetCopyright(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hPluginInfo = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlPluginInfo_GetCopyright" , &hPluginInfo ) )
			break;

		PRL_STR	sCopyright = (PRL_STR )0;
		PRL_UINT32	rnBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlPluginInfo_GetCopyright( hPluginInfo, sCopyright, &rnBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sCopyright(rnBufLength, '\0');
		sCopyright = (PRL_STR )std_sCopyright.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlPluginInfo_GetCopyright( hPluginInfo, sCopyright, &rnBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sCopyright )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlPluginInfo_GetShortDescription(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hPluginInfo = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlPluginInfo_GetShortDescription" , &hPluginInfo ) )
			break;

		PRL_STR	sDescr = (PRL_STR )0;
		PRL_UINT32	rnBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlPluginInfo_GetShortDescription( hPluginInfo, sDescr, &rnBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sDescr(rnBufLength, '\0');
		sDescr = (PRL_STR )std_sDescr.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlPluginInfo_GetShortDescription( hPluginInfo, sDescr, &rnBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sDescr )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlPluginInfo_GetLongDescription(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hPluginInfo = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlPluginInfo_GetLongDescription" , &hPluginInfo ) )
			break;

		PRL_STR	sDescr = (PRL_STR )0;
		PRL_UINT32	rnBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlPluginInfo_GetLongDescription( hPluginInfo, sDescr, &rnBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sDescr(rnBufLength, '\0');
		sDescr = (PRL_STR )std_sDescr.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlPluginInfo_GetLongDescription( hPluginInfo, sDescr, &rnBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sDescr )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlPluginInfo_GetVersion(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hPluginInfo = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlPluginInfo_GetVersion" , &hPluginInfo ) )
			break;

		PRL_STR	sVersion = (PRL_STR )0;
		PRL_UINT32	rnBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlPluginInfo_GetVersion( hPluginInfo, sVersion, &rnBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sVersion(rnBufLength, '\0');
		sVersion = (PRL_STR )std_sVersion.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlPluginInfo_GetVersion( hPluginInfo, sVersion, &rnBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sVersion )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlPluginInfo_GetId(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hPluginInfo = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlPluginInfo_GetId" , &hPluginInfo ) )
			break;

		PRL_STR	sId = (PRL_STR )0;
		PRL_UINT32	rnBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlPluginInfo_GetId( hPluginInfo, sId, &rnBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sId(rnBufLength, '\0');
		sId = (PRL_STR )std_sId.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlPluginInfo_GetId( hPluginInfo, sId, &rnBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sId )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_LoginEx(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;
		PRL_CONST_STR	host = (PRL_CONST_STR )0;
		PRL_CONST_STR	user = (PRL_CONST_STR )0;
		PRL_CONST_STR	passwd = (PRL_CONST_STR )0;
		PRL_CONST_STR	sPrevSessionUuid = (PRL_CONST_STR )0;
		PRL_UINT32	port_cmd = (PRL_UINT32 )0;
		PRL_UINT32	timeout = (PRL_UINT32 )0;
		PRL_INT32	security_level = (PRL_INT32 )0;
		PRL_UINT32	flags = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kssssIIiI:PrlSrv_LoginEx" , &hServer, &host, &user, &passwd, &sPrevSessionUuid, &port_cmd, &timeout, &security_level, &flags ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_LoginEx( hServer, host, user, passwd, sPrevSessionUuid, port_cmd, timeout, (PRL_SECURITY_LEVEL )security_level, flags );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_LoginLocalEx(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;
		PRL_CONST_STR	sPrevSessionUuid = (PRL_CONST_STR )0;
		PRL_UINT32	port = (PRL_UINT32 )0;
		PRL_INT32	security_level = (PRL_INT32 )0;
		PRL_UINT32	flags = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "ksIiI:PrlSrv_LoginLocalEx" , &hServer, &sPrevSessionUuid, &port, &security_level, &flags ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_LoginLocalEx( hServer, sPrevSessionUuid, port, (PRL_SECURITY_LEVEL )security_level, flags );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_GetDiskFreeSpace(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;
		PRL_CONST_STR	sPath = (PRL_CONST_STR )0;
		PRL_UINT32	nFlags = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "ksI:PrlSrv_GetDiskFreeSpace" , &hServer, &sPath, &nFlags ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_GetDiskFreeSpace( hServer, sPath, nFlags );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlBackupResult_GetBackupUuid(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hBackupResult = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlBackupResult_GetBackupUuid" , &hBackupResult ) )
			break;

		PRL_STR	sBackupUuid = (PRL_STR )0;
		PRL_UINT32	rnBackupUuidBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlBackupResult_GetBackupUuid( hBackupResult, sBackupUuid, &rnBackupUuidBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sBackupUuid(rnBackupUuidBufLength, '\0');
		sBackupUuid = (PRL_STR )std_sBackupUuid.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlBackupResult_GetBackupUuid( hBackupResult, sBackupUuid, &rnBackupUuidBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sBackupUuid )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVm_Move(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVm = (PRL_HANDLE )0;
		PRL_CONST_STR	sNewHomePath = (PRL_CONST_STR )0;
		PRL_UINT32	nFlags = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "ksI:PrlVm_Move" , &hVm, &sNewHomePath, &nFlags ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlVm_Move( hVm, sNewHomePath, nFlags );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVm_Connect(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hObj = (PRL_HANDLE )0;
		PRL_UINT32	nFlags = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVm_Connect" , &hObj, &nFlags ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlVm_Connect( hObj, nFlags );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVm_Disconnect(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hObj = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVm_Disconnect" , &hObj ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVm_Disconnect( hObj );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_GetVmConfig(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;
		PRL_CONST_STR	sSearchId = (PRL_CONST_STR )0;
		PRL_UINT32	nFlags = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "ksI:PrlSrv_GetVmConfig" , &hServer, &sSearchId, &nFlags ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_GetVmConfig( hServer, sSearchId, nFlags );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetResource(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_INT32	nResourceId = (PRL_INT32 )0;

		if ( ! PyArg_ParseTuple( args, "ki:PrlVmCfg_GetResource" , &hVmCfg, &nResourceId ) )
			break;

		PRL_UINT64	rnBarrirer = (PRL_UINT64 )0;
		PRL_UINT64	rnLimit = (PRL_UINT64 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetResource( hVmCfg, (PRL_CT_RESOURCE )nResourceId, &rnBarrirer, &rnLimit );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "K", rnBarrirer )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "K", rnLimit )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetResource(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_INT32	nResourceId = (PRL_INT32 )0;
		PRL_UINT64	nBarrirer = (PRL_UINT64 )0;
		PRL_UINT64	nLimit = (PRL_UINT64 )0;

		if ( ! PyArg_ParseTuple( args, "kiKK:PrlVmCfg_SetResource" , &hVmCfg, &nResourceId, &nBarrirer, &nLimit ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetResource( hVmCfg, (PRL_CT_RESOURCE )nResourceId, nBarrirer, nLimit );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_IsAutoApplyIpOnly(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_IsAutoApplyIpOnly" , &hVmCfg ) )
			break;

		PRL_BOOL	rbAutoApplyIpOnly = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_IsAutoApplyIpOnly( hVmCfg, &rbAutoApplyIpOnly );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbAutoApplyIpOnly )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetAutoApplyIpOnly(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_BOOL	bAutoApplyIpOnly = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmCfg_SetAutoApplyIpOnly" , &hVmCfg, &bAutoApplyIpOnly ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetAutoApplyIpOnly( hVmCfg, bAutoApplyIpOnly );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetCapabilitiesMask(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_GetCapabilitiesMask" , &hVmCfg ) )
			break;

		PRL_UINT32	rnCapMask = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetCapabilitiesMask( hVmCfg, &rnCapMask );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnCapMask )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetCapabilitiesMask(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_UINT32	nCapMask = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmCfg_SetCapabilitiesMask" , &hVmCfg, &nCapMask ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetCapabilitiesMask( hVmCfg, nCapMask );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetNetfilterMode(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_GetNetfilterMode" , &hVmCfg ) )
			break;

		PRL_NETFILTER_MODE	rnMode = (PRL_NETFILTER_MODE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetNetfilterMode( hVmCfg, &rnMode );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "i", rnMode )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetNetfilterMode(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_INT32	nMode = (PRL_INT32 )0;

		if ( ! PyArg_ParseTuple( args, "ki:PrlVmCfg_SetNetfilterMode" , &hVmCfg, &nMode ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetNetfilterMode( hVmCfg, (PRL_NETFILTER_MODE )nMode );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlHandle_GetPackageId(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hObj = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlHandle_GetPackageId" , &hObj ) )
			break;

		PRL_UINT64	id = (PRL_UINT64 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlHandle_GetPackageId( hObj, &id );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "K", id )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_GetCPUPoolsList(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlSrv_GetCPUPoolsList" , &hServer ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_GetCPUPoolsList( hServer );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_MoveToCPUPool(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;
		PRL_CONST_STR	sCpuPool = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ks:PrlSrv_MoveToCPUPool" , &hServer, &sCpuPool ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_MoveToCPUPool( hServer, sCpuPool );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_RecalculateCPUPool(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;
		PRL_CONST_STR	sCpuPool = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ks:PrlSrv_RecalculateCPUPool" , &hServer, &sCpuPool ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_RecalculateCPUPool( hServer, sCpuPool );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlDispCfg_GetCpuPool(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hDispConfig = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlDispCfg_GetCpuPool" , &hDispConfig ) )
			break;

		PRL_HANDLE	rhCpuPool = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlDispCfg_GetCpuPool( hDispConfig, &rhCpuPool );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhCpuPool )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlCPUPool_GetVendor(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hCpuPool = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlCPUPool_GetVendor" , &hCpuPool ) )
			break;

		PRL_STR	sBuf = (PRL_STR )0;
		PRL_UINT32	rnBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlCPUPool_GetVendor( hCpuPool, sBuf, &rnBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sBuf(rnBufLength, '\0');
		sBuf = (PRL_STR )std_sBuf.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlCPUPool_GetVendor( hCpuPool, sBuf, &rnBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sBuf )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlCPUPool_GetName(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hCpuPool = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlCPUPool_GetName" , &hCpuPool ) )
			break;

		PRL_STR	sBuf = (PRL_STR )0;
		PRL_UINT32	rnBufLength = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlCPUPool_GetName( hCpuPool, sBuf, &rnBufLength );
		Py_END_ALLOW_THREADS

		std::string std_sBuf(rnBufLength, '\0');
		sBuf = (PRL_STR )std_sBuf.data();

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlCPUPool_GetName( hCpuPool, sBuf, &rnBufLength );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "s", sBuf )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlCPUPool_GetCpuFeaturesMask(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hCpuPool = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlCPUPool_GetCpuFeaturesMask" , &hCpuPool ) )
			break;

		PRL_HANDLE	rhCpuFeatures = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlCPUPool_GetCpuFeaturesMask( hCpuPool, &rhCpuFeatures );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rhCpuFeatures )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetFeaturesMask(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_GetFeaturesMask" , &hVmCfg ) )
			break;

		PRL_UINT32	rnOn = (PRL_UINT32 )0;
		PRL_UINT32	rnOff = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetFeaturesMask( hVmCfg, &rnOn, &rnOff );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnOn )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnOff )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetFeaturesMask(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_UINT32	nOn = (PRL_UINT32 )0;
		PRL_UINT32	nOff = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kII:PrlVmCfg_SetFeaturesMask" , &hVmCfg, &nOn, &nOff ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetFeaturesMask( hVmCfg, nOn, nOff );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_SendProblemReport(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hServer = (PRL_HANDLE )0;
		PRL_HANDLE	hProblemReport = (PRL_HANDLE )0;
		PRL_UINT32	nFlags = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kkI:PrlSrv_SendProblemReport" , &hServer, &hProblemReport, &nFlags ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlSrv_SendProblemReport( hServer, hProblemReport, nFlags );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlHandle_FromString(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hHandle = (PRL_HANDLE )0;
		PRL_CONST_STR	sXml = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ks:PrlHandle_FromString" , &hHandle, &sXml ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlHandle_FromString( hHandle, sXml );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlEvent_FromString(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hEvent = (PRL_HANDLE )0;
		PRL_CONST_STR	sEvent = (PRL_CONST_STR )0;

		if ( ! PyArg_ParseTuple( args, "ks:PrlEvent_FromString" , &hEvent, &sEvent ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlEvent_FromString( hEvent, sEvent );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlApi_SwitchConsoleLogging(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_BOOL	bSwitchOn = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "I:PrlApi_SwitchConsoleLogging" , &bSwitchOn ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlApi_SwitchConsoleLogging( bSwitchOn );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetHighAvailabilityEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_BOOL	bEnabled = (PRL_BOOL )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmCfg_SetHighAvailabilityEnabled" , &hVmCfg, &bEnabled ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetHighAvailabilityEnabled( hVmCfg, bEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_IsHighAvailabilityEnabled(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_IsHighAvailabilityEnabled" , &hVmCfg ) )
			break;

		PRL_BOOL	rbEnabled = (PRL_BOOL )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_IsHighAvailabilityEnabled( hVmCfg, &rbEnabled );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rbEnabled )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetHighAvailabilityPriority(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;
		PRL_UINT32	nPriority = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlVmCfg_SetHighAvailabilityPriority" , &hVmCfg, &nPriority ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetHighAvailabilityPriority( hVmCfg, nPriority );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetHighAvailabilityPriority(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hVmCfg = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlVmCfg_GetHighAvailabilityPriority" , &hVmCfg ) )
			break;

		PRL_UINT32	rnPriority = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetHighAvailabilityPriority( hVmCfg, &rnPriority );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnPriority )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlDisk_OpenDisk_Local(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_CONST_STR	pDiskName = (PRL_CONST_STR )0;
		PRL_DISK_OPEN_FLAGS	OpenFlags = (PRL_DISK_OPEN_FLAGS )0;
		PRL_HANDLE	hPolicyList = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "sIk:PrlDisk_OpenDisk_Local" , &pDiskName, &OpenFlags, &hPolicyList ) )
			break;

		PRL_HANDLE	rHandle = (PRL_HANDLE )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlDisk_OpenDisk_Local( &rHandle, pDiskName, OpenFlags, hPolicyList );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", rHandle )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlDisk_WaitForCompletion(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	Handle = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlDisk_WaitForCompletion" , &Handle ) )
			break;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlDisk_WaitForCompletion( Handle );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlDiskMap_GetSize(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hMap = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlDiskMap_GetSize" , &hMap ) )
			break;

		PRL_UINT32	rnSize = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlDiskMap_GetSize( hMap, &rnSize );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnSize )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlDiskMap_GetGranularity(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hMap = (PRL_HANDLE )0;

		if ( ! PyArg_ParseTuple( args, "k:PrlDiskMap_GetGranularity" , &hMap ) )
			break;

		PRL_UINT32	rnSize = (PRL_UINT32 )0;

		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlDiskMap_GetGranularity( hMap, &rnSize );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "I", rnSize )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlApi_Init(PyObject* self, PyObject* args)
{
        return sdk_InitializeSDKEx(self, args);
}

static PyObject* sdk_PrlApi_InitEx(PyObject* self, PyObject* args)
{
        return sdk_InitializeSDKEx(self, args);
}

static PyObject* sdk_PrlApi_Deinit(PyObject* self, PyObject* args)
{
        return sdk_DeinitializeSDK(self, args);
}

static PRL_RESULT PrlHandle_EventCallbackHandler(PRL_HANDLE hEvent, PRL_VOID_PTR user_data)
{
	PyGILState_STATE gstate = PyGILState_Ensure();
	do {
		PRL_HANDLE_TYPE type;
		PRL_HANDLE handle = (PRL_HANDLE)0;
		PyObject *py_callback_function;
		PyObject *py_user_data;
		if (PrlHandle_GetType(hEvent, &type))
			break;
		if (type == PHT_EVENT) {
			if (!PyArg_ParseTuple((PyObject *)user_data, "kOO", &handle, &py_callback_function, &py_user_data))
				break;
			PyObject *arglist;
			arglist = Py_BuildValue("(i,O)", hEvent, py_user_data);
			PyObject *call_obj_result;
			call_obj_result = PyObject_CallObject(py_callback_function, arglist);
			if (PyErr_Occurred())
				PyErr_Print();
			Py_XDECREF(call_obj_result);
			Py_DECREF(arglist);
		}
	} while(0);
	PyGILState_Release(gstate);
	return PRL_ERR_SUCCESS;
}

static PyObject* sdk_PrlApi_SendProblemReport(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_CONST_STR	sProblemReport = (PRL_CONST_STR )0;
		PRL_BOOL	bUseProxy = (PRL_BOOL )0;
		PRL_CONST_STR	sProxyHost = (PRL_CONST_STR )0;
		PRL_UINT32	nProxyPort = (PRL_UINT32 )0;
		PRL_CONST_STR	sProxyUserLogin = (PRL_CONST_STR )0;
		PRL_CONST_STR	sProxyUserPasswd = (PRL_CONST_STR )0;
		PRL_UINT32	nProblemSendTimeout = (PRL_UINT32 )0;
		PRL_UINT32	nReserved = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "sIsIssII:PrlApi_SendProblemReport" , &sProblemReport, &bUseProxy, &sProxyHost, &nProxyPort, &sProxyUserLogin, &sProxyUserPasswd, &nProblemSendTimeout, &nReserved ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlApi_SendProblemReport( sProblemReport, bUseProxy, sProxyHost, nProxyPort, sProxyUserLogin, sProxyUserPasswd, nProblemSendTimeout, nReserved, 0, 0 );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlSrv_GetDefaultVmConfig(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hSrv = (PRL_HANDLE )0;
		PRL_VM_TYPE nVmType = (PRL_VM_TYPE )0;
		PRL_STR sConfigSample = (PRL_STR )0;
		PRL_UINT32 nOsVersion = (PRL_UINT32 )0;
		PRL_UINT32 nFlags = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kIsII:PrlSrv_GetDefaultVmConfig" ,				&hSrv, &nVmType, &sConfigSample, &nOsVersion, &nFlags ) )
			break;

		PRL_GET_VM_CONFIG_PARAM_DATA config_data;
		config_data.nVmType = nVmType;
		config_data.sConfigSample = sConfigSample;
		config_data.nOsVersion = nOsVersion;

		PRL_HANDLE hResultJob = PrlSrv_GetDefaultVmConfig(hSrv, &config_data, nFlags);
		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_GetMemGuaranteeSize(PyObject* /*self*/, PyObject* args){
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE hVm;

		if (!PyArg_ParseTuple(args, "k:PrlVmCfg_GetMemGuaranteeSize" , &hVm))
			break;

		PRL_MEMGUARANTEE_DATA data;
		PRL_RESULT prlResult;

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_GetMemGuaranteeSize(hVm, &data);
		Py_END_ALLOW_THREADS
		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if (PyList_Append(ret_list, Py_BuildValue("k", prlResult)))
			break;
		if (PyList_Append(ret_list, Py_BuildValue("I", data.type)))
			break;
		if (PyList_Append(ret_list, Py_BuildValue("I", data.value)))
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlVmCfg_SetMemGuaranteeSize(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE hVm;
		PRL_MEMGUARANTEE_TYPE nType;
		PRL_UINT32 nValue;

		if (!PyArg_ParseTuple(args, "kII:PrlVmCfg_SetMemGuaranteeSize" ,
				&hVm, &nType, &nValue))
			break;

		PRL_MEMGUARANTEE_DATA data;
		data.type = nType;
		data.value = nValue;
		PRL_RESULT prlResult;

		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlVmCfg_SetMemGuaranteeSize(hVm, &data);
		Py_END_ALLOW_THREADS
		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if (PyList_Append(ret_list, Py_BuildValue("k", prlResult)))
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static int generateGuid(PRL_GUID *guid, char *buf, size_t len)
{
        int ret = snprintf(buf, len, "%08x-%04x-%04x-%02x%02x-%02x%02x%02x%02x%02x%02x",
                        guid->Data1,
                        guid->Data2,
                        guid->Data3,
                        guid->Data4[0],
                        guid->Data4[1],
                        guid->Data4[2],
                        guid->Data4[3],
                        guid->Data4[4],
                        guid->Data4[5],
                        guid->Data4[6],
                        guid->Data4[7]);
        if (ret < 0 || ret >= (ssize_t)len)
                return -1;
        return 0;
}

static PyObject* sdk_PrlDisk_GetDiskInfo(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hDisk = (PRL_HANDLE )0;
		PyObject *info = NULL;
		if ( ! PyArg_ParseTuple( args, "kO:PrlDisk_GetDiskInfo" , &hDisk, &info) )
			break;
		if (info == NULL)
			break;

		PRL_DISK_PARAMETERS_PTR disk_params = NULL;
		PRL_UINT32 size = 0;
		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlDisk_GetDiskInfo(hDisk, disk_params, &size);
		Py_END_ALLOW_THREADS

		char *buf = new char[size];
		memset(buf, 0, size);
		disk_params = (PRL_DISK_PARAMETERS_PTR) buf;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlDisk_GetDiskInfo(hDisk, disk_params, &size);
		Py_END_ALLOW_THREADS

		if ( PyObject_SetAttrString(info, "heads", Py_BuildValue("i", disk_params->m_Heads)))
			break;
		if ( PyObject_SetAttrString(info, "cylinders", Py_BuildValue("i", disk_params->m_Cylinders)))
			break;
		if ( PyObject_SetAttrString(info, "sectors", Py_BuildValue("i", disk_params->m_Sectors)))
			break;
		if ( PyObject_SetAttrString(info, "sizeInSectors", Py_BuildValue("L", disk_params->m_SizeInSectors)))
			break;
		if ( PyObject_SetAttrString(info, "blockSize", Py_BuildValue("i", disk_params->m_BlockSize)))
			break;
		if ( PyObject_SetAttrString(info, "parts", Py_BuildValue("i", disk_params->m_Parts)))
			break;

		PyObject *storages = PyList_New(0);
		int i;
		for (i=0; i < (int) disk_params->m_Parts; ++i) {
			if( PyList_Append(storages, Py_BuildValue("s", disk_params->m_Storages[i].pFileName)))
				break;
		}
		if (i < (int) disk_params->m_Parts)
			break;
		if ( PyObject_SetAttrString(info, "storages", storages))
			break;

		char guid[37];
		generateGuid(&disk_params->Uid, guid, sizeof(guid));
		if ( PyObject_SetAttrString(info, "uid", Py_BuildValue("s", guid)))
			break;
		if ( PyObject_SetAttrString(info, "name", Py_BuildValue("s", disk_params->Name)))
			break;
		delete[] buf;

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, info) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlOpTypeList_GetItem(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hOpTypeList = (PRL_HANDLE )0;
		PRL_UINT32 nItemIndex = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kI:PrlOpTypeList_GetItem" , &hOpTypeList, &nItemIndex ) )
			break;

		PRL_INT64	nInt64 = 0LL;
		PRL_UINT64	nUInt64 = 0LL;
		double		dDouble = 0.0;

		PRL_SIZE nTypeSize = 0;
		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlOpTypeList_GetTypeSize(hOpTypeList, &nTypeSize);
		Py_END_ALLOW_THREADS
		if (PRL_SUCCEEDED(prlResult))
		{
			std::string buf(nTypeSize, 0);
			Py_BEGIN_ALLOW_THREADS
			prlResult = PrlOpTypeList_GetItem(hOpTypeList, nItemIndex, (PRL_VOID_PTR )buf.data());
			Py_END_ALLOW_THREADS
			if (PRL_SUCCEEDED(prlResult))
			{
				switch(nTypeSize)
				{
				case 1:
					nInt64 = PRL_INT64(*( (PRL_INT8* )buf.data() ));
					nUInt64 = PRL_UINT64(*( (PRL_UINT8* )buf.data() ));
					break;
				case 2:
					nInt64 = PRL_INT64(*( (PRL_INT16* )buf.data() ));
					nUInt64 = PRL_UINT64(*( (PRL_UINT16* )buf.data() ));
					break;
				case 4:
					nInt64 = PRL_INT64(*( (PRL_INT32* )buf.data() ));
					nUInt64 = PRL_UINT64(*( (PRL_UINT32* )buf.data() ));
					break;
				case 8:
					nInt64 = PRL_INT64(*( (PRL_INT64* )buf.data() ));
					nUInt64 = PRL_UINT64(*( (PRL_UINT64* )buf.data() ));
					dDouble = double(*( (double* )buf.data() ));
					break;
				default:
					PyErr_Format(PyExc_TypeError, "Unsupported opaque type size = %u!", nTypeSize);
					return NULL;
				}
			}
		}

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "L", nInt64 )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "K", nUInt64 )) )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "d", dDouble )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlReport_GetData(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hHandle = (PRL_HANDLE )0;
		if ( ! PyArg_ParseTuple( args, "k:PrlReport_GetData" , &hHandle ) )
			break;

		PyObject* pBufObj = NULL;
		PRL_UINT32 nBufLength = 0;
		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlReport_GetData(hHandle, NULL, &nBufLength);
		Py_END_ALLOW_THREADS
		if (PRL_SUCCEEDED(prlResult))
		{
#if (PY_VERSION_HEX >= 0x02050000)
			Py_ssize_t nBufSize = (Py_ssize_t )nBufLength;
#else
			int nBufSize = (int )nBufLength;
#endif
			pBufObj = PyBuffer_New( nBufSize );
			if ( ! pBufObj )
				return NULL;
			PRL_VOID_PTR pBuf = NULL;
			if ( PyObject_AsWriteBuffer(pBufObj, &pBuf, &nBufSize) )
				return NULL;
			Py_BEGIN_ALLOW_THREADS
			prlResult = PrlReport_GetData(hHandle, pBuf, &nBufLength);
			Py_END_ALLOW_THREADS
		}

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( pBufObj )
			if ( PyList_Append(ret_list, pBufObj) )
				break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlReport_Send(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hProblemReport = (PRL_HANDLE )0;
		PRL_BOOL	bUseProxy = (PRL_BOOL )0;
		PRL_CONST_STR	sProxyHost = (PRL_CONST_STR )0;
		PRL_UINT32	nProxyPort = (PRL_UINT32 )0;
		PRL_CONST_STR	sProxyUserLogin = (PRL_CONST_STR )0;
		PRL_CONST_STR	sProxyUserPasswd = (PRL_CONST_STR )0;
		PRL_UINT32	nProblemSendTimeout = (PRL_UINT32 )0;
		PRL_UINT32	nReserved = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kIsIssII:PrlReport_Send" , &hProblemReport, &bUseProxy, &sProxyHost, &nProxyPort, &sProxyUserLogin, &sProxyUserPasswd, &nProblemSendTimeout, &nReserved ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlReport_Send( hProblemReport, bUseProxy, sProxyHost, nProxyPort, sProxyUserLogin, sProxyUserPasswd, nProblemSendTimeout, nReserved, 0, 0 );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlApi_SendPackedProblemReport(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hProblemReport = (PRL_HANDLE )0;
		PRL_BOOL	bUseProxy = (PRL_BOOL )0;
		PRL_CONST_STR	sProxyHost = (PRL_CONST_STR )0;
		PRL_UINT32	nProxyPort = (PRL_UINT32 )0;
		PRL_CONST_STR	sProxyUserLogin = (PRL_CONST_STR )0;
		PRL_CONST_STR	sProxyUserPasswd = (PRL_CONST_STR )0;
		PRL_UINT32	nProblemSendTimeout = (PRL_UINT32 )0;
		PRL_UINT32	nReserved = (PRL_UINT32 )0;

		if ( ! PyArg_ParseTuple( args, "kIsIssII:PrlApi_SendPackedProblemReport" , &hProblemReport, &bUseProxy, &sProxyHost, &nProxyPort, &sProxyUserLogin, &sProxyUserPasswd, &nProblemSendTimeout, &nReserved ) )
			break;

		PRL_HANDLE hResultJob;
		Py_BEGIN_ALLOW_THREADS
		hResultJob = PrlApi_SendPackedProblemReport( hProblemReport, bUseProxy, sProxyHost, nProxyPort, sProxyUserLogin, sProxyUserPasswd, nProblemSendTimeout, nReserved, 0, 0 );
		Py_END_ALLOW_THREADS

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", hResultJob )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject* sdk_PrlDiskMap_Read(PyObject* /*self*/, PyObject* args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE	hHandle = (PRL_HANDLE )0;
		if ( ! PyArg_ParseTuple( args, "k:PrlDiskMap_Read" , &hHandle ) )
			break;

		PyObject* pBufObj = NULL;
		PRL_UINT32 nBufLength = 0;
		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlDiskMap_Read(hHandle, NULL, &nBufLength);
		Py_END_ALLOW_THREADS
		if (PRL_SUCCEEDED(prlResult))
		{
#if (PY_VERSION_HEX >= 0x02050000)
			Py_ssize_t nBufSize = (Py_ssize_t )nBufLength;
#else
			int nBufSize = (int )nBufLength;
#endif
			pBufObj = PyBuffer_New( nBufSize );
			if ( ! pBufObj )
				return NULL;
			PRL_VOID_PTR pBuf = NULL;
			if ( PyObject_AsWriteBuffer(pBufObj, &pBuf, &nBufSize) )
				return NULL;
			Py_BEGIN_ALLOW_THREADS
			prlResult = PrlDiskMap_Read(hHandle, pBuf, &nBufLength);
			Py_END_ALLOW_THREADS
		}

		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		if ( pBufObj )
			if ( PyList_Append(ret_list, pBufObj) )
				break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject *sdk_PrlHandle_RegEventHandler(PyObject* /*self*/, PyObject *args)
{
	PRL_SDK_CHECK;
	do {
		PyObject *py_callback_function;
		PyObject *py_user_data;
		PRL_HANDLE handle = (PRL_HANDLE)0;
		if ( ! PyArg_ParseTuple(args, "kOO:PrlHandle_RegEventHandler", &handle, &py_callback_function, &py_user_data))
			break;
		if ( ! PyCallable_Check(py_callback_function)) {
			PyErr_SetString(PyExc_TypeError, "parameter must be callable");
			break;
		}
		PRL_RESULT prlResult;
		Py_BEGIN_ALLOW_THREADS
		prlResult = PrlHandle_RegEventHandler(handle, PrlHandle_EventCallbackHandler, (PRL_VOID_PTR) args);
		Py_END_ALLOW_THREADS
		if (PRL_SUCCEEDED(prlResult)) {
			Py_XINCREF(args);
			args_vector.push_back(args);
		}
		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject *sdk_PrlHandle_UnregEventHandler(PyObject* /*self*/, PyObject *args)
{
	PRL_SDK_CHECK;
	do {
		PRL_HANDLE handle = (PRL_HANDLE)0;
		PyObject *py_callback_function;
		PyObject *py_user_data;
		PRL_RESULT prlResult = PRL_ERR_FAILURE;
		if ( ! PyArg_ParseTuple(args, "kOO:PrlSrv_UnregEventHandler", &handle, &py_callback_function, &py_user_data)) 
			break;
		for (std::vector<PyObject *>::size_type i = 0; i != args_vector.size(); i++) {
			if (PyObject_RichCompareBool(args, args_vector[i], Py_EQ)){ 
				Py_BEGIN_ALLOW_THREADS
				prlResult = PrlHandle_UnregEventHandler(handle, PrlHandle_EventCallbackHandler, (PRL_VOID_PTR) args_vector[i]);
				Py_END_ALLOW_THREADS
				if (PRL_SUCCEEDED(prlResult)) {
					Py_XDECREF(args_vector[i]);
					args_vector.erase(args_vector.begin() + i);
				}
				break;
			}
		}
		PyObject* ret_list = PyList_New(0);
		if ( ! ret_list )
			break;
		if ( PyList_Append(ret_list, Py_BuildValue( "k", prlResult )) )
			break;
		return ret_list;
	} while(0);
	return NULL;
}

static PyObject *sdk_PrlSrv_RegEventHandler(PyObject* self, PyObject *args)
{
	PRL_SDK_CHECK;
	return sdk_PrlHandle_RegEventHandler(self, args);
}

static PyObject *sdk_PrlSrv_UnregEventHandler(PyObject* self, PyObject *args)
{
	PRL_SDK_CHECK;
	return sdk_PrlHandle_UnregEventHandler(self, args);
}

static PyObject *sdk_PrlVm_RegEventHandler(PyObject* self, PyObject *args)
{
	PRL_SDK_CHECK;
	return sdk_PrlHandle_RegEventHandler(self, args);
}

static PyObject *sdk_PrlVm_UnregEventHandler(PyObject* self, PyObject *args)
{
	PRL_SDK_CHECK;
	return sdk_PrlHandle_UnregEventHandler(self, args);
}
static PyMethodDef SdkPythonBundle[] = 
{
	{"SetSDKLibraryPath", sdk_SetSDKLibraryPath, METH_VARARGS, "SetSDKLibraryPath"},
	{"GetSDKLibraryPath", sdk_GetSDKLibraryPath, METH_NOARGS, "GetSDKLibraryPath"},
	{"IsSDKInitialized", sdk_IsSDKInitialized, METH_NOARGS, "IsSDKInitialized"},
	{"InitializeSDK", sdk_InitializeSDK, METH_VARARGS, "InitializeSDK"},
	{"InitializeSDKEx", sdk_InitializeSDKEx, METH_VARARGS, "InitializeSDKEx"},
	{"DeinitializeSDK", sdk_DeinitializeSDK, METH_NOARGS, "DeinitializeSDK"},
	{"PrlApi_Init", sdk_PrlApi_Init, METH_VARARGS, "Initialize the Parallels API library. "},
	{"PrlApi_InitEx", sdk_PrlApi_InitEx, METH_VARARGS, "Initialize the Parallels API library (extended version)."},
	{"PrlApi_Deinit", sdk_PrlApi_Deinit, METH_NOARGS, "De-initializes the library."},
	{"PrlApi_GetVersion", sdk_PrlApi_GetVersion, METH_NOARGS, "Return the Parallels API version number. "},
	{"PrlApi_GetAppMode", sdk_PrlApi_GetAppMode, METH_NOARGS, "Return the Parallels API application mode. "},
	{"PrlApi_GetResultDescription", sdk_PrlApi_GetResultDescription, METH_VARARGS, "Evaluate a return code and return a description of the problem. "},
	{"PrlApi_GetMessageType", sdk_PrlApi_GetMessageType, METH_VARARGS, "Evaluate the specified error code and return its classification (warning, question, info, etc.). "},
	{"PrlApi_MsgCanBeIgnored", sdk_PrlApi_MsgCanBeIgnored, METH_VARARGS, "Evaluate an error code and determine if the error is critical."},
	{"PrlApi_GetCrashDumpsPath", sdk_PrlApi_GetCrashDumpsPath, METH_NOARGS, "Return the name and path of the directory where Parallels crash dumps are stored. "},
	{"PrlApi_InitCrashHandler", sdk_PrlApi_InitCrashHandler, METH_VARARGS, "Initiate the standard Parallels crash dump handler. "},
	{"PrlApi_CreateStringsList", sdk_PrlApi_CreateStringsList, METH_NOARGS, ""},
	{"PrlApi_CreateHandlesList", sdk_PrlApi_CreateHandlesList, METH_NOARGS, ""},
	{"PrlApi_CreateOpTypeList", sdk_PrlApi_CreateOpTypeList, METH_VARARGS, ""},
	{"PrlApi_GetSupportedOsesTypes", sdk_PrlApi_GetSupportedOsesTypes, METH_VARARGS, "Determine the supported OS types for the current API mode."},
	{"PrlApi_GetSupportedOsesVersions", sdk_PrlApi_GetSupportedOsesVersions, METH_VARARGS, "PrlApi_GetSupportedOsesVersions"},
	{"PrlApi_GetDefaultOsVersion", sdk_PrlApi_GetDefaultOsVersion, METH_VARARGS, "Return the default guest OS version for the specified guest OS type."},
	{"PrlApi_SendProblemReport", sdk_PrlApi_SendProblemReport, METH_VARARGS, "Send a problem report to the Parallels support server."},
	{"PrlApi_SendPackedProblemReport", sdk_PrlApi_SendPackedProblemReport, METH_VARARGS, "PrlApi_SendPackedProblemReport"},
	{"PrlStrList_GetItemsCount", sdk_PrlStrList_GetItemsCount, METH_VARARGS, ""},
	{"PrlStrList_AddItem", sdk_PrlStrList_AddItem, METH_VARARGS, ""},
	{"PrlStrList_GetItem", sdk_PrlStrList_GetItem, METH_VARARGS, ""},
	{"PrlStrList_RemoveItem", sdk_PrlStrList_RemoveItem, METH_VARARGS, ""},
	{"PrlHndlList_GetItemsCount", sdk_PrlHndlList_GetItemsCount, METH_VARARGS, ""},
	{"PrlHndlList_AddItem", sdk_PrlHndlList_AddItem, METH_VARARGS, ""},
	{"PrlHndlList_GetItem", sdk_PrlHndlList_GetItem, METH_VARARGS, ""},
	{"PrlHndlList_RemoveItem", sdk_PrlHndlList_RemoveItem, METH_VARARGS, ""},
	{"PrlOpTypeList_GetItemsCount", sdk_PrlOpTypeList_GetItemsCount, METH_VARARGS, "PrlOpTypeList_GetItemsCount"},
	{"PrlOpTypeList_GetItem", sdk_PrlOpTypeList_GetItem, METH_VARARGS, "PrlOpTypeList_GetItem"},
	{"PrlOpTypeList_RemoveItem", sdk_PrlOpTypeList_RemoveItem, METH_VARARGS, "PrlOpTypeList_RemoveItem"},
	{"PrlOpTypeList_GetTypeSize", sdk_PrlOpTypeList_GetTypeSize, METH_VARARGS, "PrlOpTypeList_GetTypeSize"},
	{"PrlApi_GetRecommendMinVmMem", sdk_PrlApi_GetRecommendMinVmMem, METH_VARARGS, "Return recommended minimal memory size for guest OS defined in the OS version parameter. "},
	{"PrlHandle_AddRef", sdk_PrlHandle_AddRef, METH_VARARGS, ""},
	{"PrlHandle_Free", sdk_PrlHandle_Free, METH_VARARGS, ""},
	{"PrlHandle_GetType", sdk_PrlHandle_GetType, METH_VARARGS, ""},
	{"PrlDbg_GetHandlesNum", sdk_PrlDbg_GetHandlesNum, METH_VARARGS, "Determine how many handles were instantiated in the API library."},
	{"PrlDbg_PrlResultToString", sdk_PrlDbg_PrlResultToString, METH_VARARGS, "Return a readable string representation of the L{Result} value."},
	{"PrlDbg_HandleTypeToString", sdk_PrlDbg_HandleTypeToString, METH_VARARGS, "Return a readable string representation of the specified handle type."},
	{"PrlDbg_EventTypeToString", sdk_PrlDbg_EventTypeToString, METH_VARARGS, "Return a readable string representation of the specified event type. "},
	{"PrlJob_Wait", sdk_PrlJob_Wait, METH_VARARGS, "Suspend the main thread and wait for the job to finish."},
	{"PrlJob_Cancel", sdk_PrlJob_Cancel, METH_VARARGS, "Cancel the specified job."},
	{"PrlJob_GetStatus", sdk_PrlJob_GetStatus, METH_VARARGS, "Obtain the current job status. "},
	{"PrlJob_GetProgress", sdk_PrlJob_GetProgress, METH_VARARGS, "Obtain the job progress info. "},
	{"PrlJob_GetRetCode", sdk_PrlJob_GetRetCode, METH_VARARGS, "Obtain the return code from the job object. "},
	{"PrlJob_GetResult", sdk_PrlJob_GetResult, METH_VARARGS, "Obtain the L{Result} object containing the results returned by the job."},
	{"PrlJob_GetError", sdk_PrlJob_GetError, METH_VARARGS, "Provide additional job error information. "},
	{"PrlJob_GetOpCode", sdk_PrlJob_GetOpCode, METH_VARARGS, "Return the job operation code. "},
	{"PrlJob_IsRequestWasSent", sdk_PrlJob_IsRequestWasSent, METH_VARARGS, "PrlJob_IsRequestWasSent"},
	{"PrlResult_GetParamsCount", sdk_PrlResult_GetParamsCount, METH_VARARGS, "Determine the number of items (strings, objects) in the Result object."},
	{"PrlResult_GetParamByIndex", sdk_PrlResult_GetParamByIndex, METH_VARARGS, "Obtain an object containing the results identified by index."},
	{"PrlResult_GetParam", sdk_PrlResult_GetParam, METH_VARARGS, "Obtain an object containing the results of the corresponding asynchronous operation."},
	{"PrlResult_GetParamByIndexAsString", sdk_PrlResult_GetParamByIndexAsString, METH_VARARGS, "Obtain a string result from the Result object identified by index."},
	{"PrlResult_GetParamAsString", sdk_PrlResult_GetParamAsString, METH_VARARGS, "Obtain a string result from the Result object."},
	{"PrlEvent_GetType", sdk_PrlEvent_GetType, METH_VARARGS, ""},
	{"PrlEvent_GetServer", sdk_PrlEvent_GetServer, METH_VARARGS, ""},
	{"PrlEvent_GetVm", sdk_PrlEvent_GetVm, METH_VARARGS, ""},
	{"PrlEvent_GetJob", sdk_PrlEvent_GetJob, METH_VARARGS, ""},
	{"PrlEvent_GetParamsCount", sdk_PrlEvent_GetParamsCount, METH_VARARGS, ""},
	{"PrlEvent_GetParam", sdk_PrlEvent_GetParam, METH_VARARGS, ""},
	{"PrlEvent_GetParamByName", sdk_PrlEvent_GetParamByName, METH_VARARGS, ""},
	{"PrlEvent_GetErrCode", sdk_PrlEvent_GetErrCode, METH_VARARGS, ""},
	{"PrlEvent_GetErrString", sdk_PrlEvent_GetErrString, METH_VARARGS, ""},
	{"PrlEvent_CanBeIgnored", sdk_PrlEvent_CanBeIgnored, METH_VARARGS, ""},
	{"PrlEvent_IsAnswerRequired", sdk_PrlEvent_IsAnswerRequired, METH_VARARGS, ""},
	{"PrlEvent_GetIssuerType", sdk_PrlEvent_GetIssuerType, METH_VARARGS, ""},
	{"PrlEvent_GetIssuerId", sdk_PrlEvent_GetIssuerId, METH_VARARGS, ""},
	{"PrlEvent_CreateAnswerEvent", sdk_PrlEvent_CreateAnswerEvent, METH_VARARGS, ""},
	{"PrlEvtPrm_GetName", sdk_PrlEvtPrm_GetName, METH_VARARGS, ""},
	{"PrlEvtPrm_GetType", sdk_PrlEvtPrm_GetType, METH_VARARGS, ""},
	{"PrlEvtPrm_ToString", sdk_PrlEvtPrm_ToString, METH_VARARGS, ""},
	{"PrlEvtPrm_ToCData", sdk_PrlEvtPrm_ToCData, METH_VARARGS, ""},
	{"PrlEvtPrm_ToUint32", sdk_PrlEvtPrm_ToUint32, METH_VARARGS, ""},
	{"PrlEvtPrm_ToInt32", sdk_PrlEvtPrm_ToInt32, METH_VARARGS, ""},
	{"PrlEvtPrm_ToUint64", sdk_PrlEvtPrm_ToUint64, METH_VARARGS, "PrlEvtPrm_ToUint64"},
	{"PrlEvtPrm_ToInt64", sdk_PrlEvtPrm_ToInt64, METH_VARARGS, "PrlEvtPrm_ToInt64"},
	{"PrlEvtPrm_ToBoolean", sdk_PrlEvtPrm_ToBoolean, METH_VARARGS, ""},
	{"PrlEvtPrm_ToHandle", sdk_PrlEvtPrm_ToHandle, METH_VARARGS, ""},
	{"PrlSrv_Create", sdk_PrlSrv_Create, METH_NOARGS, "Create a new instance of the Server class."},
	{"PrlSrv_Login", sdk_PrlSrv_Login, METH_VARARGS, "Login to a remote Parallels Service. "},
	{"PrlSrv_LoginLocal", sdk_PrlSrv_LoginLocal, METH_VARARGS, "Login to the local Parallels Service. "},
	{"PrlSrv_Logoff", sdk_PrlSrv_Logoff, METH_VARARGS, "Log off the Parallels Service."},
	{"PrlSrv_RegEventHandler", sdk_PrlSrv_RegEventHandler, METH_VARARGS, "Register an event handler. "},
	{"PrlSrv_UnregEventHandler", sdk_PrlSrv_UnregEventHandler, METH_VARARGS, "Unregister the specified event handler."},
	{"PrlSrv_GetQuestions", sdk_PrlSrv_GetQuestions, METH_VARARGS, "Allows to synchronously receive questions from Parallels Service."},
	{"PrlSrv_SetNonInteractiveSession", sdk_PrlSrv_SetNonInteractiveSession, METH_VARARGS, "Set the session in noninteractive or interactive mode. "},
	{"PrlSrv_IsNonInteractiveSession", sdk_PrlSrv_IsNonInteractiveSession, METH_VARARGS, "PrlSrv_IsNonInteractiveSession"},
	{"PrlSrv_DisableConfirmationMode", sdk_PrlSrv_DisableConfirmationMode, METH_VARARGS, "Disable administrator confirmation mode for the session. "},
	{"PrlSrv_EnableConfirmationMode", sdk_PrlSrv_EnableConfirmationMode, METH_VARARGS, "Enable administrator confirmation mode for the session. "},
	{"PrlSrv_IsConfirmationModeEnabled", sdk_PrlSrv_IsConfirmationModeEnabled, METH_VARARGS, "Determine confirmation mode for the session."},
	{"PrlSrv_GetSrvConfig", sdk_PrlSrv_GetSrvConfig, METH_VARARGS, "Obtain the L{ServerConfig} object containing the host configuration information. "},
	{"PrlSrv_GetCommonPrefs", sdk_PrlSrv_GetCommonPrefs, METH_VARARGS, "Obtain the L{DispConfig} object containing the specified Parallels Service preferences info. "},
	{"PrlSrv_CommonPrefsBeginEdit", sdk_PrlSrv_CommonPrefsBeginEdit, METH_VARARGS, "Mark the beginning of the Parallels Service preferences modification operation."},
	{"PrlSrv_CommonPrefsCommit", sdk_PrlSrv_CommonPrefsCommit, METH_VARARGS, "Commit the Parallels Server preferences changes."},
	{"PrlSrv_CommonPrefsCommitEx", sdk_PrlSrv_CommonPrefsCommitEx, METH_VARARGS, "PrlSrv_CommonPrefsCommitEx"},
	{"PrlSrv_GetUserProfile", sdk_PrlSrv_GetUserProfile, METH_VARARGS, "Obtain the L{UserConfig} object containing profile data of the currently logged in user. "},
	{"PrlSrv_GetUserInfoList", sdk_PrlSrv_GetUserInfoList, METH_VARARGS, "Obtain a list of L{UserInfo} objects containing information about all known users. "},
	{"PrlSrv_GetUserInfo", sdk_PrlSrv_GetUserInfo, METH_VARARGS, "Obtain the L{UserInfo} object containing information about the specified user. "},
	{"PrlSrv_GetVirtualNetworkList", sdk_PrlSrv_GetVirtualNetworkList, METH_VARARGS, "Obtain the L{VirtualNet} object containing information about all existing virtual networks."},
	{"PrlSrv_AddVirtualNetwork", sdk_PrlSrv_AddVirtualNetwork, METH_VARARGS, "Add a new virtual network to the Parallels Service configuration."},
	{"PrlSrv_UpdateVirtualNetwork", sdk_PrlSrv_UpdateVirtualNetwork, METH_VARARGS, "Update parameters of an existing virtual network. "},
	{"PrlSrv_DeleteVirtualNetwork", sdk_PrlSrv_DeleteVirtualNetwork, METH_VARARGS, "Remove an existing virtual network from the Parallels Service configuration. "},
	{"PrlOffmgmtService_Create", sdk_PrlOffmgmtService_Create, METH_NOARGS, "PrlOffmgmtService_Create"},
	{"PrlOffmgmtService_GetName", sdk_PrlOffmgmtService_GetName, METH_VARARGS, "PrlOffmgmtService_GetName"},
	{"PrlOffmgmtService_SetName", sdk_PrlOffmgmtService_SetName, METH_VARARGS, "PrlOffmgmtService_SetName"},
	{"PrlOffmgmtService_GetPort", sdk_PrlOffmgmtService_GetPort, METH_VARARGS, "PrlOffmgmtService_GetPort"},
	{"PrlOffmgmtService_SetPort", sdk_PrlOffmgmtService_SetPort, METH_VARARGS, "PrlOffmgmtService_SetPort"},
	{"PrlOffmgmtService_IsUsedByDefault", sdk_PrlOffmgmtService_IsUsedByDefault, METH_VARARGS, "PrlOffmgmtService_IsUsedByDefault"},
	{"PrlOffmgmtService_SetUsedByDefault", sdk_PrlOffmgmtService_SetUsedByDefault, METH_VARARGS, "PrlOffmgmtService_SetUsedByDefault"},
	{"PrlSrv_UpdateOfflineService", sdk_PrlSrv_UpdateOfflineService, METH_VARARGS, "PrlSrv_UpdateOfflineService"},
	{"PrlSrv_DeleteOfflineService", sdk_PrlSrv_DeleteOfflineService, METH_VARARGS, "PrlSrv_DeleteOfflineService"},
	{"PrlSrv_GetOfflineServicesList", sdk_PrlSrv_GetOfflineServicesList, METH_VARARGS, "PrlSrv_GetOfflineServicesList"},
	{"PrlNetworkClass_Create", sdk_PrlNetworkClass_Create, METH_VARARGS, "PrlNetworkClass_Create"},
	{"PrlNetworkClass_GetClassId", sdk_PrlNetworkClass_GetClassId, METH_VARARGS, "PrlNetworkClass_GetClassId"},
	{"PrlNetworkClass_SetClassId", sdk_PrlNetworkClass_SetClassId, METH_VARARGS, "PrlNetworkClass_SetClassId"},
	{"PrlNetworkClass_GetNetworkList", sdk_PrlNetworkClass_GetNetworkList, METH_VARARGS, "PrlNetworkClass_GetNetworkList"},
	{"PrlNetworkClass_SetNetworkList", sdk_PrlNetworkClass_SetNetworkList, METH_VARARGS, "PrlNetworkClass_SetNetworkList"},
	{"PrlSrv_UpdateNetworkClassesList", sdk_PrlSrv_UpdateNetworkClassesList, METH_VARARGS, "PrlSrv_UpdateNetworkClassesList"},
	{"PrlSrv_GetNetworkClassesList", sdk_PrlSrv_GetNetworkClassesList, METH_VARARGS, "PrlSrv_GetNetworkClassesList"},
	{"PrlNetworkShapingEntry_Create", sdk_PrlNetworkShapingEntry_Create, METH_VARARGS, "PrlNetworkShapingEntry_Create"},
	{"PrlNetworkShapingEntry_GetClassId", sdk_PrlNetworkShapingEntry_GetClassId, METH_VARARGS, "PrlNetworkShapingEntry_GetClassId"},
	{"PrlNetworkShapingEntry_SetClassId", sdk_PrlNetworkShapingEntry_SetClassId, METH_VARARGS, "PrlNetworkShapingEntry_SetClassId"},
	{"PrlNetworkShapingEntry_GetTotalRate", sdk_PrlNetworkShapingEntry_GetTotalRate, METH_VARARGS, "PrlNetworkShapingEntry_GetTotalRate"},
	{"PrlNetworkShapingEntry_SetTotalRate", sdk_PrlNetworkShapingEntry_SetTotalRate, METH_VARARGS, "PrlNetworkShapingEntry_SetTotalRate"},
	{"PrlNetworkShapingEntry_SetDevice", sdk_PrlNetworkShapingEntry_SetDevice, METH_VARARGS, "PrlNetworkShapingEntry_SetDevice"},
	{"PrlNetworkShapingEntry_GetDevice", sdk_PrlNetworkShapingEntry_GetDevice, METH_VARARGS, "PrlNetworkShapingEntry_GetDevice"},
	{"PrlNetworkShapingEntry_SetRate", sdk_PrlNetworkShapingEntry_SetRate, METH_VARARGS, "PrlNetworkShapingEntry_SetRate"},
	{"PrlNetworkShapingEntry_GetRate", sdk_PrlNetworkShapingEntry_GetRate, METH_VARARGS, "PrlNetworkShapingEntry_GetRate"},
	{"PrlNetworkShapingEntry_SetRateMPU", sdk_PrlNetworkShapingEntry_SetRateMPU, METH_VARARGS, "PrlNetworkShapingEntry_SetRateMPU"},
	{"PrlNetworkShapingEntry_GetRateMPU", sdk_PrlNetworkShapingEntry_GetRateMPU, METH_VARARGS, "PrlNetworkShapingEntry_GetRateMPU"},
	{"PrlSrv_UpdateNetworkShapingConfig", sdk_PrlSrv_UpdateNetworkShapingConfig, METH_VARARGS, "PrlSrv_UpdateNetworkShapingConfig"},
	{"PrlSrv_GetNetworkShapingConfig", sdk_PrlSrv_GetNetworkShapingConfig, METH_VARARGS, "PrlSrv_GetNetworkShapingConfig"},
	{"PrlNetworkShapingConfig_IsEnabled", sdk_PrlNetworkShapingConfig_IsEnabled, METH_VARARGS, "PrlNetworkShapingConfig_IsEnabled"},
	{"PrlNetworkShapingConfig_SetEnabled", sdk_PrlNetworkShapingConfig_SetEnabled, METH_VARARGS, "PrlNetworkShapingConfig_SetEnabled"},
	{"PrlNetworkShapingConfig_GetNetworkShapingList", sdk_PrlNetworkShapingConfig_GetNetworkShapingList, METH_VARARGS, "PrlNetworkShapingConfig_GetNetworkShapingList"},
	{"PrlNetworkShapingConfig_SetNetworkShapingList", sdk_PrlNetworkShapingConfig_SetNetworkShapingList, METH_VARARGS, "PrlNetworkShapingConfig_SetNetworkShapingList"},
	{"PrlNetworkShapingBandwidthEntry_Create", sdk_PrlNetworkShapingBandwidthEntry_Create, METH_VARARGS, "PrlNetworkShapingBandwidthEntry_Create"},
	{"PrlNetworkShapingBandwidthEntry_SetDevice", sdk_PrlNetworkShapingBandwidthEntry_SetDevice, METH_VARARGS, "PrlNetworkShapingBandwidthEntry_SetDevice"},
	{"PrlNetworkShapingBandwidthEntry_GetDevice", sdk_PrlNetworkShapingBandwidthEntry_GetDevice, METH_VARARGS, "PrlNetworkShapingBandwidthEntry_GetDevice"},
	{"PrlNetworkShapingBandwidthEntry_SetBandwidth", sdk_PrlNetworkShapingBandwidthEntry_SetBandwidth, METH_VARARGS, "PrlNetworkShapingBandwidthEntry_SetBandwidth"},
	{"PrlNetworkShapingBandwidthEntry_GetBandwidth", sdk_PrlNetworkShapingBandwidthEntry_GetBandwidth, METH_VARARGS, "PrlNetworkShapingBandwidthEntry_GetBandwidth"},
	{"PrlNetworkShapingConfig_GetNetworkDeviceBandwidthList", sdk_PrlNetworkShapingConfig_GetNetworkDeviceBandwidthList, METH_VARARGS, "PrlNetworkShapingConfig_GetNetworkDeviceBandwidthList"},
	{"PrlNetworkShapingConfig_SetNetworkDeviceBandwidthList", sdk_PrlNetworkShapingConfig_SetNetworkDeviceBandwidthList, METH_VARARGS, "PrlNetworkShapingConfig_SetNetworkDeviceBandwidthList"},
	{"PrlNetworkRate_Create", sdk_PrlNetworkRate_Create, METH_VARARGS, "PrlNetworkRate_Create"},
	{"PrlNetworkRate_GetClassId", sdk_PrlNetworkRate_GetClassId, METH_VARARGS, "PrlNetworkRate_GetClassId"},
	{"PrlNetworkRate_GetRate", sdk_PrlNetworkRate_GetRate, METH_VARARGS, "PrlNetworkRate_GetRate"},
	{"PrlVmCfg_SetNetworkRateList", sdk_PrlVmCfg_SetNetworkRateList, METH_VARARGS, "PrlVmCfg_SetNetworkRateList"},
	{"PrlVmCfg_GetNetworkRateList", sdk_PrlVmCfg_GetNetworkRateList, METH_VARARGS, "PrlVmCfg_GetNetworkRateList"},
	{"PrlVmCfg_IsRateBound", sdk_PrlVmCfg_IsRateBound, METH_VARARGS, "PrlVmCfg_IsRateBound"},
	{"PrlVmCfg_SetRateBound", sdk_PrlVmCfg_SetRateBound, METH_VARARGS, "PrlVmCfg_SetRateBound"},
	{"PrlVmCfg_SetOsTemplate", sdk_PrlVmCfg_SetOsTemplate, METH_VARARGS, "PrlVmCfg_SetOsTemplate"},
	{"PrlVmCfg_GetOsTemplate", sdk_PrlVmCfg_GetOsTemplate, METH_VARARGS, "PrlVmCfg_GetOsTemplate"},
	{"PrlVmCfg_ApplyConfigSample", sdk_PrlVmCfg_ApplyConfigSample, METH_VARARGS, "PrlVmCfg_ApplyConfigSample"},
	{"PrlVmCfg_GetAppTemplateList", sdk_PrlVmCfg_GetAppTemplateList, METH_VARARGS, "PrlVmCfg_GetAppTemplateList"},
	{"PrlVmCfg_SetAppTemplateList", sdk_PrlVmCfg_SetAppTemplateList, METH_VARARGS, "PrlVmCfg_SetAppTemplateList"},
	{"PrlSrv_ConfigureGenericPci", sdk_PrlSrv_ConfigureGenericPci, METH_VARARGS, "Configure the PCI device assignment. "},
	{"PrlSrv_GetStatistics", sdk_PrlSrv_GetStatistics, METH_VARARGS, "Obtain the L{Statistics} object containing the host resource usage statistics. "},
	{"PrlSrv_UserProfileBeginEdit", sdk_PrlSrv_UserProfileBeginEdit, METH_VARARGS, "PrlSrv_UserProfileBeginEdit"},
	{"PrlSrv_UserProfileCommit", sdk_PrlSrv_UserProfileCommit, METH_VARARGS, "Saves (commits) user profile changes to the Parallels Service. "},
	{"PrlSrv_IsConnected", sdk_PrlSrv_IsConnected, METH_VARARGS, "Determine if the connection to the specified Parallels Service is active. "},
	{"PrlSrv_GetServerInfo", sdk_PrlSrv_GetServerInfo, METH_VARARGS, "Obtain the L{ServerInfo} object containing the host computer information."},
	{"PrlSrv_RegisterVm", sdk_PrlSrv_RegisterVm, METH_VARARGS, "Register an existing virtual machine with the Parallels Service."},
	{"PrlSrv_RegisterVmEx", sdk_PrlSrv_RegisterVmEx, METH_VARARGS, "Register an existing virtual machine with Parallels Service (extended version). "},
	{"PrlSrv_RegisterVmWithUuid", sdk_PrlSrv_RegisterVmWithUuid, METH_VARARGS, "PrlSrv_RegisterVmWithUuid"},
	{"PrlSrv_Register3rdPartyVm", sdk_PrlSrv_Register3rdPartyVm, METH_VARARGS, "PrlSrv_Register3rdPartyVm"},
	{"PrlSrv_CreateVm", sdk_PrlSrv_CreateVm, METH_VARARGS, "Create a new instaince of the L{Vm} class."},
	{"PrlSrv_GetVmList", sdk_PrlSrv_GetVmList, METH_VARARGS, "Obtain a list of virtual machines from the host."},
	{"PrlSrv_GetVmListEx", sdk_PrlSrv_GetVmListEx, METH_VARARGS, "PrlSrv_GetVmListEx"},
	{"PrlSrv_GetDefaultVmConfig", sdk_PrlSrv_GetDefaultVmConfig, METH_VARARGS, "PrlSrv_GetDefaultVmConfig"},
	{"PrlSrv_CreateVmBackup", sdk_PrlSrv_CreateVmBackup, METH_VARARGS, "Backup an existing virtual machine to a backup server."},
	{"PrlSrv_RestoreVmBackup", sdk_PrlSrv_RestoreVmBackup, METH_VARARGS, "Restore a virtual machine from a backup server. "},
	{"PrlSrv_GetBackupTree", sdk_PrlSrv_GetBackupTree, METH_VARARGS, "Obtain a backup tree from the backup server. "},
	{"PrlSrv_RemoveVmBackup", sdk_PrlSrv_RemoveVmBackup, METH_VARARGS, "Remove backup of the virtual machine from the backup server."},
	{"PrlSrv_SubscribeToHostStatistics", sdk_PrlSrv_SubscribeToHostStatistics, METH_VARARGS, "Subscribe to receive host statistics."},
	{"PrlSrv_UnsubscribeFromHostStatistics", sdk_PrlSrv_UnsubscribeFromHostStatistics, METH_VARARGS, "Cancel the host statistics subscription."},
	{"PrlSrv_Shutdown", sdk_PrlSrv_Shutdown, METH_VARARGS, "Shut down the Parallels Service. "},
	{"PrlSrv_ShutdownEx", sdk_PrlSrv_ShutdownEx, METH_VARARGS, "PrlSrv_ShutdownEx"},
	{"PrlSrv_FsGetDiskList", sdk_PrlSrv_FsGetDiskList, METH_VARARGS, "Returns a list of root directories on the host computer. "},
	{"PrlSrv_FsGetDirEntries", sdk_PrlSrv_FsGetDirEntries, METH_VARARGS, "Retrieve information about a file system entry on the host. "},
	{"PrlSrv_FsCreateDir", sdk_PrlSrv_FsCreateDir, METH_VARARGS, "Create a directory in the specified location on the host. "},
	{"PrlSrv_FsRemoveEntry", sdk_PrlSrv_FsRemoveEntry, METH_VARARGS, "Remove a file system entry from the host computer. "},
	{"PrlSrv_FsCanCreateFile", sdk_PrlSrv_FsCanCreateFile, METH_VARARGS, "Determine if the current user has rights to create a file on the host. "},
	{"PrlSrv_FsRenameEntry", sdk_PrlSrv_FsRenameEntry, METH_VARARGS, "Rename a file system entry on the host. "},
	{"PrlSrv_UpdateLicense", sdk_PrlSrv_UpdateLicense, METH_VARARGS, "Installs Parallels license on the specified Parallels Service. "},
	{"PrlSrv_UpdateLicenseEx", sdk_PrlSrv_UpdateLicenseEx, METH_VARARGS, "PrlSrv_UpdateLicenseEx"},
	{"PrlSrv_GetLicenseInfo", sdk_PrlSrv_GetLicenseInfo, METH_VARARGS, "Obtain the L{License} object containing the Parallels license information. "},
	{"PrlSrv_SendAnswer", sdk_PrlSrv_SendAnswer, METH_VARARGS, "Send an answer to the Parallels Service in response to a question. "},
	{"PrlSrv_StartSearchVms", sdk_PrlSrv_StartSearchVms, METH_VARARGS, "Searche for unregistered virtual machines at the specified location(s). "},
	{"PrlFsInfo_GetType", sdk_PrlFsInfo_GetType, METH_VARARGS, "Determine the basic type of the file system entry. "},
	{"PrlFsInfo_GetFsType", sdk_PrlFsInfo_GetFsType, METH_VARARGS, "Determine the file system type of the file system entry. "},
	{"PrlFsInfo_GetChildEntriesCount", sdk_PrlFsInfo_GetChildEntriesCount, METH_VARARGS, "Determine the number of child entries for the specified remote file system entry. "},
	{"PrlFsInfo_GetChildEntry", sdk_PrlFsInfo_GetChildEntry, METH_VARARGS, "Obtain the L{FsEntry} object containing a child entry information."},
	{"PrlFsInfo_GetParentEntry", sdk_PrlFsInfo_GetParentEntry, METH_VARARGS, "Obtain the L{FsEntry} object containing the parent file system entry info."},
	{"PrlFsEntry_GetAbsolutePath", sdk_PrlFsEntry_GetAbsolutePath, METH_VARARGS, "Return the specified file system entry absolute path. "},
	{"PrlFsEntry_GetRelativeName", sdk_PrlFsEntry_GetRelativeName, METH_VARARGS, "Return the file system entry relative name. "},
	{"PrlFsEntry_GetLastModifiedDate", sdk_PrlFsEntry_GetLastModifiedDate, METH_VARARGS, "Return the date on which the specified file system entry was last modified. "},
	{"PrlFsEntry_GetSize", sdk_PrlFsEntry_GetSize, METH_VARARGS, "Return the file system entry size. "},
	{"PrlFsEntry_GetPermissions", sdk_PrlFsEntry_GetPermissions, METH_VARARGS, "Return the specified file system entry permissions (read, write, execute) for the current user. "},
	{"PrlFsEntry_GetType", sdk_PrlFsEntry_GetType, METH_VARARGS, "Return the file system entry type (file, directory, drive). "},
	{"PrlSrv_NetServiceStart", sdk_PrlSrv_NetServiceStart, METH_VARARGS, "Start the Parallels network service. "},
	{"PrlSrv_NetServiceStop", sdk_PrlSrv_NetServiceStop, METH_VARARGS, "Stop the Parallels network service. "},
	{"PrlSrv_NetServiceRestart", sdk_PrlSrv_NetServiceRestart, METH_VARARGS, "Restarts the Parallels network service. "},
	{"PrlSrv_NetServiceRestoreDefaults", sdk_PrlSrv_NetServiceRestoreDefaults, METH_VARARGS, "Restores the default settings of the Parallels network service. "},
	{"PrlSrv_GetNetServiceStatus", sdk_PrlSrv_GetNetServiceStatus, METH_VARARGS, "Obtain the L{NetService} object containing the Parallels network service status information."},
	{"PrlSrv_GetProblemReport", sdk_PrlSrv_GetProblemReport, METH_VARARGS, "Obtain a problem report in the event of a virtual machine operation failure."},
	{"PrlSrv_GetPackedProblemReport", sdk_PrlSrv_GetPackedProblemReport, METH_VARARGS, "PrlSrv_GetPackedProblemReport"},
	{"PrlSrv_AttachToLostTask", sdk_PrlSrv_AttachToLostTask, METH_VARARGS, "Obtain a handle to a running task after the connection to the Parallels Service was lost."},
	{"PrlSrv_GetSupportedOses", sdk_PrlSrv_GetSupportedOses, METH_VARARGS, "PrlSrv_GetSupportedOses"},
	{"PrlSrvCfg_GetHostRamSize", sdk_PrlSrvCfg_GetHostRamSize, METH_VARARGS, "Determine the amount of memory (RAM) available on the host. "},
	{"PrlSrvCfg_GetCpuModel", sdk_PrlSrvCfg_GetCpuModel, METH_VARARGS, "Determine the model of CPU of the host machine. "},
	{"PrlSrvCfg_GetCpuCount", sdk_PrlSrvCfg_GetCpuCount, METH_VARARGS, "Determine the number of CPUs in the host machine. "},
	{"PrlSrvCfg_GetCpuSpeed", sdk_PrlSrvCfg_GetCpuSpeed, METH_VARARGS, "Determine the host machine CPU speed. "},
	{"PrlSrvCfg_GetCpuMode", sdk_PrlSrvCfg_GetCpuMode, METH_VARARGS, "Determine the CPU mode (32 bit or 64 bit) of the host machine. "},
	{"PrlSrvCfg_GetCpuHvt", sdk_PrlSrvCfg_GetCpuHvt, METH_VARARGS, "Determine the hardware virtualization type of the host CPU."},
	{"PrlSrvCfg_GetCpuFeaturesEx", sdk_PrlSrvCfg_GetCpuFeaturesEx, METH_VARARGS, "PrlSrvCfg_GetCpuFeaturesEx"},
	{"PrlSrvCfg_GetCpuFeaturesMaskingCapabilities", sdk_PrlSrvCfg_GetCpuFeaturesMaskingCapabilities, METH_VARARGS, "PrlSrvCfg_GetCpuFeaturesMaskingCapabilities"},
	{"PrlSrvCfg_GetHostOsType", sdk_PrlSrvCfg_GetHostOsType, METH_VARARGS, "Return the host operating system type. "},
	{"PrlSrvCfg_GetHostOsMajor", sdk_PrlSrvCfg_GetHostOsMajor, METH_VARARGS, "Return the major version number of the host operating system. "},
	{"PrlSrvCfg_GetHostOsMinor", sdk_PrlSrvCfg_GetHostOsMinor, METH_VARARGS, "Return the minor version number of the host operating system. "},
	{"PrlSrvCfg_GetHostOsSubMinor", sdk_PrlSrvCfg_GetHostOsSubMinor, METH_VARARGS, "Return the sub-minor version number of the host operating system."},
	{"PrlSrvCfg_GetHostOsStrPresentation", sdk_PrlSrvCfg_GetHostOsStrPresentation, METH_VARARGS, "Return the full host operating system information as a single string. "},
	{"PrlSrvCfg_IsSoundDefaultEnabled", sdk_PrlSrvCfg_IsSoundDefaultEnabled, METH_VARARGS, "Determine whether a sound device on the host is enabled or disabled. "},
	{"PrlSrvCfg_IsUsbSupported", sdk_PrlSrvCfg_IsUsbSupported, METH_VARARGS, "Determine if USB is supported on the host. "},
	{"PrlSrvCfg_IsVtdSupported", sdk_PrlSrvCfg_IsVtdSupported, METH_VARARGS, "Determine whether VT-d is supported on the host. "},
	{"PrlSrvCfg_GetMaxHostNetAdapters", sdk_PrlSrvCfg_GetMaxHostNetAdapters, METH_VARARGS, "PrlSrvCfg_GetMaxHostNetAdapters"},
	{"PrlSrvCfg_GetMaxVmNetAdapters", sdk_PrlSrvCfg_GetMaxVmNetAdapters, METH_VARARGS, "PrlSrvCfg_GetMaxVmNetAdapters"},
	{"PrlSrvCfg_GetHostname", sdk_PrlSrvCfg_GetHostname, METH_VARARGS, "Return the hostname of the specified host or guest. "},
	{"PrlSrvCfg_GetDefaultGateway", sdk_PrlSrvCfg_GetDefaultGateway, METH_VARARGS, "Obtain the global default gateway address of the specified host or guest. "},
	{"PrlSrvCfg_GetDefaultGatewayIPv6", sdk_PrlSrvCfg_GetDefaultGatewayIPv6, METH_VARARGS, "PrlSrvCfg_GetDefaultGatewayIPv6"},
	{"PrlSrvCfg_GetDnsServers", sdk_PrlSrvCfg_GetDnsServers, METH_VARARGS, "Obtain the list of IP addresses of DNS servers for the host or guest. "},
	{"PrlSrvCfg_GetSearchDomains", sdk_PrlSrvCfg_GetSearchDomains, METH_VARARGS, "Obtain the list of search domains for the specified host or guest. "},
	{"PrlSrvCfg_GetFloppyDisksCount", sdk_PrlSrvCfg_GetFloppyDisksCount, METH_VARARGS, "Determine the number of floppy disk drives on the host. "},
	{"PrlSrvCfg_GetFloppyDisk", sdk_PrlSrvCfg_GetFloppyDisk, METH_VARARGS, "Obtain the L{HostDevice} object containing information about a floppy disk drive on the host. "},
	{"PrlSrvCfg_GetOpticalDisksCount", sdk_PrlSrvCfg_GetOpticalDisksCount, METH_VARARGS, "Determine the number of optical disk drives on the host."},
	{"PrlSrvCfg_GetOpticalDisk", sdk_PrlSrvCfg_GetOpticalDisk, METH_VARARGS, "Obtain the L{HostDevice} object containing information about an optical disk drive on the host."},
	{"PrlSrvCfg_GetSerialPortsCount", sdk_PrlSrvCfg_GetSerialPortsCount, METH_VARARGS, "Determine the number of serial ports available on the host. "},
	{"PrlSrvCfg_GetSerialPort", sdk_PrlSrvCfg_GetSerialPort, METH_VARARGS, "Obtain the L{HostDevice} object containing information about a serial port on the host. "},
	{"PrlSrvCfg_GetParallelPortsCount", sdk_PrlSrvCfg_GetParallelPortsCount, METH_VARARGS, "Determine the number of parallel ports on the host."},
	{"PrlSrvCfg_GetParallelPort", sdk_PrlSrvCfg_GetParallelPort, METH_VARARGS, "Obtain the L{HostDevice} object containing information about a parallel port on the host. "},
	{"PrlSrvCfg_GetSoundOutputDevsCount", sdk_PrlSrvCfg_GetSoundOutputDevsCount, METH_VARARGS, "Determine the number of sound devices available on the host. "},
	{"PrlSrvCfg_GetSoundOutputDev", sdk_PrlSrvCfg_GetSoundOutputDev, METH_VARARGS, "Obtain the L{HostDevice} object containing information about a sound device on the host. "},
	{"PrlSrvCfg_GetSoundMixerDevsCount", sdk_PrlSrvCfg_GetSoundMixerDevsCount, METH_VARARGS, "Determine the number of sound mixer devices available on the host. "},
	{"PrlSrvCfg_GetSoundMixerDev", sdk_PrlSrvCfg_GetSoundMixerDev, METH_VARARGS, "Obtain the L{HostDevice} object containing information about a sound mixer device on the host. "},
	{"PrlSrvCfg_GetPrintersCount", sdk_PrlSrvCfg_GetPrintersCount, METH_VARARGS, "Determine the number of printers installed on the host. "},
	{"PrlSrvCfg_GetPrinter", sdk_PrlSrvCfg_GetPrinter, METH_VARARGS, "Obtain the L{HostDevice} object containing information about a printer installed on the host. "},
	{"PrlSrvCfg_GetGenericPciDevicesCount", sdk_PrlSrvCfg_GetGenericPciDevicesCount, METH_VARARGS, "Determine the number of PCI devices installed on the host. "},
	{"PrlSrvCfg_GetGenericPciDevice", sdk_PrlSrvCfg_GetGenericPciDevice, METH_VARARGS, "Obtain the L{HostDevice} object containing information about a PCI device installed on the host."},
	{"PrlSrvCfg_GetGenericScsiDevicesCount", sdk_PrlSrvCfg_GetGenericScsiDevicesCount, METH_VARARGS, "Determine the number of generic SCSI devices installed on the host. "},
	{"PrlSrvCfg_GetGenericScsiDevice", sdk_PrlSrvCfg_GetGenericScsiDevice, METH_VARARGS, "Obtain the L{HostDevice} object containing information about a generic SCSI device."},
	{"PrlSrvCfg_GetUsbDevsCount", sdk_PrlSrvCfg_GetUsbDevsCount, METH_VARARGS, "Determine the number of USB devices on the host. "},
	{"PrlSrvCfg_GetUsbDev", sdk_PrlSrvCfg_GetUsbDev, METH_VARARGS, "Obtain the L{HostDevice} object containing information about a USB device on the host. "},
	{"PrlSrvCfg_GetHardDisksCount", sdk_PrlSrvCfg_GetHardDisksCount, METH_VARARGS, "Determine the number of hard disk drives on the host. "},
	{"PrlSrvCfg_GetHardDisk", sdk_PrlSrvCfg_GetHardDisk, METH_VARARGS, "Obtain the L{HostHardDisk} object containing information about a hard disks drive on the host."},
	{"PrlSrvCfg_GetNetAdaptersCount", sdk_PrlSrvCfg_GetNetAdaptersCount, METH_VARARGS, "Determine the number of network adapters available on the server."},
	{"PrlSrvCfg_GetNetAdapter", sdk_PrlSrvCfg_GetNetAdapter, METH_VARARGS, "Obtain the L{HostNet} object containing information about a network adapter in the host or guest."},
	{"PrlSrvCfgDev_GetName", sdk_PrlSrvCfgDev_GetName, METH_VARARGS, "Obtain the device name. "},
	{"PrlSrvCfgDev_GetId", sdk_PrlSrvCfgDev_GetId, METH_VARARGS, "Obtain the device ID. "},
	{"PrlSrvCfgDev_GetType", sdk_PrlSrvCfgDev_GetType, METH_VARARGS, "Obtain the device type. "},
	{"PrlSrvCfgDev_IsConnectedToVm", sdk_PrlSrvCfgDev_IsConnectedToVm, METH_VARARGS, "Determine whether the device is connected to a virtual machine. "},
	{"PrlSrvCfgDev_GetDeviceState", sdk_PrlSrvCfgDev_GetDeviceState, METH_VARARGS, "Determine whether a virtual machine can directly use a PCI device through IOMMU technology."},
	{"PrlSrvCfgDev_SetDeviceState", sdk_PrlSrvCfgDev_SetDeviceState, METH_VARARGS, "Set whether a virtual machine can directly use a PCI device through IOMMU technology."},
	{"PrlSrvCfgHdd_GetDevName", sdk_PrlSrvCfgHdd_GetDevName, METH_VARARGS, "Return the hard disk device name."},
	{"PrlSrvCfgHdd_GetDevId", sdk_PrlSrvCfgHdd_GetDevId, METH_VARARGS, "Return the hard disk device id. "},
	{"PrlSrvCfgHdd_GetDevSize", sdk_PrlSrvCfgHdd_GetDevSize, METH_VARARGS, "Return the size of the hard disk device. "},
	{"PrlSrvCfgHdd_GetDiskIndex", sdk_PrlSrvCfgHdd_GetDiskIndex, METH_VARARGS, "Return the index of a hard disk device."},
	{"PrlSrvCfgHdd_GetPartsCount", sdk_PrlSrvCfgHdd_GetPartsCount, METH_VARARGS, "Determine the number of partitions available on a hard drive. "},
	{"PrlSrvCfgHdd_GetPart", sdk_PrlSrvCfgHdd_GetPart, METH_VARARGS, "Obtain the L{HdPartition} object identifying the specified hard disk partition."},
	{"PrlSrvCfgHddPart_GetName", sdk_PrlSrvCfgHddPart_GetName, METH_VARARGS, "Return the hard disk partition name. "},
	{"PrlSrvCfgHddPart_GetSysName", sdk_PrlSrvCfgHddPart_GetSysName, METH_VARARGS, "Return the hard disk partition system name. "},
	{"PrlSrvCfgHddPart_GetSize", sdk_PrlSrvCfgHddPart_GetSize, METH_VARARGS, "Return the hard disk partition size. "},
	{"PrlSrvCfgHddPart_GetIndex", sdk_PrlSrvCfgHddPart_GetIndex, METH_VARARGS, "Return the index of the hard disk partition. "},
	{"PrlSrvCfgHddPart_GetType", sdk_PrlSrvCfgHddPart_GetType, METH_VARARGS, "Return a numerical code identifying the type of the partition. "},
	{"PrlSrvCfgHddPart_IsInUse", sdk_PrlSrvCfgHddPart_IsInUse, METH_VARARGS, "Determines whether the partition is in use ( contains valid file system, being used for swap, etc.)."},
	{"PrlSrvCfgHddPart_IsLogical", sdk_PrlSrvCfgHddPart_IsLogical, METH_VARARGS, "Determine whether the specified partition is a logical partition. "},
	{"PrlSrvCfgHddPart_IsActive", sdk_PrlSrvCfgHddPart_IsActive, METH_VARARGS, "Determine whether the disk partition is active or inactive. "},
	{"PrlSrvCfgNet_GetNetAdapterType", sdk_PrlSrvCfgNet_GetNetAdapterType, METH_VARARGS, "Return the network adapter type. "},
	{"PrlSrvCfgNet_GetSysIndex", sdk_PrlSrvCfgNet_GetSysIndex, METH_VARARGS, "Return the network adapter system index. "},
	{"PrlSrvCfgNet_IsEnabled", sdk_PrlSrvCfgNet_IsEnabled, METH_VARARGS, "Determine whether the adapter is enabled or disabled. "},
	{"PrlSrvCfgNet_IsConfigureWithDhcp", sdk_PrlSrvCfgNet_IsConfigureWithDhcp, METH_VARARGS, "Determine whether the adapter network settings are configured through DHCP."},
	{"PrlSrvCfgNet_IsConfigureWithDhcpIPv6", sdk_PrlSrvCfgNet_IsConfigureWithDhcpIPv6, METH_VARARGS, "PrlSrvCfgNet_IsConfigureWithDhcpIPv6"},
	{"PrlSrvCfgNet_GetDefaultGateway", sdk_PrlSrvCfgNet_GetDefaultGateway, METH_VARARGS, "Obtain the default gateway address for the specified network adapter. "},
	{"PrlSrvCfgNet_GetDefaultGatewayIPv6", sdk_PrlSrvCfgNet_GetDefaultGatewayIPv6, METH_VARARGS, "PrlSrvCfgNet_GetDefaultGatewayIPv6"},
	{"PrlSrvCfgNet_GetMacAddress", sdk_PrlSrvCfgNet_GetMacAddress, METH_VARARGS, "Return the MAC address of the specified network adapter. "},
	{"PrlSrvCfgNet_GetVlanTag", sdk_PrlSrvCfgNet_GetVlanTag, METH_VARARGS, "Return the VLAN tag of the network adapter. "},
	{"PrlSrvCfgNet_GetNetAddresses", sdk_PrlSrvCfgNet_GetNetAddresses, METH_VARARGS, "Obtain the list of network addresses (IP address/Subnet mask pairs) assigned to the network adapter."},
	{"PrlSrvCfgNet_GetDnsServers", sdk_PrlSrvCfgNet_GetDnsServers, METH_VARARGS, "Obtain the list of addresses of DNS servers assigned to the specified network adapter. "},
	{"PrlSrvCfgNet_GetSearchDomains", sdk_PrlSrvCfgNet_GetSearchDomains, METH_VARARGS, "Obtain a list of search domains assigned to the specified network adapter. "},
	{"PrlSrvCfgPci_GetDeviceClass", sdk_PrlSrvCfgPci_GetDeviceClass, METH_VARARGS, ""},
	{"PrlSrvCfgPci_IsPrimaryDevice", sdk_PrlSrvCfgPci_IsPrimaryDevice, METH_VARARGS, "PrlSrvCfgPci_IsPrimaryDevice"},
	{"PrlUsrCfg_GetVmDirUuid", sdk_PrlUsrCfg_GetVmDirUuid, METH_VARARGS, "Return name and path of the default virtual machine folder for the Parallels Service."},
	{"PrlUsrCfg_SetVmDirUuid", sdk_PrlUsrCfg_SetVmDirUuid, METH_VARARGS, "Set the default virtual machine directory name and path for the Parallels Service."},
	{"PrlUsrCfg_GetDefaultVmFolder", sdk_PrlUsrCfg_GetDefaultVmFolder, METH_VARARGS, "Return name and path of the default virtual machine directory for the user."},
	{"PrlUsrCfg_SetDefaultVmFolder", sdk_PrlUsrCfg_SetDefaultVmFolder, METH_VARARGS, "Set the default virtual machine folder for the user. "},
	{"PrlUsrCfg_CanUseMngConsole", sdk_PrlUsrCfg_CanUseMngConsole, METH_VARARGS, "Determine if the user is allowed to use the Parallels Service Management Console."},
	{"PrlUsrCfg_CanChangeSrvSets", sdk_PrlUsrCfg_CanChangeSrvSets, METH_VARARGS, "Determine if the current user can modify Parallels Service preferences. "},
	{"PrlUsrCfg_IsLocalAdministrator", sdk_PrlUsrCfg_IsLocalAdministrator, METH_VARARGS, "Determine if the user is a local administrator on the host where Parallels Service is running."},
	{"PrlUsrInfo_GetName", sdk_PrlUsrInfo_GetName, METH_VARARGS, "Return the user name."},
	{"PrlUsrInfo_GetUuid", sdk_PrlUsrInfo_GetUuid, METH_VARARGS, "Returns the user Universally Unique Identifier (UUID)."},
	{"PrlUsrInfo_GetSessionCount", sdk_PrlUsrInfo_GetSessionCount, METH_VARARGS, "Return the user active session count."},
	{"PrlUsrInfo_GetDefaultVmFolder", sdk_PrlUsrInfo_GetDefaultVmFolder, METH_VARARGS, "Return name and path of the default virtual machine directory for the user."},
	{"PrlUsrInfo_CanChangeSrvSets", sdk_PrlUsrInfo_CanChangeSrvSets, METH_VARARGS, "Determine whether the specified user is allowed to modify Parallels Service preferences."},
	{"PrlDispCfg_GetDefaultVmDir", sdk_PrlDispCfg_GetDefaultVmDir, METH_VARARGS, "Obtain name and path of the directory in which new virtual machines are created by default."},
	{"PrlDispCfg_GetDefaultCtDir", sdk_PrlDispCfg_GetDefaultCtDir, METH_VARARGS, "PrlDispCfg_GetDefaultCtDir"},
	{"PrlDispCfg_GetReservedMemLimit", sdk_PrlDispCfg_GetReservedMemLimit, METH_VARARGS, "Determine the amount of physical memory reserved for Parallels Service operation."},
	{"PrlDispCfg_SetReservedMemLimit", sdk_PrlDispCfg_SetReservedMemLimit, METH_VARARGS, "Set the amount of memory that will be allocated for Parallels Service operation."},
	{"PrlDispCfg_GetMinVmMem", sdk_PrlDispCfg_GetMinVmMem, METH_VARARGS, "Determine the minimum required memory size that must be allocated to an individual virtual machine."},
	{"PrlDispCfg_SetMinVmMem", sdk_PrlDispCfg_SetMinVmMem, METH_VARARGS, "Set the minimum required memory size that must be allocated to an individual virtual machine."},
	{"PrlDispCfg_GetMaxVmMem", sdk_PrlDispCfg_GetMaxVmMem, METH_VARARGS, "Determine the maximum memory size that can be allocated to an individual virtual machine."},
	{"PrlDispCfg_SetMaxVmMem", sdk_PrlDispCfg_SetMaxVmMem, METH_VARARGS, "Set the maximum memory size that can be allocated to an individual virtual machine."},
	{"PrlDispCfg_GetRecommendMaxVmMem", sdk_PrlDispCfg_GetRecommendMaxVmMem, METH_VARARGS, "Determine the recommended memory size for an individual virtual machine."},
	{"PrlDispCfg_SetRecommendMaxVmMem", sdk_PrlDispCfg_SetRecommendMaxVmMem, METH_VARARGS, "Set recommended memory size for an individual virtual machine."},
	{"PrlDispCfg_GetMaxReservMemLimit", sdk_PrlDispCfg_GetMaxReservMemLimit, METH_VARARGS, "Return the maximum amount of memory that can be reserved for Parallels Service operation."},
	{"PrlDispCfg_SetMaxReservMemLimit", sdk_PrlDispCfg_SetMaxReservMemLimit, METH_VARARGS, "Set the upper limit of the memory size that can be reserved for Parallels Service operation."},
	{"PrlDispCfg_GetMinReservMemLimit", sdk_PrlDispCfg_GetMinReservMemLimit, METH_VARARGS, "Return the minimum amount of physical memory that must be reserved for Parallels Service operation."},
	{"PrlDispCfg_SetMinReservMemLimit", sdk_PrlDispCfg_SetMinReservMemLimit, METH_VARARGS, "Set the lower limit of the memory size that must be reserved for Parallels Service operation."},
	{"PrlDispCfg_IsAdjustMemAuto", sdk_PrlDispCfg_IsAdjustMemAuto, METH_VARARGS, "Determine whether memory allocation for Parallels Service is performed automatically or manually."},
	{"PrlDispCfg_SetAdjustMemAuto", sdk_PrlDispCfg_SetAdjustMemAuto, METH_VARARGS, "Set the Parallels Service memory allocation mode (automatic or manual)."},
	{"PrlDispCfg_IsSendStatisticReport", sdk_PrlDispCfg_IsSendStatisticReport, METH_VARARGS, "Determine whether the statistics reports (CEP) mechanism is activated. "},
	{"PrlDispCfg_SetSendStatisticReport", sdk_PrlDispCfg_SetSendStatisticReport, METH_VARARGS, "Turn on/off the mechanism of sending statistics reports (CEP). "},
	{"PrlDispCfg_GetDefaultVNCHostName", sdk_PrlDispCfg_GetDefaultVNCHostName, METH_VARARGS, "Return the default VNC host name for the Parallels Service."},
	{"PrlDispCfg_SetDefaultVNCHostName", sdk_PrlDispCfg_SetDefaultVNCHostName, METH_VARARGS, "Set the base VNC host name."},
	{"PrlDispCfg_GetVNCBasePort", sdk_PrlDispCfg_GetVNCBasePort, METH_VARARGS, "Obtain the currently set base VNC port number."},
	{"PrlDispCfg_SetVNCBasePort", sdk_PrlDispCfg_SetVNCBasePort, METH_VARARGS, "Set the base VNC port number."},
	{"PrlDispCfg_CanChangeDefaultSettings", sdk_PrlDispCfg_CanChangeDefaultSettings, METH_VARARGS, "Determine if new users have the right to modify Parallels Service preferences."},
	{"PrlDispCfg_SetCanChangeDefaultSettings", sdk_PrlDispCfg_SetCanChangeDefaultSettings, METH_VARARGS, "Grant or deny a permission to new users to modify Parallels Service preferences."},
	{"PrlDispCfg_GetMinSecurityLevel", sdk_PrlDispCfg_GetMinSecurityLevel, METH_VARARGS, "Determine the lowest allowable security level that can be used to connect to the Parallels Service."},
	{"PrlDispCfg_SetMinSecurityLevel", sdk_PrlDispCfg_SetMinSecurityLevel, METH_VARARGS, "Set the lowest allowable security level that can be used to connect to the Parallels Service."},
	{"PrlDispCfg_GetConfirmationsList", sdk_PrlDispCfg_GetConfirmationsList, METH_VARARGS, "Obtain a list of operations that require administrator confirmation."},
	{"PrlDispCfg_SetConfirmationsList", sdk_PrlDispCfg_SetConfirmationsList, METH_VARARGS, "Set the list of operations that require administrator confirmation."},
	{"PrlDispCfg_GetDefaultBackupServer", sdk_PrlDispCfg_GetDefaultBackupServer, METH_VARARGS, "Return the default backup server host name or IP address. "},
	{"PrlDispCfg_SetDefaultBackupServer", sdk_PrlDispCfg_SetDefaultBackupServer, METH_VARARGS, "Set the default backup server host name or IP address. "},
	{"PrlDispCfg_GetBackupUserLogin", sdk_PrlDispCfg_GetBackupUserLogin, METH_VARARGS, "Return the backup user login name."},
	{"PrlDispCfg_SetBackupUserLogin", sdk_PrlDispCfg_SetBackupUserLogin, METH_VARARGS, "Set the backup user login. "},
	{"PrlDispCfg_SetBackupUserPassword", sdk_PrlDispCfg_SetBackupUserPassword, METH_VARARGS, "Set the backup user password."},
	{"PrlDispCfg_IsBackupUserPasswordEnabled", sdk_PrlDispCfg_IsBackupUserPasswordEnabled, METH_VARARGS, "Determine if the backup user password is enabled. "},
	{"PrlDispCfg_SetBackupUserPasswordEnabled", sdk_PrlDispCfg_SetBackupUserPasswordEnabled, METH_VARARGS, "Enable or disable the backup user password."},
	{"PrlDispCfg_GetDefaultBackupDirectory", sdk_PrlDispCfg_GetDefaultBackupDirectory, METH_VARARGS, "Return the name and path of the default backup directory. "},
	{"PrlDispCfg_SetDefaultBackupDirectory", sdk_PrlDispCfg_SetDefaultBackupDirectory, METH_VARARGS, "Set name and path of the default backup directory. "},
	{"PrlDispCfg_GetBackupTimeout", sdk_PrlDispCfg_GetBackupTimeout, METH_VARARGS, "PrlDispCfg_GetBackupTimeout"},
	{"PrlDispCfg_SetBackupTimeout", sdk_PrlDispCfg_SetBackupTimeout, METH_VARARGS, "PrlDispCfg_SetBackupTimeout"},
	{"PrlDispCfg_ArePluginsEnabled", sdk_PrlDispCfg_ArePluginsEnabled, METH_VARARGS, "PrlDispCfg_ArePluginsEnabled"},
	{"PrlDispCfg_EnablePlugins", sdk_PrlDispCfg_EnablePlugins, METH_VARARGS, "PrlDispCfg_EnablePlugins"},
	{"PrlDispCfg_GetVmCpuLimitType", sdk_PrlDispCfg_GetVmCpuLimitType, METH_VARARGS, "PrlDispCfg_GetVmCpuLimitType"},
	{"PrlDispCfg_SetVmCpuLimitType", sdk_PrlDispCfg_SetVmCpuLimitType, METH_VARARGS, "PrlDispCfg_SetVmCpuLimitType"},
	{"PrlDispCfg_IsVerboseLogEnabled", sdk_PrlDispCfg_IsVerboseLogEnabled, METH_VARARGS, "Determine whether the verbose log level is configured for dispatcher and virtual machines processes."},
	{"PrlDispCfg_SetVerboseLogEnabled", sdk_PrlDispCfg_SetVerboseLogEnabled, METH_VARARGS, "Enable or disable the verbose log level for dispatcher and virtual machines processes. "},
	{"PrlDispCfg_IsAllowMultiplePMC", sdk_PrlDispCfg_IsAllowMultiplePMC, METH_VARARGS, "PrlDispCfg_IsAllowMultiplePMC"},
	{"PrlDispCfg_SetAllowMultiplePMC", sdk_PrlDispCfg_SetAllowMultiplePMC, METH_VARARGS, "PrlDispCfg_SetAllowMultiplePMC"},
	{"PrlDispCfg_IsLogRotationEnabled", sdk_PrlDispCfg_IsLogRotationEnabled, METH_VARARGS, "PrlDispCfg_IsLogRotationEnabled"},
	{"PrlDispCfg_SetLogRotationEnabled", sdk_PrlDispCfg_SetLogRotationEnabled, METH_VARARGS, "PrlDispCfg_SetLogRotationEnabled"},
	{"PrlDispCfg_GetCpuFeaturesMaskEx", sdk_PrlDispCfg_GetCpuFeaturesMaskEx, METH_VARARGS, "PrlDispCfg_GetCpuFeaturesMaskEx"},
	{"PrlDispCfg_SetCpuFeaturesMaskEx", sdk_PrlDispCfg_SetCpuFeaturesMaskEx, METH_VARARGS, "PrlDispCfg_SetCpuFeaturesMaskEx"},
	{"PrlCpuFeatures_Create", sdk_PrlCpuFeatures_Create, METH_NOARGS, "PrlCpuFeatures_Create"},
	{"PrlCpuFeatures_GetValue", sdk_PrlCpuFeatures_GetValue, METH_VARARGS, "PrlCpuFeatures_GetValue"},
	{"PrlCpuFeatures_SetValue", sdk_PrlCpuFeatures_SetValue, METH_VARARGS, "PrlCpuFeatures_SetValue"},
	{"PrlVirtNet_Create", sdk_PrlVirtNet_Create, METH_NOARGS, "Creates a new instance of L{VirtualNet}. "},
	{"PrlVirtNet_GetNetworkId", sdk_PrlVirtNet_GetNetworkId, METH_VARARGS, "Return the ID of the specified virtual network. "},
	{"PrlVirtNet_SetNetworkId", sdk_PrlVirtNet_SetNetworkId, METH_VARARGS, "Set the virtual network ID. "},
	{"PrlVirtNet_GetDescription", sdk_PrlVirtNet_GetDescription, METH_VARARGS, "Return the description of the specified virtual network."},
	{"PrlVirtNet_SetDescription", sdk_PrlVirtNet_SetDescription, METH_VARARGS, "Sets the virtual network description. "},
	{"PrlVirtNet_GetNetworkType", sdk_PrlVirtNet_GetNetworkType, METH_VARARGS, "Return the virtual network type. "},
	{"PrlVirtNet_SetNetworkType", sdk_PrlVirtNet_SetNetworkType, METH_VARARGS, "Set the virtual network type. "},
	{"PrlVirtNet_GetBoundCardMac", sdk_PrlVirtNet_GetBoundCardMac, METH_VARARGS, "Return the bound card MAC address of the specified virtual network. "},
	{"PrlVirtNet_SetBoundCardMac", sdk_PrlVirtNet_SetBoundCardMac, METH_VARARGS, "Sets the specified virtual network bound card MAC address."},
	{"PrlVirtNet_GetAdapterName", sdk_PrlVirtNet_GetAdapterName, METH_VARARGS, "Return the name of the network adapter in the specified virtual network. "},
	{"PrlVirtNet_SetAdapterName", sdk_PrlVirtNet_SetAdapterName, METH_VARARGS, "Sets the specified virtual network adapter name. "},
	{"PrlVirtNet_GetAdapterIndex", sdk_PrlVirtNet_GetAdapterIndex, METH_VARARGS, "Return a numeric index assigned to the network adapter in the specified virtual network."},
	{"PrlVirtNet_SetAdapterIndex", sdk_PrlVirtNet_SetAdapterIndex, METH_VARARGS, "Sets the specified adapter index. "},
	{"PrlVirtNet_GetHostIPAddress", sdk_PrlVirtNet_GetHostIPAddress, METH_VARARGS, "Return the host IP address of the specified virtual network."},
	{"PrlVirtNet_SetHostIPAddress", sdk_PrlVirtNet_SetHostIPAddress, METH_VARARGS, "Set the virtual network host IP address. "},
	{"PrlVirtNet_GetHostIP6Address", sdk_PrlVirtNet_GetHostIP6Address, METH_VARARGS, "PrlVirtNet_GetHostIP6Address"},
	{"PrlVirtNet_SetHostIP6Address", sdk_PrlVirtNet_SetHostIP6Address, METH_VARARGS, "PrlVirtNet_SetHostIP6Address"},
	{"PrlVirtNet_GetDhcpIPAddress", sdk_PrlVirtNet_GetDhcpIPAddress, METH_VARARGS, "Return the DHCP IP address of the specified virtual network."},
	{"PrlVirtNet_SetDhcpIPAddress", sdk_PrlVirtNet_SetDhcpIPAddress, METH_VARARGS, "Set the virtual network DHCP IP address."},
	{"PrlVirtNet_GetDhcpIP6Address", sdk_PrlVirtNet_GetDhcpIP6Address, METH_VARARGS, "PrlVirtNet_GetDhcpIP6Address"},
	{"PrlVirtNet_SetDhcpIP6Address", sdk_PrlVirtNet_SetDhcpIP6Address, METH_VARARGS, "PrlVirtNet_SetDhcpIP6Address"},
	{"PrlVirtNet_GetIPNetMask", sdk_PrlVirtNet_GetIPNetMask, METH_VARARGS, "Return the IP net mask of the specified virtual network. "},
	{"PrlVirtNet_SetIPNetMask", sdk_PrlVirtNet_SetIPNetMask, METH_VARARGS, "Set the virtual network IP net mask. "},
	{"PrlVirtNet_GetIP6NetMask", sdk_PrlVirtNet_GetIP6NetMask, METH_VARARGS, "PrlVirtNet_GetIP6NetMask"},
	{"PrlVirtNet_SetIP6NetMask", sdk_PrlVirtNet_SetIP6NetMask, METH_VARARGS, "PrlVirtNet_SetIP6NetMask"},
	{"PrlVirtNet_GetVlanTag", sdk_PrlVirtNet_GetVlanTag, METH_VARARGS, "Return the VLAN tag of the specified virtual network. "},
	{"PrlVirtNet_SetVlanTag", sdk_PrlVirtNet_SetVlanTag, METH_VARARGS, "Set the VLAN tag for the virtual network. "},
	{"PrlVirtNet_GetIPScopeStart", sdk_PrlVirtNet_GetIPScopeStart, METH_VARARGS, "Returns the DHCP starting IP address of the specified virtual network. "},
	{"PrlVirtNet_SetIPScopeStart", sdk_PrlVirtNet_SetIPScopeStart, METH_VARARGS, "Set the virtual network DHCP starting IP address."},
	{"PrlVirtNet_GetIPScopeEnd", sdk_PrlVirtNet_GetIPScopeEnd, METH_VARARGS, "Return the DHCP ending IP address of the specified virtual network. "},
	{"PrlVirtNet_SetIPScopeEnd", sdk_PrlVirtNet_SetIPScopeEnd, METH_VARARGS, "Set the virtual network DHCP ending IP address"},
	{"PrlVirtNet_GetIP6ScopeStart", sdk_PrlVirtNet_GetIP6ScopeStart, METH_VARARGS, "PrlVirtNet_GetIP6ScopeStart"},
	{"PrlVirtNet_SetIP6ScopeStart", sdk_PrlVirtNet_SetIP6ScopeStart, METH_VARARGS, "PrlVirtNet_SetIP6ScopeStart"},
	{"PrlVirtNet_GetIP6ScopeEnd", sdk_PrlVirtNet_GetIP6ScopeEnd, METH_VARARGS, "PrlVirtNet_GetIP6ScopeEnd"},
	{"PrlVirtNet_SetIP6ScopeEnd", sdk_PrlVirtNet_SetIP6ScopeEnd, METH_VARARGS, "PrlVirtNet_SetIP6ScopeEnd"},
	{"PrlVirtNet_IsEnabled", sdk_PrlVirtNet_IsEnabled, METH_VARARGS, "Determine whether the virtual network is enabled or disabled. "},
	{"PrlVirtNet_SetEnabled", sdk_PrlVirtNet_SetEnabled, METH_VARARGS, "Enable or disable the virtual network. "},
	{"PrlVirtNet_IsAdapterEnabled", sdk_PrlVirtNet_IsAdapterEnabled, METH_VARARGS, "Determine whether the virtual network adapter is enabled or disabled. "},
	{"PrlVirtNet_SetAdapterEnabled", sdk_PrlVirtNet_SetAdapterEnabled, METH_VARARGS, "Enable or disable a virtual network adapter. "},
	{"PrlVirtNet_IsDHCPServerEnabled", sdk_PrlVirtNet_IsDHCPServerEnabled, METH_VARARGS, "Determine whether the virtual network DHCP server is enabled or disabled. "},
	{"PrlVirtNet_SetDHCPServerEnabled", sdk_PrlVirtNet_SetDHCPServerEnabled, METH_VARARGS, "Enable or disable the virtual network DHCP server. "},
	{"PrlVirtNet_IsDHCP6ServerEnabled", sdk_PrlVirtNet_IsDHCP6ServerEnabled, METH_VARARGS, "PrlVirtNet_IsDHCP6ServerEnabled"},
	{"PrlVirtNet_SetDHCP6ServerEnabled", sdk_PrlVirtNet_SetDHCP6ServerEnabled, METH_VARARGS, "PrlVirtNet_SetDHCP6ServerEnabled"},
	{"PrlVirtNet_IsNATServerEnabled", sdk_PrlVirtNet_IsNATServerEnabled, METH_VARARGS, "Determine whether the specified virtual network NAT server is enabled or disabled. "},
	{"PrlVirtNet_SetNATServerEnabled", sdk_PrlVirtNet_SetNATServerEnabled, METH_VARARGS, "Enable or disable the virtual network NAT server."},
	{"PrlVirtNet_GetPortForwardList", sdk_PrlVirtNet_GetPortForwardList, METH_VARARGS, "Return the port forward entries list. "},
	{"PrlVirtNet_SetPortForwardList", sdk_PrlVirtNet_SetPortForwardList, METH_VARARGS, "Set the port forward entries list. "},
	{"PrlVirtNet_GetBoundAdapterInfo", sdk_PrlVirtNet_GetBoundAdapterInfo, METH_VARARGS, "Obtain info about a physical adapter, which is bound to the virtual network object. "},
	{"PrlPortFwd_Create", sdk_PrlPortFwd_Create, METH_NOARGS, "Create a new instance of the L{PortForward} class. "},
	{"PrlPortFwd_GetRuleName", sdk_PrlPortFwd_GetRuleName, METH_VARARGS, "PrlPortFwd_GetRuleName"},
	{"PrlPortFwd_SetRuleName", sdk_PrlPortFwd_SetRuleName, METH_VARARGS, "PrlPortFwd_SetRuleName"},
	{"PrlPortFwd_GetIncomingPort", sdk_PrlPortFwd_GetIncomingPort, METH_VARARGS, "Return the incoming port."},
	{"PrlPortFwd_SetIncomingPort", sdk_PrlPortFwd_SetIncomingPort, METH_VARARGS, "Set the specified incoming port. "},
	{"PrlPortFwd_GetRedirectIPAddress", sdk_PrlPortFwd_GetRedirectIPAddress, METH_VARARGS, "Return the redirect IP address of the specified port forward entry. "},
	{"PrlPortFwd_SetRedirectIPAddress", sdk_PrlPortFwd_SetRedirectIPAddress, METH_VARARGS, "Set the specified port forward entry redirect IP address. "},
	{"PrlPortFwd_GetRedirectPort", sdk_PrlPortFwd_GetRedirectPort, METH_VARARGS, "Return the redirect port. "},
	{"PrlPortFwd_SetRedirectPort", sdk_PrlPortFwd_SetRedirectPort, METH_VARARGS, "Set the specified redirect port. "},
	{"PrlPortFwd_GetRedirectVm", sdk_PrlPortFwd_GetRedirectVm, METH_VARARGS, "PrlPortFwd_GetRedirectVm"},
	{"PrlPortFwd_SetRedirectVm", sdk_PrlPortFwd_SetRedirectVm, METH_VARARGS, "PrlPortFwd_SetRedirectVm"},
	{"PrlVm_Start", sdk_PrlVm_Start, METH_VARARGS, "Start the virtual machine. "},
	{"PrlVm_StartEx", sdk_PrlVm_StartEx, METH_VARARGS, "Start the virtual machine using the specified mode."},
	{"PrlVm_Restart", sdk_PrlVm_Restart, METH_VARARGS, "Restart the virtual machine."},
	{"PrlVm_Stop", sdk_PrlVm_Stop, METH_VARARGS, "Stop the virtual machine. "},
	{"PrlVm_StopEx", sdk_PrlVm_StopEx, METH_VARARGS, "PrlVm_StopEx"},
	{"PrlVm_Pause", sdk_PrlVm_Pause, METH_VARARGS, "Pause the virtual machine. "},
	{"PrlVm_Reset", sdk_PrlVm_Reset, METH_VARARGS, "Reset the virtual machine. "},
	{"PrlVm_Suspend", sdk_PrlVm_Suspend, METH_VARARGS, "Suspend the virtual machine. "},
	{"PrlVm_ChangeSid", sdk_PrlVm_ChangeSid, METH_VARARGS, "PrlVm_ChangeSid"},
	{"PrlVm_ResetUptime", sdk_PrlVm_ResetUptime, METH_VARARGS, "PrlVm_ResetUptime"},
	{"PrlVm_GetSuspendedScreen", sdk_PrlVm_GetSuspendedScreen, METH_VARARGS, "Obtain the virtual machine screen state before it was suspending."},
	{"PrlVm_Resume", sdk_PrlVm_Resume, METH_VARARGS, "Resume a suspended virtual machine. "},
	{"PrlVm_DropSuspendedState", sdk_PrlVm_DropSuspendedState, METH_VARARGS, "Resets a suspended virtual machine. "},
	{"PrlVm_CreateSnapshot", sdk_PrlVm_CreateSnapshot, METH_VARARGS, "Create a snapshot of a virtual machine. "},
	{"PrlVm_SwitchToSnapshot", sdk_PrlVm_SwitchToSnapshot, METH_VARARGS, "Revert the specified virtual machine to the specified snapshot."},
	{"PrlVm_SwitchToSnapshotEx", sdk_PrlVm_SwitchToSnapshotEx, METH_VARARGS, "PrlVm_SwitchToSnapshotEx"},
	{"PrlVm_DeleteSnapshot", sdk_PrlVm_DeleteSnapshot, METH_VARARGS, "Delete the specified virtual machine snapshot. "},
	{"PrlVm_GetSnapshotsTree", sdk_PrlVm_GetSnapshotsTree, METH_VARARGS, "Obtain snapshot information for the specified virtual machine. "},
	{"PrlVm_GetSnapshotsTreeEx", sdk_PrlVm_GetSnapshotsTreeEx, METH_VARARGS, "PrlVm_GetSnapshotsTreeEx"},
	{"PrlVm_Lock", sdk_PrlVm_Lock, METH_VARARGS, "Exclusively locks the virtual machine for current session."},
	{"PrlVm_Unlock", sdk_PrlVm_Unlock, METH_VARARGS, "Unlocks a previously locked virtual machine. "},
	{"PrlVm_UpdateSnapshotData", sdk_PrlVm_UpdateSnapshotData, METH_VARARGS, "Modify the virtual machine snapshot name and description. "},
	{"PrlVm_Clone", sdk_PrlVm_Clone, METH_VARARGS, "Clone an existing virtual machine."},
	{"PrlVm_CloneEx", sdk_PrlVm_CloneEx, METH_VARARGS, "Clone an existing virtual machine (extended version)."},
	{"PrlVm_CloneWithUuid", sdk_PrlVm_CloneWithUuid, METH_VARARGS, "PrlVm_CloneWithUuid"},
	{"PrlVm_Migrate", sdk_PrlVm_Migrate, METH_VARARGS, "Migrate an existing virtual machine to another host. "},
	{"PrlVm_MigrateEx", sdk_PrlVm_MigrateEx, METH_VARARGS, "Migrate an existing virtual machine to another host (extended version). "},
	{"PrlVm_MigrateWithRename", sdk_PrlVm_MigrateWithRename, METH_VARARGS, "PrlVm_MigrateWithRename"},
	{"PrlVm_MigrateWithRenameEx", sdk_PrlVm_MigrateWithRenameEx, METH_VARARGS, "PrlVm_MigrateWithRenameEx"},
	{"PrlVm_MigrateCancel", sdk_PrlVm_MigrateCancel, METH_VARARGS, "Cancel the virtual machine migration operation."},
	{"PrlVm_GenerateVmDevFilename", sdk_PrlVm_GenerateVmDevFilename, METH_VARARGS, "Generate a unique name for a virtual device. "},
	{"PrlVm_Delete", sdk_PrlVm_Delete, METH_VARARGS, "Delete the specified virtual machine from the host. "},
	{"PrlVm_GetProblemReport", sdk_PrlVm_GetProblemReport, METH_VARARGS, "Obtain a problem report on abnormal virtual machine termination. "},
	{"PrlVm_GetPackedProblemReport", sdk_PrlVm_GetPackedProblemReport, METH_VARARGS, "PrlVm_GetPackedProblemReport"},
	{"PrlVm_GetState", sdk_PrlVm_GetState, METH_VARARGS, "Obtain the L{VmInfo} object containing the specified virtual machine information."},
	{"PrlVm_RefreshConfig", sdk_PrlVm_RefreshConfig, METH_VARARGS, "Refresh the virtual machine configuration information."},
	{"PrlVm_RefreshConfigEx", sdk_PrlVm_RefreshConfigEx, METH_VARARGS, "PrlVm_RefreshConfigEx"},
	{"PrlVm_LoginInGuest", sdk_PrlVm_LoginInGuest, METH_VARARGS, "Create a new console session or binds to an existing GUI session in a virtual machine."},
	{"PrlVm_StartVncServer", sdk_PrlVm_StartVncServer, METH_VARARGS, "Start a VNC server for the specified virtual machine."},
	{"PrlVm_StopVncServer", sdk_PrlVm_StopVncServer, METH_VARARGS, "Stops the VNC server in a virtual machine"},
	{"PrlVmGuest_Logout", sdk_PrlVmGuest_Logout, METH_VARARGS, "Closes a session (or unbinds from a pre-existing session) in a virtual machine."},
	{"PrlVmGuest_RunProgram", sdk_PrlVmGuest_RunProgram, METH_VARARGS, "Execute a program in a virtual machine."},
	{"PrlVmGuest_GetNetworkSettings", sdk_PrlVmGuest_GetNetworkSettings, METH_VARARGS, "Obtain network settings of the guest operating system running in a virtual machine. "},
	{"PrlVm_SetUserPasswd", sdk_PrlVm_SetUserPasswd, METH_VARARGS, "Change the password of a guest operating system user."},
	{"PrlVm_SetConfig", sdk_PrlVm_SetConfig, METH_VARARGS, "This is a reserved method."},
	{"PrlVm_GetConfig", sdk_PrlVm_GetConfig, METH_VARARGS, "Obtain a handle of type L{VmConfig}"},
	{"PrlVmCfg_SetDefaultConfig", sdk_PrlVmCfg_SetDefaultConfig, METH_VARARGS, "Set the default configuration for a new virtual machine based on the guest OS type."},
	{"PrlVmCfg_IsConfigInvalid", sdk_PrlVmCfg_IsConfigInvalid, METH_VARARGS, "PrlVmCfg_IsConfigInvalid"},
	{"PrlVmCfg_GetConfigValidity", sdk_PrlVmCfg_GetConfigValidity, METH_VARARGS, "Return a constant indicating the virtual machine configuration validity."},
	{"PrlVmCfg_AddDefaultDevice", sdk_PrlVmCfg_AddDefaultDevice, METH_VARARGS, "Automates the task of setting devices in a virtual machine. "},
	{"PrlVmCfg_AddDefaultDeviceEx", sdk_PrlVmCfg_AddDefaultDeviceEx, METH_VARARGS, "PrlVmCfg_AddDefaultDeviceEx"},
	{"PrlVmCfg_IsDefaultDeviceNeeded", sdk_PrlVmCfg_IsDefaultDeviceNeeded, METH_VARARGS, "Determine whether a default virtual device is needed for running the OS of the specified type."},
	{"PrlVmCfg_GetDefaultMemSize", sdk_PrlVmCfg_GetDefaultMemSize, METH_VARARGS, "Return the default RAM size for to the specified OS type and version. "},
	{"PrlVmCfg_GetDefaultHddSize", sdk_PrlVmCfg_GetDefaultHddSize, METH_VARARGS, "Return the default hard disk size for to the specified OS type and version. "},
	{"PrlVmCfg_GetDefaultVideoRamSize", sdk_PrlVmCfg_GetDefaultVideoRamSize, METH_VARARGS, "Return the default video RAM size for the specified OS type and version. "},
	{"PrlVm_GetStatistics", sdk_PrlVm_GetStatistics, METH_VARARGS, "Obtain the L{Statistics} object containing the virtual machine resource usage statistics."},
	{"PrlVm_GetStatisticsEx", sdk_PrlVm_GetStatisticsEx, METH_VARARGS, "PrlVm_GetStatisticsEx"},
	{"PrlVm_SubscribeToGuestStatistics", sdk_PrlVm_SubscribeToGuestStatistics, METH_VARARGS, "Subscribe to receive the virtual machine performance statistics. "},
	{"PrlVm_UnsubscribeFromGuestStatistics", sdk_PrlVm_UnsubscribeFromGuestStatistics, METH_VARARGS, "Cancels the performance statistics subscription."},
	{"PrlVm_Reg", sdk_PrlVm_Reg, METH_VARARGS, "Create a new virtual machine and register it with the Parallels Service. "},
	{"PrlVm_RegEx", sdk_PrlVm_RegEx, METH_VARARGS, "PrlVm_RegEx"},
	{"PrlVm_Unreg", sdk_PrlVm_Unreg, METH_VARARGS, "Unregisters the virtual machine from the Parallels Service."},
	{"PrlVm_Restore", sdk_PrlVm_Restore, METH_VARARGS, "Restores the registered virtual machine. "},
	{"PrlVm_BeginEdit", sdk_PrlVm_BeginEdit, METH_VARARGS, "Mark the beginning of the virtual machine configuration changes operation."},
	{"PrlVm_Commit", sdk_PrlVm_Commit, METH_VARARGS, "Commit the virtual machine configuration changes."},
	{"PrlVm_CommitEx", sdk_PrlVm_CommitEx, METH_VARARGS, "PrlVm_CommitEx"},
	{"PrlVmCfg_CreateVmDev", sdk_PrlVmCfg_CreateVmDev, METH_VARARGS, "Create a new virtual device handle of the specified type. "},
	{"PrlVmCfg_GetAccessRights", sdk_PrlVmCfg_GetAccessRights, METH_VARARGS, "Obtain the L{AccessRights} object."},
	{"PrlVmCfg_GetDevsCount", sdk_PrlVmCfg_GetDevsCount, METH_VARARGS, "Determine the total number of devices of all types installed in the virtual machine. "},
	{"PrlVmCfg_GetAllDevices", sdk_PrlVmCfg_GetAllDevices, METH_VARARGS, "Obtains objects for all virtual devices in a virtual machine. "},
	{"PrlVmCfg_GetDevsCountByType", sdk_PrlVmCfg_GetDevsCountByType, METH_VARARGS, "Obtain the number of virtual devices of the specified type. "},
	{"PrlVmCfg_GetDevByType", sdk_PrlVmCfg_GetDevByType, METH_VARARGS, "Obtains a virtual device object according to the specified device type and index."},
	{"PrlVmCfg_GetFloppyDisksCount", sdk_PrlVmCfg_GetFloppyDisksCount, METH_VARARGS, "Determine the number of floppy disk drives in a virtual machine. "},
	{"PrlVmCfg_GetFloppyDisk", sdk_PrlVmCfg_GetFloppyDisk, METH_VARARGS, "Obtain the L{VmDevice} object containing information about a floppy disk drive in a vrtiual machine."},
	{"PrlVmCfg_GetHardDisksCount", sdk_PrlVmCfg_GetHardDisksCount, METH_VARARGS, "Determines the number of virtual hard disks in a virtual machine. "},
	{"PrlVmCfg_GetHardDisk", sdk_PrlVmCfg_GetHardDisk, METH_VARARGS, "Obtain the L{VmHardDisk} object containing the specified virtual hard disk information."},
	{"PrlVmCfg_GetOpticalDisksCount", sdk_PrlVmCfg_GetOpticalDisksCount, METH_VARARGS, "Determine the number of optical disks in the specified virtual machine. "},
	{"PrlVmCfg_GetOpticalDisk", sdk_PrlVmCfg_GetOpticalDisk, METH_VARARGS, "Obtain the L{VmDevice} object containing information about a virtual optical disk. "},
	{"PrlVmCfg_GetParallelPortsCount", sdk_PrlVmCfg_GetParallelPortsCount, METH_VARARGS, "Determine the number of virtual parallel ports in the virtual machine. "},
	{"PrlVmCfg_GetParallelPort", sdk_PrlVmCfg_GetParallelPort, METH_VARARGS, "Obtains the L{VmDevice} object containing information about a virtual parallel port."},
	{"PrlVmCfg_GetSerialPortsCount", sdk_PrlVmCfg_GetSerialPortsCount, METH_VARARGS, "Determine the number of serial ports in a virtual machine. "},
	{"PrlVmCfg_GetSerialPort", sdk_PrlVmCfg_GetSerialPort, METH_VARARGS, "Obtain the L{VmSerial} object containing information about a serial port in a virtual machine. "},
	{"PrlVmCfg_GetSoundDevsCount", sdk_PrlVmCfg_GetSoundDevsCount, METH_VARARGS, "Determine the number of sound devices in a virtual machine. "},
	{"PrlVmCfg_GetSoundDev", sdk_PrlVmCfg_GetSoundDev, METH_VARARGS, "Obtain the L{VmSound} object containing information about a sound device in a virtual machine. "},
	{"PrlVmCfg_GetUsbDevicesCount", sdk_PrlVmCfg_GetUsbDevicesCount, METH_VARARGS, "Determine the number of USB devices in a virtual machine. "},
	{"PrlVmCfg_GetUsbDevice", sdk_PrlVmCfg_GetUsbDevice, METH_VARARGS, "Obtain the L{VmUsb} object containing information about a USB device in the virtual machine. "},
	{"PrlVmCfg_GetNetAdaptersCount", sdk_PrlVmCfg_GetNetAdaptersCount, METH_VARARGS, "Determine the number of network adapters in a virtual machine. "},
	{"PrlVmCfg_GetNetAdapter", sdk_PrlVmCfg_GetNetAdapter, METH_VARARGS, "Obtain the L{VmNet} object containing information about a virtual network adapter. "},
	{"PrlVmCfg_GetGenericPciDevsCount", sdk_PrlVmCfg_GetGenericPciDevsCount, METH_VARARGS, "Determines the number of generic PCI devices in a virtual machine. "},
	{"PrlVmCfg_GetGenericPciDev", sdk_PrlVmCfg_GetGenericPciDev, METH_VARARGS, "Obtain the L{VmDevice} object containing information about a generic PCI device."},
	{"PrlVmCfg_GetGenericScsiDevsCount", sdk_PrlVmCfg_GetGenericScsiDevsCount, METH_VARARGS, "Determines the number of generic SCSI devices in a virtual machine."},
	{"PrlVmCfg_GetGenericScsiDev", sdk_PrlVmCfg_GetGenericScsiDev, METH_VARARGS, "Obtain the L{VmDevice} object containing information about a SCSI device in a virtual machine."},
	{"PrlVmCfg_GetDisplayDevsCount", sdk_PrlVmCfg_GetDisplayDevsCount, METH_VARARGS, "Determine the number of display devices in a virtual machine. "},
	{"PrlVmCfg_GetDisplayDev", sdk_PrlVmCfg_GetDisplayDev, METH_VARARGS, "Obtains the L{VmDevice} containing information about a display device in a virtual machine. "},
	{"PrlVmCfg_CreateShare", sdk_PrlVmCfg_CreateShare, METH_VARARGS, "Create a new instance of L{Share} and add it to the virtual machine list of shares."},
	{"PrlVmCfg_GetSharesCount", sdk_PrlVmCfg_GetSharesCount, METH_VARARGS, "Determine the number of shared folders in a virtual machine. "},
	{"PrlVmCfg_GetShare", sdk_PrlVmCfg_GetShare, METH_VARARGS, "Obtain the L{Share} object containing information about a shared folder. "},
	{"PrlVmCfg_IsSmartGuardEnabled", sdk_PrlVmCfg_IsSmartGuardEnabled, METH_VARARGS, "Determine whether the SmartGuard feature is enabled in the virtual machine. "},
	{"PrlVmCfg_SetSmartGuardEnabled", sdk_PrlVmCfg_SetSmartGuardEnabled, METH_VARARGS, "Enable the SmartGuard feature in the virtual machine. "},
	{"PrlVmCfg_IsSmartGuardNotifyBeforeCreation", sdk_PrlVmCfg_IsSmartGuardNotifyBeforeCreation, METH_VARARGS, "Determine whether the user will be notified on automatic snapshot creation by SmartGaurd."},
	{"PrlVmCfg_SetSmartGuardNotifyBeforeCreation", sdk_PrlVmCfg_SetSmartGuardNotifyBeforeCreation, METH_VARARGS, "Enable or disable notification of automatic snapshot creation, a SmartGuard feature. "},
	{"PrlVmCfg_GetSmartGuardInterval", sdk_PrlVmCfg_GetSmartGuardInterval, METH_VARARGS, "Determines the interval at which snapshots are taken by SmartGuard. "},
	{"PrlVmCfg_SetSmartGuardInterval", sdk_PrlVmCfg_SetSmartGuardInterval, METH_VARARGS, "Set the time interval at which snapshots are taken by SmartGuard. "},
	{"PrlVmCfg_GetSmartGuardMaxSnapshotsCount", sdk_PrlVmCfg_GetSmartGuardMaxSnapshotsCount, METH_VARARGS, "Determines the maximum snapshot count, a SmartGuard setting."},
	{"PrlVmCfg_SetSmartGuardMaxSnapshotsCount", sdk_PrlVmCfg_SetSmartGuardMaxSnapshotsCount, METH_VARARGS, "Set the maximum snapshot count, a SmartGuard feature."},
	{"PrlVmCfg_IsUserDefinedSharedFoldersEnabled", sdk_PrlVmCfg_IsUserDefinedSharedFoldersEnabled, METH_VARARGS, "Determine whether the user-defined shared folders are enabled or not. "},
	{"PrlVmCfg_SetUserDefinedSharedFoldersEnabled", sdk_PrlVmCfg_SetUserDefinedSharedFoldersEnabled, METH_VARARGS, "Enables or disables user-defined shared folders. "},
	{"PrlVmCfg_IsSmartMountEnabled", sdk_PrlVmCfg_IsSmartMountEnabled, METH_VARARGS, "PrlVmCfg_IsSmartMountEnabled"},
	{"PrlVmCfg_SetSmartMountEnabled", sdk_PrlVmCfg_SetSmartMountEnabled, METH_VARARGS, "PrlVmCfg_SetSmartMountEnabled"},
	{"PrlVmCfg_IsSmartMountRemovableDrivesEnabled", sdk_PrlVmCfg_IsSmartMountRemovableDrivesEnabled, METH_VARARGS, "PrlVmCfg_IsSmartMountRemovableDrivesEnabled"},
	{"PrlVmCfg_SetSmartMountRemovableDrivesEnabled", sdk_PrlVmCfg_SetSmartMountRemovableDrivesEnabled, METH_VARARGS, "PrlVmCfg_SetSmartMountRemovableDrivesEnabled"},
	{"PrlVmCfg_IsSmartMountDVDsEnabled", sdk_PrlVmCfg_IsSmartMountDVDsEnabled, METH_VARARGS, "PrlVmCfg_IsSmartMountDVDsEnabled"},
	{"PrlVmCfg_SetSmartMountDVDsEnabled", sdk_PrlVmCfg_SetSmartMountDVDsEnabled, METH_VARARGS, "PrlVmCfg_SetSmartMountDVDsEnabled"},
	{"PrlVmCfg_IsSmartMountNetworkSharesEnabled", sdk_PrlVmCfg_IsSmartMountNetworkSharesEnabled, METH_VARARGS, "PrlVmCfg_IsSmartMountNetworkSharesEnabled"},
	{"PrlVmCfg_SetSmartMountNetworkSharesEnabled", sdk_PrlVmCfg_SetSmartMountNetworkSharesEnabled, METH_VARARGS, "PrlVmCfg_SetSmartMountNetworkSharesEnabled"},
	{"PrlVmCfg_IsSharedProfileEnabled", sdk_PrlVmCfg_IsSharedProfileEnabled, METH_VARARGS, "Determine whether the Shared Profile feature is enabled in the virtual machine. "},
	{"PrlVmCfg_SetSharedProfileEnabled", sdk_PrlVmCfg_SetSharedProfileEnabled, METH_VARARGS, "Enable or disable the Shared Profile feature in the virtual machine. "},
	{"PrlVmCfg_IsUseDesktop", sdk_PrlVmCfg_IsUseDesktop, METH_VARARGS, "Determine whether the 'use desktop in share profile' feature is enabled or not. "},
	{"PrlVmCfg_SetUseDesktop", sdk_PrlVmCfg_SetUseDesktop, METH_VARARGS, "Enable or disable the 'undo-desktop' feature in the shared profile. "},
	{"PrlVmCfg_IsUseDocuments", sdk_PrlVmCfg_IsUseDocuments, METH_VARARGS, "Determine whether 'use documents in shared profile' feature is enabled or not. "},
	{"PrlVmCfg_SetUseDocuments", sdk_PrlVmCfg_SetUseDocuments, METH_VARARGS, "Enable or disable the 'use documents in shared profile' feature. "},
	{"PrlVmCfg_IsUsePictures", sdk_PrlVmCfg_IsUsePictures, METH_VARARGS, "Determine whether the 'used pictures in shared profile' feature is enabled or not. "},
	{"PrlVmCfg_SetUsePictures", sdk_PrlVmCfg_SetUsePictures, METH_VARARGS, "Enables or disables the 'use pictures in shared profile' feature."},
	{"PrlVmCfg_IsUseMusic", sdk_PrlVmCfg_IsUseMusic, METH_VARARGS, "Determine whether the 'use music in shared profile' feature is enabled or not. "},
	{"PrlVmCfg_SetUseMusic", sdk_PrlVmCfg_SetUseMusic, METH_VARARGS, "Enables or disables the 'use music in shared profile' feature. "},
	{"PrlVmCfg_IsUseDownloads", sdk_PrlVmCfg_IsUseDownloads, METH_VARARGS, "PrlVmCfg_IsUseDownloads"},
	{"PrlVmCfg_SetUseDownloads", sdk_PrlVmCfg_SetUseDownloads, METH_VARARGS, "PrlVmCfg_SetUseDownloads"},
	{"PrlVmCfg_IsUseMovies", sdk_PrlVmCfg_IsUseMovies, METH_VARARGS, "PrlVmCfg_IsUseMovies"},
	{"PrlVmCfg_SetUseMovies", sdk_PrlVmCfg_SetUseMovies, METH_VARARGS, "PrlVmCfg_SetUseMovies"},
	{"PrlVmCfg_GetOptimizeModifiersMode", sdk_PrlVmCfg_GetOptimizeModifiersMode, METH_VARARGS, "PrlVmCfg_GetOptimizeModifiersMode"},
	{"PrlVmCfg_SetOptimizeModifiersMode", sdk_PrlVmCfg_SetOptimizeModifiersMode, METH_VARARGS, "PrlVmCfg_SetOptimizeModifiersMode"},
	{"PrlVmCfg_IsShareClipboard", sdk_PrlVmCfg_IsShareClipboard, METH_VARARGS, "Determine whether the clipboard sharing feature is enabled in the virtual machine. "},
	{"PrlVmCfg_SetShareClipboard", sdk_PrlVmCfg_SetShareClipboard, METH_VARARGS, "Enable or disable the clipboard sharing feature. "},
	{"PrlVmCfg_IsOfflineManagementEnabled", sdk_PrlVmCfg_IsOfflineManagementEnabled, METH_VARARGS, "Determine whether the offline management feature is enabled for the virtual machine. "},
	{"PrlVmCfg_SetOfflineManagementEnabled", sdk_PrlVmCfg_SetOfflineManagementEnabled, METH_VARARGS, "Enables or disables the offline management feature for the virtual machine. "},
	{"PrlVmCfg_IsToolsAutoUpdateEnabled", sdk_PrlVmCfg_IsToolsAutoUpdateEnabled, METH_VARARGS, "Enables or disables the Parallels Tools AutoUpdate feature for the virtual machine."},
	{"PrlVmCfg_SetToolsAutoUpdateEnabled", sdk_PrlVmCfg_SetToolsAutoUpdateEnabled, METH_VARARGS, "Enable or disable the Parallels Tools AutoUpdate feature for the virtual machine. "},
	{"PrlVmCfg_IsTimeSynchronizationEnabled", sdk_PrlVmCfg_IsTimeSynchronizationEnabled, METH_VARARGS, "Determine whether the time synchronization feature is enabled in the virtual machine. "},
	{"PrlVmCfg_SetTimeSynchronizationEnabled", sdk_PrlVmCfg_SetTimeSynchronizationEnabled, METH_VARARGS, "Enable or disable the time synchronization feature in a virtual machine. "},
	{"PrlVmCfg_IsTimeSyncSmartModeEnabled", sdk_PrlVmCfg_IsTimeSyncSmartModeEnabled, METH_VARARGS, "Determine whether the smart time synchronization is enabled in a virtual machine."},
	{"PrlVmCfg_SetTimeSyncSmartModeEnabled", sdk_PrlVmCfg_SetTimeSyncSmartModeEnabled, METH_VARARGS, "Enable or disable the smart time-synchronization mode in the virtual machine. "},
	{"PrlVmCfg_GetTimeSyncInterval", sdk_PrlVmCfg_GetTimeSyncInterval, METH_VARARGS, "Obtain the time synchronization interval between the host and the guest OS. "},
	{"PrlVmCfg_SetTimeSyncInterval", sdk_PrlVmCfg_SetTimeSyncInterval, METH_VARARGS, "Set the time interval at which time in the virtual machine will be synchronized with the host OS."},
	{"PrlVmCfg_IsAllowSelectBootDevice", sdk_PrlVmCfg_IsAllowSelectBootDevice, METH_VARARGS, "Determine whether the 'select boot device' option is shown on virtual machine startup."},
	{"PrlVmCfg_SetAllowSelectBootDevice", sdk_PrlVmCfg_SetAllowSelectBootDevice, METH_VARARGS, "Switch on/off the 'select boot device' dialog on virtual machine startup."},
	{"PrlVm_RegEventHandler", sdk_PrlVm_RegEventHandler, METH_VARARGS, ""},
	{"PrlVm_UnregEventHandler", sdk_PrlVm_UnregEventHandler, METH_VARARGS, "Unregister an event handler."},
	{"PrlVm_GetQuestions", sdk_PrlVm_GetQuestions, METH_VARARGS, "Synchronously receive questions from the Parallels Service. "},
	{"PrlVmCfg_CreateBootDev", sdk_PrlVmCfg_CreateBootDev, METH_VARARGS, "Create a new instance of L{BootDevice} and add it to the virtual machine boot device list."},
	{"PrlVmCfg_GetBootDevCount", sdk_PrlVmCfg_GetBootDevCount, METH_VARARGS, "Determine the number of devices in the virtual machine boot device priority list. "},
	{"PrlVmCfg_GetBootDev", sdk_PrlVmCfg_GetBootDev, METH_VARARGS, "Obtain the L{BootDevice} object containing information about a specified boot device."},
	{"PrlVmCfg_GetName", sdk_PrlVmCfg_GetName, METH_VARARGS, "Return the virtual machine name. "},
	{"PrlVmCfg_SetName", sdk_PrlVmCfg_SetName, METH_VARARGS, "Set the virtual machine name. "},
	{"PrlVmCfg_GetHostname", sdk_PrlVmCfg_GetHostname, METH_VARARGS, "Obtain the hostname of the specified virtual machine. "},
	{"PrlVmCfg_SetHostname", sdk_PrlVmCfg_SetHostname, METH_VARARGS, "Set the virtual machine hostname. "},
	{"PrlVmCfg_GetDnsServers", sdk_PrlVmCfg_GetDnsServers, METH_VARARGS, "PrlVmCfg_GetDnsServers"},
	{"PrlVmCfg_SetDnsServers", sdk_PrlVmCfg_SetDnsServers, METH_VARARGS, "PrlVmCfg_SetDnsServers"},
	{"PrlVmCfg_GetUuid", sdk_PrlVmCfg_GetUuid, METH_VARARGS, "Return the UUID (universally unique ID) of the virtual machine. "},
	{"PrlVmCfg_SetUuid", sdk_PrlVmCfg_SetUuid, METH_VARARGS, "Set the virtual machine UUID (universally unique ID). "},
	{"PrlVmCfg_GetCtId", sdk_PrlVmCfg_GetCtId, METH_VARARGS, "PrlVmCfg_GetCtId"},
	{"PrlVmCfg_GetLinkedVmUuid", sdk_PrlVmCfg_GetLinkedVmUuid, METH_VARARGS, "PrlVmCfg_GetLinkedVmUuid"},
	{"PrlVmCfg_GetOsType", sdk_PrlVmCfg_GetOsType, METH_VARARGS, "Return the type of the operating system that the specified virtual machine is running. "},
	{"PrlVmCfg_GetOsVersion", sdk_PrlVmCfg_GetOsVersion, METH_VARARGS, "Return the version of the operating system that the specified virtual machine is running. "},
	{"PrlVmCfg_SetOsVersion", sdk_PrlVmCfg_SetOsVersion, METH_VARARGS, "Set the virtual machine guest OS version. "},
	{"PrlVmCfg_GetRamSize", sdk_PrlVmCfg_GetRamSize, METH_VARARGS, "Return the virtual machine memory (RAM) size, in megabytes. "},
	{"PrlVmCfg_SetRamSize", sdk_PrlVmCfg_SetRamSize, METH_VARARGS, "Sets the virtual machine memory (RAM) size. "},
	{"PrlVmCfg_GetVideoRamSize", sdk_PrlVmCfg_GetVideoRamSize, METH_VARARGS, "Return the video memory size of the virtual machine. "},
	{"PrlVmCfg_SetVideoRamSize", sdk_PrlVmCfg_SetVideoRamSize, METH_VARARGS, "Set the virtual machine video memory size. "},
	{"PrlVmCfg_GetMemGuaranteeSize", sdk_PrlVmCfg_GetMemGuaranteeSize, METH_VARARGS, "PrlVmCfg_GetMemGuaranteeSize"},
	{"PrlVmCfg_SetMemGuaranteeSize", sdk_PrlVmCfg_SetMemGuaranteeSize, METH_VARARGS, "PrlVmCfg_SetMemGuaranteeSize"},
	{"PrlVmCfg_GetCpuCount", sdk_PrlVmCfg_GetCpuCount, METH_VARARGS, "Determine the number of CPUs in the virtual machine. "},
	{"PrlVmCfg_SetCpuCount", sdk_PrlVmCfg_SetCpuCount, METH_VARARGS, "Set the number of CPUs for the virtual machine (the CPUs should be present in the machine). "},
	{"PrlVmCfg_GetCpuMode", sdk_PrlVmCfg_GetCpuMode, METH_VARARGS, "Determine the specified virtual machine CPU mode (32 bit or 64 bit). "},
	{"PrlVmCfg_SetCpuMode", sdk_PrlVmCfg_SetCpuMode, METH_VARARGS, "Set CPU mode (32 bit or 64 bit) for the virtual machine. "},
	{"PrlVmCfg_GetCpuAccelLevel", sdk_PrlVmCfg_GetCpuAccelLevel, METH_VARARGS, "Determine the virtual machine CPU acceleration level. "},
	{"PrlVmCfg_SetCpuAccelLevel", sdk_PrlVmCfg_SetCpuAccelLevel, METH_VARARGS, "Set CPU acceleration level for the virtual machine. "},
	{"PrlVmCfg_IsCpuVtxEnabled", sdk_PrlVmCfg_IsCpuVtxEnabled, METH_VARARGS, "Determine whether the x86 virtualization (such as Vt-x) is available in the virtual machine CPU."},
	{"PrlVmCfg_IsCpuHotplugEnabled", sdk_PrlVmCfg_IsCpuHotplugEnabled, METH_VARARGS, "PrlVmCfg_IsCpuHotplugEnabled"},
	{"PrlVmCfg_SetCpuHotplugEnabled", sdk_PrlVmCfg_SetCpuHotplugEnabled, METH_VARARGS, "PrlVmCfg_SetCpuHotplugEnabled"},
	{"PrlVmCfg_Get3DAccelerationMode", sdk_PrlVmCfg_Get3DAccelerationMode, METH_VARARGS, "PrlVmCfg_Get3DAccelerationMode"},
	{"PrlVmCfg_Set3DAccelerationMode", sdk_PrlVmCfg_Set3DAccelerationMode, METH_VARARGS, "PrlVmCfg_Set3DAccelerationMode"},
	{"PrlVmCfg_IsVerticalSynchronizationEnabled", sdk_PrlVmCfg_IsVerticalSynchronizationEnabled, METH_VARARGS, "PrlVmCfg_IsVerticalSynchronizationEnabled"},
	{"PrlVmCfg_SetVerticalSynchronizationEnabled", sdk_PrlVmCfg_SetVerticalSynchronizationEnabled, METH_VARARGS, "PrlVmCfg_SetVerticalSynchronizationEnabled"},
	{"PrlVmCfg_IsHighResolutionEnabled", sdk_PrlVmCfg_IsHighResolutionEnabled, METH_VARARGS, "PrlVmCfg_IsHighResolutionEnabled"},
	{"PrlVmCfg_SetHighResolutionEnabled", sdk_PrlVmCfg_SetHighResolutionEnabled, METH_VARARGS, "PrlVmCfg_SetHighResolutionEnabled"},
	{"PrlVmCfg_IsAdaptiveHypervisorEnabled", sdk_PrlVmCfg_IsAdaptiveHypervisorEnabled, METH_VARARGS, "PrlVmCfg_IsAdaptiveHypervisorEnabled"},
	{"PrlVmCfg_SetAdaptiveHypervisorEnabled", sdk_PrlVmCfg_SetAdaptiveHypervisorEnabled, METH_VARARGS, "PrlVmCfg_SetAdaptiveHypervisorEnabled"},
	{"PrlVmCfg_IsSwitchOffWindowsLogoEnabled", sdk_PrlVmCfg_IsSwitchOffWindowsLogoEnabled, METH_VARARGS, "PrlVmCfg_IsSwitchOffWindowsLogoEnabled"},
	{"PrlVmCfg_SetSwitchOffWindowsLogoEnabled", sdk_PrlVmCfg_SetSwitchOffWindowsLogoEnabled, METH_VARARGS, "PrlVmCfg_SetSwitchOffWindowsLogoEnabled"},
	{"PrlVmCfg_IsLongerBatteryLifeEnabled", sdk_PrlVmCfg_IsLongerBatteryLifeEnabled, METH_VARARGS, "PrlVmCfg_IsLongerBatteryLifeEnabled"},
	{"PrlVmCfg_SetLongerBatteryLifeEnabled", sdk_PrlVmCfg_SetLongerBatteryLifeEnabled, METH_VARARGS, "PrlVmCfg_SetLongerBatteryLifeEnabled"},
	{"PrlVmCfg_IsBatteryStatusEnabled", sdk_PrlVmCfg_IsBatteryStatusEnabled, METH_VARARGS, "PrlVmCfg_IsBatteryStatusEnabled"},
	{"PrlVmCfg_SetBatteryStatusEnabled", sdk_PrlVmCfg_SetBatteryStatusEnabled, METH_VARARGS, "PrlVmCfg_SetBatteryStatusEnabled"},
	{"PrlVmCfg_IsNestedVirtualizationEnabled", sdk_PrlVmCfg_IsNestedVirtualizationEnabled, METH_VARARGS, "PrlVmCfg_IsNestedVirtualizationEnabled"},
	{"PrlVmCfg_SetNestedVirtualizationEnabled", sdk_PrlVmCfg_SetNestedVirtualizationEnabled, METH_VARARGS, "PrlVmCfg_SetNestedVirtualizationEnabled"},
	{"PrlVmCfg_IsPMUVirtualizationEnabled", sdk_PrlVmCfg_IsPMUVirtualizationEnabled, METH_VARARGS, "PrlVmCfg_IsPMUVirtualizationEnabled"},
	{"PrlVmCfg_SetPMUVirtualizationEnabled", sdk_PrlVmCfg_SetPMUVirtualizationEnabled, METH_VARARGS, "PrlVmCfg_SetPMUVirtualizationEnabled"},
	{"PrlVmCfg_IsLockGuestOnSuspendEnabled", sdk_PrlVmCfg_IsLockGuestOnSuspendEnabled, METH_VARARGS, "PrlVmCfg_IsLockGuestOnSuspendEnabled"},
	{"PrlVmCfg_SetLockGuestOnSuspendEnabled", sdk_PrlVmCfg_SetLockGuestOnSuspendEnabled, METH_VARARGS, "PrlVmCfg_SetLockGuestOnSuspendEnabled"},
	{"PrlVmCfg_IsIsolatedVmEnabled", sdk_PrlVmCfg_IsIsolatedVmEnabled, METH_VARARGS, "PrlVmCfg_IsIsolatedVmEnabled"},
	{"PrlVmCfg_SetIsolatedVmEnabled", sdk_PrlVmCfg_SetIsolatedVmEnabled, METH_VARARGS, "PrlVmCfg_SetIsolatedVmEnabled"},
	{"PrlVmCfg_SetCpuUnits", sdk_PrlVmCfg_SetCpuUnits, METH_VARARGS, "Set the number of CPU units that will be allocated to a virtual machine. "},
	{"PrlVmCfg_GetCpuUnits", sdk_PrlVmCfg_GetCpuUnits, METH_VARARGS, "Determine the number of CPU units allocated to a virtual machine. "},
	{"PrlVmCfg_SetCpuLimit", sdk_PrlVmCfg_SetCpuLimit, METH_VARARGS, "Set the CPU usage limit (in percent) for a virtual machine. "},
	{"PrlVmCfg_GetCpuLimit", sdk_PrlVmCfg_GetCpuLimit, METH_VARARGS, "Determine the CPU usage limit of a virtual machine, in percent. "},
	{"PrlVmCfg_GetCpuMask", sdk_PrlVmCfg_GetCpuMask, METH_VARARGS, "PrlVmCfg_GetCpuMask"},
	{"PrlVmCfg_SetCpuMask", sdk_PrlVmCfg_SetCpuMask, METH_VARARGS, "PrlVmCfg_SetCpuMask"},
	{"PrlVmCfg_GetNodeMask", sdk_PrlVmCfg_GetNodeMask, METH_VARARGS, "PrlVmCfg_GetNodeMask"},
	{"PrlVmCfg_SetNodeMask", sdk_PrlVmCfg_SetNodeMask, METH_VARARGS, "PrlVmCfg_SetNodeMask"},
	{"PrlVmCfg_GetIoPriority", sdk_PrlVmCfg_GetIoPriority, METH_VARARGS, "Determines the specified virtual machine I/O priority. "},
	{"PrlVmCfg_SetIoPriority", sdk_PrlVmCfg_SetIoPriority, METH_VARARGS, "Set the virtual machine I/O priority. "},
	{"PrlVmCfg_GetIopsLimit", sdk_PrlVmCfg_GetIopsLimit, METH_VARARGS, "PrlVmCfg_GetIopsLimit"},
	{"PrlVmCfg_SetIopsLimit", sdk_PrlVmCfg_SetIopsLimit, METH_VARARGS, "PrlVmCfg_SetIopsLimit"},
	{"PrlVmCfg_GetServerUuid", sdk_PrlVmCfg_GetServerUuid, METH_VARARGS, "Returns the UUID of the machine hosting the specified virtual machine. "},
	{"PrlVmCfg_GetServerHost", sdk_PrlVmCfg_GetServerHost, METH_VARARGS, "Return the hostname of the machine hosting the specified virtual machine. "},
	{"PrlVmCfg_GetHomePath", sdk_PrlVmCfg_GetHomePath, METH_VARARGS, "Return the virtual machine home directory name and path. "},
	{"PrlVmCfg_GetLocation", sdk_PrlVmCfg_GetLocation, METH_VARARGS, "PrlVmCfg_GetLocation"},
	{"PrlVmCfg_GetIcon", sdk_PrlVmCfg_GetIcon, METH_VARARGS, "Return the name of the icon file used by the specified virtual machine. "},
	{"PrlVmCfg_SetIcon", sdk_PrlVmCfg_SetIcon, METH_VARARGS, "Set the virtual machine icon. "},
	{"PrlVmCfg_GetDescription", sdk_PrlVmCfg_GetDescription, METH_VARARGS, "Return the virtual machine description. "},
	{"PrlVmCfg_SetDescription", sdk_PrlVmCfg_SetDescription, METH_VARARGS, "Set the virtual machine description. "},
	{"PrlVmCfg_IsTemplate", sdk_PrlVmCfg_IsTemplate, METH_VARARGS, "Determine whether the virtual machine is a real machine or a template. "},
	{"PrlVmCfg_SetTemplateSign", sdk_PrlVmCfg_SetTemplateSign, METH_VARARGS, "Modify a regular virtual machine to become a template, and vise versa. "},
	{"PrlVmCfg_GetCustomProperty", sdk_PrlVmCfg_GetCustomProperty, METH_VARARGS, "Return the virtual machine custom property information. "},
	{"PrlVmCfg_SetCustomProperty", sdk_PrlVmCfg_SetCustomProperty, METH_VARARGS, "Set the virtual machine custom property information. "},
	{"PrlVmCfg_GetAutoStart", sdk_PrlVmCfg_GetAutoStart, METH_VARARGS, "Determine if the specified virtual machine is set to start automatically on Parallels Service start."},
	{"PrlVmCfg_SetAutoStart", sdk_PrlVmCfg_SetAutoStart, METH_VARARGS, "Set the automatic startup option for the virtual machine. "},
	{"PrlVmCfg_GetAutoStartDelay", sdk_PrlVmCfg_GetAutoStartDelay, METH_VARARGS, "Returns the time delay used during the virtual machine automatic startup. "},
	{"PrlVmCfg_SetAutoStartDelay", sdk_PrlVmCfg_SetAutoStartDelay, METH_VARARGS, "Set the time delay that will be used during the virtual machine automatic startup."},
	{"PrlVmCfg_GetStartLoginMode", sdk_PrlVmCfg_GetStartLoginMode, METH_VARARGS, "Return the automatic startup login mode for the virtual machine. "},
	{"PrlVmCfg_SetStartLoginMode", sdk_PrlVmCfg_SetStartLoginMode, METH_VARARGS, "Set the automatic startup login mode for the specified virtual machine. "},
	{"PrlVmCfg_GetStartUserLogin", sdk_PrlVmCfg_GetStartUserLogin, METH_VARARGS, "Return the user name used during the virtual machine automatic startup."},
	{"PrlVmCfg_SetStartUserCreds", sdk_PrlVmCfg_SetStartUserCreds, METH_VARARGS, "Sset the automatic startup user login and password for the virtual machine. "},
	{"PrlVmCfg_GetAutoStop", sdk_PrlVmCfg_GetAutoStop, METH_VARARGS, "Determine the mode of the automatic shutdown for the specified virtual machine."},
	{"PrlVmCfg_SetAutoStop", sdk_PrlVmCfg_SetAutoStop, METH_VARARGS, "Set the automatic shutdown mode for the virtual machine."},
	{"PrlVmCfg_GetActionOnWindowClose", sdk_PrlVmCfg_GetActionOnWindowClose, METH_VARARGS, "Determine the action on Parallels Application window close for the specified virtual machine. "},
	{"PrlVmCfg_SetActionOnWindowClose", sdk_PrlVmCfg_SetActionOnWindowClose, METH_VARARGS, "Set the action to perform on the Parallels console window closing."},
	{"PrlVmCfg_GetActionOnStopMode", sdk_PrlVmCfg_GetActionOnStopMode, METH_VARARGS, "PrlVmCfg_GetActionOnStopMode"},
	{"PrlVmCfg_SetActionOnStopMode", sdk_PrlVmCfg_SetActionOnStopMode, METH_VARARGS, "PrlVmCfg_SetActionOnStopMode"},
	{"PrlVmCfg_GetWindowMode", sdk_PrlVmCfg_GetWindowMode, METH_VARARGS, "Return the current window mode the virtual machine is in."},
	{"PrlVmCfg_SetWindowMode", sdk_PrlVmCfg_SetWindowMode, METH_VARARGS, "Sets the virtual machine window mode."},
	{"PrlVmCfg_IsStartInDetachedWindowEnabled", sdk_PrlVmCfg_IsStartInDetachedWindowEnabled, METH_VARARGS, "PrlVmCfg_IsStartInDetachedWindowEnabled"},
	{"PrlVmCfg_SetStartInDetachedWindowEnabled", sdk_PrlVmCfg_SetStartInDetachedWindowEnabled, METH_VARARGS, "PrlVmCfg_SetStartInDetachedWindowEnabled"},
	{"PrlVmCfg_IsLockInFullScreenMode", sdk_PrlVmCfg_IsLockInFullScreenMode, METH_VARARGS, "Determine whether the 'lock in screen mode' flag is set in the virtual machine configuration."},
	{"PrlVmCfg_SetLockInFullScreenMode", sdk_PrlVmCfg_SetLockInFullScreenMode, METH_VARARGS, "Enable or disable the lock in screen mode feature in the virtual machine configuration. "},
	{"PrlVmCfg_GetLastModifiedDate", sdk_PrlVmCfg_GetLastModifiedDate, METH_VARARGS, "Return the date and time when the specified virtual machine was last modified. "},
	{"PrlVmCfg_GetLastModifierName", sdk_PrlVmCfg_GetLastModifierName, METH_VARARGS, "Return the name of the user who last modified the specified virtual machine. "},
	{"PrlVmCfg_GetUptimeStartDate", sdk_PrlVmCfg_GetUptimeStartDate, METH_VARARGS, "Return the date and time when the uptime counter was started for the specified virtual machine."},
	{"PrlVmCfg_GetUptime", sdk_PrlVmCfg_GetUptime, METH_VARARGS, "PrlVmCfg_GetUptime"},
	{"PrlVmCfg_IsGuestSharingEnabled", sdk_PrlVmCfg_IsGuestSharingEnabled, METH_VARARGS, "Determine if guest sharing is enabled (the guest OS disk drives are visible in the host OS). "},
	{"PrlVmCfg_SetGuestSharingEnabled", sdk_PrlVmCfg_SetGuestSharingEnabled, METH_VARARGS, "Enables the guest sharing feature. "},
	{"PrlVmCfg_IsGuestSharingAutoMount", sdk_PrlVmCfg_IsGuestSharingAutoMount, METH_VARARGS, "Determine if host shared folders are mounted automatically in the virtual machine. "},
	{"PrlVmCfg_SetGuestSharingAutoMount", sdk_PrlVmCfg_SetGuestSharingAutoMount, METH_VARARGS, "Set the guest OS sharing auto-mount option. "},
	{"PrlVmCfg_IsGuestSharingEnableSpotlight", sdk_PrlVmCfg_IsGuestSharingEnableSpotlight, METH_VARARGS, "Determine if the virtual disks will be added to Spotlight search subsystem (Mac OS X feature)."},
	{"PrlVmCfg_SetGuestSharingEnableSpotlight", sdk_PrlVmCfg_SetGuestSharingEnableSpotlight, METH_VARARGS, "Set whether the virtual disks are added to Spotlight search subsystem."},
	{"PrlVmCfg_IsHostSharingEnabled", sdk_PrlVmCfg_IsHostSharingEnabled, METH_VARARGS, "Determine if host sharing is enabled (host shared folders are visible in the guest OS). "},
	{"PrlVmCfg_SetHostSharingEnabled", sdk_PrlVmCfg_SetHostSharingEnabled, METH_VARARGS, "Enable host sharing for the virtual machine. "},
	{"PrlVmCfg_IsShareAllHostDisks", sdk_PrlVmCfg_IsShareAllHostDisks, METH_VARARGS, "Determine whether all host disks will be present in the guest OS as shares."},
	{"PrlVmCfg_SetShareAllHostDisks", sdk_PrlVmCfg_SetShareAllHostDisks, METH_VARARGS, "Enable sharing of all host disks for the virtual machine. "},
	{"PrlVmCfg_IsShareUserHomeDir", sdk_PrlVmCfg_IsShareUserHomeDir, METH_VARARGS, "Determine whether the host user home directory will be available in the guest OS as a share. "},
	{"PrlVmCfg_SetShareUserHomeDir", sdk_PrlVmCfg_SetShareUserHomeDir, METH_VARARGS, "Enable or disable sharing of the host user home directory in the specified virtual machine. "},
	{"PrlVmCfg_IsMapSharedFoldersOnLetters", sdk_PrlVmCfg_IsMapSharedFoldersOnLetters, METH_VARARGS, "Determine whether host disks shared with the guest Windows OS will be mapped to drive letters."},
	{"PrlVmCfg_SetMapSharedFoldersOnLetters", sdk_PrlVmCfg_SetMapSharedFoldersOnLetters, METH_VARARGS, "Enable mapping of shared host disks to drive letters for the virtual machine. "},
	{"PrlVmCfg_GetVNCMode", sdk_PrlVmCfg_GetVNCMode, METH_VARARGS, "Return the VNC mode of the virtual machine. "},
	{"PrlVmCfg_SetVNCMode", sdk_PrlVmCfg_SetVNCMode, METH_VARARGS, "Set the virtual machine VNC mode. "},
	{"PrlVmCfg_GetVNCPassword", sdk_PrlVmCfg_GetVNCPassword, METH_VARARGS, "Return the VNC password for the virtual machine. "},
	{"PrlVmCfg_SetVNCPassword", sdk_PrlVmCfg_SetVNCPassword, METH_VARARGS, "Set the virtual machine VNC password. "},
	{"PrlVmCfg_GetVNCHostName", sdk_PrlVmCfg_GetVNCHostName, METH_VARARGS, "Return the VNC hostname of the virtual machine. "},
	{"PrlVmCfg_SetVNCHostName", sdk_PrlVmCfg_SetVNCHostName, METH_VARARGS, "Set the virtual machine VNC host name. "},
	{"PrlVmCfg_GetVNCPort", sdk_PrlVmCfg_GetVNCPort, METH_VARARGS, "Return the VNC port number for the virtual machine"},
	{"PrlVmCfg_SetVNCPort", sdk_PrlVmCfg_SetVNCPort, METH_VARARGS, "Set the virtual machine VNC port number. "},
	{"PrlVmCfg_IsScrResEnabled", sdk_PrlVmCfg_IsScrResEnabled, METH_VARARGS, "Determine if additional screen resolution support is enabled in the virtual machine. "},
	{"PrlVmCfg_SetScrResEnabled", sdk_PrlVmCfg_SetScrResEnabled, METH_VARARGS, "Enable or disable the additional screen resolution support in the virtual machine. "},
	{"PrlVmCfg_IsDiskCacheWriteBack", sdk_PrlVmCfg_IsDiskCacheWriteBack, METH_VARARGS, "Determine if disk cache write-back is enabled in the virtual machine."},
	{"PrlVmCfg_SetDiskCacheWriteBack", sdk_PrlVmCfg_SetDiskCacheWriteBack, METH_VARARGS, "Set the virtual machine disk cache write-back option. "},
	{"PrlVmCfg_IsOsResInFullScrMode", sdk_PrlVmCfg_IsOsResInFullScrMode, METH_VARARGS, "Determines wether the virtual machine OS resolution is in full screen mode. "},
	{"PrlVmCfg_SetOsResInFullScrMode", sdk_PrlVmCfg_SetOsResInFullScrMode, METH_VARARGS, "Turn on/off the virtual machine OS resolution in full screen mode option. "},
	{"PrlVmCfg_IsCloseAppOnShutdown", sdk_PrlVmCfg_IsCloseAppOnShutdown, METH_VARARGS, "Determine whether the Parallels console app is automatically closed on the virtual machine shutdown."},
	{"PrlVmCfg_SetCloseAppOnShutdown", sdk_PrlVmCfg_SetCloseAppOnShutdown, METH_VARARGS, "Set whether the Parallels console app will be closed on the virtual machine shutdown."},
	{"PrlVmCfg_GetSystemFlags", sdk_PrlVmCfg_GetSystemFlags, METH_VARARGS, "Return the virtual machine system flags. "},
	{"PrlVmCfg_SetSystemFlags", sdk_PrlVmCfg_SetSystemFlags, METH_VARARGS, "Set the virtual machine system flags. "},
	{"PrlVmCfg_IsDisableAPIC", sdk_PrlVmCfg_IsDisableAPIC, METH_VARARGS, "Determine whether the APIC is enabled during the virtual machine runtime. "},
	{"PrlVmCfg_SetDisableAPICSign", sdk_PrlVmCfg_SetDisableAPICSign, METH_VARARGS, "Set whether the virtual machine should be using APIC during runtime. "},
	{"PrlVmCfg_IsDisableSpeaker", sdk_PrlVmCfg_IsDisableSpeaker, METH_VARARGS, "PrlVmCfg_IsDisableSpeaker"},
	{"PrlVmCfg_SetDisableSpeakerSign", sdk_PrlVmCfg_SetDisableSpeakerSign, METH_VARARGS, "PrlVmCfg_SetDisableSpeakerSign"},
	{"PrlVmCfg_GetUndoDisksMode", sdk_PrlVmCfg_GetUndoDisksMode, METH_VARARGS, "Determine the current undo-disks mode for the virtual machine. "},
	{"PrlVmCfg_SetUndoDisksMode", sdk_PrlVmCfg_SetUndoDisksMode, METH_VARARGS, "Set the undo-disks mode for the virtual machine. "},
	{"PrlVmCfg_GetForegroundPriority", sdk_PrlVmCfg_GetForegroundPriority, METH_VARARGS, "Return foreground processes priority for the specified virtual machine. "},
	{"PrlVmCfg_SetForegroundPriority", sdk_PrlVmCfg_SetForegroundPriority, METH_VARARGS, "Set the virtual machine foreground processes priority."},
	{"PrlVmCfg_GetBackgroundPriority", sdk_PrlVmCfg_GetBackgroundPriority, METH_VARARGS, "Determine the specified virtual machine background process priority type. "},
	{"PrlVmCfg_SetBackgroundPriority", sdk_PrlVmCfg_SetBackgroundPriority, METH_VARARGS, "Set the virtual machine background processes priority. "},
	{"PrlVmCfg_IsUseDefaultAnswers", sdk_PrlVmCfg_IsUseDefaultAnswers, METH_VARARGS, "Determine whether the use default answers mechanism is active in the virtual machine. "},
	{"PrlVmCfg_SetUseDefaultAnswers", sdk_PrlVmCfg_SetUseDefaultAnswers, METH_VARARGS, "Enable the use default answers mechanism in a virtual machine. "},
	{"PrlVmCfg_GetSearchDomains", sdk_PrlVmCfg_GetSearchDomains, METH_VARARGS, "Obtain the list of search domains that will be assigned to the guest OS."},
	{"PrlVmCfg_SetSearchDomains", sdk_PrlVmCfg_SetSearchDomains, METH_VARARGS, "Set the global search domain list that will be assigned to the guest OS. "},
	{"PrlVmCfg_GetOfflineServices", sdk_PrlVmCfg_GetOfflineServices, METH_VARARGS, "Obtain the list of services available in the virtual machine offline management. "},
	{"PrlVmCfg_SetOfflineServices", sdk_PrlVmCfg_SetOfflineServices, METH_VARARGS, "Set offline services that will be available in the virtual machine offline management. "},
	{"PrlVmCfg_GetConfirmationsList", sdk_PrlVmCfg_GetConfirmationsList, METH_VARARGS, "Obtain a list of operations with virtual machine which requires administrator confirmation."},
	{"PrlVmCfg_SetConfirmationsList", sdk_PrlVmCfg_SetConfirmationsList, METH_VARARGS, "Obtain the list of virtual machine operations that require administrator confirmation."},
	{"PrlVmCfg_IsAutoCompressEnabled", sdk_PrlVmCfg_IsAutoCompressEnabled, METH_VARARGS, "Determine whether the Automatic HDD compression feature is enabled in the virtual machine."},
	{"PrlVmCfg_SetAutoCompressEnabled", sdk_PrlVmCfg_SetAutoCompressEnabled, METH_VARARGS, "Enables or disables the Automatic HDD compression feature in the virtual machine."},
	{"PrlVmCfg_GetAutoCompressInterval", sdk_PrlVmCfg_GetAutoCompressInterval, METH_VARARGS, "Determine the interval at which compacting virtual disks is performed by Automatic HDD compression. "},
	{"PrlVmCfg_SetAutoCompressInterval", sdk_PrlVmCfg_SetAutoCompressInterval, METH_VARARGS, "Set the time interval at which compacting virtual disks is done by Automatic HDD compression. "},
	{"PrlVmCfg_GetFreeDiskSpaceRatio", sdk_PrlVmCfg_GetFreeDiskSpaceRatio, METH_VARARGS, "Determine free disk space ratio at which disk compacting is done by Automatic HDD compression."},
	{"PrlVmCfg_SetFreeDiskSpaceRatio", sdk_PrlVmCfg_SetFreeDiskSpaceRatio, METH_VARARGS, "Set the free disk space ratio at which compacting virtual disks is done by Automatic HDD compress. "},
	{"PrlVmCfg_GetVmInfo", sdk_PrlVmCfg_GetVmInfo, METH_VARARGS, "PrlVmCfg_GetVmInfo"},
	{"PrlVmCfg_GetVmType", sdk_PrlVmCfg_GetVmType, METH_VARARGS, "PrlVmCfg_GetVmType"},
	{"PrlVmCfg_SetVmType", sdk_PrlVmCfg_SetVmType, METH_VARARGS, "PrlVmCfg_SetVmType"},
	{"PrlVmCfg_IsEfiEnabled", sdk_PrlVmCfg_IsEfiEnabled, METH_VARARGS, "PrlVmCfg_IsEfiEnabled"},
	{"PrlVmCfg_SetEfiEnabled", sdk_PrlVmCfg_SetEfiEnabled, METH_VARARGS, "PrlVmCfg_SetEfiEnabled"},
	{"PrlVmCfg_GetExternalBootDevice", sdk_PrlVmCfg_GetExternalBootDevice, METH_VARARGS, "PrlVmCfg_GetExternalBootDevice"},
	{"PrlVmCfg_SetExternalBootDevice", sdk_PrlVmCfg_SetExternalBootDevice, METH_VARARGS, "PrlVmCfg_SetExternalBootDevice"},
	{"PrlVm_CreateEvent", sdk_PrlVm_CreateEvent, METH_VARARGS, "Creates an event bound to the virtual machine. "},
	{"PrlVm_CreateUnattendedFloppy", sdk_PrlVm_CreateUnattendedFloppy, METH_VARARGS, "Create a floppy disk image for unattended Windows installation. "},
	{"PrlSrv_CreateUnattendedCd", sdk_PrlSrv_CreateUnattendedCd, METH_VARARGS, "Create a bootable ISO-image for unattended Linux installation."},
	{"PrlVm_InitiateDevStateNotifications", sdk_PrlVm_InitiateDevStateNotifications, METH_VARARGS, "Initiate the device states notification service."},
	{"PrlVm_ValidateConfig", sdk_PrlVm_ValidateConfig, METH_VARARGS, "Validate the specified section of a virtual machine configuration. "},
	{"PrlVm_UpdateSecurity", sdk_PrlVm_UpdateSecurity, METH_VARARGS, "Updates the security access level for the virtual machine."},
	{"PrlVm_InstallTools", sdk_PrlVm_InstallTools, METH_VARARGS, "Install Parallels Tools in the virtual machine."},
	{"PrlVm_GetToolsState", sdk_PrlVm_GetToolsState, METH_VARARGS, "Determine whether Parallels Tools is installed in the virtual machine. "},
	{"PrlVmDev_Create", sdk_PrlVmDev_Create, METH_VARARGS, "Create a new virtual device object not bound to any virtual machine."},
	{"PrlVmDev_Connect", sdk_PrlVmDev_Connect, METH_VARARGS, "Connect a virtual device to a running virtual machine."},
	{"PrlVmDev_Disconnect", sdk_PrlVmDev_Disconnect, METH_VARARGS, "Disconnect a device from a running virtual machine."},
	{"PrlVmDev_CreateImage", sdk_PrlVmDev_CreateImage, METH_VARARGS, "Physically create a virtual device image on the host. "},
	{"PrlVmDev_CopyImage", sdk_PrlVmDev_CopyImage, METH_VARARGS, "PrlVmDev_CopyImage"},
	{"PrlVmDev_ResizeImage", sdk_PrlVmDev_ResizeImage, METH_VARARGS, "Resize the virtual device image. "},
	{"PrlVmDev_GetIndex", sdk_PrlVmDev_GetIndex, METH_VARARGS, "Return the index identifying the virtual device."},
	{"PrlVmDev_SetIndex", sdk_PrlVmDev_SetIndex, METH_VARARGS, "Set theindex identifying the virtual device. "},
	{"PrlVmDev_Remove", sdk_PrlVmDev_Remove, METH_VARARGS, "Remove the virtual device object from the parent virtual machine list. "},
	{"PrlVmDev_GetType", sdk_PrlVmDev_GetType, METH_VARARGS, "Return the virtual device type."},
	{"PrlVmDev_IsConnected", sdk_PrlVmDev_IsConnected, METH_VARARGS, "Determine if the virtual device is connected. "},
	{"PrlVmDev_SetConnected", sdk_PrlVmDev_SetConnected, METH_VARARGS, "Connect the virtual device. "},
	{"PrlVmDev_IsEnabled", sdk_PrlVmDev_IsEnabled, METH_VARARGS, "Determine if the device is enabled. "},
	{"PrlVmDev_SetEnabled", sdk_PrlVmDev_SetEnabled, METH_VARARGS, "Enable the specified virtual device. "},
	{"PrlVmDev_IsRemote", sdk_PrlVmDev_IsRemote, METH_VARARGS, "Determine if the virtual device is a remote device. "},
	{"PrlVmDev_SetRemote", sdk_PrlVmDev_SetRemote, METH_VARARGS, "Change the 'remote' flag for the specified device. "},
	{"PrlVmDev_GetEmulatedType", sdk_PrlVmDev_GetEmulatedType, METH_VARARGS, "Return the virtual device emulation type. "},
	{"PrlVmDev_SetEmulatedType", sdk_PrlVmDev_SetEmulatedType, METH_VARARGS, "Sets the virtual device emulation type. "},
	{"PrlVmDev_GetImagePath", sdk_PrlVmDev_GetImagePath, METH_VARARGS, "Return virtual device image path."},
	{"PrlVmDev_SetImagePath", sdk_PrlVmDev_SetImagePath, METH_VARARGS, "Set the virtual device image path. "},
	{"PrlVmDev_GetSysName", sdk_PrlVmDev_GetSysName, METH_VARARGS, "Return the virtual device system name. "},
	{"PrlVmDev_SetSysName", sdk_PrlVmDev_SetSysName, METH_VARARGS, "Set the virtual device system name. "},
	{"PrlVmDev_GetFriendlyName", sdk_PrlVmDev_GetFriendlyName, METH_VARARGS, "Return the virtual device user-friendly name."},
	{"PrlVmDev_SetFriendlyName", sdk_PrlVmDev_SetFriendlyName, METH_VARARGS, "Set the virtual device user-friendly name. "},
	{"PrlVmDev_GetDescription", sdk_PrlVmDev_GetDescription, METH_VARARGS, "Return the description of a virtual device. "},
	{"PrlVmDev_SetDescription", sdk_PrlVmDev_SetDescription, METH_VARARGS, "Set the device description. "},
	{"PrlVmDev_GetIfaceType", sdk_PrlVmDev_GetIfaceType, METH_VARARGS, "Return the virtual device interface type (IDE or SCSI). "},
	{"PrlVmDev_SetIfaceType", sdk_PrlVmDev_SetIfaceType, METH_VARARGS, "Set the virtual device interface type (IDE or SCSI). "},
	{"PrlVmDev_GetSubType", sdk_PrlVmDev_GetSubType, METH_VARARGS, "PrlVmDev_GetSubType"},
	{"PrlVmDev_SetSubType", sdk_PrlVmDev_SetSubType, METH_VARARGS, "PrlVmDev_SetSubType"},
	{"PrlVmDev_GetStackIndex", sdk_PrlVmDev_GetStackIndex, METH_VARARGS, "Return the virtual device stack index (position at the IDE/SCSI controller bus). "},
	{"PrlVmDev_SetStackIndex", sdk_PrlVmDev_SetStackIndex, METH_VARARGS, "Set the virtual device stack index (position at the IDE or SCSI controller bus). "},
	{"PrlVmDev_SetDefaultStackIndex", sdk_PrlVmDev_SetDefaultStackIndex, METH_VARARGS, "Generates a stack index for the device (the device interface, IDE or SCSI, must be set in advance)."},
	{"PrlVmDev_GetOutputFile", sdk_PrlVmDev_GetOutputFile, METH_VARARGS, "Return the virtual device output file."},
	{"PrlVmDev_SetOutputFile", sdk_PrlVmDev_SetOutputFile, METH_VARARGS, "Set the virtual device output file. "},
	{"PrlVmDev_IsPassthrough", sdk_PrlVmDev_IsPassthrough, METH_VARARGS, "Determine if the passthrough mode is enabled for the mass storage device. "},
	{"PrlVmDev_SetPassthrough", sdk_PrlVmDev_SetPassthrough, METH_VARARGS, "Enable the passthrough mode for the mass storage device (optical or hard disk). "},
	{"PrlVmDevHd_GetDiskType", sdk_PrlVmDevHd_GetDiskType, METH_VARARGS, "Return the hard disk type. "},
	{"PrlVmDevHd_SetDiskType", sdk_PrlVmDevHd_SetDiskType, METH_VARARGS, "Set the type of the virtual hard disk. "},
	{"PrlVmDevHd_IsSplitted", sdk_PrlVmDevHd_IsSplitted, METH_VARARGS, "Determine if the virtual hard disk is split into multiple files. "},
	{"PrlVmDevHd_SetSplitted", sdk_PrlVmDevHd_SetSplitted, METH_VARARGS, "Sety whether the hard disk should be split into multiple files. "},
	{"PrlVmDevHd_GetDiskSize", sdk_PrlVmDevHd_GetDiskSize, METH_VARARGS, "Return the hard disk size. "},
	{"PrlVmDevHd_SetDiskSize", sdk_PrlVmDevHd_SetDiskSize, METH_VARARGS, "Set the size of the virtual hard disk. "},
	{"PrlVmDevHd_GetSizeOnDisk", sdk_PrlVmDevHd_GetSizeOnDisk, METH_VARARGS, "Return the size of the occupied space on the hard disk. "},
	{"PrlVmDevHd_AddPartition", sdk_PrlVmDevHd_AddPartition, METH_VARARGS, "Assign a boot camp partition to the virtual hard disk. "},
	{"PrlVmDevHd_GetPartitionsCount", sdk_PrlVmDevHd_GetPartitionsCount, METH_VARARGS, "Determine the number of partitions on the virtual hard disk. "},
	{"PrlVmDevHd_GetPartition", sdk_PrlVmDevHd_GetPartition, METH_VARARGS, "Obtain the L{VmHdPartition} object containing a hard disk partition info. "},
	{"PrlVmDevHdPart_Remove", sdk_PrlVmDevHdPart_Remove, METH_VARARGS, "Remove the specified partition object from the virtual hard disk list. "},
	{"PrlVmDevHd_SetMountPoint", sdk_PrlVmDevHd_SetMountPoint, METH_VARARGS, "PrlVmDevHd_SetMountPoint"},
	{"PrlVmDevHd_GetMountPoint", sdk_PrlVmDevHd_GetMountPoint, METH_VARARGS, "PrlVmDevHd_GetMountPoint"},
	{"PrlVmDevHd_SetAutoCompressEnabled", sdk_PrlVmDevHd_SetAutoCompressEnabled, METH_VARARGS, "PrlVmDevHd_SetAutoCompressEnabled"},
	{"PrlVmDevHd_IsAutoCompressEnabled", sdk_PrlVmDevHd_IsAutoCompressEnabled, METH_VARARGS, "PrlVmDevHd_IsAutoCompressEnabled"},
	{"PrlVmDevHd_SetStorageURL", sdk_PrlVmDevHd_SetStorageURL, METH_VARARGS, "PrlVmDevHd_SetStorageURL"},
	{"PrlVmDevHd_GetStorageURL", sdk_PrlVmDevHd_GetStorageURL, METH_VARARGS, "PrlVmDevHd_GetStorageURL"},
	{"PrlVmDevHdPart_GetSysName", sdk_PrlVmDevHdPart_GetSysName, METH_VARARGS, "Return the hard disk partition system name. "},
	{"PrlVmDevHdPart_SetSysName", sdk_PrlVmDevHdPart_SetSysName, METH_VARARGS, "Set system name for the disk partition."},
	{"PrlVmDevNet_GetBoundAdapterIndex", sdk_PrlVmDevNet_GetBoundAdapterIndex, METH_VARARGS, "Return the index of the adapter to which this virtual adapter is bound."},
	{"PrlVmDevNet_SetBoundAdapterIndex", sdk_PrlVmDevNet_SetBoundAdapterIndex, METH_VARARGS, "Set the index of the adapter to which this virtual adapter should be bound."},
	{"PrlVmDevNet_GetBoundAdapterName", sdk_PrlVmDevNet_GetBoundAdapterName, METH_VARARGS, "Return the name of the adapter to which this virtual adapter is bound."},
	{"PrlVmDevNet_SetBoundAdapterName", sdk_PrlVmDevNet_SetBoundAdapterName, METH_VARARGS, "Set the name of the network adapter to which this virtual adapter will bind."},
	{"PrlVmDevNet_GetMacAddress", sdk_PrlVmDevNet_GetMacAddress, METH_VARARGS, "Return the MAC address of the virtual network adapter."},
	{"PrlVmDevNet_GetMacAddressCanonical", sdk_PrlVmDevNet_GetMacAddressCanonical, METH_VARARGS, "PrlVmDevNet_GetMacAddressCanonical"},
	{"PrlVmDevNet_SetMacAddress", sdk_PrlVmDevNet_SetMacAddress, METH_VARARGS, "Set MAC address to the network adapter. "},
	{"PrlVmDevNet_GenerateMacAddr", sdk_PrlVmDevNet_GenerateMacAddr, METH_VARARGS, "Generate a unique MAC address for the virtual network adapter."},
	{"PrlVmDevNet_IsAutoApply", sdk_PrlVmDevNet_IsAutoApply, METH_VARARGS, "Determine if the network adapter is configured to automatically apply network settings inside guest."},
	{"PrlVmDevNet_SetAutoApply", sdk_PrlVmDevNet_SetAutoApply, METH_VARARGS, "Set whether the network adapter should be automatically configured. "},
	{"PrlVmDevNet_GetNetAddresses", sdk_PrlVmDevNet_GetNetAddresses, METH_VARARGS, "Obtain the list of IP address/subnet_mask pairs which are assigned to the virtual network adapter."},
	{"PrlVmDevNet_SetNetAddresses", sdk_PrlVmDevNet_SetNetAddresses, METH_VARARGS, "Set IP addresses/subnet masks to the network adapter. "},
	{"PrlVmDevNet_GetDnsServers", sdk_PrlVmDevNet_GetDnsServers, METH_VARARGS, "Obtain the list of DNS servers which are assigned to the virtual network adapter."},
	{"PrlVmDevNet_SetDnsServers", sdk_PrlVmDevNet_SetDnsServers, METH_VARARGS, "Assign DNS servers to the network adapter. "},
	{"PrlVmDevNet_GetSearchDomains", sdk_PrlVmDevNet_GetSearchDomains, METH_VARARGS, "Obtain the lists of search domains assigned to the virtual network adapter. "},
	{"PrlVmDevNet_SetSearchDomains", sdk_PrlVmDevNet_SetSearchDomains, METH_VARARGS, "Assign search domains to the network adapter. "},
	{"PrlVmDevNet_IsConfigureWithDhcp", sdk_PrlVmDevNet_IsConfigureWithDhcp, METH_VARARGS, "Determine if the network adapter is configured through DHCP on the guest OS side."},
	{"PrlVmDevNet_SetConfigureWithDhcp", sdk_PrlVmDevNet_SetConfigureWithDhcp, METH_VARARGS, "Set whether the network adapter should be configured through DHCP or manually."},
	{"PrlVmDevNet_IsConfigureWithDhcpIPv6", sdk_PrlVmDevNet_IsConfigureWithDhcpIPv6, METH_VARARGS, "PrlVmDevNet_IsConfigureWithDhcpIPv6"},
	{"PrlVmDevNet_SetConfigureWithDhcpIPv6", sdk_PrlVmDevNet_SetConfigureWithDhcpIPv6, METH_VARARGS, "PrlVmDevNet_SetConfigureWithDhcpIPv6"},
	{"PrlVmDevNet_GetDefaultGateway", sdk_PrlVmDevNet_GetDefaultGateway, METH_VARARGS, "Obtain the default gateway assigned to the virtual network adapter. "},
	{"PrlVmDevNet_SetDefaultGateway", sdk_PrlVmDevNet_SetDefaultGateway, METH_VARARGS, "Set the default gateway address for the network adapter. "},
	{"PrlVmDevNet_GetDefaultGatewayIPv6", sdk_PrlVmDevNet_GetDefaultGatewayIPv6, METH_VARARGS, "PrlVmDevNet_GetDefaultGatewayIPv6"},
	{"PrlVmDevNet_SetDefaultGatewayIPv6", sdk_PrlVmDevNet_SetDefaultGatewayIPv6, METH_VARARGS, "PrlVmDevNet_SetDefaultGatewayIPv6"},
	{"PrlVmDevNet_GetVirtualNetworkId", sdk_PrlVmDevNet_GetVirtualNetworkId, METH_VARARGS, "Obtain the virtual network ID assigned to the virtual network adapter. "},
	{"PrlVmDevNet_SetVirtualNetworkId", sdk_PrlVmDevNet_SetVirtualNetworkId, METH_VARARGS, "Set the virtual network ID for the network adapter."},
	{"PrlVmDevNet_GetAdapterType", sdk_PrlVmDevNet_GetAdapterType, METH_VARARGS, "PrlVmDevNet_GetAdapterType"},
	{"PrlVmDevNet_SetAdapterType", sdk_PrlVmDevNet_SetAdapterType, METH_VARARGS, "PrlVmDevNet_SetAdapterType"},
	{"PrlVmDevNet_IsPktFilterPreventMacSpoof", sdk_PrlVmDevNet_IsPktFilterPreventMacSpoof, METH_VARARGS, "PrlVmDevNet_IsPktFilterPreventMacSpoof"},
	{"PrlVmDevNet_SetPktFilterPreventMacSpoof", sdk_PrlVmDevNet_SetPktFilterPreventMacSpoof, METH_VARARGS, "PrlVmDevNet_SetPktFilterPreventMacSpoof"},
	{"PrlVmDevNet_IsPktFilterPreventPromisc", sdk_PrlVmDevNet_IsPktFilterPreventPromisc, METH_VARARGS, "PrlVmDevNet_IsPktFilterPreventPromisc"},
	{"PrlVmDevNet_SetPktFilterPreventPromisc", sdk_PrlVmDevNet_SetPktFilterPreventPromisc, METH_VARARGS, "PrlVmDevNet_SetPktFilterPreventPromisc"},
	{"PrlVmDevNet_IsPktFilterPreventIpSpoof", sdk_PrlVmDevNet_IsPktFilterPreventIpSpoof, METH_VARARGS, "PrlVmDevNet_IsPktFilterPreventIpSpoof"},
	{"PrlVmDevNet_SetPktFilterPreventIpSpoof", sdk_PrlVmDevNet_SetPktFilterPreventIpSpoof, METH_VARARGS, "PrlVmDevNet_SetPktFilterPreventIpSpoof"},
	{"PrlVmDevNet_IsFirewallEnabled", sdk_PrlVmDevNet_IsFirewallEnabled, METH_VARARGS, "PrlVmDevNet_IsFirewallEnabled"},
	{"PrlVmDevNet_SetFirewallEnabled", sdk_PrlVmDevNet_SetFirewallEnabled, METH_VARARGS, "PrlVmDevNet_SetFirewallEnabled"},
	{"PrlVmDevNet_GetFirewallDefaultPolicy", sdk_PrlVmDevNet_GetFirewallDefaultPolicy, METH_VARARGS, "PrlVmDevNet_GetFirewallDefaultPolicy"},
	{"PrlVmDevNet_SetFirewallDefaultPolicy", sdk_PrlVmDevNet_SetFirewallDefaultPolicy, METH_VARARGS, "PrlVmDevNet_SetFirewallDefaultPolicy"},
	{"PrlVmDevNet_GetFirewallRuleList", sdk_PrlVmDevNet_GetFirewallRuleList, METH_VARARGS, "PrlVmDevNet_GetFirewallRuleList"},
	{"PrlVmDevNet_SetFirewallRuleList", sdk_PrlVmDevNet_SetFirewallRuleList, METH_VARARGS, "PrlVmDevNet_SetFirewallRuleList"},
	{"PrlVmDevNet_GetHostInterfaceName", sdk_PrlVmDevNet_GetHostInterfaceName, METH_VARARGS, "PrlVmDevNet_GetHostInterfaceName"},
	{"PrlVmDevNet_SetHostInterfaceName", sdk_PrlVmDevNet_SetHostInterfaceName, METH_VARARGS, "PrlVmDevNet_SetHostInterfaceName"},
	{"PrlFirewallRule_Create", sdk_PrlFirewallRule_Create, METH_NOARGS, "PrlFirewallRule_Create"},
	{"PrlFirewallRule_GetLocalPort", sdk_PrlFirewallRule_GetLocalPort, METH_VARARGS, "PrlFirewallRule_GetLocalPort"},
	{"PrlFirewallRule_SetLocalPort", sdk_PrlFirewallRule_SetLocalPort, METH_VARARGS, "PrlFirewallRule_SetLocalPort"},
	{"PrlFirewallRule_GetRemotePort", sdk_PrlFirewallRule_GetRemotePort, METH_VARARGS, "PrlFirewallRule_GetRemotePort"},
	{"PrlFirewallRule_SetRemotePort", sdk_PrlFirewallRule_SetRemotePort, METH_VARARGS, "PrlFirewallRule_SetRemotePort"},
	{"PrlFirewallRule_GetProtocol", sdk_PrlFirewallRule_GetProtocol, METH_VARARGS, "PrlFirewallRule_GetProtocol"},
	{"PrlFirewallRule_SetProtocol", sdk_PrlFirewallRule_SetProtocol, METH_VARARGS, "PrlFirewallRule_SetProtocol"},
	{"PrlFirewallRule_GetLocalNetAddress", sdk_PrlFirewallRule_GetLocalNetAddress, METH_VARARGS, "PrlFirewallRule_GetLocalNetAddress"},
	{"PrlFirewallRule_SetLocalNetAddress", sdk_PrlFirewallRule_SetLocalNetAddress, METH_VARARGS, "PrlFirewallRule_SetLocalNetAddress"},
	{"PrlFirewallRule_GetRemoteNetAddress", sdk_PrlFirewallRule_GetRemoteNetAddress, METH_VARARGS, "PrlFirewallRule_GetRemoteNetAddress"},
	{"PrlFirewallRule_SetRemoteNetAddress", sdk_PrlFirewallRule_SetRemoteNetAddress, METH_VARARGS, "PrlFirewallRule_SetRemoteNetAddress"},
	{"PrlVmDevUsb_GetAutoconnectOption", sdk_PrlVmDevUsb_GetAutoconnectOption, METH_VARARGS, "Obtain the USB controller autoconnect device option. "},
	{"PrlVmDevUsb_SetAutoconnectOption", sdk_PrlVmDevUsb_SetAutoconnectOption, METH_VARARGS, "Set the USB controller autoconnect device option."},
	{"PrlVmDevSound_GetOutputDev", sdk_PrlVmDevSound_GetOutputDev, METH_VARARGS, "Return the output device string for the sound device. "},
	{"PrlVmDevSound_SetOutputDev", sdk_PrlVmDevSound_SetOutputDev, METH_VARARGS, "Set the output device string for the sound device. "},
	{"PrlVmDevSound_GetMixerDev", sdk_PrlVmDevSound_GetMixerDev, METH_VARARGS, "Return the mixer device string for the sound device. "},
	{"PrlVmDevSound_SetMixerDev", sdk_PrlVmDevSound_SetMixerDev, METH_VARARGS, "Set the mixer device string for the sound device. "},
	{"PrlVmDevSerial_GetSocketMode", sdk_PrlVmDevSerial_GetSocketMode, METH_VARARGS, "Return the socket mode of the virtual serial port. "},
	{"PrlVmDevSerial_SetSocketMode", sdk_PrlVmDevSerial_SetSocketMode, METH_VARARGS, "Set the socket mode for the virtual serial port. "},
	{"PrlShare_Remove", sdk_PrlShare_Remove, METH_VARARGS, "Remove the share from the virtual machine configuration. "},
	{"PrlShare_GetName", sdk_PrlShare_GetName, METH_VARARGS, "Return the shared folder name (as it appears in the guest OS). "},
	{"PrlShare_SetName", sdk_PrlShare_SetName, METH_VARARGS, "Set the share name (as it will appear in the guest OS). "},
	{"PrlShare_GetPath", sdk_PrlShare_GetPath, METH_VARARGS, "Return the shared folder path. "},
	{"PrlShare_SetPath", sdk_PrlShare_SetPath, METH_VARARGS, "Set the shared folder path. "},
	{"PrlShare_GetDescription", sdk_PrlShare_GetDescription, METH_VARARGS, "Return the shared folder description. "},
	{"PrlShare_SetDescription", sdk_PrlShare_SetDescription, METH_VARARGS, "Set the shared folder description. "},
	{"PrlShare_IsEnabled", sdk_PrlShare_IsEnabled, METH_VARARGS, "Determine whether the share is enabled or not. "},
	{"PrlShare_SetEnabled", sdk_PrlShare_SetEnabled, METH_VARARGS, "Enable the specified share. "},
	{"PrlShare_IsReadOnly", sdk_PrlShare_IsReadOnly, METH_VARARGS, "Determine if the share is read-only. "},
	{"PrlShare_SetReadOnly", sdk_PrlShare_SetReadOnly, METH_VARARGS, "Make the shared folder read-only. "},
	{"PrlBootDev_Remove", sdk_PrlBootDev_Remove, METH_VARARGS, "Remove the boot device from the boot priority list."},
	{"PrlBootDev_GetType", sdk_PrlBootDev_GetType, METH_VARARGS, "Return the boot device type."},
	{"PrlBootDev_SetType", sdk_PrlBootDev_SetType, METH_VARARGS, "Set the boot device type."},
	{"PrlBootDev_GetIndex", sdk_PrlBootDev_GetIndex, METH_VARARGS, "Obtain the boot device index."},
	{"PrlBootDev_SetIndex", sdk_PrlBootDev_SetIndex, METH_VARARGS, "Set the boot device index."},
	{"PrlBootDev_GetSequenceIndex", sdk_PrlBootDev_GetSequenceIndex, METH_VARARGS, "Obtain the sequence index of the boot device in the boot priority list."},
	{"PrlBootDev_SetSequenceIndex", sdk_PrlBootDev_SetSequenceIndex, METH_VARARGS, "Assign a sequence index to a boot device in the boot priority list."},
	{"PrlBootDev_IsInUse", sdk_PrlBootDev_IsInUse, METH_VARARGS, "Determine whether the boot device is enabled or disabled."},
	{"PrlBootDev_SetInUse", sdk_PrlBootDev_SetInUse, METH_VARARGS, "Enable or disable the boot device in the boot priority list."},
	{"PrlVmInfo_GetState", sdk_PrlVmInfo_GetState, METH_VARARGS, "Return the virtual machine state information. "},
	{"PrlVmInfo_GetAccessRights", sdk_PrlVmInfo_GetAccessRights, METH_VARARGS, "Obtains the L{AccessRights} object containing information about the virtual machine access rights."},
	{"PrlVmInfo_IsInvalid", sdk_PrlVmInfo_IsInvalid, METH_VARARGS, "Determine if the specified virtual machine is invalid."},
	{"PrlVmInfo_IsVmWaitingForAnswer", sdk_PrlVmInfo_IsVmWaitingForAnswer, METH_VARARGS, "Determine if the specified virtual machine is waiting for an answer to a question that it asked."},
	{"PrlVmInfo_IsVncServerStarted", sdk_PrlVmInfo_IsVncServerStarted, METH_VARARGS, "Determine whether a VNC server is running for the specified virtual machine."},
	{"PrlFoundVmInfo_GetName", sdk_PrlFoundVmInfo_GetName, METH_VARARGS, "Obtains the virtual machine name."},
	{"PrlFoundVmInfo_IsOldConfig", sdk_PrlFoundVmInfo_IsOldConfig, METH_VARARGS, "Determines whether the vitrual machine configuration is an older version."},
	{"PrlFoundVmInfo_GetOSVersion", sdk_PrlFoundVmInfo_GetOSVersion, METH_VARARGS, "Obtains the guest OS version information."},
	{"PrlFoundVmInfo_GetConfigPath", sdk_PrlFoundVmInfo_GetConfigPath, METH_VARARGS, "Obtains the name and path of the directory containing the virtual machine files."},
	{"PrlFoundVmInfo_IsTemplate", sdk_PrlFoundVmInfo_IsTemplate, METH_VARARGS, "Determines if the virtual machine is a template."},
	{"PrlAcl_IsAllowed", sdk_PrlAcl_IsAllowed, METH_VARARGS, "Determine if the current user is authorized to perform a specified task on the virtual machine."},
	{"PrlAcl_GetAccessForOthers", sdk_PrlAcl_GetAccessForOthers, METH_VARARGS, "Obtain the virtual machine access rights information."},
	{"PrlAcl_SetAccessForOthers", sdk_PrlAcl_SetAccessForOthers, METH_VARARGS, "Set access rights on a virtual machine."},
	{"PrlAcl_GetOwnerName", sdk_PrlAcl_GetOwnerName, METH_VARARGS, "Determine the virtual machine owner name."},
	{"PrlAcl_IsCurrentSessionOwner", sdk_PrlAcl_IsCurrentSessionOwner, METH_VARARGS, "Determine if the current user is the owner of the virtual machine."},
	{"PrlVmToolsInfo_GetState", sdk_PrlVmToolsInfo_GetState, METH_VARARGS, ""},
	{"PrlVmToolsInfo_GetVersion", sdk_PrlVmToolsInfo_GetVersion, METH_VARARGS, ""},
	{"PrlStat_GetTotalRamSize", sdk_PrlStat_GetTotalRamSize, METH_VARARGS, "Return total RAM size in bytes."},
	{"PrlStat_GetUsageRamSize", sdk_PrlStat_GetUsageRamSize, METH_VARARGS, "Return the size of RAM currently in use, in bytes."},
	{"PrlStat_GetFreeRamSize", sdk_PrlStat_GetFreeRamSize, METH_VARARGS, "Return free RAM size in bytes."},
	{"PrlStat_GetRealRamSize", sdk_PrlStat_GetRealRamSize, METH_VARARGS, "PrlStat_GetRealRamSize"},
	{"PrlStat_GetOsUptime", sdk_PrlStat_GetOsUptime, METH_VARARGS, "Return the virtual machine uptime in seconds."},
	{"PrlStat_GetCpusStatsCount", sdk_PrlStat_GetCpusStatsCount, METH_VARARGS, "Return the number of L{StatCpu} objects contained in this L{Statistics} object. Each L{StatCpu} object contains statistics for an individual CPU."},
	{"PrlStat_GetCpuStat", sdk_PrlStat_GetCpuStat, METH_VARARGS, "Return a L{StatCpu} object specified by an index."},
	{"PrlStatCpu_GetCpuUsage", sdk_PrlStatCpu_GetCpuUsage, METH_VARARGS, "Return the CPU usage, in percents."},
	{"PrlStatCpu_GetTotalTime", sdk_PrlStatCpu_GetTotalTime, METH_VARARGS, "Return the CPU total time, in seconds."},
	{"PrlStatCpu_GetUserTime", sdk_PrlStatCpu_GetUserTime, METH_VARARGS, "Return the CPU user time in seconds"},
	{"PrlStatCpu_GetSystemTime", sdk_PrlStatCpu_GetSystemTime, METH_VARARGS, "Return the CPU time, in seconds."},
	{"PrlLic_IsValid", sdk_PrlLic_IsValid, METH_VARARGS, "Determines whether the license if valid or not."},
	{"PrlLic_GetStatus", sdk_PrlLic_GetStatus, METH_VARARGS, "Determines the license status."},
	{"PrlLic_GetLicenseKey", sdk_PrlLic_GetLicenseKey, METH_VARARGS, "Obtains the liecense key."},
	{"PrlLic_GetUserName", sdk_PrlLic_GetUserName, METH_VARARGS, "Obtains the name of the user on the license."},
	{"PrlLic_GetCompanyName", sdk_PrlLic_GetCompanyName, METH_VARARGS, "Obtains the name of the company on the license."},
	{"PrlSrvInfo_GetHostName", sdk_PrlSrvInfo_GetHostName, METH_VARARGS, "Return the name of the machine hosting the specified Parallels Service."},
	{"PrlSrvInfo_GetOsVersion", sdk_PrlSrvInfo_GetOsVersion, METH_VARARGS, "Returns the version of the host operating system."},
	{"PrlSrvInfo_GetProductVersion", sdk_PrlSrvInfo_GetProductVersion, METH_VARARGS, "Return the Parallels product version number."},
	{"PrlSrvInfo_GetCmdPort", sdk_PrlSrvInfo_GetCmdPort, METH_VARARGS, "Return the port number at which the Parallels Service is listening for requests."},
	{"PrlSrvInfo_GetApplicationMode", sdk_PrlSrvInfo_GetApplicationMode, METH_VARARGS, "PrlSrvInfo_GetApplicationMode"},
	{"PrlSrvInfo_GetServerUuid", sdk_PrlSrvInfo_GetServerUuid, METH_VARARGS, "Return the host machine UUID (universally unique ID)."},
	{"PrlSrvInfo_GetStartTime", sdk_PrlSrvInfo_GetStartTime, METH_VARARGS, "PrlSrvInfo_GetStartTime"},
	{"PrlSrvInfo_GetStartTimeMonotonic", sdk_PrlSrvInfo_GetStartTimeMonotonic, METH_VARARGS, "PrlSrvInfo_GetStartTimeMonotonic"},
	{"PrlNetSvc_GetStatus", sdk_PrlNetSvc_GetStatus, METH_VARARGS, ""},
	{"PrlSrv_FsGenerateEntryName", sdk_PrlSrv_FsGenerateEntryName, METH_VARARGS, "Automatically generate a unique name for a new directory. "},
	{"PrlLoginResponse_GetSessionUuid", sdk_PrlLoginResponse_GetSessionUuid, METH_VARARGS, "Returns the session UUID string (used to restore a session)."},
	{"PrlLoginResponse_GetRunningTaskCount", sdk_PrlLoginResponse_GetRunningTaskCount, METH_VARARGS, "Return the total number of running tasks."},
	{"PrlLoginResponse_GetRunningTaskByIndex", sdk_PrlLoginResponse_GetRunningTaskByIndex, METH_VARARGS, "Obtain the L{RunningTask} object containing information about a running task."},
	{"PrlLoginResponse_GetServerUuid", sdk_PrlLoginResponse_GetServerUuid, METH_VARARGS, "Return the host machine UUID."},
	{"PrlLoginResponse_GetHostOsVersion", sdk_PrlLoginResponse_GetHostOsVersion, METH_VARARGS, "Return the host OS version."},
	{"PrlLoginResponse_GetProductVersion", sdk_PrlLoginResponse_GetProductVersion, METH_VARARGS, "Return the Parallels product version number."},
	{"PrlRunningTask_GetTaskUuid", sdk_PrlRunningTask_GetTaskUuid, METH_VARARGS, "Return the task UUID (universally unique ID). "},
	{"PrlRunningTask_GetTaskType", sdk_PrlRunningTask_GetTaskType, METH_VARARGS, "Determine the task type."},
	{"PrlRunningTask_GetTaskParametersAsString", sdk_PrlRunningTask_GetTaskParametersAsString, METH_VARARGS, "Return task parameters as a string. "},
	{"PrlSrv_SubscribeToPerfStats", sdk_PrlSrv_SubscribeToPerfStats, METH_VARARGS, "Subscribe to receive perfomance statistics. "},
	{"PrlSrv_UnsubscribeFromPerfStats", sdk_PrlSrv_UnsubscribeFromPerfStats, METH_VARARGS, "Cancels the performance statistics subscription."},
	{"PrlSrv_GetPerfStats", sdk_PrlSrv_GetPerfStats, METH_VARARGS, "PrlSrv_GetPerfStats"},
	{"PrlVm_SubscribeToPerfStats", sdk_PrlVm_SubscribeToPerfStats, METH_VARARGS, "PrlVm_SubscribeToPerfStats"},
	{"PrlVm_UnsubscribeFromPerfStats", sdk_PrlVm_UnsubscribeFromPerfStats, METH_VARARGS, "Cancels the Parallels Service performance statistics subscription ."},
	{"PrlVm_GetPerfStats", sdk_PrlVm_GetPerfStats, METH_VARARGS, "PrlVm_GetPerfStats"},
	{"PrlVm_AuthWithGuestSecurityDb", sdk_PrlVm_AuthWithGuestSecurityDb, METH_VARARGS, "Authenticate the user through the guest OS security database. "},
	{"PrlVmInfo_GetAdditionState", sdk_PrlVmInfo_GetAdditionState, METH_VARARGS, "Return the virtual machine addition state information."},
	{"PrlVm_Compact", sdk_PrlVm_Compact, METH_VARARGS, "Start the process of a virtual hard disk optimization. "},
	{"PrlVm_CancelCompact", sdk_PrlVm_CancelCompact, METH_VARARGS, "Finishes process of optimization of virtual hard disk. "},
	{"PrlVm_ConvertDisks", sdk_PrlVm_ConvertDisks, METH_VARARGS, "PrlVm_ConvertDisks"},
	{"PrlVm_CancelConvertDisks", sdk_PrlVm_CancelConvertDisks, METH_VARARGS, "PrlVm_CancelConvertDisks"},
	{"PrlOsesMatrix_GetSupportedOsesTypes", sdk_PrlOsesMatrix_GetSupportedOsesTypes, METH_VARARGS, "PrlOsesMatrix_GetSupportedOsesTypes"},
	{"PrlOsesMatrix_GetSupportedOsesVersions", sdk_PrlOsesMatrix_GetSupportedOsesVersions, METH_VARARGS, "PrlOsesMatrix_GetSupportedOsesVersions"},
	{"PrlOsesMatrix_GetDefaultOsVersion", sdk_PrlOsesMatrix_GetDefaultOsVersion, METH_VARARGS, "PrlOsesMatrix_GetDefaultOsVersion"},
	{"PrlSrv_HasRestriction", sdk_PrlSrv_HasRestriction, METH_VARARGS, "PrlSrv_HasRestriction"},
	{"PrlSrv_GetRestrictionInfo", sdk_PrlSrv_GetRestrictionInfo, METH_VARARGS, "PrlSrv_GetRestrictionInfo"},
	{"PrlApi_CreateProblemReport", sdk_PrlApi_CreateProblemReport, METH_VARARGS, "PrlApi_CreateProblemReport"},
	{"PrlReport_SetUserName", sdk_PrlReport_SetUserName, METH_VARARGS, "PrlReport_SetUserName"},
	{"PrlReport_GetUserName", sdk_PrlReport_GetUserName, METH_VARARGS, "PrlReport_GetUserName"},
	{"PrlReport_SetUserEmail", sdk_PrlReport_SetUserEmail, METH_VARARGS, "PrlReport_SetUserEmail"},
	{"PrlReport_GetUserEmail", sdk_PrlReport_GetUserEmail, METH_VARARGS, "PrlReport_GetUserEmail"},
	{"PrlReport_SetDescription", sdk_PrlReport_SetDescription, METH_VARARGS, "PrlReport_SetDescription"},
	{"PrlReport_GetDescription", sdk_PrlReport_GetDescription, METH_VARARGS, "PrlReport_GetDescription"},
	{"PrlReport_SetType", sdk_PrlReport_SetType, METH_VARARGS, "PrlReport_SetType"},
	{"PrlReport_GetType", sdk_PrlReport_GetType, METH_VARARGS, "PrlReport_GetType"},
	{"PrlReport_SetReason", sdk_PrlReport_SetReason, METH_VARARGS, "PrlReport_SetReason"},
	{"PrlReport_GetReason", sdk_PrlReport_GetReason, METH_VARARGS, "PrlReport_GetReason"},
	{"PrlReport_GetScheme", sdk_PrlReport_GetScheme, METH_VARARGS, "PrlReport_GetScheme"},
	{"PrlReport_GetArchiveFileName", sdk_PrlReport_GetArchiveFileName, METH_VARARGS, "PrlReport_GetArchiveFileName"},
	{"PrlReport_GetData", sdk_PrlReport_GetData, METH_VARARGS, "PrlReport_GetData"},
	{"PrlReport_AsString", sdk_PrlReport_AsString, METH_VARARGS, "PrlReport_AsString"},
	{"PrlReport_Assembly", sdk_PrlReport_Assembly, METH_VARARGS, "PrlReport_Assembly"},
	{"PrlReport_Send", sdk_PrlReport_Send, METH_VARARGS, "PrlReport_Send"},
	{"PrlSrv_InstallAppliance", sdk_PrlSrv_InstallAppliance, METH_VARARGS, "PrlSrv_InstallAppliance"},
	{"PrlSrv_CancelInstallAppliance", sdk_PrlSrv_CancelInstallAppliance, METH_VARARGS, "PrlSrv_CancelInstallAppliance"},
	{"PrlSrv_StopInstallAppliance", sdk_PrlSrv_StopInstallAppliance, METH_VARARGS, "PrlSrv_StopInstallAppliance"},
	{"PrlAppliance_Create", sdk_PrlAppliance_Create, METH_NOARGS, "PrlAppliance_Create"},
	{"PrlCtTemplate_GetName", sdk_PrlCtTemplate_GetName, METH_VARARGS, "PrlCtTemplate_GetName"},
	{"PrlCtTemplate_GetType", sdk_PrlCtTemplate_GetType, METH_VARARGS, "PrlCtTemplate_GetType"},
	{"PrlCtTemplate_GetDescription", sdk_PrlCtTemplate_GetDescription, METH_VARARGS, "PrlCtTemplate_GetDescription"},
	{"PrlCtTemplate_GetVersion", sdk_PrlCtTemplate_GetVersion, METH_VARARGS, "PrlCtTemplate_GetVersion"},
	{"PrlCtTemplate_GetOsType", sdk_PrlCtTemplate_GetOsType, METH_VARARGS, "PrlCtTemplate_GetOsType"},
	{"PrlCtTemplate_GetOsVersion", sdk_PrlCtTemplate_GetOsVersion, METH_VARARGS, "PrlCtTemplate_GetOsVersion"},
	{"PrlCtTemplate_GetOsTemplate", sdk_PrlCtTemplate_GetOsTemplate, METH_VARARGS, "PrlCtTemplate_GetOsTemplate"},
	{"PrlCtTemplate_GetCpuMode", sdk_PrlCtTemplate_GetCpuMode, METH_VARARGS, "PrlCtTemplate_GetCpuMode"},
	{"PrlCtTemplate_IsCached", sdk_PrlCtTemplate_IsCached, METH_VARARGS, "PrlCtTemplate_IsCached"},
	{"PrlSrv_GetCtTemplateList", sdk_PrlSrv_GetCtTemplateList, METH_VARARGS, "PrlSrv_GetCtTemplateList"},
	{"PrlSrv_RemoveCtTemplate", sdk_PrlSrv_RemoveCtTemplate, METH_VARARGS, "PrlSrv_RemoveCtTemplate"},
	{"PrlDispCfg_GetUsbIdentityCount", sdk_PrlDispCfg_GetUsbIdentityCount, METH_VARARGS, "PrlDispCfg_GetUsbIdentityCount"},
	{"PrlDispCfg_GetUsbIdentity", sdk_PrlDispCfg_GetUsbIdentity, METH_VARARGS, "PrlDispCfg_GetUsbIdentity"},
	{"PrlUsbIdent_GetSystemName", sdk_PrlUsbIdent_GetSystemName, METH_VARARGS, "PrlUsbIdent_GetSystemName"},
	{"PrlUsbIdent_GetFriendlyName", sdk_PrlUsbIdent_GetFriendlyName, METH_VARARGS, "PrlUsbIdent_GetFriendlyName"},
	{"PrlUsbIdent_GetVmUuidAssociation", sdk_PrlUsbIdent_GetVmUuidAssociation, METH_VARARGS, "PrlUsbIdent_GetVmUuidAssociation"},
	{"PrlDispCfg_SetUsbIdentAssociation", sdk_PrlDispCfg_SetUsbIdentAssociation, METH_VARARGS, "PrlDispCfg_SetUsbIdentAssociation"},
	{"PrlSrv_CopyCtTemplate", sdk_PrlSrv_CopyCtTemplate, METH_VARARGS, "PrlSrv_CopyCtTemplate"},
	{"PrlSrv_IsFeatureSupported", sdk_PrlSrv_IsFeatureSupported, METH_VARARGS, "PrlSrv_IsFeatureSupported"},
	{"PrlSrv_AddIPPrivateNetwork", sdk_PrlSrv_AddIPPrivateNetwork, METH_VARARGS, "PrlSrv_AddIPPrivateNetwork"},
	{"PrlSrv_RemoveIPPrivateNetwork", sdk_PrlSrv_RemoveIPPrivateNetwork, METH_VARARGS, "PrlSrv_RemoveIPPrivateNetwork"},
	{"PrlSrv_UpdateIPPrivateNetwork", sdk_PrlSrv_UpdateIPPrivateNetwork, METH_VARARGS, "PrlSrv_UpdateIPPrivateNetwork"},
	{"PrlSrv_GetIPPrivateNetworksList", sdk_PrlSrv_GetIPPrivateNetworksList, METH_VARARGS, "PrlSrv_GetIPPrivateNetworksList"},
	{"PrlIPPrivNet_Create", sdk_PrlIPPrivNet_Create, METH_NOARGS, "PrlIPPrivNet_Create"},
	{"PrlIPPrivNet_GetName", sdk_PrlIPPrivNet_GetName, METH_VARARGS, "PrlIPPrivNet_GetName"},
	{"PrlIPPrivNet_SetNetAddresses", sdk_PrlIPPrivNet_SetNetAddresses, METH_VARARGS, "PrlIPPrivNet_SetNetAddresses"},
	{"PrlIPPrivNet_GetNetAddresses", sdk_PrlIPPrivNet_GetNetAddresses, METH_VARARGS, "PrlIPPrivNet_GetNetAddresses"},
	{"PrlIPPrivNet_SetName", sdk_PrlIPPrivNet_SetName, METH_VARARGS, "PrlIPPrivNet_SetName"},
	{"PrlIPPrivNet_IsGlobal", sdk_PrlIPPrivNet_IsGlobal, METH_VARARGS, "PrlIPPrivNet_IsGlobal"},
	{"PrlIPPrivNet_SetGlobal", sdk_PrlIPPrivNet_SetGlobal, METH_VARARGS, "PrlIPPrivNet_SetGlobal"},
	{"PrlVmCfg_IsRamHotplugEnabled", sdk_PrlVmCfg_IsRamHotplugEnabled, METH_VARARGS, "PrlVmCfg_IsRamHotplugEnabled"},
	{"PrlVmCfg_SetRamHotplugEnabled", sdk_PrlVmCfg_SetRamHotplugEnabled, METH_VARARGS, "PrlVmCfg_SetRamHotplugEnabled"},
	{"PrlSrv_RefreshPlugins", sdk_PrlSrv_RefreshPlugins, METH_VARARGS, "PrlSrv_RefreshPlugins"},
	{"PrlSrv_GetPluginsList", sdk_PrlSrv_GetPluginsList, METH_VARARGS, "PrlSrv_GetPluginsList"},
	{"PrlVm_Mount", sdk_PrlVm_Mount, METH_VARARGS, "PrlVm_Mount"},
	{"PrlVm_Umount", sdk_PrlVm_Umount, METH_VARARGS, "PrlVm_Umount"},
	{"PrlPluginInfo_GetVendor", sdk_PrlPluginInfo_GetVendor, METH_VARARGS, "PrlPluginInfo_GetVendor"},
	{"PrlPluginInfo_GetCopyright", sdk_PrlPluginInfo_GetCopyright, METH_VARARGS, "PrlPluginInfo_GetCopyright"},
	{"PrlPluginInfo_GetShortDescription", sdk_PrlPluginInfo_GetShortDescription, METH_VARARGS, "PrlPluginInfo_GetShortDescription"},
	{"PrlPluginInfo_GetLongDescription", sdk_PrlPluginInfo_GetLongDescription, METH_VARARGS, "PrlPluginInfo_GetLongDescription"},
	{"PrlPluginInfo_GetVersion", sdk_PrlPluginInfo_GetVersion, METH_VARARGS, "PrlPluginInfo_GetVersion"},
	{"PrlPluginInfo_GetId", sdk_PrlPluginInfo_GetId, METH_VARARGS, "PrlPluginInfo_GetId"},
	{"PrlSrv_LoginEx", sdk_PrlSrv_LoginEx, METH_VARARGS, "PrlSrv_LoginEx"},
	{"PrlSrv_LoginLocalEx", sdk_PrlSrv_LoginLocalEx, METH_VARARGS, "PrlSrv_LoginLocalEx"},
	{"PrlHandle_RegEventHandler", sdk_PrlHandle_RegEventHandler, METH_VARARGS, "PrlHandle_RegEventHandler"},
	{"PrlHandle_UnregEventHandler", sdk_PrlHandle_UnregEventHandler, METH_VARARGS, "PrlHandle_UnregEventHandler"},
	{"PrlSrv_GetDiskFreeSpace", sdk_PrlSrv_GetDiskFreeSpace, METH_VARARGS, "PrlSrv_GetDiskFreeSpace"},
	{"PrlBackupResult_GetBackupUuid", sdk_PrlBackupResult_GetBackupUuid, METH_VARARGS, "PrlBackupResult_GetBackupUuid"},
	{"PrlVm_Move", sdk_PrlVm_Move, METH_VARARGS, "PrlVm_Move"},
	{"PrlVm_Connect", sdk_PrlVm_Connect, METH_VARARGS, "PrlVm_Connect"},
	{"PrlVm_Disconnect", sdk_PrlVm_Disconnect, METH_VARARGS, "PrlVm_Disconnect"},
	{"PrlSrv_GetVmConfig", sdk_PrlSrv_GetVmConfig, METH_VARARGS, "PrlSrv_GetVmConfig"},
	{"PrlVmCfg_GetResource", sdk_PrlVmCfg_GetResource, METH_VARARGS, "PrlVmCfg_GetResource"},
	{"PrlVmCfg_SetResource", sdk_PrlVmCfg_SetResource, METH_VARARGS, "PrlVmCfg_SetResource"},
	{"PrlVmCfg_IsAutoApplyIpOnly", sdk_PrlVmCfg_IsAutoApplyIpOnly, METH_VARARGS, "PrlVmCfg_IsAutoApplyIpOnly"},
	{"PrlVmCfg_SetAutoApplyIpOnly", sdk_PrlVmCfg_SetAutoApplyIpOnly, METH_VARARGS, "PrlVmCfg_SetAutoApplyIpOnly"},
	{"PrlVmCfg_GetCapabilitiesMask", sdk_PrlVmCfg_GetCapabilitiesMask, METH_VARARGS, "PrlVmCfg_GetCapabilitiesMask"},
	{"PrlVmCfg_SetCapabilitiesMask", sdk_PrlVmCfg_SetCapabilitiesMask, METH_VARARGS, "PrlVmCfg_SetCapabilitiesMask"},
	{"PrlVmCfg_GetNetfilterMode", sdk_PrlVmCfg_GetNetfilterMode, METH_VARARGS, "PrlVmCfg_GetNetfilterMode"},
	{"PrlVmCfg_SetNetfilterMode", sdk_PrlVmCfg_SetNetfilterMode, METH_VARARGS, "PrlVmCfg_SetNetfilterMode"},
	{"PrlHandle_GetPackageId", sdk_PrlHandle_GetPackageId, METH_VARARGS, "PrlHandle_GetPackageId"},
	{"PrlSrv_GetCPUPoolsList", sdk_PrlSrv_GetCPUPoolsList, METH_VARARGS, "PrlSrv_GetCPUPoolsList"},
	{"PrlSrv_MoveToCPUPool", sdk_PrlSrv_MoveToCPUPool, METH_VARARGS, "PrlSrv_MoveToCPUPool"},
	{"PrlSrv_RecalculateCPUPool", sdk_PrlSrv_RecalculateCPUPool, METH_VARARGS, "PrlSrv_RecalculateCPUPool"},
	{"PrlDispCfg_GetCpuPool", sdk_PrlDispCfg_GetCpuPool, METH_VARARGS, "PrlDispCfg_GetCpuPool"},
	{"PrlCPUPool_GetVendor", sdk_PrlCPUPool_GetVendor, METH_VARARGS, "PrlCPUPool_GetVendor"},
	{"PrlCPUPool_GetName", sdk_PrlCPUPool_GetName, METH_VARARGS, "PrlCPUPool_GetName"},
	{"PrlCPUPool_GetCpuFeaturesMask", sdk_PrlCPUPool_GetCpuFeaturesMask, METH_VARARGS, "PrlCPUPool_GetCpuFeaturesMask"},
	{"PrlVmCfg_GetFeaturesMask", sdk_PrlVmCfg_GetFeaturesMask, METH_VARARGS, "PrlVmCfg_GetFeaturesMask"},
	{"PrlVmCfg_SetFeaturesMask", sdk_PrlVmCfg_SetFeaturesMask, METH_VARARGS, "PrlVmCfg_SetFeaturesMask"},
	{"PrlSrv_SendProblemReport", sdk_PrlSrv_SendProblemReport, METH_VARARGS, "PrlSrv_SendProblemReport"},
	{"PrlHandle_FromString", sdk_PrlHandle_FromString, METH_VARARGS, "PrlHandle_FromString"},
	{"PrlEvent_FromString", sdk_PrlEvent_FromString, METH_VARARGS, "PrlEvent_FromString"},
	{"PrlApi_SwitchConsoleLogging", sdk_PrlApi_SwitchConsoleLogging, METH_VARARGS, "PrlApi_SwitchConsoleLogging"},
	{"PrlVmCfg_SetHighAvailabilityEnabled", sdk_PrlVmCfg_SetHighAvailabilityEnabled, METH_VARARGS, "PrlVmCfg_SetHighAvailabilityEnabled"},
	{"PrlVmCfg_IsHighAvailabilityEnabled", sdk_PrlVmCfg_IsHighAvailabilityEnabled, METH_VARARGS, "PrlVmCfg_IsHighAvailabilityEnabled"},
	{"PrlVmCfg_SetHighAvailabilityPriority", sdk_PrlVmCfg_SetHighAvailabilityPriority, METH_VARARGS, "PrlVmCfg_SetHighAvailabilityPriority"},
	{"PrlVmCfg_GetHighAvailabilityPriority", sdk_PrlVmCfg_GetHighAvailabilityPriority, METH_VARARGS, "PrlVmCfg_GetHighAvailabilityPriority"},
	{"PrlDisk_OpenDisk_Local", sdk_PrlDisk_OpenDisk_Local, METH_VARARGS, "PrlDisk_OpenDisk_Local"},
	{"PrlDisk_WaitForCompletion", sdk_PrlDisk_WaitForCompletion, METH_VARARGS, "PrlDisk_WaitForCompletion"},
	{"PrlDisk_GetDiskInfo", sdk_PrlDisk_GetDiskInfo, METH_VARARGS, "PrlDisk_GetDiskInfo"},
	{"PrlDiskMap_GetSize", sdk_PrlDiskMap_GetSize, METH_VARARGS, "PrlDiskMap_GetSize"},
	{"PrlDiskMap_GetGranularity", sdk_PrlDiskMap_GetGranularity, METH_VARARGS, "PrlDiskMap_GetGranularity"},
	{"PrlDiskMap_Read", sdk_PrlDiskMap_Read, METH_VARARGS, "PrlDiskMap_Read"},
	{ 0, 0, 0, 0 }
};

#ifndef PYTHON_MODULE_NAME
	#error "Unknown python module name!"
#endif

#define TO_STR2(t) #t
#define TO_STR(t) TO_STR2(t)
#define ENTRY_MODULE_NAME(x) TO_STR(x)

extern "C" void entry(void )
{
	PyObject* parent_module = Py_InitModule( ENTRY_MODULE_NAME(PYTHON_MODULE_NAME), SdkPythonBundle );
	std::string parent_name = PyModule_GetName(parent_module);
	PyObject* module = NULL;
	std::string name;

	PyEval_InitThreads();

	name = "consts";
	module = Py_InitModule( (char* )(parent_name + "." + name).c_str(), NULL );
	Py_INCREF(module);
	PyModule_AddObject( parent_module, (char* )name.c_str(), module );

	PyModule_AddIntConstant( module, "PARALLELS_API_VER", PARALLELS_API_VER );
	PyModule_AddIntConstant( module, "PRL_INVALID_HANDLE", PRL_INVALID_HANDLE );
	PyModule_AddIntConstant( module, "PRL_INVALID_FILE_DESCRIPTOR", PRL_INVALID_FILE_DESCRIPTOR );
	PyModule_AddIntConstant( module, "PHT_ERROR", PHT_ERROR );
	PyModule_AddIntConstant( module, "PHT_SERVER", PHT_SERVER );
	PyModule_AddIntConstant( module, "PHT_SERVER_CONFIG", PHT_SERVER_CONFIG );
	PyModule_AddIntConstant( module, "PHT_REMOTE_FILESYSTEM_INFO", PHT_REMOTE_FILESYSTEM_INFO );
	PyModule_AddIntConstant( module, "PHT_REMOTE_FILESYSTEM_ENTRY", PHT_REMOTE_FILESYSTEM_ENTRY );
	PyModule_AddIntConstant( module, "PHT_VIRTUAL_MACHINE", PHT_VIRTUAL_MACHINE );
	PyModule_AddIntConstant( module, "PHT_VIRTUAL_DEV_DISPLAY", PHT_VIRTUAL_DEV_DISPLAY );
	PyModule_AddIntConstant( module, "PHT_VIRTUAL_DEV_KEYBOARD", PHT_VIRTUAL_DEV_KEYBOARD );
	PyModule_AddIntConstant( module, "PHT_VIRTUAL_DEV_MOUSE", PHT_VIRTUAL_DEV_MOUSE );
	PyModule_AddIntConstant( module, "PHT_VIRTUAL_DEV_FLOPPY", PHT_VIRTUAL_DEV_FLOPPY );
	PyModule_AddIntConstant( module, "PHT_VIRTUAL_DEV_HARD_DISK", PHT_VIRTUAL_DEV_HARD_DISK );
	PyModule_AddIntConstant( module, "PHT_VIRTUAL_DEV_NET_ADAPTER", PHT_VIRTUAL_DEV_NET_ADAPTER );
	PyModule_AddIntConstant( module, "PHT_VIRTUAL_DEV_PARALLEL_PORT", PHT_VIRTUAL_DEV_PARALLEL_PORT );
	PyModule_AddIntConstant( module, "PHT_VIRTUAL_DEV_SERIAL_PORT", PHT_VIRTUAL_DEV_SERIAL_PORT );
	PyModule_AddIntConstant( module, "PHT_VIRTUAL_DEV_OPTICAL_DISK", PHT_VIRTUAL_DEV_OPTICAL_DISK );
	PyModule_AddIntConstant( module, "PHT_VIRTUAL_DEV_USB_DEVICE", PHT_VIRTUAL_DEV_USB_DEVICE );
	PyModule_AddIntConstant( module, "PHT_VIRTUAL_DEV_SOUND", PHT_VIRTUAL_DEV_SOUND );
	PyModule_AddIntConstant( module, "PHT_JOB", PHT_JOB );
	PyModule_AddIntConstant( module, "PHT_EVENT", PHT_EVENT );
	PyModule_AddIntConstant( module, "PHT_RESULT", PHT_RESULT );
	PyModule_AddIntConstant( module, "PHT_VM_INFO", PHT_VM_INFO );
	PyModule_AddIntConstant( module, "PHT_USER_PROFILE", PHT_USER_PROFILE );
	PyModule_AddIntConstant( module, "PHT_DISP_CONFIG", PHT_DISP_CONFIG );
	PyModule_AddIntConstant( module, "PHT_SHARE", PHT_SHARE );
	PyModule_AddIntConstant( module, "PHT_SCREEN_RESOLUTION", PHT_SCREEN_RESOLUTION );
	PyModule_AddIntConstant( module, "PHT_DISP_NET_ADAPTER", PHT_DISP_NET_ADAPTER );
	PyModule_AddIntConstant( module, "PHT_HW_GENERIC_DEVICE", PHT_HW_GENERIC_DEVICE );
	PyModule_AddIntConstant( module, "PHT_HW_HARD_DISK", PHT_HW_HARD_DISK );
	PyModule_AddIntConstant( module, "PHT_HW_HARD_DISK_PARTITION", PHT_HW_HARD_DISK_PARTITION );
	PyModule_AddIntConstant( module, "PHT_HW_NET_ADAPTER", PHT_HW_NET_ADAPTER );
	PyModule_AddIntConstant( module, "PHT_EVENT_PARAMETER", PHT_EVENT_PARAMETER );
	PyModule_AddIntConstant( module, "PHT_REMOTEDEV_CMD", PHT_REMOTEDEV_CMD );
	PyModule_AddIntConstant( module, "PHT_SYSTEM_STATISTICS", PHT_SYSTEM_STATISTICS );
	PyModule_AddIntConstant( module, "PHT_SYSTEM_STATISTICS_CPU", PHT_SYSTEM_STATISTICS_CPU );
	PyModule_AddIntConstant( module, "PHT_SYSTEM_STATISTICS_IFACE", PHT_SYSTEM_STATISTICS_IFACE );
	PyModule_AddIntConstant( module, "PHT_SYSTEM_STATISTICS_USER_SESSION", PHT_SYSTEM_STATISTICS_USER_SESSION );
	PyModule_AddIntConstant( module, "PHT_SYSTEM_STATISTICS_DISK", PHT_SYSTEM_STATISTICS_DISK );
	PyModule_AddIntConstant( module, "PHT_SYSTEM_STATISTICS_DISK_PARTITION", PHT_SYSTEM_STATISTICS_DISK_PARTITION );
	PyModule_AddIntConstant( module, "PHT_SYSTEM_STATISTICS_PROCESS", PHT_SYSTEM_STATISTICS_PROCESS );
	PyModule_AddIntConstant( module, "PHT_LICENSE", PHT_LICENSE );
	PyModule_AddIntConstant( module, "PHT_SERVER_INFO", PHT_SERVER_INFO );
	PyModule_AddIntConstant( module, "PHT_BOOT_DEVICE", PHT_BOOT_DEVICE );
	PyModule_AddIntConstant( module, "PHT_STRINGS_LIST", PHT_STRINGS_LIST );
	PyModule_AddIntConstant( module, "PHT_LOGIN_RESPONSE", PHT_LOGIN_RESPONSE );
	PyModule_AddIntConstant( module, "PHT_RUNNING_TASK", PHT_RUNNING_TASK );
	PyModule_AddIntConstant( module, "PHT_NET_SERVICE_STATUS", PHT_NET_SERVICE_STATUS );
	PyModule_AddIntConstant( module, "PHT_HANDLES_LIST", PHT_HANDLES_LIST );
	PyModule_AddIntConstant( module, "PHT_VIRTUAL_DISK", PHT_VIRTUAL_DISK );
	PyModule_AddIntConstant( module, "PHT_ACCESS_RIGHTS", PHT_ACCESS_RIGHTS );
	PyModule_AddIntConstant( module, "PHT_VM_TOOLS_INFO", PHT_VM_TOOLS_INFO );
	PyModule_AddIntConstant( module, "PHT_FOUND_VM_INFO", PHT_FOUND_VM_INFO );
	PyModule_AddIntConstant( module, "PHT_TIS_RECORD", PHT_TIS_RECORD );
	PyModule_AddIntConstant( module, "PHT_USER_INFO", PHT_USER_INFO );
	PyModule_AddIntConstant( module, "PHT_VM_CONFIGURATION", PHT_VM_CONFIGURATION );
	PyModule_AddIntConstant( module, "PHT_TIS_EMITTER", PHT_TIS_EMITTER );
	PyModule_AddIntConstant( module, "PHT_TOOL", PHT_TOOL );
	PyModule_AddIntConstant( module, "PHT_VIRTUAL_DEV_HD_PARTITION", PHT_VIRTUAL_DEV_HD_PARTITION );
	PyModule_AddIntConstant( module, "PHT_VIRTUAL_DEV_GENERIC_PCI", PHT_VIRTUAL_DEV_GENERIC_PCI );
	PyModule_AddIntConstant( module, "PHT_VIRTUAL_DEV_GENERIC_SCSI", PHT_VIRTUAL_DEV_GENERIC_SCSI );
	PyModule_AddIntConstant( module, "PHT_VM_GUEST_SESSION", PHT_VM_GUEST_SESSION );
	PyModule_AddIntConstant( module, "PHT_VIRTUAL_NETWORK", PHT_VIRTUAL_NETWORK );
	PyModule_AddIntConstant( module, "PHT_PORT_FORWARDING", PHT_PORT_FORWARDING );
	PyModule_AddIntConstant( module, "PHT_HW_GENERIC_PCI_DEVICE", PHT_HW_GENERIC_PCI_DEVICE );
	PyModule_AddIntConstant( module, "PHT_OPAQUE_TYPE_LIST", PHT_OPAQUE_TYPE_LIST );
	PyModule_AddIntConstant( module, "PHT_GUEST_OSES_MATRIX", PHT_GUEST_OSES_MATRIX );
	PyModule_AddIntConstant( module, "PHT_PROBLEM_REPORT", PHT_PROBLEM_REPORT );
	PyModule_AddIntConstant( module, "PHT_APPLIANCE_CONFIG", PHT_APPLIANCE_CONFIG );
	PyModule_AddIntConstant( module, "PHT_OFFLINE_SERVICE", PHT_OFFLINE_SERVICE );
	PyModule_AddIntConstant( module, "PHT_VM_VIRTUAL_DEVICES_INFO", PHT_VM_VIRTUAL_DEVICES_INFO );
	PyModule_AddIntConstant( module, "PHT_NETWORK_CLASS", PHT_NETWORK_CLASS );
	PyModule_AddIntConstant( module, "PHT_NETWORK_SHAPING", PHT_NETWORK_SHAPING );
	PyModule_AddIntConstant( module, "PHT_NETWORK_RATE", PHT_NETWORK_RATE );
	PyModule_AddIntConstant( module, "PHT_ISCSI_LUN", PHT_ISCSI_LUN );
	PyModule_AddIntConstant( module, "PHT_CT_TEMPLATE", PHT_CT_TEMPLATE );
	PyModule_AddIntConstant( module, "PHT_USB_IDENTITY", PHT_USB_IDENTITY );
	PyModule_AddIntConstant( module, "PHT_FIREWALL_RULE", PHT_FIREWALL_RULE );
	PyModule_AddIntConstant( module, "PHT_IPPRIV_NET", PHT_IPPRIV_NET );
	PyModule_AddIntConstant( module, "PHT_PLUGIN_INFO", PHT_PLUGIN_INFO );
	PyModule_AddIntConstant( module, "PHT_CVSRC", PHT_CVSRC );
	PyModule_AddIntConstant( module, "PHT_DESKTOP_CONTROL", PHT_DESKTOP_CONTROL );
	PyModule_AddIntConstant( module, "PHT_BACKUP_RESULT", PHT_BACKUP_RESULT );
	PyModule_AddIntConstant( module, "PHT_NETWORK_SHAPING_CONFIG", PHT_NETWORK_SHAPING_CONFIG );
	PyModule_AddIntConstant( module, "PHT_NETWORK_SHAPING_BANDWIDTH", PHT_NETWORK_SHAPING_BANDWIDTH );
	PyModule_AddIntConstant( module, "PHT_SYSTEM_STATISTICS_VM_DATA", PHT_SYSTEM_STATISTICS_VM_DATA );
	PyModule_AddIntConstant( module, "PHT_VIDEO_RECEIVER", PHT_VIDEO_RECEIVER );
	PyModule_AddIntConstant( module, "PHT_SESSION_INFO", PHT_SESSION_INFO );
	PyModule_AddIntConstant( module, "PHT_CPU_FEATURES", PHT_CPU_FEATURES );
	PyModule_AddIntConstant( module, "PHT_CPU_POOL", PHT_CPU_POOL );
	PyModule_AddIntConstant( module, "PHT_VIRTUAL_DISK_MAP", PHT_VIRTUAL_DISK_MAP );
	PyModule_AddIntConstant( module, "PHT_VIRTUAL_DISK_OPEN_POLICY", PHT_VIRTUAL_DISK_OPEN_POLICY );
	PyModule_AddIntConstant( module, "PHT_LAST", PHT_LAST );
	PyModule_AddIntConstant( module, "PJS_UNKNOWN", static_cast<int>(PJS_UNKNOWN) );
	PyModule_AddIntConstant( module, "PJS_RUNNING", static_cast<int>(PJS_RUNNING) );
	PyModule_AddIntConstant( module, "PJS_FINISHED", static_cast<int>(PJS_FINISHED) );
	PyModule_AddIntConstant( module, "PDT_ANY_TYPE", PDT_ANY_TYPE );
	PyModule_AddIntConstant( module, "PDT_USE_REAL_DEVICE", PDT_USE_REAL_DEVICE );
	PyModule_AddIntConstant( module, "PDT_USE_IMAGE_FILE", PDT_USE_IMAGE_FILE );
	PyModule_AddIntConstant( module, "PDT_USE_OUTPUT_FILE", PDT_USE_OUTPUT_FILE );
	PyModule_AddIntConstant( module, "PDT_USE_OTHER", PDT_USE_OTHER );
	PyModule_AddIntConstant( module, "PDT_USE_DIRECT_ASSIGN", PDT_USE_DIRECT_ASSIGN );
	PyModule_AddIntConstant( module, "PDT_USE_FILE_SYSTEM", PDT_USE_FILE_SYSTEM );
	PyModule_AddIntConstant( module, "PDT_USE_TCP", PDT_USE_TCP );
	PyModule_AddIntConstant( module, "PDT_USE_UDP", PDT_USE_UDP );
	PyModule_AddIntConstant( module, "PDT_USE_REAL_FLOPPY", PDT_USE_REAL_FLOPPY );
	PyModule_AddIntConstant( module, "PDT_USE_REAL_HDD", PDT_USE_REAL_HDD );
	PyModule_AddIntConstant( module, "PDT_USE_REAL_CDDVD", PDT_USE_REAL_CDDVD );
	PyModule_AddIntConstant( module, "PDT_USE_REAL_SERIAL_PORT", PDT_USE_REAL_SERIAL_PORT );
	PyModule_AddIntConstant( module, "PDT_USE_SERIAL_PORT_SOCKET_MODE", PDT_USE_SERIAL_PORT_SOCKET_MODE );
	PyModule_AddIntConstant( module, "PDT_USE_SERIAL_PORT_TCP_MODE", PDT_USE_SERIAL_PORT_TCP_MODE );
	PyModule_AddIntConstant( module, "PDT_USE_SERIAL_PORT_UDP_MODE", PDT_USE_SERIAL_PORT_UDP_MODE );
	PyModule_AddIntConstant( module, "PDT_USE_REAL_PARALLEL_PORT", PDT_USE_REAL_PARALLEL_PORT );
	PyModule_AddIntConstant( module, "PDT_USE_PARALLEL_PORT_PRINTER_MODE", PDT_USE_PARALLEL_PORT_PRINTER_MODE );
	PyModule_AddIntConstant( module, "PDT_USE_PARALLEL_PORT_PRINT_TO_PDF_MODE", PDT_USE_PARALLEL_PORT_PRINT_TO_PDF_MODE );
	PyModule_AddIntConstant( module, "PDT_USE_HOST_ONLY_NETWORK", PDT_USE_HOST_ONLY_NETWORK );
	PyModule_AddIntConstant( module, "PDT_USE_SHARED_NETWORK", PDT_USE_SHARED_NETWORK );
	PyModule_AddIntConstant( module, "PDT_USE_BRIDGE_ETHERNET", PDT_USE_BRIDGE_ETHERNET );
	PyModule_AddIntConstant( module, "PDT_USE_AC97_SOUND", PDT_USE_AC97_SOUND );
	PyModule_AddIntConstant( module, "PDT_USE_CREATIVE_SB16_SOUND", PDT_USE_CREATIVE_SB16_SOUND );
	PyModule_AddIntConstant( module, "PDT_USE_REAL_USB_CONTROLLER", PDT_USE_REAL_USB_CONTROLLER );
	PyModule_AddIntConstant( module, "PDT_USE_BOOTCAMP", PDT_USE_BOOTCAMP );
	PyModule_AddIntConstant( module, "PMS_IDE_DEVICE", PMS_IDE_DEVICE );
	PyModule_AddIntConstant( module, "PMS_SCSI_DEVICE", PMS_SCSI_DEVICE );
	PyModule_AddIntConstant( module, "PMS_SATA_DEVICE", PMS_SATA_DEVICE );
	PyModule_AddIntConstant( module, "PMS_VIRTIO_BLOCK_DEVICE", PMS_VIRTIO_BLOCK_DEVICE );
	PyModule_AddIntConstant( module, "PMS_UNKNOWN_DEVICE", PMS_UNKNOWN_DEVICE );
	PyModule_AddIntConstant( module, "PRN_LPT_DEVICE", PRN_LPT_DEVICE );
	PyModule_AddIntConstant( module, "PRN_USB_DEVICE", PRN_USB_DEVICE );
	PyModule_AddIntConstant( module, "PRN_UNKNOWN_DEVICE", PRN_UNKNOWN_DEVICE );
	PyModule_AddIntConstant( module, "PHD_PLAIN_HARD_DISK", PHD_PLAIN_HARD_DISK );
	PyModule_AddIntConstant( module, "PHD_EXPANDING_HARD_DISK", PHD_EXPANDING_HARD_DISK );
	PyModule_AddIntConstant( module, "PSP_SERIAL_SOCKET_SERVER", PSP_SERIAL_SOCKET_SERVER );
	PyModule_AddIntConstant( module, "PSP_SERIAL_SOCKET_CLIENT", PSP_SERIAL_SOCKET_CLIENT );
	PyModule_AddIntConstant( module, "PCM_CPU_MODE_32", PCM_CPU_MODE_32 );
	PyModule_AddIntConstant( module, "PCM_CPU_MODE_64", PCM_CPU_MODE_64 );
	PyModule_AddIntConstant( module, "PCM_CPU_NONE_HV", PCM_CPU_NONE_HV );
	PyModule_AddIntConstant( module, "PCM_CPU_INTEL_VT_X", PCM_CPU_INTEL_VT_X );
	PyModule_AddIntConstant( module, "PCM_CPU_AMD_V", PCM_CPU_AMD_V );
	PyModule_AddIntConstant( module, "PVA_ACCELERATION_DISABLED", PVA_ACCELERATION_DISABLED );
	PyModule_AddIntConstant( module, "PVA_ACCELERATION_NORMAL", PVA_ACCELERATION_NORMAL );
	PyModule_AddIntConstant( module, "PVA_ACCELERATION_HIGH", PVA_ACCELERATION_HIGH );
	PyModule_AddIntConstant( module, "PAO_VM_START_MANUAL", PAO_VM_START_MANUAL );
	PyModule_AddIntConstant( module, "PAO_VM_START_ON_LOAD", PAO_VM_START_ON_LOAD );
	PyModule_AddIntConstant( module, "PAO_VM_START_ON_RELOAD", PAO_VM_START_ON_RELOAD );
	PyModule_AddIntConstant( module, "PAO_VM_START_ON_GUI_APP_STARTUP", PAO_VM_START_ON_GUI_APP_STARTUP );
	PyModule_AddIntConstant( module, "PAO_VM_START_ON_GUI_VM_WINDOW_OPEN", PAO_VM_START_ON_GUI_VM_WINDOW_OPEN );
	PyModule_AddIntConstant( module, "PAO_VM_START_ON_GUI_WINDOW_LOAD", PAO_VM_START_ON_GUI_WINDOW_LOAD );
	PyModule_AddIntConstant( module, "PLM_START_ACCOUNT", PLM_START_ACCOUNT );
	PyModule_AddIntConstant( module, "PLM_ROOT_ACCOUNT", PLM_ROOT_ACCOUNT );
	PyModule_AddIntConstant( module, "PLM_USER_ACCOUNT", PLM_USER_ACCOUNT );
	PyModule_AddIntConstant( module, "PLM_START_ACOUNT", PLM_START_ACOUNT );
	PyModule_AddIntConstant( module, "PLM_ROOT_ACOUNT", PLM_ROOT_ACOUNT );
	PyModule_AddIntConstant( module, "PLM_USER_ACOUNT", PLM_USER_ACOUNT );
	PyModule_AddIntConstant( module, "PAO_VM_STOP", PAO_VM_STOP );
	PyModule_AddIntConstant( module, "PAO_VM_SUSPEND", PAO_VM_SUSPEND );
	PyModule_AddIntConstant( module, "PAO_VM_SHUTDOWN", PAO_VM_SHUTDOWN );
	PyModule_AddIntConstant( module, "PWM_DEFAULT_WINDOW_MODE", PWM_DEFAULT_WINDOW_MODE );
	PyModule_AddIntConstant( module, "PWM_WINDOWED_WINDOW_MODE", PWM_WINDOWED_WINDOW_MODE );
	PyModule_AddIntConstant( module, "PWM_FULL_SCREEN_WINDOW_MODE", PWM_FULL_SCREEN_WINDOW_MODE );
	PyModule_AddIntConstant( module, "PWC_TOP_LEFT_CORNER", PWC_TOP_LEFT_CORNER );
	PyModule_AddIntConstant( module, "PWC_TOP_RIGHT_CORNER", PWC_TOP_RIGHT_CORNER );
	PyModule_AddIntConstant( module, "PWC_BOTTOM_LEFT_CORNER", PWC_BOTTOM_LEFT_CORNER );
	PyModule_AddIntConstant( module, "PWC_BOTTOM_RIGHT_CORNER", PWC_BOTTOM_RIGHT_CORNER );
	PyModule_AddIntConstant( module, "PCA_NO_ACTION", PCA_NO_ACTION );
	PyModule_AddIntConstant( module, "PCA_WINDOWED", PCA_WINDOWED );
	PyModule_AddIntConstant( module, "PCA_COHERENCE", PCA_COHERENCE );
	PyModule_AddIntConstant( module, "PCA_SEAMLESS", PCA_SEAMLESS );
	PyModule_AddIntConstant( module, "PCA_MODALITY", PCA_MODALITY );
	PyModule_AddIntConstant( module, "PCA_HIDE_APPLICATION", PCA_HIDE_APPLICATION );
	PyModule_AddIntConstant( module, "PCA_UNGRAB_INPUT", PCA_UNGRAB_INPUT );
	PyModule_AddIntConstant( module, "PCA_CRYSTAL", PCA_CRYSTAL );
	PyModule_AddIntConstant( module, "PSVM_OFF", PSVM_OFF );
	PyModule_AddIntConstant( module, "PSVM_AUTO", PSVM_AUTO );
	PyModule_AddIntConstant( module, "PSVM_KEEP_ASPECT_RATIO", PSVM_KEEP_ASPECT_RATIO );
	PyModule_AddIntConstant( module, "PSVM_KEEP_ASPECT_RATIO_BY_EXPANDING", PSVM_KEEP_ASPECT_RATIO_BY_EXPANDING );
	PyModule_AddIntConstant( module, "PSVM_IGNORE_ASPECT_RATIO", PSVM_IGNORE_ASPECT_RATIO );
	PyModule_AddIntConstant( module, "PWC_VM_UNKNOWN_ACTION", PWC_VM_UNKNOWN_ACTION );
	PyModule_AddIntConstant( module, "PWC_VM_STOP", PWC_VM_STOP );
	PyModule_AddIntConstant( module, "PWC_VM_SUSPEND", PWC_VM_SUSPEND );
	PyModule_AddIntConstant( module, "PWC_VM_ASK_USER", PWC_VM_ASK_USER );
	PyModule_AddIntConstant( module, "PWC_VM_PAUSE", PWC_VM_PAUSE );
	PyModule_AddIntConstant( module, "PWC_VM_SHUTDOWN", PWC_VM_SHUTDOWN );
	PyModule_AddIntConstant( module, "PWC_VM_DO_NOTHING", PWC_VM_DO_NOTHING );
	PyModule_AddIntConstant( module, "PAS_KEEP_VM_WINDOW_OPEN", PAS_KEEP_VM_WINDOW_OPEN );
	PyModule_AddIntConstant( module, "PAS_CLOSE_VM_WINDOW", PAS_CLOSE_VM_WINDOW );
	PyModule_AddIntConstant( module, "PAS_QUIT_APPLICATION", PAS_QUIT_APPLICATION );
	PyModule_AddIntConstant( module, "PBO_HDD_CD_FLOPPY", PBO_HDD_CD_FLOPPY );
	PyModule_AddIntConstant( module, "PBO_FLOPPY_HDD_CD", PBO_FLOPPY_HDD_CD );
	PyModule_AddIntConstant( module, "PBO_CD_HDD_FLOPPY", PBO_CD_HDD_FLOPPY );
	PyModule_AddIntConstant( module, "PDA_DEVICE_IDLE", PDA_DEVICE_IDLE );
	PyModule_AddIntConstant( module, "PDA_DEVICE_READ", PDA_DEVICE_READ );
	PyModule_AddIntConstant( module, "PDA_DEVICE_WRITE", PDA_DEVICE_WRITE );
	PyModule_AddIntConstant( module, "PDM_APP_IN_DOCK_NEVER", PDM_APP_IN_DOCK_NEVER );
	PyModule_AddIntConstant( module, "PDM_APP_IN_DOCK_COHERENCE_ONLY", PDM_APP_IN_DOCK_COHERENCE_ONLY );
	PyModule_AddIntConstant( module, "PDM_APP_IN_DOCK_ALWAYS", PDM_APP_IN_DOCK_ALWAYS );
	PyModule_AddIntConstant( module, "PIT_DOCK_ICON_SYSTEM", PIT_DOCK_ICON_SYSTEM );
	PyModule_AddIntConstant( module, "PIT_DOCK_ICON_LIVE_SCREEN_SHOT", PIT_DOCK_ICON_LIVE_SCREEN_SHOT );
	PyModule_AddIntConstant( module, "PIT_DOCK_ICON_START_MENU", PIT_DOCK_ICON_START_MENU );
	PyModule_AddIntConstant( module, "PVR_PRIORITY_LOW", PVR_PRIORITY_LOW );
	PyModule_AddIntConstant( module, "PVR_PRIORITY_NORMAL", PVR_PRIORITY_NORMAL );
	PyModule_AddIntConstant( module, "PVR_PRIORITY_HIGH", PVR_PRIORITY_HIGH );
	PyModule_AddIntConstant( module, "PNA_HOST_ONLY", PNA_HOST_ONLY );
	PyModule_AddIntConstant( module, "PNA_SHARED", PNA_SHARED );
	PyModule_AddIntConstant( module, "PNA_BRIDGED_ETHERNET", PNA_BRIDGED_ETHERNET );
	PyModule_AddIntConstant( module, "PNA_DIRECT_ASSIGN", PNA_DIRECT_ASSIGN );
	PyModule_AddIntConstant( module, "PNA_ROUTED", PNA_ROUTED );
	PyModule_AddIntConstant( module, "PVN_BRIDGED_ETHERNET", PVN_BRIDGED_ETHERNET );
	PyModule_AddIntConstant( module, "PVN_HOST_ONLY", PVN_HOST_ONLY );
	PyModule_AddIntConstant( module, "VMS_UNKNOWN", VMS_UNKNOWN );
	PyModule_AddIntConstant( module, "VMS_STOPPED", VMS_STOPPED );
	PyModule_AddIntConstant( module, "VMS_STARTING", VMS_STARTING );
	PyModule_AddIntConstant( module, "VMS_RESTORING", VMS_RESTORING );
	PyModule_AddIntConstant( module, "VMS_RUNNING", VMS_RUNNING );
	PyModule_AddIntConstant( module, "VMS_PAUSED", VMS_PAUSED );
	PyModule_AddIntConstant( module, "VMS_SUSPENDING", VMS_SUSPENDING );
	PyModule_AddIntConstant( module, "VMS_STOPPING", VMS_STOPPING );
	PyModule_AddIntConstant( module, "VMS_COMPACTING", VMS_COMPACTING );
	PyModule_AddIntConstant( module, "VMS_SUSPENDED", VMS_SUSPENDED );
	PyModule_AddIntConstant( module, "VMS_SNAPSHOTING", VMS_SNAPSHOTING );
	PyModule_AddIntConstant( module, "VMS_RESETTING", VMS_RESETTING );
	PyModule_AddIntConstant( module, "VMS_PAUSING", VMS_PAUSING );
	PyModule_AddIntConstant( module, "VMS_CONTINUING", VMS_CONTINUING );
	PyModule_AddIntConstant( module, "VMS_MIGRATING", VMS_MIGRATING );
	PyModule_AddIntConstant( module, "VMS_DELETING_STATE", VMS_DELETING_STATE );
	PyModule_AddIntConstant( module, "VMS_RESUMING", VMS_RESUMING );
	PyModule_AddIntConstant( module, "VMS_SUSPENDING_SYNC", VMS_SUSPENDING_SYNC );
	PyModule_AddIntConstant( module, "VMS_RECONNECTING", VMS_RECONNECTING );
	PyModule_AddIntConstant( module, "VMS_MOUNTED", VMS_MOUNTED );
	PyModule_AddIntConstant( module, "VMS_REBOOTED", VMS_REBOOTED );
	PyModule_AddIntConstant( module, "VMS_AGENT_STARTED", VMS_AGENT_STARTED );
	PyModule_AddIntConstant( module, "VMAS_NOSTATE", VMAS_NOSTATE );
	PyModule_AddIntConstant( module, "VMAS_BACKUPING", VMAS_BACKUPING );
	PyModule_AddIntConstant( module, "VMAS_RESTORING_FROM_BACKUP", VMAS_RESTORING_FROM_BACKUP );
	PyModule_AddIntConstant( module, "VMAS_CLONING", VMAS_CLONING );
	PyModule_AddIntConstant( module, "VMAS_MOVING", VMAS_MOVING );
	PyModule_AddIntConstant( module, "VMAS_MAX", VMAS_MAX );
	PyModule_AddIntConstant( module, "PTS_UNKNOWN", PTS_UNKNOWN );
	PyModule_AddIntConstant( module, "PTS_POSSIBLY_INSTALLED", PTS_POSSIBLY_INSTALLED );
	PyModule_AddIntConstant( module, "PTS_NOT_INSTALLED", PTS_NOT_INSTALLED );
	PyModule_AddIntConstant( module, "PTS_INSTALLED", PTS_INSTALLED );
	PyModule_AddIntConstant( module, "PTS_OUTDATED", PTS_OUTDATED );
	PyModule_AddIntConstant( module, "PTS_RELATIVE_MOUSE", PTS_RELATIVE_MOUSE );
	PyModule_AddIntConstant( module, "PTS_SLIDING_MOUSE", PTS_SLIDING_MOUSE );
	PyModule_AddIntConstant( module, "PTS_ABSOLUTE_MOUSE", PTS_ABSOLUTE_MOUSE );
	PyModule_AddIntConstant( module, "PTS_NO_CURSOR", PTS_NO_CURSOR );
	PyModule_AddIntConstant( module, "PTS_SLIDING_CURSOR", PTS_SLIDING_CURSOR );
	PyModule_AddIntConstant( module, "PTS_MOVING_CURSOR", PTS_MOVING_CURSOR );
	PyModule_AddIntConstant( module, "IOS_DISABLED", IOS_DISABLED );
	PyModule_AddIntConstant( module, "IOS_STARTED", IOS_STARTED );
	PyModule_AddIntConstant( module, "IOS_STOPPED", IOS_STOPPED );
	PyModule_AddIntConstant( module, "IOS_UNKNOWN_VM_UUID", IOS_UNKNOWN_VM_UUID );
	PyModule_AddIntConstant( module, "IOS_CONNECTION_TIMEOUT", IOS_CONNECTION_TIMEOUT );
	PyModule_AddIntConstant( module, "IOS_AUTH_FAILED", IOS_AUTH_FAILED );
	PyModule_AddIntConstant( module, "PMB_NOBUTTON", PMB_NOBUTTON );
	PyModule_AddIntConstant( module, "PMB_LEFT_BUTTON", PMB_LEFT_BUTTON );
	PyModule_AddIntConstant( module, "PMB_RIGHT_BUTTON", PMB_RIGHT_BUTTON );
	PyModule_AddIntConstant( module, "PMB_MIDDLE_BUTTON", PMB_MIDDLE_BUTTON );
	PyModule_AddIntConstant( module, "PMB_XBUTTON1", PMB_XBUTTON1 );
	PyModule_AddIntConstant( module, "PMB_XBUTTON2", PMB_XBUTTON2 );
	PyModule_AddIntConstant( module, "PMB_XBUTTON3", PMB_XBUTTON3 );
	PyModule_AddIntConstant( module, "PMB_XBUTTON4", PMB_XBUTTON4 );
	PyModule_AddIntConstant( module, "PMB_XBUTTON5", PMB_XBUTTON5 );
	PyModule_AddIntConstant( module, "PKE_PRESS", PKE_PRESS );
	PyModule_AddIntConstant( module, "PKE_RELEASE", PKE_RELEASE );
	PyModule_AddIntConstant( module, "PKE_CLICK", 0xFF );
	PyModule_AddIntConstant( module, "PIF_RAW", PIF_RAW );
	PyModule_AddIntConstant( module, "PIF_BMP", PIF_BMP );
	PyModule_AddIntConstant( module, "PIF_JPG", PIF_JPG );
	PyModule_AddIntConstant( module, "PIF_PNG", PIF_PNG );
	PyModule_AddIntConstant( module, "PHO_MAC", PHO_MAC );
	PyModule_AddIntConstant( module, "PHO_LIN", PHO_LIN );
	PyModule_AddIntConstant( module, "PHO_WIN", PHO_WIN );
	PyModule_AddIntConstant( module, "PHO_UNKNOWN", PHO_UNKNOWN );
	PyModule_AddIntConstant( module, "PDE_GENERIC_DEVICE", PDE_GENERIC_DEVICE );
	PyModule_AddIntConstant( module, "PDE_CLUSTERED_DEVICE", PDE_CLUSTERED_DEVICE );
	PyModule_AddIntConstant( module, "PDE_STORAGE_DEVICE", PDE_STORAGE_DEVICE );
	PyModule_AddIntConstant( module, "PDE_FLOPPY_DISK", PDE_FLOPPY_DISK );
	PyModule_AddIntConstant( module, "PDE_MASSSTORAGE_DEVICE", PDE_MASSSTORAGE_DEVICE );
	PyModule_AddIntConstant( module, "PDE_OPTICAL_DISK", PDE_OPTICAL_DISK );
	PyModule_AddIntConstant( module, "PDE_HARD_DISK", PDE_HARD_DISK );
	PyModule_AddIntConstant( module, "PDE_GENERIC_NETWORK_ADAPTER", PDE_GENERIC_NETWORK_ADAPTER );
	PyModule_AddIntConstant( module, "PDE_GENERIC_PORT", PDE_GENERIC_PORT );
	PyModule_AddIntConstant( module, "PDE_SERIAL_PORT", PDE_SERIAL_PORT );
	PyModule_AddIntConstant( module, "PDE_PARALLEL_PORT", PDE_PARALLEL_PORT );
	PyModule_AddIntConstant( module, "PDE_SOUND_DEVICE", PDE_SOUND_DEVICE );
	PyModule_AddIntConstant( module, "PDE_MIXER_DEVICE", PDE_MIXER_DEVICE );
	PyModule_AddIntConstant( module, "PDE_USB_DEVICE", PDE_USB_DEVICE );
	PyModule_AddIntConstant( module, "PDE_PRINTER", PDE_PRINTER );
	PyModule_AddIntConstant( module, "PDE_GENERIC_PCI_DEVICE", PDE_GENERIC_PCI_DEVICE );
	PyModule_AddIntConstant( module, "PDE_GENERIC_SCSI_DEVICE", PDE_GENERIC_SCSI_DEVICE );
	PyModule_AddIntConstant( module, "PDE_VIRTUAL_SNAPSHOT_DEVICE", PDE_VIRTUAL_SNAPSHOT_DEVICE );
	PyModule_AddIntConstant( module, "PDE_PCI_VIDEO_ADAPTER", PDE_PCI_VIDEO_ADAPTER );
	PyModule_AddIntConstant( module, "PDE_VIRTUAL_SHARED_FOLDERS_DEVICE", PDE_VIRTUAL_SHARED_FOLDERS_DEVICE );
	PyModule_AddIntConstant( module, "PDE_ATTACHED_BACKUP_DISK", PDE_ATTACHED_BACKUP_DISK );
	PyModule_AddIntConstant( module, "PDE_MAX", PDE_MAX );
	PyModule_AddIntConstant( module, "PHI_REAL_NET_ADAPTER", PHI_REAL_NET_ADAPTER );
	PyModule_AddIntConstant( module, "PHI_VIRTUAL_NET_ADAPTER", PHI_VIRTUAL_NET_ADAPTER );
	PyModule_AddIntConstant( module, "PHY_WIFI_REAL_NET_ADAPTER", PHY_WIFI_REAL_NET_ADAPTER );
	PyModule_AddIntConstant( module, "PFD_UINT32", PFD_UINT32 );
	PyModule_AddIntConstant( module, "PFD_STRING", PFD_STRING );
	PyModule_AddIntConstant( module, "PFD_INT32", PFD_INT32 );
	PyModule_AddIntConstant( module, "PFD_CDATA", PFD_CDATA );
	PyModule_AddIntConstant( module, "PFD_BOOLEAN", PFD_BOOLEAN );
	PyModule_AddIntConstant( module, "PFD_ENTITY", PFD_ENTITY );
	PyModule_AddIntConstant( module, "PFD_ENUMERATION", PFD_ENUMERATION );
	PyModule_AddIntConstant( module, "PFD_INT64", PFD_INT64 );
	PyModule_AddIntConstant( module, "PFD_UINT64", PFD_UINT64 );
	PyModule_AddIntConstant( module, "PFD_BINARY", PFD_BINARY );
	PyModule_AddIntConstant( module, "PFD_UNKNOWN", PFD_UNKNOWN );
	PyModule_AddIntConstant( module, "PIE_VIRTUAL_MACHINE", PIE_VIRTUAL_MACHINE );
	PyModule_AddIntConstant( module, "PIE_DISPATCHER", PIE_DISPATCHER );
	PyModule_AddIntConstant( module, "PIE_IO_SERVICE", PIE_IO_SERVICE );
	PyModule_AddIntConstant( module, "PIE_WEB_SERVICE", PIE_WEB_SERVICE );
	PyModule_AddIntConstant( module, "PIE_UNKNOWN", PIE_UNKNOWN );
	PyModule_AddIntConstant( module, "PFS_WINDOWS_LIKE_FS", PFS_WINDOWS_LIKE_FS );
	PyModule_AddIntConstant( module, "PFS_UNIX_LIKE_FS", PFS_UNIX_LIKE_FS );
	PyModule_AddIntConstant( module, "PRL_FS_INVALID", PRL_FS_INVALID );
	PyModule_AddIntConstant( module, "PRL_FS_FAT", PRL_FS_FAT );
	PyModule_AddIntConstant( module, "PRL_FS_FAT32", PRL_FS_FAT32 );
	PyModule_AddIntConstant( module, "PRL_FS_NTFS", PRL_FS_NTFS );
	PyModule_AddIntConstant( module, "PRL_FS_HFS", PRL_FS_HFS );
	PyModule_AddIntConstant( module, "PRL_FS_ADFS", PRL_FS_ADFS );
	PyModule_AddIntConstant( module, "PRL_FS_AFFS", PRL_FS_AFFS );
	PyModule_AddIntConstant( module, "PRL_FS_AFS", PRL_FS_AFS );
	PyModule_AddIntConstant( module, "PRL_FS_AUTOFS", PRL_FS_AUTOFS );
	PyModule_AddIntConstant( module, "PRL_FS_CODA", PRL_FS_CODA );
	PyModule_AddIntConstant( module, "PRL_FS_EFS", PRL_FS_EFS );
	PyModule_AddIntConstant( module, "PRL_FS_EXTFS", PRL_FS_EXTFS );
	PyModule_AddIntConstant( module, "PRL_FS_HPFS", PRL_FS_HPFS );
	PyModule_AddIntConstant( module, "PRL_FS_ISOFS", PRL_FS_ISOFS );
	PyModule_AddIntConstant( module, "PRL_FS_JFFS2", PRL_FS_JFFS2 );
	PyModule_AddIntConstant( module, "PRL_FS_NFS", PRL_FS_NFS );
	PyModule_AddIntConstant( module, "PRL_FS_QNX4", PRL_FS_QNX4 );
	PyModule_AddIntConstant( module, "PRL_FS_REISERFS", PRL_FS_REISERFS );
	PyModule_AddIntConstant( module, "PRL_FS_SMBFS", PRL_FS_SMBFS );
	PyModule_AddIntConstant( module, "PRL_FS_GFS", PRL_FS_GFS );
	PyModule_AddIntConstant( module, "PRL_FS_FUSE", PRL_FS_FUSE );
	PyModule_AddIntConstant( module, "PRL_FS_UNSPECIFIED", PRL_FS_UNSPECIFIED );
	PyModule_AddIntConstant( module, "PSE_DRIVE", PSE_DRIVE );
	PyModule_AddIntConstant( module, "PSE_DIRECTORY", PSE_DIRECTORY );
	PyModule_AddIntConstant( module, "PSE_FILE", PSE_FILE );
	PyModule_AddIntConstant( module, "PPS_PROC_SLEEP", PPS_PROC_SLEEP );
	PyModule_AddIntConstant( module, "PPS_PROC_RUN", PPS_PROC_RUN );
	PyModule_AddIntConstant( module, "PPS_PROC_STOP", PPS_PROC_STOP );
	PyModule_AddIntConstant( module, "PPS_PROC_ZOMBIE", PPS_PROC_ZOMBIE );
	PyModule_AddIntConstant( module, "PPS_PROC_IDLE", PPS_PROC_IDLE );
	PyModule_AddIntConstant( module, "PRL_VERSION_ANY", PRL_VERSION_ANY );
	PyModule_AddIntConstant( module, "PRL_VERSION_3X", PRL_VERSION_3X );
	PyModule_AddIntConstant( module, "PRL_VERSION_4X", PRL_VERSION_4X );
	PyModule_AddIntConstant( module, "PRL_VERSION_5X", PRL_VERSION_5X );
	PyModule_AddIntConstant( module, "PRL_VERSION_6X", PRL_VERSION_6X );
	PyModule_AddIntConstant( module, "PRL_VERSION_7X", PRL_VERSION_7X );
	PyModule_AddIntConstant( module, "PRL_VERSION_8X", PRL_VERSION_8X );
	PyModule_AddIntConstant( module, "PRL_VERSION_9X", PRL_VERSION_9X );
	PyModule_AddIntConstant( module, "PRL_VERSION_10X", PRL_VERSION_10X );
	PyModule_AddIntConstant( module, "PRL_PRODUCT_ANY", PRL_PRODUCT_ANY );
	PyModule_AddIntConstant( module, "PRL_PRODUCT_DESKTOP", PRL_PRODUCT_DESKTOP );
	PyModule_AddIntConstant( module, "PRL_PRODUCT_SERVER", PRL_PRODUCT_SERVER );
	PyModule_AddIntConstant( module, "PRL_PRODUCT_WORKSTATION", PRL_PRODUCT_WORKSTATION );
	PyModule_AddIntConstant( module, "PRL_PRODUCT_STM", PRL_PRODUCT_STM );
	PyModule_AddIntConstant( module, "PRL_PRODUCT_PLAYER", PRL_PRODUCT_PLAYER );
	PyModule_AddIntConstant( module, "PRL_PRODUCT_DESKTOP_WL", PRL_PRODUCT_DESKTOP_WL );
	PyModule_AddIntConstant( module, "PLRK_UNKNOWN", PLRK_UNKNOWN );
	PyModule_AddIntConstant( module, "PLRK_VM_CPU_LIMIT", PLRK_VM_CPU_LIMIT );
	PyModule_AddIntConstant( module, "PLRK_VM_MEMORY_LIMIT", PLRK_VM_MEMORY_LIMIT );
	PyModule_AddIntConstant( module, "PLRK_VM_VTD_AVAILABLE", PLRK_VM_VTD_AVAILABLE );
	PyModule_AddIntConstant( module, "PLRK_ALLOWED_GUEST_OS_VERSIONS", PLRK_ALLOWED_GUEST_OS_VERSIONS );
	PyModule_AddIntConstant( module, "PLRK_RUNNING_VMS_LIMIT", PLRK_RUNNING_VMS_LIMIT );
	PyModule_AddIntConstant( module, "PLRK_VM_CREATE", PLRK_VM_CREATE );
	PyModule_AddIntConstant( module, "PLRK_VM_REGISTER", PLRK_VM_REGISTER );
	PyModule_AddIntConstant( module, "PLRK_VM_IMPORT_3RD_PARTY", PLRK_VM_IMPORT_3RD_PARTY );
	PyModule_AddIntConstant( module, "PLRK_VM_CLONE", PLRK_VM_CLONE );
	PyModule_AddIntConstant( module, "PLRK_VM_CONVERT_TO_TEMPLATE", PLRK_VM_CONVERT_TO_TEMPLATE );
	PyModule_AddIntConstant( module, "PLRK_VM_CONVERT_FROM_TEMPLATE", PLRK_VM_CONVERT_FROM_TEMPLATE );
	PyModule_AddIntConstant( module, "PLRK_VM_DOWNLOAD", PLRK_VM_DOWNLOAD );
	PyModule_AddIntConstant( module, "PLRK_VM_SUSPEND", PLRK_VM_SUSPEND );
	PyModule_AddIntConstant( module, "PLRK_VM_PAUSE", PLRK_VM_PAUSE );
	PyModule_AddIntConstant( module, "PLRK_VM_SNAPSHOT_CREATE", PLRK_VM_SNAPSHOT_CREATE );
	PyModule_AddIntConstant( module, "PLRK_VM_SNAPSHOT_SWITCH", PLRK_VM_SNAPSHOT_SWITCH );
	PyModule_AddIntConstant( module, "PLRK_VM_SNAPSHOT_DELETE", PLRK_VM_SNAPSHOT_DELETE );
	PyModule_AddIntConstant( module, "PLRK_VM_SNAPSHOT_TREE", PLRK_VM_SNAPSHOT_TREE );
	PyModule_AddIntConstant( module, "PLRK_VM_UNDODISK_FEATURE", PLRK_VM_UNDODISK_FEATURE );
	PyModule_AddIntConstant( module, "PLRK_VM_SAFEMODE_FEATURE", PLRK_VM_SAFEMODE_FEATURE );
	PyModule_AddIntConstant( module, "PLRK_VM_SMARTGUARD_FEATURE", PLRK_VM_SMARTGUARD_FEATURE );
	PyModule_AddIntConstant( module, "PLRK_VM_SHOW_FULLSCREEN", PLRK_VM_SHOW_FULLSCREEN );
	PyModule_AddIntConstant( module, "PLRK_RUNNING_VMS_LIMIT_PER_USER", PLRK_RUNNING_VMS_LIMIT_PER_USER );
	PyModule_AddIntConstant( module, "PGD_UNKNOWN", PGD_UNKNOWN );
	PyModule_AddIntConstant( module, "PGD_WINDOWS_VISTA", PGD_WINDOWS_VISTA );
	PyModule_AddIntConstant( module, "PGD_WINDOWS_XP", PGD_WINDOWS_XP );
	PyModule_AddIntConstant( module, "PGD_WINDOWS_XP_32", PGD_WINDOWS_XP_32 );
	PyModule_AddIntConstant( module, "PGD_WINDOWS_XP_64", PGD_WINDOWS_XP_64 );
	PyModule_AddIntConstant( module, "PGD_WINDOWS_VISTA_32", PGD_WINDOWS_VISTA_32 );
	PyModule_AddIntConstant( module, "PGD_WINDOWS_VISTA_64", PGD_WINDOWS_VISTA_64 );
	PyModule_AddIntConstant( module, "PMT_WARNING", PMT_WARNING );
	PyModule_AddIntConstant( module, "PMT_INFORMATION", PMT_INFORMATION );
	PyModule_AddIntConstant( module, "PMT_CRITICAL", PMT_CRITICAL );
	PyModule_AddIntConstant( module, "PMT_QUESTION", PMT_QUESTION );
	PyModule_AddIntConstant( module, "PMT_ANSWER", PMT_ANSWER );
	PyModule_AddIntConstant( module, "PUD_CONNECT_TO_PRIMARY_OS", PUD_CONNECT_TO_PRIMARY_OS );
	PyModule_AddIntConstant( module, "PUD_CONNECT_TO_GUEST_OS", PUD_CONNECT_TO_GUEST_OS );
	PyModule_AddIntConstant( module, "PUD_ASK_USER_WHAT_TODO", PUD_ASK_USER_WHAT_TODO );
	PyModule_AddIntConstant( module, "PUD_CONNECTED_MANUALLY", PUD_CONNECTED_MANUALLY );
	PyModule_AddIntConstant( module, "PUD_CONNECTED_AUTOMATICALLY", PUD_CONNECTED_AUTOMATICALLY );
	PyModule_AddIntConstant( module, "PUDT_OTHER", PUDT_OTHER );
	PyModule_AddIntConstant( module, "PUDT_HUB", PUDT_HUB );
	PyModule_AddIntConstant( module, "PUDT_VIDEO", PUDT_VIDEO );
	PyModule_AddIntConstant( module, "PUDT_FOTO", PUDT_FOTO );
	PyModule_AddIntConstant( module, "PUDT_AUDIO", PUDT_AUDIO );
	PyModule_AddIntConstant( module, "PUDT_PRINTER", PUDT_PRINTER );
	PyModule_AddIntConstant( module, "PUDT_SCANNER", PUDT_SCANNER );
	PyModule_AddIntConstant( module, "PUDT_BLUETOOTH", PUDT_BLUETOOTH );
	PyModule_AddIntConstant( module, "PUDT_WIRELESS", PUDT_WIRELESS );
	PyModule_AddIntConstant( module, "PUDT_COMMUNICATION", PUDT_COMMUNICATION );
	PyModule_AddIntConstant( module, "PUDT_KEYBOARD", PUDT_KEYBOARD );
	PyModule_AddIntConstant( module, "PUDT_MOUSE", PUDT_MOUSE );
	PyModule_AddIntConstant( module, "PUDT_SMART_CARD", PUDT_SMART_CARD );
	PyModule_AddIntConstant( module, "PUDT_DISK_STORAGE", PUDT_DISK_STORAGE );
	PyModule_AddIntConstant( module, "PUDT_ATAPI_STORAGE", PUDT_ATAPI_STORAGE );
	PyModule_AddIntConstant( module, "PUDT_APPLE_IPHONE", PUDT_APPLE_IPHONE );
	PyModule_AddIntConstant( module, "PUDT_APPLE_IPOD", PUDT_APPLE_IPOD );
	PyModule_AddIntConstant( module, "PUDT_APPLE_IPAD", PUDT_APPLE_IPAD );
	PyModule_AddIntConstant( module, "PUDT_APPLE_IETH", PUDT_APPLE_IETH );
	PyModule_AddIntConstant( module, "PUDT_RIM_BLACKBERRY", PUDT_RIM_BLACKBERRY );
	PyModule_AddIntConstant( module, "PUDT_GARMIN_GPS", PUDT_GARMIN_GPS );
	PyModule_AddIntConstant( module, "PSS_STARTED", PSS_STARTED );
	PyModule_AddIntConstant( module, "PSS_STOPPED", PSS_STOPPED );
	PyModule_AddIntConstant( module, "PSS_NOT_INSTALLED", PSS_NOT_INSTALLED );
	PyModule_AddIntConstant( module, "PSS_UNKNOWN", PSS_UNKNOWN );
	PyModule_AddIntConstant( module, "RTT_RUNNING_TASK_UNKNOWN", RTT_RUNNING_TASK_UNKNOWN );
	PyModule_AddIntConstant( module, "RTT_RUNNING_TASK_CREATE_VM", RTT_RUNNING_TASK_CREATE_VM );
	PyModule_AddIntConstant( module, "RTT_RUNNING_TASK_REGISTER_VM", RTT_RUNNING_TASK_REGISTER_VM );
	PyModule_AddIntConstant( module, "RTT_RUNNING_TASK_CLONE_VM", RTT_RUNNING_TASK_CLONE_VM );
	PyModule_AddIntConstant( module, "RTT_RUNNING_TASK_DELETE_VM", RTT_RUNNING_TASK_DELETE_VM );
	PyModule_AddIntConstant( module, "RTT_RUNNING_TASK_UNREG_VM", RTT_RUNNING_TASK_UNREG_VM );
	PyModule_AddIntConstant( module, "RTT_RUNNING_TASK_CREATE_IMAGE", RTT_RUNNING_TASK_CREATE_IMAGE );
	PyModule_AddIntConstant( module, "RTT_RUNNING_TASK_RESTORE_VM", RTT_RUNNING_TASK_RESTORE_VM );
	PyModule_AddIntConstant( module, "RTT_RUNNING_TASK_MIGRATE_VM", RTT_RUNNING_TASK_MIGRATE_VM );
	PyModule_AddIntConstant( module, "RTT_RUNNING_TASK_COPY_IMAGE", RTT_RUNNING_TASK_COPY_IMAGE );
	PyModule_AddIntConstant( module, "PTU_CMD_INVALID", PTU_CMD_INVALID );
	PyModule_AddIntConstant( module, "PTU_CMD_PTU_ALIVE", PTU_CMD_PTU_ALIVE );
	PyModule_AddIntConstant( module, "PRD_DISABLED", PRD_DISABLED );
	PyModule_AddIntConstant( module, "PRD_AUTO", PRD_AUTO );
	PyModule_AddIntConstant( module, "PRD_MANUAL", PRD_MANUAL );
	PyModule_AddIntConstant( module, "PAR_VM_START_ACCESS", PAR_VM_START_ACCESS );
	PyModule_AddIntConstant( module, "PAR_VM_STOP_ACCESS", PAR_VM_STOP_ACCESS );
	PyModule_AddIntConstant( module, "PAR_VM_PAUSE_ACCESS", PAR_VM_PAUSE_ACCESS );
	PyModule_AddIntConstant( module, "PAR_VM_RESET_ACCESS", PAR_VM_RESET_ACCESS );
	PyModule_AddIntConstant( module, "PAR_VM_SUSPEND_ACCESS", PAR_VM_SUSPEND_ACCESS );
	PyModule_AddIntConstant( module, "PAR_VM_RESUME_ACCESS", PAR_VM_RESUME_ACCESS );
	PyModule_AddIntConstant( module, "PAR_VM_DROPSUSPENDEDSTATE_ACCESS", PAR_VM_DROPSUSPENDEDSTATE_ACCESS );
	PyModule_AddIntConstant( module, "PAR_VM_CLONE_ACCESS", PAR_VM_CLONE_ACCESS );
	PyModule_AddIntConstant( module, "PAR_VM_DELETE_ACCESS", PAR_VM_DELETE_ACCESS );
	PyModule_AddIntConstant( module, "PAR_VM_GETPROBLEMREPORT_ACCESS", PAR_VM_GETPROBLEMREPORT_ACCESS );
	PyModule_AddIntConstant( module, "PAR_VM_GETCONFIG_ACCESS", PAR_VM_GETCONFIG_ACCESS );
	PyModule_AddIntConstant( module, "PAR_VM_GETSTATISTICS_ACCESS", PAR_VM_GETSTATISTICS_ACCESS );
	PyModule_AddIntConstant( module, "PAR_VM_STATISTICS_SUBSCRIPTION_ACCESS", PAR_VM_STATISTICS_SUBSCRIPTION_ACCESS );
	PyModule_AddIntConstant( module, "PAR_VM_SUBSCRIBETOGUESTSTATISTICS_ACCESS", PAR_VM_SUBSCRIBETOGUESTSTATISTICS_ACCESS );
	PyModule_AddIntConstant( module, "PAR_VM_UNSUBSCRIBEFROMGUESTSTATISTICS_ACCESS", PAR_VM_UNSUBSCRIBEFROMGUESTSTATISTICS_ACCESS );
	PyModule_AddIntConstant( module, "PAR_VM_UNREG_ACCESS", PAR_VM_UNREG_ACCESS );
	PyModule_AddIntConstant( module, "PAR_VM_COMMIT_ACCESS", PAR_VM_COMMIT_ACCESS );
	PyModule_AddIntConstant( module, "PAR_VM_EDITING_ACCESS", PAR_VM_EDITING_ACCESS );
	PyModule_AddIntConstant( module, "PAR_VMDEV_CONNECT_ACCESS", PAR_VMDEV_CONNECT_ACCESS );
	PyModule_AddIntConstant( module, "PAR_VMDEV_DISCONNECT_ACCESS", PAR_VMDEV_DISCONNECT_ACCESS );
	PyModule_AddIntConstant( module, "PAR_VMDEV_CREATEIMAGE_ACCESS", PAR_VMDEV_CREATEIMAGE_ACCESS );
	PyModule_AddIntConstant( module, "PAR_VM_SEND_ANSWER_ACCESS", PAR_VM_SEND_ANSWER_ACCESS );
	PyModule_AddIntConstant( module, "PAR_VM_GET_VMINFO_ACCESS", PAR_VM_GET_VMINFO_ACCESS );
	PyModule_AddIntConstant( module, "PAR_VM_INSTALL_TOOLS_ACCESS", PAR_VM_INSTALL_TOOLS_ACCESS );
	PyModule_AddIntConstant( module, "PAR_VM_INITIATE_DEV_STATE_NOTIFICATIONS_ACCESS", PAR_VM_INITIATE_DEV_STATE_NOTIFICATIONS_ACCESS );
	PyModule_AddIntConstant( module, "PAR_VM_UPDATE_SECURITY_ACCESS", PAR_VM_UPDATE_SECURITY_ACCESS );
	PyModule_AddIntConstant( module, "PAR_VM_CANCEL_COMPACT_ACCESS", PAR_VM_CANCEL_COMPACT_ACCESS );
	PyModule_AddIntConstant( module, "PAR_VM_REGISTER_ACCESS", PAR_VM_REGISTER_ACCESS );
	PyModule_AddIntConstant( module, "PAR_VM_MIGRATE_ACCESS", PAR_VM_MIGRATE_ACCESS );
	PyModule_AddIntConstant( module, "PAR_VM_START_STOP_VNC_SERVER", PAR_VM_START_STOP_VNC_SERVER );
	PyModule_AddIntConstant( module, "PAR_VM_GET_SUSPENDED_SCREEN_ACCESS", PAR_VM_GET_SUSPENDED_SCREEN_ACCESS );
	PyModule_AddIntConstant( module, "PAR_VM_PERFSTAT_ACCESS", PAR_VM_PERFSTAT_ACCESS );
	PyModule_AddIntConstant( module, "PAR_VM_LOCK_ACCESS", PAR_VM_LOCK_ACCESS );
	PyModule_AddIntConstant( module, "PAR_VM_MIGRATE_CANCEL_ACCESS", PAR_VM_MIGRATE_CANCEL_ACCESS );
	PyModule_AddIntConstant( module, "PAR_VM_RUN_COMPRESSOR_ACCESS", PAR_VM_RUN_COMPRESSOR_ACCESS );
	PyModule_AddIntConstant( module, "PAR_VM_CANCEL_COMPRESSOR_ACCESS", PAR_VM_CANCEL_COMPRESSOR_ACCESS );
	PyModule_AddIntConstant( module, "PAR_VM_CREATE_SNAPSHOT_ACCESS", PAR_VM_CREATE_SNAPSHOT_ACCESS );
	PyModule_AddIntConstant( module, "PAR_VM_SWITCH_TO_SNAPSHOT_ACCESS", PAR_VM_SWITCH_TO_SNAPSHOT_ACCESS );
	PyModule_AddIntConstant( module, "PAR_VM_DELETE_SNAPSHOT_ACCESS", PAR_VM_DELETE_SNAPSHOT_ACCESS );
	PyModule_AddIntConstant( module, "PAR_VM_START_EX_ACCESS", PAR_VM_START_EX_ACCESS );
	PyModule_AddIntConstant( module, "PAR_VM_UNLOCK_ACCESS", PAR_VM_UNLOCK_ACCESS );
	PyModule_AddIntConstant( module, "PAR_VM_RESTART_GUEST_ACCESS", PAR_VM_RESTART_GUEST_ACCESS );
	PyModule_AddIntConstant( module, "PAR_VM_INSTALL_UTILITY_ACCESS", PAR_VM_INSTALL_UTILITY_ACCESS );
	PyModule_AddIntConstant( module, "PAR_VM_UPDATE_TOOLS_SECTION", PAR_VM_UPDATE_TOOLS_SECTION );
	PyModule_AddIntConstant( module, "PAR_VM_RESTORE_ACCESS", PAR_VM_RESTORE_ACCESS );
	PyModule_AddIntConstant( module, "PAR_VM_CREATE_BACKUP_ACCESS", PAR_VM_CREATE_BACKUP_ACCESS );
	PyModule_AddIntConstant( module, "PAR_VM_RESIZE_DISK_ACCESS", PAR_VM_RESIZE_DISK_ACCESS );
	PyModule_AddIntConstant( module, "PAR_VM_CREATE_ACCESS", PAR_VM_CREATE_ACCESS );
	PyModule_AddIntConstant( module, "PAR_SRV_USER_PROFILE_BEGINEDIT_ACCESS", PAR_SRV_USER_PROFILE_BEGINEDIT_ACCESS );
	PyModule_AddIntConstant( module, "PAR_SRV_USER_PROFILE_COMMIT_ACCESS", PAR_SRV_USER_PROFILE_COMMIT_ACCESS );
	PyModule_AddIntConstant( module, "PAR_SRV_SERVER_PROFILE_BEGINEDIT_ACCESS", PAR_SRV_SERVER_PROFILE_BEGINEDIT_ACCESS );
	PyModule_AddIntConstant( module, "PAR_SRV_SERVER_PROFILE_COMMIT_ACCESS", PAR_SRV_SERVER_PROFILE_COMMIT_ACCESS );
	PyModule_AddIntConstant( module, "PAR_VM_GUI_VIEW_MODE_CHANGE_ACCESS", PAR_VM_GUI_VIEW_MODE_CHANGE_ACCESS );
	PyModule_AddIntConstant( module, "PAR_VM_BEGINEDIT_ACCESS", PAR_VM_BEGINEDIT_ACCESS );
	PyModule_AddIntConstant( module, "PAR_VM_RESTORE_BACKUP_ACCESS", PAR_VM_RESTORE_BACKUP_ACCESS );
	PyModule_AddIntConstant( module, "PAR_VM_COMPACT_ACCESS", PAR_VM_COMPACT_ACCESS );
	PyModule_AddIntConstant( module, "PAR_VM_CHANGE_SID_ACCESS", PAR_VM_CHANGE_SID_ACCESS );
	PyModule_AddIntConstant( module, "PAR_VM_RESET_UPTIME_ACCESS", PAR_VM_RESET_UPTIME_ACCESS );
	PyModule_AddIntConstant( module, "PAR_VM_INTERNAL_CMD_ACCESS", PAR_VM_INTERNAL_CMD_ACCESS );
	PyModule_AddIntConstant( module, "PAR_VM_GET_VIRT_DEV_INFO", PAR_VM_GET_VIRT_DEV_INFO );
	PyModule_AddIntConstant( module, "PAR_VM_GET_TOOLS_INFO", PAR_VM_GET_TOOLS_INFO );
	PyModule_AddIntConstant( module, "PAR_VM_CONVERT_DISKS_ACCESS", PAR_VM_CONVERT_DISKS_ACCESS );
	PyModule_AddIntConstant( module, "PAR_VM_ENCRYPT_OPERATION_ACCESS", PAR_VM_ENCRYPT_OPERATION_ACCESS );
	PyModule_AddIntConstant( module, "PAR_VM_CHANGE_PASSWORD_ACCESS", PAR_VM_CHANGE_PASSWORD_ACCESS );
	PyModule_AddIntConstant( module, "PAR_VM_ENCRYPT_ACCESS", PAR_VM_ENCRYPT_ACCESS );
	PyModule_AddIntConstant( module, "PAR_VM_DECRYPT_ACCESS", PAR_VM_DECRYPT_ACCESS );
	PyModule_AddIntConstant( module, "PAR_VM_SET_PROTECTION_ACCESS", PAR_VM_SET_PROTECTION_ACCESS );
	PyModule_AddIntConstant( module, "PAR_VM_REMOVE_PROTECTION_ACCESS", PAR_VM_REMOVE_PROTECTION_ACCESS );
	PyModule_AddIntConstant( module, "PAR_VM_AUTHORISE_ACCESS", PAR_VM_AUTHORISE_ACCESS );
	PyModule_AddIntConstant( module, "PAR_VMDEV_COPY_IMAGE_ACCESS", PAR_VMDEV_COPY_IMAGE_ACCESS );
	PyModule_AddIntConstant( module, "PAR_VM_MOUNT_ACCESS", PAR_VM_MOUNT_ACCESS );
	PyModule_AddIntConstant( module, "PAR_VM_MOVE_ACCESS", PAR_VM_MOVE_ACCESS );
	PyModule_AddIntConstant( module, "PAR_VM_CHANGE_GUEST_OS_PASSWORD_ACCESS", PAR_VM_CHANGE_GUEST_OS_PASSWORD_ACCESS );
	PyModule_AddIntConstant( module, "PAR_SRV_SENDPROBLEMREPORT_ACCESS", PAR_SRV_SENDPROBLEMREPORT_ACCESS );
	PyModule_AddIntConstant( module, "PAR_MAX", PAR_MAX );
	PyModule_AddIntConstant( module, "PAO_VM_NOT_SHARED", PAO_VM_NOT_SHARED );
	PyModule_AddIntConstant( module, "PAO_VM_SHARED_ON_VIEW", PAO_VM_SHARED_ON_VIEW );
	PyModule_AddIntConstant( module, "PAO_VM_SHARED_ON_VIEW_AND_RUN", PAO_VM_SHARED_ON_VIEW_AND_RUN );
	PyModule_AddIntConstant( module, "PAO_VM_SHARED_ON_FULL_ACCESS", PAO_VM_SHARED_ON_FULL_ACCESS );
	PyModule_AddIntConstant( module, "PST_VM_SHUTDOWN", PST_VM_SHUTDOWN );
	PyModule_AddIntConstant( module, "PST_VM_REBOOT", PST_VM_REBOOT );
	PyModule_AddIntConstant( module, "PST_VM_HIBERNATE", PST_VM_HIBERNATE );
	PyModule_AddIntConstant( module, "PST_VM_SUSPEND", PST_VM_SUSPEND );
	PyModule_AddIntConstant( module, "PGST_CAPABILITY_SHUTDOWN", PGST_CAPABILITY_SHUTDOWN );
	PyModule_AddIntConstant( module, "PGST_CAPABILITY_REBOOT", PGST_CAPABILITY_REBOOT );
	PyModule_AddIntConstant( module, "PGST_CAPABILITY_SUSPEND", PGST_CAPABILITY_SUSPEND );
	PyModule_AddIntConstant( module, "PGST_CAPABILITY_HIBERNATE", PGST_CAPABILITY_HIBERNATE );
	PyModule_AddIntConstant( module, "PVC_VALIDATE_CHANGES_ONLY", PVC_VALIDATE_CHANGES_ONLY );
	PyModule_AddIntConstant( module, "PVC_ALL", PVC_ALL );
	PyModule_AddIntConstant( module, "PVC_GENERAL_PARAMETERS", PVC_GENERAL_PARAMETERS );
	PyModule_AddIntConstant( module, "PVC_BOOT_OPTION", PVC_BOOT_OPTION );
	PyModule_AddIntConstant( module, "PVC_REMOTE_DISPLAY", PVC_REMOTE_DISPLAY );
	PyModule_AddIntConstant( module, "PVC_SHARED_FOLDERS", PVC_SHARED_FOLDERS );
	PyModule_AddIntConstant( module, "PVC_CPU", PVC_CPU );
	PyModule_AddIntConstant( module, "PVC_MAIN_MEMORY", PVC_MAIN_MEMORY );
	PyModule_AddIntConstant( module, "PVC_VIDEO_MEMORY", PVC_VIDEO_MEMORY );
	PyModule_AddIntConstant( module, "PVC_FLOPPY_DISK", PVC_FLOPPY_DISK );
	PyModule_AddIntConstant( module, "PVC_CD_DVD_ROM", PVC_CD_DVD_ROM );
	PyModule_AddIntConstant( module, "PVC_HARD_DISK", PVC_HARD_DISK );
	PyModule_AddIntConstant( module, "PVC_NETWORK_ADAPTER", PVC_NETWORK_ADAPTER );
	PyModule_AddIntConstant( module, "PVC_SOUND", PVC_SOUND );
	PyModule_AddIntConstant( module, "PVC_SERIAL_PORT", PVC_SERIAL_PORT );
	PyModule_AddIntConstant( module, "PVC_PARALLEL_PORT", PVC_PARALLEL_PORT );
	PyModule_AddIntConstant( module, "PVC_IDE_DEVICES", PVC_IDE_DEVICES );
	PyModule_AddIntConstant( module, "PVC_SCSI_DEVICES", PVC_SCSI_DEVICES );
	PyModule_AddIntConstant( module, "PVC_GENERIC_PCI", PVC_GENERIC_PCI );
	PyModule_AddIntConstant( module, "PVC_OFFLINE_MANAGEMENT_SETTINGS", PVC_OFFLINE_MANAGEMENT_SETTINGS );
	PyModule_AddIntConstant( module, "PVC_LICENSE_RESTRICTIONS", PVC_LICENSE_RESTRICTIONS );
	PyModule_AddIntConstant( module, "PVC_SATA_DEVICES", PVC_SATA_DEVICES );
	PyModule_AddIntConstant( module, "PVC_LAST_SECTION", PVC_LAST_SECTION );
	PyModule_AddIntConstant( module, "PTIS_RECORD_EMPTY", PTIS_RECORD_EMPTY );
	PyModule_AddIntConstant( module, "PTIS_RECORD_ACTIVE", PTIS_RECORD_ACTIVE );
	PyModule_AddIntConstant( module, "PTIS_RECORD_CANCELED", PTIS_RECORD_CANCELED );
	PyModule_AddIntConstant( module, "PTIS_RECORD_UID", PTIS_RECORD_UID );
	PyModule_AddIntConstant( module, "PTIS_RECORD_NAME", PTIS_RECORD_NAME );
	PyModule_AddIntConstant( module, "PTIS_RECORD_INFO", PTIS_RECORD_INFO );
	PyModule_AddIntConstant( module, "PTIS_RECORD_TEXT", PTIS_RECORD_TEXT );
	PyModule_AddIntConstant( module, "PTIS_RECORD_DATA", PTIS_RECORD_DATA );
	PyModule_AddIntConstant( module, "PTIS_RECORD_STATE", PTIS_RECORD_STATE );
	PyModule_AddIntConstant( module, "PTIS_RECORD_TIME", PTIS_RECORD_TIME );
	PyModule_AddIntConstant( module, "PTIS_RECORD_OWNER", PTIS_RECORD_OWNER );
	PyModule_AddIntConstant( module, "PTIS_RECORD_FLAGS", PTIS_RECORD_FLAGS );
	PyModule_AddIntConstant( module, "PTIS_RECORD_REMOVED", PTIS_RECORD_REMOVED );
	PyModule_AddIntConstant( module, "PTIS_RECORD_CLEARED", PTIS_RECORD_CLEARED );
	PyModule_AddIntConstant( module, "PJOC_UNKNOWN", PJOC_UNKNOWN );
	PyModule_AddIntConstant( module, "PJOC_JOB_CANCEL", PJOC_JOB_CANCEL );
	PyModule_AddIntConstant( module, "PJOC_SRV_LOOKUP_PARALLELS_SERVERS", PJOC_SRV_LOOKUP_PARALLELS_SERVERS );
	PyModule_AddIntConstant( module, "PJOC_SRV_LOGIN", PJOC_SRV_LOGIN );
	PyModule_AddIntConstant( module, "PJOC_SRV_LOGIN_LOCAL", PJOC_SRV_LOGIN_LOCAL );
	PyModule_AddIntConstant( module, "PJOC_SRV_LOGOFF", PJOC_SRV_LOGOFF );
	PyModule_AddIntConstant( module, "PJOC_SRV_GET_SRV_CONFIG", PJOC_SRV_GET_SRV_CONFIG );
	PyModule_AddIntConstant( module, "PJOC_SRV_GET_COMMON_PREFS", PJOC_SRV_GET_COMMON_PREFS );
	PyModule_AddIntConstant( module, "PJOC_SRV_COMMON_PREFS_BEGIN_EDIT", PJOC_SRV_COMMON_PREFS_BEGIN_EDIT );
	PyModule_AddIntConstant( module, "PJOC_SRV_COMMON_PREFS_COMMIT", PJOC_SRV_COMMON_PREFS_COMMIT );
	PyModule_AddIntConstant( module, "PJOC_SRV_GET_USER_PROFILE", PJOC_SRV_GET_USER_PROFILE );
	PyModule_AddIntConstant( module, "PJOC_SRV_GET_STATISTICS", PJOC_SRV_GET_STATISTICS );
	PyModule_AddIntConstant( module, "PJOC_SRV_USER_PROFILE_BEGIN_EDIT", PJOC_SRV_USER_PROFILE_BEGIN_EDIT );
	PyModule_AddIntConstant( module, "PJOC_SRV_USER_PROFILE_COMMIT", PJOC_SRV_USER_PROFILE_COMMIT );
	PyModule_AddIntConstant( module, "PJOC_SRV_REGISTER_VM", PJOC_SRV_REGISTER_VM );
	PyModule_AddIntConstant( module, "PJOC_SRV_REGISTER_VM_EX", PJOC_SRV_REGISTER_VM_EX );
	PyModule_AddIntConstant( module, "PJOC_SRV_GET_VM_LIST", PJOC_SRV_GET_VM_LIST );
	PyModule_AddIntConstant( module, "PJOC_SRV_SUBSCRIBE_TO_HOST_STATISTICS", PJOC_SRV_SUBSCRIBE_TO_HOST_STATISTICS );
	PyModule_AddIntConstant( module, "PJOC_SRV_UNSUBSCRIBE_FROM_HOST_STATISTICS", PJOC_SRV_UNSUBSCRIBE_FROM_HOST_STATISTICS );
	PyModule_AddIntConstant( module, "PJOC_SRV_SHUTDOWN", PJOC_SRV_SHUTDOWN );
	PyModule_AddIntConstant( module, "PJOC_SRV_FS_GET_DISK_LIST", PJOC_SRV_FS_GET_DISK_LIST );
	PyModule_AddIntConstant( module, "PJOC_SRV_FS_GET_DIR_ENTRIES", PJOC_SRV_FS_GET_DIR_ENTRIES );
	PyModule_AddIntConstant( module, "PJOC_SRV_FS_CREATE_DIR", PJOC_SRV_FS_CREATE_DIR );
	PyModule_AddIntConstant( module, "PJOC_SRV_FS_REMOVE_ENTRY", PJOC_SRV_FS_REMOVE_ENTRY );
	PyModule_AddIntConstant( module, "PJOC_SRV_FS_CAN_CREATE_FILE", PJOC_SRV_FS_CAN_CREATE_FILE );
	PyModule_AddIntConstant( module, "PJOC_SRV_FS_RENAME_ENTRY", PJOC_SRV_FS_RENAME_ENTRY );
	PyModule_AddIntConstant( module, "PJOC_SRV_FS_GENERATE_ENTRY_NAME", PJOC_SRV_FS_GENERATE_ENTRY_NAME );
	PyModule_AddIntConstant( module, "PJOC_SRV_UPDATE_LICENSE", PJOC_SRV_UPDATE_LICENSE );
	PyModule_AddIntConstant( module, "PJOC_SRV_GET_LICENSE_INFO", PJOC_SRV_GET_LICENSE_INFO );
	PyModule_AddIntConstant( module, "PJOC_SRV_SEND_ANSWER", PJOC_SRV_SEND_ANSWER );
	PyModule_AddIntConstant( module, "PJOC_SRV_START_SEARCH_VMS", PJOC_SRV_START_SEARCH_VMS );
	PyModule_AddIntConstant( module, "PJOC_SRV_NET_SERVICE_START", PJOC_SRV_NET_SERVICE_START );
	PyModule_AddIntConstant( module, "PJOC_SRV_NET_SERVICE_STOP", PJOC_SRV_NET_SERVICE_STOP );
	PyModule_AddIntConstant( module, "PJOC_SRV_NET_SERVICE_RESTART", PJOC_SRV_NET_SERVICE_RESTART );
	PyModule_AddIntConstant( module, "PJOC_SRV_NET_SERVICE_RESTORE_DEFAULTS", PJOC_SRV_NET_SERVICE_RESTORE_DEFAULTS );
	PyModule_AddIntConstant( module, "PJOC_SRV_GET_NET_SERVICE_STATUS", PJOC_SRV_GET_NET_SERVICE_STATUS );
	PyModule_AddIntConstant( module, "PJOC_SRV_ADD_NET_ADAPTER", PJOC_SRV_ADD_NET_ADAPTER );
	PyModule_AddIntConstant( module, "PJOC_SRV_DELETE_NET_ADAPTER", PJOC_SRV_DELETE_NET_ADAPTER );
	PyModule_AddIntConstant( module, "PJOC_SRV_UPDATE_NET_ADAPTER", PJOC_SRV_UPDATE_NET_ADAPTER );
	PyModule_AddIntConstant( module, "PJOC_SRV_GET_PROBLEM_REPORT", PJOC_SRV_GET_PROBLEM_REPORT );
	PyModule_AddIntConstant( module, "PJOC_SRV_ATTACH_TO_LOST_TASK", PJOC_SRV_ATTACH_TO_LOST_TASK );
	PyModule_AddIntConstant( module, "PJOC_SRV_GET_USER_INFO_LIST", PJOC_SRV_GET_USER_INFO_LIST );
	PyModule_AddIntConstant( module, "PJOC_SRV_GET_USER_INFO", PJOC_SRV_GET_USER_INFO );
	PyModule_AddIntConstant( module, "PJOC_VM_START", PJOC_VM_START );
	PyModule_AddIntConstant( module, "PJOC_VM_STOP", PJOC_VM_STOP );
	PyModule_AddIntConstant( module, "PJOC_VM_PAUSE", PJOC_VM_PAUSE );
	PyModule_AddIntConstant( module, "PJOC_VM_RESET", PJOC_VM_RESET );
	PyModule_AddIntConstant( module, "PJOC_VM_SUSPEND", PJOC_VM_SUSPEND );
	PyModule_AddIntConstant( module, "PJOC_VM_RESUME", PJOC_VM_RESUME );
	PyModule_AddIntConstant( module, "PJOC_VM_DROP_SUSPENDED_STATE", PJOC_VM_DROP_SUSPENDED_STATE );
	PyModule_AddIntConstant( module, "PJOC_VM_CLONE", PJOC_VM_CLONE );
	PyModule_AddIntConstant( module, "PJOC_VM_DELETE", PJOC_VM_DELETE );
	PyModule_AddIntConstant( module, "PJOC_VM_GET_PROBLEM_REPORT", PJOC_VM_GET_PROBLEM_REPORT );
	PyModule_AddIntConstant( module, "PJOC_VM_GET_STATE", PJOC_VM_GET_STATE );
	PyModule_AddIntConstant( module, "PJOC_VM_GENERATE_VM_DEV_FILENAME", PJOC_VM_GENERATE_VM_DEV_FILENAME );
	PyModule_AddIntConstant( module, "PJOC_VM_GET_TOOLS_STATE", PJOC_VM_GET_TOOLS_STATE );
	PyModule_AddIntConstant( module, "PJOC_VM_REFRESH_CONFIG", PJOC_VM_REFRESH_CONFIG );
	PyModule_AddIntConstant( module, "PJOC_VM_GET_STATISTICS", PJOC_VM_GET_STATISTICS );
	PyModule_AddIntConstant( module, "PJOC_VM_SUBSCRIBE_TO_GUEST_STATISTICS", PJOC_VM_SUBSCRIBE_TO_GUEST_STATISTICS );
	PyModule_AddIntConstant( module, "PJOC_VM_UNSUBSCRIBE_FROM_GUEST_STATISTICS", PJOC_VM_UNSUBSCRIBE_FROM_GUEST_STATISTICS );
	PyModule_AddIntConstant( module, "PJOC_VM_REG", PJOC_VM_REG );
	PyModule_AddIntConstant( module, "PJOC_VM_UNREG", PJOC_VM_UNREG );
	PyModule_AddIntConstant( module, "PJOC_VM_BEGIN_EDIT", PJOC_VM_BEGIN_EDIT );
	PyModule_AddIntConstant( module, "PJOC_VM_COMMIT", PJOC_VM_COMMIT );
	PyModule_AddIntConstant( module, "PJOC_VM_CREATE_UNATTENDED_FLOPPY", PJOC_VM_CREATE_UNATTENDED_FLOPPY );
	PyModule_AddIntConstant( module, "PJOC_VM_INITIATE_DEV_STATE_NOTIFICATIONS", PJOC_VM_INITIATE_DEV_STATE_NOTIFICATIONS );
	PyModule_AddIntConstant( module, "PJOC_VM_UPDATE_SECURITY", PJOC_VM_UPDATE_SECURITY );
	PyModule_AddIntConstant( module, "PJOC_VM_VALIDATE_CONFIG", PJOC_VM_VALIDATE_CONFIG );
	PyModule_AddIntConstant( module, "PJOC_VM_DEV_CONNECT", PJOC_VM_DEV_CONNECT );
	PyModule_AddIntConstant( module, "PJOC_VM_DEV_DISCONNECT", PJOC_VM_DEV_DISCONNECT );
	PyModule_AddIntConstant( module, "PJOC_VM_DEV_CREATE_IMAGE", PJOC_VM_DEV_CREATE_IMAGE );
	PyModule_AddIntConstant( module, "PJOC_VM_INSTALL_TOOLS", PJOC_VM_INSTALL_TOOLS );
	PyModule_AddIntConstant( module, "PJOC_VM_SEND_SHUTDOWN_COMMAND", PJOC_VM_SEND_SHUTDOWN_COMMAND );
	PyModule_AddIntConstant( module, "PJOC_VM_SEND_CLIPBOARD_REQUEST", PJOC_VM_SEND_CLIPBOARD_REQUEST );
	PyModule_AddIntConstant( module, "PJOC_VM_CONNECT_TO_VM", PJOC_VM_CONNECT_TO_VM );
	PyModule_AddIntConstant( module, "PJOC_VM_DEV_DISPLAY_CAPTURE_SCREEN", PJOC_VM_DEV_DISPLAY_CAPTURE_SCREEN );
	PyModule_AddIntConstant( module, "PJOC_VM_MIGRATE", PJOC_VM_MIGRATE );
	PyModule_AddIntConstant( module, "PJOC_VM_SEND_DRAGDROP_COMMAND", PJOC_VM_SEND_DRAGDROP_COMMAND );
	PyModule_AddIntConstant( module, "PJOC_VM_GUEST_RUN_PROGRAM", PJOC_VM_GUEST_RUN_PROGRAM );
	PyModule_AddIntConstant( module, "PJOC_VM_GUEST_LOGOUT", PJOC_VM_GUEST_LOGOUT );
	PyModule_AddIntConstant( module, "PJOC_SRV_SUBSCRIBE_PERFSTATS", PJOC_SRV_SUBSCRIBE_PERFSTATS );
	PyModule_AddIntConstant( module, "PJOC_SRV_UNSUBSCRIBE_PERFSTATS", PJOC_SRV_UNSUBSCRIBE_PERFSTATS );
	PyModule_AddIntConstant( module, "PJOC_SRV_GET_PERFSTATS", PJOC_SRV_GET_PERFSTATS );
	PyModule_AddIntConstant( module, "PJOC_VM_SUBSCRIBE_PERFSTATS", PJOC_VM_SUBSCRIBE_PERFSTATS );
	PyModule_AddIntConstant( module, "PJOC_VM_UNSUBSCRIBE_PERFSTATS", PJOC_VM_UNSUBSCRIBE_PERFSTATS );
	PyModule_AddIntConstant( module, "PJOC_VM_GET_PERFSTATS", PJOC_VM_GET_PERFSTATS );
	PyModule_AddIntConstant( module, "PJOC_VM_GET_SUSPENDED_SCREEN", PJOC_VM_GET_SUSPENDED_SCREEN );
	PyModule_AddIntConstant( module, "PJOC_VM_MIGRATE_CANCEL", PJOC_VM_MIGRATE_CANCEL );
	PyModule_AddIntConstant( module, "PJOC_VM_RUN_COMPRESSOR", PJOC_VM_RUN_COMPRESSOR );
	PyModule_AddIntConstant( module, "PJOC_VM_CANCEL_COMPRESSOR", PJOC_VM_CANCEL_COMPRESSOR );
	PyModule_AddIntConstant( module, "PJOC_VM_CREATE_SNAPSHOT", PJOC_VM_CREATE_SNAPSHOT );
	PyModule_AddIntConstant( module, "PJOC_VM_SWITCH_TO_SNAPSHOT", PJOC_VM_SWITCH_TO_SNAPSHOT );
	PyModule_AddIntConstant( module, "PJOC_VM_DELETE_SNAPSHOT", PJOC_VM_DELETE_SNAPSHOT );
	PyModule_AddIntConstant( module, "PJOC_VM_GET_SNAPSHOTS_TREE", PJOC_VM_GET_SNAPSHOTS_TREE );
	PyModule_AddIntConstant( module, "PJOC_VM_START_EX", PJOC_VM_START_EX );
	PyModule_AddIntConstant( module, "PJOC_VM_LOGIN_IN_GUEST", PJOC_VM_LOGIN_IN_GUEST );
	PyModule_AddIntConstant( module, "PJOC_VM_UPDATE_SNAPSHOT_DATA", PJOC_VM_UPDATE_SNAPSHOT_DATA );
	PyModule_AddIntConstant( module, "PJOC_VM_RESTART", PJOC_VM_RESTART );
	PyModule_AddIntConstant( module, "PJOC_VM_INSTALL_UTILITY", PJOC_VM_INSTALL_UTILITY );
	PyModule_AddIntConstant( module, "PJOC_VM_UPDATE_TOOLS_SECTION", PJOC_VM_UPDATE_TOOLS_SECTION );
	PyModule_AddIntConstant( module, "PJOC_SRV_GET_ALL_HOST_USERS", PJOC_SRV_GET_ALL_HOST_USERS );
	PyModule_AddIntConstant( module, "PJOC_VM_RESTORE", PJOC_VM_RESTORE );
	PyModule_AddIntConstant( module, "PJOC_VM_START_VNC_SERVER", PJOC_VM_START_VNC_SERVER );
	PyModule_AddIntConstant( module, "PJOC_VM_STOP_VNC_SERVER", PJOC_VM_STOP_VNC_SERVER );
	PyModule_AddIntConstant( module, "PJOC_VM_GUEST_GET_NETWORK_SETTINGS", PJOC_VM_GUEST_GET_NETWORK_SETTINGS );
	PyModule_AddIntConstant( module, "PJOC_SRV_GET_VIRTUAL_NETWORK_LIST", PJOC_SRV_GET_VIRTUAL_NETWORK_LIST );
	PyModule_AddIntConstant( module, "PJOC_VM_AUTH_WITH_GUEST_SECURITY_DB", PJOC_VM_AUTH_WITH_GUEST_SECURITY_DB );
	PyModule_AddIntConstant( module, "PJOC_VM_GUEST_SET_USER_PASSWD", PJOC_VM_GUEST_SET_USER_PASSWD );
	PyModule_AddIntConstant( module, "PJOC_SRV_ADD_VIRTUAL_NETWORK", PJOC_SRV_ADD_VIRTUAL_NETWORK );
	PyModule_AddIntConstant( module, "PJOC_SRV_UPDATE_VIRTUAL_NETWORK", PJOC_SRV_UPDATE_VIRTUAL_NETWORK );
	PyModule_AddIntConstant( module, "PJOC_SRV_DELETE_VIRTUAL_NETWORK", PJOC_SRV_DELETE_VIRTUAL_NETWORK );
	PyModule_AddIntConstant( module, "PJOC_SRV_CONFIGURE_GENERIC_PCI", PJOC_SRV_CONFIGURE_GENERIC_PCI );
	PyModule_AddIntConstant( module, "PJOC_SRV_PREPARE_FOR_HIBERNATE", PJOC_SRV_PREPARE_FOR_HIBERNATE );
	PyModule_AddIntConstant( module, "PJOC_SRV_AFTER_HOST_RESUME", PJOC_SRV_AFTER_HOST_RESUME );
	PyModule_AddIntConstant( module, "PJOC_SRV_GET_BACKUP_TREE", PJOC_SRV_GET_BACKUP_TREE );
	PyModule_AddIntConstant( module, "PJOC_SRV_CREATE_VM_BACKUP", PJOC_SRV_CREATE_VM_BACKUP );
	PyModule_AddIntConstant( module, "PJOC_SRV_RESTORE_VM_BACKUP", PJOC_SRV_RESTORE_VM_BACKUP );
	PyModule_AddIntConstant( module, "PJOC_API_SEND_PROBLEM_REPORT", PJOC_API_SEND_PROBLEM_REPORT );
	PyModule_AddIntConstant( module, "PJOC_VM_LOCK", PJOC_VM_LOCK );
	PyModule_AddIntConstant( module, "PJOC_VM_UNLOCK", PJOC_VM_UNLOCK );
	PyModule_AddIntConstant( module, "PJOC_SRV_SET_NON_INTERACTIVE_SESSION", PJOC_SRV_SET_NON_INTERACTIVE_SESSION );
	PyModule_AddIntConstant( module, "PJOC_SRV_CREATE_UNATTENDED_CD", PJOC_SRV_CREATE_UNATTENDED_CD );
	PyModule_AddIntConstant( module, "PJOC_SRV_REMOVE_VM_BACKUP", PJOC_SRV_REMOVE_VM_BACKUP );
	PyModule_AddIntConstant( module, "PJOC_VM_RESIZE_DISK_IMAGE", PJOC_VM_RESIZE_DISK_IMAGE );
	PyModule_AddIntConstant( module, "PJOC_SRV_SET_SESSION_CONFIRMATION_MODE", PJOC_SRV_SET_SESSION_CONFIRMATION_MODE );
	PyModule_AddIntConstant( module, "PJOC_SRV_STORE_VALUE_BY_KEY", PJOC_SRV_STORE_VALUE_BY_KEY );
	PyModule_AddIntConstant( module, "PJOC_VM_STORE_VALUE_BY_KEY", PJOC_VM_STORE_VALUE_BY_KEY );
	PyModule_AddIntConstant( module, "PJOC_VM_COMPACT", PJOC_VM_COMPACT );
	PyModule_AddIntConstant( module, "PJOC_VM_CANCEL_COMPACT", PJOC_VM_CANCEL_COMPACT );
	PyModule_AddIntConstant( module, "PJOC_SRV_SEND_CLIENT_STATISTICS", PJOC_SRV_SEND_CLIENT_STATISTICS );
	PyModule_AddIntConstant( module, "PJOC_VM_GET_PACKED_PROBLEM_REPORT", PJOC_VM_GET_PACKED_PROBLEM_REPORT );
	PyModule_AddIntConstant( module, "PJOC_SRV_GET_PACKED_PROBLEM_REPORT", PJOC_SRV_GET_PACKED_PROBLEM_REPORT );
	PyModule_AddIntConstant( module, "PJOC_API_SEND_PACKED_PROBLEM_REPORT", PJOC_API_SEND_PACKED_PROBLEM_REPORT );
	PyModule_AddIntConstant( module, "PJOC_SRV_UPDATE_USB_ASSOC_LIST", PJOC_SRV_UPDATE_USB_ASSOC_LIST );
	PyModule_AddIntConstant( module, "PJOC_SRV_REGISTER_3RD_PARTY_VM", PJOC_SRV_REGISTER_3RD_PARTY_VM );
	PyModule_AddIntConstant( module, "PJOC_VM_CHANGE_SID", PJOC_VM_CHANGE_SID );
	PyModule_AddIntConstant( module, "PJOC_VM_RESET_UPTIME", PJOC_VM_RESET_UPTIME );
	PyModule_AddIntConstant( module, "PJOC_REPORT_ASSEMBLY", PJOC_REPORT_ASSEMBLY );
	PyModule_AddIntConstant( module, "PJOC_SRV_INSTALL_APPLIANCE", PJOC_SRV_INSTALL_APPLIANCE );
	PyModule_AddIntConstant( module, "PJOC_SRV_UPDATE_OFFLINE_SERVICE", PJOC_SRV_UPDATE_OFFLINE_SERVICE );
	PyModule_AddIntConstant( module, "PJOC_SRV_DELETE_OFFLINE_SERVICE", PJOC_SRV_DELETE_OFFLINE_SERVICE );
	PyModule_AddIntConstant( module, "PJOC_SRV_GET_OFFLINE_SERVICES_LIST", PJOC_SRV_GET_OFFLINE_SERVICES_LIST );
	PyModule_AddIntConstant( module, "PJOC_SRV_START_CLUSTER_SERVICE", PJOC_SRV_START_CLUSTER_SERVICE );
	PyModule_AddIntConstant( module, "PJOC_SRV_STOP_CLUSTER_SERVICE", PJOC_SRV_STOP_CLUSTER_SERVICE );
	PyModule_AddIntConstant( module, "PJOC_VM_CMD_INTERNAL", PJOC_VM_CMD_INTERNAL );
	PyModule_AddIntConstant( module, "PJOC_VM_GET_VIRTUAL_DEVICES_INFO", PJOC_VM_GET_VIRTUAL_DEVICES_INFO );
	PyModule_AddIntConstant( module, "PJOC_VM_CONVERT_DISKS", PJOC_VM_CONVERT_DISKS );
	PyModule_AddIntConstant( module, "PJOC_SRV_UPDATE_NETWORK_CLASSES_CONFIG", PJOC_SRV_UPDATE_NETWORK_CLASSES_CONFIG );
	PyModule_AddIntConstant( module, "PJOC_SRV_GET_NETWORK_CLASSES_LIST", PJOC_SRV_GET_NETWORK_CLASSES_LIST );
	PyModule_AddIntConstant( module, "PJOC_SRV_UPDATE_NETWORK_SHAPING_CONFIG", PJOC_SRV_UPDATE_NETWORK_SHAPING_CONFIG );
	PyModule_AddIntConstant( module, "PJOC_SRV_GET_NETWORK_SHAPING_CONFIG", PJOC_SRV_GET_NETWORK_SHAPING_CONFIG );
	PyModule_AddIntConstant( module, "PJOC_SRV_RESTART_NETWORK_SHAPING", PJOC_SRV_RESTART_NETWORK_SHAPING );
	PyModule_AddIntConstant( module, "PJOC_SRV_PROXY_GET_REGISTERED_HOSTS", PJOC_SRV_PROXY_GET_REGISTERED_HOSTS );
	PyModule_AddIntConstant( module, "PJOC_SRV_REGISTER_ISCSI_STORAGE", PJOC_SRV_REGISTER_ISCSI_STORAGE );
	PyModule_AddIntConstant( module, "PJOC_SRV_UNREGISTER_ISCSI_STORAGE", PJOC_SRV_UNREGISTER_ISCSI_STORAGE );
	PyModule_AddIntConstant( module, "PJOC_SRV_EXTEND_ISCSI_STORAGE", PJOC_SRV_EXTEND_ISCSI_STORAGE );
	PyModule_AddIntConstant( module, "PJOC_SRV_GET_CT_TEMPLATE_LIST", PJOC_SRV_GET_CT_TEMPLATE_LIST );
	PyModule_AddIntConstant( module, "PJOC_SRV_CHECK_ALIVE", PJOC_SRV_CHECK_ALIVE );
	PyModule_AddIntConstant( module, "PJOC_SRV_GET_DEFAULT_VM_CONFIG", PJOC_SRV_GET_DEFAULT_VM_CONFIG );
	PyModule_AddIntConstant( module, "PJOC_SRV_REMOVE_CT_TEMPLATE", PJOC_SRV_REMOVE_CT_TEMPLATE );
	PyModule_AddIntConstant( module, "PJOC_SRV_COPY_CT_TEMPLATE", PJOC_SRV_COPY_CT_TEMPLATE );
	PyModule_AddIntConstant( module, "PJOC_SRV_ADD_IPPRIVATE_NETWORK", PJOC_SRV_ADD_IPPRIVATE_NETWORK );
	PyModule_AddIntConstant( module, "PJOC_SRV_REMOVE_IPPRIVATE_NETWORK", PJOC_SRV_REMOVE_IPPRIVATE_NETWORK );
	PyModule_AddIntConstant( module, "PJOC_SRV_UPDATE_IPPRIVATE_NETWORK", PJOC_SRV_UPDATE_IPPRIVATE_NETWORK );
	PyModule_AddIntConstant( module, "PJOC_SRV_GET_IPPRIVATE_NETWORKS_LIST", PJOC_SRV_GET_IPPRIVATE_NETWORKS_LIST );
	PyModule_AddIntConstant( module, "PJOC_VM_DEV_COPY_IMAGE", PJOC_VM_DEV_COPY_IMAGE );
	PyModule_AddIntConstant( module, "PJOC_SRV_REFRESH_PLUGINS", PJOC_SRV_REFRESH_PLUGINS );
	PyModule_AddIntConstant( module, "PJOC_VM_MOUNT", PJOC_VM_MOUNT );
	PyModule_AddIntConstant( module, "PJOC_VM_UMOUNT", PJOC_VM_UMOUNT );
	PyModule_AddIntConstant( module, "PJOC_SRV_GET_PLUGINS_LIST", PJOC_SRV_GET_PLUGINS_LIST );
	PyModule_AddIntConstant( module, "PJOC_SRV_GET_DISK_FREE_SPACE", PJOC_SRV_GET_DISK_FREE_SPACE );
	PyModule_AddIntConstant( module, "PJOC_DESKTOP_CONTROL_CONNECT", PJOC_DESKTOP_CONTROL_CONNECT );
	PyModule_AddIntConstant( module, "PJOC_VM_MOVE", PJOC_VM_MOVE );
	PyModule_AddIntConstant( module, "PJOC_SRV_GENERATE_CSR", PJOC_SRV_GENERATE_CSR );
	PyModule_AddIntConstant( module, "PJOC_SRV_SIGN_CERTIFICATION_REQUEST", PJOC_SRV_SIGN_CERTIFICATION_REQUEST );
	PyModule_AddIntConstant( module, "PJOC_SRV_GET_VM_CONFIG", PJOC_SRV_GET_VM_CONFIG );
	PyModule_AddIntConstant( module, "PJOC_PTM_RPC", PJOC_PTM_RPC );
	PyModule_AddIntConstant( module, "PJOC_API_PUT_USER_DATA", PJOC_API_PUT_USER_DATA );
	PyModule_AddIntConstant( module, "PJOC_API_GET_USER_DATA", PJOC_API_GET_USER_DATA );
	PyModule_AddIntConstant( module, "PJOC_API_GET_USER_KEYS", PJOC_API_GET_USER_KEYS );
	PyModule_AddIntConstant( module, "PJOC_API_REMOVE_USER_DATA", PJOC_API_REMOVE_USER_DATA );
	PyModule_AddIntConstant( module, "PJOC_API_PUT_ICON", PJOC_API_PUT_ICON );
	PyModule_AddIntConstant( module, "PJOC_API_VALIDATE_IN_CACHE", PJOC_API_VALIDATE_IN_CACHE );
	PyModule_AddIntConstant( module, "PJOC_SRV_UPDATE_SESSION_INFO", PJOC_SRV_UPDATE_SESSION_INFO );
	PyModule_AddIntConstant( module, "PJOC_API_SUBSCRIBE_ON_REGISTRATION", PJOC_API_SUBSCRIBE_ON_REGISTRATION );
	PyModule_AddIntConstant( module, "PJOC_SRV_SEND_PROBLEM_REPORT", PJOC_SRV_SEND_PROBLEM_REPORT );
	PyModule_AddIntConstant( module, "PJOC_VM_SEND_PROBLEM_REPORT", PJOC_VM_SEND_PROBLEM_REPORT );
	PyModule_AddIntConstant( module, "PJOC_VM_SET_PROTECTION", PJOC_VM_SET_PROTECTION );
	PyModule_AddIntConstant( module, "PJOC_VM_REMOVE_PROTECTION", PJOC_VM_REMOVE_PROTECTION );
	PyModule_AddIntConstant( module, "PJOC_SRV_CPU_POOLS_LIST_POOLS", PJOC_SRV_CPU_POOLS_LIST_POOLS );
	PyModule_AddIntConstant( module, "PJOC_SRV_CPU_POOLS_MOVE", PJOC_SRV_CPU_POOLS_MOVE );
	PyModule_AddIntConstant( module, "PJOC_SRV_CPU_POOLS_RECALCULATE", PJOC_SRV_CPU_POOLS_RECALCULATE );
	PyModule_AddIntConstant( module, "PJOC_SRV_CPU_POOLS_JOIN", PJOC_SRV_CPU_POOLS_JOIN );
	PyModule_AddIntConstant( module, "PJOC_SRV_CPU_POOLS_LEAVE", PJOC_SRV_CPU_POOLS_LEAVE );
	PyModule_AddIntConstant( module, "PDCQ_HIGH_QUALITY", PDCQ_HIGH_QUALITY );
	PyModule_AddIntConstant( module, "PDCQ_MEDIUM_QUALITY", PDCQ_MEDIUM_QUALITY );
	PyModule_AddIntConstant( module, "PDCQ_LOW_QUALITY", PDCQ_LOW_QUALITY );
	PyModule_AddIntConstant( module, "PDCC_HIGH_COMPRESSION", PDCC_HIGH_COMPRESSION );
	PyModule_AddIntConstant( module, "PDCC_MEDIUM_COMPRESSION", PDCC_MEDIUM_COMPRESSION );
	PyModule_AddIntConstant( module, "PDCC_LOW_COMPRESSION", PDCC_LOW_COMPRESSION );
	PyModule_AddIntConstant( module, "PDCC_NO_COMPRESSION", PDCC_NO_COMPRESSION );
	PyModule_AddIntConstant( module, "PDCT_HIGH_QUALITY_WITHOUT_COMPRESSION", PDCT_HIGH_QUALITY_WITHOUT_COMPRESSION );
	PyModule_AddIntConstant( module, "PDCT_HIGH_QUALITY_WITH_COMPRESSION", PDCT_HIGH_QUALITY_WITH_COMPRESSION );
	PyModule_AddIntConstant( module, "PDCT_MEDIUM_QUALITY_WITHOUT_COMPRESSION", PDCT_MEDIUM_QUALITY_WITHOUT_COMPRESSION );
	PyModule_AddIntConstant( module, "PDCT_MEDIUM_QUALITY_WITH_COMPRESSION", PDCT_MEDIUM_QUALITY_WITH_COMPRESSION );
	PyModule_AddIntConstant( module, "PDCT_LOW_QUALITY_WITHOUT_COMPRESSION", PDCT_LOW_QUALITY_WITHOUT_COMPRESSION );
	PyModule_AddIntConstant( module, "PDCT_LOW_QUALITY_WITH_COMPRESSION", PDCT_LOW_QUALITY_WITH_COMPRESSION );
	PyModule_AddIntConstant( module, "PDBF_NO_CONVERSION", PDBF_NO_CONVERSION );
	PyModule_AddIntConstant( module, "PDBF_INDEX8", PDBF_INDEX8 );
	PyModule_AddIntConstant( module, "PDBF_RGB15", PDBF_RGB15 );
	PyModule_AddIntConstant( module, "PDBF_RGB16", PDBF_RGB16 );
	PyModule_AddIntConstant( module, "PDBF_RGB24", PDBF_RGB24 );
	PyModule_AddIntConstant( module, "PDBF_BGR32", PDBF_BGR32 );
	PyModule_AddIntConstant( module, "PDBF_RGB32", PDBF_RGB32 );
	PyModule_AddIntConstant( module, "PDBF_YUV422x8", PDBF_YUV422x8 );
	PyModule_AddIntConstant( module, "PDBF_YUV422x6", PDBF_YUV422x6 );
	PyModule_AddIntConstant( module, "PDBF_YUV422x4", PDBF_YUV422x4 );
	PyModule_AddIntConstant( module, "PDBF_YUV420", PDBF_YUV420 );
	PyModule_AddIntConstant( module, "PSIA_OPEN_DEFAULT", PSIA_OPEN_DEFAULT );
	PyModule_AddIntConstant( module, "PSIA_OPEN_IN_GUEST", PSIA_OPEN_IN_GUEST );
	PyModule_AddIntConstant( module, "PSIA_OPEN_IN_HOST", PSIA_OPEN_IN_HOST );
	PyModule_AddIntConstant( module, "PAM_UNKNOWN", PAM_UNKNOWN );
	PyModule_AddIntConstant( module, "PAM_SERVER", PAM_SERVER );
	PyModule_AddIntConstant( module, "PAM_LAST", PAM_LAST );
	PyModule_AddIntConstant( module, "PUD_DISABLE_UNDO_DISKS", PUD_DISABLE_UNDO_DISKS );
	PyModule_AddIntConstant( module, "PUD_REVERSE_CHANGES", PUD_REVERSE_CHANGES );
	PyModule_AddIntConstant( module, "PUD_COMMIT_CHANGES", PUD_COMMIT_CHANGES );
	PyModule_AddIntConstant( module, "PUD_PROMPT_BEHAVIOUR", PUD_PROMPT_BEHAVIOUR );
	PyModule_AddIntConstant( module, "WINDOW_LEFT_EDGE_MASK", WINDOW_LEFT_EDGE_MASK );
	PyModule_AddIntConstant( module, "WINDOW_TOP_EDGE_MASK", WINDOW_TOP_EDGE_MASK );
	PyModule_AddIntConstant( module, "WINDOW_RIGHT_EDGE_MASK", WINDOW_RIGHT_EDGE_MASK );
	PyModule_AddIntConstant( module, "WINDOW_BOTTOM_EDGE_MASK", WINDOW_BOTTOM_EDGE_MASK );
	PyModule_AddIntConstant( module, "WINDOW_ALL_EDGE_MASK", WINDOW_ALL_EDGE_MASK );
	PyModule_AddIntConstant( module, "PPF_TCP", PPF_TCP );
	PyModule_AddIntConstant( module, "PPF_UDP", PPF_UDP );
	PyModule_AddIntConstant( module, "PGD_PCI_NETWORK", PGD_PCI_NETWORK );
	PyModule_AddIntConstant( module, "PGD_PCI_DISPLAY", PGD_PCI_DISPLAY );
	PyModule_AddIntConstant( module, "PGD_PCI_SOUND", PGD_PCI_SOUND );
	PyModule_AddIntConstant( module, "PGD_PCI_OTHER", PGD_PCI_OTHER );
	PyModule_AddIntConstant( module, "PGS_CONNECTED_TO_HOST", PGS_CONNECTED_TO_HOST );
	PyModule_AddIntConstant( module, "PGS_CONNECTED_TO_VM", PGS_CONNECTED_TO_VM );
	PyModule_AddIntConstant( module, "PGS_RESERVED", PGS_RESERVED );
	PyModule_AddIntConstant( module, "PGS_NON_CONTROLLED_USB", PGS_NON_CONTROLLED_USB );
	PyModule_AddIntConstant( module, "PGS_CONNECTING_TO_VM", PGS_CONNECTING_TO_VM );
	PyModule_AddIntConstant( module, "PRL_IOPRIO_MIN", PRL_IOPRIO_MIN );
	PyModule_AddIntConstant( module, "PRL_IOPRIO_DEFAULT", PRL_IOPRIO_DEFAULT );
	PyModule_AddIntConstant( module, "PRL_IOPRIO_MAX", PRL_IOPRIO_MAX );
	PyModule_AddIntConstant( module, "PRL_CPUUNITS_MIN", PRL_CPUUNITS_MIN );
	PyModule_AddIntConstant( module, "PRL_CPUUNITS_DEFAULT", PRL_CPUUNITS_DEFAULT );
	PyModule_AddIntConstant( module, "PRL_CPUUNITS_MAX", PRL_CPUUNITS_MAX );
	PyModule_AddIntConstant( module, "PRL_CPULIMIT_PERCENTS100", PRL_CPULIMIT_PERCENTS100 );
	PyModule_AddIntConstant( module, "PRL_CPULIMIT_MHZ", PRL_CPULIMIT_MHZ );
	PyModule_AddIntConstant( module, "PRL_CPULIMIT_PERCENTS", PRL_CPULIMIT_PERCENTS );
	PyModule_AddIntConstant( module, "PRL_CPULIMIT_PERCENTS_TO_MHZ", PRL_CPULIMIT_PERCENTS_TO_MHZ );
	PyModule_AddIntConstant( module, "PRL_VM_CPULIMIT_FULL", PRL_VM_CPULIMIT_FULL );
	PyModule_AddIntConstant( module, "PRL_VM_CPULIMIT_GUEST", PRL_VM_CPULIMIT_GUEST );
	PyModule_AddIntConstant( module, "PRL_IOLIMIT_BS", PRL_IOLIMIT_BS );
	PyModule_AddIntConstant( module, "PAI_INVALID_ADAPTER", PAI_INVALID_ADAPTER );
	PyModule_AddIntConstant( module, "PAI_GENERATE_INDEX", PAI_GENERATE_INDEX );
	PyModule_AddIntConstant( module, "PVL_UNKNOWN", PVL_UNKNOWN );
	PyModule_AddIntConstant( module, "PVL_LOCAL_FS", PVL_LOCAL_FS );
	PyModule_AddIntConstant( module, "PVL_REMOTE_FS", PVL_REMOTE_FS );
	PyModule_AddIntConstant( module, "PVL_USB_DRIVE", PVL_USB_DRIVE );
	PyModule_AddIntConstant( module, "PVL_FIREWIRE_DRIVE", PVL_FIREWIRE_DRIVE );
	PyModule_AddIntConstant( module, "PVC_COLOR_RED", PVC_COLOR_RED );
	PyModule_AddIntConstant( module, "PVC_COLOR_ORANGE", PVC_COLOR_ORANGE );
	PyModule_AddIntConstant( module, "PVC_COLOR_YELLOW", PVC_COLOR_YELLOW );
	PyModule_AddIntConstant( module, "PVC_COLOR_GREEN", PVC_COLOR_GREEN );
	PyModule_AddIntConstant( module, "PVC_COLOR_BLUE", PVC_COLOR_BLUE );
	PyModule_AddIntConstant( module, "PVC_COLOR_PURPLE", PVC_COLOR_PURPLE );
	PyModule_AddIntConstant( module, "PVC_COLOR_GREY", PVC_COLOR_GREY );
	PyModule_AddIntConstant( module, "PVC_NO_COLOR", PVC_NO_COLOR );
	PyModule_AddIntConstant( module, "PIM_IDE_0_0", PIM_IDE_0_0 );
	PyModule_AddIntConstant( module, "PIM_IDE_0_1", PIM_IDE_0_1 );
	PyModule_AddIntConstant( module, "PIM_IDE_1_0", PIM_IDE_1_0 );
	PyModule_AddIntConstant( module, "PIM_IDE_1_1", PIM_IDE_1_1 );
	PyModule_AddIntConstant( module, "PIM_SCSI_0_0", PIM_SCSI_0_0 );
	PyModule_AddIntConstant( module, "PIM_SCSI_1_0", PIM_SCSI_1_0 );
	PyModule_AddIntConstant( module, "PIM_SCSI_2_0", PIM_SCSI_2_0 );
	PyModule_AddIntConstant( module, "PIM_SCSI_3_0", PIM_SCSI_3_0 );
	PyModule_AddIntConstant( module, "PIM_SCSI_4_0", PIM_SCSI_4_0 );
	PyModule_AddIntConstant( module, "PIM_SCSI_5_0", PIM_SCSI_5_0 );
	PyModule_AddIntConstant( module, "PIM_SCSI_6_0", PIM_SCSI_6_0 );
	PyModule_AddIntConstant( module, "PIM_SCSI_7_0", PIM_SCSI_7_0 );
	PyModule_AddIntConstant( module, "PIM_SCSI_8_0", PIM_SCSI_8_0 );
	PyModule_AddIntConstant( module, "PIM_SCSI_9_0", PIM_SCSI_9_0 );
	PyModule_AddIntConstant( module, "PIM_SCSI_10_0", PIM_SCSI_10_0 );
	PyModule_AddIntConstant( module, "PIM_SCSI_11_0", PIM_SCSI_11_0 );
	PyModule_AddIntConstant( module, "PIM_SCSI_12_0", PIM_SCSI_12_0 );
	PyModule_AddIntConstant( module, "PIM_SCSI_13_0", PIM_SCSI_13_0 );
	PyModule_AddIntConstant( module, "PIM_SCSI_14_0", PIM_SCSI_14_0 );
	PyModule_AddIntConstant( module, "PIM_SCSI_15_0", PIM_SCSI_15_0 );
	PyModule_AddIntConstant( module, "PIM_SATA_0_0", PIM_SATA_0_0 );
	PyModule_AddIntConstant( module, "PIM_SATA_0_1", PIM_SATA_0_1 );
	PyModule_AddIntConstant( module, "PIM_SATA_0_2", PIM_SATA_0_2 );
	PyModule_AddIntConstant( module, "PIM_SATA_0_3", PIM_SATA_0_3 );
	PyModule_AddIntConstant( module, "PIM_SATA_0_4", PIM_SATA_0_4 );
	PyModule_AddIntConstant( module, "PIM_SATA_0_5", PIM_SATA_0_5 );
	PyModule_AddIntConstant( module, "PIM_ALL_DISKS", PIM_ALL_DISKS );
	PyModule_AddIntConstant( module, "PIM_COMPACT_DELAYED", PIM_COMPACT_DELAYED );
	PyModule_AddIntConstant( module, "PIM_IDE_MASK_OFFSET", PIM_IDE_MASK_OFFSET );
	PyModule_AddIntConstant( module, "PIM_SCSI_MASK_OFFSET", PIM_SCSI_MASK_OFFSET );
	PyModule_AddIntConstant( module, "PIM_SATA_MASK_OFFSET", PIM_SATA_MASK_OFFSET );
	PyModule_AddIntConstant( module, "PRS_OLD_XML_BASED", PRS_OLD_XML_BASED );
	PyModule_AddIntConstant( module, "PRS_NEW_PACKED", PRS_NEW_PACKED );
	PyModule_AddIntConstant( module, "PRT_REPORT_TYPE_UNDEFINED", PRT_REPORT_TYPE_UNDEFINED );
	PyModule_AddIntConstant( module, "PRT_AUTOMATIC_VM_GENERATED_REPORT", PRT_AUTOMATIC_VM_GENERATED_REPORT );
	PyModule_AddIntConstant( module, "PRT_AUTOMATIC_DISPATCHER_GENERATED_REPORT", PRT_AUTOMATIC_DISPATCHER_GENERATED_REPORT );
	PyModule_AddIntConstant( module, "PRT_USER_DEFINED_ON_STOPPED_VM_REPORT", PRT_USER_DEFINED_ON_STOPPED_VM_REPORT );
	PyModule_AddIntConstant( module, "PRT_USER_DEFINED_ON_RUNNING_VM_REPORT", PRT_USER_DEFINED_ON_RUNNING_VM_REPORT );
	PyModule_AddIntConstant( module, "PRT_USER_DEFINED_ON_CONNECTED_SERVER", PRT_USER_DEFINED_ON_CONNECTED_SERVER );
	PyModule_AddIntConstant( module, "PRT_USER_DEFINED_ON_DISCONNECTED_SERVER", PRT_USER_DEFINED_ON_DISCONNECTED_SERVER );
	PyModule_AddIntConstant( module, "PRT_USER_DEFINED_ON_NOT_RESPONDING_VM_REPORT", PRT_USER_DEFINED_ON_NOT_RESPONDING_VM_REPORT );
	PyModule_AddIntConstant( module, "PRT_AUTOMATIC_DETECTED_REPORT", PRT_AUTOMATIC_DETECTED_REPORT );
	PyModule_AddIntConstant( module, "PRT_AUTOMATIC_STATISTICS_REPORT", PRT_AUTOMATIC_STATISTICS_REPORT );
	PyModule_AddIntConstant( module, "PRT_AUTOMATIC_INSTALLED_SOFTWARE_REPORT", PRT_AUTOMATIC_INSTALLED_SOFTWARE_REPORT );
	PyModule_AddIntConstant( module, "PRT_AUTOMATIC_VZ_STATISTICS_REPORT", PRT_AUTOMATIC_VZ_STATISTICS_REPORT );
	PyModule_AddIntConstant( module, "PRT_AUTOMATIC_UTW7AGENT_PRE_MIGRATION", PRT_AUTOMATIC_UTW7AGENT_PRE_MIGRATION );
	PyModule_AddIntConstant( module, "PRT_AUTOMATIC_UTW7AGENT_POST_MIGRATION", PRT_AUTOMATIC_UTW7AGENT_POST_MIGRATION );
	PyModule_AddIntConstant( module, "PRT_AUTOMATIC_TRANSPORTER_REPORT", PRT_AUTOMATIC_TRANSPORTER_REPORT );
	PyModule_AddIntConstant( module, "PRT_USER_DEFINED_TRANSPORTER_REPORT", PRT_USER_DEFINED_TRANSPORTER_REPORT );
	PyModule_AddIntConstant( module, "PRT_AUTOMATIC_GUEST_GENERATED_REPORT", PRT_AUTOMATIC_GUEST_GENERATED_REPORT );
	PyModule_AddIntConstant( module, "PRT_USER_DEFINED_ON_CONTAINER_REPORT", PRT_USER_DEFINED_ON_CONTAINER_REPORT );
	PyModule_AddIntConstant( module, "PRT_USER_DEFINED_ON_MOBILE_REPORT", PRT_USER_DEFINED_ON_MOBILE_REPORT );
	PyModule_AddIntConstant( module, "PRT_USER_DEFINED_ON_MOBILE_FEEDBACK_REPORT", PRT_USER_DEFINED_ON_MOBILE_FEEDBACK_REPORT );
	PyModule_AddIntConstant( module, "PRT_LAST", PRT_LAST );
	PyModule_AddIntConstant( module, "PRR_UNKNOWN", PRR_UNKNOWN );
	PyModule_AddIntConstant( module, "PRR_BOOT_CAMP", PRR_BOOT_CAMP );
	PyModule_AddIntConstant( module, "PRR_HANG_LOCKUP", PRR_HANG_LOCKUP );
	PyModule_AddIntConstant( module, "PRR_KEYBOARD", PRR_KEYBOARD );
	PyModule_AddIntConstant( module, "PRR_NETWORK", PRR_NETWORK );
	PyModule_AddIntConstant( module, "PRR_PARALLELS_TOOLS", PRR_PARALLELS_TOOLS );
	PyModule_AddIntConstant( module, "PRR_PERFORMANCE", PRR_PERFORMANCE );
	PyModule_AddIntConstant( module, "PRR_PRODUCT_REGISTRATION", PRR_PRODUCT_REGISTRATION );
	PyModule_AddIntConstant( module, "PRR_SNAPSHOTS", PRR_SNAPSHOTS );
	PyModule_AddIntConstant( module, "PRR_SOUND", PRR_SOUND );
	PyModule_AddIntConstant( module, "PRR_SUPPORT_REQUEST", PRR_SUPPORT_REQUEST );
	PyModule_AddIntConstant( module, "PRR_USB", PRR_USB );
	PyModule_AddIntConstant( module, "PRR_VIDEO_3D_GRAPHICS", PRR_VIDEO_3D_GRAPHICS );
	PyModule_AddIntConstant( module, "PRR_OTHER", PRR_OTHER );
	PyModule_AddIntConstant( module, "PRR_BACKUP", PRR_BACKUP );
	PyModule_AddIntConstant( module, "PRR_MIGRATION", PRR_MIGRATION );
	PyModule_AddIntConstant( module, "PRR_CONNECTION", PRR_CONNECTION );
	PyModule_AddIntConstant( module, "PRR_LAST", PRR_LAST );
	PyModule_AddIntConstant( module, "PADS_NOT_STARTED", PADS_NOT_STARTED );
	PyModule_AddIntConstant( module, "PADS_STOPPED", PADS_STOPPED );
	PyModule_AddIntConstant( module, "PADS_DOWNLOADING", PADS_DOWNLOADING );
	PyModule_AddIntConstant( module, "PADS_DOWNLOADED", PADS_DOWNLOADED );
	PyModule_AddIntConstant( module, "PADS_UNPACKED", PADS_UNPACKED );
	PyModule_AddIntConstant( module, "PADS_MOVED", PADS_MOVED );
	PyModule_AddIntConstant( module, "PADS_REGISTERED", PADS_REGISTERED );
	PyModule_AddIntConstant( module, "PADS_CANCELED", PADS_CANCELED );
	PyModule_AddIntConstant( module, "PSM_KILL", PSM_KILL );
	PyModule_AddIntConstant( module, "PSM_SHUTDOWN", PSM_SHUTDOWN );
	PyModule_AddIntConstant( module, "PSM_ACPI", PSM_ACPI );
	PyModule_AddIntConstant( module, "PSM_LAST", PSM_LAST );
	PyModule_AddIntConstant( module, "PVSS_OPTIMIZED_FOR_TIME_MACHINE", PVSS_OPTIMIZED_FOR_TIME_MACHINE );
	PyModule_AddIntConstant( module, "PVSS_CUSTOM", PVSS_CUSTOM );
	PyModule_AddIntConstant( module, "PSCT_AUTO", PSCT_AUTO );
	PyModule_AddIntConstant( module, "PSCT_STEREO", PSCT_STEREO );
	PyModule_AddIntConstant( module, "PSCT_SURROUND_5_1", PSCT_SURROUND_5_1 );
	PyModule_AddIntConstant( module, "PNT_UNDEFINED", PNT_UNDEFINED );
	PyModule_AddIntConstant( module, "PNT_RTL", PNT_RTL );
	PyModule_AddIntConstant( module, "PNT_E1000", PNT_E1000 );
	PyModule_AddIntConstant( module, "PNT_VIRTIO", PNT_VIRTIO );
	PyModule_AddIntConstant( module, "PNT_E1000E", PNT_E1000E );
	PyModule_AddIntConstant( module, "PNWR_GENERATED_MAC", PNWR_GENERATED_MAC );
	PyModule_AddIntConstant( module, "PNWR_HOST_MAC", PNWR_HOST_MAC );
	PyModule_AddIntConstant( module, "PNWR_AUTO", PNWR_AUTO );
	PyModule_AddIntConstant( module, "PVT_VM", PVT_VM );
	PyModule_AddIntConstant( module, "PVT_CT", PVT_CT );
	PyModule_AddIntConstant( module, "PEVT_VM_UNKNOWN", PEVT_VM_UNKNOWN );
	PyModule_AddIntConstant( module, "PEVT_NATIVE_VM", PEVT_NATIVE_VM );
	PyModule_AddIntConstant( module, "PEVT_VMWARE", PEVT_VMWARE );
	PyModule_AddIntConstant( module, "PCR_KMEMSIZE", PCR_KMEMSIZE );
	PyModule_AddIntConstant( module, "PCR_LOCKEDPAGES", PCR_LOCKEDPAGES );
	PyModule_AddIntConstant( module, "PCR_PRIVVMPAGES", PCR_PRIVVMPAGES );
	PyModule_AddIntConstant( module, "PCR_SHMPAGES", PCR_SHMPAGES );
	PyModule_AddIntConstant( module, "PCR_NUMPROC", PCR_NUMPROC );
	PyModule_AddIntConstant( module, "PCR_PHYSPAGES", PCR_PHYSPAGES );
	PyModule_AddIntConstant( module, "PCR_VMGUARPAGES", PCR_VMGUARPAGES );
	PyModule_AddIntConstant( module, "PCR_OOMGUARPAGES", PCR_OOMGUARPAGES );
	PyModule_AddIntConstant( module, "PCR_NUMTCPSOCK", PCR_NUMTCPSOCK );
	PyModule_AddIntConstant( module, "PCR_NUMFLOCK", PCR_NUMFLOCK );
	PyModule_AddIntConstant( module, "PCR_NUMPTY", PCR_NUMPTY );
	PyModule_AddIntConstant( module, "PCR_NUMSIGINFO", PCR_NUMSIGINFO );
	PyModule_AddIntConstant( module, "PCR_TCPSNDBUF", PCR_TCPSNDBUF );
	PyModule_AddIntConstant( module, "PCR_TCPRCVBUF", PCR_TCPRCVBUF );
	PyModule_AddIntConstant( module, "PCR_OTHERSOCKBUF", PCR_OTHERSOCKBUF );
	PyModule_AddIntConstant( module, "PCR_DGRAMRCVBUF", PCR_DGRAMRCVBUF );
	PyModule_AddIntConstant( module, "PCR_NUMOTHERSOCK", PCR_NUMOTHERSOCK );
	PyModule_AddIntConstant( module, "PCR_DCACHESIZE", PCR_DCACHESIZE );
	PyModule_AddIntConstant( module, "PCR_NUMFILE", PCR_NUMFILE );
	PyModule_AddIntConstant( module, "PCR_NUMIPTENT", PCR_NUMIPTENT );
	PyModule_AddIntConstant( module, "PCR_SWAPPAGES", PCR_SWAPPAGES );
	PyModule_AddIntConstant( module, "PCR_QUOTAUGIDLIMIT", PCR_QUOTAUGIDLIMIT );
	PyModule_AddIntConstant( module, "PCR_LAST", PCR_LAST );
	PyModule_AddIntConstant( module, "PCT_TYPE_EZ_OS", PCT_TYPE_EZ_OS );
	PyModule_AddIntConstant( module, "PCT_TYPE_EZ_APP", PCT_TYPE_EZ_APP );
	PyModule_AddIntConstant( module, "PFSM_UNKNOWN_FEATURE", PFSM_UNKNOWN_FEATURE );
	PyModule_AddIntConstant( module, "PFSM_SATA_HOTPLUG_SUPPORT", PFSM_SATA_HOTPLUG_SUPPORT );
	PyModule_AddIntConstant( module, "PFSM_DEFAULT_SATA_ALLOWED", PFSM_DEFAULT_SATA_ALLOWED );
	PyModule_AddIntConstant( module, "PFSM_VM_CONFIG_MERGE_SUPPORT", PFSM_VM_CONFIG_MERGE_SUPPORT );
	PyModule_AddIntConstant( module, "PFSM_PSBM5", PFSM_PSBM5 );
	PyModule_AddIntConstant( module, "PFSM_AUTOSTART_VM_AS_OWNER", PFSM_AUTOSTART_VM_AS_OWNER );
	PyModule_AddIntConstant( module, "PFSM_DEFAULT_PLAINDISK_ALLOWED", PFSM_DEFAULT_PLAINDISK_ALLOWED );
	PyModule_AddIntConstant( module, "PFSM_NO_SHARED_NETWORKING", PFSM_NO_SHARED_NETWORKING );
	PyModule_AddIntConstant( module, "PFSM_DISK_IO_LIMITS", PFSM_DISK_IO_LIMITS );
	PyModule_AddIntConstant( module, "PFSM_FINE_CPU_LIMITS", PFSM_FINE_CPU_LIMITS );
	PyModule_AddIntConstant( module, "PFSM_ROUTED_NETWORKING", PFSM_ROUTED_NETWORKING );
	PyModule_AddIntConstant( module, "PFSM_RAM_HOTPLUG_SUPPORT", PFSM_RAM_HOTPLUG_SUPPORT );
	PyModule_AddIntConstant( module, "PFSM_CPU_HOTPLUG_SUPPORT", PFSM_CPU_HOTPLUG_SUPPORT );
	PyModule_AddIntConstant( module, "PFSM_IPV6_SUPPORT", PFSM_IPV6_SUPPORT );
	PyModule_AddIntConstant( module, "PFSM_USB_PRINTER_SUPPORT", PFSM_USB_PRINTER_SUPPORT );
	PyModule_AddIntConstant( module, "PFSM_NIC_CHANGE_ALLOWED", PFSM_NIC_CHANGE_ALLOWED );
	PyModule_AddIntConstant( module, "PFSM_DESKTOP_CONTROL_SUPPORT", PFSM_DESKTOP_CONTROL_SUPPORT );
	PyModule_AddIntConstant( module, "PCFE_FEATURES", PCFE_FEATURES );
	PyModule_AddIntConstant( module, "PCFE_EXT_FEATURES", PCFE_EXT_FEATURES );
	PyModule_AddIntConstant( module, "PCFE_EXT_00000007_EBX", PCFE_EXT_00000007_EBX );
	PyModule_AddIntConstant( module, "PCFE_EXT_80000001_ECX", PCFE_EXT_80000001_ECX );
	PyModule_AddIntConstant( module, "PCFE_EXT_80000001_EDX", PCFE_EXT_80000001_EDX );
	PyModule_AddIntConstant( module, "PCFE_EXT_80000007_EDX", PCFE_EXT_80000007_EDX );
	PyModule_AddIntConstant( module, "PCFE_EXT_80000008_EAX", PCFE_EXT_80000008_EAX );
	PyModule_AddIntConstant( module, "PCFE_EXT_0000000D_EAX", PCFE_EXT_0000000D_EAX );
	PyModule_AddIntConstant( module, "PCFE_MAX", PCFE_MAX );
	PyModule_AddIntConstant( module, "PFP_ACCEPT", PFP_ACCEPT );
	PyModule_AddIntConstant( module, "PFP_DENY", PFP_DENY );
	PyModule_AddIntConstant( module, "PFD_INCOMING", PFD_INCOMING );
	PyModule_AddIntConstant( module, "PFD_OUTGOING", PFD_OUTGOING );
	PyModule_AddIntConstant( module, "PVA_PRESTART", PVA_PRESTART );
	PyModule_AddIntConstant( module, "PVA_POSTSTART", PVA_POSTSTART );
	PyModule_AddIntConstant( module, "PVA_PRESTOP", PVA_PRESTOP );
	PyModule_AddIntConstant( module, "PVA_POSTSTOP", PVA_POSTSTOP );
	PyModule_AddIntConstant( module, "DMT_DISTRO", DMT_DISTRO );
	PyModule_AddIntConstant( module, "DMT_LIVE_CD", DMT_LIVE_CD );
	PyModule_AddIntConstant( module, "DMT_MBR", DMT_MBR );
	PyModule_AddIntConstant( module, "PVSC_DMAR_NOT_FOUND", PVSC_DMAR_NOT_FOUND );
	PyModule_AddIntConstant( module, "PVSC_DMAR_ERROR", PVSC_DMAR_ERROR );
	PyModule_AddIntConstant( module, "PVSC_ACPI_ERROR", PVSC_ACPI_ERROR );
	PyModule_AddIntConstant( module, "PVSC_HARDWARE_ERROR", PVSC_HARDWARE_ERROR );
	PyModule_AddIntConstant( module, "PVSC_INTERNAL_ERROR", PVSC_INTERNAL_ERROR );
	PyModule_AddIntConstant( module, "PVSC_NOT_PRESENT", PVSC_NOT_PRESENT );
	PyModule_AddIntConstant( module, "PVSC_ENABLED", PVSC_ENABLED );
	PyModule_AddIntConstant( module, "PDSS_UNKNOWN", PDSS_UNKNOWN );
	PyModule_AddIntConstant( module, "PDSS_VM_MISCELLANEOUS_SPACE", PDSS_VM_MISCELLANEOUS_SPACE );
	PyModule_AddIntConstant( module, "PDSS_VM_RECLAIM_SPACE", PDSS_VM_RECLAIM_SPACE );
	PyModule_AddIntConstant( module, "PDSS_VM_SNAPSHOTS_SPACE", PDSS_VM_SNAPSHOTS_SPACE );
	PyModule_AddIntConstant( module, "PDSS_VM_DISK_DATA_SPACE", PDSS_VM_DISK_DATA_SPACE );
	PyModule_AddIntConstant( module, "PDSS_VM_FULL_SPACE", PDSS_VM_FULL_SPACE );
	PyModule_AddIntConstant( module, "PVBT_VM", PVBT_VM );
	PyModule_AddIntConstant( module, "PVBT_CT_VZFS", PVBT_CT_VZFS );
	PyModule_AddIntConstant( module, "PVBT_CT_PLOOP", PVBT_CT_PLOOP );
	PyModule_AddIntConstant( module, "PVBT_CT_VZWIN", PVBT_CT_VZWIN );
	PyModule_AddIntConstant( module, "PCS_DISCONNECTED", PCS_DISCONNECTED );
	PyModule_AddIntConstant( module, "PCS_CONNECTED", PCS_CONNECTED );
	PyModule_AddIntConstant( module, "PCS_CONNECTING", PCS_CONNECTING );
	PyModule_AddIntConstant( module, "PCD_BUSLOGIC", PCD_BUSLOGIC );
	PyModule_AddIntConstant( module, "PCD_LSI_SPI", PCD_LSI_SPI );
	PyModule_AddIntConstant( module, "PCD_LSI_SAS", PCD_LSI_SAS );
	PyModule_AddIntConstant( module, "PCD_VIRTIO_SCSI", PCD_VIRTIO_SCSI );
	PyModule_AddIntConstant( module, "PCD_UNKNOWN_DEVICE", PCD_UNKNOWN_DEVICE );
	PyModule_AddIntConstant( module, "PBT_LEGACY", PBT_LEGACY );
	PyModule_AddIntConstant( module, "PBT_EFI", PBT_EFI );
	PyModule_AddIntConstant( module, "P3D_DISABLED", P3D_DISABLED );
	PyModule_AddIntConstant( module, "P3D_ENABLED_HIGHEST", P3D_ENABLED_HIGHEST );
	PyModule_AddIntConstant( module, "P3D_ENABLED_DX9", P3D_ENABLED_DX9 );
	PyModule_AddIntConstant( module, "PDCM_CLIENT_DISPLAY_INFO", PDCM_CLIENT_DISPLAY_INFO );
	PyModule_AddIntConstant( module, "PDCM_HAS_HIDPI_DISPLAY", PDCM_HAS_HIDPI_DISPLAY );
	PyModule_AddIntConstant( module, "PDCM_DO_NOT_RESTORE", PDCM_DO_NOT_RESTORE );
	PyModule_AddIntConstant( module, "PDCM_RESTORE_DEFAULT", PDCM_RESTORE_DEFAULT );
	PyModule_AddIntConstant( module, "PDCM_DISABLE_HIDPI_ADJUSTMENT", PDCM_DISABLE_HIDPI_ADJUSTMENT );
	PyModule_AddIntConstant( module, "PDCM_RETINA_MODE", PDCM_RETINA_MODE );
	PyModule_AddIntConstant( module, "PDCM_ENABLE_HEADS", PDCM_ENABLE_HEADS );
	PyModule_AddIntConstant( module, "PTBS_UNKNOWN", PTBS_UNKNOWN );
	PyModule_AddIntConstant( module, "PTBS_HIDE", PTBS_HIDE );
	PyModule_AddIntConstant( module, "PTBS_SHOW", PTBS_SHOW );
	PyModule_AddIntConstant( module, "PTBS_DEFAULT", PTBS_DEFAULT );
	PyModule_AddIntConstant( module, "PRL_UIEMU_ELEMENT_SEARCH_AREA_WINDOW", PRL_UIEMU_ELEMENT_SEARCH_AREA_WINDOW );
	PyModule_AddIntConstant( module, "PRL_UIEMU_ELEMENT_SEARCH_AREA_GLOBAL", PRL_UIEMU_ELEMENT_SEARCH_AREA_GLOBAL );
	PyModule_AddIntConstant( module, "PCC_CHOWN", PCC_CHOWN );
	PyModule_AddIntConstant( module, "PCC_FS_MASK", PCC_FS_MASK );
	PyModule_AddIntConstant( module, "PCC_DAC_OVERRIDE", PCC_DAC_OVERRIDE );
	PyModule_AddIntConstant( module, "PCC_DAC_READ_SEARCH", PCC_DAC_READ_SEARCH );
	PyModule_AddIntConstant( module, "PCC_FOWNER", PCC_FOWNER );
	PyModule_AddIntConstant( module, "PCC_FSETID", PCC_FSETID );
	PyModule_AddIntConstant( module, "PCC_KILL", PCC_KILL );
	PyModule_AddIntConstant( module, "PCC_SETGID", PCC_SETGID );
	PyModule_AddIntConstant( module, "PCC_SETUID", PCC_SETUID );
	PyModule_AddIntConstant( module, "PCC_SETPCAP", PCC_SETPCAP );
	PyModule_AddIntConstant( module, "PCC_LINUX_IMMUTABLE", PCC_LINUX_IMMUTABLE );
	PyModule_AddIntConstant( module, "PCC_NET_BIND_SERVICE", PCC_NET_BIND_SERVICE );
	PyModule_AddIntConstant( module, "PCC_NET_BROADCAST", PCC_NET_BROADCAST );
	PyModule_AddIntConstant( module, "PCC_NET_ADMIN", PCC_NET_ADMIN );
	PyModule_AddIntConstant( module, "PCC_NET_RAW", PCC_NET_RAW );
	PyModule_AddIntConstant( module, "PCC_IPC_LOCK", PCC_IPC_LOCK );
	PyModule_AddIntConstant( module, "PCC_IPC_OWNER", PCC_IPC_OWNER );
	PyModule_AddIntConstant( module, "PCC_SYS_MODULE", PCC_SYS_MODULE );
	PyModule_AddIntConstant( module, "PCC_SYS_RAWIO", PCC_SYS_RAWIO );
	PyModule_AddIntConstant( module, "PCC_SYS_CHROOT", PCC_SYS_CHROOT );
	PyModule_AddIntConstant( module, "PCC_SYS_PTRACE", PCC_SYS_PTRACE );
	PyModule_AddIntConstant( module, "PCC_SYS_PACCT", PCC_SYS_PACCT );
	PyModule_AddIntConstant( module, "PCC_SYS_ADMIN", PCC_SYS_ADMIN );
	PyModule_AddIntConstant( module, "PCC_SYS_BOOT", PCC_SYS_BOOT );
	PyModule_AddIntConstant( module, "PCC_SYS_NICE", PCC_SYS_NICE );
	PyModule_AddIntConstant( module, "PCC_SYS_RESOURCE", PCC_SYS_RESOURCE );
	PyModule_AddIntConstant( module, "PCC_SYS_TIME", PCC_SYS_TIME );
	PyModule_AddIntConstant( module, "PCC_SYS_TTY_CONFIG", PCC_SYS_TTY_CONFIG );
	PyModule_AddIntConstant( module, "PCC_MKNOD", PCC_MKNOD );
	PyModule_AddIntConstant( module, "PCC_LEASE", PCC_LEASE );
	PyModule_AddIntConstant( module, "PCC_AUDIT_WRITE", PCC_AUDIT_WRITE );
	PyModule_AddIntConstant( module, "PCC_VE_ADMIN", PCC_VE_ADMIN );
	PyModule_AddIntConstant( module, "PCC_SETFCAP", PCC_SETFCAP );
	PyModule_AddIntConstant( module, "PCNM_NOT_SET", PCNM_NOT_SET );
	PyModule_AddIntConstant( module, "PCNM_DISABLED", PCNM_DISABLED );
	PyModule_AddIntConstant( module, "PCNM_STATELESS", PCNM_STATELESS );
	PyModule_AddIntConstant( module, "PCNM_STATEFUL", PCNM_STATEFUL );
	PyModule_AddIntConstant( module, "PCNM_FULL", PCNM_FULL );
	PyModule_AddIntConstant( module, "PCF_FEATURE_SYSFS", PCF_FEATURE_SYSFS );
	PyModule_AddIntConstant( module, "PCF_FEATURE_NFS", PCF_FEATURE_NFS );
	PyModule_AddIntConstant( module, "PCF_FEATURE_DEF_PERM", PCF_FEATURE_DEF_PERM );
	PyModule_AddIntConstant( module, "PCF_FEATURE_SIT", PCF_FEATURE_SIT );
	PyModule_AddIntConstant( module, "PCF_FEATURE_IPIP", PCF_FEATURE_IPIP );
	PyModule_AddIntConstant( module, "PCF_FEATURE_PPP", PCF_FEATURE_PPP );
	PyModule_AddIntConstant( module, "PCF_FEATURE_IPGRE", PCF_FEATURE_IPGRE );
	PyModule_AddIntConstant( module, "PCF_FEATURE_BRIDGE", PCF_FEATURE_BRIDGE );
	PyModule_AddIntConstant( module, "PCF_FEATURE_NFSD", PCF_FEATURE_NFSD );
	PyModule_AddIntConstant( module, "PMAA_NO_ADVANCED_AUTH_NEEDED", PMAA_NO_ADVANCED_AUTH_NEEDED );
	PyModule_AddIntConstant( module, "PMAA_USE_SYSTEM_CREDENTIALS", PMAA_USE_SYSTEM_CREDENTIALS );
	PyModule_AddIntConstant( module, "POD_STANDARD", POD_STANDARD );
	PyModule_AddIntConstant( module, "POD_OPTIMIZE_FOR_GAMES", POD_OPTIMIZE_FOR_GAMES );
	PyModule_AddIntConstant( module, "POD_OPTIMIZE_FOR_ACCESSIBILITY", POD_OPTIMIZE_FOR_ACCESSIBILITY );
	PyModule_AddIntConstant( module, "PDR_UNSPECIFIED", PDR_UNSPECIFIED );
	PyModule_AddIntConstant( module, "PDR_RECONNECT", PDR_RECONNECT );
	PyModule_AddIntConstant( module, "PDR_HOST_USER_LOGGED_IN", PDR_HOST_USER_LOGGED_IN );
	PyModule_AddIntConstant( module, "PDR_HOST_USER_INPUT_DETECTED", PDR_HOST_USER_INPUT_DETECTED );
	PyModule_AddIntConstant( module, "PDR_ANOTHER_CLIENT_CONNECTED", PDR_ANOTHER_CLIENT_CONNECTED );
	PyModule_AddIntConstant( module, "PDR_SESSION_BECOME_INACTIVE", PDR_SESSION_BECOME_INACTIVE );
	PyModule_AddIntConstant( module, "PVRCS_CONNECTED", PVRCS_CONNECTED );
	PyModule_AddIntConstant( module, "PVRCS_DISCONNECTED", PVRCS_DISCONNECTED );
	PyModule_AddIntConstant( module, "PVRCS_NO_CONNECTION", PVRCS_NO_CONNECTION );
	PyModule_AddIntConstant( module, "PVRCS_CONNECTING", PVRCS_CONNECTING );
	PyModule_AddIntConstant( module, "VMP_PRODUCTIVITY", VMP_PRODUCTIVITY );
	PyModule_AddIntConstant( module, "VMP_GAMES", VMP_GAMES );
	PyModule_AddIntConstant( module, "VMP_SOFTWARE_DEVELOPER", VMP_SOFTWARE_DEVELOPER );
	PyModule_AddIntConstant( module, "VMP_DESIGNER", VMP_DESIGNER );
	PyModule_AddIntConstant( module, "TEV_DATA_RECEIVED", TEV_DATA_RECEIVED );
	PyModule_AddIntConstant( module, "TEV_CONNECTED", TEV_CONNECTED );
	PyModule_AddIntConstant( module, "TEV_DISCONNECTED", TEV_DISCONNECTED );
	PyModule_AddIntConstant( module, "POCM_DISABLED", POCM_DISABLED );
	PyModule_AddIntConstant( module, "POCM_ENABLED", POCM_ENABLED );
	PyModule_AddIntConstant( module, "POCM_AUTO", POCM_AUTO );
	PyModule_AddIntConstant( module, "NRM_DISABLED", NRM_DISABLED );
	PyModule_AddIntConstant( module, "NRM_ENABLED", NRM_ENABLED );
	PyModule_AddIntConstant( module, "PRL_MEMGUARANTEE_AUTO", PRL_MEMGUARANTEE_AUTO );
	PyModule_AddIntConstant( module, "PRL_MEMGUARANTEE_PERCENTS", PRL_MEMGUARANTEE_PERCENTS );
	PyModule_AddIntConstant( module, "PSL_LOW_SECURITY", PSL_LOW_SECURITY );
	PyModule_AddIntConstant( module, "PSL_NORMAL_SECURITY", PSL_NORMAL_SECURITY );
	PyModule_AddIntConstant( module, "PSL_HIGH_SECURITY", PSL_HIGH_SECURITY );
	PyModule_AddIntConstant( module, "PACF_NORMAL_SECURITY", PACF_NORMAL_SECURITY );
	PyModule_AddIntConstant( module, "PACF_HIGH_SECURITY", PACF_HIGH_SECURITY );
	PyModule_AddIntConstant( module, "PACF_NON_INTERACTIVE_MODE", PACF_NON_INTERACTIVE_MODE );
	PyModule_AddIntConstant( module, "PACF_CANCEL_TASK_ON_END_SESSION", PACF_CANCEL_TASK_ON_END_SESSION );
	PyModule_AddIntConstant( module, "PACF_MAX", PACF_MAX );
	PyModule_AddIntConstant( module, "PACF_LAST", PACF_LAST );
	PyModule_AddIntConstant( module, "PRVF_REGENERATE_VM_UUID", PRVF_REGENERATE_VM_UUID );
	PyModule_AddIntConstant( module, "PRVF_KEEP_OTHERS_PERMISSIONS", PRVF_KEEP_OTHERS_PERMISSIONS );
	PyModule_AddIntConstant( module, "PRCF_FORCE", PRCF_FORCE );
	PyModule_AddIntConstant( module, "PRVF_REGENERATE_SRC_VM_UUID", PRVF_REGENERATE_SRC_VM_UUID );
	PyModule_AddIntConstant( module, "PRVF_IGNORE_HA_CLUSTER", PRVF_IGNORE_HA_CLUSTER );
	PyModule_AddIntConstant( module, "PRCF_UNREG_PRESERVE", PRCF_UNREG_PRESERVE );
	PyModule_AddIntConstant( module, "PCVF_CLONE_TO_TEMPLATE", PCVF_CLONE_TO_TEMPLATE );
	PyModule_AddIntConstant( module, "PCVF_CHANGE_SID", PCVF_CHANGE_SID );
	PyModule_AddIntConstant( module, "PCVF_LINKED_CLONE", PCVF_LINKED_CLONE );
	PyModule_AddIntConstant( module, "PCVF_IMPORT_BOOT_CAMP", PCVF_IMPORT_BOOT_CAMP );
	PyModule_AddIntConstant( module, "PCVF_DETACH_EXTERNAL_VIRTUAL_HDD", PCVF_DETACH_EXTERNAL_VIRTUAL_HDD );
	PyModule_AddIntConstant( module, "PR3F_ALLOW_UNKNOWN_OS", PR3F_ALLOW_UNKNOWN_OS );
	PyModule_AddIntConstant( module, "PR3F_CREATE_SHADOW_VM", PR3F_CREATE_SHADOW_VM );
	PyModule_AddIntConstant( module, "PRIF_RESIZE_LAST_PARTITION", PRIF_RESIZE_LAST_PARTITION );
	PyModule_AddIntConstant( module, "PRIF_DISK_INFO", PRIF_DISK_INFO );
	PyModule_AddIntConstant( module, "PRIF_RESIZE_OFFLINE", PRIF_RESIZE_OFFLINE );
	PyModule_AddIntConstant( module, "PVMSL_LOW_SECURITY", PVMSL_LOW_SECURITY );
	PyModule_AddIntConstant( module, "PVMSL_NORMAL_SECURITY", PVMSL_NORMAL_SECURITY );
	PyModule_AddIntConstant( module, "PVMSL_HIGH_SECURITY", PVMSL_HIGH_SECURITY );
	PyModule_AddIntConstant( module, "PVMT_COLD_MIGRATION", PVMT_COLD_MIGRATION );
	PyModule_AddIntConstant( module, "PVMT_WARM_MIGRATION", PVMT_WARM_MIGRATION );
	PyModule_AddIntConstant( module, "PVMT_HOT_MIGRATION", PVMT_HOT_MIGRATION );
	PyModule_AddIntConstant( module, "PVM_DONT_RESUME_VM", PVM_DONT_RESUME_VM );
	PyModule_AddIntConstant( module, "PVMT_DONT_RESUME_VM", PVMT_DONT_RESUME_VM );
	PyModule_AddIntConstant( module, "PVMT_CLONE_MODE", PVMT_CLONE_MODE );
	PyModule_AddIntConstant( module, "PVMT_SWITCH_TEMPLATE", PVMT_SWITCH_TEMPLATE );
	PyModule_AddIntConstant( module, "PVMT_CHANGE_SID", PVMT_CHANGE_SID );
	PyModule_AddIntConstant( module, "PVMT_IGNORE_EXISTING_BUNDLE", PVMT_IGNORE_EXISTING_BUNDLE );
	PyModule_AddIntConstant( module, "PVMT_REMOVE_SOURCE_BUNDLE", PVMT_REMOVE_SOURCE_BUNDLE );
	PyModule_AddIntConstant( module, "PVMT_SEND_DISK_MAP", PVMT_SEND_DISK_MAP );
	PyModule_AddIntConstant( module, "PVMT_UNCOMPRESSED", PVMT_UNCOMPRESSED );
	PyModule_AddIntConstant( module, "PVMT_DIRECT_DATA_CONNECTION", PVMT_DIRECT_DATA_CONNECTION );
	PyModule_AddIntConstant( module, "PBSL_LOW_SECURITY", PBSL_LOW_SECURITY );
	PyModule_AddIntConstant( module, "PBSL_NORMAL_SECURITY", PBSL_NORMAL_SECURITY );
	PyModule_AddIntConstant( module, "PBSL_HIGH_SECURITY", PBSL_HIGH_SECURITY );
	PyModule_AddIntConstant( module, "PBT_FULL", PBT_FULL );
	PyModule_AddIntConstant( module, "PBT_INCREMENTAL", PBT_INCREMENTAL );
	PyModule_AddIntConstant( module, "PBT_DIFFERENTIAL", PBT_DIFFERENTIAL );
	PyModule_AddIntConstant( module, "PBT_RESTORE_TO_COPY", PBT_RESTORE_TO_COPY );
	PyModule_AddIntConstant( module, "PBT_IGNORE_NOT_EXISTS", PBT_IGNORE_NOT_EXISTS );
	PyModule_AddIntConstant( module, "PBT_UNCOMPRESSED", PBT_UNCOMPRESSED );
	PyModule_AddIntConstant( module, "PBT_VM", PBT_VM );
	PyModule_AddIntConstant( module, "PBT_CT", PBT_CT );
	PyModule_AddIntConstant( module, "PBT_BACKUP_ID", PBT_BACKUP_ID );
	PyModule_AddIntConstant( module, "PBT_CHAIN", PBT_CHAIN );
	PyModule_AddIntConstant( module, "PBT_KEEP_CHAIN", PBT_KEEP_CHAIN );
	PyModule_AddIntConstant( module, "PFD_STDOUT", PFD_STDOUT );
	PyModule_AddIntConstant( module, "PFD_STDERR", PFD_STDERR );
	PyModule_AddIntConstant( module, "PFD_STDIN", PFD_STDIN );
	PyModule_AddIntConstant( module, "PFD_ALL", PFD_ALL );
	PyModule_AddIntConstant( module, "PRPM_RUN_PROGRAM_AND_RETURN_IMMEDIATELY", PRPM_RUN_PROGRAM_AND_RETURN_IMMEDIATELY );
	PyModule_AddIntConstant( module, "PRPM_RUN_PROGRAM_IN_SHELL", PRPM_RUN_PROGRAM_IN_SHELL );
	PyModule_AddIntConstant( module, "PRPM_RUN_PROGRAM_ENTER", PRPM_RUN_PROGRAM_ENTER );
	PyModule_AddIntConstant( module, "PSM_VM_START", PSM_VM_START );
	PyModule_AddIntConstant( module, "PSM_VM_SAFE_START", PSM_VM_SAFE_START );
	PyModule_AddIntConstant( module, "PSM_VM_START_FOR_COMPACT", PSM_VM_START_FOR_COMPACT );
	PyModule_AddIntConstant( module, "PSM_VM_START_LAST_ITEM", PSM_VM_START_LAST_ITEM );
	PyModule_AddIntConstant( module, "PNSF_VM_START_WAIT", PNSF_VM_START_WAIT );
	PyModule_AddIntConstant( module, "PNSF_CT_SKIP_ARPDETECT", PNSF_CT_SKIP_ARPDETECT );
	PyModule_AddIntConstant( module, "PCM_COMPACT_WITH_HARD_DISKS_INFO", PCM_COMPACT_WITH_HARD_DISKS_INFO );
	PyModule_AddIntConstant( module, "PCM_HARD_DISKS_INFO", PCM_HARD_DISKS_INFO );
	PyModule_AddIntConstant( module, "PCM_FULL_CLEAN_UP_VM", PCM_FULL_CLEAN_UP_VM );
	PyModule_AddIntConstant( module, "PTU_FLG_ZERO", PTU_FLG_ZERO );
	PyModule_AddIntConstant( module, "PPRF_ADD_CLIENT_PART", PPRF_ADD_CLIENT_PART );
	PyModule_AddIntConstant( module, "PPRF_ADD_SERVER_PART", PPRF_ADD_SERVER_PART );
	PyModule_AddIntConstant( module, "PPRF_DO_NOT_CREATE_HOST_SCREENSHOT", PPRF_DO_NOT_CREATE_HOST_SCREENSHOT );
	PyModule_AddIntConstant( module, "PAIF_USE_GRAPHIC_MODE", PAIF_USE_GRAPHIC_MODE );
	PyModule_AddIntConstant( module, "PAIF_INIT_AS_APPSTORE_CLIENT", PAIF_INIT_AS_APPSTORE_CLIENT );
	PyModule_AddIntConstant( module, "PSF_FORCE", PSF_FORCE );
	PyModule_AddIntConstant( module, "PSF_NOFORCE", PSF_NOFORCE );
	PyModule_AddIntConstant( module, "PIAF_CANCEL", PIAF_CANCEL );
	PyModule_AddIntConstant( module, "PIAF_FORCE", PIAF_FORCE );
	PyModule_AddIntConstant( module, "PIAF_STOP", PIAF_STOP );
	PyModule_AddIntConstant( module, "PCVD_CANCEL", PCVD_CANCEL );
	PyModule_AddIntConstant( module, "PCVD_TO_PLAIN_DISK", PCVD_TO_PLAIN_DISK );
	PyModule_AddIntConstant( module, "PCVD_TO_EXPANDING_DISK", PCVD_TO_EXPANDING_DISK );
	PyModule_AddIntConstant( module, "PCVD_TO_SPLIT_DISK", PCVD_TO_SPLIT_DISK );
	PyModule_AddIntConstant( module, "PCVD_TO_NON_SPLIT_DISK", PCVD_TO_NON_SPLIT_DISK );
	PyModule_AddIntConstant( module, "PCVD_MERGE_ALL_SNAPSHOTS", PCVD_MERGE_ALL_SNAPSHOTS );
	PyModule_AddIntConstant( module, "PCF_ORIGINAL_CLIENT", PCF_ORIGINAL_CLIENT );
	PyModule_AddIntConstant( module, "PCF_LIGHTWEIGHT_CLIENT", PCF_LIGHTWEIGHT_CLIENT );
	PyModule_AddIntConstant( module, "PCF_TRUSTED_CHANNEL", PCF_TRUSTED_CHANNEL );
	PyModule_AddIntConstant( module, "PSV_CALC_BOOT_CAMP_SIZE", PSV_CALC_BOOT_CAMP_SIZE );
	PyModule_AddIntConstant( module, "PISCSI_STORAGE_CREATE", PISCSI_STORAGE_CREATE );
	PyModule_AddIntConstant( module, "PISCSI_STORAGE_REMOVE", PISCSI_STORAGE_REMOVE );
	PyModule_AddIntConstant( module, "PISCSI_STORAGE_MOUNT_RDONLY", PISCSI_STORAGE_MOUNT_RDONLY );
	PyModule_AddIntConstant( module, "PISCSI_STORAGE_REMOUNT", PISCSI_STORAGE_REMOUNT );
	PyModule_AddIntConstant( module, "PISCSI_STORAGE_MOUNT", PISCSI_STORAGE_MOUNT );
	PyModule_AddIntConstant( module, "PISCSI_STORAGE_EXT3", PISCSI_STORAGE_EXT3 );
	PyModule_AddIntConstant( module, "PISCSI_STORAGE_EXT4", PISCSI_STORAGE_EXT4 );
	PyModule_AddIntConstant( module, "PISCSI_STORAGE_NTFS", PISCSI_STORAGE_NTFS );
	PyModule_AddIntConstant( module, "PVTF_VM", PVTF_VM );
	PyModule_AddIntConstant( module, "PVTF_CT", PVTF_CT );
	PyModule_AddIntConstant( module, "PGST_FULL_SIZE_SCREENSHOTS", PGST_FULL_SIZE_SCREENSHOTS );
	PyModule_AddIntConstant( module, "PGST_WITHOUT_SCREENSHOTS", PGST_WITHOUT_SCREENSHOTS );
	PyModule_AddIntConstant( module, "PCSF_DISK_ONLY", PCSF_DISK_ONLY );
	PyModule_AddIntConstant( module, "PCSF_BACKUP", PCSF_BACKUP );
	PyModule_AddIntConstant( module, "PSSF_SKIP_RESUME", PSSF_SKIP_RESUME );
	PyModule_AddIntConstant( module, "PDSF_SKIP_SPACE_CHECK", PDSF_SKIP_SPACE_CHECK );
	PyModule_AddIntConstant( module, "PDSF_BACKUP", PDSF_BACKUP );
	PyModule_AddIntConstant( module, "PDSF_BACKUP_MAP", PDSF_BACKUP_MAP );
	PyModule_AddIntConstant( module, "PCTMP_LOW_SECURITY", PCTMP_LOW_SECURITY );
	PyModule_AddIntConstant( module, "PCTMP_NORMAL_SECURITY", PCTMP_NORMAL_SECURITY );
	PyModule_AddIntConstant( module, "PCTMP_HIGH_SECURITY", PCTMP_HIGH_SECURITY );
	PyModule_AddIntConstant( module, "PCTMPL_FORCE", PCTMPL_FORCE );
	PyModule_AddIntConstant( module, "PVCF_DESTROY_HDD_BUNDLE", PVCF_DESTROY_HDD_BUNDLE );
	PyModule_AddIntConstant( module, "PVCF_WAIT_FOR_APPLY", PVCF_WAIT_FOR_APPLY );
	PyModule_AddIntConstant( module, "PEVF_WAIT_FOR_APPLY", PEVF_WAIT_FOR_APPLY );
	PyModule_AddIntConstant( module, "PVCF_DESTROY_HDD_BUNDLE_FORCE", PVCF_DESTROY_HDD_BUNDLE_FORCE );
	PyModule_AddIntConstant( module, "PVCF_DETACH_HDD_BUNDLE", PVCF_DETACH_HDD_BUNDLE );
	PyModule_AddIntConstant( module, "PVCF_RENAME_EXT_DISKS", PVCF_RENAME_EXT_DISKS );
	PyModule_AddIntConstant( module, "PMVD_READ_ONLY", PMVD_READ_ONLY );
	PyModule_AddIntConstant( module, "PMVD_READ_WRITE", PMVD_READ_WRITE );
	PyModule_AddIntConstant( module, "PMVD_INFO", PMVD_INFO );
	PyModule_AddIntConstant( module, "PCDIF_CREATE_FROM_LION_RECOVERY_PARTITION", PCDIF_CREATE_FROM_LION_RECOVERY_PARTITION );
	PyModule_AddIntConstant( module, "PRNVM_CREATE_FROM_LION_RECOVERY_PARTITION", PRNVM_CREATE_FROM_LION_RECOVERY_PARTITION );
	PyModule_AddIntConstant( module, "PRNVM_ALLOW_TO_AUTO_DECREASE_HDD_SIZE", PRNVM_ALLOW_TO_AUTO_DECREASE_HDD_SIZE );
	PyModule_AddIntConstant( module, "PRNVM_PRESERVE_DISK", PRNVM_PRESERVE_DISK );
	PyModule_AddIntConstant( module, "PGVLF_GET_ONLY_VM", PGVLF_GET_ONLY_VM );
	PyModule_AddIntConstant( module, "PGVLF_GET_ONLY_CT", PGVLF_GET_ONLY_CT );
	PyModule_AddIntConstant( module, "PGVLF_GET_ONLY_IDENTITY_INFO", PGVLF_GET_ONLY_IDENTITY_INFO );
	PyModule_AddIntConstant( module, "PGVLF_GET_STATE_INFO", PGVLF_GET_STATE_INFO );
	PyModule_AddIntConstant( module, "PGVLF_FILL_AUTOGENERATED", PGVLF_FILL_AUTOGENERATED );
	PyModule_AddIntConstant( module, "PGVLF_GET_ONLY_VM_TEMPLATES", PGVLF_GET_ONLY_VM_TEMPLATES );
	PyModule_AddIntConstant( module, "PGVC_SEARCH_BY_UUID", PGVC_SEARCH_BY_UUID );
	PyModule_AddIntConstant( module, "PGVC_SEARCH_BY_NAME", PGVC_SEARCH_BY_NAME );
	PyModule_AddIntConstant( module, "PGVC_FILL_AUTOGENERATED", PGVC_FILL_AUTOGENERATED );
	PyModule_AddIntConstant( module, "PUPLF_KICK_TO_UDPATE_CURR_FILE_LICENSE", PUPLF_KICK_TO_UDPATE_CURR_FILE_LICENSE );
	PyModule_AddIntConstant( module, "PUPLF_ACTIVATE_PERMANENT_LICENSE_ONLINE", PUPLF_ACTIVATE_PERMANENT_LICENSE_ONLINE );
	PyModule_AddIntConstant( module, "PUPLF_ACTIVATE_PERMANENT_LICENSE_OFFLINE", PUPLF_ACTIVATE_PERMANENT_LICENSE_OFFLINE );
	PyModule_AddIntConstant( module, "PUPLF_CHECK_KEY_ONLY", PUPLF_CHECK_KEY_ONLY );
	PyModule_AddIntConstant( module, "PUPLF_DEACTIVATE_CURRENT_LICENSE", PUPLF_DEACTIVATE_CURRENT_LICENSE );
	PyModule_AddIntConstant( module, "PUPLF_ACTIVATE_PRECACHED_KEY", PUPLF_ACTIVATE_PRECACHED_KEY );
	PyModule_AddIntConstant( module, "PUPLF_STORE_PRECACHED_KEY", PUPLF_STORE_PRECACHED_KEY );
	PyModule_AddIntConstant( module, "PUPLF_REMOVE_PRECACHED_KEY", PUPLF_REMOVE_PRECACHED_KEY );
	PyModule_AddIntConstant( module, "PUPLF_DEACTIVATE_CURRENT_LICENSE_OFFLINE_ALLOWED", PUPLF_DEACTIVATE_CURRENT_LICENSE_OFFLINE_ALLOWED );
	PyModule_AddIntConstant( module, "PUPLF_CHECK_KEY_ONLY_VOLUME", PUPLF_CHECK_KEY_ONLY_VOLUME );
	PyModule_AddIntConstant( module, "PUPLF_REGISTER_CURRENT_LICENSE", PUPLF_REGISTER_CURRENT_LICENSE );
	PyModule_AddIntConstant( module, "PSHF_FORCE_SHUTDOWN", PSHF_FORCE_SHUTDOWN );
	PyModule_AddIntConstant( module, "PSHF_DONT_WAIT_TO_COMPLETE", PSHF_DONT_WAIT_TO_COMPLETE );
	PyModule_AddIntConstant( module, "PSHF_SUSPEND_VM_TO_PRAM", PSHF_SUSPEND_VM_TO_PRAM );
	PyModule_AddIntConstant( module, "PSPF_PASSWD_CRYPTED", PSPF_PASSWD_CRYPTED );
	PyModule_AddIntConstant( module, "PVMSF_HOST_DISK_SPACE_USAGE_ONLY", PVMSF_HOST_DISK_SPACE_USAGE_ONLY );
	PyModule_AddIntConstant( module, "PVMSF_GUEST_OS_INFORMATION_ONLY", PVMSF_GUEST_OS_INFORMATION_ONLY );
	PyModule_AddIntConstant( module, "PLLF_LOGIN_WITH_DELAYED_CONNECTION", PLLF_LOGIN_WITH_DELAYED_CONNECTION );
	PyModule_AddIntConstant( module, "PRL_USE_VNET_NAME_FOR_BRIDGE_NAME", PRL_USE_VNET_NAME_FOR_BRIDGE_NAME );
	PyModule_AddIntConstant( module, "PBMBF_CREATE_MAP", PBMBF_CREATE_MAP );
	PyModule_AddIntConstant( module, "PEMBF_FAILURE_CLEANUP", PEMBF_FAILURE_CLEANUP );
	PyModule_AddIntConstant( module, "PET_VM_INF_UNINITIALIZED_EVENT_CODE", PET_VM_INF_UNINITIALIZED_EVENT_CODE );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_VM_STATE_CHANGED", PET_DSP_EVT_VM_STATE_CHANGED );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_VM_CONFIG_CHANGED", PET_DSP_EVT_VM_CONFIG_CHANGED );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_VM_DEV_STATE_CHANGED", PET_DSP_EVT_VM_DEV_STATE_CHANGED );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_VM_CREATED", PET_DSP_EVT_VM_CREATED );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_VM_ADDED", PET_DSP_EVT_VM_ADDED );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_VM_DELETED", PET_DSP_EVT_VM_DELETED );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_VM_STARTED", PET_DSP_EVT_VM_STARTED );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_VM_STOPPED", PET_DSP_EVT_VM_STOPPED );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_VM_ABORTED", PET_DSP_EVT_VM_ABORTED );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_VM_RESETED", PET_DSP_EVT_VM_RESETED );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_VM_SUSPENDING", PET_DSP_EVT_VM_SUSPENDING );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_VM_SUSPENDED", PET_DSP_EVT_VM_SUSPENDED );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_VM_RESUMING", PET_DSP_EVT_VM_RESUMING );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_VM_RESUMED", PET_DSP_EVT_VM_RESUMED );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_VM_START_IO_FLOW", PET_DSP_EVT_VM_START_IO_FLOW );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_VM_SNAPSHOTED", PET_DSP_EVT_VM_SNAPSHOTED );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_VM_STATESAVED", PET_DSP_EVT_VM_STATESAVED );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_VM_RESTORED", PET_DSP_EVT_VM_RESTORED );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_VM_STATERESTORED", PET_DSP_EVT_VM_STATERESTORED );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_VM_NET_RECONNECTED", PET_DSP_EVT_VM_NET_RECONNECTED );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_VM_PAUSED", PET_DSP_EVT_VM_PAUSED );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_VM_CONTINUED", PET_DSP_EVT_VM_CONTINUED );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_VM_CONFIG_APPLIED", PET_DSP_EVT_VM_CONFIG_APPLIED );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_VM_STATISTICS_UPDATED", PET_DSP_EVT_VM_STATISTICS_UPDATED );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_VM_PROBLEM_REPORT_CREATED", PET_DSP_EVT_VM_PROBLEM_REPORT_CREATED );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_VM_ABOUT_TO_RESET", PET_DSP_EVT_VM_ABOUT_TO_RESET );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_VM_SECURITY_CHANGED", PET_DSP_EVT_VM_SECURITY_CHANGED );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_VM_UNREGISTERED", PET_DSP_EVT_VM_UNREGISTERED );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_VM_REMOTE_DEV_READY_TO_START", PET_DSP_EVT_VM_REMOTE_DEV_READY_TO_START );
	PyModule_AddIntConstant( module, "PET_VM_EVT_VM_CONFIG_CHANGED", PET_VM_EVT_VM_CONFIG_CHANGED );
	PyModule_AddIntConstant( module, "PET_VM_EVT_REQUEST_FILE_OPEN", PET_VM_EVT_REQUEST_FILE_OPEN );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_VM_MIGRATE_STARTED", PET_DSP_EVT_VM_MIGRATE_STARTED );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_VM_MIGRATE_CANCELLED", PET_DSP_EVT_VM_MIGRATE_CANCELLED );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_VM_MIGRATE_FINISHED", PET_DSP_EVT_VM_MIGRATE_FINISHED );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_VM_MIGRATE_PROGRESS_CHANGED", PET_DSP_EVT_VM_MIGRATE_PROGRESS_CHANGED );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_VM_SNAPSHOTING", PET_DSP_EVT_VM_SNAPSHOTING );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_VM_RESTORING", PET_DSP_EVT_VM_RESTORING );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_VM_SNAPSHOTS_TREE_CHANGED", PET_DSP_EVT_VM_SNAPSHOTS_TREE_CHANGED );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_VM_DELETING_STATE", PET_DSP_EVT_VM_DELETING_STATE );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_VM_STATE_DELETED", PET_DSP_EVT_VM_STATE_DELETED );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_VM_ABOUT_TO_START_DEINIT", PET_DSP_EVT_VM_ABOUT_TO_START_DEINIT );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_VM_ABOUT_TO_START_INIT", PET_DSP_EVT_VM_ABOUT_TO_START_INIT );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_VM_MEMORY_SWAPPING_STARTED", PET_DSP_EVT_VM_MEMORY_SWAPPING_STARTED );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_VM_MEMORY_SWAPPING_FINISHED", PET_DSP_EVT_VM_MEMORY_SWAPPING_FINISHED );
	PyModule_AddIntConstant( module, "PET_VM_EVT_UNMOUNT", PET_VM_EVT_UNMOUNT );
	PyModule_AddIntConstant( module, "PET_VM_EVT_MOUNT", PET_VM_EVT_MOUNT );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_REBOOT_HOST", PET_DSP_EVT_REBOOT_HOST );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_REBOOT_HOST_MANUAL_TO_INIT_VTD_DEVICES", PET_DSP_EVT_REBOOT_HOST_MANUAL_TO_INIT_VTD_DEVICES );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_BACKUP_STARTED", PET_DSP_EVT_BACKUP_STARTED );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_BACKUP_CANCELLED", PET_DSP_EVT_BACKUP_CANCELLED );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_CREATE_BACKUP_FINISHED", PET_DSP_EVT_CREATE_BACKUP_FINISHED );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_BACKUP_PROGRESS_CHANGED", PET_DSP_EVT_BACKUP_PROGRESS_CHANGED );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_JOB_PROGRESS_CHANGED", PET_DSP_EVT_JOB_PROGRESS_CHANGED );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_RESTORE_PROGRESS_CHANGED", PET_DSP_EVT_RESTORE_PROGRESS_CHANGED );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_DISK_RESIZE_STARTED", PET_DSP_EVT_DISK_RESIZE_STARTED );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_DISK_RESIZE_FINISHED", PET_DSP_EVT_DISK_RESIZE_FINISHED );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_DISK_RESIZE_PROGRESS_CHANGED", PET_DSP_EVT_DISK_RESIZE_PROGRESS_CHANGED );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_VM_ADDITION_STATE_CHANGED", PET_DSP_EVT_VM_ADDITION_STATE_CHANGED );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_RESTORE_BACKUP_FINISHED", PET_DSP_EVT_RESTORE_BACKUP_FINISHED );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_REMOVE_BACKUP_FINISHED", PET_DSP_EVT_REMOVE_BACKUP_FINISHED );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_VM_MIGRATE_CANCELLED_DISP", PET_DSP_EVT_VM_MIGRATE_CANCELLED_DISP );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_VM_MIGRATE_FINISHED_DISP", PET_DSP_EVT_VM_MIGRATE_FINISHED_DISP );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_TIME_MACHINE_BACKUP_IS_OVER", PET_DSP_EVT_TIME_MACHINE_BACKUP_IS_OVER );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_CONVERSION_DISKS_PROGRESS_CHANGED", PET_DSP_EVT_CONVERSION_DISKS_PROGRESS_CHANGED );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_CONVERSION_DISKS_PROGRESS_FINISHED", PET_DSP_EVT_CONVERSION_DISKS_PROGRESS_FINISHED );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_CONVERT_THIRD_PARTY_PROGRESS_CHANGED", PET_DSP_EVT_CONVERT_THIRD_PARTY_PROGRESS_CHANGED );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_CONNECTED_TO_PROXY", PET_DSP_EVT_CONNECTED_TO_PROXY );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_DISCONNECTED_FROM_PROXY", PET_DSP_EVT_DISCONNECTED_FROM_PROXY );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_CONNECTING_TO_PROXY", PET_DSP_EVT_CONNECTING_TO_PROXY );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_RECONFIG_VM_PROGRESS_CHANGED", PET_DSP_EVT_RECONFIG_VM_PROGRESS_CHANGED );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_VM_MIGRATE_WAIT_REMOUNT", PET_DSP_EVT_VM_MIGRATE_WAIT_REMOUNT );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_VM_CONFIG_APPLY_FINISHED", PET_DSP_EVT_VM_CONFIG_APPLY_FINISHED );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_VM_IO_CLIENT_STATISTICTS", PET_DSP_EVT_VM_IO_CLIENT_STATISTICTS );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_VM_SET_HOST_TIME", PET_DSP_EVT_VM_SET_HOST_TIME );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_VM_LOW_HOST_MEMORY", PET_DSP_EVT_VM_LOW_HOST_MEMORY );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_VM_MAC_OS_VER", PET_DSP_EVT_VM_MAC_OS_VER );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_VM_PAUSED_BY_HOST_SLEEP", PET_DSP_EVT_VM_PAUSED_BY_HOST_SLEEP );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_VM_CONTINUED_BY_HOST_WAKEUP", PET_DSP_EVT_VM_CONTINUED_BY_HOST_WAKEUP );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_VM_FROZEN", PET_DSP_EVT_VM_FROZEN );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_VM_UNFROZEN", PET_DSP_EVT_VM_UNFROZEN );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_CONNECTION_CLIENT_INFO_WAS_SET", PET_DSP_EVT_CONNECTION_CLIENT_INFO_WAS_SET );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_CONNECTION_WAS_CLOSED", PET_DSP_EVT_CONNECTION_WAS_CLOSED );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_OP_ACCEPTED", PET_DSP_EVT_OP_ACCEPTED );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_OP_REJECTED", PET_DSP_EVT_OP_REJECTED );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_OP_RESULT", PET_DSP_EVT_OP_RESULT );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_DIR_STATE_CHANGED", PET_DSP_EVT_DIR_STATE_CHANGED );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_HOST_STATISTICS_UPDATED", PET_DSP_EVT_HOST_STATISTICS_UPDATED );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_HW_CONFIG_CHANGED", PET_DSP_EVT_HW_CONFIG_CHANGED );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_CLIENT_CONNECTED", PET_DSP_EVT_CLIENT_CONNECTED );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_CLIENT_DISCONNECTED", PET_DSP_EVT_CLIENT_DISCONNECTED );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_CLIENT_REJECTED", PET_DSP_EVT_CLIENT_REJECTED );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_FOUND_LOST_VM_CONFIG", PET_DSP_EVT_FOUND_LOST_VM_CONFIG );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_HAS_EVENT", PET_DSP_EVT_HAS_EVENT );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_RECONNECT", PET_DSP_EVT_RECONNECT );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_DISP_CONNECTION_CLOSED", PET_DSP_EVT_DISP_CONNECTION_CLOSED );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_DISP_SHUTDOWN", PET_DSP_EVT_DISP_SHUTDOWN );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_USER_PROFILE_CHANGED", PET_DSP_EVT_USER_PROFILE_CHANGED );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_COMMON_PREFS_CHANGED", PET_DSP_EVT_COMMON_PREFS_CHANGED );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_VM_MESSAGE", PET_DSP_EVT_VM_MESSAGE );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_VM_QUESTION", PET_DSP_EVT_VM_QUESTION );
	PyModule_AddIntConstant( module, "PET_JOB_DELETE_VM_PROGRESS_CHANGED", PET_JOB_DELETE_VM_PROGRESS_CHANGED );
	PyModule_AddIntConstant( module, "PET_VM_INF_START_FILE_COPYING", PET_VM_INF_START_FILE_COPYING );
	PyModule_AddIntConstant( module, "PET_VM_INF_END_FILE_COPYING", PET_VM_INF_END_FILE_COPYING );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_ERROR_MESSAGE", PET_DSP_EVT_ERROR_MESSAGE );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_WARNING_MESSAGE", PET_DSP_EVT_WARNING_MESSAGE );
	PyModule_AddIntConstant( module, "PET_JOB_HDD_CREATE_PROGRESS_CHANGED", PET_JOB_HDD_CREATE_PROGRESS_CHANGED );
	PyModule_AddIntConstant( module, "PET_JOB_FILE_COPY_PROGRESS_CHANGED", PET_JOB_FILE_COPY_PROGRESS_CHANGED );
	PyModule_AddIntConstant( module, "PET_JOB_SUSPEND_PROGRESS_CHANGED", PET_JOB_SUSPEND_PROGRESS_CHANGED );
	PyModule_AddIntConstant( module, "PET_JOB_RESUME_PROGRESS_CHANGED", PET_JOB_RESUME_PROGRESS_CHANGED );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_ANSWER_TO_VM_WAS_DONE", PET_DSP_EVT_ANSWER_TO_VM_WAS_DONE );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_LICENSE_CHANGED", PET_DSP_EVT_LICENSE_CHANGED );
	PyModule_AddIntConstant( module, "PET_JOB_CREATE_SNAPSHOT_PROGRESS_CHANGED", PET_JOB_CREATE_SNAPSHOT_PROGRESS_CHANGED );
	PyModule_AddIntConstant( module, "PET_JOB_SWITCH_TO_SNAPSHOT_PROGRESS_CHANGED", PET_JOB_SWITCH_TO_SNAPSHOT_PROGRESS_CHANGED );
	PyModule_AddIntConstant( module, "PET_JOB_DELETE_SNAPSHOT_PROGRESS_CHANGED", PET_JOB_DELETE_SNAPSHOT_PROGRESS_CHANGED );
	PyModule_AddIntConstant( module, "PET_JOB_COMMIT_UNFINISHED_DISK_OP_PROGRESS_CHANGED", PET_JOB_COMMIT_UNFINISHED_DISK_OP_PROGRESS_CHANGED );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_COMMIT_UNFINISHED_DISK_OP_STARTED", PET_DSP_EVT_COMMIT_UNFINISHED_DISK_OP_STARTED );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_COMMIT_UNFINISHED_DISK_OP_FINISHED", PET_DSP_EVT_COMMIT_UNFINISHED_DISK_OP_FINISHED );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_VM_ENCRYPT_PROGRESS_CHANGED", PET_DSP_EVT_VM_ENCRYPT_PROGRESS_CHANGED );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_VM_DECRYPT_PROGRESS_CHANGED", PET_DSP_EVT_VM_DECRYPT_PROGRESS_CHANGED );
	PyModule_AddIntConstant( module, "PET_JOB_STAGE_PROGRESS_CHANGED", PET_JOB_STAGE_PROGRESS_CHANGED );
	PyModule_AddIntConstant( module, "PET_VM_INF_START_BUNCH_COPYING", PET_VM_INF_START_BUNCH_COPYING );
	PyModule_AddIntConstant( module, "PET_VM_INF_END_BUNCH_COPYING", PET_VM_INF_END_BUNCH_COPYING );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_SMC_USER_FORCE_DISCONNECTED", PET_DSP_EVT_SMC_USER_FORCE_DISCONNECTED );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_SMC_CANCEL_USER_COMMAND", PET_DSP_EVT_SMC_CANCEL_USER_COMMAND );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_SMC_DISPATCHER_SHUTDOWN", PET_DSP_EVT_SMC_DISPATCHER_SHUTDOWN );
	PyModule_AddIntConstant( module, "PET_IO_SCREEN_SIZE", PET_IO_SCREEN_SIZE );
	PyModule_AddIntConstant( module, "PET_IO_SLIDING_MOUSE_FLAG", PET_IO_SLIDING_MOUSE_FLAG );
	PyModule_AddIntConstant( module, "PET_IO_DEVICE_IS_IN_USE", PET_IO_DEVICE_IS_IN_USE );
	PyModule_AddIntConstant( module, "PET_IO_KEYBOARD_LEDS", PET_IO_KEYBOARD_LEDS );
	PyModule_AddIntConstant( module, "PET_IO_STATE", PET_IO_STATE );
	PyModule_AddIntConstant( module, "PET_IO_SCREEN_CAPTURED", PET_IO_SCREEN_CAPTURED );
	PyModule_AddIntConstant( module, "PET_IO_BEFORE_SCREEN_SIZE", PET_IO_BEFORE_SCREEN_SIZE );
	PyModule_AddIntConstant( module, "PET_IO_REMOTE_COMMAND", PET_IO_REMOTE_COMMAND );
	PyModule_AddIntConstant( module, "PET_IO_MOUSE_CURSOR_CHANGED", PET_IO_MOUSE_CURSOR_CHANGED );
	PyModule_AddIntConstant( module, "PET_IO_MOUSE_CURSOR_HID", PET_IO_MOUSE_CURSOR_HID );
	PyModule_AddIntConstant( module, "PET_IO_MOUSE_CURSOR_SET", PET_IO_MOUSE_CURSOR_SET );
	PyModule_AddIntConstant( module, "PET_IO_DYNRES_TOOL_STATUS", PET_IO_DYNRES_TOOL_STATUS );
	PyModule_AddIntConstant( module, "PET_IO_TOOLS_UTILITY_COMMAND", PET_IO_TOOLS_UTILITY_COMMAND );
	PyModule_AddIntConstant( module, "PET_IO_TOOLS_VM_SHUTDOWN", PET_IO_TOOLS_VM_SHUTDOWN );
	PyModule_AddIntConstant( module, "PET_IO_TOOLS_CLIPBOARD_DATA", PET_IO_TOOLS_CLIPBOARD_DATA );
	PyModule_AddIntConstant( module, "PET_IO_SCREEN_SURFACE_DETACHED", PET_IO_SCREEN_SURFACE_DETACHED );
	PyModule_AddIntConstant( module, "PET_IO_TOOLS_SIA_DATA", PET_IO_TOOLS_SIA_DATA );
	PyModule_AddIntConstant( module, "PET_IO_TOOLS_VMCTG_COMMAND", PET_IO_TOOLS_VMCTG_COMMAND );
	PyModule_AddIntConstant( module, "PET_IO_TOOLS_DRAGDROP_DATA", PET_IO_TOOLS_DRAGDROP_DATA );
	PyModule_AddIntConstant( module, "PET_IO_TOOLS_GENERAL_COMMAND", PET_IO_TOOLS_GENERAL_COMMAND );
	PyModule_AddIntConstant( module, "PET_IO_TOOLS_DESKTOP_UTILITY_STATE", PET_IO_TOOLS_DESKTOP_UTILITY_STATE );
	PyModule_AddIntConstant( module, "PET_IO_DISPLAY_SCREEN_SIZE", PET_IO_DISPLAY_SCREEN_SIZE );
	PyModule_AddIntConstant( module, "PET_IO_DISPLAY_BEFORE_SCREEN_SIZE", PET_IO_DISPLAY_BEFORE_SCREEN_SIZE );
	PyModule_AddIntConstant( module, "PET_IO_DISPLAY_SCREEN_CAPTURED", PET_IO_DISPLAY_SCREEN_CAPTURED );
	PyModule_AddIntConstant( module, "PET_IO_SWITCH_VESA_MODE", PET_IO_SWITCH_VESA_MODE );
	PyModule_AddIntConstant( module, "PET_IO_TOOLS_LANGUAGE_HOTKEY_CHANGED", PET_IO_TOOLS_LANGUAGE_HOTKEY_CHANGED );
	PyModule_AddIntConstant( module, "PET_IO_AVAILABLE_DISPLAYS", PET_IO_AVAILABLE_DISPLAYS );
	PyModule_AddIntConstant( module, "PET_IO_SCREEN_SURFACE_ATTACHED", PET_IO_SCREEN_SURFACE_ATTACHED );
	PyModule_AddIntConstant( module, "PET_IO_UIEMU_ELEMENT_AT_POS", PET_IO_UIEMU_ELEMENT_AT_POS );
	PyModule_AddIntConstant( module, "PET_IO_AUDIO_OUTPUT_DATA", PET_IO_AUDIO_OUTPUT_DATA );
	PyModule_AddIntConstant( module, "PET_IO_AUDIO_OUTPUT_ENCODING_SET", PET_IO_AUDIO_OUTPUT_ENCODING_SET );
	PyModule_AddIntConstant( module, "PET_IO_AUDIO_OUTPUT_STREAM_STARTED", PET_IO_AUDIO_OUTPUT_STREAM_STARTED );
	PyModule_AddIntConstant( module, "PET_IO_AUDIO_OUTPUT_STOP", PET_IO_AUDIO_OUTPUT_STOP );
	PyModule_AddIntConstant( module, "PET_IO_CVSRC_OPEN", PET_IO_CVSRC_OPEN );
	PyModule_AddIntConstant( module, "PET_IO_CVSRC_CLOSE", PET_IO_CVSRC_CLOSE );
	PyModule_AddIntConstant( module, "PET_IO_SSO_GET_CREDENTIALS", PET_IO_SSO_GET_CREDENTIALS );
	PyModule_AddIntConstant( module, "PET_IO_MOUSE_CURSOR_MOVED", PET_IO_MOUSE_CURSOR_MOVED );
	PyModule_AddIntConstant( module, "PET_IO_UIEMU_CARET_INFO", PET_IO_UIEMU_CARET_INFO );
	PyModule_AddIntConstant( module, "PET_IO_DISPLAY_GAMMA_CHANGED", PET_IO_DISPLAY_GAMMA_CHANGED );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_VM_TOOLS_STATE_CHANGED", PET_DSP_EVT_VM_TOOLS_STATE_CHANGED );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_VM_COMPACT_PROCESSING", PET_DSP_EVT_VM_COMPACT_PROCESSING );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_VM_COMPACT_FINISHED", PET_DSP_EVT_VM_COMPACT_FINISHED );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_VM_COMPRESSOR_FINISHED", PET_DSP_EVT_VM_COMPRESSOR_FINISHED );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_VM_COMPRESSOR_CONTINUED", PET_DSP_EVT_VM_COMPRESSOR_CONTINUED );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_VM_SOFTWARE_INSTALLED", PET_DSP_EVT_VM_SOFTWARE_INSTALLED );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_VM_PIS_NOTIFICATION_ASK_TO_INSTALL", PET_DSP_EVT_VM_PIS_NOTIFICATION_ASK_TO_INSTALL );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_VM_VIRTUAL_DEVICES_STATE_CHANGED", PET_DSP_EVT_VM_VIRTUAL_DEVICES_STATE_CHANGED );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_PERFSTATS", PET_DSP_EVT_PERFSTATS );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_VM_PERFSTATS", PET_DSP_EVT_VM_PERFSTATS );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_VM_UPGRADE_INIT", PET_DSP_EVT_VM_UPGRADE_INIT );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_VM_UPGRADE_INIT_TIMEOUT", PET_DSP_EVT_VM_UPGRADE_INIT_TIMEOUT );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_VM_UPGRADE_STAGE_1", PET_DSP_EVT_VM_UPGRADE_STAGE_1 );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_VM_UPGRADE_STAGE_2", PET_DSP_EVT_VM_UPGRADE_STAGE_2 );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_VM_UPGRADE_STAGE_3", PET_DSP_EVT_VM_UPGRADE_STAGE_3 );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_VM_UPGRADE_COMPLETED", PET_DSP_EVT_VM_UPGRADE_COMPLETED );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_VM_UPGRADE_UNKNOWN_ERROR", PET_DSP_EVT_VM_UPGRADE_UNKNOWN_ERROR );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_VM_UPGRADE_INIT_VMW", PET_DSP_EVT_VM_UPGRADE_INIT_VMW );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_VM_UPGRADE_INIT_PHY", PET_DSP_EVT_VM_UPGRADE_INIT_PHY );
	PyModule_AddIntConstant( module, "PET_IO_READY_TO_ACCEPT_STDIN_PKGS", PET_IO_READY_TO_ACCEPT_STDIN_PKGS );
	PyModule_AddIntConstant( module, "PET_VM_READY_TO_BOOT", PET_VM_READY_TO_BOOT );
	PyModule_AddIntConstant( module, "PET_VM_READY_TO_PRINT", PET_VM_READY_TO_PRINT );
	PyModule_AddIntConstant( module, "PET_VM_DEFAULT_SOUND_RECONNECTED", PET_VM_DEFAULT_SOUND_RECONNECTED );
	PyModule_AddIntConstant( module, "PET_VM_EVT_UNMOUNT_USB_MEDIA", PET_VM_EVT_UNMOUNT_USB_MEDIA );
	PyModule_AddIntConstant( module, "PET_VM_EVT_UNMOUNT_DVD_MEDIA", PET_VM_EVT_UNMOUNT_DVD_MEDIA );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_APPLIANCE_DOWNLOAD_PROGRESS_CHANGED", PET_DSP_EVT_APPLIANCE_DOWNLOAD_PROGRESS_CHANGED );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_APPLIANCE_DOWNLOAD_FINISHED", PET_DSP_EVT_APPLIANCE_DOWNLOAD_FINISHED );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_APPLIANCE_ARCHIVE_UNPACK_STARTED", PET_DSP_EVT_APPLIANCE_ARCHIVE_UNPACK_STARTED );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_APPLIANCE_ARCHIVE_UNPACK_FINISHED", PET_DSP_EVT_APPLIANCE_ARCHIVE_UNPACK_FINISHED );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_APPLIANCE_REGISTER_VM_STARTED", PET_DSP_EVT_APPLIANCE_REGISTER_VM_STARTED );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_APPLIANCE_REGISTER_VM_FINISHED", PET_DSP_EVT_APPLIANCE_REGISTER_VM_FINISHED );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_CEP_WRITE_STRING", PET_DSP_EVT_CEP_WRITE_STRING );
	PyModule_AddIntConstant( module, "PET_DSP_COHERENCE_FAKE_STUB_NOTIFICATION", PET_DSP_COHERENCE_FAKE_STUB_NOTIFICATION );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_VM_WAS_ENCRYPTED", PET_DSP_EVT_VM_WAS_ENCRYPTED );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_VM_WAS_DECRYPTED", PET_DSP_EVT_VM_WAS_DECRYPTED );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_ENCRYPTED_VM_PASSWORD_CHANGED", PET_DSP_EVT_ENCRYPTED_VM_PASSWORD_CHANGED );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_ENCRYPTED_VM_NEED_AUTH_AGAIN", PET_DSP_EVT_ENCRYPTED_VM_NEED_AUTH_AGAIN );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_VM_WAS_PROTECTED", PET_DSP_EVT_VM_WAS_PROTECTED );
	PyModule_AddIntConstant( module, "PET_DSP_EVT_VM_WAS_UNPROTECTED", PET_DSP_EVT_VM_WAS_UNPROTECTED );
	PyModule_AddIntConstant( module, "PET_VM_EVT_TIS_BACKUP_WRITE", PET_VM_EVT_TIS_BACKUP_WRITE );
	PyModule_AddIntConstant( module, "PET_IO_EVT_DISCONNECT_WITH_REASON", PET_IO_EVT_DISCONNECT_WITH_REASON );
	PyModule_AddIntConstant( module, "PET_VIDEO_RECEIVER_FORMAT", PET_VIDEO_RECEIVER_FORMAT );
	PyModule_AddIntConstant( module, "PET_VIDEO_RECEIVER_FRAME", PET_VIDEO_RECEIVER_FRAME );
	PyModule_AddIntConstant( module, "PET_VIDEO_RECEIVER_CLOSED", PET_VIDEO_RECEIVER_CLOSED );
	PyModule_AddIntConstant( module, "PET_VIDEO_CAPTURE_GEOMETRY", PET_VIDEO_CAPTURE_GEOMETRY );
	PyModule_AddIntConstant( module, "PET_VIDEO_RECEIVER_CONNECTION_STATE", PET_VIDEO_RECEIVER_CONNECTION_STATE );
	PyModule_AddIntConstant( module, "PET_PTM_EVT_PROPERTY_CHANGED", PET_PTM_EVT_PROPERTY_CHANGED );
	PyModule_AddIntConstant( module, "PET_PTM_EVT_OBJECT_DELETED", PET_PTM_EVT_OBJECT_DELETED );
	PyModule_AddIntConstant( module, "PET_PTM_EVT_OBJECT_CREATED", PET_PTM_EVT_OBJECT_CREATED );
	PyModule_AddIntConstant( module, "PET_PTM_EVT_SUBSCRIBED", PET_PTM_EVT_SUBSCRIBED );
	PyModule_AddIntConstant( module, "PET_PTM_EVT_RPC_COMPLETED", PET_PTM_EVT_RPC_COMPLETED );
	PyModule_AddIntConstant( module, "PET_IO_DISPLAY_PALETTE_CHANGED", PET_IO_DISPLAY_PALETTE_CHANGED );
	PyModule_AddIntConstant( module, "PET_IO_TOOLS_TIS_QUERY", PET_IO_TOOLS_TIS_QUERY );
	PyModule_AddIntConstant( module, "PET_IO_SCREEN_UPDATED", PET_IO_SCREEN_UPDATED );
	PyModule_AddIntConstant( module, "PET_IO_AUTH_RESPONSE", PET_IO_AUTH_RESPONSE );
	PyModule_AddIntConstant( module, "PET_IO_ATTACH_RESPONSE", PET_IO_ATTACH_RESPONSE );
	PyModule_AddIntConstant( module, "PET_IO_ENCODING_RESPONSE", PET_IO_ENCODING_RESPONSE );
	PyModule_AddIntConstant( module, "PET_IO_MEMORY_INFO", PET_IO_MEMORY_INFO );
	PyModule_AddIntConstant( module, "PET_IO_SCREEN_CAPTURED_BUFFER", PET_IO_SCREEN_CAPTURED_BUFFER );
	PyModule_AddIntConstant( module, "PET_IO_TOOLS_TIS_SUBSCRIBE", PET_IO_TOOLS_TIS_SUBSCRIBE );
	PyModule_AddIntConstant( module, "PET_IO_TOOLS_TIS_UNSUBSCRIBE", PET_IO_TOOLS_TIS_UNSUBSCRIBE );
	PyModule_AddIntConstant( module, "PET_IO_CLI_AUTHENTICATE_SESSION", PET_IO_CLI_AUTHENTICATE_SESSION );
	PyModule_AddIntConstant( module, "PET_IO_CLI_ATTACH_TO_VM", PET_IO_CLI_ATTACH_TO_VM );
	PyModule_AddIntConstant( module, "PET_IO_CLI_ENCODING_REQUEST", PET_IO_CLI_ENCODING_REQUEST );
	PyModule_AddIntConstant( module, "PET_IO_CLI_SCREEN_WATCH_UPDATES", PET_IO_CLI_SCREEN_WATCH_UPDATES );
	PyModule_AddIntConstant( module, "PET_IO_CLI_SCREEN_CAPTURE_BUFFER", PET_IO_CLI_SCREEN_CAPTURE_BUFFER );
	PyModule_AddIntConstant( module, "PET_IO_CLI_SCREEN_SIZE", PET_IO_CLI_SCREEN_SIZE );
	PyModule_AddIntConstant( module, "PET_IO_CLI_KEYBOARD_SCANCODE", PET_IO_CLI_KEYBOARD_SCANCODE );
	PyModule_AddIntConstant( module, "PET_IO_CLI_MOUSE_SETPOS", PET_IO_CLI_MOUSE_SETPOS );
	PyModule_AddIntConstant( module, "PET_IO_CLI_MOUSE_MOVE", PET_IO_CLI_MOUSE_MOVE );
	PyModule_AddIntConstant( module, "PET_IO_CLI_MOUSE_NEED_CURSOR", PET_IO_CLI_MOUSE_NEED_CURSOR );
	PyModule_AddIntConstant( module, "PET_IO_CLI_GRACEFUL_SHUTDOWN", PET_IO_CLI_GRACEFUL_SHUTDOWN );
	PyModule_AddIntConstant( module, "PET_IO_CLI_SCREEN_SET_SURFACE", PET_IO_CLI_SCREEN_SET_SURFACE );
	PyModule_AddIntConstant( module, "PET_IO_CLI_REMOTE_COMMAND", PET_IO_CLI_REMOTE_COMMAND );
	PyModule_AddIntConstant( module, "PET_IO_CLI_TOOLS_UTILITY_COMMAND", PET_IO_CLI_TOOLS_UTILITY_COMMAND );
	PyModule_AddIntConstant( module, "PET_IO_CLI_TOOLS_TIS_QUERY", PET_IO_CLI_TOOLS_TIS_QUERY );
	PyModule_AddIntConstant( module, "PET_IO_CLI_TOOLS_CLIPBOARD_DATA", PET_IO_CLI_TOOLS_CLIPBOARD_DATA );
	PyModule_AddIntConstant( module, "PET_IO_CLI_TOOLS_SIA_DATA", PET_IO_CLI_TOOLS_SIA_DATA );
	PyModule_AddIntConstant( module, "PET_IO_CLI_TOOLS_VMCTG_COMMAND", PET_IO_CLI_TOOLS_VMCTG_COMMAND );
	PyModule_AddIntConstant( module, "PET_IO_CLI_TOOLS_GENERAL_COMMAND", PET_IO_CLI_TOOLS_GENERAL_COMMAND );
	PyModule_AddIntConstant( module, "PET_IO_CLI_TOOLS_EMPTY_RECYCLE_BIN", PET_IO_CLI_TOOLS_EMPTY_RECYCLE_BIN );
	PyModule_AddIntConstant( module, "PET_IO_CLI_TOOLS_SET_TASKBAR_VISIBILITY", PET_IO_CLI_TOOLS_SET_TASKBAR_VISIBILITY );
	PyModule_AddIntConstant( module, "PET_IO_CLI_TOOLS_TOGGLE_DESKTOP", PET_IO_CLI_TOOLS_TOGGLE_DESKTOP );
	PyModule_AddIntConstant( module, "PET_IO_CLI_TOOLS_MOVE_TASKBAR", PET_IO_CLI_TOOLS_MOVE_TASKBAR );
	PyModule_AddIntConstant( module, "PET_IO_CLI_TOOLS_SHOW_RECYCLE_BIN", PET_IO_CLI_TOOLS_SHOW_RECYCLE_BIN );
	PyModule_AddIntConstant( module, "PET_IO_CLI_TOOLS_NOTIFY_COHERENCE_STATE", PET_IO_CLI_TOOLS_NOTIFY_COHERENCE_STATE );
	PyModule_AddIntConstant( module, "PET_IO_CLI_TOOLS_ADJUST_WORKING_AREA", PET_IO_CLI_TOOLS_ADJUST_WORKING_AREA );
	PyModule_AddIntConstant( module, "PET_IO_CLI_KEYBOARD_KEY", PET_IO_CLI_KEYBOARD_KEY );
	PyModule_AddIntConstant( module, "PET_IO_CLI_TOOLS_UIEMU", PET_IO_CLI_TOOLS_UIEMU );
	PyModule_AddIntConstant( module, "DEPRECATED_PET_IO_CLI_AUDIO_OUTPUT_STREAM_START", DEPRECATED_PET_IO_CLI_AUDIO_OUTPUT_STREAM_START );
	PyModule_AddIntConstant( module, "DEPRECATED_PET_IO_CLI_AUDIO_OUTPUT_STREAM_STOP", DEPRECATED_PET_IO_CLI_AUDIO_OUTPUT_STREAM_STOP );
	PyModule_AddIntConstant( module, "DEPRECATED_PET_IO_CLI_AUDIO_OUTPUT_SET_ENCODING", DEPRECATED_PET_IO_CLI_AUDIO_OUTPUT_SET_ENCODING );
	PyModule_AddIntConstant( module, "PET_IO_CLI_CVSRC_CONNECT", PET_IO_CLI_CVSRC_CONNECT );
	PyModule_AddIntConstant( module, "PET_IO_CLI_CVSRC_DISCONNECT", PET_IO_CLI_CVSRC_DISCONNECT );
	PyModule_AddIntConstant( module, "PET_IO_CLI_AUTHENTICATE_EXEC_SESSION", PET_IO_CLI_AUTHENTICATE_EXEC_SESSION );
	PyModule_AddIntConstant( module, "PET_IO_CLI_SWITCH_SLIDING_MOUSE", PET_IO_CLI_SWITCH_SLIDING_MOUSE );
	PyModule_AddIntConstant( module, "PET_IO_CLI_SSO_SET_CREDENTIALS", PET_IO_CLI_SSO_SET_CREDENTIALS );
	PyModule_AddIntConstant( module, "PET_IO_CLI_SSO_SET_CREDENTIALS_ASYNC", PET_IO_CLI_SSO_SET_CREDENTIALS_ASYNC );
	PyModule_AddIntConstant( module, "PET_IO_CLI_SSO_LOCKED", PET_IO_CLI_SSO_LOCKED );
	PyModule_AddIntConstant( module, "PET_IO_CLI_SSO_UNLOCKED", PET_IO_CLI_SSO_UNLOCKED );
	PyModule_AddIntConstant( module, "PET_IO_CLI_DPI_SCREEN_SIZE", PET_IO_CLI_DPI_SCREEN_SIZE );
	PyModule_AddIntConstant( module, "PET_IO_CLI_TOOLS_SET_INDENTS", PET_IO_CLI_TOOLS_SET_INDENTS );
	PyModule_AddIntConstant( module, "PET_IO_CLI_AUDIO_RECORDING_STREAM_START", PET_IO_CLI_AUDIO_RECORDING_STREAM_START );
	PyModule_AddIntConstant( module, "PET_IO_CLI_AUDIO_RECORDING_STREAM_STOP", PET_IO_CLI_AUDIO_RECORDING_STREAM_STOP );
	PyModule_AddIntConstant( module, "PET_IO_CLI_AUDIO_PLAYOUT_STREAM_START", PET_IO_CLI_AUDIO_PLAYOUT_STREAM_START );
	PyModule_AddIntConstant( module, "PET_IO_CLI_AUDIO_PLAYOUT_STREAM_STOP", PET_IO_CLI_AUDIO_PLAYOUT_STREAM_STOP );
	PyModule_AddIntConstant( module, "PET_IO_CLI_TOOLS_OPEN_FILE_BROWSER", PET_IO_CLI_TOOLS_OPEN_FILE_BROWSER );
	PyModule_AddIntConstant( module, "PET_IO_STDIN_PORTION", PET_IO_STDIN_PORTION );
	PyModule_AddIntConstant( module, "PET_IO_STDOUT_PORTION", PET_IO_STDOUT_PORTION );
	PyModule_AddIntConstant( module, "PET_IO_STDERR_PORTION", PET_IO_STDERR_PORTION );
	PyModule_AddIntConstant( module, "PET_IO_READY_TO_ACCEPT_STDOUT_STDERR_PKGS", PET_IO_READY_TO_ACCEPT_STDOUT_STDERR_PKGS );
	PyModule_AddIntConstant( module, "PET_IO_FIN_TO_TRANSMIT_STDOUT_STDERR", PET_IO_FIN_TO_TRANSMIT_STDOUT_STDERR );
	PyModule_AddIntConstant( module, "PET_IO_CLIENT_PROCESSED_ALL_DESCS_DATA", PET_IO_CLIENT_PROCESSED_ALL_DESCS_DATA );
	PyModule_AddIntConstant( module, "PET_IO_TTY_SETTINGS_REQUIRED", PET_IO_TTY_SETTINGS_REQUIRED );
	PyModule_AddIntConstant( module, "PET_IO_TTY_SETTINGS_PROVIDED", PET_IO_TTY_SETTINGS_PROVIDED );
	PyModule_AddIntConstant( module, "PET_IO_STDIN_WAS_CLOSED", PET_IO_STDIN_WAS_CLOSED );
	PyModule_AddIntConstant( module, "PET_IT_RECONFIG_BOOTCAMP_START", PET_IT_RECONFIG_BOOTCAMP_START );
	PyModule_AddIntConstant( module, "PET_IT_VALIDATE_BOOTCAMP_START", PET_IT_VALIDATE_BOOTCAMP_START );
	PyModule_AddIntConstant( module, "PET_IT_CONVERT_TO_OLD_START", PET_IT_CONVERT_TO_OLD_START );
	PyModule_AddIntConstant( module, "PET_IT_CONVERT_TO_CURRENT_START", PET_IT_CONVERT_TO_CURRENT_START );
	PyModule_AddIntConstant( module, "PET_IT_RECONFIG_START", PET_IT_RECONFIG_START );
	PyModule_AddIntConstant( module, "PET_IT_MERGE_SNAPSHOTS_START", PET_IT_MERGE_SNAPSHOTS_START );
	PyModule_AddIntConstant( module, "PET_IT_MAKE_PLAIN_START", PET_IT_MAKE_PLAIN_START );
	PyModule_AddIntConstant( module, "PET_IT_MAKE_EXPANDING_START", PET_IT_MAKE_EXPANDING_START );
	PyModule_AddIntConstant( module, "PET_IT_MAKE_SPLIT_START", PET_IT_MAKE_SPLIT_START );
	PyModule_AddIntConstant( module, "PET_IT_MAKE_NON_SPLIT_START", PET_IT_MAKE_NON_SPLIT_START );
	PyModule_AddIntConstant( module, "PET_IT_GET_RESIZE_INFORMATION_START", PET_IT_GET_RESIZE_INFORMATION_START );
	PyModule_AddIntConstant( module, "PET_IT_INCREASE_LAST_VOLUME_START", PET_IT_INCREASE_LAST_VOLUME_START );
	PyModule_AddIntConstant( module, "PET_IT_RESIZING_START", PET_IT_RESIZING_START );
	PyModule_AddIntConstant( module, "PET_IT_DECREASING_START", PET_IT_DECREASING_START );
	PyModule_AddIntConstant( module, "PET_IT_COMPACTING_START", PET_IT_COMPACTING_START );
	PyModule_AddIntConstant( module, "PET_IT_FIX_CONSISTENCY_START", PET_IT_FIX_CONSISTENCY_START );
	PyModule_AddIntConstant( module, "PET_IT_CONVERT_TO_EXTEND_START", PET_IT_CONVERT_TO_EXTEND_START );
	PyModule_AddIntConstant( module, "PET_DESKCTL_SESSION_AUTH", PET_DESKCTL_SESSION_AUTH );
	PyModule_AddIntConstant( module, "PET_DESKCTL_SESSION_AUTH_FIN", PET_DESKCTL_SESSION_AUTH_FIN );
	PyModule_AddIntConstant( module, "PET_DESKCTL_ATTACH", PET_DESKCTL_ATTACH );
	PyModule_AddIntConstant( module, "PET_DESKCTL_ATTACH_FIN", PET_DESKCTL_ATTACH_FIN );
	PyModule_AddIntConstant( module, "PET_DESKCTL_LOCAL_AUTH", PET_DESKCTL_LOCAL_AUTH );
	PyModule_AddIntConstant( module, "PET_DESKCTL_LOCAL_AUTH_QUEST", PET_DESKCTL_LOCAL_AUTH_QUEST );
	PyModule_AddIntConstant( module, "PET_DESKCTL_LOCAL_AUTH_ANSWER", PET_DESKCTL_LOCAL_AUTH_ANSWER );
	PyModule_AddIntConstant( module, "PET_DESKCTL_LOCAL_AUTH_FIN", PET_DESKCTL_LOCAL_AUTH_FIN );
	PyModule_AddIntConstant( module, "PET_DESKCTL_ACCEPT_CLIENTS", PET_DESKCTL_ACCEPT_CLIENTS );
	PyModule_AddIntConstant( module, "PET_DESKCTL_REJECT_CLIENTS", PET_DESKCTL_REJECT_CLIENTS );
	PyModule_AddIntConstant( module, "PET_DESKCTL_CONFIG", PET_DESKCTL_CONFIG );
	PyModule_AddIntConstant( module, "PET_DESKCTL_CONFIG_QUERY", PET_DESKCTL_CONFIG_QUERY );
	PyModule_AddIntConstant( module, "PET_DESKCTL_SEND_SAS", PET_DESKCTL_SEND_SAS );
	PyModule_AddIntConstant( module, "PET_DESKCTL_STATUS_CHANGE", PET_DESKCTL_STATUS_CHANGE );
	PyModule_AddIntConstant( module, "PET_IO_DISCONNECT_WITH_REASON", PET_IO_DISCONNECT_WITH_REASON );
	PyModule_AddIntConstant( module, "PET_IO_DISPLAY_RESOLUTION_SET", PET_IO_DISPLAY_RESOLUTION_SET );
	PyModule_AddIntConstant( module, "PET_VIDEO_STREAM_START", PET_VIDEO_STREAM_START );
	PyModule_AddIntConstant( module, "PET_VIDEO_STREAM_CLOSE", PET_VIDEO_STREAM_CLOSE );
	PyModule_AddIntConstant( module, "PET_VIDEO_STREAM_FORMAT", PET_VIDEO_STREAM_FORMAT );
	PyModule_AddIntConstant( module, "PET_VIDEO_STREAM_DATA", PET_VIDEO_STREAM_DATA );
	PyModule_AddIntConstant( module, "PET_VIDEO_STREAM_CLOSED", PET_VIDEO_STREAM_CLOSED );
	PyModule_AddIntConstant( module, "PET_VIDEO_STREAM_ACK_FRAME", PET_VIDEO_STREAM_ACK_FRAME );
	PyModule_AddIntConstant( module, "PET_VIDEO_STREAM_OPEN", PET_VIDEO_STREAM_OPEN );
	PyModule_AddIntConstant( module, "PET_VIDEO_DATA_CHANNEL_CTL", PET_VIDEO_DATA_CHANNEL_CTL );
	PyModule_AddIntConstant( module, "PET_VIDEO_STREAM_STOP", PET_VIDEO_STREAM_STOP );
	PyModule_AddIntConstant( module, "PET_IO_PTM_PROTOCOL", PET_IO_PTM_PROTOCOL );
	PyModule_AddIntConstant( module, "PET_IO_IOSERVICE_CHANNELS_PROTOCOL", PET_IO_IOSERVICE_CHANNELS_PROTOCOL );
	PyModule_AddIntConstant( module, "PRL_KEY_INVALID", PRL_KEY_INVALID );
	PyModule_AddIntConstant( module, "PRL_KEY_WILDCARD_ANY", PRL_KEY_WILDCARD_ANY );
	PyModule_AddIntConstant( module, "PRL_KEY_WILDCARD_KEYBOARD", PRL_KEY_WILDCARD_KEYBOARD );
	PyModule_AddIntConstant( module, "PRL_KEY_WILDCARD_MOUSE", PRL_KEY_WILDCARD_MOUSE );
	PyModule_AddIntConstant( module, "PRL_KEY_WILDCARD_SHIFT", PRL_KEY_WILDCARD_SHIFT );
	PyModule_AddIntConstant( module, "PRL_KEY_WILDCARD_CTRL", PRL_KEY_WILDCARD_CTRL );
	PyModule_AddIntConstant( module, "PRL_KEY_WILDCARD_ALT", PRL_KEY_WILDCARD_ALT );
	PyModule_AddIntConstant( module, "PRL_KEY_WILDCARD_WIN", PRL_KEY_WILDCARD_WIN );
	PyModule_AddIntConstant( module, "PRL_KEY_ESCAPE", PRL_KEY_ESCAPE );
	PyModule_AddIntConstant( module, "PRL_KEY_1", PRL_KEY_1 );
	PyModule_AddIntConstant( module, "PRL_KEY_2", PRL_KEY_2 );
	PyModule_AddIntConstant( module, "PRL_KEY_3", PRL_KEY_3 );
	PyModule_AddIntConstant( module, "PRL_KEY_4", PRL_KEY_4 );
	PyModule_AddIntConstant( module, "PRL_KEY_5", PRL_KEY_5 );
	PyModule_AddIntConstant( module, "PRL_KEY_6", PRL_KEY_6 );
	PyModule_AddIntConstant( module, "PRL_KEY_7", PRL_KEY_7 );
	PyModule_AddIntConstant( module, "PRL_KEY_8", PRL_KEY_8 );
	PyModule_AddIntConstant( module, "PRL_KEY_9", PRL_KEY_9 );
	PyModule_AddIntConstant( module, "PRL_KEY_0", PRL_KEY_0 );
	PyModule_AddIntConstant( module, "PRL_KEY_MINUS", PRL_KEY_MINUS );
	PyModule_AddIntConstant( module, "PRL_KEY_EQUAL", PRL_KEY_EQUAL );
	PyModule_AddIntConstant( module, "PRL_KEY_BACKSPACE", PRL_KEY_BACKSPACE );
	PyModule_AddIntConstant( module, "PRL_KEY_TAB", PRL_KEY_TAB );
	PyModule_AddIntConstant( module, "PRL_KEY_Q", PRL_KEY_Q );
	PyModule_AddIntConstant( module, "PRL_KEY_W", PRL_KEY_W );
	PyModule_AddIntConstant( module, "PRL_KEY_E", PRL_KEY_E );
	PyModule_AddIntConstant( module, "PRL_KEY_R", PRL_KEY_R );
	PyModule_AddIntConstant( module, "PRL_KEY_T", PRL_KEY_T );
	PyModule_AddIntConstant( module, "PRL_KEY_Y", PRL_KEY_Y );
	PyModule_AddIntConstant( module, "PRL_KEY_U", PRL_KEY_U );
	PyModule_AddIntConstant( module, "PRL_KEY_I", PRL_KEY_I );
	PyModule_AddIntConstant( module, "PRL_KEY_O", PRL_KEY_O );
	PyModule_AddIntConstant( module, "PRL_KEY_P", PRL_KEY_P );
	PyModule_AddIntConstant( module, "PRL_KEY_LEFT_BRACKET", PRL_KEY_LEFT_BRACKET );
	PyModule_AddIntConstant( module, "PRL_KEY_RIGHT_BRACKET", PRL_KEY_RIGHT_BRACKET );
	PyModule_AddIntConstant( module, "PRL_KEY_ENTER", PRL_KEY_ENTER );
	PyModule_AddIntConstant( module, "PRL_KEY_LEFT_CONTROL", PRL_KEY_LEFT_CONTROL );
	PyModule_AddIntConstant( module, "PRL_KEY_A", PRL_KEY_A );
	PyModule_AddIntConstant( module, "PRL_KEY_S", PRL_KEY_S );
	PyModule_AddIntConstant( module, "PRL_KEY_D", PRL_KEY_D );
	PyModule_AddIntConstant( module, "PRL_KEY_F", PRL_KEY_F );
	PyModule_AddIntConstant( module, "PRL_KEY_G", PRL_KEY_G );
	PyModule_AddIntConstant( module, "PRL_KEY_H", PRL_KEY_H );
	PyModule_AddIntConstant( module, "PRL_KEY_J", PRL_KEY_J );
	PyModule_AddIntConstant( module, "PRL_KEY_K", PRL_KEY_K );
	PyModule_AddIntConstant( module, "PRL_KEY_L", PRL_KEY_L );
	PyModule_AddIntConstant( module, "PRL_KEY_SEMICOLON", PRL_KEY_SEMICOLON );
	PyModule_AddIntConstant( module, "PRL_KEY_QUOTE", PRL_KEY_QUOTE );
	PyModule_AddIntConstant( module, "PRL_KEY_TILDA", PRL_KEY_TILDA );
	PyModule_AddIntConstant( module, "PRL_KEY_LEFT_SHIFT", PRL_KEY_LEFT_SHIFT );
	PyModule_AddIntConstant( module, "PRL_KEY_BACKSLASH", PRL_KEY_BACKSLASH );
	PyModule_AddIntConstant( module, "PRL_KEY_Z", PRL_KEY_Z );
	PyModule_AddIntConstant( module, "PRL_KEY_X", PRL_KEY_X );
	PyModule_AddIntConstant( module, "PRL_KEY_C", PRL_KEY_C );
	PyModule_AddIntConstant( module, "PRL_KEY_V", PRL_KEY_V );
	PyModule_AddIntConstant( module, "PRL_KEY_B", PRL_KEY_B );
	PyModule_AddIntConstant( module, "PRL_KEY_N", PRL_KEY_N );
	PyModule_AddIntConstant( module, "PRL_KEY_M", PRL_KEY_M );
	PyModule_AddIntConstant( module, "PRL_KEY_COMMA", PRL_KEY_COMMA );
	PyModule_AddIntConstant( module, "PRL_KEY_DOT", PRL_KEY_DOT );
	PyModule_AddIntConstant( module, "PRL_KEY_SLASH", PRL_KEY_SLASH );
	PyModule_AddIntConstant( module, "PRL_KEY_RIGHT_SHIFT", PRL_KEY_RIGHT_SHIFT );
	PyModule_AddIntConstant( module, "PRL_KEY_NP_STAR", PRL_KEY_NP_STAR );
	PyModule_AddIntConstant( module, "PRL_KEY_LEFT_ALT", PRL_KEY_LEFT_ALT );
	PyModule_AddIntConstant( module, "PRL_KEY_SPACE", PRL_KEY_SPACE );
	PyModule_AddIntConstant( module, "PRL_KEY_CAPS_LOCK", PRL_KEY_CAPS_LOCK );
	PyModule_AddIntConstant( module, "PRL_KEY_F1", PRL_KEY_F1 );
	PyModule_AddIntConstant( module, "PRL_KEY_F2", PRL_KEY_F2 );
	PyModule_AddIntConstant( module, "PRL_KEY_F3", PRL_KEY_F3 );
	PyModule_AddIntConstant( module, "PRL_KEY_F4", PRL_KEY_F4 );
	PyModule_AddIntConstant( module, "PRL_KEY_F5", PRL_KEY_F5 );
	PyModule_AddIntConstant( module, "PRL_KEY_F6", PRL_KEY_F6 );
	PyModule_AddIntConstant( module, "PRL_KEY_F7", PRL_KEY_F7 );
	PyModule_AddIntConstant( module, "PRL_KEY_F8", PRL_KEY_F8 );
	PyModule_AddIntConstant( module, "PRL_KEY_F9", PRL_KEY_F9 );
	PyModule_AddIntConstant( module, "PRL_KEY_F10", PRL_KEY_F10 );
	PyModule_AddIntConstant( module, "PRL_KEY_NUM_LOCK", PRL_KEY_NUM_LOCK );
	PyModule_AddIntConstant( module, "PRL_KEY_SCROLL_LOCK", PRL_KEY_SCROLL_LOCK );
	PyModule_AddIntConstant( module, "PRL_KEY_NP_7", PRL_KEY_NP_7 );
	PyModule_AddIntConstant( module, "PRL_KEY_NP_8", PRL_KEY_NP_8 );
	PyModule_AddIntConstant( module, "PRL_KEY_NP_9", PRL_KEY_NP_9 );
	PyModule_AddIntConstant( module, "PRL_KEY_NP_MINUS", PRL_KEY_NP_MINUS );
	PyModule_AddIntConstant( module, "PRL_KEY_NP_4", PRL_KEY_NP_4 );
	PyModule_AddIntConstant( module, "PRL_KEY_NP_5", PRL_KEY_NP_5 );
	PyModule_AddIntConstant( module, "PRL_KEY_NP_6", PRL_KEY_NP_6 );
	PyModule_AddIntConstant( module, "PRL_KEY_NP_PLUS", PRL_KEY_NP_PLUS );
	PyModule_AddIntConstant( module, "PRL_KEY_NP_1", PRL_KEY_NP_1 );
	PyModule_AddIntConstant( module, "PRL_KEY_NP_2", PRL_KEY_NP_2 );
	PyModule_AddIntConstant( module, "PRL_KEY_NP_3", PRL_KEY_NP_3 );
	PyModule_AddIntConstant( module, "PRL_KEY_NP_0", PRL_KEY_NP_0 );
	PyModule_AddIntConstant( module, "PRL_KEY_NP_DELETE", PRL_KEY_NP_DELETE );
	PyModule_AddIntConstant( module, "PRL_KEY_PRINT", PRL_KEY_PRINT );
	PyModule_AddIntConstant( module, "PRL_KEY_EUROPE_1", PRL_KEY_EUROPE_1 );
	PyModule_AddIntConstant( module, "PRL_KEY_EUROPE_2", PRL_KEY_EUROPE_2 );
	PyModule_AddIntConstant( module, "PRL_KEY_F11", PRL_KEY_F11 );
	PyModule_AddIntConstant( module, "PRL_KEY_F12", PRL_KEY_F12 );
	PyModule_AddIntConstant( module, "PRL_KEY_HOME", PRL_KEY_HOME );
	PyModule_AddIntConstant( module, "PRL_KEY_UP", PRL_KEY_UP );
	PyModule_AddIntConstant( module, "PRL_KEY_PAGE_UP", PRL_KEY_PAGE_UP );
	PyModule_AddIntConstant( module, "PRL_KEY_LEFT", PRL_KEY_LEFT );
	PyModule_AddIntConstant( module, "PRL_KEY_RIGHT", PRL_KEY_RIGHT );
	PyModule_AddIntConstant( module, "PRL_KEY_END", PRL_KEY_END );
	PyModule_AddIntConstant( module, "PRL_KEY_DOWN", PRL_KEY_DOWN );
	PyModule_AddIntConstant( module, "PRL_KEY_PAGE_DOWN", PRL_KEY_PAGE_DOWN );
	PyModule_AddIntConstant( module, "PRL_KEY_INSERT", PRL_KEY_INSERT );
	PyModule_AddIntConstant( module, "PRL_KEY_DELETE", PRL_KEY_DELETE );
	PyModule_AddIntConstant( module, "PRL_KEY_NP_ENTER", PRL_KEY_NP_ENTER );
	PyModule_AddIntConstant( module, "PRL_KEY_RIGHT_CONTROL", PRL_KEY_RIGHT_CONTROL );
	PyModule_AddIntConstant( module, "PRL_KEY_PAUSE", PRL_KEY_PAUSE );
	PyModule_AddIntConstant( module, "PRL_KEY_NP_SLASH", PRL_KEY_NP_SLASH );
	PyModule_AddIntConstant( module, "PRL_KEY_RIGHT_ALT", PRL_KEY_RIGHT_ALT );
	PyModule_AddIntConstant( module, "PRL_KEY_LEFT_WIN", PRL_KEY_LEFT_WIN );
	PyModule_AddIntConstant( module, "PRL_KEY_RIGHT_WIN", PRL_KEY_RIGHT_WIN );
	PyModule_AddIntConstant( module, "PRL_KEY_MENU", PRL_KEY_MENU );
	PyModule_AddIntConstant( module, "PRL_KEY_MEDIA_NEXT_TRACK", PRL_KEY_MEDIA_NEXT_TRACK );
	PyModule_AddIntConstant( module, "PRL_KEY_MEDIA_PREV_TRACK", PRL_KEY_MEDIA_PREV_TRACK );
	PyModule_AddIntConstant( module, "PRL_KEY_MEDIA_STOP", PRL_KEY_MEDIA_STOP );
	PyModule_AddIntConstant( module, "PRL_KEY_MEDIA_PLAY_PAUSE", PRL_KEY_MEDIA_PLAY_PAUSE );
	PyModule_AddIntConstant( module, "PRL_KEY_MUTE", PRL_KEY_MUTE );
	PyModule_AddIntConstant( module, "PRL_KEY_VOLUME_UP", PRL_KEY_VOLUME_UP );
	PyModule_AddIntConstant( module, "PRL_KEY_VOLUME_DOWN", PRL_KEY_VOLUME_DOWN );
	PyModule_AddIntConstant( module, "PRL_KEY_MEDIA_SELECT", PRL_KEY_MEDIA_SELECT );
	PyModule_AddIntConstant( module, "PRL_KEY_APP_MAIL", PRL_KEY_APP_MAIL );
	PyModule_AddIntConstant( module, "PRL_KEY_APP_CALCULATOR", PRL_KEY_APP_CALCULATOR );
	PyModule_AddIntConstant( module, "PRL_KEY_APP_MY_COMPUTER", PRL_KEY_APP_MY_COMPUTER );
	PyModule_AddIntConstant( module, "PRL_KEY_WWW_SEARCH", PRL_KEY_WWW_SEARCH );
	PyModule_AddIntConstant( module, "PRL_KEY_WWW_HOME", PRL_KEY_WWW_HOME );
	PyModule_AddIntConstant( module, "PRL_KEY_WWW_BACK", PRL_KEY_WWW_BACK );
	PyModule_AddIntConstant( module, "PRL_KEY_WWW_FORWARD", PRL_KEY_WWW_FORWARD );
	PyModule_AddIntConstant( module, "PRL_KEY_WWW_STOP", PRL_KEY_WWW_STOP );
	PyModule_AddIntConstant( module, "PRL_KEY_WWW_REFRESH", PRL_KEY_WWW_REFRESH );
	PyModule_AddIntConstant( module, "PRL_KEY_WWW_FAVORITES", PRL_KEY_WWW_FAVORITES );
	PyModule_AddIntConstant( module, "PRL_KEY_EJECT", PRL_KEY_EJECT );
	PyModule_AddIntConstant( module, "PRL_KEY_SYSTEM_POWER", PRL_KEY_SYSTEM_POWER );
	PyModule_AddIntConstant( module, "PRL_KEY_SYSTEM_SLEEP", PRL_KEY_SYSTEM_SLEEP );
	PyModule_AddIntConstant( module, "PRL_KEY_SYSTEM_WAKE", PRL_KEY_SYSTEM_WAKE );
	PyModule_AddIntConstant( module, "PRL_KEY_BRAZILIAN_KEYPAD", PRL_KEY_BRAZILIAN_KEYPAD );
	PyModule_AddIntConstant( module, "PRL_KEY_RO", PRL_KEY_RO );
	PyModule_AddIntConstant( module, "PRL_KEY_HIRAGANA_KATAKANA", PRL_KEY_HIRAGANA_KATAKANA );
	PyModule_AddIntConstant( module, "PRL_KEY_YEN", PRL_KEY_YEN );
	PyModule_AddIntConstant( module, "PRL_KEY_HENKAN", PRL_KEY_HENKAN );
	PyModule_AddIntConstant( module, "PRL_KEY_MUHENKAN", PRL_KEY_MUHENKAN );
	PyModule_AddIntConstant( module, "PRL_KEY_PC9800_KEYPAD", PRL_KEY_PC9800_KEYPAD );
	PyModule_AddIntConstant( module, "PRL_KEY_HANGUEL", PRL_KEY_HANGUEL );
	PyModule_AddIntConstant( module, "PRL_KEY_HANJA", PRL_KEY_HANJA );
	PyModule_AddIntConstant( module, "PRL_KEY_KATAKANA", PRL_KEY_KATAKANA );
	PyModule_AddIntConstant( module, "PRL_KEY_HIRAGANA", PRL_KEY_HIRAGANA );
	PyModule_AddIntConstant( module, "PRL_KEY_ZENKAKU_HANKAKU", PRL_KEY_ZENKAKU_HANKAKU );
	PyModule_AddIntConstant( module, "PRL_KEY_F13", PRL_KEY_F13 );
	PyModule_AddIntConstant( module, "PRL_KEY_F14", PRL_KEY_F14 );
	PyModule_AddIntConstant( module, "PRL_KEY_F15", PRL_KEY_F15 );
	PyModule_AddIntConstant( module, "PRL_KEY_F16", PRL_KEY_F16 );
	PyModule_AddIntConstant( module, "PRL_KEY_F17", PRL_KEY_F17 );
	PyModule_AddIntConstant( module, "PRL_KEY_F18", PRL_KEY_F18 );
	PyModule_AddIntConstant( module, "PRL_KEY_F19", PRL_KEY_F19 );
	PyModule_AddIntConstant( module, "PRL_KEY_F20", PRL_KEY_F20 );
	PyModule_AddIntConstant( module, "PRL_KEY_F21", PRL_KEY_F21 );
	PyModule_AddIntConstant( module, "PRL_KEY_F22", PRL_KEY_F22 );
	PyModule_AddIntConstant( module, "PRL_KEY_F23", PRL_KEY_F23 );
	PyModule_AddIntConstant( module, "PRL_KEY_F24", PRL_KEY_F24 );
	PyModule_AddIntConstant( module, "PRL_KEY_NP_EQUAL", PRL_KEY_NP_EQUAL );
	PyModule_AddIntConstant( module, "PRL_KEY_BREAK", PRL_KEY_BREAK );
	PyModule_AddIntConstant( module, "PRL_KEY_PRINT_WITH_MODIFIER", PRL_KEY_PRINT_WITH_MODIFIER );
	PyModule_AddIntConstant( module, "PRL_KEY_SYSRQ", PRL_KEY_SYSRQ );
	PyModule_AddIntConstant( module, "PRL_KEY_FN", PRL_KEY_FN );
	PyModule_AddIntConstant( module, "PRL_KEY_EURO", PRL_KEY_EURO );
	PyModule_AddIntConstant( module, "PRL_KEY_DOLLAR", PRL_KEY_DOLLAR );
	PyModule_AddIntConstant( module, "PRL_KEY_MON_BRIGHTNESS_DOWN", PRL_KEY_MON_BRIGHTNESS_DOWN );
	PyModule_AddIntConstant( module, "PRL_KEY_MON_BRIGHTNESS_UP", PRL_KEY_MON_BRIGHTNESS_UP );
	PyModule_AddIntConstant( module, "PRL_KEY_APP_EXPOSE", PRL_KEY_APP_EXPOSE );
	PyModule_AddIntConstant( module, "PRL_KEY_APP_DASHBOARD", PRL_KEY_APP_DASHBOARD );
	PyModule_AddIntConstant( module, "PRL_KEY_KBD_BRIGHTNESS_DOWN", PRL_KEY_KBD_BRIGHTNESS_DOWN );
	PyModule_AddIntConstant( module, "PRL_KEY_KBD_BRIGHTNESS_UP", PRL_KEY_KBD_BRIGHTNESS_UP );
	PyModule_AddIntConstant( module, "PRL_KEY_MAC129", PRL_KEY_MAC129 );
	PyModule_AddIntConstant( module, "PRL_KEY_LEFT_BUTTON", PRL_KEY_LEFT_BUTTON );
	PyModule_AddIntConstant( module, "PRL_KEY_MIDDLE_BUTTON", PRL_KEY_MIDDLE_BUTTON );
	PyModule_AddIntConstant( module, "PRL_KEY_RIGHT_BUTTON", PRL_KEY_RIGHT_BUTTON );
	PyModule_AddIntConstant( module, "PRL_KEY_MOVE_UP_LEFT", PRL_KEY_MOVE_UP_LEFT );
	PyModule_AddIntConstant( module, "PRL_KEY_MOVE_UP", PRL_KEY_MOVE_UP );
	PyModule_AddIntConstant( module, "PRL_KEY_MOVE_UP_RIGHT", PRL_KEY_MOVE_UP_RIGHT );
	PyModule_AddIntConstant( module, "PRL_KEY_MOVE_LEFT", PRL_KEY_MOVE_LEFT );
	PyModule_AddIntConstant( module, "PRL_KEY_MOVE_RIGHT", PRL_KEY_MOVE_RIGHT );
	PyModule_AddIntConstant( module, "PRL_KEY_MOVE_DOWN_LEFT", PRL_KEY_MOVE_DOWN_LEFT );
	PyModule_AddIntConstant( module, "PRL_KEY_MOVE_DOWN", PRL_KEY_MOVE_DOWN );
	PyModule_AddIntConstant( module, "PRL_KEY_MOVE_DOWN_RIGHT", PRL_KEY_MOVE_DOWN_RIGHT );
	PyModule_AddIntConstant( module, "PRL_KEY_WHEEL_UP", PRL_KEY_WHEEL_UP );
	PyModule_AddIntConstant( module, "PRL_KEY_WHEEL_DOWN", PRL_KEY_WHEEL_DOWN );
	PyModule_AddIntConstant( module, "PRL_KEY_WHEEL_LEFT", PRL_KEY_WHEEL_LEFT );
	PyModule_AddIntConstant( module, "PRL_KEY_WHEEL_RIGHT", PRL_KEY_WHEEL_RIGHT );
	PyModule_AddIntConstant( module, "PRL_KEY_MAX", PRL_KEY_MAX );

	PyModule_AddStringConstant( module, "PRL_CURRENT_GUEST_OS_SESSION", "4a5533a7-31c6-4d7a-a400-1f330dc57a9d" );
	PyModule_AddStringConstant( module, "PRL_PRIVILEGED_GUEST_OS_SESSION", "531582ac-3dce-446f-8c26-dd7e3384dcf4" );

	PyModule_AddIntConstant( module, "PVS_GUEST_TYPE_MACOS", PVS_GUEST_TYPE_MACOS );
	PyModule_AddIntConstant( module, "PVS_GUEST_TYPE_WINDOWS", PVS_GUEST_TYPE_WINDOWS );
	PyModule_AddIntConstant( module, "PVS_GUEST_TYPE_LINUX", PVS_GUEST_TYPE_LINUX );
	PyModule_AddIntConstant( module, "PVS_GUEST_TYPE_FREEBSD", PVS_GUEST_TYPE_FREEBSD );
	PyModule_AddIntConstant( module, "PVS_GUEST_TYPE_OS2", PVS_GUEST_TYPE_OS2 );
	PyModule_AddIntConstant( module, "PVS_GUEST_TYPE_MSDOS", PVS_GUEST_TYPE_MSDOS );
	PyModule_AddIntConstant( module, "PVS_GUEST_TYPE_NETWARE", PVS_GUEST_TYPE_NETWARE );
	PyModule_AddIntConstant( module, "PVS_GUEST_TYPE_SOLARIS", PVS_GUEST_TYPE_SOLARIS );
	PyModule_AddIntConstant( module, "PVS_GUEST_TYPE_CHROMEOS", PVS_GUEST_TYPE_CHROMEOS );
	PyModule_AddIntConstant( module, "PVS_GUEST_TYPE_ANDROID", PVS_GUEST_TYPE_ANDROID );
	PyModule_AddIntConstant( module, "PVS_GUEST_TYPE_OTHER", PVS_GUEST_TYPE_OTHER );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_MACOS_TIGER", PVS_GUEST_VER_MACOS_TIGER );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_MACOS_LEOPARD", PVS_GUEST_VER_MACOS_LEOPARD );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_MACOS_SNOW_LEOPARD", PVS_GUEST_VER_MACOS_SNOW_LEOPARD );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_MACOS_UNIVERSAL", PVS_GUEST_VER_MACOS_UNIVERSAL );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_MACOS_LAST", PVS_GUEST_VER_MACOS_LAST );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_WIN_311", PVS_GUEST_VER_WIN_311 );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_WIN_95", PVS_GUEST_VER_WIN_95 );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_WIN_98", PVS_GUEST_VER_WIN_98 );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_WIN_ME", PVS_GUEST_VER_WIN_ME );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_WIN_NT", PVS_GUEST_VER_WIN_NT );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_WIN_2K", PVS_GUEST_VER_WIN_2K );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_WIN_XP", PVS_GUEST_VER_WIN_XP );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_WIN_2003", PVS_GUEST_VER_WIN_2003 );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_WIN_VISTA", PVS_GUEST_VER_WIN_VISTA );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_WIN_2008", PVS_GUEST_VER_WIN_2008 );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_WIN_WINDOWS7", PVS_GUEST_VER_WIN_WINDOWS7 );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_WIN_WINDOWS8", PVS_GUEST_VER_WIN_WINDOWS8 );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_WIN_2012", PVS_GUEST_VER_WIN_2012 );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_WIN_WINDOWS8_1", PVS_GUEST_VER_WIN_WINDOWS8_1 );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_WIN_LAST", PVS_GUEST_VER_WIN_LAST );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_WIN_OTHER", PVS_GUEST_VER_WIN_OTHER );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_CHROMEOS_1x", PVS_GUEST_VER_CHROMEOS_1x );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_CHROMEOS_LAST", PVS_GUEST_VER_CHROMEOS_LAST );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_CHROMEOS_OTHER", PVS_GUEST_VER_CHROMEOS_OTHER );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_ANDROID_2_x", PVS_GUEST_VER_ANDROID_2_x );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_ANDROID_3_x", PVS_GUEST_VER_ANDROID_3_x );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_ANDROID_4_0", PVS_GUEST_VER_ANDROID_4_0 );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_ANDROID_LAST", PVS_GUEST_VER_ANDROID_LAST );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_ANDROID_OTHER", PVS_GUEST_VER_ANDROID_OTHER );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_LIN_REDHAT", PVS_GUEST_VER_LIN_REDHAT );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_LIN_SUSE", PVS_GUEST_VER_LIN_SUSE );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_LIN_MANDRAKE", PVS_GUEST_VER_LIN_MANDRAKE );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_LIN_KRNL_24", PVS_GUEST_VER_LIN_KRNL_24 );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_LIN_KRNL_26", PVS_GUEST_VER_LIN_KRNL_26 );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_LIN_DEBIAN", PVS_GUEST_VER_LIN_DEBIAN );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_LIN_FEDORA", PVS_GUEST_VER_LIN_FEDORA );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_LIN_FEDORA_5", PVS_GUEST_VER_LIN_FEDORA_5 );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_LIN_XANDROS", PVS_GUEST_VER_LIN_XANDROS );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_LIN_UBUNTU", PVS_GUEST_VER_LIN_UBUNTU );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_LIN_SLES9", PVS_GUEST_VER_LIN_SLES9 );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_LIN_RHLES3", PVS_GUEST_VER_LIN_RHLES3 );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_LIN_CENTOS", PVS_GUEST_VER_LIN_CENTOS );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_LIN_RH_LEGACY", PVS_GUEST_VER_LIN_RH_LEGACY );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_LIN_OPENSUSE", PVS_GUEST_VER_LIN_OPENSUSE );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_LIN_PSBM", PVS_GUEST_VER_LIN_PSBM );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_LIN_MAGEIA", PVS_GUEST_VER_LIN_MAGEIA );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_LIN_MINT", PVS_GUEST_VER_LIN_MINT );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_LIN_REDHAT_7", PVS_GUEST_VER_LIN_REDHAT_7 );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_LIN_CENTOS_7", PVS_GUEST_VER_LIN_CENTOS_7 );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_LIN_VZLINUX", PVS_GUEST_VER_LIN_VZLINUX );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_LIN_VZLINUX_7", PVS_GUEST_VER_LIN_VZLINUX_7 );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_LIN_LAST", PVS_GUEST_VER_LIN_LAST );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_LIN_OTHER", PVS_GUEST_VER_LIN_OTHER );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_BSD_4X", PVS_GUEST_VER_BSD_4X );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_BSD_5X", PVS_GUEST_VER_BSD_5X );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_BSD_6X", PVS_GUEST_VER_BSD_6X );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_BSD_7X", PVS_GUEST_VER_BSD_7X );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_BSD_8X", PVS_GUEST_VER_BSD_8X );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_BSD_LAST", PVS_GUEST_VER_BSD_LAST );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_BSD_OTHER", PVS_GUEST_VER_BSD_OTHER );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_OS2_WARP3", PVS_GUEST_VER_OS2_WARP3 );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_OS2_WARP4", PVS_GUEST_VER_OS2_WARP4 );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_OS2_WARP45", PVS_GUEST_VER_OS2_WARP45 );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_OS2_ECS11", PVS_GUEST_VER_OS2_ECS11 );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_OS2_ECS12", PVS_GUEST_VER_OS2_ECS12 );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_OS2_LAST", PVS_GUEST_VER_OS2_LAST );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_OS2_OTHER", PVS_GUEST_VER_OS2_OTHER );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_DOS_MS622", PVS_GUEST_VER_DOS_MS622 );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_DOS_LAST", PVS_GUEST_VER_DOS_LAST );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_DOS_OTHER", PVS_GUEST_VER_DOS_OTHER );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_NET_4X", PVS_GUEST_VER_NET_4X );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_NET_5X", PVS_GUEST_VER_NET_5X );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_NET_6X", PVS_GUEST_VER_NET_6X );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_NET_LAST", PVS_GUEST_VER_NET_LAST );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_NET_OTHER", PVS_GUEST_VER_NET_OTHER );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_SOL_9", PVS_GUEST_VER_SOL_9 );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_SOL_10", PVS_GUEST_VER_SOL_10 );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_SOL_11", PVS_GUEST_VER_SOL_11 );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_SOL_OPEN", PVS_GUEST_VER_SOL_OPEN );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_SOL_LAST", PVS_GUEST_VER_SOL_LAST );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_SOL_OTHER", PVS_GUEST_VER_SOL_OTHER );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_OTH_QNX", PVS_GUEST_VER_OTH_QNX );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_OTH_OPENSTEP", PVS_GUEST_VER_OTH_OPENSTEP );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_OTH_LAST", PVS_GUEST_VER_OTH_LAST );
	PyModule_AddIntConstant( module, "PVS_GUEST_VER_OTH_OTHER", PVS_GUEST_VER_OTH_OTHER );

	PyObject* scan_codes = Py_BuildValue("{}");
	PyModule_AddObject( module, "ScanCodesList", scan_codes );

	PyDict_SetItemString( scan_codes, "0", Py_BuildValue( "(b)", 11 ) );
	PyDict_SetItemString( scan_codes, "NUM_0", Py_BuildValue( "(b)", 11 ) );
	PyDict_SetItemString( scan_codes, "1", Py_BuildValue( "(b)", 2 ) );
	PyDict_SetItemString( scan_codes, "NUM_1", Py_BuildValue( "(b)", 2 ) );
	PyDict_SetItemString( scan_codes, "2", Py_BuildValue( "(b)", 3 ) );
	PyDict_SetItemString( scan_codes, "NUM_2", Py_BuildValue( "(b)", 3 ) );
	PyDict_SetItemString( scan_codes, "3", Py_BuildValue( "(b)", 4 ) );
	PyDict_SetItemString( scan_codes, "NUM_3", Py_BuildValue( "(b)", 4 ) );
	PyDict_SetItemString( scan_codes, "4", Py_BuildValue( "(b)", 5 ) );
	PyDict_SetItemString( scan_codes, "NUM_4", Py_BuildValue( "(b)", 5 ) );
	PyDict_SetItemString( scan_codes, "5", Py_BuildValue( "(b)", 6 ) );
	PyDict_SetItemString( scan_codes, "NUM_5", Py_BuildValue( "(b)", 6 ) );
	PyDict_SetItemString( scan_codes, "6", Py_BuildValue( "(b)", 7 ) );
	PyDict_SetItemString( scan_codes, "NUM_6", Py_BuildValue( "(b)", 7 ) );
	PyDict_SetItemString( scan_codes, "7", Py_BuildValue( "(b)", 8 ) );
	PyDict_SetItemString( scan_codes, "NUM_7", Py_BuildValue( "(b)", 8 ) );
	PyDict_SetItemString( scan_codes, "8", Py_BuildValue( "(b)", 9 ) );
	PyDict_SetItemString( scan_codes, "NUM_8", Py_BuildValue( "(b)", 9 ) );
	PyDict_SetItemString( scan_codes, "9", Py_BuildValue( "(b)", 10 ) );
	PyDict_SetItemString( scan_codes, "NUM_9", Py_BuildValue( "(b)", 10 ) );
	PyDict_SetItemString( scan_codes, "A", Py_BuildValue( "(b)", 30 ) );
	PyDict_SetItemString( scan_codes, "ALT_LEFT", Py_BuildValue( "(b)", 56 ) );
	PyDict_SetItemString( scan_codes, "ALT_RIGHT", Py_BuildValue( "(b,b)", 224,56 ) );
	PyDict_SetItemString( scan_codes, "APP_CALCULATOR", Py_BuildValue( "(b,b)", 224,33 ) );
	PyDict_SetItemString( scan_codes, "APP_MAIL", Py_BuildValue( "(b,b)", 224,108 ) );
	PyDict_SetItemString( scan_codes, "APP_MY_COMPUTER", Py_BuildValue( "(b,b)", 224,107 ) );
	PyDict_SetItemString( scan_codes, "B", Py_BuildValue( "(b)", 48 ) );
	PyDict_SetItemString( scan_codes, "BACKSLASH", Py_BuildValue( "(b)", 43 ) );
	PyDict_SetItemString( scan_codes, "BACKSPACE", Py_BuildValue( "(b)", 14 ) );
	PyDict_SetItemString( scan_codes, "BRAZILIAN_KEYPAD", Py_BuildValue( "(b)", 126 ) );
	PyDict_SetItemString( scan_codes, "BREAK", Py_BuildValue( "(b,b,b,b)", 224,70,224,198 ) );
	PyDict_SetItemString( scan_codes, "C", Py_BuildValue( "(b)", 46 ) );
	PyDict_SetItemString( scan_codes, "CAPS_LOCK", Py_BuildValue( "(b)", 58 ) );
	PyDict_SetItemString( scan_codes, "CBRACE_LEFT", Py_BuildValue( "(b)", 26 ) );
	PyDict_SetItemString( scan_codes, "CBRACE_RIGHT", Py_BuildValue( "(b)", 27 ) );
	PyDict_SetItemString( scan_codes, "CMD_LEFT", Py_BuildValue( "(b,b)", 224,91 ) );
	PyDict_SetItemString( scan_codes, "CMD_RIGHT", Py_BuildValue( "(b,b)", 224,92 ) );
	PyDict_SetItemString( scan_codes, "COLON", Py_BuildValue( "(b)", 39 ) );
	PyDict_SetItemString( scan_codes, "CTRL_LEFT", Py_BuildValue( "(b)", 29 ) );
	PyDict_SetItemString( scan_codes, "CTRL_RIGHT", Py_BuildValue( "(b,b)", 224,29 ) );
	PyDict_SetItemString( scan_codes, "D", Py_BuildValue( "(b)", 32 ) );
	PyDict_SetItemString( scan_codes, "DELETE", Py_BuildValue( "(b,b)", 224,83 ) );
	PyDict_SetItemString( scan_codes, "DOLLAR", Py_BuildValue( "(b,b)", 224,52 ) );
	PyDict_SetItemString( scan_codes, "DOWN", Py_BuildValue( "(b,b)", 224,80 ) );
	PyDict_SetItemString( scan_codes, "E", Py_BuildValue( "(b)", 18 ) );
	PyDict_SetItemString( scan_codes, "EJECT", Py_BuildValue( "(b,b)", 224,99 ) );
	PyDict_SetItemString( scan_codes, "END", Py_BuildValue( "(b,b)", 224,79 ) );
	PyDict_SetItemString( scan_codes, "ENTER", Py_BuildValue( "(b)", 28 ) );
	PyDict_SetItemString( scan_codes, "ESC", Py_BuildValue( "(b)", 1 ) );
	PyDict_SetItemString( scan_codes, "EURO", Py_BuildValue( "(b,b)", 224,51 ) );
	PyDict_SetItemString( scan_codes, "EUROPE_1", Py_BuildValue( "(b)", 43 ) );
	PyDict_SetItemString( scan_codes, "F", Py_BuildValue( "(b)", 33 ) );
	PyDict_SetItemString( scan_codes, "F1", Py_BuildValue( "(b)", 59 ) );
	PyDict_SetItemString( scan_codes, "F10", Py_BuildValue( "(b)", 68 ) );
	PyDict_SetItemString( scan_codes, "F11", Py_BuildValue( "(b)", 87 ) );
	PyDict_SetItemString( scan_codes, "F12", Py_BuildValue( "(b)", 88 ) );
	PyDict_SetItemString( scan_codes, "F13", Py_BuildValue( "(b)", 100 ) );
	PyDict_SetItemString( scan_codes, "F14", Py_BuildValue( "(b)", 101 ) );
	PyDict_SetItemString( scan_codes, "F15", Py_BuildValue( "(b)", 102 ) );
	PyDict_SetItemString( scan_codes, "F16", Py_BuildValue( "(b)", 103 ) );
	PyDict_SetItemString( scan_codes, "F17", Py_BuildValue( "(b)", 104 ) );
	PyDict_SetItemString( scan_codes, "F18", Py_BuildValue( "(b)", 105 ) );
	PyDict_SetItemString( scan_codes, "F19", Py_BuildValue( "(b)", 106 ) );
	PyDict_SetItemString( scan_codes, "F2", Py_BuildValue( "(b)", 60 ) );
	PyDict_SetItemString( scan_codes, "F20", Py_BuildValue( "(b)", 107 ) );
	PyDict_SetItemString( scan_codes, "F21", Py_BuildValue( "(b)", 108 ) );
	PyDict_SetItemString( scan_codes, "F22", Py_BuildValue( "(b)", 109 ) );
	PyDict_SetItemString( scan_codes, "F23", Py_BuildValue( "(b)", 110 ) );
	PyDict_SetItemString( scan_codes, "F24", Py_BuildValue( "(b)", 118 ) );
	PyDict_SetItemString( scan_codes, "F3", Py_BuildValue( "(b)", 61 ) );
	PyDict_SetItemString( scan_codes, "F4", Py_BuildValue( "(b)", 62 ) );
	PyDict_SetItemString( scan_codes, "F5", Py_BuildValue( "(b)", 63 ) );
	PyDict_SetItemString( scan_codes, "F6", Py_BuildValue( "(b)", 64 ) );
	PyDict_SetItemString( scan_codes, "F7", Py_BuildValue( "(b)", 65 ) );
	PyDict_SetItemString( scan_codes, "F8", Py_BuildValue( "(b)", 66 ) );
	PyDict_SetItemString( scan_codes, "F9", Py_BuildValue( "(b)", 67 ) );
	PyDict_SetItemString( scan_codes, "G", Py_BuildValue( "(b)", 34 ) );
	PyDict_SetItemString( scan_codes, "GREATER", Py_BuildValue( "(b)", 52 ) );
	PyDict_SetItemString( scan_codes, "H", Py_BuildValue( "(b)", 35 ) );
	PyDict_SetItemString( scan_codes, "HANGUEL", Py_BuildValue( "(b)", 242 ) );
	PyDict_SetItemString( scan_codes, "HANJA", Py_BuildValue( "(b)", 241 ) );
	PyDict_SetItemString( scan_codes, "HENKAN", Py_BuildValue( "(b)", 121 ) );
	PyDict_SetItemString( scan_codes, "HIRAGANA", Py_BuildValue( "(b)", 119 ) );
	PyDict_SetItemString( scan_codes, "HIRAGANA_KATAKANA", Py_BuildValue( "(b)", 112 ) );
	PyDict_SetItemString( scan_codes, "HOME", Py_BuildValue( "(b,b)", 224,71 ) );
	PyDict_SetItemString( scan_codes, "I", Py_BuildValue( "(b)", 23 ) );
	PyDict_SetItemString( scan_codes, "INSERT", Py_BuildValue( "(b,b)", 224,82 ) );
	PyDict_SetItemString( scan_codes, "J", Py_BuildValue( "(b)", 36 ) );
	PyDict_SetItemString( scan_codes, "K", Py_BuildValue( "(b)", 37 ) );
	PyDict_SetItemString( scan_codes, "KATAKANA", Py_BuildValue( "(b)", 120 ) );
	PyDict_SetItemString( scan_codes, "L", Py_BuildValue( "(b)", 38 ) );
	PyDict_SetItemString( scan_codes, "LEFT", Py_BuildValue( "(b,b)", 224,75 ) );
	PyDict_SetItemString( scan_codes, "LESS", Py_BuildValue( "(b)", 51 ) );
	PyDict_SetItemString( scan_codes, "LESS_GREATER", Py_BuildValue( "(b)", 86 ) );
	PyDict_SetItemString( scan_codes, "M", Py_BuildValue( "(b)", 50 ) );
	PyDict_SetItemString( scan_codes, "MEDIA_NEXT_TRACK", Py_BuildValue( "(b,b)", 224,25 ) );
	PyDict_SetItemString( scan_codes, "MEDIA_PLAY_PAUSE", Py_BuildValue( "(b,b)", 224,34 ) );
	PyDict_SetItemString( scan_codes, "MEDIA_PREV_TRACK", Py_BuildValue( "(b,b)", 224,16 ) );
	PyDict_SetItemString( scan_codes, "MEDIA_SELECT", Py_BuildValue( "(b,b)", 224,109 ) );
	PyDict_SetItemString( scan_codes, "MEDIA_STOP", Py_BuildValue( "(b,b)", 224,36 ) );
	PyDict_SetItemString( scan_codes, "MENU", Py_BuildValue( "(b,b)", 224,93 ) );
	PyDict_SetItemString( scan_codes, "MINUS", Py_BuildValue( "(b)", 12 ) );
	PyDict_SetItemString( scan_codes, "MUHENKAN", Py_BuildValue( "(b)", 123 ) );
	PyDict_SetItemString( scan_codes, "MUTE", Py_BuildValue( "(b,b)", 224,32 ) );
	PyDict_SetItemString( scan_codes, "N", Py_BuildValue( "(b)", 49 ) );
	PyDict_SetItemString( scan_codes, "NUM_LOCK", Py_BuildValue( "(b)", 69 ) );
	PyDict_SetItemString( scan_codes, "O", Py_BuildValue( "(b)", 24 ) );
	PyDict_SetItemString( scan_codes, "P", Py_BuildValue( "(b)", 25 ) );
	PyDict_SetItemString( scan_codes, "PAD_0", Py_BuildValue( "(b)", 82 ) );
	PyDict_SetItemString( scan_codes, "PAD_1", Py_BuildValue( "(b)", 79 ) );
	PyDict_SetItemString( scan_codes, "PAD_2", Py_BuildValue( "(b)", 80 ) );
	PyDict_SetItemString( scan_codes, "PAD_3", Py_BuildValue( "(b)", 81 ) );
	PyDict_SetItemString( scan_codes, "PAD_4", Py_BuildValue( "(b)", 75 ) );
	PyDict_SetItemString( scan_codes, "PAD_5", Py_BuildValue( "(b)", 76 ) );
	PyDict_SetItemString( scan_codes, "PAD_6", Py_BuildValue( "(b)", 77 ) );
	PyDict_SetItemString( scan_codes, "PAD_7", Py_BuildValue( "(b)", 71 ) );
	PyDict_SetItemString( scan_codes, "PAD_8", Py_BuildValue( "(b)", 72 ) );
	PyDict_SetItemString( scan_codes, "PAD_9", Py_BuildValue( "(b)", 73 ) );
	PyDict_SetItemString( scan_codes, "PAD_DEL", Py_BuildValue( "(b)", 83 ) );
	PyDict_SetItemString( scan_codes, "PAD_ENTER", Py_BuildValue( "(b,b)", 224,28 ) );
	PyDict_SetItemString( scan_codes, "PAD_EQUAL", Py_BuildValue( "(b)", 89 ) );
	PyDict_SetItemString( scan_codes, "PAD_MINUS", Py_BuildValue( "(b)", 74 ) );
	PyDict_SetItemString( scan_codes, "PAD_PLUS", Py_BuildValue( "(b)", 78 ) );
	PyDict_SetItemString( scan_codes, "PAD_SLASH", Py_BuildValue( "(b,b)", 224,53 ) );
	PyDict_SetItemString( scan_codes, "PAD_STAR", Py_BuildValue( "(b)", 55 ) );
	PyDict_SetItemString( scan_codes, "PAGE_DOWN", Py_BuildValue( "(b,b)", 224,81 ) );
	PyDict_SetItemString( scan_codes, "PAGE_UP", Py_BuildValue( "(b,b)", 224,73 ) );
	PyDict_SetItemString( scan_codes, "PAUSE_BREAK", Py_BuildValue( "(b,b,b,b,b,b)", 225,29,69,225,157,197 ) );
	PyDict_SetItemString( scan_codes, "PC9800_KEYPAD", Py_BuildValue( "(b)", 92 ) );
	PyDict_SetItemString( scan_codes, "PLUS", Py_BuildValue( "(b)", 13 ) );
	PyDict_SetItemString( scan_codes, "PRINT_SCREEN", Py_BuildValue( "(b,b,b,b)", 224,42,224,55 ) );
	PyDict_SetItemString( scan_codes, "PRINT_SCREEN2", Py_BuildValue( "(b,b)", 224,55 ) );
	PyDict_SetItemString( scan_codes, "Q", Py_BuildValue( "(b)", 16 ) );
	PyDict_SetItemString( scan_codes, "QUOTE", Py_BuildValue( "(b)", 40 ) );
	PyDict_SetItemString( scan_codes, "R", Py_BuildValue( "(b)", 19 ) );
	PyDict_SetItemString( scan_codes, "RIGHT", Py_BuildValue( "(b,b)", 224,77 ) );
	PyDict_SetItemString( scan_codes, "RO", Py_BuildValue( "(b)", 115 ) );
	PyDict_SetItemString( scan_codes, "S", Py_BuildValue( "(b)", 31 ) );
	PyDict_SetItemString( scan_codes, "SCROLL_LOCK", Py_BuildValue( "(b)", 70 ) );
	PyDict_SetItemString( scan_codes, "SHIFT_LEFT", Py_BuildValue( "(b)", 42 ) );
	PyDict_SetItemString( scan_codes, "SHIFT_RIGHT", Py_BuildValue( "(b)", 54 ) );
	PyDict_SetItemString( scan_codes, "SLASH", Py_BuildValue( "(b)", 53 ) );
	PyDict_SetItemString( scan_codes, "SPACE", Py_BuildValue( "(b)", 57 ) );
	PyDict_SetItemString( scan_codes, "SYSRQ", Py_BuildValue( "(b)", 84 ) );
	PyDict_SetItemString( scan_codes, "SYSTEM_POWER", Py_BuildValue( "(b,b)", 224,94 ) );
	PyDict_SetItemString( scan_codes, "SYSTEM_SLEEP", Py_BuildValue( "(b,b)", 224,95 ) );
	PyDict_SetItemString( scan_codes, "SYSTEM_WAKE", Py_BuildValue( "(b,b)", 224,99 ) );
	PyDict_SetItemString( scan_codes, "T", Py_BuildValue( "(b)", 20 ) );
	PyDict_SetItemString( scan_codes, "TAB", Py_BuildValue( "(b)", 15 ) );
	PyDict_SetItemString( scan_codes, "TILDA", Py_BuildValue( "(b)", 41 ) );
	PyDict_SetItemString( scan_codes, "U", Py_BuildValue( "(b)", 22 ) );
	PyDict_SetItemString( scan_codes, "UP", Py_BuildValue( "(b,b)", 224,72 ) );
	PyDict_SetItemString( scan_codes, "V", Py_BuildValue( "(b)", 47 ) );
	PyDict_SetItemString( scan_codes, "VOLUME_DOWN", Py_BuildValue( "(b,b)", 224,46 ) );
	PyDict_SetItemString( scan_codes, "VOLUME_UP", Py_BuildValue( "(b,b)", 224,48 ) );
	PyDict_SetItemString( scan_codes, "W", Py_BuildValue( "(b)", 17 ) );
	PyDict_SetItemString( scan_codes, "WWW_BACK", Py_BuildValue( "(b,b)", 224,106 ) );
	PyDict_SetItemString( scan_codes, "WWW_FAVORITES", Py_BuildValue( "(b,b)", 224,102 ) );
	PyDict_SetItemString( scan_codes, "WWW_FORWARD", Py_BuildValue( "(b,b)", 224,105 ) );
	PyDict_SetItemString( scan_codes, "WWW_HOME", Py_BuildValue( "(b,b)", 224,50 ) );
	PyDict_SetItemString( scan_codes, "WWW_REFRESH", Py_BuildValue( "(b,b)", 224,103 ) );
	PyDict_SetItemString( scan_codes, "WWW_SEARCH", Py_BuildValue( "(b,b)", 224,101 ) );
	PyDict_SetItemString( scan_codes, "WWW_STOP", Py_BuildValue( "(b,b)", 224,104 ) );
	PyDict_SetItemString( scan_codes, "X", Py_BuildValue( "(b)", 45 ) );
	PyDict_SetItemString( scan_codes, "Y", Py_BuildValue( "(b)", 21 ) );
	PyDict_SetItemString( scan_codes, "YEN", Py_BuildValue( "(b)", 125 ) );
	PyDict_SetItemString( scan_codes, "Z", Py_BuildValue( "(b)", 44 ) );
	PyDict_SetItemString( scan_codes, "ZENKAKU_HANKAKU", Py_BuildValue( "(b)", 118 ) );

	name = "errors";
	module = Py_InitModule( (char* )(parent_name + "." + name).c_str(), NULL );
	Py_INCREF(module);
	PyModule_AddObject( parent_module, (char* )name.c_str(), module );

	PyModule_AddIntConstant( module, "PRL_ERR_SUCCESS", PRL_ERR_SUCCESS );
	PyModule_AddIntConstant( module, "PRL_ERR_UNEXPECTED", PRL_ERR_UNEXPECTED );
	PyModule_AddIntConstant( module, "PRL_ERR_OUT_OF_MEMORY", PRL_ERR_OUT_OF_MEMORY );
	PyModule_AddIntConstant( module, "PRL_ERR_INVALID_ARG", PRL_ERR_INVALID_ARG );
	PyModule_AddIntConstant( module, "PRL_ERR_INVALID_HANDLE", PRL_ERR_INVALID_HANDLE );
	PyModule_AddIntConstant( module, "PRL_ERR_ACCESS_DENIED", PRL_ERR_ACCESS_DENIED );
	PyModule_AddIntConstant( module, "PRL_ERR_BUFFER_OVERRUN", PRL_ERR_BUFFER_OVERRUN );
	PyModule_AddIntConstant( module, "PRL_ERR_UNINITIALIZED", PRL_ERR_UNINITIALIZED );
	PyModule_AddIntConstant( module, "PRL_ERR_UNIMPLEMENTED", PRL_ERR_UNIMPLEMENTED );
	PyModule_AddIntConstant( module, "PRL_ERR_FAILURE", PRL_ERR_FAILURE );
	PyModule_AddIntConstant( module, "PRL_ERR_FILE_NOT_FOUND", PRL_ERR_FILE_NOT_FOUND );
	PyModule_AddIntConstant( module, "PRL_ERR_DOUBLE_INIT", PRL_ERR_DOUBLE_INIT );
	PyModule_AddIntConstant( module, "PRL_ERR_SYMBOL_NOT_FOUND", PRL_ERR_SYMBOL_NOT_FOUND );
	PyModule_AddIntConstant( module, "PRL_ERR_OPERATION_PENDING", PRL_ERR_OPERATION_PENDING );
	PyModule_AddIntConstant( module, "PRL_ERR_NO_DATA", PRL_ERR_NO_DATA );
	PyModule_AddIntConstant( module, "PRL_ERR_TIMEOUT", PRL_ERR_TIMEOUT );
	PyModule_AddIntConstant( module, "PRL_ERR_OPERATION_FAILED", PRL_ERR_OPERATION_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_PARAM_NOT_FOUND", PRL_ERR_PARAM_NOT_FOUND );
	PyModule_AddIntConstant( module, "PRL_ERR_INVALID_PARAM", PRL_ERR_INVALID_PARAM );
	PyModule_AddIntConstant( module, "PRL_ERR_NO_DISP_CONFIG_FOUND", PRL_ERR_NO_DISP_CONFIG_FOUND );
	PyModule_AddIntConstant( module, "PRL_ERR_BAD_DISP_CONFIG_FILE_SPECIFIED", PRL_ERR_BAD_DISP_CONFIG_FILE_SPECIFIED );
	PyModule_AddIntConstant( module, "PRL_ERR_OPEN_DISP_CONFIG_READ", PRL_ERR_OPEN_DISP_CONFIG_READ );
	PyModule_AddIntConstant( module, "PRL_ERR_OPEN_DISP_CONFIG_WRITE", PRL_ERR_OPEN_DISP_CONFIG_WRITE );
	PyModule_AddIntConstant( module, "PRL_ERR_PARSE_DISP_CONFIG", PRL_ERR_PARSE_DISP_CONFIG );
	PyModule_AddIntConstant( module, "PRL_ERR_PARSING_EVENT", PRL_ERR_PARSING_EVENT );
	PyModule_AddIntConstant( module, "PRL_ERR_DISP_CONFIG_ALREADY_EXISTS", PRL_ERR_DISP_CONFIG_ALREADY_EXISTS );
	PyModule_AddIntConstant( module, "PRL_ERR_NO_VM_DIR_CONFIG_FOUND", PRL_ERR_NO_VM_DIR_CONFIG_FOUND );
	PyModule_AddIntConstant( module, "PRL_ERR_BAD_VM_DIR_CONFIG_FILE_SPECIFIED", PRL_ERR_BAD_VM_DIR_CONFIG_FILE_SPECIFIED );
	PyModule_AddIntConstant( module, "PRL_ERR_OPEN_VM_DIR_CONFIG_READ", PRL_ERR_OPEN_VM_DIR_CONFIG_READ );
	PyModule_AddIntConstant( module, "PRL_ERR_OPEN_VM_DIR_CONFIG_WRITE", PRL_ERR_OPEN_VM_DIR_CONFIG_WRITE );
	PyModule_AddIntConstant( module, "PRL_ERR_PARSE_VM_DIR_CONFIG", PRL_ERR_PARSE_VM_DIR_CONFIG );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_DIR_CONFIG_ALREADY_EXISTS", PRL_ERR_VM_DIR_CONFIG_ALREADY_EXISTS );
	PyModule_AddIntConstant( module, "PRL_ERR_BAD_VM_CONFIG_FILE_SPECIFIED", PRL_ERR_BAD_VM_CONFIG_FILE_SPECIFIED );
	PyModule_AddIntConstant( module, "PRL_ERR_OPEN_VM_CONFIG_READ", PRL_ERR_OPEN_VM_CONFIG_READ );
	PyModule_AddIntConstant( module, "PRL_ERR_OPEN_VM_CONFIG_WRITE", PRL_ERR_OPEN_VM_CONFIG_WRITE );
	PyModule_AddIntConstant( module, "PRL_ERR_READ_XML_CONTENT", PRL_ERR_READ_XML_CONTENT );
	PyModule_AddIntConstant( module, "PRL_ERR_PARSE_VM_CONFIG", PRL_ERR_PARSE_VM_CONFIG );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_CONFIG_ALREADY_EXISTS", PRL_ERR_VM_CONFIG_ALREADY_EXISTS );
	PyModule_AddIntConstant( module, "PRL_ERR_CONFIG_FILE_NOT_SET", PRL_ERR_CONFIG_FILE_NOT_SET );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_DIR_FILE_NOT_SET", PRL_ERR_VM_DIR_FILE_NOT_SET );
	PyModule_AddIntConstant( module, "PRL_ERR_DISP_CONFIG_FILE_NOT_SET", PRL_ERR_DISP_CONFIG_FILE_NOT_SET );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_START_FAILED", PRL_ERR_VM_START_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_SET_LICENSE_FAILED", PRL_ERR_VM_SET_LICENSE_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_SET_CONFIG_FAILED", PRL_ERR_VM_SET_CONFIG_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_POWER_ON_FAILED", PRL_ERR_VM_POWER_ON_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_POWER_OFF_FAILED", PRL_ERR_VM_POWER_OFF_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_RESET_FAILED", PRL_ERR_VM_RESET_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_GET_STATUS_FAILED", PRL_ERR_VM_GET_STATUS_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_GET_PROBLEM_REPORT_FAILED", PRL_ERR_VM_GET_PROBLEM_REPORT_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_GET_CONFIG_FAILED", PRL_ERR_VM_GET_CONFIG_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_ALREADY_SUSPENDED", PRL_ERR_VM_ALREADY_SUSPENDED );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_PAUSE_FAILED", PRL_ERR_VM_PAUSE_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_ALREADY_RESUMED", PRL_ERR_VM_ALREADY_RESUMED );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_SAVE_STATE_FAILED", PRL_ERR_VM_SAVE_STATE_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_CREATE_SNAPSHOT_FAILED", PRL_ERR_VM_CREATE_SNAPSHOT_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_RESTORE_STATE_FAILED", PRL_ERR_VM_RESTORE_STATE_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_DEV_CONNECT_FAILED", PRL_ERR_VM_DEV_CONNECT_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_DEV_DISCONNECT_FAILED", PRL_ERR_VM_DEV_DISCONNECT_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_DEV_CHANGE_MEDIA_FAILED", PRL_ERR_VM_DEV_CHANGE_MEDIA_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_GET_DEVICE_STATE_FAILED", PRL_ERR_VM_GET_DEVICE_STATE_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_USER_OPERATION_NOT_AUTHORISED", PRL_ERR_USER_OPERATION_NOT_AUTHORISED );
	PyModule_AddIntConstant( module, "PRL_ERR_ACCESS_TOKEN_INVALID", PRL_ERR_ACCESS_TOKEN_INVALID );
	PyModule_AddIntConstant( module, "PRL_ERR_USER_IS_ALREADY_LOGGED", PRL_ERR_USER_IS_ALREADY_LOGGED );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_ALREADY_REGISTERED_VM_UUID", PRL_ERR_VM_ALREADY_REGISTERED_VM_UUID );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_ALREADY_REGISTERED_VM_PATH", PRL_ERR_VM_ALREADY_REGISTERED_VM_PATH );
	PyModule_AddIntConstant( module, "PRL_ERR_PREV_SESSION_IS_ACTIVE", PRL_ERR_PREV_SESSION_IS_ACTIVE );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_DIRECTORY_NOT_INITIALIZED", PRL_ERR_VM_DIRECTORY_NOT_INITIALIZED );
	PyModule_AddIntConstant( module, "PRL_ERR_DISP_CONFIG_WRITE_ERR", PRL_ERR_DISP_CONFIG_WRITE_ERR );
	PyModule_AddIntConstant( module, "PRL_ERR_USER_DIRECTORY_NOT_SET", PRL_ERR_USER_DIRECTORY_NOT_SET );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_PROCESS_IS_NOT_STARTED", PRL_ERR_VM_PROCESS_IS_NOT_STARTED );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_OPERATION_FAILED", PRL_ERR_VM_OPERATION_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_PARSE_HOST_HW_INFO", PRL_ERR_PARSE_HOST_HW_INFO );
	PyModule_AddIntConstant( module, "PRL_ERR_PARSE_HARD_DISK_HW_INFO", PRL_ERR_PARSE_HARD_DISK_HW_INFO );
	PyModule_AddIntConstant( module, "PRL_ERR_PARSE_FILESYSTEM_INFO", PRL_ERR_PARSE_FILESYSTEM_INFO );
	PyModule_AddIntConstant( module, "PRL_ERR_PARSE_USER_PROFILE", PRL_ERR_PARSE_USER_PROFILE );
	PyModule_AddIntConstant( module, "PRL_ERR_NO_TARGET_PATH_SPECIFIED", PRL_ERR_NO_TARGET_PATH_SPECIFIED );
	PyModule_AddIntConstant( module, "PRL_ERR_DIRECTORY_DOES_NOT_EXIST", PRL_ERR_DIRECTORY_DOES_NOT_EXIST );
	PyModule_AddIntConstant( module, "PRL_ERR_TARGET_PATH_IS_NOT_DIRECTORY", PRL_ERR_TARGET_PATH_IS_NOT_DIRECTORY );
	PyModule_AddIntConstant( module, "PRL_ERR_TARGET_NAME_ALREADY_OCCUPIED", PRL_ERR_TARGET_NAME_ALREADY_OCCUPIED );
	PyModule_AddIntConstant( module, "PRL_ERR_ACCESS_DENIED_TO_DISK_IMAGE", PRL_ERR_ACCESS_DENIED_TO_DISK_IMAGE );
	PyModule_AddIntConstant( module, "PRL_ERR_ENTRY_DOES_NOT_EXIST", PRL_ERR_ENTRY_DOES_NOT_EXIST );
	PyModule_AddIntConstant( module, "PRL_ERR_ENTRY_ALREADY_EXISTS", PRL_ERR_ENTRY_ALREADY_EXISTS );
	PyModule_AddIntConstant( module, "PRL_ERR_CANT_RENAME_ENTRY", PRL_ERR_CANT_RENAME_ENTRY );
	PyModule_AddIntConstant( module, "PRL_ERR_CANT_REMOVE_ENTRY", PRL_ERR_CANT_REMOVE_ENTRY );
	PyModule_AddIntConstant( module, "PRL_ERR_BAD_PARAMETERS", PRL_ERR_BAD_PARAMETERS );
	PyModule_AddIntConstant( module, "PRL_ERR_PARSE_PROBLEM_REPORT", PRL_ERR_PARSE_PROBLEM_REPORT );
	PyModule_AddIntConstant( module, "PRL_ERR_NO_PROBLEM_REPORT_FOUND", PRL_ERR_NO_PROBLEM_REPORT_FOUND );
	PyModule_AddIntConstant( module, "PRL_ERR_OPEN_PROBLEM_REPORT_READ", PRL_ERR_OPEN_PROBLEM_REPORT_READ );
	PyModule_AddIntConstant( module, "PRL_ERR_PROBLEM_REPORT_FILE_NOTSET", PRL_ERR_PROBLEM_REPORT_FILE_NOTSET );
	PyModule_AddIntConstant( module, "PRL_ERR_PROBLEM_REPORT_ALREADY_EXISTS", PRL_ERR_PROBLEM_REPORT_ALREADY_EXISTS );
	PyModule_AddIntConstant( module, "PRL_ERR_PROBLEM_REPORT_WRITE", PRL_ERR_PROBLEM_REPORT_WRITE );
	PyModule_AddIntConstant( module, "PRL_ERR_SAVE_VM_CATALOG", PRL_ERR_SAVE_VM_CATALOG );
	PyModule_AddIntConstant( module, "PRL_ERR_UNRECOGNIZED_REQUEST", PRL_ERR_UNRECOGNIZED_REQUEST );
	PyModule_AddIntConstant( module, "PRL_ERR_TASK_NOT_FOUND", PRL_ERR_TASK_NOT_FOUND );
	PyModule_AddIntConstant( module, "PRL_ERR_HDD_IMAGE_NOT_EXIST", PRL_ERR_HDD_IMAGE_NOT_EXIST );
	PyModule_AddIntConstant( module, "PRL_ERR_HDD_IMAGE_CLONE_TO_SELF", PRL_ERR_HDD_IMAGE_CLONE_TO_SELF );
	PyModule_AddIntConstant( module, "PRL_ERR_FLOPPY_IMAGE_NOT_EXIST", PRL_ERR_FLOPPY_IMAGE_NOT_EXIST );
	PyModule_AddIntConstant( module, "PRL_ERR_SERIAL_PORT_IMAGE_NOT_EXIST", PRL_ERR_SERIAL_PORT_IMAGE_NOT_EXIST );
	PyModule_AddIntConstant( module, "PRL_ERR_PARALLEL_PORT_IMAGE_NOT_EXIST", PRL_ERR_PARALLEL_PORT_IMAGE_NOT_EXIST );
	PyModule_AddIntConstant( module, "PRL_ERR_CANT_CREATE_HDD_IMAGE", PRL_ERR_CANT_CREATE_HDD_IMAGE );
	PyModule_AddIntConstant( module, "PRL_ERR_CANT_CREATE_FLOPPY_IMAGE", PRL_ERR_CANT_CREATE_FLOPPY_IMAGE );
	PyModule_AddIntConstant( module, "PRL_ERR_ACCES_DENIED_FILE_TO_PARENT_PARENT_DIR", PRL_ERR_ACCES_DENIED_FILE_TO_PARENT_PARENT_DIR );
	PyModule_AddIntConstant( module, "PRL_ERR_CANT_CREATE_PARALLEL_PORT_IMAGE", PRL_ERR_CANT_CREATE_PARALLEL_PORT_IMAGE );
	PyModule_AddIntConstant( module, "PRL_ERR_NOT_ALL_FILES_WAS_DELETED", PRL_ERR_NOT_ALL_FILES_WAS_DELETED );
	PyModule_AddIntConstant( module, "PRL_ERR_UNABLE_DROP_SUSPENDED_STATE", PRL_ERR_UNABLE_DROP_SUSPENDED_STATE );
	PyModule_AddIntConstant( module, "PRL_ERR_CANT_EDIT_SUSPENDED_VM", PRL_ERR_CANT_EDIT_SUSPENDED_VM );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_UUID_NOT_FOUND", PRL_ERR_VM_UUID_NOT_FOUND );
	PyModule_AddIntConstant( module, "PRL_ERR_INCONSISTENCY_VM_CONFIG", PRL_ERR_INCONSISTENCY_VM_CONFIG );
	PyModule_AddIntConstant( module, "PRL_ERR_CLONE_OPERATION_CANCELED", PRL_ERR_CLONE_OPERATION_CANCELED );
	PyModule_AddIntConstant( module, "PRL_ERR_SEARCH_CONFIG_OPERATION_CANCELED", PRL_ERR_SEARCH_CONFIG_OPERATION_CANCELED );
	PyModule_AddIntConstant( module, "PRL_ERR_CANT_ALOCA_MEM_FILE_COPY", PRL_ERR_CANT_ALOCA_MEM_FILE_COPY );
	PyModule_AddIntConstant( module, "PRL_ERR_FILE_READ_ERROR", PRL_ERR_FILE_READ_ERROR );
	PyModule_AddIntConstant( module, "PRL_ERR_SMC_ERROR", PRL_ERR_SMC_ERROR );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_CONFIG_WAS_CHANGED", PRL_ERR_VM_CONFIG_WAS_CHANGED );
	PyModule_AddIntConstant( module, "PRL_ERR_RETURN_CODE_RANG_EEND", PRL_ERR_RETURN_CODE_RANG_EEND );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_ALREADY_REGISTERED_UNIQUE_PARAMS", PRL_ERR_VM_ALREADY_REGISTERED_UNIQUE_PARAMS );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_ALREADY_REGISTERED_VM_NAME", PRL_ERR_VM_ALREADY_REGISTERED_VM_NAME );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_NAME_IS_EMPTY", PRL_ERR_VM_NAME_IS_EMPTY );
	PyModule_AddIntConstant( module, "PRL_ERR_PARSE_CLIENT_PREFS", PRL_ERR_PARSE_CLIENT_PREFS );
	PyModule_AddIntConstant( module, "PRL_ERR_USER_PROFILE_WAS_CHANGED", PRL_ERR_USER_PROFILE_WAS_CHANGED );
	PyModule_AddIntConstant( module, "PRL_ERR_USER_CANT_CHANGE_ACCESS_PROFILE", PRL_ERR_USER_CANT_CHANGE_ACCESS_PROFILE );
	PyModule_AddIntConstant( module, "PRL_ERR_USER_CANT_CHANGE_READ_ONLY_VALUE", PRL_ERR_USER_CANT_CHANGE_READ_ONLY_VALUE );
	PyModule_AddIntConstant( module, "PRL_ERR_PARSE_COMMON_SERVER_PREFS", PRL_ERR_PARSE_COMMON_SERVER_PREFS );
	PyModule_AddIntConstant( module, "PRL_ERR_COMMON_SERVER_PREFS_WERE_CHANGED", PRL_ERR_COMMON_SERVER_PREFS_WERE_CHANGED );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_CREATE_INVALID_ARG", PRL_ERR_VM_CREATE_INVALID_ARG );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_ALREADY_CREATED", PRL_ERR_VM_ALREADY_CREATED );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_NOT_CREATED", PRL_ERR_VM_NOT_CREATED );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_GET_STATUS_INVALID_ARG", PRL_ERR_VM_GET_STATUS_INVALID_ARG );
	PyModule_AddIntConstant( module, "PRL_ERR_GET_MON_STATE_VM_NOT_CREATED", PRL_ERR_GET_MON_STATE_VM_NOT_CREATED );
	PyModule_AddIntConstant( module, "PRL_ERR_GET_MON_STATE_INVALID_ARG", PRL_ERR_GET_MON_STATE_INVALID_ARG );
	PyModule_AddIntConstant( module, "PRL_ERR_GET_MON_STATE_VM_NOT_CONFIGURED", PRL_ERR_GET_MON_STATE_VM_NOT_CONFIGURED );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_GET_CONFIG_INVALID_ARG", PRL_ERR_VM_GET_CONFIG_INVALID_ARG );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_GET_CONFIG_NOT_CONFIGURED", PRL_ERR_VM_GET_CONFIG_NOT_CONFIGURED );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_SET_CONFIG_INVALID_ARG", PRL_ERR_VM_SET_CONFIG_INVALID_ARG );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_CONF_CHANGED_NOT_CREATED", PRL_ERR_VM_CONF_CHANGED_NOT_CREATED );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_CONF_CHANGED_INVALID_ARG", PRL_ERR_VM_CONF_CHANGED_INVALID_ARG );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_CONF_CHANGED_NOT_STARTED", PRL_ERR_VM_CONF_CHANGED_NOT_STARTED );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_CONF_CHANGED_UNSUPPORTED_DEV", PRL_ERR_VM_CONF_CHANGED_UNSUPPORTED_DEV );
	PyModule_AddIntConstant( module, "PRL_ERR_GET_LICENSE_INVALID_ARG", PRL_ERR_GET_LICENSE_INVALID_ARG );
	PyModule_AddIntConstant( module, "PRL_ERR_SET_LICENSE_INVALID_ARG", PRL_ERR_SET_LICENSE_INVALID_ARG );
	PyModule_AddIntConstant( module, "PRL_ERR_SET_LICENSE_INVALID_KEY", PRL_ERR_SET_LICENSE_INVALID_KEY );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_START_NOT_CREATED", PRL_ERR_VM_START_NOT_CREATED );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_START_NOT_CONFIGURED", PRL_ERR_VM_START_NOT_CONFIGURED );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_STOP_NOT_CREATED", PRL_ERR_VM_STOP_NOT_CREATED );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_RESTART_NOT_CREATED", PRL_ERR_VM_RESTART_NOT_CREATED );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_RESTART_NOT_STARTED", PRL_ERR_VM_RESTART_NOT_STARTED );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_PAUSE_NOT_CREATED", PRL_ERR_VM_PAUSE_NOT_CREATED );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_PAUSE_NOT_STARTED", PRL_ERR_VM_PAUSE_NOT_STARTED );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_PAUSE_ALREADY_PAUSED", PRL_ERR_VM_PAUSE_ALREADY_PAUSED );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_GET_SCR_SIZE_NOT_CREATED", PRL_ERR_VM_GET_SCR_SIZE_NOT_CREATED );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_GET_SCR_UPDATED_NOT_CREATED", PRL_ERR_VM_GET_SCR_UPDATED_NOT_CREATED );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_GET_SCR_UPDATED_NOT_RUNNING", PRL_ERR_VM_GET_SCR_UPDATED_NOT_RUNNING );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_SET_VISIBLE_NOT_CREATED", PRL_ERR_VM_SET_VISIBLE_NOT_CREATED );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_VIEW_SCR_NOT_CREATED", PRL_ERR_VM_VIEW_SCR_NOT_CREATED );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_VIEW_SCR_INVALID_ARG", PRL_ERR_VM_VIEW_SCR_INVALID_ARG );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_VIEW_SCR_NOT_RUNNING", PRL_ERR_VM_VIEW_SCR_NOT_RUNNING );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_SEND_REL_MOUSE_NOT_CREATED", PRL_ERR_VM_SEND_REL_MOUSE_NOT_CREATED );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_SEND_REL_MOUSE_NOT_RUNNING", PRL_ERR_VM_SEND_REL_MOUSE_NOT_RUNNING );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_SEND_REL_MOUSE_PAUSED", PRL_ERR_VM_SEND_REL_MOUSE_PAUSED );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_SEND_ABS_MOUSE_NOT_CREATED", PRL_ERR_VM_SEND_ABS_MOUSE_NOT_CREATED );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_SEND_ABS_MOUSE_NOT_RUNNING", PRL_ERR_VM_SEND_ABS_MOUSE_NOT_RUNNING );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_SEND_ABS_MOUSE_PAUSED", PRL_ERR_VM_SEND_ABS_MOUSE_PAUSED );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_SEND_KEYBOARD_NOT_CREATED", PRL_ERR_VM_SEND_KEYBOARD_NOT_CREATED );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_SEND_KEYBOARD_NOT_RUNNING", PRL_ERR_VM_SEND_KEYBOARD_NOT_RUNNING );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_SEND_KEYBOARD_PAUSED", PRL_ERR_VM_SEND_KEYBOARD_PAUSED );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_GET_INDICATORS_NOT_CREATED", PRL_ERR_VM_GET_INDICATORS_NOT_CREATED );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_GET_INDICATORS_INVALID_ARG", PRL_ERR_VM_GET_INDICATORS_INVALID_ARG );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_GET_INDICATORS_NOT_RUNNING", PRL_ERR_VM_GET_INDICATORS_NOT_RUNNING );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_CREATE_HDD_IMG_INVALID_ARG", PRL_ERR_VM_CREATE_HDD_IMG_INVALID_ARG );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_CREATE_HDD_IMG_INVALID_CREATE", PRL_ERR_VM_CREATE_HDD_IMG_INVALID_CREATE );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_GET_HDD_IMG_INVALID_ARG", PRL_ERR_VM_GET_HDD_IMG_INVALID_ARG );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_GET_HDD_IMG_NOT_OPEN", PRL_ERR_VM_GET_HDD_IMG_NOT_OPEN );
	PyModule_AddIntConstant( module, "PRL_ERR_UPDATE_MEM_VM_NOT_CREATED", PRL_ERR_UPDATE_MEM_VM_NOT_CREATED );
	PyModule_AddIntConstant( module, "PRL_ERR_UNABLE_SEND_REQUEST", PRL_ERR_UNABLE_SEND_REQUEST );
	PyModule_AddIntConstant( module, "PRL_ERR_UPD_TOOLS_VER_VM_NOT_CREATED", PRL_ERR_UPD_TOOLS_VER_VM_NOT_CREATED );
	PyModule_AddIntConstant( module, "PRL_ERR_UPD_TOOLS_VER_VM_NOT_CONFIGURED", PRL_ERR_UPD_TOOLS_VER_VM_NOT_CONFIGURED );
	PyModule_AddIntConstant( module, "PRL_ERR_GET_RESOLUTION_TOOL_VMNOTCREATED", PRL_ERR_GET_RESOLUTION_TOOL_VMNOTCREATED );
	PyModule_AddIntConstant( module, "PRL_ERR_GET_RESOLUTION_TOOL_INVALID_ARG", PRL_ERR_GET_RESOLUTION_TOOL_INVALID_ARG );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_HDD_SIZE", PRL_ERR_VM_HDD_SIZE );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_IN_HDD_CONSTRUCTOR", PRL_ERR_VM_IN_HDD_CONSTRUCTOR );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_UNABLE_TO_OPEN_VIRTUAL_BRIDGE", PRL_ERR_VM_UNABLE_TO_OPEN_VIRTUAL_BRIDGE );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_ASYNC_CD_CONSTRUCTOR", PRL_ERR_VM_ASYNC_CD_CONSTRUCTOR );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_UNABLE_OPEN_DISK_IMAGE", PRL_ERR_VM_UNABLE_OPEN_DISK_IMAGE );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_UNDEFINED_API_CALL", PRL_ERR_VM_UNDEFINED_API_CALL );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_UNABLE_SEND_REQUEST", PRL_ERR_VM_UNABLE_SEND_REQUEST );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_ALLOC_MEM_DRV_NOT_STARTED", PRL_ERR_VM_ALLOC_MEM_DRV_NOT_STARTED );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_ALLOC_VM_MEMORY", PRL_ERR_VM_ALLOC_VM_MEMORY );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_FREE_VM_MEMORY", PRL_ERR_VM_FREE_VM_MEMORY );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_INTERACT_PRLS_DRIVER", PRL_ERR_VM_INTERACT_PRLS_DRIVER );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_UNABLE_ALLOC_MEM", PRL_ERR_VM_UNABLE_ALLOC_MEM );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_MAP_VM_MEM0", PRL_ERR_VM_MAP_VM_MEM0 );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_INIT_MONITOR", PRL_ERR_VM_INIT_MONITOR );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_INIT_VCPU", PRL_ERR_VM_INIT_VCPU );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_UNABLE_GET_GUEST_CPU", PRL_ERR_VM_UNABLE_GET_GUEST_CPU );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_VALLOC_MON_BODY", PRL_ERR_VM_VALLOC_MON_BODY );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_VALLOC_PE_IMG", PRL_ERR_VM_VALLOC_PE_IMG );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_LOAD_MONITOR", PRL_ERR_VM_LOAD_MONITOR );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_UNABLE_ALLOC_MEM_MONITOR", PRL_ERR_VM_UNABLE_ALLOC_MEM_MONITOR );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_UNABLE_CREATE_TIMER", PRL_ERR_VM_UNABLE_CREATE_TIMER );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_HYPERVIZOR_COMM", PRL_ERR_VM_HYPERVIZOR_COMM );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_PRLS_DESCTOP_ALLOC_PHYS_MEM", PRL_ERR_VM_PRLS_DESCTOP_ALLOC_PHYS_MEM );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_MONITOR", PRL_ERR_VM_MONITOR );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_REQUEST_NOT_SUPPORTED", PRL_ERR_VM_REQUEST_NOT_SUPPORTED );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_BAD_OS_TYPE", PRL_ERR_VM_BAD_OS_TYPE );
	PyModule_AddIntConstant( module, "PRL_ERR_ALIGN_ON_4", PRL_ERR_ALIGN_ON_4 );
	PyModule_AddIntConstant( module, "PRL_ERR_INVALID_MEMORY_SIZE", PRL_ERR_INVALID_MEMORY_SIZE );
	PyModule_AddIntConstant( module, "PRL_ERR_EXCEED_MEMORY_LIMIT", PRL_ERR_EXCEED_MEMORY_LIMIT );
	PyModule_AddIntConstant( module, "PRL_ERR_HDD_IMAGE_NOT_SPECIFIED", PRL_ERR_HDD_IMAGE_NOT_SPECIFIED );
	PyModule_AddIntConstant( module, "PRL_ERR_INVALID_HDD_GEOMETRY", PRL_ERR_INVALID_HDD_GEOMETRY );
	PyModule_AddIntConstant( module, "PRL_ERR_CDD_IMAGE_NOT_SPECIFIED", PRL_ERR_CDD_IMAGE_NOT_SPECIFIED );
	PyModule_AddIntConstant( module, "PRL_ERR_FDD_IMAGE_NOT_SPECIFIED", PRL_ERR_FDD_IMAGE_NOT_SPECIFIED );
	PyModule_AddIntConstant( module, "PRL_ERR_MAC_ADDRESS_IS_EMPTY", PRL_ERR_MAC_ADDRESS_IS_EMPTY );
	PyModule_AddIntConstant( module, "PRL_ERR_MAC_ADDRESS_IN_CORRECT_LENGTH", PRL_ERR_MAC_ADDRESS_IN_CORRECT_LENGTH );
	PyModule_AddIntConstant( module, "PRL_ERR_MAC_ADDRESS_WITH_2_ZERO_START", PRL_ERR_MAC_ADDRESS_WITH_2_ZERO_START );
	PyModule_AddIntConstant( module, "PRL_ERR_MAC_ADDRESS_WITH_ALL_ZEROS", PRL_ERR_MAC_ADDRESS_WITH_ALL_ZEROS );
	PyModule_AddIntConstant( module, "PRL_ERR_MAC_ADDRESS_WITHIN_CORRECT_SYMBOLS", PRL_ERR_MAC_ADDRESS_WITHIN_CORRECT_SYMBOLS );
	PyModule_AddIntConstant( module, "PRL_ERR_COM_OUTPUT_FILE_IS_NOT_SPECIFIED", PRL_ERR_COM_OUTPUT_FILE_IS_NOT_SPECIFIED );
	PyModule_AddIntConstant( module, "PRL_ERR_LPT_OUTPUT_FILE_IS_NOT_SPECIFIED", PRL_ERR_LPT_OUTPUT_FILE_IS_NOT_SPECIFIED );
	PyModule_AddIntConstant( module, "PRL_ERR_COM_OUTPUT_FILE_NOT_EXIST", PRL_ERR_COM_OUTPUT_FILE_NOT_EXIST );
	PyModule_AddIntConstant( module, "PRL_ERR_LPT_OUTPUT_FILE_NOT_EXIST", PRL_ERR_LPT_OUTPUT_FILE_NOT_EXIST );
	PyModule_AddIntConstant( module, "PRL_QUEST_EXCEED_RECOMMENDED_MEMORY", PRL_QUEST_EXCEED_RECOMMENDED_MEMORY );
	PyModule_AddIntConstant( module, "PRL_QUEST_CDD_IMAGE_NOT_EXIST", PRL_QUEST_CDD_IMAGE_NOT_EXIST );
	PyModule_AddIntConstant( module, "PRL_QUEST_CD_DRIVE_NOT_EXIST", PRL_QUEST_CD_DRIVE_NOT_EXIST );
	PyModule_AddIntConstant( module, "PRL_QUEST_HDD_SAME_IMAGE", PRL_QUEST_HDD_SAME_IMAGE );
	PyModule_AddIntConstant( module, "PRL_QUEST_HDD_IMAGE_NOT_EXIST", PRL_QUEST_HDD_IMAGE_NOT_EXIST );
	PyModule_AddIntConstant( module, "PRL_QUEST_FDD_IMAGE_NOT_EXIST", PRL_QUEST_FDD_IMAGE_NOT_EXIST );
	PyModule_AddIntConstant( module, "PRL_QUEST_FDD_DRIVE_NOT_EXIST", PRL_QUEST_FDD_DRIVE_NOT_EXIST );
	PyModule_AddIntConstant( module, "PRL_ERR_FLOPPY_DRIVE_INVALID", PRL_ERR_FLOPPY_DRIVE_INVALID );
	PyModule_AddIntConstant( module, "PRL_ERR_FIXME", PRL_ERR_FIXME );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_HOME_PATH_IS_NOT_EMPTY", PRL_ERR_VM_HOME_PATH_IS_NOT_EMPTY );
	PyModule_AddIntConstant( module, "PRL_ERR_CANT_PARSE_VM_CONFIG", PRL_ERR_CANT_PARSE_VM_CONFIG );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_UUID_EMPTY", PRL_ERR_VM_UUID_EMPTY );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_EMPTY_NAME_OF_CLONE", PRL_ERR_VM_EMPTY_NAME_OF_CLONE );
	PyModule_AddIntConstant( module, "PRL_ERR_MAKE_DIRECTORY", PRL_ERR_MAKE_DIRECTORY );
	PyModule_AddIntConstant( module, "PRL_ERR_SERIAL_IMG_NOT_FOUND", PRL_ERR_SERIAL_IMG_NOT_FOUND );
	PyModule_AddIntConstant( module, "PRL_ERR_SAVE_VM_CONFIG", PRL_ERR_SAVE_VM_CONFIG );
	PyModule_AddIntConstant( module, "PRL_ERR_SERIAL_IMG_COPY", PRL_ERR_SERIAL_IMG_COPY );
	PyModule_AddIntConstant( module, "PRL_ERR_PARALLEL_PORT_IMG_COPY", PRL_ERR_PARALLEL_PORT_IMG_COPY );
	PyModule_AddIntConstant( module, "PRL_ERR_HDD_IMAGE_COPY", PRL_ERR_HDD_IMAGE_COPY );
	PyModule_AddIntConstant( module, "PRL_ERR_INSERTING_VM_TO_CATALOGUE", PRL_ERR_INSERTING_VM_TO_CATALOGUE );
	PyModule_AddIntConstant( module, "PRL_ERR_ACCESS_TO_VM_DENIED", PRL_ERR_ACCESS_TO_VM_DENIED );
	PyModule_AddIntConstant( module, "PRL_ERR_RETRIEVE_VM_CONFIG", PRL_ERR_RETRIEVE_VM_CONFIG );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_DOES_NOT_STOPPED", PRL_ERR_VM_DOES_NOT_STOPPED );
	PyModule_AddIntConstant( module, "PRL_ERR_CONCURRENT_COMMAND_EXECUTING", PRL_ERR_CONCURRENT_COMMAND_EXECUTING );
	PyModule_AddIntConstant( module, "PRL_ERR_GET_USER_HOME_DIR", PRL_ERR_GET_USER_HOME_DIR );
	PyModule_AddIntConstant( module, "PRL_ERR_CANT_PARSE_DISP_EVENT", PRL_ERR_CANT_PARSE_DISP_EVENT );
	PyModule_AddIntConstant( module, "PRL_ERR_INVALID_ACCESS_TOKEN_RECEIVED", PRL_ERR_INVALID_ACCESS_TOKEN_RECEIVED );
	PyModule_AddIntConstant( module, "PRL_ERR_WS_DISP_CONNECTION_CLOSED", PRL_ERR_WS_DISP_CONNECTION_CLOSED );
	PyModule_AddIntConstant( module, "PRL_ERR_SHUT_DOWN_NOT_IFICATION_SERVICE", PRL_ERR_SHUT_DOWN_NOT_IFICATION_SERVICE );
	PyModule_AddIntConstant( module, "PRL_ERR_SERVER_GOES_DOWN", PRL_ERR_SERVER_GOES_DOWN );
	PyModule_AddIntConstant( module, "PRL_ERR_CANT_CONNECT_TO_DISPATCHER", PRL_ERR_CANT_CONNECT_TO_DISPATCHER );
	PyModule_AddIntConstant( module, "PRL_ERR_SEND_COMMAND_TOWS_FAILED", PRL_ERR_SEND_COMMAND_TOWS_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_NOT_CONNECTED_TO_DISPATCHER", PRL_ERR_NOT_CONNECTED_TO_DISPATCHER );
	PyModule_AddIntConstant( module, "PRL_ERR_ALREADY_CONNECTED_TO_DISPATCHER", PRL_ERR_ALREADY_CONNECTED_TO_DISPATCHER );
	PyModule_AddIntConstant( module, "PRL_ERR_DELETING_VM_FROM_CATALOGUE", PRL_ERR_DELETING_VM_FROM_CATALOGUE );
	PyModule_AddIntConstant( module, "PRL_ERR_COM_DEVICE_ALREADY_EXIST", PRL_ERR_COM_DEVICE_ALREADY_EXIST );
	PyModule_AddIntConstant( module, "PRL_ERR_LPT_DEVICE_ALREADY_EXIST", PRL_ERR_LPT_DEVICE_ALREADY_EXIST );
	PyModule_AddIntConstant( module, "PRL_ERR_FLOPPY_IMAGE_ALREADY_EXIST", PRL_ERR_FLOPPY_IMAGE_ALREADY_EXIST );
	PyModule_AddIntConstant( module, "PRL_ERR_USER_NO_AUTH_TO_EDIT_SERVER_SETTINGS", PRL_ERR_USER_NO_AUTH_TO_EDIT_SERVER_SETTINGS );
	PyModule_AddIntConstant( module, "PRL_ERR_UNDER_OLD_HYPERVISOR", PRL_ERR_UNDER_OLD_HYPERVISOR );
	PyModule_AddIntConstant( module, "PRL_ERR_USER_CANT_CHANGE_PROFILE_ACCESS_PART", PRL_ERR_USER_CANT_CHANGE_PROFILE_ACCESS_PART );
	PyModule_AddIntConstant( module, "PRL_ERR_TOO_LOW_HDD_SIZE", PRL_ERR_TOO_LOW_HDD_SIZE );
	PyModule_AddIntConstant( module, "PRL_WARN_LAN_NOT_CONNECTED", PRL_WARN_LAN_NOT_CONNECTED );
	PyModule_AddIntConstant( module, "PRL_WARN_UNABLE_OPEN_DEVICE_NAME", PRL_WARN_UNABLE_OPEN_DEVICE_NAME );
	PyModule_AddIntConstant( module, "PRL_WARN_UNABLE_OPEN_DEVICE", PRL_WARN_UNABLE_OPEN_DEVICE );
	PyModule_AddIntConstant( module, "PRL_WARN_IMAGE_IS_STOLEN", PRL_WARN_IMAGE_IS_STOLEN );
	PyModule_AddIntConstant( module, "PRL_WARN_TARGET_HOST_DISK_IS_FULL", PRL_WARN_TARGET_HOST_DISK_IS_FULL );
	PyModule_AddIntConstant( module, "PRL_WARN_UNKNOWN_HDD_REQUEST_TYPE", PRL_WARN_UNKNOWN_HDD_REQUEST_TYPE );
	PyModule_AddIntConstant( module, "PRL_WARN_FAT32_FILE_OVERRUN", PRL_WARN_FAT32_FILE_OVERRUN );
	PyModule_AddIntConstant( module, "PRL_WARN_HDD_ERROR", PRL_WARN_HDD_ERROR );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_INTERNAL_OS_ERROR", PRL_ERR_VM_INTERNAL_OS_ERROR );
	PyModule_AddIntConstant( module, "PRL_ERR_NETWORK_ROLLBACK_FAILED", PRL_ERR_NETWORK_ROLLBACK_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_COMMON_SERVER_PREFS_BLOCKED_TO_CHANGE", PRL_ERR_COMMON_SERVER_PREFS_BLOCKED_TO_CHANGE );
	PyModule_AddIntConstant( module, "PRL_ERR_CANT_INIT_REAL_CPUS_INFO", PRL_ERR_CANT_INIT_REAL_CPUS_INFO );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_DEVICES_INITIALIZATION_FAILED", PRL_ERR_VM_DEVICES_INITIALIZATION_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_DEVICES_TERMINATION_FAILED", PRL_ERR_VM_DEVICES_TERMINATION_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_OPERATION_WAS_CANCELED", PRL_ERR_OPERATION_WAS_CANCELED );
	PyModule_AddIntConstant( module, "PRL_ERR_PARSE_STATISTICS", PRL_ERR_PARSE_STATISTICS );
	PyModule_AddIntConstant( module, "PRL_ERR_WRONG_CONNECTION_SECURITY_LEVEL", PRL_ERR_WRONG_CONNECTION_SECURITY_LEVEL );
	PyModule_AddIntConstant( module, "PRL_ERR_REMOTE_DEVICE_NOT_REGISTERED", PRL_ERR_REMOTE_DEVICE_NOT_REGISTERED );
	PyModule_AddIntConstant( module, "PRL_ERR_REMOTE_DEVICE_EXIST", PRL_ERR_REMOTE_DEVICE_EXIST );
	PyModule_AddIntConstant( module, "PRL_ERR_REMOTE_DEVICE_NOT_EXIST", PRL_ERR_REMOTE_DEVICE_NOT_EXIST );
	PyModule_AddIntConstant( module, "PRL_ERR_CANT_CHANGE_OWNER_OF_FILE", PRL_ERR_CANT_CHANGE_OWNER_OF_FILE );
	PyModule_AddIntConstant( module, "PRL_ERR_CANT_DELETE_FILE", PRL_ERR_CANT_DELETE_FILE );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_CONFIG_DOESNT_EXIST", PRL_ERR_VM_CONFIG_DOESNT_EXIST );
	PyModule_AddIntConstant( module, "PRL_ERR_INSTALLATION_PROBLEM", PRL_ERR_INSTALLATION_PROBLEM );
	PyModule_AddIntConstant( module, "PRL_ERR_VMDIR_INVALID_PATH", PRL_ERR_VMDIR_INVALID_PATH );
	PyModule_AddIntConstant( module, "PRL_ERR_VMDIR_PATH_IS_NOT_ABSOLUTE", PRL_ERR_VMDIR_PATH_IS_NOT_ABSOLUTE );
	PyModule_AddIntConstant( module, "PRL_ERR_API_WASNT_INITIALIZED", PRL_ERR_API_WASNT_INITIALIZED );
	PyModule_AddIntConstant( module, "PRL_ERR_HDD_IMAGE_IS_ALREADY_EXIST", PRL_ERR_HDD_IMAGE_IS_ALREADY_EXIST );
	PyModule_AddIntConstant( module, "PRL_WARN_TOO_LOW_HDD_SIZE", PRL_WARN_TOO_LOW_HDD_SIZE );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_APPLY_CONFIG_FAILED", PRL_ERR_VM_APPLY_CONFIG_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_APPLY_CONFIG_NEEDS_REBOOT", PRL_ERR_VM_APPLY_CONFIG_NEEDS_REBOOT );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_CANT_CLONE_RUNNING", PRL_ERR_VM_CANT_CLONE_RUNNING );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_CANT_DELETE_RUNNING", PRL_ERR_VM_CANT_DELETE_RUNNING );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_CANT_UNREG_RUNNING", PRL_ERR_VM_CANT_UNREG_RUNNING );
	PyModule_AddIntConstant( module, "PRL_ERR_COULDNT_CREATE_AUTHORIZATION_FILE", PRL_ERR_COULDNT_CREATE_AUTHORIZATION_FILE );
	PyModule_AddIntConstant( module, "PRL_ERR_COULDNT_SET_PERMISSIONS_TO_AUTHORIZATION_FILE", PRL_ERR_COULDNT_SET_PERMISSIONS_TO_AUTHORIZATION_FILE );
	PyModule_AddIntConstant( module, "PRL_ERR_OUT_OF_DISK_SPACE", PRL_ERR_OUT_OF_DISK_SPACE );
	PyModule_AddIntConstant( module, "PRL_ERR_NOT_ENOUGH_PERMS_TO_OPEN_AUTHORIZATION_FILE", PRL_ERR_NOT_ENOUGH_PERMS_TO_OPEN_AUTHORIZATION_FILE );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_SPECIFY_GUEST_INSTALL_FILES", PRL_ERR_VM_SPECIFY_GUEST_INSTALL_FILES );
	PyModule_AddIntConstant( module, "PRL_ERR_IO_SEND_QUEUE_IS_FULL", PRL_ERR_IO_SEND_QUEUE_IS_FULL );
	PyModule_AddIntConstant( module, "PRL_ERR_IO_STOPPED", PRL_ERR_IO_STOPPED );
	PyModule_AddIntConstant( module, "PRL_ERR_IO_UNKNOWN_VM_ID", PRL_ERR_IO_UNKNOWN_VM_ID );
	PyModule_AddIntConstant( module, "PRL_ERR_IO_CONNECTION_TIMEOUT", PRL_ERR_IO_CONNECTION_TIMEOUT );
	PyModule_AddIntConstant( module, "PRL_ERR_IO_AUTHENTICATION_FAILED", PRL_ERR_IO_AUTHENTICATION_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_FILES_ALREADY_REMOVED", PRL_ERR_VM_FILES_ALREADY_REMOVED );
	PyModule_AddIntConstant( module, "PRL_ERR_CAN_NOT_GET_DISK_FREE_SPACE", PRL_ERR_CAN_NOT_GET_DISK_FREE_SPACE );
	PyModule_AddIntConstant( module, "PRL_QUESTION_CAN_NOT_GET_DISK_FREE_SPACE", PRL_QUESTION_CAN_NOT_GET_DISK_FREE_SPACE );
	PyModule_AddIntConstant( module, "PRL_ERR_NOT_ENOUGH_DISK_FREE_SPACE", PRL_ERR_NOT_ENOUGH_DISK_FREE_SPACE );
	PyModule_AddIntConstant( module, "PRL_ERR_CANT_CONVERT_VM_CONFIG_DUE_UNDO_DISKS_PRESENT", PRL_ERR_CANT_CONVERT_VM_CONFIG_DUE_UNDO_DISKS_PRESENT );
	PyModule_AddIntConstant( module, "PRL_ERR_CANT_CONVERT_VM_CONFIG_DUE_UNDO_SNAPSHOTS_PRESENT", PRL_ERR_CANT_CONVERT_VM_CONFIG_DUE_UNDO_SNAPSHOTS_PRESENT );
	PyModule_AddIntConstant( module, "PRL_ERR_CANT_CONVERT_HDD_IMAGE_FILE", PRL_ERR_CANT_CONVERT_HDD_IMAGE_FILE );
	PyModule_AddIntConstant( module, "PRL_QUEST_POWER_OFF", PRL_QUEST_POWER_OFF );
	PyModule_AddIntConstant( module, "PRL_QUEST_RESET", PRL_QUEST_RESET );
	PyModule_AddIntConstant( module, "PRL_ERR_USER_NO_AUTH_TO_SAVE_FILES", PRL_ERR_USER_NO_AUTH_TO_SAVE_FILES );
	PyModule_AddIntConstant( module, "PRL_ERR_FDD_IMAGE_COPY", PRL_ERR_FDD_IMAGE_COPY );
	PyModule_AddIntConstant( module, "PRL_ERR_FDD_IMAGE_CLONE_TO_SELF", PRL_ERR_FDD_IMAGE_CLONE_TO_SELF );
	PyModule_AddIntConstant( module, "PRL_ERR_USER_NO_AUTH_TO_CREATE_VM_IN_DIR", PRL_ERR_USER_NO_AUTH_TO_CREATE_VM_IN_DIR );
	PyModule_AddIntConstant( module, "PRL_ERR_ADD_HW_FLOPPY_IMAGE_NOT_SPECIFYED", PRL_ERR_ADD_HW_FLOPPY_IMAGE_NOT_SPECIFYED );
	PyModule_AddIntConstant( module, "PRL_ERR_WINDOWS_EXPRESS_INSTALL_USER_NAME_EMPTY", PRL_ERR_WINDOWS_EXPRESS_INSTALL_USER_NAME_EMPTY );
	PyModule_AddIntConstant( module, "PRL_ERR_ADD_VM_OPERATION_WAS_CANCELED", PRL_ERR_ADD_VM_OPERATION_WAS_CANCELED );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_CANT_CLONE_HDD_MISSING", PRL_ERR_VM_CANT_CLONE_HDD_MISSING );
	PyModule_AddIntConstant( module, "PRL_ERR_USER_NO_AUTH_TO_EDIT_VM", PRL_ERR_USER_NO_AUTH_TO_EDIT_VM );
	PyModule_AddIntConstant( module, "PRL_ERR_FILE_NOT_EXIST", PRL_ERR_FILE_NOT_EXIST );
	PyModule_AddIntConstant( module, "PRL_ERR_CONFIG_EDIT_COLLISION", PRL_ERR_CONFIG_EDIT_COLLISION );
	PyModule_AddIntConstant( module, "PRL_ERR_INCORRECT_PATH", PRL_ERR_INCORRECT_PATH );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_ABORT", PRL_ERR_VM_ABORT );
	PyModule_AddIntConstant( module, "PRL_ERR_SERVER_PREFS_EDIT_COLLISION", PRL_ERR_SERVER_PREFS_EDIT_COLLISION );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_DIRECTORY_NOT_EXIST", PRL_ERR_VM_DIRECTORY_NOT_EXIST );
	PyModule_AddIntConstant( module, "PRL_ERR_MAC_ADDRESS_INCORRECT", PRL_ERR_MAC_ADDRESS_INCORRECT );
	PyModule_AddIntConstant( module, "PRL_ERR_CANT_RECREATE_HDD", PRL_ERR_CANT_RECREATE_HDD );
	PyModule_AddIntConstant( module, "PRL_ERR_AUTHENTICATION_FAILED", PRL_ERR_AUTHENTICATION_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_LOCAL_AUTHENTICATION_FAILED", PRL_ERR_LOCAL_AUTHENTICATION_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_CANT_UPDATE_DEVICE_INFO", PRL_ERR_CANT_UPDATE_DEVICE_INFO );
	PyModule_AddIntConstant( module, "PRL_ERR_CANT_REPLACE_FLOPPY_IMAGE", PRL_ERR_CANT_REPLACE_FLOPPY_IMAGE );
	PyModule_AddIntConstant( module, "PRL_ERR_NO_BOOTING_DEVICE_SELECTED", PRL_ERR_NO_BOOTING_DEVICE_SELECTED );
	PyModule_AddIntConstant( module, "PRL_ERR_INCORRECT_FDD_PATH", PRL_ERR_INCORRECT_FDD_PATH );
	PyModule_AddIntConstant( module, "PRL_ERR_HVT_NOT_PRESENT", PRL_ERR_HVT_NOT_PRESENT );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_TO_REGISTER_IS_NOT_SPECIFIED", PRL_ERR_VM_TO_REGISTER_IS_NOT_SPECIFIED );
	PyModule_AddIntConstant( module, "PRL_ERR_CANT_CONFIGURE_PHYSICAL_HDD", PRL_ERR_CANT_CONFIGURE_PHYSICAL_HDD );
	PyModule_AddIntConstant( module, "PRL_ERR_CANT_CHANGE_FILE_PERMISSIONS", PRL_ERR_CANT_CHANGE_FILE_PERMISSIONS );
	PyModule_AddIntConstant( module, "PRL_ERR_IO_DISABLED", PRL_ERR_IO_DISABLED );
	PyModule_AddIntConstant( module, "PRL_ERR_HVT_DISABLED", PRL_ERR_HVT_DISABLED );
	PyModule_AddIntConstant( module, "PRL_ERR_VTX_ENABLED_ONLY_IN_SMX", PRL_ERR_VTX_ENABLED_ONLY_IN_SMX );
	PyModule_AddIntConstant( module, "PRL_ERR_DEV_DISABLE_AFTER_LOST", PRL_ERR_DEV_DISABLE_AFTER_LOST );
	PyModule_AddIntConstant( module, "PRL_ERR_REMOTE_DISPLAY_HOST_NOT_SPECIFIED", PRL_ERR_REMOTE_DISPLAY_HOST_NOT_SPECIFIED );
	PyModule_AddIntConstant( module, "PRL_ERR_REMOTE_DISPLAY_WRONG_PORT_NUMBER", PRL_ERR_REMOTE_DISPLAY_WRONG_PORT_NUMBER );
	PyModule_AddIntConstant( module, "PRL_ERR_CONFIG_BEGIN_EDIT_NOT_FOUND_OBJECT_UUID", PRL_ERR_CONFIG_BEGIN_EDIT_NOT_FOUND_OBJECT_UUID );
	PyModule_AddIntConstant( module, "PRL_ERR_CONFIG_BEGIN_EDIT_NOT_FOUND_USER_UUID", PRL_ERR_CONFIG_BEGIN_EDIT_NOT_FOUND_USER_UUID );
	PyModule_AddIntConstant( module, "PRL_ERR_HOST_AMD_GUEST_MAC", PRL_ERR_HOST_AMD_GUEST_MAC );
	PyModule_AddIntConstant( module, "PRL_ERR_ATTACH_TO_TASK_BAD_SESSION", PRL_ERR_ATTACH_TO_TASK_BAD_SESSION );
	PyModule_AddIntConstant( module, "PRL_ERR_IMPERSONATE_FAILED", PRL_ERR_IMPERSONATE_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_REVERT_IMPERSONATE_FAILED", PRL_ERR_REVERT_IMPERSONATE_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_REBOOT_HOST", PRL_ERR_REBOOT_HOST );
	PyModule_AddIntConstant( module, "PRL_ERR_GET_NET_SERVICE_STATUS_FAILED", PRL_ERR_GET_NET_SERVICE_STATUS_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_X64GUEST_ON_X32HOST", PRL_ERR_X64GUEST_ON_X32HOST );
	PyModule_AddIntConstant( module, "PRL_ERR_FILE_OR_DIR_ALREADY_EXISTS", PRL_ERR_FILE_OR_DIR_ALREADY_EXISTS );
	PyModule_AddIntConstant( module, "PRL_ERR_READONLY_FILESYSTEM", PRL_ERR_READONLY_FILESYSTEM );
	PyModule_AddIntConstant( module, "PRL_ERR_X64GUEST_ON_X64VM_HVT_DISABLED", PRL_ERR_X64GUEST_ON_X64VM_HVT_DISABLED );
	PyModule_AddIntConstant( module, "PRL_ERR_GUEST_MAC_NOT_ENOUGH_MEMORY", PRL_ERR_GUEST_MAC_NOT_ENOUGH_MEMORY );
	PyModule_AddIntConstant( module, "PRL_ERR_GUEST_MAC_INVALID_VERSION", PRL_ERR_GUEST_MAC_INVALID_VERSION );
	PyModule_AddIntConstant( module, "PRL_ERR_ACCESS_DENINED_TO_RUN_WIZARD", PRL_ERR_ACCESS_DENINED_TO_RUN_WIZARD );
	PyModule_AddIntConstant( module, "PRL_ERR_ANOTHER_USER_SESSIONS_PRESENT", PRL_ERR_ANOTHER_USER_SESSIONS_PRESENT );
	PyModule_AddIntConstant( module, "PRL_ERR_SOME_VMS_RUNNING", PRL_ERR_SOME_VMS_RUNNING );
	PyModule_AddIntConstant( module, "PRL_ERR_SOME_TASKS_PRESENT", PRL_ERR_SOME_TASKS_PRESENT );
	PyModule_AddIntConstant( module, "PRL_ERR_DISPATCHER_SERVICE_MODE", PRL_ERR_DISPATCHER_SERVICE_MODE );
	PyModule_AddIntConstant( module, "PRL_ERR_INVALID_CONFIGURATION", PRL_ERR_INVALID_CONFIGURATION );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_APPLY_CHANGES_PENDING", PRL_ERR_VM_APPLY_CHANGES_PENDING );
	PyModule_AddIntConstant( module, "PRL_ERR_HVT_TURNED_OFF_IN_CONFIG", PRL_ERR_HVT_TURNED_OFF_IN_CONFIG );
	PyModule_AddIntConstant( module, "PRL_ERR_CANT_TO_START_VM_TEMPLATE", PRL_ERR_CANT_TO_START_VM_TEMPLATE );
	PyModule_AddIntConstant( module, "PRL_ERR_NO_MORE_FREE_INTERFACE_SLOTS", PRL_ERR_NO_MORE_FREE_INTERFACE_SLOTS );
	PyModule_AddIntConstant( module, "PRL_ERR_TOOLS_UNSUPPORTED_GUEST", PRL_ERR_TOOLS_UNSUPPORTED_GUEST );
	PyModule_AddIntConstant( module, "PRL_ERR_FREE_DISC_SPACE_FOR_CLONE", PRL_ERR_FREE_DISC_SPACE_FOR_CLONE );
	PyModule_AddIntConstant( module, "PRL_ERR_FILE_WRITE_ERROR", PRL_ERR_FILE_WRITE_ERROR );
	PyModule_AddIntConstant( module, "PRL_ERR_FILE_DISK_SPACE_ERROR", PRL_ERR_FILE_DISK_SPACE_ERROR );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_CONFIG_INVALID_VM_UUID", PRL_ERR_VM_CONFIG_INVALID_VM_UUID );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_CONFIG_INVALID_SERVER_UUID", PRL_ERR_VM_CONFIG_INVALID_SERVER_UUID );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_MUST_BE_STOPPED_BEFORE_RENAMING", PRL_ERR_VM_MUST_BE_STOPPED_BEFORE_RENAMING );
	PyModule_AddIntConstant( module, "PRL_ERR_DISP_VM_IS_NOT_STARTED", PRL_ERR_DISP_VM_IS_NOT_STARTED );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_INVALID_SWAP_REGION", PRL_ERR_VM_INVALID_SWAP_REGION );
	PyModule_AddIntConstant( module, "PRL_ERR_CPU_SHUTDOWN", PRL_ERR_CPU_SHUTDOWN );
	PyModule_AddIntConstant( module, "PRL_ERR_CPU_RESTART", PRL_ERR_CPU_RESTART );
	PyModule_AddIntConstant( module, "PRL_ERR_ACCESS_DENIED_TO_CHANGE_PERMISSIONS", PRL_ERR_ACCESS_DENIED_TO_CHANGE_PERMISSIONS );
	PyModule_AddIntConstant( module, "PRL_ERR_CANT_GET_FILE_PERMISSIONS", PRL_ERR_CANT_GET_FILE_PERMISSIONS );
	PyModule_AddIntConstant( module, "PRL_ERR_CANT_REMOVE_INVALID_VM_AS_NON_ADMIN", PRL_ERR_CANT_REMOVE_INVALID_VM_AS_NON_ADMIN );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_MUST_BE_STOPPED_FOR_CHANGE_DEVICES", PRL_ERR_VM_MUST_BE_STOPPED_FOR_CHANGE_DEVICES );
	PyModule_AddIntConstant( module, "PRL_ERR_CANT_CONVERT_OLD_VM_WITH_INSTALLED_TOOLS", PRL_ERR_CANT_CONVERT_OLD_VM_WITH_INSTALLED_TOOLS );
	PyModule_AddIntConstant( module, "PRL_ERR_CANTS_CREATE_DISK_IMAGE_ON_FAT", PRL_ERR_CANTS_CREATE_DISK_IMAGE_ON_FAT );
	PyModule_AddIntConstant( module, "PRL_ERR_CANTS_CREATE_DISK_IMAGE_ON_FAT32", PRL_ERR_CANTS_CREATE_DISK_IMAGE_ON_FAT32 );
	PyModule_AddIntConstant( module, "PRL_ERR_EXCEED_LIMIT_MAX_RUNNING_VMS", PRL_ERR_EXCEED_LIMIT_MAX_RUNNING_VMS );
	PyModule_AddIntConstant( module, "PRL_ERR_CANT_CREATE_HDD_IMAGE_NO_SPACE", PRL_ERR_CANT_CREATE_HDD_IMAGE_NO_SPACE );
	PyModule_AddIntConstant( module, "PRL_ERR_USER_NOT_FOUND", PRL_ERR_USER_NOT_FOUND );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_ALREADY_CONNECTED", PRL_ERR_VM_ALREADY_CONNECTED );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_GUESTMEM_FAIL", PRL_ERR_VM_GUESTMEM_FAIL );
	PyModule_AddIntConstant( module, "PRL_ERR_CANT_CHANGE_OWNER_OF_VM_FILE", PRL_ERR_CANT_CHANGE_OWNER_OF_VM_FILE );
	PyModule_AddIntConstant( module, "PRL_ERR_CANT_CHANGE_OWNER_OF_DISK_IMAGE_FILE", PRL_ERR_CANT_CHANGE_OWNER_OF_DISK_IMAGE_FILE );
	PyModule_AddIntConstant( module, "PRL_ERR_ONLY_ADMIN_CAN_SET_PARAMETER_STARTLOGINMODE_ROOT", PRL_ERR_ONLY_ADMIN_CAN_SET_PARAMETER_STARTLOGINMODE_ROOT );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_USER_AUTHENTICATION_FAILED", PRL_ERR_VM_USER_AUTHENTICATION_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_GUEST_MAC_NOT_MACSERVER_HOST", PRL_ERR_GUEST_MAC_NOT_MACSERVER_HOST );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_COULDNT_BE_STARTED_UNDER_SPECIFIED_USER", PRL_ERR_VM_COULDNT_BE_STARTED_UNDER_SPECIFIED_USER );
	PyModule_AddIntConstant( module, "PRL_ERR_UNSUPPORTED_NETWORK_FILE_SYSTEM", PRL_ERR_UNSUPPORTED_NETWORK_FILE_SYSTEM );
	PyModule_AddIntConstant( module, "PRL_ERR_UNSUPPORTED_FILE_SYSTEM", PRL_ERR_UNSUPPORTED_FILE_SYSTEM );
	PyModule_AddIntConstant( module, "PRL_ERR_CANT_CREATE_SERIAL_PORT_IMAGE", PRL_ERR_CANT_CREATE_SERIAL_PORT_IMAGE );
	PyModule_AddIntConstant( module, "PRL_ERR_IO_NO_CONNECTION", PRL_ERR_IO_NO_CONNECTION );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_ALREADY_RUNNING", PRL_ERR_VM_ALREADY_RUNNING );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_LOAD_BINARY_FAILED", PRL_ERR_VM_LOAD_BINARY_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_DISP_SHUTDOWN_IN_PROCESS", PRL_ERR_DISP_SHUTDOWN_IN_PROCESS );
	PyModule_AddIntConstant( module, "PRL_ERR_DROP_SUSPEND_FOR_HDD_QUEST", PRL_ERR_DROP_SUSPEND_FOR_HDD_QUEST );
	PyModule_AddIntConstant( module, "PRL_ERR_OBJECT_WAS_REMOVED", PRL_ERR_OBJECT_WAS_REMOVED );
	PyModule_AddIntConstant( module, "PRL_ERR_NO_TARGET_DIR_PATH_SPECIFIED", PRL_ERR_NO_TARGET_DIR_PATH_SPECIFIED );
	PyModule_AddIntConstant( module, "PRL_ERR_CANT_REMOVE_DIR_ENTRY", PRL_ERR_CANT_REMOVE_DIR_ENTRY );
	PyModule_AddIntConstant( module, "PRL_ERR_CANT_RENAME_DIR_ENTRY", PRL_ERR_CANT_RENAME_DIR_ENTRY );
	PyModule_AddIntConstant( module, "PRL_ERR_ENTRY_DIR_ALREADY_EXISTS", PRL_ERR_ENTRY_DIR_ALREADY_EXISTS );
	PyModule_AddIntConstant( module, "PRL_ERR_ENTRY_DIR_DOES_NOT_EXIST", PRL_ERR_ENTRY_DIR_DOES_NOT_EXIST );
	PyModule_AddIntConstant( module, "PRL_ERR_HANDSHAKE_FAILED", PRL_ERR_HANDSHAKE_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_WRONG_PROTOCOL_VERSION", PRL_ERR_WRONG_PROTOCOL_VERSION );
	PyModule_AddIntConstant( module, "PRL_ERR_SSL_HANDSHAKE_FAILED", PRL_ERR_SSL_HANDSHAKE_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_DISP_LOGON_ACTIONS_REACHED_UP_LIMIT", PRL_ERR_DISP_LOGON_ACTIONS_REACHED_UP_LIMIT );
	PyModule_AddIntConstant( module, "PRL_ERR_DISP_VM_COMMAND_CANT_BE_EXECUTED", PRL_ERR_DISP_VM_COMMAND_CANT_BE_EXECUTED );
	PyModule_AddIntConstant( module, "PRL_ERR_CANT_TO_CHANGE_PERMISSIONS_ON_REMOTE_LOCATION", PRL_ERR_CANT_TO_CHANGE_PERMISSIONS_ON_REMOTE_LOCATION );
	PyModule_AddIntConstant( module, "PRL_ERR_NO_CD_DRIVE_AVAILABLE", PRL_ERR_NO_CD_DRIVE_AVAILABLE );
	PyModule_AddIntConstant( module, "PRL_ERR_CANT_CONFIGURE_PARTITION_HDD", PRL_ERR_CANT_CONFIGURE_PARTITION_HDD );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_IS_NOT_SUSPENDED", PRL_ERR_VM_IS_NOT_SUSPENDED );
	PyModule_AddIntConstant( module, "PRL_ERR_COMMAND_SUPPORTED_ONLY_AT_SERVER_MODE", PRL_ERR_COMMAND_SUPPORTED_ONLY_AT_SERVER_MODE );
	PyModule_AddIntConstant( module, "PRL_ERR_API_INCOMPATIBLE", PRL_ERR_API_INCOMPATIBLE );
	PyModule_AddIntConstant( module, "PRL_ERR_GUEST_TOOLS_NOT_INSTALLED", PRL_ERR_GUEST_TOOLS_NOT_INSTALLED );
	PyModule_AddIntConstant( module, "PRL_ERR_XML_WRITE_FILE", PRL_ERR_XML_WRITE_FILE );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_ANOTHER_TOOLS_IN_USE", PRL_ERR_VM_ANOTHER_TOOLS_IN_USE );
	PyModule_AddIntConstant( module, "PRL_ERR_NEED_KILL_PREV_SETTING", PRL_ERR_NEED_KILL_PREV_SETTING );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_DELETE_STATE_FAILED", PRL_ERR_VM_DELETE_STATE_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_SNAPSHOT_CHANGED_VM_CONFIG", PRL_ERR_VM_SNAPSHOT_CHANGED_VM_CONFIG );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_SNAPSHOT_IN_UNDO_DISKS_MODE", PRL_ERR_VM_SNAPSHOT_IN_UNDO_DISKS_MODE );
	PyModule_AddIntConstant( module, "PRL_ERR_INVALID_KEXT_REBOOT_REQUIRED", PRL_ERR_INVALID_KEXT_REBOOT_REQUIRED );
	PyModule_AddIntConstant( module, "PRL_ERR_HYP_ALLOC_VMS_MEMORY", PRL_ERR_HYP_ALLOC_VMS_MEMORY );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_UPDATE_SNAPSHOT_DATA_FAILED", PRL_ERR_VM_UPDATE_SNAPSHOT_DATA_FAILED );
	PyModule_AddIntConstant( module, "PRL_WARN_VM_DVD_DISCONNECT_LOCKED_DEV", PRL_WARN_VM_DVD_DISCONNECT_LOCKED_DEV );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_DVD_DISCONNECT_FAILED_LOCKED", PRL_ERR_VM_DVD_DISCONNECT_FAILED_LOCKED );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_EDIT_UNABLE_SWITCH_ON_UNDO_DISKS_MODE", PRL_ERR_VM_EDIT_UNABLE_SWITCH_ON_UNDO_DISKS_MODE );
	PyModule_AddIntConstant( module, "PRL_ERR_NVRAM_FILE_COPY", PRL_ERR_NVRAM_FILE_COPY );
	PyModule_AddIntConstant( module, "PRL_ERR_SNAPSHOTS_COPY", PRL_ERR_SNAPSHOTS_COPY );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_RESTART_GUEST_FAILED", PRL_ERR_VM_RESTART_GUEST_FAILED );
	PyModule_AddIntConstant( module, "PRL_WNG_START_VM_ON_MOUNTED_DISK", PRL_WNG_START_VM_ON_MOUNTED_DISK );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_SNAPSHOT_IN_SAFE_MODE", PRL_ERR_VM_SNAPSHOT_IN_SAFE_MODE );
	PyModule_AddIntConstant( module, "PET_ERR_WARN_REACH_OVERCOMMIT_STATE_ON_SETMEM", PET_ERR_WARN_REACH_OVERCOMMIT_STATE_ON_SETMEM );
	PyModule_AddIntConstant( module, "PRL_ERR_FREE_DISK_SPACE_FOR_CREATE_SNAPSHOT", PRL_ERR_FREE_DISK_SPACE_FOR_CREATE_SNAPSHOT );
	PyModule_AddIntConstant( module, "PRL_ERR_FREE_DISK_SPACE_FOR_REVERT_TO_SNAPSHOT", PRL_ERR_FREE_DISK_SPACE_FOR_REVERT_TO_SNAPSHOT );
	PyModule_AddIntConstant( module, "PRL_ERR_CANNOT_PROCESSING_UNDO_DISKS_FOR_INVALID_VM", PRL_ERR_CANNOT_PROCESSING_UNDO_DISKS_FOR_INVALID_VM );
	PyModule_AddIntConstant( module, "PRL_ERR_CANNOT_PROCESSING_SAFE_MODE_FOR_INVALID_VM", PRL_ERR_CANNOT_PROCESSING_SAFE_MODE_FOR_INVALID_VM );
	PyModule_AddIntConstant( module, "PRL_WARN_GOING_TO_TAKE_SMART_GUARD_SNAPSHOT", PRL_WARN_GOING_TO_TAKE_SMART_GUARD_SNAPSHOT );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_ALREADY_REGISTERED", PRL_ERR_VM_ALREADY_REGISTERED );
	PyModule_AddIntConstant( module, "PRL_WARN_VM_DVD_DISCONNECTED_BY_GUEST", PRL_WARN_VM_DVD_DISCONNECTED_BY_GUEST );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_DIRECTORY_FOLDER_DOESNT_EXIST", PRL_ERR_VM_DIRECTORY_FOLDER_DOESNT_EXIST );
	PyModule_AddIntConstant( module, "PRL_ERR_TRY_AGAIN", PRL_ERR_TRY_AGAIN );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_EDIT_UNABLE_SWITCH_OFF_UNDO_DISKS_MODE", PRL_ERR_VM_EDIT_UNABLE_SWITCH_OFF_UNDO_DISKS_MODE );
	PyModule_AddIntConstant( module, "PRL_ERR_IO_INVALID_POINTER_ACCESS", PRL_ERR_IO_INVALID_POINTER_ACCESS );
	PyModule_AddIntConstant( module, "PRL_ERR_NOT_ENOUGH_DISK_SPACE_TO_XML_SAVE", PRL_ERR_NOT_ENOUGH_DISK_SPACE_TO_XML_SAVE );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_CONFIG_CAN_BE_RESTORED", PRL_ERR_VM_CONFIG_CAN_BE_RESTORED );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_CONFIG_IS_ALREADY_VALID", PRL_ERR_VM_CONFIG_IS_ALREADY_VALID );
	PyModule_AddIntConstant( module, "PRL_ERR_NOT_ENOUGH_DISK_SPACE_TO_START_VM", PRL_ERR_NOT_ENOUGH_DISK_SPACE_TO_START_VM );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_EDIT_UNABLE_CHANGE_IP_ADDRESS", PRL_ERR_VM_EDIT_UNABLE_CHANGE_IP_ADDRESS );
	PyModule_AddIntConstant( module, "PRL_WARN_CANT_CONNECT_VOLUME", PRL_WARN_CANT_CONNECT_VOLUME );
	PyModule_AddIntConstant( module, "PRL_ERR_CONFIGURE_GENERIC_PCI_TASK_ALREADY_RUN", PRL_ERR_CONFIGURE_GENERIC_PCI_TASK_ALREADY_RUN );
	PyModule_AddIntConstant( module, "PRL_ERR_VTD_DEVICE_DOES_NOT_EXIST", PRL_ERR_VTD_DEVICE_DOES_NOT_EXIST );
	PyModule_AddIntConstant( module, "PRL_ERR_CANT_START_VM_SINCE_NO_VTD_DRIVER", PRL_ERR_CANT_START_VM_SINCE_NO_VTD_DRIVER );
	PyModule_AddIntConstant( module, "PRL_ERR_FAILURE_ON_VM_DESTROYED", PRL_ERR_FAILURE_ON_VM_DESTROYED );
	PyModule_AddIntConstant( module, "PRL_ERR_CANT_START_VM_SINCE_VTD_DEVICE_ALREADY_USED", PRL_ERR_CANT_START_VM_SINCE_VTD_DEVICE_ALREADY_USED );
	PyModule_AddIntConstant( module, "PRL_ERR_PREPARE_FOR_HIBERNATE_TASK_ALREADY_RUN", PRL_ERR_PREPARE_FOR_HIBERNATE_TASK_ALREADY_RUN );
	PyModule_AddIntConstant( module, "PRL_ERR_PREPARE_FOR_HIBERNATE_VM_WRONG_STATE", PRL_ERR_PREPARE_FOR_HIBERNATE_VM_WRONG_STATE );
	PyModule_AddIntConstant( module, "PRL_ERR_PREPARE_FOR_HIBERNATE_VM_WITHOUT_TOOLS", PRL_ERR_PREPARE_FOR_HIBERNATE_VM_WITHOUT_TOOLS );
	PyModule_AddIntConstant( module, "PRL_ERR_PREPARE_FOR_HIBERNATE_VM_CANNOT_STAND_BY", PRL_ERR_PREPARE_FOR_HIBERNATE_VM_CANNOT_STAND_BY );
	PyModule_AddIntConstant( module, "PRL_ERR_USER_NO_AUTH_TO_CREATE_ROOT_VM_DIR", PRL_ERR_USER_NO_AUTH_TO_CREATE_ROOT_VM_DIR );
	PyModule_AddIntConstant( module, "PRL_ERR_CANT_REVERT_VM_SINCE_VTD_DEVICE_ALREADY_USED", PRL_ERR_CANT_REVERT_VM_SINCE_VTD_DEVICE_ALREADY_USED );
	PyModule_AddIntConstant( module, "PRL_WARN_NOT_SYMMETRIC_CPU", PRL_WARN_NOT_SYMMETRIC_CPU );
	PyModule_AddIntConstant( module, "PRL_WARN_DEV_USB_CONNECT_FAILED", PRL_WARN_DEV_USB_CONNECT_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_SNAPSHOT_NOT_FOUND", PRL_ERR_VM_SNAPSHOT_NOT_FOUND );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_SNAPSHOTS_CONFIG_NOT_FOUND", PRL_ERR_VM_SNAPSHOTS_CONFIG_NOT_FOUND );
	PyModule_AddIntConstant( module, "PRL_WARN_DEV_USB_OPEN_FAILED", PRL_WARN_DEV_USB_OPEN_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_LOGIN_BY_MISMATCH_CLIENT_MODE", PRL_ERR_LOGIN_BY_MISMATCH_CLIENT_MODE );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_IS_EXCLUSIVELY_LOCKED", PRL_ERR_VM_IS_EXCLUSIVELY_LOCKED );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_IS_NOT_LOCKED", PRL_ERR_VM_IS_NOT_LOCKED );
	PyModule_AddIntConstant( module, "PRL_ERR_NOT_LOCK_OWNER_SESSION_TRIES_TO_UNLOCK", PRL_ERR_NOT_LOCK_OWNER_SESSION_TRIES_TO_UNLOCK );
	PyModule_AddIntConstant( module, "PRL_ERR_CANNOT_SAVE_REMOTE_DEVICE_STATE", PRL_ERR_CANNOT_SAVE_REMOTE_DEVICE_STATE );
	PyModule_AddIntConstant( module, "PRL_ERR_SUSPEND_REJECTED_BY_GUEST", PRL_ERR_SUSPEND_REJECTED_BY_GUEST );
	PyModule_AddIntConstant( module, "PRL_ERR_PLAYER_CANT_SUSPEND_IN_PAUSE", PRL_ERR_PLAYER_CANT_SUSPEND_IN_PAUSE );
	PyModule_AddIntConstant( module, "PRL_WARN_PREPARE_FOR_HIBERNATE_UNABLE_SUSPEND_DO_STOP", PRL_WARN_PREPARE_FOR_HIBERNATE_UNABLE_SUSPEND_DO_STOP );
	PyModule_AddIntConstant( module, "PRL_ERR_HVT_NOT_AVAILABLE_WARNING", PRL_ERR_HVT_NOT_AVAILABLE_WARNING );
	PyModule_AddIntConstant( module, "PRL_ERR_CANT_RESIZE_HDD", PRL_ERR_CANT_RESIZE_HDD );
	PyModule_AddIntConstant( module, "PRL_ERR_NETWORK_ADAPTER_NOT_FOUND", PRL_ERR_NETWORK_ADAPTER_NOT_FOUND );
	PyModule_AddIntConstant( module, "PRL_ERR_DISP_START_VM_FOR_COMPACT_FAILED", PRL_ERR_DISP_START_VM_FOR_COMPACT_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_REMOTE_DISPLAY_EMPTY_PASSWORD", PRL_ERR_REMOTE_DISPLAY_EMPTY_PASSWORD );
	PyModule_AddIntConstant( module, "PRL_ERR_DISP_AUTO_COMPRESS_PERIOD_OUT_OF_RANGE", PRL_ERR_DISP_AUTO_COMPRESS_PERIOD_OUT_OF_RANGE );
	PyModule_AddIntConstant( module, "PRL_ERR_COMPACT_WRONG_VM_STATE", PRL_ERR_COMPACT_WRONG_VM_STATE );
	PyModule_AddIntConstant( module, "PRL_ERR_WRONG_VM_STATE", PRL_ERR_WRONG_VM_STATE );
	PyModule_AddIntConstant( module, "PRL_ERR_NO_ONE_HARD_DISK_TO_COMPRESS", PRL_ERR_NO_ONE_HARD_DISK_TO_COMPRESS );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_TOOL_PROCESS_ERROR", PRL_ERR_DISK_TOOL_PROCESS_ERROR );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_TOOL_NOT_FOUND", PRL_ERR_DISK_TOOL_NOT_FOUND );
	PyModule_AddIntConstant( module, "PRL_ERR_DISP_CANNOT_COMPACT_VM_HARD_DISK", PRL_ERR_DISP_CANNOT_COMPACT_VM_HARD_DISK );
	PyModule_AddIntConstant( module, "PRL_ERR_COMPACT_ALREADY_SWITCHED_ON", PRL_ERR_COMPACT_ALREADY_SWITCHED_ON );
	PyModule_AddIntConstant( module, "PRL_WARN_VERBOSE_LOGGING", PRL_WARN_VERBOSE_LOGGING );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_COMPACT_HARD_DISK_FAILED", PRL_ERR_VM_COMPACT_HARD_DISK_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_AUTO_COMPRESS_TASK_ALREADY_RUN", PRL_ERR_VM_AUTO_COMPRESS_TASK_ALREADY_RUN );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_HARD_DISK_NOT_COMPACTABLE", PRL_ERR_VM_HARD_DISK_NOT_COMPACTABLE );
	PyModule_AddIntConstant( module, "PRL_ERR_HARD_DISK_NOT_VIRTUAL_OR_DISABLED", PRL_ERR_HARD_DISK_NOT_VIRTUAL_OR_DISABLED );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_COMPACT_NOT_SUPPORTED_GUEST_OS", PRL_ERR_VM_COMPACT_NOT_SUPPORTED_GUEST_OS );
	PyModule_AddIntConstant( module, "PRL_WARN_CANNOT_MOUNT_BACK_PARTITION", PRL_WARN_CANNOT_MOUNT_BACK_PARTITION );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_PROCESS_IS_NOT_STARTED_BY_WRONG_HOST_SW", PRL_ERR_VM_PROCESS_IS_NOT_STARTED_BY_WRONG_HOST_SW );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_RESTORE_STATE_FAILED_VM_STOPPED", PRL_ERR_VM_RESTORE_STATE_FAILED_VM_STOPPED );
	PyModule_AddIntConstant( module, "PRL_ERR_DISP_TIME_MACHINE_IS_RUNNING", PRL_ERR_DISP_TIME_MACHINE_IS_RUNNING );
	PyModule_AddIntConstant( module, "PRL_ERR_SMP_NOT_SUPPORTED_HVT_DISABLED", PRL_ERR_SMP_NOT_SUPPORTED_HVT_DISABLED );
	PyModule_AddIntConstant( module, "PRL_ERR_SMP_NOT_SUPPORTED_HVT_NOT_PRESENT", PRL_ERR_SMP_NOT_SUPPORTED_HVT_NOT_PRESENT );
	PyModule_AddIntConstant( module, "PRL_ERR_HVT_DISABLED_WARNING", PRL_ERR_HVT_DISABLED_WARNING );
	PyModule_AddIntConstant( module, "PRL_ERR_ACCESS_TO_VM_HDD_DENIED", PRL_ERR_ACCESS_TO_VM_HDD_DENIED );
	PyModule_AddIntConstant( module, "PRL_ERR_ACCESS_TO_CLONE_VM_DEVICE_DENIED", PRL_ERR_ACCESS_TO_CLONE_VM_DEVICE_DENIED );
	PyModule_AddIntConstant( module, "PRL_ERR_CANT_CONNECT_TO_DISPATCHER_ITERATIVELY", PRL_ERR_CANT_CONNECT_TO_DISPATCHER_ITERATIVELY );
	PyModule_AddIntConstant( module, "PRL_ERR_CANT_RESOLVE_HOSTNAME", PRL_ERR_CANT_RESOLVE_HOSTNAME );
	PyModule_AddIntConstant( module, "PRL_ERR_PARALLEL_PORT_NO_RASTERIZER", PRL_ERR_PARALLEL_PORT_NO_RASTERIZER );
	PyModule_AddIntConstant( module, "PRL_ERR_NOT_ENOUGH_RIGHTS_FOR_LINKED_CLONE", PRL_ERR_NOT_ENOUGH_RIGHTS_FOR_LINKED_CLONE );
	PyModule_AddIntConstant( module, "PRL_ERR_COULDNT_TO_CREATE_HDD_LINKED_CLONE", PRL_ERR_COULDNT_TO_CREATE_HDD_LINKED_CLONE );
	PyModule_AddIntConstant( module, "PRL_ERR_MERGE_XML_DOCUMENT_CONFLICT", PRL_ERR_MERGE_XML_DOCUMENT_CONFLICT );
	PyModule_AddIntConstant( module, "PRL_ERR_INVALID_ACTION_REQUESTED", PRL_ERR_INVALID_ACTION_REQUESTED );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_UNPAUSE_FAILED", PRL_ERR_VM_UNPAUSE_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_READ_FAILED", PRL_ERR_READ_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_WRITE_FAILED", PRL_ERR_WRITE_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_OPEN_FAILED", PRL_ERR_OPEN_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_SERVICE_BUSY", PRL_ERR_SERVICE_BUSY );
	PyModule_AddIntConstant( module, "PRL_ERR_PROXY_HANDSHAKE_FAILED", PRL_ERR_PROXY_HANDSHAKE_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_PROXY_WRONG_PROTOCOL_VERSION", PRL_ERR_PROXY_WRONG_PROTOCOL_VERSION );
	PyModule_AddIntConstant( module, "PRL_ERR_PROXY_WRONG_PORT_NUMBER", PRL_ERR_PROXY_WRONG_PORT_NUMBER );
	PyModule_AddIntConstant( module, "PRL_ERR_PROXY_PEER_NOT_FOUND", PRL_ERR_PROXY_PEER_NOT_FOUND );
	PyModule_AddIntConstant( module, "PRL_ERR_DISPLAY_ENCODINGS_NOT_SUPPORTED", PRL_ERR_DISPLAY_ENCODINGS_NOT_SUPPORTED );
	PyModule_AddIntConstant( module, "PRL_ERR_ONLY_ADMIN_CAN_SET_VERBOSE_LOGGING", PRL_ERR_ONLY_ADMIN_CAN_SET_VERBOSE_LOGGING );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_HDD_DISCONNECT_FAILED_LOCKED", PRL_ERR_VM_HDD_DISCONNECT_FAILED_LOCKED );
	PyModule_AddIntConstant( module, "PRL_ERR_START_VM_BY_NOT_DEFINED_USER", PRL_ERR_START_VM_BY_NOT_DEFINED_USER );
	PyModule_AddIntConstant( module, "PRL_ERR_START_VM_BY_NOT_AUTH_USER", PRL_ERR_START_VM_BY_NOT_AUTH_USER );
	PyModule_AddIntConstant( module, "PRL_WARN_LINK_TO_OUTSIDED_HDD_WILL_BE_DROPPED_AFTER_CLONE", PRL_WARN_LINK_TO_OUTSIDED_HDD_WILL_BE_DROPPED_AFTER_CLONE );
	PyModule_AddIntConstant( module, "PRL_WARN_OUTSIDED_HDD_WILL_BE_ONLY_LINKED_AFTER_CLONE", PRL_WARN_OUTSIDED_HDD_WILL_BE_ONLY_LINKED_AFTER_CLONE );
	PyModule_AddIntConstant( module, "PRL_ERR_COULD_NOT_START_FIREWALL_TOOL", PRL_ERR_COULD_NOT_START_FIREWALL_TOOL );
	PyModule_AddIntConstant( module, "PRL_ERR_FIREWALL_TOOL_EXECUTED_WITH_ERROR", PRL_ERR_FIREWALL_TOOL_EXECUTED_WITH_ERROR );
	PyModule_AddIntConstant( module, "PRL_ERR_CANNOT_EDIT_HARDWARE_FOR_PAUSED_VM", PRL_ERR_CANNOT_EDIT_HARDWARE_FOR_PAUSED_VM );
	PyModule_AddIntConstant( module, "PRL_ERR_INVALID_MEMORY_QUOTA", PRL_ERR_INVALID_MEMORY_QUOTA );
	PyModule_AddIntConstant( module, "PRL_ERR_INVALID_MEMORY_GUARANTEE", PRL_ERR_INVALID_MEMORY_GUARANTEE );
	PyModule_AddIntConstant( module, "PRL_ERR_UNABLE_APPLY_MEMORY_GUARANTEE", PRL_ERR_UNABLE_APPLY_MEMORY_GUARANTEE );
	PyModule_AddIntConstant( module, "PRL_ERR_LOW_MEMORY_LIMIT", PRL_ERR_LOW_MEMORY_LIMIT );
	PyModule_AddIntConstant( module, "PRL_ERR_CANNOT_EDIT_FIREWALL_AT_TRANS_VM_STATE", PRL_ERR_CANNOT_EDIT_FIREWALL_AT_TRANS_VM_STATE );
	PyModule_AddIntConstant( module, "PRL_ERR_UNABLE_APPLY_TOTAL_LIMIT", PRL_ERR_UNABLE_APPLY_TOTAL_LIMIT );
	PyModule_AddIntConstant( module, "PRL_ERR_INVALID_TOTAL_LIMIT", PRL_ERR_INVALID_TOTAL_LIMIT );
	PyModule_AddIntConstant( module, "PRL_ERR_AUDIO_ENCODINGS_NOT_SUPPORTED", PRL_ERR_AUDIO_ENCODINGS_NOT_SUPPORTED );
	PyModule_AddIntConstant( module, "PRL_ERR_MSG_START_32BIT_VM_ON_64BIT_HOST", PRL_ERR_MSG_START_32BIT_VM_ON_64BIT_HOST );
	PyModule_AddIntConstant( module, "PRL_WARN_VM_SYNC_DEFAULT_PRINTER_DISABLED", PRL_WARN_VM_SYNC_DEFAULT_PRINTER_DISABLED );
	PyModule_AddIntConstant( module, "PRL_ERR_TIME_MACHINE_EXCLUDED_LIST_OP", PRL_ERR_TIME_MACHINE_EXCLUDED_LIST_OP );
	PyModule_AddIntConstant( module, "PRL_ERR_START_SAFE_MODE_UNSUPPORTED", PRL_ERR_START_SAFE_MODE_UNSUPPORTED );
	PyModule_AddIntConstant( module, "PRL_ERR_COPY_VM_INFO_FILE", PRL_ERR_COPY_VM_INFO_FILE );
	PyModule_AddIntConstant( module, "PRL_ERR_DISPLAY_FORMAT_NOT_SUPPORTED", PRL_ERR_DISPLAY_FORMAT_NOT_SUPPORTED );
	PyModule_AddIntConstant( module, "PRL_ERR_IOSERVICE_COMPRESS", PRL_ERR_IOSERVICE_COMPRESS );
	PyModule_AddIntConstant( module, "PRL_ERR_INVALID_CREATE_FLOPPY_IMAGE_PARAMETERS", PRL_ERR_INVALID_CREATE_FLOPPY_IMAGE_PARAMETERS );
	PyModule_AddIntConstant( module, "PRL_ERR_RUN_VM_ACTION_SCRIPT", PRL_ERR_RUN_VM_ACTION_SCRIPT );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_IN_WAKING_UP_STATE", PRL_ERR_VM_IN_WAKING_UP_STATE );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_IN_FROZEN_STATE", PRL_ERR_VM_IN_FROZEN_STATE );
	PyModule_AddIntConstant( module, "PRL_ERR_MEM_EXCEED_PHY_SPACE", PRL_ERR_MEM_EXCEED_PHY_SPACE );
	PyModule_AddIntConstant( module, "PRL_ERR_GET_DISK_FREE_SPACE_FAILED", PRL_ERR_GET_DISK_FREE_SPACE_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_DISP_VM_IS_NOT_STOPPED", PRL_ERR_DISP_VM_IS_NOT_STOPPED );
	PyModule_AddIntConstant( module, "PRL_ERR_MOBILE_ADVANCED_AUTH_REQUIRED", PRL_ERR_MOBILE_ADVANCED_AUTH_REQUIRED );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_HYPERVISOR_HVT_ENABLED_ON_HYPERSWITCH", PRL_ERR_VM_HYPERVISOR_HVT_ENABLED_ON_HYPERSWITCH );
	PyModule_AddIntConstant( module, "PRL_ERR_CANT_CHANGE_PROXY_MANAGER_URL", PRL_ERR_CANT_CHANGE_PROXY_MANAGER_URL );
	PyModule_AddIntConstant( module, "PRL_ERR_CANT_CHANGE_HOST_ID", PRL_ERR_CANT_CHANGE_HOST_ID );
	PyModule_AddIntConstant( module, "PRL_ERR_CANT_CHANGE_PROXY_MANAGER_URL_BY_NON_PRIVILEGED_USER", PRL_ERR_CANT_CHANGE_PROXY_MANAGER_URL_BY_NON_PRIVILEGED_USER );
	PyModule_AddIntConstant( module, "PRL_WARN_WINDOWS_UPDATE_WORKING", PRL_WARN_WINDOWS_UPDATE_WORKING );
	PyModule_AddIntConstant( module, "PRL_ERR_NOT_CONNECTED_TO_PROXY_MANAGER", PRL_ERR_NOT_CONNECTED_TO_PROXY_MANAGER );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_LIFETIME_IS_EXPIRED", PRL_ERR_VM_LIFETIME_IS_EXPIRED );
	PyModule_AddIntConstant( module, "PRL_ERR_UNABLE_TO_SETUP_HEADLESS_MODE", PRL_ERR_UNABLE_TO_SETUP_HEADLESS_MODE );
	PyModule_AddIntConstant( module, "PRL_ERR_UNABLE_TO_SETUP_HEADLESS_MODE_BY_NON_PRIVILEGED_USER", PRL_ERR_UNABLE_TO_SETUP_HEADLESS_MODE_BY_NON_PRIVILEGED_USER );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_EXPIRATION_TIME_CHECK_INTERVAL_OUT_OF_RANGE", PRL_ERR_VM_EXPIRATION_TIME_CHECK_INTERVAL_OUT_OF_RANGE );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_EXPIRATION_OFFLINE_GRACE_PERIOD_EXPIRED", PRL_ERR_VM_EXPIRATION_OFFLINE_GRACE_PERIOD_EXPIRED );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_EXPIRATION_HOST_DATETIME_SKEWED", PRL_ERR_VM_EXPIRATION_HOST_DATETIME_SKEWED );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_EXPIRATION_VM_IS_IN_OFFLINE_GRACE_PERIOD", PRL_ERR_VM_EXPIRATION_VM_IS_IN_OFFLINE_GRACE_PERIOD );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_EXPIRATION_VM_IS_ABOUT_TO_EXPIRE", PRL_ERR_VM_EXPIRATION_VM_IS_ABOUT_TO_EXPIRE );
	PyModule_AddIntConstant( module, "PRL_ERR_UNABLE_TO_CONTINUE_VM_LIFETIME_IS_EXPIRED", PRL_ERR_UNABLE_TO_CONTINUE_VM_LIFETIME_IS_EXPIRED );
	PyModule_AddIntConstant( module, "PRL_ERR_CANT_CHANGE_WEB_PORTAL_DOMAIN", PRL_ERR_CANT_CHANGE_WEB_PORTAL_DOMAIN );
	PyModule_AddIntConstant( module, "PRL_ERR_CANT_CHANGE_WEB_PORTAL_DOMAIN_BY_NON_PRIVILEGED_USER", PRL_ERR_CANT_CHANGE_WEB_PORTAL_DOMAIN_BY_NON_PRIVILEGED_USER );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_EDIT_UNABLE_CONVERT_TO_TEMPLATE", PRL_ERR_VM_EDIT_UNABLE_CONVERT_TO_TEMPLATE );
	PyModule_AddIntConstant( module, "PRL_ERR_DELETE_UNFINISHED_STATE_FAILED", PRL_ERR_DELETE_UNFINISHED_STATE_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_EXT_DISK_ALREADY_EXISTS", PRL_ERR_EXT_DISK_ALREADY_EXISTS );
	PyModule_AddIntConstant( module, "PRL_ERR_EXT_DISK_CANT_RENAME", PRL_ERR_EXT_DISK_CANT_RENAME );
	PyModule_AddIntConstant( module, "PRL_ERR_BRIDGE_NOT_FOUND_FOR_NETWORK_ADAPTER", PRL_ERR_BRIDGE_NOT_FOUND_FOR_NETWORK_ADAPTER );
	PyModule_AddIntConstant( module, "PRL_ERR_VCMMD_NO_CONNECTION", PRL_ERR_VCMMD_NO_CONNECTION );
	PyModule_AddIntConstant( module, "PRL_WARN_DELETE_NO_CONFIG_UNREGISTER", PRL_WARN_DELETE_NO_CONFIG_UNREGISTER );
	PyModule_AddIntConstant( module, "PRL_ERR_PPC_INVALID_CREDENTIALS", PRL_ERR_PPC_INVALID_CREDENTIALS );
	PyModule_AddIntConstant( module, "PRL_ERR_PPC_INVALID_CREDENTIALS_ON_RECONNECT", PRL_ERR_PPC_INVALID_CREDENTIALS_ON_RECONNECT );
	PyModule_AddIntConstant( module, "PRL_ERR_PPC_SERVER_BUSY", PRL_ERR_PPC_SERVER_BUSY );
	PyModule_AddIntConstant( module, "PRL_ERR_PPC_UNABLE_TO_CONNECT", PRL_ERR_PPC_UNABLE_TO_CONNECT );
	PyModule_AddIntConstant( module, "PRL_ERR_PAX_HOST_LIMIT_WAS_EXCEEDED", PRL_ERR_PAX_HOST_LIMIT_WAS_EXCEEDED );
	PyModule_AddIntConstant( module, "PRL_ERR_CONN_UNABLE_TO_ESTABLISH_TRUSTED_CHANNEL", PRL_ERR_CONN_UNABLE_TO_ESTABLISH_TRUSTED_CHANNEL );
	PyModule_AddIntConstant( module, "PRL_ERR_CONN_CLIENT_CERTIFICATE_INVALID", PRL_ERR_CONN_CLIENT_CERTIFICATE_INVALID );
	PyModule_AddIntConstant( module, "PRL_ERR_CONN_CLIENT_CERTIFICATE_EXPIRED", PRL_ERR_CONN_CLIENT_CERTIFICATE_EXPIRED );
	PyModule_AddIntConstant( module, "PRL_ERR_CONN_CLIENT_CERTIFICATE_REVOKED", PRL_ERR_CONN_CLIENT_CERTIFICATE_REVOKED );
	PyModule_AddIntConstant( module, "PRL_ERR_CONN_SERVER_CERTIFICATE_INVALID", PRL_ERR_CONN_SERVER_CERTIFICATE_INVALID );
	PyModule_AddIntConstant( module, "PRL_ERR_CONN_SERVER_CERTIFICATE_EXPIRED", PRL_ERR_CONN_SERVER_CERTIFICATE_EXPIRED );
	PyModule_AddIntConstant( module, "PRL_ERR_CONN_SERVER_CERTIFICATE_REVOKED", PRL_ERR_CONN_SERVER_CERTIFICATE_REVOKED );
	PyModule_AddIntConstant( module, "PRL_ERR_PAX_ACCESS_FORBIDDEN", PRL_ERR_PAX_ACCESS_FORBIDDEN );
	PyModule_AddIntConstant( module, "PRL_ERR_DEV_FLOPPY_CONNECT_FAILED", PRL_ERR_DEV_FLOPPY_CONNECT_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_INCORRECT_CDROM_PATH", PRL_ERR_INCORRECT_CDROM_PATH );
	PyModule_AddIntConstant( module, "PRL_ERR_UNSUPPORTED_DEVICE_TYPE", PRL_ERR_UNSUPPORTED_DEVICE_TYPE );
	PyModule_AddIntConstant( module, "PRL_WARN_VM_PD3_COMPAT_MODE", PRL_WARN_VM_PD3_COMPAT_MODE );
	PyModule_AddIntConstant( module, "PRL_WARN_VM_BOOTCAMP_MODE", PRL_WARN_VM_BOOTCAMP_MODE );
	PyModule_AddIntConstant( module, "PRL_WARN_VM_PD3_COMPAT_NO_MOUSE", PRL_WARN_VM_PD3_COMPAT_NO_MOUSE );
	PyModule_AddIntConstant( module, "PRL_ERR_INVALID_PARALLELS_DISK", PRL_ERR_INVALID_PARALLELS_DISK );
	PyModule_AddIntConstant( module, "PRL_ERR_IMAGE_NEED_TO_CONVERT", PRL_ERR_IMAGE_NEED_TO_CONVERT );
	PyModule_AddIntConstant( module, "PRL_ERR_HARD_DISK_IMAGE_CORRUPTED", PRL_ERR_HARD_DISK_IMAGE_CORRUPTED );
	PyModule_AddIntConstant( module, "PRL_ERR_CREATE_HARD_DISK_WITH_ZERO_SIZE", PRL_ERR_CREATE_HARD_DISK_WITH_ZERO_SIZE );
	PyModule_AddIntConstant( module, "PRL_NET_ETHLIST_CREATE_ERROR", PRL_NET_ETHLIST_CREATE_ERROR );
	PyModule_AddIntConstant( module, "PRL_NET_SYSTEM_ERROR", PRL_NET_SYSTEM_ERROR );
	PyModule_AddIntConstant( module, "PRL_NET_WINSCM_OPEN_ERROR", PRL_NET_WINSCM_OPEN_ERROR );
	PyModule_AddIntConstant( module, "PRL_NET_SRV_NOTIFY_ERROR", PRL_NET_SRV_NOTIFY_ERROR );
	PyModule_AddIntConstant( module, "PRL_NET_ADAPTER_NOT_EXIST", PRL_NET_ADAPTER_NOT_EXIST );
	PyModule_AddIntConstant( module, "PRL_NET_ERR_ADAPTER_CONFIG", PRL_NET_ERR_ADAPTER_CONFIG );
	PyModule_AddIntConstant( module, "PRL_NET_ERR_ETH_NO_BINDABLE_ADAPTER", PRL_NET_ERR_ETH_NO_BINDABLE_ADAPTER );
	PyModule_AddIntConstant( module, "PRL_NET_ERR_PRL_NO_BINDABLE_ADAPTER", PRL_NET_ERR_PRL_NO_BINDABLE_ADAPTER );
	PyModule_AddIntConstant( module, "PRL_NET_PRLNET_OPEN_FAILED", PRL_NET_PRLNET_OPEN_FAILED );
	PyModule_AddIntConstant( module, "PRL_NET_BIND_FAILED", PRL_NET_BIND_FAILED );
	PyModule_AddIntConstant( module, "PRL_NET_CABLE_DISCONNECTED", PRL_NET_CABLE_DISCONNECTED );
	PyModule_AddIntConstant( module, "PRL_NET_RENAME_FAILED", PRL_NET_RENAME_FAILED );
	PyModule_AddIntConstant( module, "PRL_NET_INSTALL_TIMEOUT", PRL_NET_INSTALL_TIMEOUT );
	PyModule_AddIntConstant( module, "PRL_NET_INSTALL_FAILED", PRL_NET_INSTALL_FAILED );
	PyModule_AddIntConstant( module, "PRL_NET_UNINSTALL_FAILED", PRL_NET_UNINSTALL_FAILED );
	PyModule_AddIntConstant( module, "PRL_NET_CONNECTION_SHARING_CONFLICT", PRL_NET_CONNECTION_SHARING_CONFLICT );
	PyModule_AddIntConstant( module, "PRL_NET_RESTORE_DEFAULTS_PARTITIAL_SUCCESS", PRL_NET_RESTORE_DEFAULTS_PARTITIAL_SUCCESS );
	PyModule_AddIntConstant( module, "PRL_NET_VLAN_UNSUPPORTED_IN_THIS_VERSION", PRL_NET_VLAN_UNSUPPORTED_IN_THIS_VERSION );
	PyModule_AddIntConstant( module, "PRL_NET_VMDEVICE_VIRTUAL_NETWORK_NOT_EXIST", PRL_NET_VMDEVICE_VIRTUAL_NETWORK_NOT_EXIST );
	PyModule_AddIntConstant( module, "PRL_NET_VMDEVICE_VIRTUAL_NETWORK_NO_ADAPTER", PRL_NET_VMDEVICE_VIRTUAL_NETWORK_NO_ADAPTER );
	PyModule_AddIntConstant( module, "PRL_NET_VMDEVICE_VIRTUAL_NETWORK_CONFIG_ERROR", PRL_NET_VMDEVICE_VIRTUAL_NETWORK_CONFIG_ERROR );
	PyModule_AddIntConstant( module, "PRL_NET_VMDEVICE_VIRTUAL_NETWORK_DISABLED", PRL_NET_VMDEVICE_VIRTUAL_NETWORK_DISABLED );
	PyModule_AddIntConstant( module, "PRL_NET_IPADDRESS_MODIFY_FAILED_WARNING", PRL_NET_IPADDRESS_MODIFY_FAILED_WARNING );
	PyModule_AddIntConstant( module, "PRL_NET_PKTFILTER_ERROR", PRL_NET_PKTFILTER_ERROR );
	PyModule_AddIntConstant( module, "PRL_NET_DUPLICATE_VIRTUAL_NETWORK_ID", PRL_NET_DUPLICATE_VIRTUAL_NETWORK_ID );
	PyModule_AddIntConstant( module, "PRL_NET_VIRTUAL_NETWORK_ID_NOT_EXISTS", PRL_NET_VIRTUAL_NETWORK_ID_NOT_EXISTS );
	PyModule_AddIntConstant( module, "PRL_NET_VIRTUAL_NETWORK_NOT_FOUND", PRL_NET_VIRTUAL_NETWORK_NOT_FOUND );
	PyModule_AddIntConstant( module, "PRL_NET_ADAPTER_ALREADY_USED", PRL_NET_ADAPTER_ALREADY_USED );
	PyModule_AddIntConstant( module, "PRL_NET_VIRTUAL_NETWORK_SHARED_EXISTS", PRL_NET_VIRTUAL_NETWORK_SHARED_EXISTS );
	PyModule_AddIntConstant( module, "PRL_NET_OFFMGMT_ERROR", PRL_NET_OFFMGMT_ERROR );
	PyModule_AddIntConstant( module, "PRL_NET_VIRTUAL_NETWORK_SHARED_PROHIBITED", PRL_NET_VIRTUAL_NETWORK_SHARED_PROHIBITED );
	PyModule_AddIntConstant( module, "PRL_NET_DUPLICATE_IPPRIVATE_NETWORK_NAME", PRL_NET_DUPLICATE_IPPRIVATE_NETWORK_NAME );
	PyModule_AddIntConstant( module, "PRL_NET_IPPRIVATE_NETWORK_DOES_NOT_EXIST", PRL_NET_IPPRIVATE_NETWORK_DOES_NOT_EXIST );
	PyModule_AddIntConstant( module, "PRL_NET_IPPRIVATE_NETWORK_INVALID_IP", PRL_NET_IPPRIVATE_NETWORK_INVALID_IP );
	PyModule_AddIntConstant( module, "PRL_NET_VALID_FAILURE", PRL_NET_VALID_FAILURE );
	PyModule_AddIntConstant( module, "PRL_NET_VALID_WRONG_NET_MASK", PRL_NET_VALID_WRONG_NET_MASK );
	PyModule_AddIntConstant( module, "PRL_NET_VALID_WRONG_HOST_IP_ADDR", PRL_NET_VALID_WRONG_HOST_IP_ADDR );
	PyModule_AddIntConstant( module, "PRL_NET_VALID_WRONG_DHCP_IP_ADDR", PRL_NET_VALID_WRONG_DHCP_IP_ADDR );
	PyModule_AddIntConstant( module, "PRL_NET_VALID_DHCP_RANGE_WRONG_IP_ADDRS", PRL_NET_VALID_DHCP_RANGE_WRONG_IP_ADDRS );
	PyModule_AddIntConstant( module, "PRL_NET_VALID_MISMATCH_DHCP_SCOPE_MASK", PRL_NET_VALID_MISMATCH_DHCP_SCOPE_MASK );
	PyModule_AddIntConstant( module, "PRL_NET_VALID_DHCP_SCOPE_RANGE_LESS_MIN", PRL_NET_VALID_DHCP_SCOPE_RANGE_LESS_MIN );
	PyModule_AddIntConstant( module, "PRL_ERR_SOUND_DEVICE_WRITE_FAILED", PRL_ERR_SOUND_DEVICE_WRITE_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_SOUND_OUT_DEVICE_OPEN_FAILED", PRL_ERR_SOUND_OUT_DEVICE_OPEN_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_SOUND_IN_DEVICE_OPEN_FAILED", PRL_ERR_SOUND_IN_DEVICE_OPEN_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_SOUND_BAD_EMULATION_TYPE", PRL_ERR_SOUND_BAD_EMULATION_TYPE );
	PyModule_AddIntConstant( module, "PRL_ERR_DEV_SERIAL_PORT_PHYSICAL_CONNECT_FAILED", PRL_ERR_DEV_SERIAL_PORT_PHYSICAL_CONNECT_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_DEV_SERIAL_PORT_PIPE_CONNECT_FAILED", PRL_ERR_DEV_SERIAL_PORT_PIPE_CONNECT_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_DEV_SERIAL_PORT_FILE_CONNECT_FAILED", PRL_ERR_DEV_SERIAL_PORT_FILE_CONNECT_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_DEV_SERIAL_PORT_REMOTE_CONNECT_FAILED", PRL_ERR_DEV_SERIAL_PORT_REMOTE_CONNECT_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_DEV_PARALLEL_PORT_PHYSICAL_CONNECT_FAILED", PRL_ERR_DEV_PARALLEL_PORT_PHYSICAL_CONNECT_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_DEV_PARALLEL_PORT_PRINTER_CONNECT_FAILED", PRL_ERR_DEV_PARALLEL_PORT_PRINTER_CONNECT_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_DEV_PARALLEL_PORT_FILE_CONNECT_FAILED", PRL_ERR_DEV_PARALLEL_PORT_FILE_CONNECT_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_DEV_PARALLEL_PORT_REMOTE_CONNECT_FAILED", PRL_ERR_DEV_PARALLEL_PORT_REMOTE_CONNECT_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_DEV_USB_OPEN_MANAGER_FAILED", PRL_ERR_DEV_USB_OPEN_MANAGER_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_DEV_USB_INSTALL_DRIVER_FAILED", PRL_ERR_DEV_USB_INSTALL_DRIVER_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_DEV_USB_NO_FREE_PORTS", PRL_ERR_DEV_USB_NO_FREE_PORTS );
	PyModule_AddIntConstant( module, "PRL_ERR_DEV_USB_HARD_DEVICE_INSERTED", PRL_ERR_DEV_USB_HARD_DEVICE_INSERTED );
	PyModule_AddIntConstant( module, "PRL_ERR_DEV_USB_HARD_DEVICE_INSERTED2", PRL_ERR_DEV_USB_HARD_DEVICE_INSERTED2 );
	PyModule_AddIntConstant( module, "PRL_ERR_DEV_USB_BUSY", PRL_ERR_DEV_USB_BUSY );
	PyModule_AddIntConstant( module, "PRL_ERR_DEV_USB_REUSE", PRL_ERR_DEV_USB_REUSE );
	PyModule_AddIntConstant( module, "PRL_ERR_DEV_USB_CHANGEPID", PRL_ERR_DEV_USB_CHANGEPID );
	PyModule_AddIntConstant( module, "PRL_ERR_DEV_USB_NOT_CONFIGURED", PRL_ERR_DEV_USB_NOT_CONFIGURED );
	PyModule_AddIntConstant( module, "PRL_ERR_DEV_ALREADY_CONNECTED", PRL_ERR_DEV_ALREADY_CONNECTED );
	PyModule_AddIntConstant( module, "PRL_ERR_DEV_ALREADY_DISCONNECTED", PRL_ERR_DEV_ALREADY_DISCONNECTED );
	PyModule_AddIntConstant( module, "PRL_WARN_UNABLE_OPEN_DEVICE_ON_START_VM", PRL_WARN_UNABLE_OPEN_DEVICE_ON_START_VM );
	PyModule_AddIntConstant( module, "PRL_ERR_DEV_PRINTER_OVERFLOW", PRL_ERR_DEV_PRINTER_OVERFLOW );
	PyModule_AddIntConstant( module, "PRL_ERR_DEV_MAX_NUMBER_EXCEEDED", PRL_ERR_DEV_MAX_NUMBER_EXCEEDED );
	PyModule_AddIntConstant( module, "PRL_ERR_DEV_MAX_CD_HDD_EXCEEDED", PRL_ERR_DEV_MAX_CD_HDD_EXCEEDED );
	PyModule_AddIntConstant( module, "PRL_ERR_VTD_INITIALIZATION_FAILED", PRL_ERR_VTD_INITIALIZATION_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_VTD_ALREADY_HOOKED_FAILED", PRL_ERR_VTD_ALREADY_HOOKED_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_VTD_HOOK_FAILED", PRL_ERR_VTD_HOOK_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_VTD_HOOK_NEED_REBOOT_FAILED", PRL_ERR_VTD_HOOK_NEED_REBOOT_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_VTD_WAIT_ASR", PRL_ERR_VTD_WAIT_ASR );
	PyModule_AddIntConstant( module, "PRL_ERR_VTD_HOOK_AFTER_INSTALL_NEED_REBOOT", PRL_ERR_VTD_HOOK_AFTER_INSTALL_NEED_REBOOT );
	PyModule_AddIntConstant( module, "PRL_ERR_VTD_HOOK_AFTER_REVERT_NEED_REBOOT", PRL_ERR_VTD_HOOK_AFTER_REVERT_NEED_REBOOT );
	PyModule_AddIntConstant( module, "PRL_ERR_VTD_HOOK_INSTALLATION_FAILED", PRL_ERR_VTD_HOOK_INSTALLATION_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_VTD_HOOK_REVERT_FAILED", PRL_ERR_VTD_HOOK_REVERT_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_VTD_HOOK_INVALID_CONFIG", PRL_ERR_VTD_HOOK_INVALID_CONFIG );
	PyModule_AddIntConstant( module, "PRL_ERR_VTD_HOOK_DEVICE_CURRENTLY_IN_USE", PRL_ERR_VTD_HOOK_DEVICE_CURRENTLY_IN_USE );
	PyModule_AddIntConstant( module, "PRL_ERR_MEMORY_ALLOC_ERROR", PRL_ERR_MEMORY_ALLOC_ERROR );
	PyModule_AddIntConstant( module, "PRL_ERR_DEV_MAX_CD_EXCEEDED_WITH_DISABLED_CLIENT_SCSII", PRL_ERR_DEV_MAX_CD_EXCEEDED_WITH_DISABLED_CLIENT_SCSII );
	PyModule_AddIntConstant( module, "PRL_WNG_NO_OPERATION_SYSTEM_INSTALLED", PRL_WNG_NO_OPERATION_SYSTEM_INSTALLED );
	PyModule_AddIntConstant( module, "PRL_ERR_WIN_AERO_DISABLED", PRL_ERR_WIN_AERO_DISABLED );
	PyModule_AddIntConstant( module, "PRL_ERR_VTD_DEVICE_TROUBLESHOOT", PRL_ERR_VTD_DEVICE_TROUBLESHOOT );
	PyModule_AddIntConstant( module, "PRL_ERR_INVALID_OS_TYPE", PRL_ERR_INVALID_OS_TYPE );
	PyModule_AddIntConstant( module, "PRL_ERR_VTD_HOOK_UPDATE_SCRIPT_EXECUTE", PRL_ERR_VTD_HOOK_UPDATE_SCRIPT_EXECUTE );
	PyModule_AddIntConstant( module, "PRL_ERR_LICENSE_VALID", PRL_ERR_LICENSE_VALID );
	PyModule_AddIntConstant( module, "PRL_ERR_LICENSE_NOT_VALID", PRL_ERR_LICENSE_NOT_VALID );
	PyModule_AddIntConstant( module, "PRL_ERR_LICENSE_EXPIRED", PRL_ERR_LICENSE_EXPIRED );
	PyModule_AddIntConstant( module, "PRL_ERR_LICENSE_WRONG_VERSION", PRL_ERR_LICENSE_WRONG_VERSION );
	PyModule_AddIntConstant( module, "PRL_ERR_LICENSE_WRONG_PRODUCT", PRL_ERR_LICENSE_WRONG_PRODUCT );
	PyModule_AddIntConstant( module, "PRL_ERR_LICENSE_WRONG_PLATFORM", PRL_ERR_LICENSE_WRONG_PLATFORM );
	PyModule_AddIntConstant( module, "PRL_ERR_LICENSE_WRONG_LANGUAGE", PRL_ERR_LICENSE_WRONG_LANGUAGE );
	PyModule_AddIntConstant( module, "PRL_ERR_LICENSE_WRONG_DISTRIBUTOR", PRL_ERR_LICENSE_WRONG_DISTRIBUTOR );
	PyModule_AddIntConstant( module, "PRL_ERR_LICENSE_AUTH_FAILED", PRL_ERR_LICENSE_AUTH_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_LICENSE_WRONG_ADVANCED_FIELD", PRL_ERR_LICENSE_WRONG_ADVANCED_FIELD );
	PyModule_AddIntConstant( module, "PRL_ERR_LICENSE_UPGRADE_NO_PERMANENT_LICENSE", PRL_ERR_LICENSE_UPGRADE_NO_PERMANENT_LICENSE );
	PyModule_AddIntConstant( module, "PRL_ERR_LICENSE_UPGRADE_NO_ACCEPTABLE_LICENSE", PRL_ERR_LICENSE_UPGRADE_NO_ACCEPTABLE_LICENSE );
	PyModule_AddIntConstant( module, "PRL_ERR_LICENSE_FILE_WRITE_FAILED", PRL_ERR_LICENSE_FILE_WRITE_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_LICENSE_BETA_KEY_RELEASE_PRODUCT", PRL_ERR_LICENSE_BETA_KEY_RELEASE_PRODUCT );
	PyModule_AddIntConstant( module, "PRL_ERR_LICENSE_TOO_MANY_VCPUS", PRL_ERR_LICENSE_TOO_MANY_VCPUS );
	PyModule_AddIntConstant( module, "PRL_ERR_LICENSE_RELEASE_KEY_BETA_PRODUCT", PRL_ERR_LICENSE_RELEASE_KEY_BETA_PRODUCT );
	PyModule_AddIntConstant( module, "PRL_ERR_LICENSE_NOT_STARTED", PRL_ERR_LICENSE_NOT_STARTED );
	PyModule_AddIntConstant( module, "PRL_ERR_LICENSE_BLACKLISTED", PRL_ERR_LICENSE_BLACKLISTED );
	PyModule_AddIntConstant( module, "PRL_ERR_LICENSE_TOO_MANY_MEMORY", PRL_ERR_LICENSE_TOO_MANY_MEMORY );
	PyModule_AddIntConstant( module, "PRL_ERR_LICENSE_VM_HAS_VTD_DEVICES", PRL_ERR_LICENSE_VM_HAS_VTD_DEVICES );
	PyModule_AddIntConstant( module, "PRL_ERR_VZLICENSE_TIMEOUT", PRL_ERR_VZLICENSE_TIMEOUT );
	PyModule_AddIntConstant( module, "PRL_ERR_VZLICENSE_CANCEL", PRL_ERR_VZLICENSE_CANCEL );
	PyModule_AddIntConstant( module, "PRL_ERR_VZLICENSE_PROXY_AUTH", PRL_ERR_VZLICENSE_PROXY_AUTH );
	PyModule_AddIntConstant( module, "PRL_ERR_VZLICENSE_PROXY", PRL_ERR_VZLICENSE_PROXY );
	PyModule_AddIntConstant( module, "PRL_ERR_VZLICENSE_NETWORK", PRL_ERR_VZLICENSE_NETWORK );
	PyModule_AddIntConstant( module, "PRL_ERR_VZLICENSE_NOTSUP", PRL_ERR_VZLICENSE_NOTSUP );
	PyModule_AddIntConstant( module, "PRL_ERR_VZLICENSE_WRONG", PRL_ERR_VZLICENSE_WRONG );
	PyModule_AddIntConstant( module, "PRL_ERR_VZLICENSE_NODATA", PRL_ERR_VZLICENSE_NODATA );
	PyModule_AddIntConstant( module, "PRL_ERR_VZLICENSE_ERR_KA", PRL_ERR_VZLICENSE_ERR_KA );
	PyModule_AddIntConstant( module, "PRL_ERR_VZLICENSE_LOCK", PRL_ERR_VZLICENSE_LOCK );
	PyModule_AddIntConstant( module, "PRL_ERR_VZLICENSE_EACCES", PRL_ERR_VZLICENSE_EACCES );
	PyModule_AddIntConstant( module, "PRL_ERR_VZLICENSE_NOENT", PRL_ERR_VZLICENSE_NOENT );
	PyModule_AddIntConstant( module, "PRL_ERR_VZLICENSE_NOINIT", PRL_ERR_VZLICENSE_NOINIT );
	PyModule_AddIntConstant( module, "PRL_ERR_VZLICENSE_EXIST", PRL_ERR_VZLICENSE_EXIST );
	PyModule_AddIntConstant( module, "PRL_ERR_VZLICENSE_IO", PRL_ERR_VZLICENSE_IO );
	PyModule_AddIntConstant( module, "PRL_ERR_VZLICENSE_INVAL", PRL_ERR_VZLICENSE_INVAL );
	PyModule_AddIntConstant( module, "PRL_ERR_VZLICENSE_NOMEM", PRL_ERR_VZLICENSE_NOMEM );
	PyModule_AddIntConstant( module, "PRL_ERR_VZLICENSE_FATAL", PRL_ERR_VZLICENSE_FATAL );
	PyModule_AddIntConstant( module, "PRL_ERR_VZLICENSE_INVALID_HWID", PRL_ERR_VZLICENSE_INVALID_HWID );
	PyModule_AddIntConstant( module, "PRL_ERR_VZLICENSE_ACTIVATION_KEY", PRL_ERR_VZLICENSE_ACTIVATION_KEY );
	PyModule_AddIntConstant( module, "PRL_ERR_VZLICENSE_VMS_LIMIT_EXCEEDED", PRL_ERR_VZLICENSE_VMS_LIMIT_EXCEEDED );
	PyModule_AddIntConstant( module, "PRL_ERR_VZLICENSE_UNSUPPORTED_APP_MODE", PRL_ERR_VZLICENSE_UNSUPPORTED_APP_MODE );
	PyModule_AddIntConstant( module, "PRL_ERR_VZLICENSE_UNSUPPORTED_MODE", PRL_ERR_VZLICENSE_UNSUPPORTED_MODE );
	PyModule_AddIntConstant( module, "PRL_ERR_VZLICENSE_TASK_ALREADY_RUN", PRL_ERR_VZLICENSE_TASK_ALREADY_RUN );
	PyModule_AddIntConstant( module, "PRL_ERR_LICENSE_RESTRICTED_GUEST_OS", PRL_ERR_LICENSE_RESTRICTED_GUEST_OS );
	PyModule_AddIntConstant( module, "PRL_ERR_LICENSE_RESTRICTED_TO_RUNNING_VMS_LIMIT", PRL_ERR_LICENSE_RESTRICTED_TO_RUNNING_VMS_LIMIT );
	PyModule_AddIntConstant( module, "PRL_ERR_LICENSE_RESTRICTED_TO_CREATE_VM", PRL_ERR_LICENSE_RESTRICTED_TO_CREATE_VM );
	PyModule_AddIntConstant( module, "PRL_ERR_LICENSE_RESTRICTED_TO_REGISTER_VM", PRL_ERR_LICENSE_RESTRICTED_TO_REGISTER_VM );
	PyModule_AddIntConstant( module, "PRL_ERR_LICENSE_RESTRICTED_TO_REGISTER_3RD_PARTY_VM", PRL_ERR_LICENSE_RESTRICTED_TO_REGISTER_3RD_PARTY_VM );
	PyModule_AddIntConstant( module, "PRL_ERR_LICENSE_RESTRICTED_TO_CLONE_VM", PRL_ERR_LICENSE_RESTRICTED_TO_CLONE_VM );
	PyModule_AddIntConstant( module, "PRL_ERR_LICENSE_RESTRICTED_TO_CONVERT_TO_TEMPLATE", PRL_ERR_LICENSE_RESTRICTED_TO_CONVERT_TO_TEMPLATE );
	PyModule_AddIntConstant( module, "PRL_ERR_LICENSE_RESTRICTED_TO_CONVERT_FROM_TEMPLATE", PRL_ERR_LICENSE_RESTRICTED_TO_CONVERT_FROM_TEMPLATE );
	PyModule_AddIntConstant( module, "PRL_ERR_LICENSE_RESTRICTED_TO_SUSPEND_VM", PRL_ERR_LICENSE_RESTRICTED_TO_SUSPEND_VM );
	PyModule_AddIntConstant( module, "PRL_ERR_LICENSE_RESTRICTED_TO_PAUSE_VM", PRL_ERR_LICENSE_RESTRICTED_TO_PAUSE_VM );
	PyModule_AddIntConstant( module, "PRL_ERR_LICENSE_RESTRICTED_TO_SNAPSHOT_CREATE", PRL_ERR_LICENSE_RESTRICTED_TO_SNAPSHOT_CREATE );
	PyModule_AddIntConstant( module, "PRL_ERR_LICENSE_RESTRICTED_TO_SNAPSHOT_SWITCH", PRL_ERR_LICENSE_RESTRICTED_TO_SNAPSHOT_SWITCH );
	PyModule_AddIntConstant( module, "PRL_ERR_LICENSE_RESTRICTED_TO_SNAPSHOT_DELETE", PRL_ERR_LICENSE_RESTRICTED_TO_SNAPSHOT_DELETE );
	PyModule_AddIntConstant( module, "PRL_ERR_LICENSE_RESTRICTED_TO_SNAPSHOT_SHOW_TREE", PRL_ERR_LICENSE_RESTRICTED_TO_SNAPSHOT_SHOW_TREE );
	PyModule_AddIntConstant( module, "PRL_ERR_LICENSE_RESTRICTED_TO_UNDODISK_FEATURE", PRL_ERR_LICENSE_RESTRICTED_TO_UNDODISK_FEATURE );
	PyModule_AddIntConstant( module, "PRL_ERR_LICENSE_RESTRICTED_TO_SAFEMODE_FEATURE", PRL_ERR_LICENSE_RESTRICTED_TO_SAFEMODE_FEATURE );
	PyModule_AddIntConstant( module, "PRL_ERR_LICENSE_RESTRICTED_TO_SMARTGUARD_FEATURE", PRL_ERR_LICENSE_RESTRICTED_TO_SMARTGUARD_FEATURE );
	PyModule_AddIntConstant( module, "PRL_ERR_LICENSE_GRACED", PRL_ERR_LICENSE_GRACED );
	PyModule_AddIntConstant( module, "PRL_ERR_LICENSE_RESTRICTED_CPU_COUNT", PRL_ERR_LICENSE_RESTRICTED_CPU_COUNT );
	PyModule_AddIntConstant( module, "PRL_ERR_LICENSE_RESTRICTED_TO_RUNNING_VMS_LIMIT_PER_USER", PRL_ERR_LICENSE_RESTRICTED_TO_RUNNING_VMS_LIMIT_PER_USER );
	PyModule_AddIntConstant( module, "PRL_ERR_LICENSE_BLACKLISTED_TO_VM_OPERATION", PRL_ERR_LICENSE_BLACKLISTED_TO_VM_OPERATION );
	PyModule_AddIntConstant( module, "PRL_ERR_VOLUME_LICENSE_EXCEEDED_LIMIT", PRL_ERR_VOLUME_LICENSE_EXCEEDED_LIMIT );
	PyModule_AddIntConstant( module, "PRL_ERR_VZLICENSE_KA_LICENSE_IS_UP_TO_DATE", PRL_ERR_VZLICENSE_KA_LICENSE_IS_UP_TO_DATE );
	PyModule_AddIntConstant( module, "PRL_ERR_VZLICENSE_KA_LICENSE_IS_NOT_PROLONGATED_YET", PRL_ERR_VZLICENSE_KA_LICENSE_IS_NOT_PROLONGATED_YET );
	PyModule_AddIntConstant( module, "PRL_ERR_VZLICENSE_KA_LICENSE_EXPIRED", PRL_ERR_VZLICENSE_KA_LICENSE_EXPIRED );
	PyModule_AddIntConstant( module, "PRL_ERR_VZLICENSE_KA_ACTIVATION_LIMIT_REACHED", PRL_ERR_VZLICENSE_KA_ACTIVATION_LIMIT_REACHED );
	PyModule_AddIntConstant( module, "PRL_ERR_VZLICENSE_KA_HWID_DOES_NOT_MATCH", PRL_ERR_VZLICENSE_KA_HWID_DOES_NOT_MATCH );
	PyModule_AddIntConstant( module, "PRL_ERR_VZLICENSE_KA_LICENSE_IS_TERMINATED", PRL_ERR_VZLICENSE_KA_LICENSE_IS_TERMINATED );
	PyModule_AddIntConstant( module, "PRL_WARN_LICENSE_RESTRICTED_RKU", PRL_WARN_LICENSE_RESTRICTED_RKU );
	PyModule_AddIntConstant( module, "PRL_ERR_LICENSE_UNSUPPORTED_LICENSE_TYPE_TO_DEACTIVATION", PRL_ERR_LICENSE_UNSUPPORTED_LICENSE_TYPE_TO_DEACTIVATION );
	PyModule_AddIntConstant( module, "PRL_ERR_LICENSE_DEFERRED_LICENSE_NOT_FOUND", PRL_ERR_LICENSE_DEFERRED_LICENSE_NOT_FOUND );
	PyModule_AddIntConstant( module, "PRL_ERR_VZLICENSE_UNSUPPORTED_UPDATE_OP", PRL_ERR_VZLICENSE_UNSUPPORTED_UPDATE_OP );
	PyModule_AddIntConstant( module, "PRL_ERR_LICENSE_IS_NOT_VOLUME", PRL_ERR_LICENSE_IS_NOT_VOLUME );
	PyModule_AddIntConstant( module, "PRL_ERR_ACTIVATION_WRONG_CONFIRMATION_FORMAT", PRL_ERR_ACTIVATION_WRONG_CONFIRMATION_FORMAT );
	PyModule_AddIntConstant( module, "PRL_ERR_ACTIVATION_WRONG_CONFIRMATION_MESSAGE", PRL_ERR_ACTIVATION_WRONG_CONFIRMATION_MESSAGE );
	PyModule_AddIntConstant( module, "PRL_ERR_ACTIVATION_WRONG_CONFIRMATION_SIGNATURE", PRL_ERR_ACTIVATION_WRONG_CONFIRMATION_SIGNATURE );
	PyModule_AddIntConstant( module, "PRL_ERR_ACTIVATE_WRONG_TYPE_OF_ACTIVE_LICENSE", PRL_ERR_ACTIVATE_WRONG_TYPE_OF_ACTIVE_LICENSE );
	PyModule_AddIntConstant( module, "PRL_ERR_ACTIVATE_NO_INSTALLED_LICENSE", PRL_ERR_ACTIVATE_NO_INSTALLED_LICENSE );
	PyModule_AddIntConstant( module, "PRL_ERR_ACTIVATE_TRIAL_LICENSE", PRL_ERR_ACTIVATE_TRIAL_LICENSE );
	PyModule_AddIntConstant( module, "PRL_ERR_ACTIVATION_SERVER_ERROR", PRL_ERR_ACTIVATION_SERVER_ERROR );
	PyModule_AddIntConstant( module, "PRL_ERR_ACTIVATION_SERVER_ACTIVATION_ID_IS_INVALID", PRL_ERR_ACTIVATION_SERVER_ACTIVATION_ID_IS_INVALID );
	PyModule_AddIntConstant( module, "PRL_ERR_ACTIVATION_SERVER_KEY_IS_INVALID", PRL_ERR_ACTIVATION_SERVER_KEY_IS_INVALID );
	PyModule_AddIntConstant( module, "PRL_ERR_ACTIVATION_SERVER_KEY_IS_BLACKLISTED", PRL_ERR_ACTIVATION_SERVER_KEY_IS_BLACKLISTED );
	PyModule_AddIntConstant( module, "PRL_ERR_ACTIVATION_SERVER_HWIDS_AMOUNT_REACHED", PRL_ERR_ACTIVATION_SERVER_HWIDS_AMOUNT_REACHED );
	PyModule_AddIntConstant( module, "PRL_ERR_ACTIVATION_WRONG_SERVER_RESPONSE", PRL_ERR_ACTIVATION_WRONG_SERVER_RESPONSE );
	PyModule_AddIntConstant( module, "PRL_ERR_ACTIVATION_UNABLE_TO_SEND_REQUEST", PRL_ERR_ACTIVATION_UNABLE_TO_SEND_REQUEST );
	PyModule_AddIntConstant( module, "PRL_ERR_ACTIVATION_HTTP_REQUEST_FAILED", PRL_ERR_ACTIVATION_HTTP_REQUEST_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_UNABLE_TO_SEND_REQUEST", PRL_ERR_UNABLE_TO_SEND_REQUEST );
	PyModule_AddIntConstant( module, "PRL_ERR_HTTP_REQUEST_FAILED", PRL_ERR_HTTP_REQUEST_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_ACTIVATION_UPDATE_FAILED", PRL_ERR_ACTIVATION_UPDATE_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_ACTIVATION_OFFLINE_PERIOD_EXPIRED", PRL_ERR_ACTIVATION_OFFLINE_PERIOD_EXPIRED );
	PyModule_AddIntConstant( module, "PRL_ERR_ACTIVATION_COMMON_SERVER_ERROR", PRL_ERR_ACTIVATION_COMMON_SERVER_ERROR );
	PyModule_AddIntConstant( module, "PRL_ERR_DEACTIVATE_WRONG_TYPE_OF_ACTIVE_LICENSE", PRL_ERR_DEACTIVATE_WRONG_TYPE_OF_ACTIVE_LICENSE );
	PyModule_AddIntConstant( module, "PRL_ERR_DEACTIVATE_NO_INSTALLED_LICENSE", PRL_ERR_DEACTIVATE_NO_INSTALLED_LICENSE );
	PyModule_AddIntConstant( module, "PRL_ERR_DEACTIVATE_TRIAL_LICENSE", PRL_ERR_DEACTIVATE_TRIAL_LICENSE );
	PyModule_AddIntConstant( module, "PRL_ERR_DEACTIVATION_SERVER_ERROR", PRL_ERR_DEACTIVATION_SERVER_ERROR );
	PyModule_AddIntConstant( module, "PRL_ERR_DEACTIVATION_SERVER_ACTIVATION_ID_IS_INVALID", PRL_ERR_DEACTIVATION_SERVER_ACTIVATION_ID_IS_INVALID );
	PyModule_AddIntConstant( module, "PRL_ERR_DEACTIVATION_SERVER_KEY_IS_INVALID", PRL_ERR_DEACTIVATION_SERVER_KEY_IS_INVALID );
	PyModule_AddIntConstant( module, "PRL_ERR_DEACTIVATION_SERVER_KEY_IS_BLACKLISTED", PRL_ERR_DEACTIVATION_SERVER_KEY_IS_BLACKLISTED );
	PyModule_AddIntConstant( module, "PRL_ERR_DEACTIVATION_WRONG_SERVER_RESPONSE", PRL_ERR_DEACTIVATION_WRONG_SERVER_RESPONSE );
	PyModule_AddIntConstant( module, "PRL_ERR_DEACTIVATION_UNABLE_TO_SEND_REQUEST", PRL_ERR_DEACTIVATION_UNABLE_TO_SEND_REQUEST );
	PyModule_AddIntConstant( module, "PRL_ERR_DEACTIVATION_HTTP_REQUEST_FAILED", PRL_ERR_DEACTIVATION_HTTP_REQUEST_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_DEACTIVATION_COMMON_SERVER_ERROR", PRL_ERR_DEACTIVATION_COMMON_SERVER_ERROR );
	PyModule_AddIntConstant( module, "PRL_ERR_DEACTIVATION_OLD_HWID_NOT_FOUND", PRL_ERR_DEACTIVATION_OLD_HWID_NOT_FOUND );
	PyModule_AddIntConstant( module, "PRL_ERR_LIC_REGISTRATION_COMMON_ERROR", PRL_ERR_LIC_REGISTRATION_COMMON_ERROR );
	PyModule_AddIntConstant( module, "PRL_ERR_VTD_DEVICE_NOT_MAPPED", PRL_ERR_VTD_DEVICE_NOT_MAPPED );
	PyModule_AddIntConstant( module, "PET_QUESTION_SAMPLE_1", PET_QUESTION_SAMPLE_1 );
	PyModule_AddIntConstant( module, "PET_QUESTION_SAMPLE_2", PET_QUESTION_SAMPLE_2 );
	PyModule_AddIntConstant( module, "PET_QUESTION_DO_YOU_WANT_TO_OVERWRITE_FILE", PET_QUESTION_DO_YOU_WANT_TO_OVERWRITE_FILE );
	PyModule_AddIntConstant( module, "PET_QUESTION_TXT_ERROR", PET_QUESTION_TXT_ERROR );
	PyModule_AddIntConstant( module, "PET_QUESTION_OLD_CONFIG_CONVERTION", PET_QUESTION_OLD_CONFIG_CONVERTION );
	PyModule_AddIntConstant( module, "PET_QUESTION_FREE_SIZE_FOR_COMPRESSED_DISK", PET_QUESTION_FREE_SIZE_FOR_COMPRESSED_DISK );
	PyModule_AddIntConstant( module, "PET_QUESTION_DELETE_FILES_OUT_OF_VM_DIR", PET_QUESTION_DELETE_FILES_OUT_OF_VM_DIR );
	PyModule_AddIntConstant( module, "PET_QUESTION_DELETE_PARALLELS_FILES_IN_VM_DIR", PET_QUESTION_DELETE_PARALLELS_FILES_IN_VM_DIR );
	PyModule_AddIntConstant( module, "PET_QUESTION_REGISTER_VM_TEMPLATE", PET_QUESTION_REGISTER_VM_TEMPLATE );
	PyModule_AddIntConstant( module, "PET_QUESTION_DELETE_VM_WITH_CORRUPTED_CONFIG", PET_QUESTION_DELETE_VM_WITH_CORRUPTED_CONFIG );
	PyModule_AddIntConstant( module, "PET_QUESTION_REGISTER_USED_VM", PET_QUESTION_REGISTER_USED_VM );
	PyModule_AddIntConstant( module, "PET_QUESTION_CREATE_NEW_MAC_ADDRESS", PET_QUESTION_CREATE_NEW_MAC_ADDRESS );
	PyModule_AddIntConstant( module, "PET_QUESTION_CHANGE_VM_MIGRATION_TYPE", PET_QUESTION_CHANGE_VM_MIGRATION_TYPE );
	PyModule_AddIntConstant( module, "PET_QUESTION_VM_COPY_OR_MOVE", PET_QUESTION_VM_COPY_OR_MOVE );
	PyModule_AddIntConstant( module, "PET_QUESTION_REACH_OVERCOMMIT_STATE", PET_QUESTION_REACH_OVERCOMMIT_STATE );
	PyModule_AddIntConstant( module, "PET_QUESTION_BOOTCAMP_HELPER_INIT_FAILURE", PET_QUESTION_BOOTCAMP_HELPER_INIT_FAILURE );
	PyModule_AddIntConstant( module, "PET_QUESTION_BOOTCAMP_HELPER_OS_UNSUPPORTED", PET_QUESTION_BOOTCAMP_HELPER_OS_UNSUPPORTED );
	PyModule_AddIntConstant( module, "PET_QUESTION_REACH_OVERCOMMIT_STATE_ON_SETMEM", PET_QUESTION_REACH_OVERCOMMIT_STATE_ON_SETMEM );
	PyModule_AddIntConstant( module, "PET_QUESTION_UNDO_DISKS_MODE", PET_QUESTION_UNDO_DISKS_MODE );
	PyModule_AddIntConstant( module, "PET_QUESTION_MAC_PHYSICAL_MEMORY_MAP_BUG", PET_QUESTION_MAC_PHYSICAL_MEMORY_MAP_BUG );
	PyModule_AddIntConstant( module, "PET_QUESTION_CREATE_OS2_GUEST_WITHOUT_FDD_IMAGE", PET_QUESTION_CREATE_OS2_GUEST_WITHOUT_FDD_IMAGE );
	PyModule_AddIntConstant( module, "PET_QUESTION_APPLY_WHEN_HYP_CANNOT_ALLOC_VMS_MEM", PET_QUESTION_APPLY_WHEN_HYP_CANNOT_ALLOC_VMS_MEM );
	PyModule_AddIntConstant( module, "PET_QUESTION_ALLOW_TO_SUSPEND_VM_WITH_BOOTCAMP_DISK", PET_QUESTION_ALLOW_TO_SUSPEND_VM_WITH_BOOTCAMP_DISK );
	PyModule_AddIntConstant( module, "PET_QUESTION_RESTORE_VM_CONFIG_FROM_BACKUP", PET_QUESTION_RESTORE_VM_CONFIG_FROM_BACKUP );
	PyModule_AddIntConstant( module, "PET_QUESTION_CANCEL_CLONE_OPERATION", PET_QUESTION_CANCEL_CLONE_OPERATION );
	PyModule_AddIntConstant( module, "PET_QUESTION_CANCEL_CLONE_TO_TEMPLATE_OPERATION", PET_QUESTION_CANCEL_CLONE_TO_TEMPLATE_OPERATION );
	PyModule_AddIntConstant( module, "PET_QUESTION_CANCEL_DEPLOY_OPERATION", PET_QUESTION_CANCEL_DEPLOY_OPERATION );
	PyModule_AddIntConstant( module, "PET_QUESTION_REBOOT_HOST_ON_PCI_DRIVER_INSTALL_OR_REVERT", PET_QUESTION_REBOOT_HOST_ON_PCI_DRIVER_INSTALL_OR_REVERT );
	PyModule_AddIntConstant( module, "PET_QUESTION_VM_ROOT_DIRECTORY_NOT_EXISTS", PET_QUESTION_VM_ROOT_DIRECTORY_NOT_EXISTS );
	PyModule_AddIntConstant( module, "PET_QUESTION_RESTART_VM_GUEST_TO_COMPACT", PET_QUESTION_RESTART_VM_GUEST_TO_COMPACT );
	PyModule_AddIntConstant( module, "PET_QUESTION_STOP_VM_TO_COMPACT", PET_QUESTION_STOP_VM_TO_COMPACT );
	PyModule_AddIntConstant( module, "PET_QUESTION_COMPACT_VM_DISKS", PET_QUESTION_COMPACT_VM_DISKS );
	PyModule_AddIntConstant( module, "PET_QUESTION_CONTINUE_IF_HVT_DISABLED", PET_QUESTION_CONTINUE_IF_HVT_DISABLED );
	PyModule_AddIntConstant( module, "PET_QUESTION_DELAYED_COMPACT_VM_DISKS", PET_QUESTION_DELAYED_COMPACT_VM_DISKS );
	PyModule_AddIntConstant( module, "PET_QUESTION_SWITCH_OFF_AUTO_COMPRESS", PET_QUESTION_SWITCH_OFF_AUTO_COMPRESS );
	PyModule_AddIntConstant( module, "PET_QUESTION_FORCE_COMPACT_VM_DISKS", PET_QUESTION_FORCE_COMPACT_VM_DISKS );
	PyModule_AddIntConstant( module, "PET_QUESTION_BACKUP_RESTORE_NOT_ENOUGH_FREE_DISK_SPACE", PET_QUESTION_BACKUP_RESTORE_NOT_ENOUGH_FREE_DISK_SPACE );
	PyModule_AddIntConstant( module, "PET_QUESTION_BACKUP_CREATE_NOT_ENOUGH_FREE_DISK_SPACE", PET_QUESTION_BACKUP_CREATE_NOT_ENOUGH_FREE_DISK_SPACE );
	PyModule_AddIntConstant( module, "PET_QUESTION_APPLIANCE_CORRUPTED_INSTALLATION", PET_QUESTION_APPLIANCE_CORRUPTED_INSTALLATION );
	PyModule_AddIntConstant( module, "PET_QUESTION_ON_QUERY_END_SESSION", PET_QUESTION_ON_QUERY_END_SESSION );
	PyModule_AddIntConstant( module, "PET_QUESTION_ON_QUERY_END_SESSION_RESTRICTED", PET_QUESTION_ON_QUERY_END_SESSION_RESTRICTED );
	PyModule_AddIntConstant( module, "PRL_QUESTION_CONVERT_3RD_PARTY_CANNOT_MIGRATE", PRL_QUESTION_CONVERT_3RD_PARTY_CANNOT_MIGRATE );
	PyModule_AddIntConstant( module, "PET_QUESTION_VM_REBOOT_REQUIRED_BY_PRL_TOOLS", PET_QUESTION_VM_REBOOT_REQUIRED_BY_PRL_TOOLS );
	PyModule_AddIntConstant( module, "PRL_QUESTION_CONVERT_VM_SPECIFY_DISTRO_PATH", PRL_QUESTION_CONVERT_VM_SPECIFY_DISTRO_PATH );
	PyModule_AddIntConstant( module, "PRL_QUESTION_ASK_ENCRYPTED_VM_PASSWORD", PRL_QUESTION_ASK_ENCRYPTED_VM_PASSWORD );
	PyModule_AddIntConstant( module, "PET_QUESTION_CANCEL_IMPORT_BOOTCAMP_OPERATION", PET_QUESTION_CANCEL_IMPORT_BOOTCAMP_OPERATION );
	PyModule_AddIntConstant( module, "PRL_QUESTION_CONVERT_VM_CANT_DETECT_OS", PRL_QUESTION_CONVERT_VM_CANT_DETECT_OS );
	PyModule_AddIntConstant( module, "PET_QUESTION_CANCEL_CONVERT_3RD_VM_OPERATION", PET_QUESTION_CANCEL_CONVERT_3RD_VM_OPERATION );
	PyModule_AddIntConstant( module, "PET_QUESTION_COMMON_HDD_ERROR", PET_QUESTION_COMMON_HDD_ERROR );
	PyModule_AddIntConstant( module, "PRL_WARN_VM_DISCONNECT_SATA_HDD", PRL_WARN_VM_DISCONNECT_SATA_HDD );
	PyModule_AddIntConstant( module, "PRL_QUESTION_FINALIZE_VM_PROCESS", PRL_QUESTION_FINALIZE_VM_PROCESS );
	PyModule_AddIntConstant( module, "PET_QUESTION_SUSPEND_STATE_INCOMPATIBLE_CPU", PET_QUESTION_SUSPEND_STATE_INCOMPATIBLE_CPU );
	PyModule_AddIntConstant( module, "PET_QUESTION_SNAPSHOT_STATE_INCOMPATIBLE_CPU", PET_QUESTION_SNAPSHOT_STATE_INCOMPATIBLE_CPU );
	PyModule_AddIntConstant( module, "PET_QUESTION_CREATE_VM_FROM_LION_RECOVERY_PART", PET_QUESTION_CREATE_VM_FROM_LION_RECOVERY_PART );
	PyModule_AddIntConstant( module, "PET_QUESTION_SUSPEND_STATE_INCOMPATIBLE", PET_QUESTION_SUSPEND_STATE_INCOMPATIBLE );
	PyModule_AddIntConstant( module, "PET_QUESTION_SNAPSHOT_STATE_INCOMPATIBLE", PET_QUESTION_SNAPSHOT_STATE_INCOMPATIBLE );
	PyModule_AddIntConstant( module, "PRL_QUESTION_CONVERT_GUEST_OS_IS_HIBERNATED", PRL_QUESTION_CONVERT_GUEST_OS_IS_HIBERNATED );
	PyModule_AddIntConstant( module, "PRL_QUESTION_SETUP_YANDEX_SEARCH", PRL_QUESTION_SETUP_YANDEX_SEARCH );
	PyModule_AddIntConstant( module, "PET_ANSWER_OK", PET_ANSWER_OK );
	PyModule_AddIntConstant( module, "PET_ANSWER_CANCEL", PET_ANSWER_CANCEL );
	PyModule_AddIntConstant( module, "PET_ANSWER_YES", PET_ANSWER_YES );
	PyModule_AddIntConstant( module, "PET_ANSWER_NO", PET_ANSWER_NO );
	PyModule_AddIntConstant( module, "PET_ANSWER_BREAK", PET_ANSWER_BREAK );
	PyModule_AddIntConstant( module, "PET_ANSWER_OVERIDE", PET_ANSWER_OVERIDE );
	PyModule_AddIntConstant( module, "PET_ANSWER_SHUTDOWN", PET_ANSWER_SHUTDOWN );
	PyModule_AddIntConstant( module, "PET_ANSWER_STOP", PET_ANSWER_STOP );
	PyModule_AddIntConstant( module, "PET_ANSWER_CONTINUE", PET_ANSWER_CONTINUE );
	PyModule_AddIntConstant( module, "PET_ANSWER_CREATE_NEW", PET_ANSWER_CREATE_NEW );
	PyModule_AddIntConstant( module, "PET_ANSWER_USE_CURRENT", PET_ANSWER_USE_CURRENT );
	PyModule_AddIntConstant( module, "PET_ANSWER_APPEND", PET_ANSWER_APPEND );
	PyModule_AddIntConstant( module, "PET_ANSWER_REPLACE", PET_ANSWER_REPLACE );
	PyModule_AddIntConstant( module, "PET_ANSWER_COPIED", PET_ANSWER_COPIED );
	PyModule_AddIntConstant( module, "PET_ANSWER_MOVED", PET_ANSWER_MOVED );
	PyModule_AddIntConstant( module, "PET_ANSWER_STARTVM", PET_ANSWER_STARTVM );
	PyModule_AddIntConstant( module, "PET_ANSWER_COMMIT", PET_ANSWER_COMMIT );
	PyModule_AddIntConstant( module, "PET_ANSWER_REVERT", PET_ANSWER_REVERT );
	PyModule_AddIntConstant( module, "PET_ANSWER_DISCONNECT_ANYWAY", PET_ANSWER_DISCONNECT_ANYWAY );
	PyModule_AddIntConstant( module, "PET_ANSWER_CREATE", PET_ANSWER_CREATE );
	PyModule_AddIntConstant( module, "PET_ANSWER_SKIP", PET_ANSWER_SKIP );
	PyModule_AddIntConstant( module, "PET_ANSWER_SUSPEND_ANYWAY", PET_ANSWER_SUSPEND_ANYWAY );
	PyModule_AddIntConstant( module, "PET_ANSWER_RESTART_NOW", PET_ANSWER_RESTART_NOW );
	PyModule_AddIntConstant( module, "PET_ANSWER_LATER", PET_ANSWER_LATER );
	PyModule_AddIntConstant( module, "PET_ANSWER_COMPACT", PET_ANSWER_COMPACT );
	PyModule_AddIntConstant( module, "PET_ANSWER_SUSPEND", PET_ANSWER_SUSPEND );
	PyModule_AddIntConstant( module, "PET_ANSWER_STOP_AND_RESTORE", PET_ANSWER_STOP_AND_RESTORE );
	PyModule_AddIntConstant( module, "PET_ANSWER_RESTORE", PET_ANSWER_RESTORE );
	PyModule_AddIntConstant( module, "PET_ANSWER_BROWSE", PET_ANSWER_BROWSE );
	PyModule_AddIntConstant( module, "PET_ANSWER_RETRY", PET_ANSWER_RETRY );
	PyModule_AddIntConstant( module, "PET_ANSWER_RESTART", PET_ANSWER_RESTART );
	PyModule_AddIntConstant( module, "PET_ANSWER_RESUME", PET_ANSWER_RESUME );
	PyModule_AddIntConstant( module, "PET_ANSWER_CHANGE", PET_ANSWER_CHANGE );
	PyModule_AddIntConstant( module, "PET_ANSWER_DONT_CHANGE", PET_ANSWER_DONT_CHANGE );
	PyModule_AddIntConstant( module, "PRL_ERR_UPD_UPDATER_CONFIG", PRL_ERR_UPD_UPDATER_CONFIG );
	PyModule_AddIntConstant( module, "PRL_ERR_UPD_UPDATES", PRL_ERR_UPD_UPDATES );
	PyModule_AddIntConstant( module, "PRL_ERR_CREATE_PRIVELEGED_PROCESS", PRL_ERR_CREATE_PRIVELEGED_PROCESS );
	PyModule_AddIntConstant( module, "PRL_ERR_VA_CONFIG", PRL_ERR_VA_CONFIG );
	PyModule_AddIntConstant( module, "PRL_ERR_STATE_UNEXPECTED_ERROR", PRL_ERR_STATE_UNEXPECTED_ERROR );
	PyModule_AddIntConstant( module, "PRL_ERR_STATE_NO_DISKS", PRL_ERR_STATE_NO_DISKS );
	PyModule_AddIntConstant( module, "PRL_ERR_STATE_PROCESS_RUNNING", PRL_ERR_STATE_PROCESS_RUNNING );
	PyModule_AddIntConstant( module, "PRL_ERR_STATE_STOPPING_STATE", PRL_ERR_STATE_STOPPING_STATE );
	PyModule_AddIntConstant( module, "PRL_ERR_STATE_ROLLBACK_IN_PROGRESS", PRL_ERR_STATE_ROLLBACK_IN_PROGRESS );
	PyModule_AddIntConstant( module, "PRL_ERR_STATE_ROLLBACK_ERROR", PRL_ERR_STATE_ROLLBACK_ERROR );
	PyModule_AddIntConstant( module, "PRL_ERR_STATE_INVALID_PARAMETERS", PRL_ERR_STATE_INVALID_PARAMETERS );
	PyModule_AddIntConstant( module, "PRL_ERR_STATE_ERROR_CREATE_IMAGE", PRL_ERR_STATE_ERROR_CREATE_IMAGE );
	PyModule_AddIntConstant( module, "PRL_ERR_STATE_ERROR_RENAMING_IMAGE", PRL_ERR_STATE_ERROR_RENAMING_IMAGE );
	PyModule_AddIntConstant( module, "PRL_ERR_STATE_CANT_OPEN_IMAGE", PRL_ERR_STATE_CANT_OPEN_IMAGE );
	PyModule_AddIntConstant( module, "PRL_ERR_STATE_CANT_OPEN_FOR_WRITE", PRL_ERR_STATE_CANT_OPEN_FOR_WRITE );
	PyModule_AddIntConstant( module, "PRL_ERR_STATE_CANT_OPEN_LOCKED", PRL_ERR_STATE_CANT_OPEN_LOCKED );
	PyModule_AddIntConstant( module, "PRL_ERR_STATE_CANT_SAVE_LOCKED", PRL_ERR_STATE_CANT_SAVE_LOCKED );
	PyModule_AddIntConstant( module, "PRL_ERR_STATE_INT_CORRUPTED", PRL_ERR_STATE_INT_CORRUPTED );
	PyModule_AddIntConstant( module, "PRL_ERR_STATE_NO_STATE", PRL_ERR_STATE_NO_STATE );
	PyModule_AddIntConstant( module, "PRL_ERR_STATE_ALREADY_EXISTS", PRL_ERR_STATE_ALREADY_EXISTS );
	PyModule_AddIntConstant( module, "PRL_ERR_STATE_NOT_OPENED", PRL_ERR_STATE_NOT_OPENED );
	PyModule_AddIntConstant( module, "PRL_ERR_STATE_NOT_PERMITTED", PRL_ERR_STATE_NOT_PERMITTED );
	PyModule_AddIntConstant( module, "PRL_ERR_STATE_FULL_DELETE_FAILED", PRL_ERR_STATE_FULL_DELETE_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_STATE_MERGE_FAILED", PRL_ERR_STATE_MERGE_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_STATE_MERGE_NO_SPACE", PRL_ERR_STATE_MERGE_NO_SPACE );
	PyModule_AddIntConstant( module, "PRL_ERR_STATE_MEMORY_ERROR", PRL_ERR_STATE_MEMORY_ERROR );
	PyModule_AddIntConstant( module, "PRL_ERR_STATE_INVALID_IMAGE_TYPE", PRL_ERR_STATE_INVALID_IMAGE_TYPE );
	PyModule_AddIntConstant( module, "PRL_ERR_STATE_DELETE_NONCLOSED", PRL_ERR_STATE_DELETE_NONCLOSED );
	PyModule_AddIntConstant( module, "PRL_ERR_STATE_CANT_LOAD_SPECIFIED_CFG", PRL_ERR_STATE_CANT_LOAD_SPECIFIED_CFG );
	PyModule_AddIntConstant( module, "PRL_ERR_STATE_GETFREESPACE_FAILED", PRL_ERR_STATE_GETFREESPACE_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_STATE_STATFS_FAILED", PRL_ERR_STATE_STATFS_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_STATE_NOT_RELEASED", PRL_ERR_STATE_NOT_RELEASED );
	PyModule_AddIntConstant( module, "PRL_ERR_CORE_STATE_ERROR_COMMON", PRL_ERR_CORE_STATE_ERROR_COMMON );
	PyModule_AddIntConstant( module, "PRL_ERR_CORE_STATE_INV_SAV_VERSION", PRL_ERR_CORE_STATE_INV_SAV_VERSION );
	PyModule_AddIntConstant( module, "PRL_ERR_CORE_STATE_CORRUPT_SAV_FILE", PRL_ERR_CORE_STATE_CORRUPT_SAV_FILE );
	PyModule_AddIntConstant( module, "PRL_ERR_CORE_STATE_CORRUPT_MEM_FILE", PRL_ERR_CORE_STATE_CORRUPT_MEM_FILE );
	PyModule_AddIntConstant( module, "PRL_ERR_CORE_STATE_CHANGE_VM_CONFIG", PRL_ERR_CORE_STATE_CHANGE_VM_CONFIG );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_SUSPEND_FAILED", PRL_ERR_VM_SUSPEND_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_RESUME_FAILED", PRL_ERR_VM_RESUME_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_RESUME_INV_SAV_VERSION_CANCEL_RESUME", PRL_ERR_VM_RESUME_INV_SAV_VERSION_CANCEL_RESUME );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_SUSPEND_CHANGED_VM_CONFIG", PRL_ERR_VM_SUSPEND_CHANGED_VM_CONFIG );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_MEMORY_SWAPPING_IN_PROGRESS", PRL_ERR_VM_MEMORY_SWAPPING_IN_PROGRESS );
	PyModule_AddIntConstant( module, "PRL_ERR_CANT_SUSPEND_VM_WITH_BOOTCAMP", PRL_ERR_CANT_SUSPEND_VM_WITH_BOOTCAMP );
	PyModule_AddIntConstant( module, "PRL_ERR_SAFE_MODE_START_DURING_SUSPENDING_SYNC", PRL_ERR_SAFE_MODE_START_DURING_SUSPENDING_SYNC );
	PyModule_AddIntConstant( module, "PRL_ERR_CORE_STATE_VM_WOULD_STOP", PRL_ERR_CORE_STATE_VM_WOULD_STOP );
	PyModule_AddIntConstant( module, "PRL_ERR_RESUME_BOOTCAMP_CORRUPT_DISK_STATE_PARAM", PRL_ERR_RESUME_BOOTCAMP_CORRUPT_DISK_STATE_PARAM );
	PyModule_AddIntConstant( module, "PRL_ERR_RESUME_BOOTCAMP_CHANGED_DISK_CONTENTS", PRL_ERR_RESUME_BOOTCAMP_CHANGED_DISK_CONTENTS );
	PyModule_AddIntConstant( module, "PRL_ERR_SUSPEND_BOOTCAMP_NOT_NTFS_ONLY_DISK", PRL_ERR_SUSPEND_BOOTCAMP_NOT_NTFS_ONLY_DISK );
	PyModule_AddIntConstant( module, "PRL_ERR_SUSPEND_BOOTCAMP_NTFS_RW_MOUNTERS_DETECTED", PRL_ERR_SUSPEND_BOOTCAMP_NTFS_RW_MOUNTERS_DETECTED );
	PyModule_AddIntConstant( module, "PRL_ERR_CORE_STATE_NO_FILE", PRL_ERR_CORE_STATE_NO_FILE );
	PyModule_AddIntConstant( module, "PRL_ERR_CORE_STATE_CANCELLED", PRL_ERR_CORE_STATE_CANCELLED );
	PyModule_AddIntConstant( module, "PRL_ERR_CORE_STATE_VM_WOULD_RESTART", PRL_ERR_CORE_STATE_VM_WOULD_RESTART );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_GENERIC_ERROR", PRL_ERR_DISK_GENERIC_ERROR );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_XML_OPEN_FAILED", PRL_ERR_DISK_XML_OPEN_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_XML_INVALID", PRL_ERR_DISK_XML_INVALID );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_XML_INVALID_VERSION", PRL_ERR_DISK_XML_INVALID_VERSION );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_XML_SAVE_ERROR", PRL_ERR_DISK_XML_SAVE_ERROR );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_XML_LARGE_FILE", PRL_ERR_DISK_XML_LARGE_FILE );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_SNAPSHOTS_CORRUPTED", PRL_ERR_DISK_SNAPSHOTS_CORRUPTED );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_STORAGE_CORRUPTED", PRL_ERR_DISK_STORAGE_CORRUPTED );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_IMAGES_CORRUPTED", PRL_ERR_DISK_IMAGES_CORRUPTED );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_INVALID_BLOCKSIZE", PRL_ERR_DISK_INVALID_BLOCKSIZE );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_STATES_ERROR", PRL_ERR_DISK_STATES_ERROR );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_INVALID_PARAMETERS", PRL_ERR_DISK_INVALID_PARAMETERS );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_FILE_EXISTS", PRL_ERR_DISK_FILE_EXISTS );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_FILE_CREATE_ERROR", PRL_ERR_DISK_FILE_CREATE_ERROR );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_FILE_OPEN_ERROR", PRL_ERR_DISK_FILE_OPEN_ERROR );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_DIR_CREATE_ERROR", PRL_ERR_DISK_DIR_CREATE_ERROR );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_CREATE_IMAGE_ERROR", PRL_ERR_DISK_CREATE_IMAGE_ERROR );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_OPERATION_IN_PROGRESS", PRL_ERR_DISK_OPERATION_IN_PROGRESS );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_BLOCK_SKIPPED", PRL_ERR_DISK_BLOCK_SKIPPED );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_BLOCK_PARTIALLY_PROCESSED", PRL_ERR_DISK_BLOCK_PARTIALLY_PROCESSED );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_MEMORY_ERROR", PRL_ERR_DISK_MEMORY_ERROR );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_DISK_NOT_OPENED", PRL_ERR_DISK_DISK_NOT_OPENED );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_INSUFFICIENT_SPACE", PRL_ERR_DISK_INSUFFICIENT_SPACE );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_FAT32_SIZE_EXCEEDED", PRL_ERR_DISK_FAT32_SIZE_EXCEEDED );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_NOT_PERMITTED", PRL_ERR_DISK_NOT_PERMITTED );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_INTERNAL_CLASS_ERROR", PRL_ERR_DISK_INTERNAL_CLASS_ERROR );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_WRITE_OUT_DISK", PRL_ERR_DISK_WRITE_OUT_DISK );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_WRITE_FAILED", PRL_ERR_DISK_WRITE_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_READ_OUT_DISK", PRL_ERR_DISK_READ_OUT_DISK );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_READ_FAILED", PRL_ERR_DISK_READ_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_SET_CACHING_FAILED", PRL_ERR_DISK_SET_CACHING_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_FSYNC_FAILED", PRL_ERR_DISK_FSYNC_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_FULLFSYNC_FAILED", PRL_ERR_DISK_FULLFSYNC_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_INVALID_FORMAT", PRL_ERR_DISK_INVALID_FORMAT );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_RENAME_ERROR", PRL_ERR_DISK_RENAME_ERROR );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_OPERATION_NOT_ALLOWED", PRL_ERR_DISK_OPERATION_NOT_ALLOWED );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_OPERATION_ABORTED", PRL_ERR_DISK_OPERATION_ABORTED );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_SHARING_VIOLATION", PRL_ERR_DISK_SHARING_VIOLATION );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_USER_INTERRUPTED", PRL_ERR_DISK_USER_INTERRUPTED );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_XML_SAVE_REMOVE_ERROR", PRL_ERR_DISK_XML_SAVE_REMOVE_ERROR );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_XML_SAVE_RENAME_ERROR", PRL_ERR_DISK_XML_SAVE_RENAME_ERROR );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_WRITE_REAL_FAILED", PRL_ERR_DISK_WRITE_REAL_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_NOT_IMPLEMENTED", PRL_ERR_DISK_NOT_IMPLEMENTED );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_PARTITIONS_TABLE_CYCLE", PRL_ERR_DISK_PARTITIONS_TABLE_CYCLE );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_IMAGE_BUSY", PRL_ERR_DISK_IMAGE_BUSY );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_BLOCK_CREATED", PRL_ERR_DISK_BLOCK_CREATED );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_GROUP_INTERSECT", PRL_ERR_DISK_GROUP_INTERSECT );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_INCORRECTLY_CLOSED", PRL_ERR_DISK_INCORRECTLY_CLOSED );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_OFFSETS_FIXED", PRL_ERR_DISK_OFFSETS_FIXED );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_CANT_INITIALIZE_IMAGE", PRL_ERR_DISK_CANT_INITIALIZE_IMAGE );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_SMALL_IMAGE_SIZE", PRL_ERR_DISK_SMALL_IMAGE_SIZE );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_NULL_PART_SIZE", PRL_ERR_DISK_NULL_PART_SIZE );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_XML_LOCKED", PRL_ERR_DISK_XML_LOCKED );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_PARTITION_NOT_FOUND", PRL_ERR_DISK_PARTITION_NOT_FOUND );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_PARTITION_INVALID_NAME", PRL_ERR_DISK_PARTITION_INVALID_NAME );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_UNALIGNED", PRL_ERR_DISK_UNALIGNED );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_NOT_VALID_OFFSET", PRL_ERR_DISK_NOT_VALID_OFFSET );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_ENLARGE_FAILED", PRL_ERR_DISK_ENLARGE_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_POSSIBLE_OVERRUN", PRL_ERR_DISK_POSSIBLE_OVERRUN );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_BOOTCAMP_WRITE_MBR", PRL_ERR_DISK_BOOTCAMP_WRITE_MBR );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_IMPERSONATE_FAILED", PRL_ERR_DISK_IMPERSONATE_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_XML_MISSING", PRL_ERR_DISK_XML_MISSING );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_UNCOMMITED_OPERATION", PRL_ERR_DISK_UNCOMMITED_OPERATION );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_MOUNTED_OVERLAP", PRL_ERR_DISK_MOUNTED_OVERLAP );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_GET_SIZE_FAILED", PRL_ERR_DISK_GET_SIZE_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_GPT_MBR_NOT_EQUAL", PRL_ERR_DISK_GPT_MBR_NOT_EQUAL );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_XML_DIFFERS_FROM_REAL", PRL_ERR_DISK_XML_DIFFERS_FROM_REAL );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_XML_PARTITION_NOT_FOUND", PRL_ERR_DISK_XML_PARTITION_NOT_FOUND );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_SHARED_BLOCK", PRL_ERR_DISK_SHARED_BLOCK );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_COMPRESSED_FILE_EMPTY", PRL_ERR_DISK_COMPRESSED_FILE_EMPTY );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_TRUNCATE_FAILED", PRL_ERR_DISK_TRUNCATE_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_BLOCK_SEARCH_FAILED", PRL_ERR_DISK_BLOCK_SEARCH_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_POINTERS_MIXED_UP", PRL_ERR_DISK_POINTERS_MIXED_UP );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_SET_FILE_SIZE_FAILED", PRL_ERR_DISK_SET_FILE_SIZE_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_DATA_NOT_FOUND", PRL_ERR_DISK_DATA_NOT_FOUND );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_RESERVED_WORD", PRL_ERR_DISK_RESERVED_WORD );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_GET_MOUNTPATH_FAILED", PRL_ERR_DISK_GET_MOUNTPATH_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_MOUNT_FAILED", PRL_ERR_DISK_MOUNT_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_UNMOUNT_FAILED", PRL_ERR_DISK_UNMOUNT_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_GET_PARAMS_FAILED", PRL_ERR_DISK_GET_PARAMS_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_IDENTIFY_FAILED", PRL_ERR_DISK_IDENTIFY_FAILED );
	PyModule_AddIntConstant( module, "PRL_CHECKED_DISK_VALID", PRL_CHECKED_DISK_VALID );
	PyModule_AddIntConstant( module, "PRL_CHECKED_DISK_OLD_VERSION", PRL_CHECKED_DISK_OLD_VERSION );
	PyModule_AddIntConstant( module, "PRL_CHECKED_DISK_INVALID", PRL_CHECKED_DISK_INVALID );
	PyModule_AddIntConstant( module, "PRL_ERR_FILE_TRANSFER_CLIENT_NOT_CONNECTED", PRL_ERR_FILE_TRANSFER_CLIENT_NOT_CONNECTED );
	PyModule_AddIntConstant( module, "PRL_ERR_FILE_TRANSFER_CANT_LOCATE_SRC_FILE", PRL_ERR_FILE_TRANSFER_CANT_LOCATE_SRC_FILE );
	PyModule_AddIntConstant( module, "PRL_ERR_FILE_TRANSFER_CANT_READ_SRC_FILE", PRL_ERR_FILE_TRANSFER_CANT_READ_SRC_FILE );
	PyModule_AddIntConstant( module, "PRL_ERR_FILE_TRANSFER_INVALID_CREDENTIALS", PRL_ERR_FILE_TRANSFER_INVALID_CREDENTIALS );
	PyModule_AddIntConstant( module, "PRL_ERR_FILE_TRANSFER_CANT_CREATE_DST_FILE", PRL_ERR_FILE_TRANSFER_CANT_CREATE_DST_FILE );
	PyModule_AddIntConstant( module, "PRL_ERR_FILE_TRANSFER_CANT_WRITE_DATA_TO_DST_FILE", PRL_ERR_FILE_TRANSFER_CANT_WRITE_DATA_TO_DST_FILE );
	PyModule_AddIntConstant( module, "PRL_ERR_FILE_TRANSFER_DST_FILE_ALREADY_EXIST", PRL_ERR_FILE_TRANSFER_DST_FILE_ALREADY_EXIST );
	PyModule_AddIntConstant( module, "PRL_ERR_FILE_TRANSFER_OPERATION_NOT_SUPPORTED", PRL_ERR_FILE_TRANSFER_OPERATION_NOT_SUPPORTED );
	PyModule_AddIntConstant( module, "PRL_ERR_FILE_TRANSFER_UPLOAD_CANCELED_BY_USER", PRL_ERR_FILE_TRANSFER_UPLOAD_CANCELED_BY_USER );
	PyModule_AddIntConstant( module, "PRL_ERR_FILE_TRANSFER_INVALID_ARGUMENTS", PRL_ERR_FILE_TRANSFER_INVALID_ARGUMENTS );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_RESTRICTED_OS_VERSION", PRL_ERR_VMCONF_RESTRICTED_OS_VERSION );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_RESTRICTED_CPU_COUNT", PRL_ERR_VMCONF_RESTRICTED_CPU_COUNT );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_RESTRICTED_MEMORY_SIZE", PRL_ERR_VMCONF_RESTRICTED_MEMORY_SIZE );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_RESTRICTED_UNDO_DISKS", PRL_ERR_VMCONF_RESTRICTED_UNDO_DISKS );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_RESTRICTED_SMART_GUARD", PRL_ERR_VMCONF_RESTRICTED_SMART_GUARD );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_VALIDATION_FAILED", PRL_ERR_VMCONF_VALIDATION_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_VM_NAME_IS_EMPTY", PRL_ERR_VMCONF_VM_NAME_IS_EMPTY );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_UNKNOWN_OS_TYPE", PRL_ERR_VMCONF_UNKNOWN_OS_TYPE );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_UNKNOWN_OS_VERSION", PRL_ERR_VMCONF_UNKNOWN_OS_VERSION );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_VM_NAME_HAS_INVALID_SYMBOL", PRL_ERR_VMCONF_VM_NAME_HAS_INVALID_SYMBOL );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_INVALID_DEVICE_MAIN_INDEX", PRL_ERR_VMCONF_INVALID_DEVICE_MAIN_INDEX );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_DESKTOP_MODE_REMOTE_DEVICES", PRL_ERR_VMCONF_DESKTOP_MODE_REMOTE_DEVICES );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_REAL_HARD_UNDO_DISKS_NOT_ALLOW", PRL_ERR_VMCONF_REAL_HARD_UNDO_DISKS_NOT_ALLOW );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_BOOTCAMP_HARD_UNDO_DISKS_NOT_ALLOW", PRL_ERR_VMCONF_BOOTCAMP_HARD_UNDO_DISKS_NOT_ALLOW );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_INCOMPAT_HARD_UNDO_DISKS_NOT_ALLOW", PRL_ERR_VMCONF_INCOMPAT_HARD_UNDO_DISKS_NOT_ALLOW );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_BOOTCAMP_HARD_SNAPSHOTS_NOT_ALLOW", PRL_ERR_VMCONF_BOOTCAMP_HARD_SNAPSHOTS_NOT_ALLOW );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_REAL_HARD_SAFE_MODE_NOT_ALLOW", PRL_ERR_VMCONF_REAL_HARD_SAFE_MODE_NOT_ALLOW );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_BOOTCAMP_SAFE_MODE_NOT_ALLOW", PRL_ERR_VMCONF_BOOTCAMP_SAFE_MODE_NOT_ALLOW );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_INCOMPAT_SAFE_MODE_NOT_ALLOW", PRL_ERR_VMCONF_INCOMPAT_SAFE_MODE_NOT_ALLOW );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_NO_HD_IMAGES_IN_UNDO_DISKS_MODE", PRL_ERR_VMCONF_NO_HD_IMAGES_IN_UNDO_DISKS_MODE );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_NO_HD_IMAGES_IN_SAFE_MODE", PRL_ERR_VMCONF_NO_HD_IMAGES_IN_SAFE_MODE );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_BOOTCAMP_HARD_DISK_SMART_GUARD_NOT_ALLOW", PRL_ERR_VMCONF_BOOTCAMP_HARD_DISK_SMART_GUARD_NOT_ALLOW );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_INCOMPAT_HARD_DISK_SMART_GUARD_NOT_ALLOW", PRL_ERR_VMCONF_INCOMPAT_HARD_DISK_SMART_GUARD_NOT_ALLOW );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_VIDEO_NOT_ENABLED", PRL_ERR_VMCONF_VIDEO_NOT_ENABLED );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_NO_AUTO_COMPRESS_WITH_UNDO_DISKS", PRL_ERR_VMCONF_NO_AUTO_COMPRESS_WITH_UNDO_DISKS );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_NO_AUTO_COMPRESS_WITH_SMART_GUARD", PRL_ERR_VMCONF_NO_AUTO_COMPRESS_WITH_SMART_GUARD );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_NO_SMART_GUARD_WITH_UNDO_DISKS", PRL_ERR_VMCONF_NO_SMART_GUARD_WITH_UNDO_DISKS );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_CPUUNITS_NOT_SUPPORTED", PRL_ERR_VMCONF_CPUUNITS_NOT_SUPPORTED );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_CPULIMIT_NOT_SUPPORTED", PRL_ERR_VMCONF_CPULIMIT_NOT_SUPPORTED );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_IOPRIO_NOT_SUPPORTED", PRL_ERR_VMCONF_IOPRIO_NOT_SUPPORTED );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_IOLIMIT_NOT_SUPPORTED", PRL_ERR_VMCONF_IOLIMIT_NOT_SUPPORTED );
	PyModule_AddIntConstant( module, "PRL_ERR_VZ_API_NOT_INITIALIZED", PRL_ERR_VZ_API_NOT_INITIALIZED );
	PyModule_AddIntConstant( module, "PRL_ERR_CT_NOT_FOUND", PRL_ERR_CT_NOT_FOUND );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_IOPSLIMIT_NOT_SUPPORTED", PRL_ERR_VMCONF_IOPSLIMIT_NOT_SUPPORTED );
	PyModule_AddIntConstant( module, "PRL_ERR_SAMPLE_CONFIG_NOT_FOUND", PRL_ERR_SAMPLE_CONFIG_NOT_FOUND );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_NEED_HEADLESS_MODE_FOR_AUTOSTART", PRL_ERR_VMCONF_NEED_HEADLESS_MODE_FOR_AUTOSTART );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_NEED_HEADLESS_MODE_FOR_AUTOSTOP", PRL_ERR_VMCONF_NEED_HEADLESS_MODE_FOR_AUTOSTOP );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_NEED_HEADLESS_MODE_FOR_KEEP_VM_ALIVE_ON_GUI_EXIT", PRL_ERR_VMCONF_NEED_HEADLESS_MODE_FOR_KEEP_VM_ALIVE_ON_GUI_EXIT );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_VM_NAME_IS_TOO_LONG", PRL_ERR_VMCONF_VM_NAME_IS_TOO_LONG );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_NEED_MORE_MEMORY_TO_ENABLE_HOTPLUG", PRL_ERR_VMCONF_NEED_MORE_MEMORY_TO_ENABLE_HOTPLUG );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_EFI_UNSUPPORTED_GUEST", PRL_ERR_VMCONF_EFI_UNSUPPORTED_GUEST );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_BOOT_OPTION_INVALID_DEVICE_TYPE", PRL_ERR_VMCONF_BOOT_OPTION_INVALID_DEVICE_TYPE );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_BOOT_OPTION_DUPLICATE_DEVICE", PRL_ERR_VMCONF_BOOT_OPTION_DUPLICATE_DEVICE );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_BOOT_OPTION_DEVICE_NOT_EXISTS", PRL_ERR_VMCONF_BOOT_OPTION_DEVICE_NOT_EXISTS );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_AUTOSTART_FROM_CURRENT_USER_FORBIDDEN", PRL_ERR_VMCONF_AUTOSTART_FROM_CURRENT_USER_FORBIDDEN );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_REMOTE_DISPLAY_PORT_NUMBER_IS_ZERO", PRL_ERR_VMCONF_REMOTE_DISPLAY_PORT_NUMBER_IS_ZERO );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_REMOTE_DISPLAY_HOST_IP_ADDRESS_IS_ZERO", PRL_ERR_VMCONF_REMOTE_DISPLAY_HOST_IP_ADDRESS_IS_ZERO );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_REMOTE_DISPLAY_INVALID_HOST_IP_ADDRESS", PRL_ERR_VMCONF_REMOTE_DISPLAY_INVALID_HOST_IP_ADDRESS );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_REMOTE_DISPLAY_EMPTY_PASSWORD", PRL_ERR_VMCONF_REMOTE_DISPLAY_EMPTY_PASSWORD );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_REMOTE_DISPLAY_PASSWORD_TOO_LONG", PRL_ERR_VMCONF_REMOTE_DISPLAY_PASSWORD_TOO_LONG );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_SHARED_FOLDERS_EMPTY_FOLDER_NAME", PRL_ERR_VMCONF_SHARED_FOLDERS_EMPTY_FOLDER_NAME );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_SHARED_FOLDERS_DUPLICATE_FOLDER_NAME", PRL_ERR_VMCONF_SHARED_FOLDERS_DUPLICATE_FOLDER_NAME );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_SHARED_FOLDERS_INVALID_FOLDER_PATH", PRL_ERR_VMCONF_SHARED_FOLDERS_INVALID_FOLDER_PATH );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_SHARED_FOLDERS_DUPLICATE_FOLDER_PATH", PRL_ERR_VMCONF_SHARED_FOLDERS_DUPLICATE_FOLDER_PATH );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_CPU_ZERO_COUNT", PRL_ERR_VMCONF_CPU_ZERO_COUNT );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_CPU_COUNT_MORE_MAX_CPU_COUNT", PRL_ERR_VMCONF_CPU_COUNT_MORE_MAX_CPU_COUNT );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_CPU_COUNT_MORE_HOST_CPU_COUNT", PRL_ERR_VMCONF_CPU_COUNT_MORE_HOST_CPU_COUNT );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_CPU_MASK_INVALID", PRL_ERR_VMCONF_CPU_MASK_INVALID );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_CPU_MASK_INVALID_CPU_NUM", PRL_ERR_VMCONF_CPU_MASK_INVALID_CPU_NUM );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_CPU_NODE_MASK_INVALID", PRL_ERR_VMCONF_CPU_NODE_MASK_INVALID );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_MAIN_MEMORY_ZERO_SIZE", PRL_ERR_VMCONF_MAIN_MEMORY_ZERO_SIZE );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_MAIN_MEMORY_OUT_OF_RANGE", PRL_ERR_VMCONF_MAIN_MEMORY_OUT_OF_RANGE );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_MAIN_MEMORY_NOT_4_RATIO_SIZE", PRL_ERR_VMCONF_MAIN_MEMORY_NOT_4_RATIO_SIZE );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_MAIN_MEMORY_SIZE_NOT_EAQUAL_RECOMMENDED", PRL_ERR_VMCONF_MAIN_MEMORY_SIZE_NOT_EAQUAL_RECOMMENDED );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_MAIN_MEMORY_MAX_BALLOON_SIZE_MORE_100_PERCENT", PRL_ERR_VMCONF_MAIN_MEMORY_MAX_BALLOON_SIZE_MORE_100_PERCENT );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_MAIN_MEMORY_MQ_PRIOR_ZERO", PRL_ERR_VMCONF_MAIN_MEMORY_MQ_PRIOR_ZERO );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_MAIN_MEMORY_MQ_PRIOR_OUT_OF_RANGE", PRL_ERR_VMCONF_MAIN_MEMORY_MQ_PRIOR_OUT_OF_RANGE );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_MAIN_MEMORY_MQ_INVALID_RANGE", PRL_ERR_VMCONF_MAIN_MEMORY_MQ_INVALID_RANGE );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_MAIN_MEMORY_MQ_MIN_LESS_VMM_OVERHEAD_VALUE", PRL_ERR_VMCONF_MAIN_MEMORY_MQ_MIN_LESS_VMM_OVERHEAD_VALUE );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_MAIN_MEMORY_MQ_MIN_OUT_OF_RANGE", PRL_ERR_VMCONF_MAIN_MEMORY_MQ_MIN_OUT_OF_RANGE );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_VIDEO_MEMORY_OUT_OF_RANGE", PRL_ERR_VMCONF_VIDEO_MEMORY_OUT_OF_RANGE );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_FLOPPY_DISK_SYS_NAME_IS_EMPTY", PRL_ERR_VMCONF_FLOPPY_DISK_SYS_NAME_IS_EMPTY );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_FLOPPY_DISK_IMAGE_IS_NOT_EXIST", PRL_ERR_VMCONF_FLOPPY_DISK_IMAGE_IS_NOT_EXIST );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_FLOPPY_DISK_IS_NOT_ACCESSIBLE", PRL_ERR_VMCONF_FLOPPY_DISK_IS_NOT_ACCESSIBLE );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_FLOPPY_DISK_IMAGE_IS_NOT_VALID", PRL_ERR_VMCONF_FLOPPY_DISK_IMAGE_IS_NOT_VALID );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_FLOPPY_DISK_SYS_NAME_HAS_INVALID_SYMBOL", PRL_ERR_VMCONF_FLOPPY_DISK_SYS_NAME_HAS_INVALID_SYMBOL );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_FLOPPY_DISK_URL_FORMAT_SYS_NAME", PRL_ERR_VMCONF_FLOPPY_DISK_URL_FORMAT_SYS_NAME );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_CD_DVD_ROM_SYS_NAME_IS_EMPTY", PRL_ERR_VMCONF_CD_DVD_ROM_SYS_NAME_IS_EMPTY );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_CD_DVD_ROM_DUPLICATE_SYS_NAME", PRL_ERR_VMCONF_CD_DVD_ROM_DUPLICATE_SYS_NAME );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_CD_DVD_ROM_IMAGE_IS_NOT_EXIST", PRL_ERR_VMCONF_CD_DVD_ROM_IMAGE_IS_NOT_EXIST );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_CD_DVD_ROM_URL_FORMAT_SYS_NAME", PRL_ERR_VMCONF_CD_DVD_ROM_URL_FORMAT_SYS_NAME );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_CD_DVD_ROM_SET_SATA_FOR_UNSUPPORTED_OS", PRL_ERR_VMCONF_CD_DVD_ROM_SET_SATA_FOR_UNSUPPORTED_OS );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_CD_DVD_ROM_SET_SATA_FOR_OLD_CHIPSET", PRL_ERR_VMCONF_CD_DVD_ROM_SET_SATA_FOR_OLD_CHIPSET );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_HARD_DISK_SYS_NAME_IS_EMPTY", PRL_ERR_VMCONF_HARD_DISK_SYS_NAME_IS_EMPTY );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_HARD_DISK_IMAGE_IS_NOT_EXIST", PRL_ERR_VMCONF_HARD_DISK_IMAGE_IS_NOT_EXIST );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_HARD_DISK_IMAGE_IS_NOT_VALID", PRL_ERR_VMCONF_HARD_DISK_IMAGE_IS_NOT_VALID );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_HARD_DISK_DUPLICATE_SYS_NAME", PRL_ERR_VMCONF_HARD_DISK_DUPLICATE_SYS_NAME );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_HARD_DISK_SYS_NAME_HAS_INVALID_SYMBOL", PRL_ERR_VMCONF_HARD_DISK_SYS_NAME_HAS_INVALID_SYMBOL );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_HARD_DISK_URL_FORMAT_SYS_NAME", PRL_ERR_VMCONF_HARD_DISK_URL_FORMAT_SYS_NAME );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_HARD_DISK_WRONG_TYPE_BOOTCAMP_PARTITION", PRL_ERR_VMCONF_HARD_DISK_WRONG_TYPE_BOOTCAMP_PARTITION );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_HARD_DISK_MISS_BOOTCAMP_PARTITION", PRL_ERR_VMCONF_HARD_DISK_MISS_BOOTCAMP_PARTITION );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_HARD_DISK_WRONG_TYPE_FOR_ENCRYPTRED_VM", PRL_ERR_VMCONF_HARD_DISK_WRONG_TYPE_FOR_ENCRYPTRED_VM );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_HARD_DISK_NOT_ENOUGH_SPACE_FOR_ENCRYPT_DISK", PRL_ERR_VMCONF_HARD_DISK_NOT_ENOUGH_SPACE_FOR_ENCRYPT_DISK );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_HARD_DISK_SET_SATA_FOR_UNSUPPORTED_OS", PRL_ERR_VMCONF_HARD_DISK_SET_SATA_FOR_UNSUPPORTED_OS );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_HARD_DISK_SET_SATA_FOR_OLD_CHIPSET", PRL_ERR_VMCONF_HARD_DISK_SET_SATA_FOR_OLD_CHIPSET );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_HARD_DISK_UNABLE_DELETE_DISK_WITH_SNAPSHOTS", PRL_ERR_VMCONF_HARD_DISK_UNABLE_DELETE_DISK_WITH_SNAPSHOTS );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_NETWORK_ADAPTER_INVALID_BOUND_INDEX", PRL_ERR_VMCONF_NETWORK_ADAPTER_INVALID_BOUND_INDEX );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_NETWORK_ADAPTER_INVALID_MAC_ADDRESS", PRL_ERR_VMCONF_NETWORK_ADAPTER_INVALID_MAC_ADDRESS );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_NETWORK_ADAPTER_DUPLICATE_MAC_ADDRESS", PRL_ERR_VMCONF_NETWORK_ADAPTER_DUPLICATE_MAC_ADDRESS );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_NETWORK_ADAPTER_DUPLICATE_IP_ADDRESS", PRL_ERR_VMCONF_NETWORK_ADAPTER_DUPLICATE_IP_ADDRESS );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_NETWORK_ADAPTER_ETHLIST_CREATE_ERROR", PRL_ERR_VMCONF_NETWORK_ADAPTER_ETHLIST_CREATE_ERROR );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_NETWORK_ADAPTER_INVALID_IP_ADDRESS", PRL_ERR_VMCONF_NETWORK_ADAPTER_INVALID_IP_ADDRESS );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_NETWORK_ADAPTER_GUEST_TOOLS_NOT_AVAILABLE", PRL_ERR_VMCONF_NETWORK_ADAPTER_GUEST_TOOLS_NOT_AVAILABLE );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_DUPLICATE_IP_ADDRESS", PRL_ERR_VMCONF_DUPLICATE_IP_ADDRESS );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_NETWORK_ADAPTER_MULTICAST_IP_ADDRESS", PRL_ERR_VMCONF_NETWORK_ADAPTER_MULTICAST_IP_ADDRESS );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_NETWORK_ADAPTER_BROADCAST_IP_ADDRESS", PRL_ERR_VMCONF_NETWORK_ADAPTER_BROADCAST_IP_ADDRESS );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_NETWORK_ADAPTER_INVALID_GATEWAY_IP_ADDRESS", PRL_ERR_VMCONF_NETWORK_ADAPTER_INVALID_GATEWAY_IP_ADDRESS );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_NETWORK_ADAPTER_GATEWAY_NOT_IN_SUBNET", PRL_ERR_VMCONF_NETWORK_ADAPTER_GATEWAY_NOT_IN_SUBNET );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_NETWORK_ADAPTER_INVALID_DNS_IP_ADDRESS", PRL_ERR_VMCONF_NETWORK_ADAPTER_INVALID_DNS_IP_ADDRESS );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_NETWORK_ADAPTER_INVALID_SEARCH_DOMAIN_NAME", PRL_ERR_VMCONF_NETWORK_ADAPTER_INVALID_SEARCH_DOMAIN_NAME );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_NETWORK_ADAPTER_ROUTED_NO_STATIC_ADDRESS", PRL_ERR_VMCONF_NETWORK_ADAPTER_ROUTED_NO_STATIC_ADDRESS );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_SOUND_MIXER_IS_EMPTY", PRL_ERR_VMCONF_SOUND_MIXER_IS_EMPTY );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_SOUND_OUTPUT_IS_EMPTY", PRL_ERR_VMCONF_SOUND_OUTPUT_IS_EMPTY );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_SERIAL_PORT_SYS_NAME_IS_EMPTY", PRL_ERR_VMCONF_SERIAL_PORT_SYS_NAME_IS_EMPTY );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_SERIAL_PORT_IMAGE_IS_NOT_EXIST", PRL_ERR_VMCONF_SERIAL_PORT_IMAGE_IS_NOT_EXIST );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_SERIAL_PORT_SYS_NAME_HAS_INVALID_SYMBOL", PRL_ERR_VMCONF_SERIAL_PORT_SYS_NAME_HAS_INVALID_SYMBOL );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_SERIAL_PORT_URL_FORMAT_SYS_NAME", PRL_ERR_VMCONF_SERIAL_PORT_URL_FORMAT_SYS_NAME );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_PARALLEL_PORT_SYS_NAME_IS_EMPTY", PRL_ERR_VMCONF_PARALLEL_PORT_SYS_NAME_IS_EMPTY );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_PARALLEL_PORT_IMAGE_IS_NOT_EXIST", PRL_ERR_VMCONF_PARALLEL_PORT_IMAGE_IS_NOT_EXIST );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_PARALLEL_PORT_SYS_NAME_HAS_INVALID_SYMBOL", PRL_ERR_VMCONF_PARALLEL_PORT_SYS_NAME_HAS_INVALID_SYMBOL );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_PARALLEL_PORT_URL_FORMAT_SYS_NAME", PRL_ERR_VMCONF_PARALLEL_PORT_URL_FORMAT_SYS_NAME );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_IDE_DEVICES_COUNT_OUT_OF_RANGE", PRL_ERR_VMCONF_IDE_DEVICES_COUNT_OUT_OF_RANGE );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_IDE_DEVICES_DUPLICATE_STACK_INDEX", PRL_ERR_VMCONF_IDE_DEVICES_DUPLICATE_STACK_INDEX );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_SATA_DEVICES_COUNT_OUT_OF_RANGE", PRL_ERR_VMCONF_SATA_DEVICES_COUNT_OUT_OF_RANGE );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_SATA_DEVICES_DUPLICATE_STACK_INDEX", PRL_ERR_VMCONF_SATA_DEVICES_DUPLICATE_STACK_INDEX );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_VIRTIO_BLOCK_DEVICES_DUPLICATE_STACK_INDEX", PRL_ERR_VMCONF_VIRTIO_BLOCK_DEVICES_DUPLICATE_STACK_INDEX );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_SCSI_DEVICES_COUNT_OUT_OF_RANGE", PRL_ERR_VMCONF_SCSI_DEVICES_COUNT_OUT_OF_RANGE );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_SCSI_DEVICES_DUPLICATE_STACK_INDEX", PRL_ERR_VMCONF_SCSI_DEVICES_DUPLICATE_STACK_INDEX );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_SCSI_BUSLOGIC_WITH_EFI_NOT_SUPPORTED", PRL_ERR_VMCONF_SCSI_BUSLOGIC_WITH_EFI_NOT_SUPPORTED );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_GENERIC_PCI_DEVICE_CANNOT_BE_ADDED", PRL_ERR_VMCONF_GENERIC_PCI_DEVICE_CANNOT_BE_ADDED );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_GENERIC_PCI_DEVICE_NOT_FOUND", PRL_ERR_VMCONF_GENERIC_PCI_DEVICE_NOT_FOUND );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_GENERIC_PCI_DEVICE_NOT_CONNECTED", PRL_ERR_VMCONF_GENERIC_PCI_DEVICE_NOT_CONNECTED );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_GENERIC_PCI_VIDEO_DEVICE_IS_ONE", PRL_ERR_VMCONF_GENERIC_PCI_VIDEO_DEVICE_IS_ONE );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_GENERIC_PCI_DEVICE_DUPLICATE_IN_ANOTHER_VM", PRL_ERR_VMCONF_GENERIC_PCI_DEVICE_DUPLICATE_IN_ANOTHER_VM );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_GENERIC_PCI_WRONG_DEVICE", PRL_ERR_VMCONF_GENERIC_PCI_WRONG_DEVICE );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_GENERIC_PCI_DUPLICATE_SYS_NAME", PRL_ERR_VMCONF_GENERIC_PCI_DUPLICATE_SYS_NAME );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_GENERIC_PCI_VIDEO_NOT_SINGLE", PRL_ERR_VMCONF_GENERIC_PCI_VIDEO_NOT_SINGLE );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_GENERIC_PCI_VIDEO_WRONG_COUNT", PRL_ERR_VMCONF_GENERIC_PCI_VIDEO_WRONG_COUNT );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_NO_IP_ADDRESSES_SPECIFIED_FOR_OFFLINE_MANAGEMENT", PRL_ERR_VMCONF_NO_IP_ADDRESSES_SPECIFIED_FOR_OFFLINE_MANAGEMENT );
	PyModule_AddIntConstant( module, "PRL_WARN_NO_SHARED_NETWORK_FOR_OFFLINE_MANAGEMENT", PRL_WARN_NO_SHARED_NETWORK_FOR_OFFLINE_MANAGEMENT );
	PyModule_AddIntConstant( module, "PRL_ERR_VMCONF_NO_CONFIGURED_TOTALRATE_FOR_NETWORK_CLASS", PRL_ERR_VMCONF_NO_CONFIGURED_TOTALRATE_FOR_NETWORK_CLASS );
	PyModule_AddIntConstant( module, "PRL_ERR_TIS_INVALID_UID", PRL_ERR_TIS_INVALID_UID );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_COMPACT_PROCESSING", PRL_ERR_VM_COMPACT_PROCESSING );
	PyModule_AddIntConstant( module, "PRL_WARN_COMPACT_THROUGH_COPY", PRL_WARN_COMPACT_THROUGH_COPY );
	PyModule_AddIntConstant( module, "PRL_WARN_COMPACT_DESTRUCTIVE", PRL_WARN_COMPACT_DESTRUCTIVE );
	PyModule_AddIntConstant( module, "PRL_ERR_IPFO_SOCKET_CREATE_FAILED", PRL_ERR_IPFO_SOCKET_CREATE_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_IPFO_SOCKET_BIND_FAILED", PRL_ERR_IPFO_SOCKET_BIND_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_IPFO_SOCKET_LISTEN_FAILED", PRL_ERR_IPFO_SOCKET_LISTEN_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_IPFO_SOCKET_ACCEPT_FAILED", PRL_ERR_IPFO_SOCKET_ACCEPT_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_IPFO_SOCKET_CONNECT_FAILED", PRL_ERR_IPFO_SOCKET_CONNECT_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_IPFO_SOCKET_NOT_OPENED", PRL_ERR_IPFO_SOCKET_NOT_OPENED );
	PyModule_AddIntConstant( module, "PRL_ERR_IPFO_INVALID_MODE", PRL_ERR_IPFO_INVALID_MODE );
	PyModule_AddIntConstant( module, "PRL_ERR_IPFO_SEND_FAILED", PRL_ERR_IPFO_SEND_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_IPFO_RECEIVE_FAILED", PRL_ERR_IPFO_RECEIVE_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_IPC_CREATE_MAP_FAILED", PRL_ERR_IPC_CREATE_MAP_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_IPC_ATTACH_FAILED", PRL_ERR_IPC_ATTACH_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_IPC_FTOK_FAILED", PRL_ERR_IPC_FTOK_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_DISP2DISP_SESSION_ALREADY_AUTHORIZED", PRL_ERR_DISP2DISP_SESSION_ALREADY_AUTHORIZED );
	PyModule_AddIntConstant( module, "PRL_ERR_DISP2DISP_WRONG_USER_SESSION_UUID", PRL_ERR_DISP2DISP_WRONG_USER_SESSION_UUID );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_MIGRATE_CHECKING_PRECONDITIONS_FAILED", PRL_ERR_VM_MIGRATE_CHECKING_PRECONDITIONS_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_MIGRATE_NOT_ENOUGH_DISK_SPACE_ON_SOURCE", PRL_ERR_VM_MIGRATE_NOT_ENOUGH_DISK_SPACE_ON_SOURCE );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_MIGRATE_OUT_OF_MEMORY_ON_TARGET", PRL_ERR_VM_MIGRATE_OUT_OF_MEMORY_ON_TARGET );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_MIGRATE_TARGET_VM_HOME_PATH_NOT_EXISTS", PRL_ERR_VM_MIGRATE_TARGET_VM_HOME_PATH_NOT_EXISTS );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_MIGRATE_NOT_ENOUGH_CPUS_ON_TARGET", PRL_ERR_VM_MIGRATE_NOT_ENOUGH_CPUS_ON_TARGET );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_MIGRATE_NON_COMPATIBLE_CPU_ON_TARGET", PRL_ERR_VM_MIGRATE_NON_COMPATIBLE_CPU_ON_TARGET );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_MIGRATE_NETWORK_SHARE_IS_ABSENT_ON_TARGET", PRL_ERR_VM_MIGRATE_NETWORK_SHARE_IS_ABSENT_ON_TARGET );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_MIGRATE_FLOPPY_DISK_IS_ABSENT_ON_TARGET", PRL_ERR_VM_MIGRATE_FLOPPY_DISK_IS_ABSENT_ON_TARGET );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_MIGRATE_OPTICAL_DISK_IS_ABSENT_ON_TARGET", PRL_ERR_VM_MIGRATE_OPTICAL_DISK_IS_ABSENT_ON_TARGET );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_MIGRATE_SERIAL_PORT_IS_ABSENT_ON_TARGET", PRL_ERR_VM_MIGRATE_SERIAL_PORT_IS_ABSENT_ON_TARGET );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_MIGRATE_PARALLEL_PORT_IS_ABSENT_ON_TARGET", PRL_ERR_VM_MIGRATE_PARALLEL_PORT_IS_ABSENT_ON_TARGET );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_MIGRATE_NETWORK_ADAPTER_IS_ABSENT_ON_TARGET", PRL_ERR_VM_MIGRATE_NETWORK_ADAPTER_IS_ABSENT_ON_TARGET );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_MIGRATE_USB_CONTROLLER_IS_ABSENT_ON_TARGET", PRL_ERR_VM_MIGRATE_USB_CONTROLLER_IS_ABSENT_ON_TARGET );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_MIGRATE_SOUND_DEVICE_IS_ABSENT_ON_TARGET", PRL_ERR_VM_MIGRATE_SOUND_DEVICE_IS_ABSENT_ON_TARGET );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_MIGRATE_VM_ALREADY_EXISTS_ON_TARGET", PRL_ERR_VM_MIGRATE_VM_ALREADY_EXISTS_ON_TARGET );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_MIGRATE_NOT_ENOUGH_DISK_SPACE_ON_TARGET", PRL_ERR_VM_MIGRATE_NOT_ENOUGH_DISK_SPACE_ON_TARGET );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_MIGRATE_COULDNT_DETACH_TARGET_CONNECTION", PRL_ERR_VM_MIGRATE_COULDNT_DETACH_TARGET_CONNECTION );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_MIGRATE_UNSUITABLE_VM_STATE", PRL_ERR_VM_MIGRATE_UNSUITABLE_VM_STATE );
	PyModule_AddIntConstant( module, "PRL_ERR_FILECOPY_PROTOCOL", PRL_ERR_FILECOPY_PROTOCOL );
	PyModule_AddIntConstant( module, "PRL_ERR_FILECOPY_DIR_EXIST", PRL_ERR_FILECOPY_DIR_EXIST );
	PyModule_AddIntConstant( module, "PRL_ERR_FILECOPY_FILE_EXIST", PRL_ERR_FILECOPY_FILE_EXIST );
	PyModule_AddIntConstant( module, "PRL_ERR_FILECOPY_CANT_CREATE_DIR", PRL_ERR_FILECOPY_CANT_CREATE_DIR );
	PyModule_AddIntConstant( module, "PRL_ERR_FILECOPY_CANT_OPEN_FILE", PRL_ERR_FILECOPY_CANT_OPEN_FILE );
	PyModule_AddIntConstant( module, "PRL_ERR_FILECOPY_CANT_WRITE", PRL_ERR_FILECOPY_CANT_WRITE );
	PyModule_AddIntConstant( module, "PRL_ERR_FILECOPY_INTERNAL", PRL_ERR_FILECOPY_INTERNAL );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_MIGRATE_VM_UUID_ALREADY_EXISTS_ON_TARGET", PRL_ERR_VM_MIGRATE_VM_UUID_ALREADY_EXISTS_ON_TARGET );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_MIGRATE_VM_HOME_ALREADY_EXISTS_ON_TARGET", PRL_ERR_VM_MIGRATE_VM_HOME_ALREADY_EXISTS_ON_TARGET );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_MIGRATE_REMOTE_DEVICE_IS_ATTACHED", PRL_ERR_VM_MIGRATE_REMOTE_DEVICE_IS_ATTACHED );
	PyModule_AddIntConstant( module, "PRL_INFO_VM_MIGRATE_STORAGE_IS_SHARED", PRL_INFO_VM_MIGRATE_STORAGE_IS_SHARED );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_MIGRATE_RESUME_FAILED", PRL_ERR_VM_MIGRATE_RESUME_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_MIGRATE_STORAGE_INFO_PARSE", PRL_ERR_VM_MIGRATE_STORAGE_INFO_PARSE );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_MIGRATE_REGISTER_VM_FAILED", PRL_ERR_VM_MIGRATE_REGISTER_VM_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_MIGRATE_SUSPEND_VM_FAILED", PRL_ERR_VM_MIGRATE_SUSPEND_VM_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_MIGRATE_RESUME_VM_FAILED", PRL_ERR_VM_MIGRATE_RESUME_VM_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_MIGRATE_VM_ALREADY_MIGRATE_ON_TARGET", PRL_ERR_VM_MIGRATE_VM_ALREADY_MIGRATE_ON_TARGET );
	PyModule_AddIntConstant( module, "PRL_ERR_CT_MIGRATE_INTERNAL_ERROR", PRL_ERR_CT_MIGRATE_INTERNAL_ERROR );
	PyModule_AddIntConstant( module, "PRL_ERR_COPY_CT_TMPL_INTERNAL_ERROR", PRL_ERR_COPY_CT_TMPL_INTERNAL_ERROR );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_MIGRATE_CANNOT_REMOTE_CLONE_SHARED_VM", PRL_ERR_VM_MIGRATE_CANNOT_REMOTE_CLONE_SHARED_VM );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_MIGRATE_CONTINUE_START_FAILED", PRL_ERR_VM_MIGRATE_CONTINUE_START_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_MIGRATE_BREAK_BY_DISK_CONDITION", PRL_ERR_VM_MIGRATE_BREAK_BY_DISK_CONDITION );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_MIGRATE_WARM_MODE_NOT_SUPPORTED", PRL_ERR_VM_MIGRATE_WARM_MODE_NOT_SUPPORTED );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_MIGRATE_DEVICE_IMAGE_OUT_OF_BUNDLE", PRL_ERR_VM_MIGRATE_DEVICE_IMAGE_OUT_OF_BUNDLE );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_MIGRATE_INVALID_DISK_TYPE", PRL_ERR_VM_MIGRATE_INVALID_DISK_TYPE );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_MIGRATE_NON_COMPATIBLE_CPU_ON_TARGET_SHORT", PRL_ERR_VM_MIGRATE_NON_COMPATIBLE_CPU_ON_TARGET_SHORT );
	PyModule_AddIntConstant( module, "PRL_ERR_CT_MIGRATE_ID_ALREADY_EXIST", PRL_ERR_CT_MIGRATE_ID_ALREADY_EXIST );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_MIGRATE_TO_THE_SAME_NODE", PRL_ERR_VM_MIGRATE_TO_THE_SAME_NODE );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_MIGRATE_ACCESS_TO_VM_DENIED", PRL_ERR_VM_MIGRATE_ACCESS_TO_VM_DENIED );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_MIGRATE_ERROR_DELETE_VM", PRL_ERR_VM_MIGRATE_ERROR_DELETE_VM );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_MIGRATE_ERROR_UNREGISTER_VM", PRL_ERR_VM_MIGRATE_ERROR_UNREGISTER_VM );
	PyModule_AddIntConstant( module, "PRL_ERR_CT_MIGRATE_TARGET_ALREADY_EXISTS", PRL_ERR_CT_MIGRATE_TARGET_ALREADY_EXISTS );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_MIGRATE_EXTERNAL_DISKS_NOT_SUPPORTED", PRL_ERR_VM_MIGRATE_EXTERNAL_DISKS_NOT_SUPPORTED );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_MIGRATE_EXT_DISK_DIR_ALREADY_EXISTS_ON_TARGET", PRL_ERR_VM_MIGRATE_EXT_DISK_DIR_ALREADY_EXISTS_ON_TARGET );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_MIGRATE_CANNOT_CREATE_DIRECTORY", PRL_ERR_VM_MIGRATE_CANNOT_CREATE_DIRECTORY );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_MIGRATE_TARGET_INSIDE_SHARED_VM_PRIVATE", PRL_ERR_VM_MIGRATE_TARGET_INSIDE_SHARED_VM_PRIVATE );
	PyModule_AddIntConstant( module, "PRL_ERR_CT_MIGRATE_EXTERNAL_PROCESS", PRL_ERR_CT_MIGRATE_EXTERNAL_PROCESS );
	PyModule_AddIntConstant( module, "PRL_ERR_IPHONE_PROXY_CANNOT_START", PRL_ERR_IPHONE_PROXY_CANNOT_START );
	PyModule_AddIntConstant( module, "PRL_ERR_IPHONE_PROXY_CANNOT_STOP", PRL_ERR_IPHONE_PROXY_CANNOT_STOP );
	PyModule_AddIntConstant( module, "PRL_ERR_IPHONE_PROXY_ALREADY_STARTED", PRL_ERR_IPHONE_PROXY_ALREADY_STARTED );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_TOOLS_CANT_PARSE_UPDATE_PARAMETERS", PRL_ERR_VM_TOOLS_CANT_PARSE_UPDATE_PARAMETERS );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_TOOLS_CANT_UPDATE_WITHOUT_RESTART", PRL_ERR_VM_TOOLS_CANT_UPDATE_WITHOUT_RESTART );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_TOOL_NOT_AVAILABLE", PRL_ERR_VM_TOOL_NOT_AVAILABLE );
	PyModule_AddIntConstant( module, "PRL_ERR_ONLY_ADMIN_OR_VM_OWNER_CAN_OPEN_THIS_SESSION", PRL_ERR_ONLY_ADMIN_OR_VM_OWNER_CAN_OPEN_THIS_SESSION );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_EXEC_GUEST_TOOL_NOT_AVAILABLE", PRL_ERR_VM_EXEC_GUEST_TOOL_NOT_AVAILABLE );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_GUEST_SESSION_EXPIRED", PRL_ERR_VM_GUEST_SESSION_EXPIRED );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_EXEC_PROGRAM_NOT_FOUND", PRL_ERR_VM_EXEC_PROGRAM_NOT_FOUND );
	PyModule_AddIntConstant( module, "PRL_ERR_GUEST_PROGRAM_EXECUTION_FAILED", PRL_ERR_GUEST_PROGRAM_EXECUTION_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_SET_NETWORK_SETTINGS_FAILED", PRL_ERR_SET_NETWORK_SETTINGS_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_VNC_SERVER_ALREADY_STARTED", PRL_ERR_VNC_SERVER_ALREADY_STARTED );
	PyModule_AddIntConstant( module, "PRL_ERR_VNC_SERVER_DISABLED", PRL_ERR_VNC_SERVER_DISABLED );
	PyModule_AddIntConstant( module, "PRL_ERR_VNC_SERVER_AUTOSET_PORT_FAILED", PRL_ERR_VNC_SERVER_AUTOSET_PORT_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_FAILED_TO_START_VNC_SERVER", PRL_ERR_FAILED_TO_START_VNC_SERVER );
	PyModule_AddIntConstant( module, "PRL_ERR_FAILED_TO_STOP_VNC_SERVER", PRL_ERR_FAILED_TO_STOP_VNC_SERVER );
	PyModule_AddIntConstant( module, "PRL_ERR_VNC_SERVER_NOT_STARTED", PRL_ERR_VNC_SERVER_NOT_STARTED );
	PyModule_AddIntConstant( module, "PRL_WARN_FAILED_TO_START_VNC_SERVER", PRL_WARN_FAILED_TO_START_VNC_SERVER );
	PyModule_AddIntConstant( module, "PRL_ERR_SUSPEND_VM_VTD_PAUSED", PRL_ERR_SUSPEND_VM_VTD_PAUSED );
	PyModule_AddIntConstant( module, "PRL_ERR_SUSPEND_VM_VTD_WITH_UNSUPPORTED_SHUTDOWN_TOOL", PRL_ERR_SUSPEND_VM_VTD_WITH_UNSUPPORTED_SHUTDOWN_TOOL );
	PyModule_AddIntConstant( module, "PRL_ERR_SUSPEND_VM_VTD_BY_GUEST_SLEEP_TIMEOUT", PRL_ERR_SUSPEND_VM_VTD_BY_GUEST_SLEEP_TIMEOUT );
	PyModule_AddIntConstant( module, "PRL_ERR_CREATE_SNAPSHOT_VM_VTD_PAUSED", PRL_ERR_CREATE_SNAPSHOT_VM_VTD_PAUSED );
	PyModule_AddIntConstant( module, "PRL_ERR_CREATE_SNAPSHOT_VM_VTD_WITH_UNSUPPORTED_SHUTDOWN_TOOL", PRL_ERR_CREATE_SNAPSHOT_VM_VTD_WITH_UNSUPPORTED_SHUTDOWN_TOOL );
	PyModule_AddIntConstant( module, "PRL_ERR_CREATE_SNAPSHOT_VM_VTD_BY_GUEST_SLEEP_TIMEOUT", PRL_ERR_CREATE_SNAPSHOT_VM_VTD_BY_GUEST_SLEEP_TIMEOUT );
	PyModule_AddIntConstant( module, "PRL_ERR_SUSPEND_VM_VTD_WITH_UNLOADED_SHUTDOWN_TOOL", PRL_ERR_SUSPEND_VM_VTD_WITH_UNLOADED_SHUTDOWN_TOOL );
	PyModule_AddIntConstant( module, "PRL_ERR_SUSPEND_VM_VTD_WITH_OUTDATED_SHUTDOWN_TOOL", PRL_ERR_SUSPEND_VM_VTD_WITH_OUTDATED_SHUTDOWN_TOOL );
	PyModule_AddIntConstant( module, "PRL_ERR_CREATE_SNAPSHOT_VM_VTD_WITH_UNLOADED_SHUTDOWN_TOOL", PRL_ERR_CREATE_SNAPSHOT_VM_VTD_WITH_UNLOADED_SHUTDOWN_TOOL );
	PyModule_AddIntConstant( module, "PRL_ERR_CREATE_SNAPSHOT_VM_VTD_WITH_OUTDATED_SHUTDOWN_TOOL", PRL_ERR_CREATE_SNAPSHOT_VM_VTD_WITH_OUTDATED_SHUTDOWN_TOOL );
	PyModule_AddIntConstant( module, "PRL_ERR_REVERT_SNAPSHOT_VM_VTD_PAUSED", PRL_ERR_REVERT_SNAPSHOT_VM_VTD_PAUSED );
	PyModule_AddIntConstant( module, "PRL_ERR_REVERT_SNAPSHOT_VM_VTD_BY_GUEST_SLEEP_TIMEOUT", PRL_ERR_REVERT_SNAPSHOT_VM_VTD_BY_GUEST_SLEEP_TIMEOUT );
	PyModule_AddIntConstant( module, "PRL_ERR_REVERT_SNAPSHOT_VM_VTD_WITH_UNSUPPORTED_SHUTDOWN_TOOL", PRL_ERR_REVERT_SNAPSHOT_VM_VTD_WITH_UNSUPPORTED_SHUTDOWN_TOOL );
	PyModule_AddIntConstant( module, "PRL_ERR_REVERT_SNAPSHOT_VM_VTD_WITH_UNLOADED_SHUTDOWN_TOOL", PRL_ERR_REVERT_SNAPSHOT_VM_VTD_WITH_UNLOADED_SHUTDOWN_TOOL );
	PyModule_AddIntConstant( module, "PRL_ERR_REVERT_SNAPSHOT_VM_VTD_WITH_OUTDATED_SHUTDOWN_TOOL", PRL_ERR_REVERT_SNAPSHOT_VM_VTD_WITH_OUTDATED_SHUTDOWN_TOOL );
	PyModule_AddIntConstant( module, "PRL_ERR_STAND_BY_VM_PAUSED", PRL_ERR_STAND_BY_VM_PAUSED );
	PyModule_AddIntConstant( module, "PRL_ERR_STAND_BY_VM_WITH_UNLOADED_SHUTDOWN_TOOL", PRL_ERR_STAND_BY_VM_WITH_UNLOADED_SHUTDOWN_TOOL );
	PyModule_AddIntConstant( module, "PRL_ERR_STAND_BY_VM_WITH_OUTDATED_SHUTDOWN_TOOL", PRL_ERR_STAND_BY_VM_WITH_OUTDATED_SHUTDOWN_TOOL );
	PyModule_AddIntConstant( module, "PRL_ERR_STAND_BY_VM_WITH_UNSUPPORTED_SHUTDOWN_TOOL", PRL_ERR_STAND_BY_VM_WITH_UNSUPPORTED_SHUTDOWN_TOOL );
	PyModule_AddIntConstant( module, "PRL_ERR_STAND_BY_VM_BY_GUEST_SLEEP_TIMEOUT", PRL_ERR_STAND_BY_VM_BY_GUEST_SLEEP_TIMEOUT );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_SHUTDOWN_FAILED", PRL_ERR_VM_SHUTDOWN_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_SHUTDOWN_MACHINE_LOCKED", PRL_ERR_VM_SHUTDOWN_MACHINE_LOCKED );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_SHUTDOWN_HIBERNATE_NOT_SUPPORTED", PRL_ERR_VM_SHUTDOWN_HIBERNATE_NOT_SUPPORTED );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_SHUTDOWN_SUSPEND_NOT_SUPPORTED", PRL_ERR_VM_SHUTDOWN_SUSPEND_NOT_SUPPORTED );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_SHUTDOWN_HIBERNATE_FAILED", PRL_ERR_VM_SHUTDOWN_HIBERNATE_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_SUSPEND_VM_VTD_WITH_UNSUPPORTED_CAPS", PRL_ERR_SUSPEND_VM_VTD_WITH_UNSUPPORTED_CAPS );
	PyModule_AddIntConstant( module, "PRL_ERR_CREATE_SNAPSHOT_VM_VTD_WITH_UNSUPPORTED_CAPS", PRL_ERR_CREATE_SNAPSHOT_VM_VTD_WITH_UNSUPPORTED_CAPS );
	PyModule_AddIntConstant( module, "PRL_ERR_REVERT_SNAPSHOT_VM_VTD_WITH_UNSUPPORTED_CAPS", PRL_ERR_REVERT_SNAPSHOT_VM_VTD_WITH_UNSUPPORTED_CAPS );
	PyModule_AddIntConstant( module, "PRL_ERR_HVT_NOT_PRESENT_WARNING", PRL_ERR_HVT_NOT_PRESENT_WARNING );
	PyModule_AddIntConstant( module, "PRL_ERR_SUSPEND_WITH_USB_BOOTDISK", PRL_ERR_SUSPEND_WITH_USB_BOOTDISK );
	PyModule_AddIntConstant( module, "PRL_ERR_BACKUP_INTERNAL_PROTO_ERROR", PRL_ERR_BACKUP_INTERNAL_PROTO_ERROR );
	PyModule_AddIntConstant( module, "PRL_ERR_BACKUP_INTERNAL_ERROR", PRL_ERR_BACKUP_INTERNAL_ERROR );
	PyModule_AddIntConstant( module, "PRL_ERR_BACKUP_TIMEOUT_EXCEEDED", PRL_ERR_BACKUP_TIMEOUT_EXCEEDED );
	PyModule_AddIntConstant( module, "PRL_ERR_BACKUP_ACCESS_TO_VM_DENIED", PRL_ERR_BACKUP_ACCESS_TO_VM_DENIED );
	PyModule_AddIntConstant( module, "PRL_ERR_BACKUP_BACKUP_UUID_NOT_FOUND", PRL_ERR_BACKUP_BACKUP_UUID_NOT_FOUND );
	PyModule_AddIntConstant( module, "PRL_ERR_BACKUP_CREATE_SNAPSHOT_FAILED", PRL_ERR_BACKUP_CREATE_SNAPSHOT_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_BACKUP_SWITCH_TO_SNAPSHOT_FAILED", PRL_ERR_BACKUP_SWITCH_TO_SNAPSHOT_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_BACKUP_REGISTER_VM_FAILED", PRL_ERR_BACKUP_REGISTER_VM_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_BACKUP_DIRECTORY_ALREADY_EXIST", PRL_ERR_BACKUP_DIRECTORY_ALREADY_EXIST );
	PyModule_AddIntConstant( module, "PRL_ERR_BACKUP_CANNOT_CREATE_DIRECTORY", PRL_ERR_BACKUP_CANNOT_CREATE_DIRECTORY );
	PyModule_AddIntConstant( module, "PRL_ERR_BACKUP_RESTORE_VM_RUNNING", PRL_ERR_BACKUP_RESTORE_VM_RUNNING );
	PyModule_AddIntConstant( module, "PRL_ERR_BACKUP_BACKUP_NOT_FOUND", PRL_ERR_BACKUP_BACKUP_NOT_FOUND );
	PyModule_AddIntConstant( module, "PRL_ERR_BACKUP_CANNOT_REMOVE_DIRECTORY", PRL_ERR_BACKUP_CANNOT_REMOVE_DIRECTORY );
	PyModule_AddIntConstant( module, "PRL_ERR_BACKUP_LOCKED_FOR_READING", PRL_ERR_BACKUP_LOCKED_FOR_READING );
	PyModule_AddIntConstant( module, "PRL_ERR_BACKUP_LOCKED_FOR_WRITING", PRL_ERR_BACKUP_LOCKED_FOR_WRITING );
	PyModule_AddIntConstant( module, "PRL_ERR_BACKUP_REQUIRE_LOGIN_PASSWORD", PRL_ERR_BACKUP_REQUIRE_LOGIN_PASSWORD );
	PyModule_AddIntConstant( module, "PRL_ERR_BACKUP_ACRONIS_ERR", PRL_ERR_BACKUP_ACRONIS_ERR );
	PyModule_AddIntConstant( module, "PRL_WARN_BACKUP_HAS_NOT_FULL_BACKUP", PRL_WARN_BACKUP_HAS_NOT_FULL_BACKUP );
	PyModule_AddIntConstant( module, "PRL_ERR_BACKUP_BACKUP_CMD_FAILED", PRL_ERR_BACKUP_BACKUP_CMD_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_BACKUP_RESTORE_CMD_FAILED", PRL_ERR_BACKUP_RESTORE_CMD_FAILED );
	PyModule_AddIntConstant( module, "PRL_WARN_BACKUP_GUEST_SYNCHRONIZATION_FAILED", PRL_WARN_BACKUP_GUEST_SYNCHRONIZATION_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_BACKUP_SNAPSHOT_OF_PAUSED_VM", PRL_ERR_BACKUP_SNAPSHOT_OF_PAUSED_VM );
	PyModule_AddIntConstant( module, "PRL_ERR_FAILED_TO_CONNECT_TO_BACKUP_SERVER", PRL_ERR_FAILED_TO_CONNECT_TO_BACKUP_SERVER );
	PyModule_AddIntConstant( module, "PRL_ERR_FAILED_TO_AUTH_ON_BACKUP_SERVER", PRL_ERR_FAILED_TO_AUTH_ON_BACKUP_SERVER );
	PyModule_AddIntConstant( module, "PRL_ERR_BACKUP_CANNOT_SET_PERMISSIONS", PRL_ERR_BACKUP_CANNOT_SET_PERMISSIONS );
	PyModule_AddIntConstant( module, "PRL_WARN_BACKUP_DEVICE_IMAGE_NOT_FOUND", PRL_WARN_BACKUP_DEVICE_IMAGE_NOT_FOUND );
	PyModule_AddIntConstant( module, "PRL_WARN_BACKUP_SP_GUEST_SYNCHRONIZATION_FAILED", PRL_WARN_BACKUP_SP_GUEST_SYNCHRONIZATION_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_BACKUP_RESTORE_NOT_ENOUGH_FREE_DISK_SPACE", PRL_ERR_BACKUP_RESTORE_NOT_ENOUGH_FREE_DISK_SPACE );
	PyModule_AddIntConstant( module, "PRL_ERR_BACKUP_CREATE_NOT_ENOUGH_FREE_DISK_SPACE", PRL_ERR_BACKUP_CREATE_NOT_ENOUGH_FREE_DISK_SPACE );
	PyModule_AddIntConstant( module, "PRL_WARN_BACKUP_GUEST_UNABLE_TO_SYNCHRONIZE", PRL_WARN_BACKUP_GUEST_UNABLE_TO_SYNCHRONIZE );
	PyModule_AddIntConstant( module, "PRL_ERR_USER_NO_AUTH_TO_SAVE_BACKUP_FILES", PRL_ERR_USER_NO_AUTH_TO_SAVE_BACKUP_FILES );
	PyModule_AddIntConstant( module, "PRL_ERR_PATH_IS_NOT_DIRECTORY", PRL_ERR_PATH_IS_NOT_DIRECTORY );
	PyModule_AddIntConstant( module, "PRL_ERR_BACKUP_TOOL_CANNOT_START", PRL_ERR_BACKUP_TOOL_CANNOT_START );
	PyModule_AddIntConstant( module, "PRL_ERR_BACKUP_CT_ID_ALREADY_EXIST", PRL_ERR_BACKUP_CT_ID_ALREADY_EXIST );
	PyModule_AddIntConstant( module, "PRL_ERR_BACKUP_REMOVE_PERMISSIONS_DENIED", PRL_ERR_BACKUP_REMOVE_PERMISSIONS_DENIED );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_BACKUP_HDD_IMAGE_OUT_OF_BUNDLE", PRL_ERR_VM_BACKUP_HDD_IMAGE_OUT_OF_BUNDLE );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_BACKUP_INVALID_DISK_TYPE", PRL_ERR_VM_BACKUP_INVALID_DISK_TYPE );
	PyModule_AddIntConstant( module, "PRL_WARN_BACKUP_NON_IMAGE_HDD", PRL_WARN_BACKUP_NON_IMAGE_HDD );
	PyModule_AddIntConstant( module, "PRL_ERR_BACKUP_RESTORE_INTERNAL_ERROR", PRL_ERR_BACKUP_RESTORE_INTERNAL_ERROR );
	PyModule_AddIntConstant( module, "PRL_ERR_BACKUP_RESTORE_INTERNAL_PROTO_ERROR", PRL_ERR_BACKUP_RESTORE_INTERNAL_PROTO_ERROR );
	PyModule_AddIntConstant( module, "PRL_ERR_BACKUP_RESTORE_DIRECTORY_ALREADY_EXIST", PRL_ERR_BACKUP_RESTORE_DIRECTORY_ALREADY_EXIST );
	PyModule_AddIntConstant( module, "PRL_ERR_BACKUP_RESTORE_CANNOT_CREATE_DIRECTORY", PRL_ERR_BACKUP_RESTORE_CANNOT_CREATE_DIRECTORY );
	PyModule_AddIntConstant( module, "PRL_ERR_BACKUP_RESTORE_PROHIBIT_WHEN_ATTACHED", PRL_ERR_BACKUP_RESTORE_PROHIBIT_WHEN_ATTACHED );
	PyModule_AddIntConstant( module, "PRL_ERR_BACKUP_RESTORE_EXISTING_SET_PRIVATE", PRL_ERR_BACKUP_RESTORE_EXISTING_SET_PRIVATE );
	PyModule_AddIntConstant( module, "PRL_ERR_BACKUP_UNSUPPORTED_KEEP_CHAIN", PRL_ERR_BACKUP_UNSUPPORTED_KEEP_CHAIN );
	PyModule_AddIntConstant( module, "PRL_ERR_HTTP_HOST_NOT_FOUND", PRL_ERR_HTTP_HOST_NOT_FOUND );
	PyModule_AddIntConstant( module, "PRL_ERR_HTTP_CONNECTION_REFUSED", PRL_ERR_HTTP_CONNECTION_REFUSED );
	PyModule_AddIntConstant( module, "PRL_ERR_HTTP_UNEXPECTED_CLOSE", PRL_ERR_HTTP_UNEXPECTED_CLOSE );
	PyModule_AddIntConstant( module, "PRL_ERR_HTTP_INVALID_RESPONSE_HEADER", PRL_ERR_HTTP_INVALID_RESPONSE_HEADER );
	PyModule_AddIntConstant( module, "PRL_ERR_HTTP_WRONG_CONTENT_LENGTH", PRL_ERR_HTTP_WRONG_CONTENT_LENGTH );
	PyModule_AddIntConstant( module, "PRL_ERR_HTTP_PROXY_AUTH_REQUIRED", PRL_ERR_HTTP_PROXY_AUTH_REQUIRED );
	PyModule_AddIntConstant( module, "PRL_ERR_HTTP_AUTH_REQUIRED", PRL_ERR_HTTP_AUTH_REQUIRED );
	PyModule_AddIntConstant( module, "PRL_ERR_HTTP_PROBLEM_REPORT_SEND_FAILURE", PRL_ERR_HTTP_PROBLEM_REPORT_SEND_FAILURE );
	PyModule_AddIntConstant( module, "PRL_ERR_XMLRPC_WRONG_METHOD_CALL", PRL_ERR_XMLRPC_WRONG_METHOD_CALL );
	PyModule_AddIntConstant( module, "PRL_ERR_XMLRPC_INVALID_CREDENTIALS", PRL_ERR_XMLRPC_INVALID_CREDENTIALS );
	PyModule_AddIntConstant( module, "PRL_ERR_XMLRPC_LIMITS_EXHAUSTED", PRL_ERR_XMLRPC_LIMITS_EXHAUSTED );
	PyModule_AddIntConstant( module, "PRL_ERR_XMLRPC_INVALID_REQUEST_INFO", PRL_ERR_XMLRPC_INVALID_REQUEST_INFO );
	PyModule_AddIntConstant( module, "PRL_ERR_XMLRPC_INTERNAL_ERROR", PRL_ERR_XMLRPC_INTERNAL_ERROR );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_LOCKED_FOR_CLONE", PRL_ERR_VM_LOCKED_FOR_CLONE );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_LOCKED_FOR_DELETE", PRL_ERR_VM_LOCKED_FOR_DELETE );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_LOCKED_FOR_UNREGISTER", PRL_ERR_VM_LOCKED_FOR_UNREGISTER );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_LOCKED_FOR_EDIT_COMMIT", PRL_ERR_VM_LOCKED_FOR_EDIT_COMMIT );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_LOCKED_FOR_EXECUTE", PRL_ERR_VM_LOCKED_FOR_EXECUTE );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_LOCKED_FOR_EXECUTE_EX", PRL_ERR_VM_LOCKED_FOR_EXECUTE_EX );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_LOCKED_FOR_INTERNAL_REASON", PRL_ERR_VM_LOCKED_FOR_INTERNAL_REASON );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_LOCKED_FOR_EDIT_COMMIT_WITH_RENAME", PRL_ERR_VM_LOCKED_FOR_EDIT_COMMIT_WITH_RENAME );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_LOCKED_FOR_UPDATE_SECURITY", PRL_ERR_VM_LOCKED_FOR_UPDATE_SECURITY );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_LOCKED_FOR_MIGRATE", PRL_ERR_VM_LOCKED_FOR_MIGRATE );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_LOCKED_FOR_CREATE_SNAPSHOT", PRL_ERR_VM_LOCKED_FOR_CREATE_SNAPSHOT );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_LOCKED_FOR_SWITCH_TO_SNAPSHOT", PRL_ERR_VM_LOCKED_FOR_SWITCH_TO_SNAPSHOT );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_LOCKED_FOR_DELETE_TO_SNAPSHOT", PRL_ERR_VM_LOCKED_FOR_DELETE_TO_SNAPSHOT );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_LOCKED_FOR_BACKUP", PRL_ERR_VM_LOCKED_FOR_BACKUP );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_LOCKED_FOR_RESTORE_FROM_BACKUP", PRL_ERR_VM_LOCKED_FOR_RESTORE_FROM_BACKUP );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_LOCKED_CTL_FOR_BACKUP", PRL_ERR_VM_LOCKED_CTL_FOR_BACKUP );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_LOCKED_FOR_DISK_RESIZE", PRL_ERR_VM_LOCKED_FOR_DISK_RESIZE );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_LOCKED_FOR_DISK_COMPACT", PRL_ERR_VM_LOCKED_FOR_DISK_COMPACT );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_LOCKED_FOR_DISK_CONVERT", PRL_ERR_VM_LOCKED_FOR_DISK_CONVERT );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_LOCKED_FOR_ENCRYPT", PRL_ERR_VM_LOCKED_FOR_ENCRYPT );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_LOCKED_FOR_DECRYPT", PRL_ERR_VM_LOCKED_FOR_DECRYPT );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_LOCKED_FOR_CHANGE_PASSWORD", PRL_ERR_VM_LOCKED_FOR_CHANGE_PASSWORD );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_LOCKED_FOR_CHANGE_FIREWALL", PRL_ERR_VM_LOCKED_FOR_CHANGE_FIREWALL );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_LOCKED_FOR_COPY_IMAGE", PRL_ERR_VM_LOCKED_FOR_COPY_IMAGE );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_LOCKED_FOR_MOVE", PRL_ERR_VM_LOCKED_FOR_MOVE );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_LOCKED_FOR_SET_PROTECTION", PRL_ERR_VM_LOCKED_FOR_SET_PROTECTION );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_LOCKED_FOR_REMOVE_PROTECTION", PRL_ERR_VM_LOCKED_FOR_REMOVE_PROTECTION );
	PyModule_AddIntConstant( module, "PRL_ERR_NOT_SENTILLION_CLIENT", PRL_ERR_NOT_SENTILLION_CLIENT );
	PyModule_AddIntConstant( module, "PRL_ERR_CREATE_BOOTABLE_ISO", PRL_ERR_CREATE_BOOTABLE_ISO );
	PyModule_AddIntConstant( module, "PRL_ERR_UNATTENDED_UNSUPPORTED_GUEST", PRL_ERR_UNATTENDED_UNSUPPORTED_GUEST );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_RESIZER_NOT_FOUND", PRL_ERR_DISK_RESIZER_NOT_FOUND );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_RESIZE_WITH_SNAPSHOTS_NOT_ALLOWED", PRL_ERR_DISK_RESIZE_WITH_SNAPSHOTS_NOT_ALLOWED );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_RESIZE_SIZE_TOO_LOW", PRL_ERR_DISK_RESIZE_SIZE_TOO_LOW );
	PyModule_AddIntConstant( module, "PRL_ERR_DISK_RESIZE_FAILED", PRL_ERR_DISK_RESIZE_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_CONFIRMATION_MODE_UNABLE_CHANGE_BY_NOT_ADMIN", PRL_ERR_CONFIRMATION_MODE_UNABLE_CHANGE_BY_NOT_ADMIN );
	PyModule_AddIntConstant( module, "PRL_ERR_CONFIRMATION_MODE_ALREADY_ENABLED", PRL_ERR_CONFIRMATION_MODE_ALREADY_ENABLED );
	PyModule_AddIntConstant( module, "PRL_ERR_CONFIRMATION_MODE_ALREADY_DISABLED", PRL_ERR_CONFIRMATION_MODE_ALREADY_DISABLED );
	PyModule_AddIntConstant( module, "PRL_ERR_ADMIN_CONFIRMATION_IS_REQUIRED_FOR_OPERATION", PRL_ERR_ADMIN_CONFIRMATION_IS_REQUIRED_FOR_OPERATION );
	PyModule_AddIntConstant( module, "PRL_ERR_ADMIN_CONFIRMATION_IS_REQUIRED_FOR_VM_OPERATION", PRL_ERR_ADMIN_CONFIRMATION_IS_REQUIRED_FOR_VM_OPERATION );
	PyModule_AddIntConstant( module, "PRL_ERR_CHANGESID_FAILED", PRL_ERR_CHANGESID_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_CHANGESID_GUEST_TOOLS_NOT_AVAILABLE", PRL_ERR_CHANGESID_GUEST_TOOLS_NOT_AVAILABLE );
	PyModule_AddIntConstant( module, "PRL_ERR_CHANGESID_VM_START_FAILED", PRL_ERR_CHANGESID_VM_START_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_CHANGESID_NOT_SUPPORTED", PRL_ERR_CHANGESID_NOT_SUPPORTED );
	PyModule_AddIntConstant( module, "PRL_ERR_CHANGESID_NOT_AVAILABLE", PRL_ERR_CHANGESID_NOT_AVAILABLE );
	PyModule_AddIntConstant( module, "PRL_ERR_CONVERT_3RD_PARTY_VM_FAILED", PRL_ERR_CONVERT_3RD_PARTY_VM_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_CONVERT_3RD_PARTY_VM_NO_SPACE", PRL_ERR_CONVERT_3RD_PARTY_VM_NO_SPACE );
	PyModule_AddIntConstant( module, "PRL_ERR_IMPORT_BOOTCAMP_VM_FAILED", PRL_ERR_IMPORT_BOOTCAMP_VM_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_IMPORT_BOOTCAMP_VM_NO_SPACE", PRL_ERR_IMPORT_BOOTCAMP_VM_NO_SPACE );
	PyModule_AddIntConstant( module, "PRL_ERR_CONVERT_NO_GUEST_OS_FOUND", PRL_ERR_CONVERT_NO_GUEST_OS_FOUND );
	PyModule_AddIntConstant( module, "PRL_ERR_CONVERT_EFI_CONFIG_INVALID", PRL_ERR_CONVERT_EFI_CONFIG_INVALID );
	PyModule_AddIntConstant( module, "PRL_ERR_CONVERT_EFI_GUEST_OS_UNSUPPORTED", PRL_ERR_CONVERT_EFI_GUEST_OS_UNSUPPORTED );
	PyModule_AddIntConstant( module, "PRL_ERR_CONVERT_GUEST_OS_IS_HIBERNATED", PRL_ERR_CONVERT_GUEST_OS_IS_HIBERNATED );
	PyModule_AddIntConstant( module, "PRL_ERR_VMHELPER_CREATEVM_FAILED", PRL_ERR_VMHELPER_CREATEVM_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_VMHELPER_GETTING_AVAILABLE_DRIVE_FAILED", PRL_ERR_VMHELPER_GETTING_AVAILABLE_DRIVE_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_VMHELPER_DISK_MOUNT_FAILED", PRL_ERR_VMHELPER_DISK_MOUNT_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_VMHELPER_DISK_UNMOUNT_FAILED", PRL_ERR_VMHELPER_DISK_UNMOUNT_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_VMHELPER_DIR_PATH_INVALID", PRL_ERR_VMHELPER_DIR_PATH_INVALID );
	PyModule_AddIntConstant( module, "PRL_ERR_APPLIANCE_INVALID_CONFIG", PRL_ERR_APPLIANCE_INVALID_CONFIG );
	PyModule_AddIntConstant( module, "PRL_ERR_APPLIANCE_USER_NOT_FOUND", PRL_ERR_APPLIANCE_USER_NOT_FOUND );
	PyModule_AddIntConstant( module, "PRL_ERR_APPLIANCE_DOWNLOAD_PARENT_PATH_NOT_DIR", PRL_ERR_APPLIANCE_DOWNLOAD_PARENT_PATH_NOT_DIR );
	PyModule_AddIntConstant( module, "PRL_ERR_APPLIANCE_DOWNLOAD_PARENT_PATH_NOT_EXISTS", PRL_ERR_APPLIANCE_DOWNLOAD_PARENT_PATH_NOT_EXISTS );
	PyModule_AddIntConstant( module, "PRL_ERR_APPLIANCE_DOWNLOAD_PATH_CANNOT_CREATE", PRL_ERR_APPLIANCE_DOWNLOAD_PATH_CANNOT_CREATE );
	PyModule_AddIntConstant( module, "PRL_ERR_APPLIANCE_DOWNLOAD_UTILITY_NOT_FOUND", PRL_ERR_APPLIANCE_DOWNLOAD_UTILITY_NOT_FOUND );
	PyModule_AddIntConstant( module, "PRL_ERR_APPLIANCE_DOWNLOAD_UTILITY_NOT_STARTED", PRL_ERR_APPLIANCE_DOWNLOAD_UTILITY_NOT_STARTED );
	PyModule_AddIntConstant( module, "PRL_ERR_APPLIANCE_EXIT_WITH_ERROR", PRL_ERR_APPLIANCE_EXIT_WITH_ERROR );
	PyModule_AddIntConstant( module, "PRL_ERR_APPLIANCE_CANNOT_EXTRACT_VM", PRL_ERR_APPLIANCE_CANNOT_EXTRACT_VM );
	PyModule_AddIntConstant( module, "PRL_ERR_APPLIANCE_INSTALL_ALREADY_IN_PROCESS", PRL_ERR_APPLIANCE_INSTALL_ALREADY_IN_PROCESS );
	PyModule_AddIntConstant( module, "PRL_ERR_APPLIANCE_CANNOT_CHANGE_OWNER", PRL_ERR_APPLIANCE_CANNOT_CHANGE_OWNER );
	PyModule_AddIntConstant( module, "PRL_ERR_APPLIANCE_NAME_NOT_MATCH_VM_BUNDLE", PRL_ERR_APPLIANCE_NAME_NOT_MATCH_VM_BUNDLE );
	PyModule_AddIntConstant( module, "PRL_ERR_APPLIANCE_CANNOT_MOVE_VM_BUNDLE", PRL_ERR_APPLIANCE_CANNOT_MOVE_VM_BUNDLE );
	PyModule_AddIntConstant( module, "PRL_ERR_APPLIANCE_INSTALL_WAS_NOT_STARTED", PRL_ERR_APPLIANCE_INSTALL_WAS_NOT_STARTED );
	PyModule_AddIntConstant( module, "PRL_ERR_APPLIANCE_CANNOT_CALCULATE_MD5", PRL_ERR_APPLIANCE_CANNOT_CALCULATE_MD5 );
	PyModule_AddIntConstant( module, "PRL_ERR_APPLIANCE_MISMATCH_MD5", PRL_ERR_APPLIANCE_MISMATCH_MD5 );
	PyModule_AddIntConstant( module, "PRL_ERR_CONV_HD_WRONG_VM_STATE", PRL_ERR_CONV_HD_WRONG_VM_STATE );
	PyModule_AddIntConstant( module, "PRL_ERR_CONV_HD_EXIT_WITH_ERROR", PRL_ERR_CONV_HD_EXIT_WITH_ERROR );
	PyModule_AddIntConstant( module, "PRL_ERR_CONV_HD_NO_ONE_DISK_FOR_CONVERSION", PRL_ERR_CONV_HD_NO_ONE_DISK_FOR_CONVERSION );
	PyModule_AddIntConstant( module, "PRL_ERR_CONV_HD_DISK_TOOL_NOT_STARTED", PRL_ERR_CONV_HD_DISK_TOOL_NOT_STARTED );
	PyModule_AddIntConstant( module, "PRL_ERR_CONV_HD_CONFLICT", PRL_ERR_CONV_HD_CONFLICT );
	PyModule_AddIntConstant( module, "PRL_ERR_OBJECT_NOT_FOUND", PRL_ERR_OBJECT_NOT_FOUND );
	PyModule_AddIntConstant( module, "PRL_ERR_OBJECT_LIB_LOAD_ERROR", PRL_ERR_OBJECT_LIB_LOAD_ERROR );
	PyModule_AddIntConstant( module, "PRL_ERR_OBJECT_LIB_NO_FUNCTIONS", PRL_ERR_OBJECT_LIB_NO_FUNCTIONS );
	PyModule_AddIntConstant( module, "PRL_ERR_OBJECT_DUPLICATE_UID", PRL_ERR_OBJECT_DUPLICATE_UID );
	PyModule_AddIntConstant( module, "PRL_ERR_OBJECT_BAD_INTERFACE", PRL_ERR_OBJECT_BAD_INTERFACE );
	PyModule_AddIntConstant( module, "PRL_ERR_OBJECT_LIB_WRONG_PERMS", PRL_ERR_OBJECT_LIB_WRONG_PERMS );
	PyModule_AddIntConstant( module, "PRL_ERR_OBJECT_LIB_CANT_GET_PERMS", PRL_ERR_OBJECT_LIB_CANT_GET_PERMS );
	PyModule_AddIntConstant( module, "PRL_ERR_OBJECT_DUPLICATE_CLASS", PRL_ERR_OBJECT_DUPLICATE_CLASS );
	PyModule_AddIntConstant( module, "PRL_ERR_OBJECT_CLASS_NOT_FOUND", PRL_ERR_OBJECT_CLASS_NOT_FOUND );
	PyModule_AddIntConstant( module, "PRL_ERR_PCMOVER_NOT_INSTALLED", PRL_ERR_PCMOVER_NOT_INSTALLED );
	PyModule_AddIntConstant( module, "PRL_ERR_PCMOVER_VAN_FILE_PREPARE_FAILED", PRL_ERR_PCMOVER_VAN_FILE_PREPARE_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_PCMOVER_MIGRATE_FAILED", PRL_ERR_PCMOVER_MIGRATE_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_PCMOVER_EXEC_FAILED", PRL_ERR_PCMOVER_EXEC_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_PCMOVER_POLICY_FILE_WRITE_ERROR", PRL_ERR_PCMOVER_POLICY_FILE_WRITE_ERROR );
	PyModule_AddIntConstant( module, "PRL_ERR_PCMOVER_POLICY_FILE_OPEN_ERROR", PRL_ERR_PCMOVER_POLICY_FILE_OPEN_ERROR );
	PyModule_AddIntConstant( module, "PRL_ERR_PCMOVER_VAN_FILE_CREATE_ERROR", PRL_ERR_PCMOVER_VAN_FILE_CREATE_ERROR );
	PyModule_AddIntConstant( module, "PRL_ERR_PCMOVER_VAN_FILE_OPEN_ERROR", PRL_ERR_PCMOVER_VAN_FILE_OPEN_ERROR );
	PyModule_AddIntConstant( module, "PRL_ERR_PCMOVER_WINDOWS_DIR_NOT_EXIST", PRL_ERR_PCMOVER_WINDOWS_DIR_NOT_EXIST );
	PyModule_AddIntConstant( module, "PRL_ERR_TEST_TEXT_MESSAGES", PRL_ERR_TEST_TEXT_MESSAGES );
	PyModule_AddIntConstant( module, "PRL_ERR_TEST_TEXT_MESSAGES_PS", PRL_ERR_TEST_TEXT_MESSAGES_PS );
	PyModule_AddIntConstant( module, "PRL_ERR_SET_CPULIMIT", PRL_ERR_SET_CPULIMIT );
	PyModule_AddIntConstant( module, "PRL_ERR_SET_CPUUNITS", PRL_ERR_SET_CPUUNITS );
	PyModule_AddIntConstant( module, "PRL_ERR_SET_IOPRIO", PRL_ERR_SET_IOPRIO );
	PyModule_AddIntConstant( module, "PRL_ERR_ACTION_NOT_SUPPORTED_FOR_CT", PRL_ERR_ACTION_NOT_SUPPORTED_FOR_CT );
	PyModule_AddIntConstant( module, "PRL_ERR_SET_IOLIMIT", PRL_ERR_SET_IOLIMIT );
	PyModule_AddIntConstant( module, "PRL_ERR_SET_CPUMASK", PRL_ERR_SET_CPUMASK );
	PyModule_AddIntConstant( module, "PRL_ERR_VZ_OPERATION_FAILED", PRL_ERR_VZ_OPERATION_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_VZ_OSTEMPLATE_NOT_FOUND", PRL_ERR_VZ_OSTEMPLATE_NOT_FOUND );
	PyModule_AddIntConstant( module, "PRL_ERR_CT_IS_RUNNING", PRL_ERR_CT_IS_RUNNING );
	PyModule_AddIntConstant( module, "PRL_ERR_UNNAMED_CT_MOVE", PRL_ERR_UNNAMED_CT_MOVE );
	PyModule_AddIntConstant( module, "PRL_ERR_VZCTL_OPERATION_FAILED", PRL_ERR_VZCTL_OPERATION_FAILED );
	PyModule_AddIntConstant( module, "PRL_ERR_ISCSI_STORAGE_LIBRARY", PRL_ERR_ISCSI_STORAGE_LIBRARY );
	PyModule_AddIntConstant( module, "PRL_ERR_ISCSI_STORAGE_START", PRL_ERR_ISCSI_STORAGE_START );
	PyModule_AddIntConstant( module, "PRL_ERR_ISCSI_STORAGE_CREATE", PRL_ERR_ISCSI_STORAGE_CREATE );
	PyModule_AddIntConstant( module, "PRL_ERR_ISCSI_STORAGE_REMOVE", PRL_ERR_ISCSI_STORAGE_REMOVE );
	PyModule_AddIntConstant( module, "PRL_ERR_ISCSI_STORAGE_MOUNT", PRL_ERR_ISCSI_STORAGE_MOUNT );
	PyModule_AddIntConstant( module, "PRL_ERR_ISCSI_STORAGE_UMOUNT", PRL_ERR_ISCSI_STORAGE_UMOUNT );
	PyModule_AddIntConstant( module, "PRL_ERR_ISCSI_STORAGE_EXTEND", PRL_ERR_ISCSI_STORAGE_EXTEND );
	PyModule_AddIntConstant( module, "PRL_ERR_ISCSI_STORAGE_GET_STATE", PRL_ERR_ISCSI_STORAGE_GET_STATE );
	PyModule_AddIntConstant( module, "PRL_ERR_ISCSI_STORAGE_MOUNTED", PRL_ERR_ISCSI_STORAGE_MOUNTED );
	PyModule_AddIntConstant( module, "PRL_ERR_ISCSI_STORAGE_NOT_MOUNTED", PRL_ERR_ISCSI_STORAGE_NOT_MOUNTED );
	PyModule_AddIntConstant( module, "PRL_ERR_ISCSI_STORAGE_NOT_SUPPORTED", PRL_ERR_ISCSI_STORAGE_NOT_SUPPORTED );
	PyModule_AddIntConstant( module, "PRL_ERR_ISCSI_STORAGE_INVALID_FSTYPE", PRL_ERR_ISCSI_STORAGE_INVALID_FSTYPE );
	PyModule_AddIntConstant( module, "PRL_ERR_ISCSI_STORAGE_NOT_FOUND", PRL_ERR_ISCSI_STORAGE_NOT_FOUND );
	PyModule_AddIntConstant( module, "PRL_ERR_ISCSI_STORAGE_ALREADY_REGISTERED", PRL_ERR_ISCSI_STORAGE_ALREADY_REGISTERED );
	PyModule_AddIntConstant( module, "PRL_ERR_ISCSI_STORAGE_CANNOT_CREATE_MOUNT_POINT", PRL_ERR_ISCSI_STORAGE_CANNOT_CREATE_MOUNT_POINT );
	PyModule_AddIntConstant( module, "PRL_ERR_ISCSI_STORAGE_MOUNT_POINT_ALREADY_EXISTS", PRL_ERR_ISCSI_STORAGE_MOUNT_POINT_ALREADY_EXISTS );
	PyModule_AddIntConstant( module, "PRL_ERR_UNSUPPORTED_VIRTUAL_SOURCE", PRL_ERR_UNSUPPORTED_VIRTUAL_SOURCE );
	PyModule_AddIntConstant( module, "PRL_ERR_CANT_UNPACK_ARCHIVE", PRL_ERR_CANT_UNPACK_ARCHIVE );
	PyModule_AddIntConstant( module, "PRL_ERR_CANT_CONVERT_CONFIG", PRL_ERR_CANT_CONVERT_CONFIG );
	PyModule_AddIntConstant( module, "PRL_ERR_CANT_CONVERT_OTHER_VENDOR_VM", PRL_ERR_CANT_CONVERT_OTHER_VENDOR_VM );
	PyModule_AddIntConstant( module, "PRL_ERR_CANT_CONVERT_OTHER_VENDOR_HDD", PRL_ERR_CANT_CONVERT_OTHER_VENDOR_HDD );
	PyModule_AddIntConstant( module, "PRL_ERR_CANT_RECONFIG_GUEST_OS", PRL_ERR_CANT_RECONFIG_GUEST_OS );
	PyModule_AddIntConstant( module, "PRL_ERR_CANT_PREPARE_RECONFIG_DATA", PRL_ERR_CANT_PREPARE_RECONFIG_DATA );
	PyModule_AddIntConstant( module, "PRL_ERR_NO_GUEST_OS_FOUND", PRL_ERR_NO_GUEST_OS_FOUND );
	PyModule_AddIntConstant( module, "PRL_ERR_UNSUPPORTED_LAYOUTS_STRUCTURE", PRL_ERR_UNSUPPORTED_LAYOUTS_STRUCTURE );
	PyModule_AddIntConstant( module, "PRL_ERR_SOURCE_ISNT_BOOTCAMP_DISK", PRL_ERR_SOURCE_ISNT_BOOTCAMP_DISK );
	PyModule_AddIntConstant( module, "PRL_ERR_OS_RECONFIG_DATA_ABSENT", PRL_ERR_OS_RECONFIG_DATA_ABSENT );
	PyModule_AddIntConstant( module, "PRL_WRN_IT_FIRST_WARNING", PRL_WRN_IT_FIRST_WARNING );
	PyModule_AddIntConstant( module, "PRL_WRN_IT_EMPTY_MBR", PRL_WRN_IT_EMPTY_MBR );
	PyModule_AddIntConstant( module, "PRL_WRN_IT_VOLUME_RESIZING", PRL_WRN_IT_VOLUME_RESIZING );
	PyModule_AddIntConstant( module, "PRL_WRN_IT_CANT_RESIZE_VOLUME", PRL_WRN_IT_CANT_RESIZE_VOLUME );
	PyModule_AddIntConstant( module, "PRL_WRN_IT_CANT_RESIZE_LDM_DISK", PRL_WRN_IT_CANT_RESIZE_LDM_DISK );
	PyModule_AddIntConstant( module, "PRL_ERR_IT_FIRST_FAILURE", PRL_ERR_IT_FIRST_FAILURE );
	PyModule_AddIntConstant( module, "PRL_ERR_IT_FAST_RESIZE_FAILURE", PRL_ERR_IT_FAST_RESIZE_FAILURE );
	PyModule_AddIntConstant( module, "PRL_ERR_IT_ROLLBACK_FAILURE", PRL_ERR_IT_ROLLBACK_FAILURE );
	PyModule_AddIntConstant( module, "PRL_ERR_IT_FIRST_ERROR", PRL_ERR_IT_FIRST_ERROR );
	PyModule_AddIntConstant( module, "PRL_ERR_IT_USER_INTERRUPTED", PRL_ERR_IT_USER_INTERRUPTED );
	PyModule_AddIntConstant( module, "PRL_ERR_IT_SIZE_CHANGED", PRL_ERR_IT_SIZE_CHANGED );
	PyModule_AddIntConstant( module, "PRL_ERR_IT_CANT_OPEN_IMAGE", PRL_ERR_IT_CANT_OPEN_IMAGE );
	PyModule_AddIntConstant( module, "PRL_ERR_IT_CANT_GET_PARAMS_FROM_OLD_IMAGE", PRL_ERR_IT_CANT_GET_PARAMS_FROM_OLD_IMAGE );
	PyModule_AddIntConstant( module, "PRL_ERR_IT_GUEST_TOOLS_UNKNOWN_STATE", PRL_ERR_IT_GUEST_TOOLS_UNKNOWN_STATE );
	PyModule_AddIntConstant( module, "PRL_ERR_IT_CANT_VALIDATE_BOOTCAMP", PRL_ERR_IT_CANT_VALIDATE_BOOTCAMP );
	PyModule_AddIntConstant( module, "PRL_ERR_IT_CANT_RECONFIG", PRL_ERR_IT_CANT_RECONFIG );
	PyModule_AddIntConstant( module, "PRL_ERR_IT_CANT_RECONFIG_BOOTCAMP", PRL_ERR_IT_CANT_RECONFIG_BOOTCAMP );
	PyModule_AddIntConstant( module, "PRL_ERR_IT_CANT_PREPARE_RECONFIG_DATA", PRL_ERR_IT_CANT_PREPARE_RECONFIG_DATA );
	PyModule_AddIntConstant( module, "PRL_ERR_IT_RECONFIG_PATH_NEEDED", PRL_ERR_IT_RECONFIG_PATH_NEEDED );
	PyModule_AddIntConstant( module, "PRL_ERR_IT_UNKNOWN_OS", PRL_ERR_IT_UNKNOWN_OS );
	PyModule_AddIntConstant( module, "PRL_ERR_IT_HAL_NOT_FOUND", PRL_ERR_IT_HAL_NOT_FOUND );
	PyModule_AddIntConstant( module, "PRL_ERR_IT_SNAPSHOTS_MERGE_IS_NEEDED", PRL_ERR_IT_SNAPSHOTS_MERGE_IS_NEEDED );
	PyModule_AddIntConstant( module, "PRL_ERR_IT_CONVERT_TO_CURRENT_ERROR", PRL_ERR_IT_CONVERT_TO_CURRENT_ERROR );
	PyModule_AddIntConstant( module, "PRL_ERR_IT_DISK_SMALL_FOR_SPLIT", PRL_ERR_IT_DISK_SMALL_FOR_SPLIT );
	PyModule_AddIntConstant( module, "PRL_ERR_IT_CANT_RESIZE_VOLUME", PRL_ERR_IT_CANT_RESIZE_VOLUME );
	PyModule_AddIntConstant( module, "PRL_ERR_IT_CANT_RESIZE_LDM_DISK", PRL_ERR_IT_CANT_RESIZE_LDM_DISK );
	PyModule_AddIntConstant( module, "PRL_ERR_IT_FS_NOT_SUPPORTED_FOR_RESIZE", PRL_ERR_IT_FS_NOT_SUPPORTED_FOR_RESIZE );
	PyModule_AddIntConstant( module, "PRL_ERR_IT_CANT_COMPACT", PRL_ERR_IT_CANT_COMPACT );
	PyModule_AddIntConstant( module, "PRL_ERR_IT_CANT_COMPACT_LDM_DISK", PRL_ERR_IT_CANT_COMPACT_LDM_DISK );
	PyModule_AddIntConstant( module, "PRL_ERR_IT_CANT_GET_BITMAP", PRL_ERR_IT_CANT_GET_BITMAP );
	PyModule_AddIntConstant( module, "PRL_ERR_IT_CANT_COMPACT_PLAIN_DISK", PRL_ERR_IT_CANT_COMPACT_PLAIN_DISK );
	PyModule_AddIntConstant( module, "PRL_ERR_TEMPLATE_HAS_APPS", PRL_ERR_TEMPLATE_HAS_APPS );
	PyModule_AddIntConstant( module, "PRL_ERR_TEMPLATE_NOT_FOUND", PRL_ERR_TEMPLATE_NOT_FOUND );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_MOUNT", PRL_ERR_VM_MOUNT );
	PyModule_AddIntConstant( module, "PRL_ERR_VM_UNMOUNT", PRL_ERR_VM_UNMOUNT );
	PyModule_AddIntConstant( module, "PRL_ERR_CONNECT_TO_MOUNTER", PRL_ERR_CONNECT_TO_MOUNTER );
	PyModule_AddIntConstant( module, "PRL_ERR_PERFORM_MOUNTER_COMMAND", PRL_ERR_PERFORM_MOUNTER_COMMAND );
	PyModule_AddIntConstant( module, "PRL_ERR_MOUNTER_LIST_NO_OBJECT", PRL_ERR_MOUNTER_LIST_NO_OBJECT );
	PyModule_AddIntConstant( module, "PRL_ERR_CI_DEVICE_IS_NOT_VIRTUAL", PRL_ERR_CI_DEVICE_IS_NOT_VIRTUAL );
	PyModule_AddIntConstant( module, "PRL_ERR_CI_CANNOT_COPY_IMAGE_NON_STOPPED_VM", PRL_ERR_CI_CANNOT_COPY_IMAGE_NON_STOPPED_VM );
	PyModule_AddIntConstant( module, "PRL_ERR_CI_PERMISSIONS_DENIED", PRL_ERR_CI_PERMISSIONS_DENIED );
	PyModule_AddIntConstant( module, "PRL_ERR_CVSRC_IO_ERROR", PRL_ERR_CVSRC_IO_ERROR );
	PyModule_AddIntConstant( module, "PRL_ERR_CVSRC_NO_OPEN_REQUEST", PRL_ERR_CVSRC_NO_OPEN_REQUEST );
	PyModule_AddIntConstant( module, "PRL_ERR_CVSRC_NO_CHANNEL", PRL_ERR_CVSRC_NO_CHANNEL );
	PyModule_AddIntConstant( module, "PRL_ERR_CLUSTER_RESOURCE_ERROR", PRL_ERR_CLUSTER_RESOURCE_ERROR );
	PyModule_AddIntConstant( module, "PRL_ERR_REG_PSTORAGE_REVOKE_IS_NEEDS", PRL_ERR_REG_PSTORAGE_REVOKE_IS_NEEDS );
	PyModule_AddIntConstant( module, "PRL_ERR_FORCE_REG_ON_SHARED_STORAGE_IS_NEEDED", PRL_ERR_FORCE_REG_ON_SHARED_STORAGE_IS_NEEDED );
	PyModule_AddIntConstant( module, "PRL_ERR_WEB_PORTAL_OK", PRL_ERR_WEB_PORTAL_OK );
	PyModule_AddIntConstant( module, "PRL_ERR_WEB_PORTAL_CREATED", PRL_ERR_WEB_PORTAL_CREATED );
	PyModule_AddIntConstant( module, "PRL_ERR_WEB_PORTAL_ACCEPTED", PRL_ERR_WEB_PORTAL_ACCEPTED );
	PyModule_AddIntConstant( module, "PRL_ERR_WEB_PORTAL_BAD_REQUEST", PRL_ERR_WEB_PORTAL_BAD_REQUEST );
	PyModule_AddIntConstant( module, "PRL_ERR_WEB_PORTAL_NOT_FOUND", PRL_ERR_WEB_PORTAL_NOT_FOUND );
	PyModule_AddIntConstant( module, "PRL_ERR_WEB_PORTAL_UNAUTHORIZED", PRL_ERR_WEB_PORTAL_UNAUTHORIZED );
	PyModule_AddIntConstant( module, "PRL_ERR_WEB_PORTAL_INVALID_PARAMETERS", PRL_ERR_WEB_PORTAL_INVALID_PARAMETERS );
	PyModule_AddIntConstant( module, "PRL_ERR_WEB_PORTAL_CONFLICT", PRL_ERR_WEB_PORTAL_CONFLICT );
	PyModule_AddIntConstant( module, "PRL_ERR_WEB_PORTAL_SERVICE_UNAVAILABLE", PRL_ERR_WEB_PORTAL_SERVICE_UNAVAILABLE );
	PyModule_AddIntConstant( module, "PRL_ERR_WEB_PORTAL_INVALID_EMAIL", PRL_ERR_WEB_PORTAL_INVALID_EMAIL );
	PyModule_AddIntConstant( module, "PRL_ERR_WEB_PORTAL_ACCOUNT_ALREADY_EXISTS", PRL_ERR_WEB_PORTAL_ACCOUNT_ALREADY_EXISTS );
	PyModule_AddIntConstant( module, "PRL_ERR_WEB_PORTAL_INVALID_PASSWORD", PRL_ERR_WEB_PORTAL_INVALID_PASSWORD );
	PyModule_AddIntConstant( module, "PRL_ERR_WEB_PORTAL_NO_CONTENT", PRL_ERR_WEB_PORTAL_NO_CONTENT );
	PyModule_AddIntConstant( module, "PRL_ERR_WEB_PORTAL_FORBIDDEN", PRL_ERR_WEB_PORTAL_FORBIDDEN );
	PyModule_AddIntConstant( module, "PRL_ERR_WEB_PORTAL_SOCIAL_CONFIRM_EMAIL_SENT", PRL_ERR_WEB_PORTAL_SOCIAL_CONFIRM_EMAIL_SENT );
	PyModule_AddIntConstant( module, "PRL_ERR_WEB_PORTAL_SOCIAL_UNCONFIRMED_ACCOUNT", PRL_ERR_WEB_PORTAL_SOCIAL_UNCONFIRMED_ACCOUNT );
	PyModule_AddIntConstant( module, "PRL_ERR_WEB_PORTAL_SOCIAL_APP_DENIED", PRL_ERR_WEB_PORTAL_SOCIAL_APP_DENIED );
	PyModule_AddIntConstant( module, "PRL_ERR_WEB_PORTAL_SOCIAL_SERVICE_BAD_RESPONSE", PRL_ERR_WEB_PORTAL_SOCIAL_SERVICE_BAD_RESPONSE );
	PyModule_AddIntConstant( module, "PRL_ERR_WEB_PORTAL_SOCIAL_SERVICE_UNAVAILABLE", PRL_ERR_WEB_PORTAL_SOCIAL_SERVICE_UNAVAILABLE );
	PyModule_AddIntConstant( module, "PRL_ERR_WEB_PORTAL_SOCIAL_PROHIBITED_FOR_BA", PRL_ERR_WEB_PORTAL_SOCIAL_PROHIBITED_FOR_BA );
	PyModule_AddIntConstant( module, "PRL_ERR_SDK_TRY_AGAIN", PRL_ERR_SDK_TRY_AGAIN );
	PyModule_AddIntConstant( module, "PRL_ERR_BUSE_NOT_MOUNTED", PRL_ERR_BUSE_NOT_MOUNTED );
	PyModule_AddIntConstant( module, "PRL_ERR_BUSE_INTERNAL_ERROR", PRL_ERR_BUSE_INTERNAL_ERROR );
	PyModule_AddIntConstant( module, "PRL_ERR_BUSE_ENTRY_INVALID", PRL_ERR_BUSE_ENTRY_INVALID );
	PyModule_AddIntConstant( module, "PRL_ERR_BUSE_ENTRY_ALREADY_EXIST", PRL_ERR_BUSE_ENTRY_ALREADY_EXIST );
	PyModule_AddIntConstant( module, "PRL_ERR_BUSE_ENTRY_ALREADY_INITIALIZED", PRL_ERR_BUSE_ENTRY_ALREADY_INITIALIZED );
	PyModule_AddIntConstant( module, "PRL_ERR_BUSE_ENTRY_IO_ERROR", PRL_ERR_BUSE_ENTRY_IO_ERROR );
	PyModule_AddIntConstant( module, "PRL_ERR_ATTACH_BACKUP_INTERNAL_ERROR", PRL_ERR_ATTACH_BACKUP_INTERNAL_ERROR );
	PyModule_AddIntConstant( module, "PRL_ERR_ATTACH_BACKUP_INVALID_STORAGE_URL", PRL_ERR_ATTACH_BACKUP_INVALID_STORAGE_URL );
	PyModule_AddIntConstant( module, "PRL_ERR_ATTACH_BACKUP_CUSTOM_BACKUP_SERVER_NOT_SUPPORTED", PRL_ERR_ATTACH_BACKUP_CUSTOM_BACKUP_SERVER_NOT_SUPPORTED );
	PyModule_AddIntConstant( module, "PRL_ERR_ATTACH_BACKUP_PROTO_ERROR", PRL_ERR_ATTACH_BACKUP_PROTO_ERROR );
	PyModule_AddIntConstant( module, "PRL_ERR_ATTACH_BACKUP_FORMAT_NOT_SUPPORTED", PRL_ERR_ATTACH_BACKUP_FORMAT_NOT_SUPPORTED );
	PyModule_AddIntConstant( module, "PRL_ERR_ATTACH_BACKUP_ALREADY_ATTACHED", PRL_ERR_ATTACH_BACKUP_ALREADY_ATTACHED );
	PyModule_AddIntConstant( module, "PRL_ERR_ATTACH_BACKUP_BUSE_NOT_MOUNTED", PRL_ERR_ATTACH_BACKUP_BUSE_NOT_MOUNTED );
	PyModule_AddIntConstant( module, "PRL_ERR_ATTACH_BACKUP_URL_CHANGE_PROHIBITED", PRL_ERR_ATTACH_BACKUP_URL_CHANGE_PROHIBITED );
	PyModule_AddIntConstant( module, "PRL_ERR_CPUFEATURES_NO_BINARY", PRL_ERR_CPUFEATURES_NO_BINARY );
	PyModule_AddIntConstant( module, "PRL_ERR_CPUFEATURES_INCORRECT_MASK", PRL_ERR_CPUFEATURES_INCORRECT_MASK );
	PyModule_AddIntConstant( module, "PRL_ERR_CPUFEATURES_POOLS_MANAGMENT", PRL_ERR_CPUFEATURES_POOLS_MANAGMENT );
	PyModule_AddIntConstant( module, "PRL_ERR_CPUFEATURES_RUNNING_VM_OR_CT", PRL_ERR_CPUFEATURES_RUNNING_VM_OR_CT );
	PyModule_AddIntConstant( module, "PRL_ERR_CPUFEATURES_NOT_IN_POOLS", PRL_ERR_CPUFEATURES_NOT_IN_POOLS );
	PyModule_AddIntConstant( module, "PRL_ERR_CPUFEATURES_DEFAULT_POOL_ARG", PRL_ERR_CPUFEATURES_DEFAULT_POOL_ARG );
	PyModule_AddIntConstant( module, "PRL_ERR_CPUFEATURES_INCOMPATIBLE_NODE", PRL_ERR_CPUFEATURES_INCOMPATIBLE_NODE );
}
